/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         MYSQLparse
#define yylex           MYSQLlex
#define yyerror         MYSQLerror
#define yydebug         MYSQLdebug
#define yynerrs         MYSQLnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                         \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void MYSQLerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}


#ifndef DBUG_OFF
void turn_parser_debug_on()
{
  /*
     MYSQLdebug is in sql/sql_yacc.cc, in bison generated code.
     Turning this option on is **VERY** verbose, and should be
     used when investigating a syntax error problem only.

     The syntax to run with bison traces is as follows :
     - Starting a server manually :
       mysqld --debug-dbug="d,parser_debug" ...
     - Running a test :
       mysql-test-run.pl --mysqld="--debug-dbug=d,parser_debug" ...

     The result will be in the process stderr (var/log/master.err)
   */

  extern int yydebug;
  yydebug= 1;
}
#endif


/**
  Helper action for a case expression statement (the expr in 'CASE expr').
  This helper is used for 'searched' cases only.
  @param lex the parser lex context
  @param expr the parsed expression
  @return 0 on success
*/

int LEX::case_stmt_action_expr(Item* expr)
{
  int case_expr_id= spcont->register_case_expr();
  sp_instr_set_case_expr *i;

  if (spcont->push_case_expr_id(case_expr_id))
    return 1;

  i= new (thd->mem_root)
    sp_instr_set_case_expr(sphead->instructions(), spcont, case_expr_id, expr,
                           this);

  sphead->add_cont_backpatch(i);
  return sphead->add_instr(i);
}

/**
  Helper action for a case when condition.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
  @param when the parsed expression for the WHEN clause
  @param simple true for simple cases, false for searched cases
*/

int LEX::case_stmt_action_when(Item *when, bool simple)
{
  uint ip= sphead->instructions();
  sp_instr_jump_if_not *i;
  Item_case_expr *var;
  Item *expr;

  if (simple)
  {
    var= new (thd->mem_root)
         Item_case_expr(thd, spcont->get_current_case_expr_id());

#ifdef DBUG_ASSERT_EXISTS
    if (var)
    {
      var->m_sp= sphead;
    }
#endif

    expr= new (thd->mem_root) Item_func_eq(thd, var, when);
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, expr, this);
  }
  else
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, when, this);

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  return
    !MY_TEST(i) ||
    sphead->push_backpatch(thd, i, spcont->push_label(thd, &empty_clex_str, 0)) ||
    sphead->add_cont_backpatch(i) ||
    sphead->add_instr(i);
}

/**
  Helper action for a case then statements.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
*/

int LEX::case_stmt_action_then()
{
  uint ip= sphead->instructions();
  sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, spcont);
  if (!MY_TEST(i) || sphead->add_instr(i))
    return 1;

  /*
    BACKPATCH: Resolving forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  sphead->backpatch(spcont->pop_label());

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_then" to after END CASE
    (jump from instruction 4 to 12, 7 to 12 ... in the example)
  */

  return sphead->push_backpatch(thd, i, spcont->last_label());
}


/**
  Helper action for a SET statement.
  Used to push a system variable into the assignment list.

  @param tmp      the system variable with base name
  @param var_type the scope of the variable
  @param val      the value being assigned to the variable

  @return TRUE if error, FALSE otherwise.
*/

bool
LEX::set_system_variable(enum enum_var_type var_type,
                         sys_var *sysvar, const LEX_CSTRING *base_name,
                         Item *val)
{
  set_var *setvar;

  /* No AUTOCOMMIT from a stored function or trigger. */
  if (spcont && sysvar == Sys_autocommit_ptr)
    sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;

  if (val && val->type() == Item::FIELD_ITEM &&
      ((Item_field*)val)->table_name)
  {
    my_error(ER_WRONG_TYPE_FOR_VAR, MYF(0), sysvar->name.str);
    return TRUE;
  }

  if (!(setvar= new (thd->mem_root) set_var(thd, var_type, sysvar,
                                            base_name, val)))
    return TRUE;

  return var_list.push_back(setvar, thd->mem_root);
}


/**
  Helper action for a SET statement.
  Used to SET a field of NEW row.

  @param name     the field name
  @param val      the value being assigned to the row

  @return TRUE if error, FALSE otherwise.
*/

bool LEX::set_trigger_new_row(const LEX_CSTRING *name, Item *val)
{
  Item_trigger_field *trg_fld;
  sp_instr_set_trigger_field *sp_fld;

  /* QQ: Shouldn't this be field's default value ? */
  if (! val)
    val= new (thd->mem_root) Item_null(thd);

  DBUG_ASSERT(trg_chistics.action_time == TRG_ACTION_BEFORE &&
              (trg_chistics.event == TRG_EVENT_INSERT ||
               trg_chistics.event == TRG_EVENT_UPDATE));

  trg_fld= new (thd->mem_root)
            Item_trigger_field(thd, current_context(),
                               Item_trigger_field::NEW_ROW,
                               name, UPDATE_ACL, FALSE);

  if (unlikely(trg_fld == NULL))
    return TRUE;

  sp_fld= new (thd->mem_root)
        sp_instr_set_trigger_field(sphead->instructions(),
                                   spcont, trg_fld, val, this);

  if (unlikely(sp_fld == NULL))
    return TRUE;

  /*
    Let us add this item to list of all Item_trigger_field
    objects in trigger.
  */
  trg_table_fields.link_in_list(trg_fld, &trg_fld->next_trg_field);

  return sphead->add_instr(sp_fld);
}


/**
  Create an object to represent a SP variable in the Item-hierarchy.

  @param  name        The SP variable name.
  @param  spvar       The SP variable (optional).
  @param  start_in_q  Start position of the SP variable name in the query.
  @param  end_in_q    End position of the SP variable name in the query.

  @remark If spvar is not specified, the name is used to search for the
          variable in the parse-time context. If the variable does not
          exist, a error is set and NULL is returned to the caller.

  @return An Item_splocal object representing the SP variable, or NULL on error.
*/
Item_splocal*
LEX::create_item_for_sp_var(const Lex_ident_cli_st *cname, sp_variable *spvar)
{
  const Sp_rcontext_handler *rh;
  Item_splocal *item;
  const char *start_in_q= cname->pos();
  const char *end_in_q= cname->end();
  uint pos_in_q, len_in_q;
  Lex_ident_sys name(thd, cname);

  if (name.is_null())
    return NULL;  // EOM

  /* If necessary, look for the variable. */
  if (spcont && !spvar)
    spvar= find_variable(&name, &rh);

  if (!spvar)
  {
    my_error(ER_SP_UNDECLARED_VAR, MYF(0), name.str);
    return NULL;
  }

  DBUG_ASSERT(spcont && spvar);

  /* Position and length of the SP variable name in the query. */
  pos_in_q= (uint)(start_in_q - sphead->m_tmp_query);
  len_in_q= (uint)(end_in_q - start_in_q);

  item= new (thd->mem_root)
    Item_splocal(thd, rh, &name, spvar->offset, spvar->type_handler(),
                 pos_in_q, len_in_q);

#ifdef DBUG_ASSERT_EXISTS
  if (item)
    item->m_sp= sphead;
#endif

  return item;
}

/**
  Helper to resolve the SQL:2003 Syntax exception 1) in <in predicate>.
  See SQL:2003, Part 2, section 8.4 <in predicate>, Note 184, page 383.
  This function returns the proper item for the SQL expression
  <code>left [NOT] IN ( expr )</code>
  @param thd the current thread
  @param left the in predicand
  @param equal true for IN predicates, false for NOT IN predicates
  @param expr first and only expression of the in value list
  @return an expression representing the IN predicate.
*/
Item* handle_sql2003_note184_exception(THD *thd, Item* left, bool equal,
                                       Item *expr)
{
  /*
    Relevant references for this issue:
    - SQL:2003, Part 2, section 8.4 <in predicate>, page 383,
    - SQL:2003, Part 2, section 7.2 <row value expression>, page 296,
    - SQL:2003, Part 2, section 6.3 <value expression primary>, page 174,
    - SQL:2003, Part 2, section 7.15 <subquery>, page 370,
    - SQL:2003 Feature F561, "Full value expressions".

    The exception in SQL:2003 Note 184 means:
    Item_singlerow_subselect, which corresponds to a <scalar subquery>,
    should be re-interpreted as an Item_in_subselect, which corresponds
    to a <table subquery> when used inside an <in predicate>.

    Our reading of Note 184 is reccursive, so that all:
    - IN (( <subquery> ))
    - IN ((( <subquery> )))
    - IN '('^N <subquery> ')'^N
    - etc
    should be interpreted as a <table subquery>, no matter how deep in the
    expression the <subquery> is.
  */

  Item *result;

  DBUG_ENTER("handle_sql2003_note184_exception");

  if (expr->type() == Item::SUBSELECT_ITEM)
  {
    Item_subselect *expr2 = (Item_subselect*) expr;

    if (expr2->substype() == Item_subselect::SINGLEROW_SUBS)
    {
      Item_singlerow_subselect *expr3 = (Item_singlerow_subselect*) expr2;
      st_select_lex *subselect;

      /*
        Implement the mandated change, by altering the semantic tree:
          left IN Item_singlerow_subselect(subselect)
        is modified to
          left IN (subselect)
        which is represented as
          Item_in_subselect(left, subselect)
      */
      subselect= expr3->invalidate_and_restore_select_lex();
      result= new (thd->mem_root) Item_in_subselect(thd, left, subselect);

      if (! equal)
        result = negate_expression(thd, result);

      DBUG_RETURN(result);
    }
  }

  if (equal)
    result= new (thd->mem_root) Item_func_eq(thd, left, expr);
  else
    result= new (thd->mem_root) Item_func_ne(thd, left, expr);

  DBUG_RETURN(result);
}

/**
  Create a separate LEX for each assignment if in SP.

  If we are in SP we want have own LEX for each assignment.
  This is mostly because it is hard for several sp_instr_set
  and sp_instr_set_trigger instructions share one LEX.
  (Well, it is theoretically possible but adds some extra
  overhead on preparation for execution stage and IMO less
  robust).

  QQ: May be we should simply prohibit group assignments in SP?

  @see sp_create_assignment_instr

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead
*/

bool sp_create_assignment_lex(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    Lex_input_stream *lip= &thd->m_parser_state->m_lip;
    LEX *old_lex= lex;
    lex->sphead->reset_lex(thd);
    lex= thd->lex;

    /* Set new LEX as if we at start of set rule. */
    lex->sql_command= SQLCOM_SET_OPTION;
    if (lex->main_select_push())
      return true;
    mysql_init_select(lex);
    lex->var_list.empty();
    lex->autocommit= 0;
    /* get_ptr() is only correct with no lookahead. */
    if (no_lookahead)
        lex->sphead->m_tmp_query= lip->get_ptr();
    else
        lex->sphead->m_tmp_query= lip->get_tok_end();
    /* Inherit from outer lex. */
    lex->option_type= old_lex->option_type;
  }
  return false;
}


/**
  Create a SP instruction for a SET assignment.

  @see sp_create_assignment_lex

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead

  @return false if success, true otherwise.
*/

bool sp_create_assignment_instr(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    if (!lex->var_list.is_empty())
    {
      /*
        We have assignment to user or system variable or
        option setting, so we should construct sp_instr_stmt
        for it.
      */
      Lex_input_stream *lip= &thd->m_parser_state->m_lip;

      /*
        Extract the query statement from the tokenizer.  The
        end is either lip->ptr, if there was no lookahead,
        lip->tok_end otherwise.
      */
      static const LEX_CSTRING setsp= { STRING_WITH_LEN("SET ") };
      const char *qend= no_lookahead ? lip->get_ptr() : lip->get_tok_end();
      Lex_cstring qbuf(lex->sphead->m_tmp_query, qend);
      if (lex->new_sp_instr_stmt(thd, setsp, qbuf))
        return true;
    }
    lex->pop_select();
    if (lex->check_main_unit_semantics())
    {
      /*
        "lex" can be referrenced by:
        - sp_instr_set                          SET a= expr;
        - sp_instr_set_row_field                SET r.a= expr;
        - sp_instr_stmt (just generated above)  SET @a= expr;
        In this case, "lex" is fully owned by sp_instr_xxx and it will
        be deleted by the destructor ~sp_instr_xxx().
        So we should remove "lex" from the stack sp_head::m_lex,
        to avoid double free.
        Note, in case "lex" is not owned by any sp_instr_xxx,
        it's also safe to remove it from the stack right now.
        So we can remove it unconditionally, without testing lex->sp_lex_in_use.
      */
      lex->sphead->restore_lex(thd);
      return true;
    }
    enum_var_type inner_option_type= lex->option_type;
    if (lex->sphead->restore_lex(thd))
      return true;
    /* Copy option_type to outer lex in case it has changed. */
    thd->lex->option_type= inner_option_type;
  }
  return false;
}

void LEX::add_key_to_list(LEX_CSTRING *field_name,
                          enum Key::Keytype type, bool check_exists)
{
  Key *key;
  MEM_ROOT *mem_root= thd->mem_root;
  key= new (mem_root)
        Key(type, &null_clex_str, HA_KEY_ALG_UNDEF, false,
             DDL_options(check_exists ?
                         DDL_options::OPT_IF_NOT_EXISTS :
                         DDL_options::OPT_NONE));
  key->columns.push_back(new (mem_root) Key_part_spec(field_name, 0),
                         mem_root);
  alter_info.key_list.push_back(key, mem_root);
}

bool LEX::add_alter_list(const char *name, Virtual_column_info *expr,
                         bool exists)
{
  MEM_ROOT *mem_root= thd->mem_root;
  Alter_column *ac= new (mem_root) Alter_column(name, expr, exists);
  if (unlikely(ac == NULL))
    return true;
  alter_info.alter_list.push_back(ac, mem_root);
  alter_info.flags|= ALTER_CHANGE_COLUMN_DEFAULT;
  return false;
}

void LEX::init_last_field(Column_definition *field,
                          const LEX_CSTRING *field_name,
                          const CHARSET_INFO *cs)
{
  last_field= field;

  field->field_name= *field_name;

  /* reset LEX fields that are used in Create_field::set_and_check() */
  charset= cs;
}


bool LEX::set_bincmp(CHARSET_INFO *cs, bool bin)
{
  /*
     if charset is NULL - we're parsing a field declaration.
     we cannot call find_bin_collation for a field here, because actual
     field charset is determined in get_sql_field_charset() much later.
     so we only set a flag.
  */
  if (!charset)
  {
    charset= cs;
    last_field->flags|= bin ? BINCMP_FLAG : 0;
    return false;
  }

  charset= bin ? find_bin_collation(cs ? cs : charset)
               :                    cs ? cs : charset;
  return charset == NULL;
}

#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


Virtual_column_info *add_virtual_expression(THD *thd, Item *expr)
{
  Virtual_column_info *v= new (thd->mem_root) Virtual_column_info();
  if (unlikely(!v))
     return 0;
   v->expr= expr;
   v->utf8= 0;  /* connection charset */
   return v;
}



#line 751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DEFINER_SYM = 402,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 403,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 404,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 405,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 406,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 407,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 408,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 409,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 410,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 411,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 412,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 413,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 414,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 415,               /* ENABLE_SYM  */
  YYSYMBOL_END = 416,                      /* END  */
  YYSYMBOL_ENDS_SYM = 417,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 418,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 419,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 420,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 421,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 422,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 423,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 424,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 425,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 426,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 427,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 428,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 429,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 430,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 431,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 432,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 433,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 434,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 435,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 436,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 437,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 438,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 439,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 440,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 441,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 442,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 443,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 444,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 445,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 446,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 447,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 448,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 449,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 450,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 451,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 452,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 453,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 454,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 455,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 456,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 457,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 458,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 459,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 460,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 461,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 462,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 463,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 464,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 465,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 466,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 467,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 468,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 469,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 470,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 471,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 472,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 473,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 474,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 475,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 476,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 477,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 478,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 479,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 480,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 481,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 482,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 483,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 484,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 485,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 486,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 487,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 488,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 489,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 490,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 491,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 492,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 493,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 494,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 495,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 496,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 497,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 498,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 499,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 500,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 501, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 502,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 503,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 504,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 505,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 506,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 507,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 508,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 509,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 510,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 511,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 512,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 513,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 514,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 515,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 516,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 517,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 518,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 519,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 520,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 521, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 522, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 523,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 524,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 525,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 526,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 527,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 528, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 529,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 530,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 531,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 532,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 533,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 534,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 535,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 536,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 537,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 538,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 539,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 540,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 541,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 542,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 543,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 544,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 545,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 546,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 547,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 548,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 549,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 550,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 551,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 552,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 553,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 554,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 555,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 556,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 557,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 558,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 559,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 560,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 561,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 562,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 563,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 564,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 565,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 566,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 567,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 568,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 569,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 570,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 571,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 572,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 573,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 574,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 575,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 576,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 577,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 578,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 579,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 580,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 581,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 582,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 583,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 584,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 585,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 586,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 587,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 588,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 589,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 590,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 591,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 592,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 593,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 594,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 595,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 596,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 597,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 598,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 599,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 600,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 601,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 602,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 603,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 604,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 605,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 606,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 607,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 608,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 609,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 610,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 611,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 612,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 613,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 614,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 615,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 616,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 617,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 618,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 619,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 620,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 621,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 622,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 623,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 624,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 625,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 626,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 627,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 628,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 629,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 630,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 631,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 632,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 633,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 634,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 635,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 636,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 637,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 638,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 639,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 640,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 641,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 642,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 643,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 644,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 645,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 646,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 647,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 648,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 649,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 650,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 651,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 652,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 653,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 654,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 655,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 656,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 657,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 658,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 659,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 660,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 661,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 662,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 663,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 664,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 665,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 666,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 667,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 668,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 669,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 670,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 671,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 672,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 673,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 674,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 675,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 676,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 677,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 678,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 679,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 680,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 681,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 682,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 683,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 684,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 685,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 686,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 687,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 688,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 689,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 690,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 691,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 692,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 693,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 694,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 695,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 696,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 697,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 698,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 699,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 700,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 701,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 702,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 703,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 704,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 705,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 706,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 707,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 708,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 709,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 710,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 711,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 712,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 713,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 714,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 715,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 716,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 717,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 718,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 719,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 720,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 721,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 722,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 723,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 724,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 725,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 726,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 727,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 728,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 729,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 730,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 731,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 732,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 733,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 734,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 735,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 736,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 737,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 738,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 739,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 740,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 741,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 742,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 743,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 744,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 745,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 746,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 747,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 748,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 749,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 750,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 751,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 752,           /* PREC_BELOW_NOT  */
  YYSYMBOL_753_ = 753,                     /* '='  */
  YYSYMBOL_754_ = 754,                     /* '>'  */
  YYSYMBOL_755_ = 755,                     /* '<'  */
  YYSYMBOL_756_ = 756,                     /* '|'  */
  YYSYMBOL_757_ = 757,                     /* '&'  */
  YYSYMBOL_758_ = 758,                     /* '-'  */
  YYSYMBOL_759_ = 759,                     /* '+'  */
  YYSYMBOL_760_ = 760,                     /* '*'  */
  YYSYMBOL_761_ = 761,                     /* '/'  */
  YYSYMBOL_762_ = 762,                     /* '%'  */
  YYSYMBOL_763_ = 763,                     /* '^'  */
  YYSYMBOL_764_ = 764,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 765,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 766, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 767,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 768, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_769_ = 769,                     /* '('  */
  YYSYMBOL_770_ = 770,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 771,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_772_ = 772,                     /* ','  */
  YYSYMBOL_773_ = 773,                     /* '!'  */
  YYSYMBOL_774_ = 774,                     /* '{'  */
  YYSYMBOL_775_ = 775,                     /* '}'  */
  YYSYMBOL_776_ = 776,                     /* ';'  */
  YYSYMBOL_777_ = 777,                     /* '.'  */
  YYSYMBOL_778_ = 778,                     /* '@'  */
  YYSYMBOL_779_ = 779,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 780,                 /* $accept  */
  YYSYMBOL_query = 781,                    /* query  */
  YYSYMBOL_782_1 = 782,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 783,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 784,              /* verb_clause  */
  YYSYMBOL_statement = 785,                /* statement  */
  YYSYMBOL_deallocate = 786,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 787,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 788,                  /* prepare  */
  YYSYMBOL_789_2 = 789,                    /* $@2  */
  YYSYMBOL_execute = 790,                  /* execute  */
  YYSYMBOL_791_3 = 791,                    /* $@3  */
  YYSYMBOL_792_4 = 792,                    /* $@4  */
  YYSYMBOL_execute_using = 793,            /* execute_using  */
  YYSYMBOL_794_5 = 794,                    /* $@5  */
  YYSYMBOL_execute_params = 795,           /* execute_params  */
  YYSYMBOL_help = 796,                     /* help  */
  YYSYMBOL_797_6 = 797,                    /* $@6  */
  YYSYMBOL_change = 798,                   /* change  */
  YYSYMBOL_799_7 = 799,                    /* $@7  */
  YYSYMBOL_master_defs = 800,              /* master_defs  */
  YYSYMBOL_master_def = 801,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 802,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 803,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 804,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 805,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 806,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 807,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 808,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 809, /* optional_connection_name  */
  YYSYMBOL_connection_name = 810,          /* connection_name  */
  YYSYMBOL_create = 811,                   /* create  */
  YYSYMBOL_812_8 = 812,                    /* $@8  */
  YYSYMBOL_813_9 = 813,                    /* $@9  */
  YYSYMBOL_814_10 = 814,                   /* $@10  */
  YYSYMBOL_815_11 = 815,                   /* $@11  */
  YYSYMBOL_816_12 = 816,                   /* $@12  */
  YYSYMBOL_817_13 = 817,                   /* $@13  */
  YYSYMBOL_818_14 = 818,                   /* $@14  */
  YYSYMBOL_819_15 = 819,                   /* $@15  */
  YYSYMBOL_820_16 = 820,                   /* $@16  */
  YYSYMBOL_821_17 = 821,                   /* $@17  */
  YYSYMBOL_822_18 = 822,                   /* $@18  */
  YYSYMBOL_823_19 = 823,                   /* $@19  */
  YYSYMBOL_824_20 = 824,                   /* $@20  */
  YYSYMBOL_825_21 = 825,                   /* $@21  */
  YYSYMBOL_826_22 = 826,                   /* $@22  */
  YYSYMBOL_827_23 = 827,                   /* $@23  */
  YYSYMBOL_828_24 = 828,                   /* $@24  */
  YYSYMBOL_829_25 = 829,                   /* $@25  */
  YYSYMBOL_opt_sequence = 830,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 831,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 832,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 833,          /* force_lookahead  */
  YYSYMBOL_server_def = 834,               /* server_def  */
  YYSYMBOL_835_26 = 835,                   /* $@26  */
  YYSYMBOL_server_options_list = 836,      /* server_options_list  */
  YYSYMBOL_server_option = 837,            /* server_option  */
  YYSYMBOL_event_tail = 838,               /* event_tail  */
  YYSYMBOL_839_27 = 839,                   /* $@27  */
  YYSYMBOL_ev_schedule_time = 840,         /* ev_schedule_time  */
  YYSYMBOL_841_28 = 841,                   /* $@28  */
  YYSYMBOL_opt_ev_status = 842,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 843,                /* ev_starts  */
  YYSYMBOL_ev_ends = 844,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 845,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 846,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 847,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 848,              /* ev_sql_stmt  */
  YYSYMBOL_849_29 = 849,                   /* $@29  */
  YYSYMBOL_clear_privileges = 850,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 851,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 852,                  /* sp_name  */
  YYSYMBOL_sp_a_chistics = 853,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 854,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 855,               /* sp_chistic  */
  YYSYMBOL_sp_c_chistic = 856,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 857,                  /* sp_suid  */
  YYSYMBOL_call = 858,                     /* call  */
  YYSYMBOL_859_30 = 859,                   /* $@30  */
  YYSYMBOL_860_31 = 860,                   /* $@31  */
  YYSYMBOL_861_32 = 861,                   /* $@32  */
  YYSYMBOL_opt_sp_cparam_list = 862,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 863,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 864,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 865,          /* sp_fdparam_list  */
  YYSYMBOL_866_33 = 866,                   /* $@33  */
  YYSYMBOL_sp_fdparams = 867,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 868,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 869,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 870,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 871,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 872,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 873,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 874, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_875_34 = 875,                   /* $@34  */
  YYSYMBOL_sp_proc_stmts = 876,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 877,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_decls = 878,                 /* sp_decls  */
  YYSYMBOL_sp_decl = 879,                  /* sp_decl  */
  YYSYMBOL_optionally_qualified_column_ident = 880, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 881,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 882,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 883, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 884,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 885, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_variable_list = 886,    /* sp_decl_variable_list  */
  YYSYMBOL_sp_decl_body = 887,             /* sp_decl_body  */
  YYSYMBOL_888_35 = 888,                   /* $@35  */
  YYSYMBOL_sp_decl_handler = 889,          /* sp_decl_handler  */
  YYSYMBOL_890_36 = 890,                   /* $@36  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 891, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 892,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 893,           /* sp_cursor_stmt  */
  YYSYMBOL_894_37 = 894,                   /* $@37  */
  YYSYMBOL_sp_handler_type = 895,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 896,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 897,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 898,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 899,                 /* sqlstate  */
  YYSYMBOL_opt_value = 900,                /* opt_value  */
  YYSYMBOL_sp_hcond = 901,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 902,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 903,              /* signal_stmt  */
  YYSYMBOL_signal_value = 904,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 905,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 906, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 907, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 908,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 909, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 910,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 911,          /* get_diagnostics  */
  YYSYMBOL_which_area = 912,               /* which_area  */
  YYSYMBOL_diagnostics_information = 913,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 914,    /* statement_information  */
  YYSYMBOL_statement_information_item = 915, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 916, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 917, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 918,         /* condition_number  */
  YYSYMBOL_condition_information = 919,    /* condition_information  */
  YYSYMBOL_condition_information_item = 920, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 921, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 922,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 923,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 924,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt_in_returns_clause = 925, /* sp_proc_stmt_in_returns_clause  */
  YYSYMBOL_sp_proc_stmt = 926,             /* sp_proc_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 927, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 928,          /* sp_proc_stmt_if  */
  YYSYMBOL_929_38 = 929,                   /* $@38  */
  YYSYMBOL_sp_proc_stmt_statement = 930,   /* sp_proc_stmt_statement  */
  YYSYMBOL_931_39 = 931,                   /* $@39  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 932,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 933,      /* sp_proc_stmt_return  */
  YYSYMBOL_934_40 = 934,                   /* $@40  */
  YYSYMBOL_reset_lex_expr = 935,           /* reset_lex_expr  */
  YYSYMBOL_936_41 = 936,                   /* $@41  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 937, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 938, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 939,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 940,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 941, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_assignment_source_lex = 942,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 943,   /* assignment_source_expr  */
  YYSYMBOL_944_42 = 944,                   /* $@42  */
  YYSYMBOL_for_loop_bound_expr = 945,      /* for_loop_bound_expr  */
  YYSYMBOL_946_43 = 946,                   /* $@43  */
  YYSYMBOL_cursor_actual_parameters = 947, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 948, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 949,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 950,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 951,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 952,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 953,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 954,                    /* sp_if  */
  YYSYMBOL_955_44 = 955,                   /* $@44  */
  YYSYMBOL_956_45 = 956,                   /* $@45  */
  YYSYMBOL_957_46 = 957,                   /* $@46  */
  YYSYMBOL_sp_elseifs = 958,               /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 959,  /* case_stmt_specification  */
  YYSYMBOL_960_47 = 960,                   /* $@47  */
  YYSYMBOL_case_stmt_body = 961,           /* case_stmt_body  */
  YYSYMBOL_962_48 = 962,                   /* $@48  */
  YYSYMBOL_963_49 = 963,                   /* $@49  */
  YYSYMBOL_simple_when_clause_list = 964,  /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 965, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 966,       /* simple_when_clause  */
  YYSYMBOL_967_50 = 967,                   /* $@50  */
  YYSYMBOL_968_51 = 968,                   /* $@51  */
  YYSYMBOL_searched_when_clause = 969,     /* searched_when_clause  */
  YYSYMBOL_970_52 = 970,                   /* $@52  */
  YYSYMBOL_971_53 = 971,                   /* $@53  */
  YYSYMBOL_else_clause_opt = 972,          /* else_clause_opt  */
  YYSYMBOL_sp_label = 973,                 /* sp_label  */
  YYSYMBOL_sp_opt_label = 974,             /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 975,           /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 976,         /* sp_labeled_block  */
  YYSYMBOL_977_54 = 977,                   /* $@54  */
  YYSYMBOL_sp_unlabeled_block = 978,       /* sp_unlabeled_block  */
  YYSYMBOL_979_55 = 979,                   /* $@55  */
  YYSYMBOL_sp_unlabeled_block_not_atomic = 980, /* sp_unlabeled_block_not_atomic  */
  YYSYMBOL_981_56 = 981,                   /* $@56  */
  YYSYMBOL_opt_sp_for_loop_direction = 982, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 983, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_984_57 = 984,                   /* $@57  */
  YYSYMBOL_sp_for_loop_bounds = 985,       /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 986,                /* loop_body  */
  YYSYMBOL_while_body = 987,               /* while_body  */
  YYSYMBOL_988_58 = 988,                   /* $@58  */
  YYSYMBOL_repeat_body = 989,              /* repeat_body  */
  YYSYMBOL_990_59 = 990,                   /* $@59  */
  YYSYMBOL_pop_sp_loop_label = 991,        /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 992,       /* sp_labeled_control  */
  YYSYMBOL_993_60 = 993,                   /* $@60  */
  YYSYMBOL_994_61 = 994,                   /* $@61  */
  YYSYMBOL_995_62 = 995,                   /* $@62  */
  YYSYMBOL_996_63 = 996,                   /* $@63  */
  YYSYMBOL_997_64 = 997,                   /* $@64  */
  YYSYMBOL_998_65 = 998,                   /* $@65  */
  YYSYMBOL_sp_unlabeled_control = 999,     /* sp_unlabeled_control  */
  YYSYMBOL_1000_66 = 1000,                 /* $@66  */
  YYSYMBOL_1001_67 = 1001,                 /* $@67  */
  YYSYMBOL_1002_68 = 1002,                 /* $@68  */
  YYSYMBOL_1003_69 = 1003,                 /* $@69  */
  YYSYMBOL_1004_70 = 1004,                 /* $@70  */
  YYSYMBOL_trg_action_time = 1005,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1006,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1007, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1008,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1009,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1010,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1011,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1012,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1013, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1014,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1015,   /* change_ts_option_list  */
  YYSYMBOL_1016_71 = 1016,                 /* $@71  */
  YYSYMBOL_change_ts_options = 1017,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1018,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1019,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1020,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1021,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1022, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1023, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1024, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1025, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1026,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1027,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1028, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1029, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1030, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1031,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1032,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1033,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1034,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1035,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1036,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1037,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1038,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1039,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1040,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1041, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1042, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1043,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1044,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1045,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1046,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1047,                 /* ts_wait  */
  YYSYMBOL_size_number = 1048,             /* size_number  */
  YYSYMBOL_create_body = 1049,             /* create_body  */
  YYSYMBOL_1050_72 = 1050,                 /* $@72  */
  YYSYMBOL_create_like = 1051,             /* create_like  */
  YYSYMBOL_opt_create_select = 1052,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1053, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1054, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1055,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1056,            /* partitioning  */
  YYSYMBOL_1057_73 = 1057,                 /* $@73  */
  YYSYMBOL_have_partitioning = 1058,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1059,         /* partition_entry  */
  YYSYMBOL_1060_74 = 1060,                 /* $@74  */
  YYSYMBOL_partition = 1061,               /* partition  */
  YYSYMBOL_1062_75 = 1062,                 /* $@75  */
  YYSYMBOL_part_type_def = 1063,           /* part_type_def  */
  YYSYMBOL_1064_76 = 1064,                 /* $@76  */
  YYSYMBOL_1065_77 = 1065,                 /* $@77  */
  YYSYMBOL_1066_78 = 1066,                 /* $@78  */
  YYSYMBOL_opt_linear = 1067,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1068,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1069,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1070,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1071,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1072,        /* part_column_list  */
  YYSYMBOL_part_func = 1073,               /* part_func  */
  YYSYMBOL_sub_part_func = 1074,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1075,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1076,            /* opt_sub_part  */
  YYSYMBOL_1077_79 = 1077,                 /* $@79  */
  YYSYMBOL_1078_80 = 1078,                 /* $@80  */
  YYSYMBOL_sub_part_field_list = 1079,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1080,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1081,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1082,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1083,               /* part_defs  */
  YYSYMBOL_part_def_list = 1084,           /* part_def_list  */
  YYSYMBOL_part_definition = 1085,         /* part_definition  */
  YYSYMBOL_1086_81 = 1086,                 /* $@81  */
  YYSYMBOL_part_name = 1087,               /* part_name  */
  YYSYMBOL_opt_part_values = 1088,         /* opt_part_values  */
  YYSYMBOL_1089_82 = 1089,                 /* $@82  */
  YYSYMBOL_1090_83 = 1090,                 /* $@83  */
  YYSYMBOL_part_func_max = 1091,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1092,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1093,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1094,         /* part_value_item  */
  YYSYMBOL_1095_84 = 1095,                 /* $@84  */
  YYSYMBOL_1096_85 = 1096,                 /* $@85  */
  YYSYMBOL_part_value_item_list = 1097,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1098,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1099,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1100,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1101,     /* sub_part_definition  */
  YYSYMBOL_1102_86 = 1102,                 /* $@86  */
  YYSYMBOL_sub_name = 1103,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1104,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1105,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1106,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1107, /* opt_versioning_rotation  */
  YYSYMBOL_1108_87 = 1108,                 /* $@87  */
  YYSYMBOL_opt_versioning_interval_start = 1109, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1110,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1111, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1112, /* create_database_options  */
  YYSYMBOL_create_database_option = 1113,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1114, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1115,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1116,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1117, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1118, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1119,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1120,     /* create_table_option  */
  YYSYMBOL_1121_88 = 1121,                 /* $@88  */
  YYSYMBOL_opt_versioning_option = 1122,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1123,       /* versioning_option  */
  YYSYMBOL_default_charset = 1124,         /* default_charset  */
  YYSYMBOL_default_collation = 1125,       /* default_collation  */
  YYSYMBOL_storage_engines = 1126,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1127,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1128,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1129,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1130,                /* udf_type  */
  YYSYMBOL_create_field_list = 1131,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1132, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1133,              /* field_list  */
  YYSYMBOL_field_list_item = 1134,         /* field_list_item  */
  YYSYMBOL_column_def = 1135,              /* column_def  */
  YYSYMBOL_key_def = 1136,                 /* key_def  */
  YYSYMBOL_1137_89 = 1137,                 /* $@89  */
  YYSYMBOL_1138_90 = 1138,                 /* $@90  */
  YYSYMBOL_1139_91 = 1139,                 /* $@91  */
  YYSYMBOL_1140_92 = 1140,                 /* $@92  */
  YYSYMBOL_1141_93 = 1141,                 /* $@93  */
  YYSYMBOL_1142_94 = 1142,                 /* $@94  */
  YYSYMBOL_1143_95 = 1143,                 /* $@95  */
  YYSYMBOL_constraint_def = 1144,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1145,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1146, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1147,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1148,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1149,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1150,          /* opt_constraint  */
  YYSYMBOL_constraint = 1151,              /* constraint  */
  YYSYMBOL_field_spec = 1152,              /* field_spec  */
  YYSYMBOL_1153_96 = 1153,                 /* @96  */
  YYSYMBOL_field_type_or_serial = 1154,    /* field_type_or_serial  */
  YYSYMBOL_1155_97 = 1155,                 /* $@97  */
  YYSYMBOL_1156_98 = 1156,                 /* $@98  */
  YYSYMBOL_opt_serial_attribute = 1157,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1158, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1159,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1160, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1161,               /* field_def  */
  YYSYMBOL_1162_99 = 1162,                 /* $@99  */
  YYSYMBOL_opt_generated_always = 1163,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1164,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1165,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1166, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1167,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1168,         /* parse_vcol_expr  */
  YYSYMBOL_1169_100 = 1169,                /* $@100  */
  YYSYMBOL_parenthesized_expr = 1170,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1171,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1172,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1173,     /* column_default_expr  */
  YYSYMBOL_field_type = 1174,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1175,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1176,          /* field_type_all  */
  YYSYMBOL_field_type_numeric = 1177,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1178, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1179,       /* field_type_string  */
  YYSYMBOL_field_type_temporal = 1180,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1181,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1182,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1183,            /* spatial_type  */
  YYSYMBOL_char = 1184,                    /* char  */
  YYSYMBOL_nchar = 1185,                   /* nchar  */
  YYSYMBOL_varchar = 1186,                 /* varchar  */
  YYSYMBOL_nvarchar = 1187,                /* nvarchar  */
  YYSYMBOL_int_type = 1188,                /* int_type  */
  YYSYMBOL_real_type = 1189,               /* real_type  */
  YYSYMBOL_srid_option = 1190,             /* srid_option  */
  YYSYMBOL_float_options = 1191,           /* float_options  */
  YYSYMBOL_precision = 1192,               /* precision  */
  YYSYMBOL_field_options = 1193,           /* field_options  */
  YYSYMBOL_field_length = 1194,            /* field_length  */
  YYSYMBOL_opt_field_length = 1195,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1196, /* opt_field_length_default_1  */
  YYSYMBOL_opt_precision = 1197,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1198,          /* attribute_list  */
  YYSYMBOL_attribute = 1199,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1200,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1201,          /* opt_compressed  */
  YYSYMBOL_compressed = 1202,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1203, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1204, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1205,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1206,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1207,  /* with_or_without_system  */
  YYSYMBOL_charset = 1208,                 /* charset  */
  YYSYMBOL_charset_name = 1209,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1210, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1211,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1212, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1213, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1214,          /* collation_name  */
  YYSYMBOL_opt_collate = 1215,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1216, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1217,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1218,        /* charset_or_alias  */
  YYSYMBOL_collate = 1219,                 /* collate  */
  YYSYMBOL_opt_binary = 1220,              /* opt_binary  */
  YYSYMBOL_binary = 1221,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1222,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1223,             /* ws_nweights  */
  YYSYMBOL_1224_101 = 1224,                /* $@101  */
  YYSYMBOL_ws_level_flag_desc = 1225,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1226,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1227,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1228,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1229,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1230,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1231,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1232,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1233,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1234,             /* opt_primary  */
  YYSYMBOL_references = 1235,              /* references  */
  YYSYMBOL_opt_ref_list = 1236,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1237,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1238,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1239,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1240,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1241,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1242,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1243,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1244,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1245,              /* opt_unique  */
  YYSYMBOL_fulltext = 1246,                /* fulltext  */
  YYSYMBOL_spatial = 1247,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1248,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1249,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1250,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1251,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1252,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1253,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1254, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1255, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1256,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1257,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1258,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1259,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1260,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1261,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1262,                /* key_list  */
  YYSYMBOL_key_part = 1263,                /* key_part  */
  YYSYMBOL_opt_ident = 1264,               /* opt_ident  */
  YYSYMBOL_string_list = 1265,             /* string_list  */
  YYSYMBOL_alter = 1266,                   /* alter  */
  YYSYMBOL_1267_102 = 1267,                /* $@102  */
  YYSYMBOL_1268_103 = 1268,                /* $@103  */
  YYSYMBOL_1269_104 = 1269,                /* $@104  */
  YYSYMBOL_1270_105 = 1270,                /* $@105  */
  YYSYMBOL_1271_106 = 1271,                /* $@106  */
  YYSYMBOL_1272_107 = 1272,                /* $@107  */
  YYSYMBOL_1273_108 = 1273,                /* $@108  */
  YYSYMBOL_1274_109 = 1274,                /* $@109  */
  YYSYMBOL_1275_110 = 1275,                /* $@110  */
  YYSYMBOL_1276_111 = 1276,                /* $@111  */
  YYSYMBOL_1277_112 = 1277,                /* $@112  */
  YYSYMBOL_account_locking_option = 1278,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1279, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1280, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1281, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1282,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1283,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1284,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1285,          /* alter_commands  */
  YYSYMBOL_1286_113 = 1286,                /* $@113  */
  YYSYMBOL_1287_114 = 1287,                /* $@114  */
  YYSYMBOL_1288_115 = 1288,                /* $@115  */
  YYSYMBOL_remove_partitioning = 1289,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1290, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1291,      /* add_partition_rule  */
  YYSYMBOL_1292_116 = 1292,                /* $@116  */
  YYSYMBOL_add_part_extra = 1293,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1294,    /* reorg_partition_rule  */
  YYSYMBOL_1295_117 = 1295,                /* $@117  */
  YYSYMBOL_reorg_parts_rule = 1296,        /* reorg_parts_rule  */
  YYSYMBOL_1297_118 = 1297,                /* $@118  */
  YYSYMBOL_alt_part_name_list = 1298,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1299,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1300,              /* alter_list  */
  YYSYMBOL_add_column = 1301,              /* add_column  */
  YYSYMBOL_alter_list_item = 1302,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1303, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1304,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1305,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1306,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1307,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1308,           /* alter_options  */
  YYSYMBOL_1309_119 = 1309,                /* $@119  */
  YYSYMBOL_alter_options_part2 = 1310,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1311,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1312,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1313,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1314,               /* opt_place  */
  YYSYMBOL_opt_to = 1315,                  /* opt_to  */
  YYSYMBOL_slave = 1316,                   /* slave  */
  YYSYMBOL_1317_120 = 1317,                /* $@120  */
  YYSYMBOL_1318_121 = 1318,                /* $@121  */
  YYSYMBOL_start = 1319,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1320, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1321, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1322, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1323,       /* slave_thread_opts  */
  YYSYMBOL_1324_122 = 1324,                /* $@122  */
  YYSYMBOL_slave_thread_opt_list = 1325,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1326,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1327,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1328,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1329,                /* checksum  */
  YYSYMBOL_1330_123 = 1330,                /* $@123  */
  YYSYMBOL_opt_checksum_type = 1331,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1332,    /* repair_table_or_view  */
  YYSYMBOL_1333_124 = 1333,                /* $@124  */
  YYSYMBOL_repair = 1334,                  /* repair  */
  YYSYMBOL_1335_125 = 1335,                /* $@125  */
  YYSYMBOL_opt_mi_repair_type = 1336,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1337,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1338,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1339,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1340,                 /* analyze  */
  YYSYMBOL_1341_126 = 1341,                /* $@126  */
  YYSYMBOL_analyze_table_list = 1342,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1343, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1344, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1345,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1346, /* persistent_column_stat_spec  */
  YYSYMBOL_1347_127 = 1347,                /* $@127  */
  YYSYMBOL_persistent_index_stat_spec = 1348, /* persistent_index_stat_spec  */
  YYSYMBOL_1349_128 = 1349,                /* $@128  */
  YYSYMBOL_table_column_list = 1350,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1351,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1352,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1353,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1354,     /* check_view_or_table  */
  YYSYMBOL_1355_129 = 1355,                /* $@129  */
  YYSYMBOL_check = 1356,                   /* check  */
  YYSYMBOL_1357_130 = 1357,                /* $@130  */
  YYSYMBOL_opt_mi_check_type = 1358,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1359,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1360,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1361,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1362,                /* optimize  */
  YYSYMBOL_1363_131 = 1363,                /* $@131  */
  YYSYMBOL_opt_no_write_to_binlog = 1364,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1365,                  /* rename  */
  YYSYMBOL_1366_132 = 1366,                /* $@132  */
  YYSYMBOL_rename_list = 1367,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1368,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1369,          /* table_to_table  */
  YYSYMBOL_keycache = 1370,                /* keycache  */
  YYSYMBOL_1371_133 = 1371,                /* $@133  */
  YYSYMBOL_keycache_list_or_parts = 1372,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1373,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1374,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1375, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1376,          /* key_cache_name  */
  YYSYMBOL_preload = 1377,                 /* preload  */
  YYSYMBOL_1378_134 = 1378,                /* $@134  */
  YYSYMBOL_preload_list_or_parts = 1379,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1380,            /* preload_list  */
  YYSYMBOL_preload_keys = 1381,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1382,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1383,           /* adm_partition  */
  YYSYMBOL_1384_135 = 1384,                /* $@135  */
  YYSYMBOL_cache_keys_spec = 1385,         /* cache_keys_spec  */
  YYSYMBOL_1386_136 = 1386,                /* $@136  */
  YYSYMBOL_cache_key_list_or_empty = 1387, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1388,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1389,                  /* select  */
  YYSYMBOL_1390_137 = 1390,                /* $@137  */
  YYSYMBOL_1391_138 = 1391,                /* $@138  */
  YYSYMBOL_select_into = 1392,             /* select_into  */
  YYSYMBOL_1393_139 = 1393,                /* $@139  */
  YYSYMBOL_1394_140 = 1394,                /* $@140  */
  YYSYMBOL_simple_table = 1395,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1396, /* table_value_constructor  */
  YYSYMBOL_1397_141 = 1397,                /* $@141  */
  YYSYMBOL_query_specification_start = 1398, /* query_specification_start  */
  YYSYMBOL_1399_142 = 1399,                /* $@142  */
  YYSYMBOL_1400_143 = 1400,                /* $@143  */
  YYSYMBOL_query_specification = 1401,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1402, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1403,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1404, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1405, /* query_expression_body_ext  */
  YYSYMBOL_1406_144 = 1406,                /* $@144  */
  YYSYMBOL_1407_145 = 1407,                /* $@145  */
  YYSYMBOL_query_expression_body_ext_parens = 1408, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1409,   /* query_expression_body  */
  YYSYMBOL_1410_146 = 1410,                /* $@146  */
  YYSYMBOL_query_primary = 1411,           /* query_primary  */
  YYSYMBOL_query_simple = 1412,            /* query_simple  */
  YYSYMBOL_subselect = 1413,               /* subselect  */
  YYSYMBOL_subquery = 1414,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1415,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1416,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1417,    /* table_reference_list  */
  YYSYMBOL_select_options = 1418,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1419,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1420,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1421, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1422, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1423, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1424,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1425,      /* select_option_list  */
  YYSYMBOL_select_option = 1426,           /* select_option  */
  YYSYMBOL_select_lock_type = 1427,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1428,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1429, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1430,        /* select_item_list  */
  YYSYMBOL_select_item = 1431,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1432,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1433,           /* remember_name  */
  YYSYMBOL_remember_end = 1434,            /* remember_end  */
  YYSYMBOL_select_alias = 1435,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1436, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1437,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1438,         /* optional_braces  */
  YYSYMBOL_expr = 1439,                    /* expr  */
  YYSYMBOL_boolean_test = 1440,            /* boolean_test  */
  YYSYMBOL_predicate = 1441,               /* predicate  */
  YYSYMBOL_bit_expr = 1442,                /* bit_expr  */
  YYSYMBOL_or = 1443,                      /* or  */
  YYSYMBOL_and = 1444,                     /* and  */
  YYSYMBOL_not = 1445,                     /* not  */
  YYSYMBOL_not2 = 1446,                    /* not2  */
  YYSYMBOL_comp_op = 1447,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1448,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1449,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1450,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1451,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1452,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1453,      /* string_dyncol_type  */
  YYSYMBOL_1454_147 = 1454,                /* $@147  */
  YYSYMBOL_dyncall_create_element = 1455,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1456,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1457,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1458,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1459,           /* trim_operands  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1460, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1461,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1462,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1463,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1464, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1465, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1466,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1467,      /* substring_operands  */
  YYSYMBOL_function_call_nonkeyword = 1468, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1469,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1470,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1471,   /* function_call_generic  */
  YYSYMBOL_1472_148 = 1472,                /* @148  */
  YYSYMBOL_fulltext_options = 1473,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1474, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1475,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1476,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1477,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1478,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1479,                /* sum_expr  */
  YYSYMBOL_1480_149 = 1480,                /* $@149  */
  YYSYMBOL_1481_150 = 1481,                /* $@150  */
  YYSYMBOL_1482_151 = 1482,                /* $@151  */
  YYSYMBOL_window_func_expr = 1483,        /* window_func_expr  */
  YYSYMBOL_window_func = 1484,             /* window_func  */
  YYSYMBOL_simple_window_func = 1485,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1486, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1487,     /* percentile_function  */
  YYSYMBOL_1488_152 = 1488,                /* $@152  */
  YYSYMBOL_inverse_distribution_function_def = 1489, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1490, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1491,             /* window_name  */
  YYSYMBOL_variable = 1492,                /* variable  */
  YYSYMBOL_1493_153 = 1493,                /* $@153  */
  YYSYMBOL_variable_aux = 1494,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1495,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1496,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1497,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1498,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1499,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1500,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1501,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1502,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1503,             /* in_sum_expr  */
  YYSYMBOL_1504_154 = 1504,                /* $@154  */
  YYSYMBOL_cast_type = 1505,               /* cast_type  */
  YYSYMBOL_1506_155 = 1506,                /* $@155  */
  YYSYMBOL_1507_156 = 1507,                /* $@156  */
  YYSYMBOL_1508_157 = 1508,                /* $@157  */
  YYSYMBOL_cast_type_numeric = 1509,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1510,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1511,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1512,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1513,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1514,              /* ident_list  */
  YYSYMBOL_when_list = 1515,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1516,      /* when_list_opt_else  */
  YYSYMBOL_table_ref = 1517,               /* table_ref  */
  YYSYMBOL_join_table_list = 1518,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1519,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1520,      /* derived_table_list  */
  YYSYMBOL_join_table = 1521,              /* join_table  */
  YYSYMBOL_1522_158 = 1522,                /* $@158  */
  YYSYMBOL_1523_159 = 1523,                /* $@159  */
  YYSYMBOL_1524_160 = 1524,                /* $@160  */
  YYSYMBOL_1525_161 = 1525,                /* $@161  */
  YYSYMBOL_1526_162 = 1526,                /* $@162  */
  YYSYMBOL_1527_163 = 1527,                /* $@163  */
  YYSYMBOL_inner_join = 1528,              /* inner_join  */
  YYSYMBOL_normal_join = 1529,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1530,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1531,           /* use_partition  */
  YYSYMBOL_table_factor = 1532,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1533, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1534, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1535, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1536, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1537,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1538,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1539,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1540,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1541,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1542,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1543,   /* index_hint_definition  */
  YYSYMBOL_1544_164 = 1544,                /* $@164  */
  YYSYMBOL_1545_165 = 1545,                /* $@165  */
  YYSYMBOL_index_hints_list = 1546,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1547,    /* opt_index_hints_list  */
  YYSYMBOL_1548_166 = 1548,                /* $@166  */
  YYSYMBOL_opt_key_definition = 1549,      /* opt_key_definition  */
  YYSYMBOL_1550_167 = 1550,                /* $@167  */
  YYSYMBOL_opt_key_usage_list = 1551,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1552,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1553,          /* key_usage_list  */
  YYSYMBOL_using_list = 1554,              /* using_list  */
  YYSYMBOL_interval = 1555,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1556,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1557,          /* date_time_type  */
  YYSYMBOL_table_alias = 1558,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1559,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1560,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1561,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1562,        /* opt_where_clause  */
  YYSYMBOL_1563_168 = 1563,                /* $@168  */
  YYSYMBOL_opt_having_clause = 1564,       /* opt_having_clause  */
  YYSYMBOL_1565_169 = 1565,                /* $@169  */
  YYSYMBOL_opt_group_clause = 1566,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1567,              /* group_list  */
  YYSYMBOL_olap_opt = 1568,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1569,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1570,         /* window_def_list  */
  YYSYMBOL_window_def = 1571,              /* window_def  */
  YYSYMBOL_window_spec = 1572,             /* window_spec  */
  YYSYMBOL_1573_170 = 1573,                /* $@170  */
  YYSYMBOL_opt_window_ref = 1574,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1575, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1576, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1577, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1578,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1579,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1580,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1581,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1582, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1583,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1584,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1585,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1586,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1587,            /* order_clause  */
  YYSYMBOL_1588_171 = 1588,                /* $@171  */
  YYSYMBOL_order_list = 1589,              /* order_list  */
  YYSYMBOL_order_dir = 1590,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1591,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1592,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1593, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1594,           /* limit_options  */
  YYSYMBOL_limit_option = 1595,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1596,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1597,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1598,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1599,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1600,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1601, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1602,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1603,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1604,                /* opt_plus  */
  YYSYMBOL_int_num = 1605,                 /* int_num  */
  YYSYMBOL_ulong_num = 1606,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1607,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1608,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1609,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1610,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1611,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1612,                 /* dec_num  */
  YYSYMBOL_choice = 1613,                  /* choice  */
  YYSYMBOL_bool = 1614,                    /* bool  */
  YYSYMBOL_procedure_clause = 1615,        /* procedure_clause  */
  YYSYMBOL_1616_172 = 1616,                /* $@172  */
  YYSYMBOL_procedure_list = 1617,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1618,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1619,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1620,    /* select_var_list_init  */
  YYSYMBOL_1621_173 = 1621,                /* $@173  */
  YYSYMBOL_select_var_list = 1622,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1623,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1624,           /* select_outvar  */
  YYSYMBOL_into = 1625,                    /* into  */
  YYSYMBOL_into_destination = 1626,        /* into_destination  */
  YYSYMBOL_1627_174 = 1627,                /* $@174  */
  YYSYMBOL_1628_175 = 1628,                /* $@175  */
  YYSYMBOL_do = 1629,                      /* do  */
  YYSYMBOL_1630_176 = 1630,                /* $@176  */
  YYSYMBOL_drop = 1631,                    /* drop  */
  YYSYMBOL_1632_177 = 1632,                /* $@177  */
  YYSYMBOL_1633_178 = 1633,                /* $@178  */
  YYSYMBOL_1634_179 = 1634,                /* $@179  */
  YYSYMBOL_1635_180 = 1635,                /* $@180  */
  YYSYMBOL_table_list = 1636,              /* table_list  */
  YYSYMBOL_table_name = 1637,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1638, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1639,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1640,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1641, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1642,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1643,           /* opt_temporary  */
  YYSYMBOL_insert = 1644,                  /* insert  */
  YYSYMBOL_1645_181 = 1645,                /* $@181  */
  YYSYMBOL_1646_182 = 1646,                /* $@182  */
  YYSYMBOL_replace = 1647,                 /* replace  */
  YYSYMBOL_1648_183 = 1648,                /* $@183  */
  YYSYMBOL_1649_184 = 1649,                /* $@184  */
  YYSYMBOL_insert_lock_option = 1650,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1651,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1652,                 /* insert2  */
  YYSYMBOL_insert_table = 1653,            /* insert_table  */
  YYSYMBOL_1654_185 = 1654,                /* $@185  */
  YYSYMBOL_insert_field_spec = 1655,       /* insert_field_spec  */
  YYSYMBOL_1656_186 = 1656,                /* $@186  */
  YYSYMBOL_insert_field_list = 1657,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1658,              /* opt_fields  */
  YYSYMBOL_fields = 1659,                  /* fields  */
  YYSYMBOL_insert_values = 1660,           /* insert_values  */
  YYSYMBOL_values_list = 1661,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1662,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1663,          /* ident_eq_value  */
  YYSYMBOL_equal = 1664,                   /* equal  */
  YYSYMBOL_opt_equal = 1665,               /* opt_equal  */
  YYSYMBOL_opt_with = 1666,                /* opt_with  */
  YYSYMBOL_opt_by = 1667,                  /* opt_by  */
  YYSYMBOL_no_braces = 1668,               /* no_braces  */
  YYSYMBOL_1669_187 = 1669,                /* $@187  */
  YYSYMBOL_no_braces_with_names = 1670,    /* no_braces_with_names  */
  YYSYMBOL_1671_188 = 1671,                /* $@188  */
  YYSYMBOL_opt_values = 1672,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1673,   /* opt_values_with_names  */
  YYSYMBOL_values = 1674,                  /* values  */
  YYSYMBOL_values_with_names = 1675,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1676,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1677, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1678,       /* opt_insert_update  */
  YYSYMBOL_1679_189 = 1679,                /* $@189  */
  YYSYMBOL_1680_190 = 1680,                /* $@190  */
  YYSYMBOL_update_table_list = 1681,       /* update_table_list  */
  YYSYMBOL_update = 1682,                  /* update  */
  YYSYMBOL_1683_191 = 1683,                /* $@191  */
  YYSYMBOL_1684_192 = 1684,                /* $@192  */
  YYSYMBOL_update_list = 1685,             /* update_list  */
  YYSYMBOL_update_elem = 1686,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1687,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1688,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1689,        /* opt_low_priority  */
  YYSYMBOL_delete = 1690,                  /* delete  */
  YYSYMBOL_1691_193 = 1691,                /* $@193  */
  YYSYMBOL_opt_delete_system_time = 1692,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1693,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1694,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1695, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1696,            /* single_multi  */
  YYSYMBOL_1697_194 = 1697,                /* $@194  */
  YYSYMBOL_1698_195 = 1698,                /* $@195  */
  YYSYMBOL_opt_select_expressions = 1699,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1700,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1701,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1702,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1703,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1704,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1705,                /* truncate  */
  YYSYMBOL_1706_196 = 1706,                /* $@196  */
  YYSYMBOL_opt_table_sym = 1707,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1708,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1709,            /* profile_defs  */
  YYSYMBOL_profile_def = 1710,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1711,        /* opt_profile_args  */
  YYSYMBOL_show = 1712,                    /* show  */
  YYSYMBOL_1713_197 = 1713,                /* $@197  */
  YYSYMBOL_show_param = 1714,              /* show_param  */
  YYSYMBOL_1715_198 = 1715,                /* $@198  */
  YYSYMBOL_1716_199 = 1716,                /* $@199  */
  YYSYMBOL_show_engine_param = 1717,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1718,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1719,             /* opt_storage  */
  YYSYMBOL_opt_db = 1720,                  /* opt_db  */
  YYSYMBOL_opt_full = 1721,                /* opt_full  */
  YYSYMBOL_from_or_in = 1722,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1723,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1724,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1725,          /* wild_and_where  */
  YYSYMBOL_describe = 1726,                /* describe  */
  YYSYMBOL_1727_200 = 1727,                /* $@200  */
  YYSYMBOL_1728_201 = 1728,                /* $@201  */
  YYSYMBOL_explainable_command = 1729,     /* explainable_command  */
  YYSYMBOL_describe_command = 1730,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1731,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1732,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1733,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1734,     /* opt_describe_column  */
  YYSYMBOL_flush = 1735,                   /* flush  */
  YYSYMBOL_1736_202 = 1736,                /* $@202  */
  YYSYMBOL_flush_options = 1737,           /* flush_options  */
  YYSYMBOL_1738_203 = 1738,                /* $@203  */
  YYSYMBOL_opt_flush_lock = 1739,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1740,              /* flush_lock  */
  YYSYMBOL_1741_204 = 1741,                /* $@204  */
  YYSYMBOL_flush_options_list = 1742,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1743,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1744,          /* opt_table_list  */
  YYSYMBOL_backup = 1745,                  /* backup  */
  YYSYMBOL_backup_statements = 1746,       /* backup_statements  */
  YYSYMBOL_1747_205 = 1747,                /* $@205  */
  YYSYMBOL_opt_delete_gtid_domain = 1748,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1749,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1750,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1751, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1752,                   /* reset  */
  YYSYMBOL_1753_206 = 1753,                /* $@206  */
  YYSYMBOL_reset_options = 1754,           /* reset_options  */
  YYSYMBOL_reset_option = 1755,            /* reset_option  */
  YYSYMBOL_1756_207 = 1756,                /* $@207  */
  YYSYMBOL_1757_208 = 1757,                /* $@208  */
  YYSYMBOL_slave_reset_options = 1758,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1759,    /* master_reset_options  */
  YYSYMBOL_purge = 1760,                   /* purge  */
  YYSYMBOL_1761_209 = 1761,                /* $@209  */
  YYSYMBOL_kill = 1762,                    /* kill  */
  YYSYMBOL_1763_210 = 1763,                /* $@210  */
  YYSYMBOL_kill_type = 1764,               /* kill_type  */
  YYSYMBOL_kill_option = 1765,             /* kill_option  */
  YYSYMBOL_opt_connection = 1766,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1767,               /* kill_expr  */
  YYSYMBOL_shutdown = 1768,                /* shutdown  */
  YYSYMBOL_1769_211 = 1769,                /* $@211  */
  YYSYMBOL_shutdown_option = 1770,         /* shutdown_option  */
  YYSYMBOL_use = 1771,                     /* use  */
  YYSYMBOL_load = 1772,                    /* load  */
  YYSYMBOL_1773_212 = 1773,                /* $@212  */
  YYSYMBOL_1774_213 = 1774,                /* $@213  */
  YYSYMBOL_1775_214 = 1775,                /* $@214  */
  YYSYMBOL_1776_215 = 1776,                /* $@215  */
  YYSYMBOL_data_or_xml = 1777,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1778,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1779,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1780,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1781,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1782,         /* field_term_list  */
  YYSYMBOL_field_term = 1783,              /* field_term  */
  YYSYMBOL_opt_line_term = 1784,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1785,          /* line_term_list  */
  YYSYMBOL_line_term = 1786,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1787, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1788,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1789,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1790,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1791,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1792,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1793,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1794,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1795,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1796,            /* text_literal  */
  YYSYMBOL_text_string = 1797,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1798,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1799,            /* param_marker  */
  YYSYMBOL_signed_literal = 1800,          /* signed_literal  */
  YYSYMBOL_literal = 1801,                 /* literal  */
  YYSYMBOL_NUM_literal = 1802,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1803,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1804,             /* with_clause  */
  YYSYMBOL_1805_216 = 1805,                /* $@216  */
  YYSYMBOL_opt_recursive = 1806,           /* opt_recursive  */
  YYSYMBOL_with_list = 1807,               /* with_list  */
  YYSYMBOL_with_list_element = 1808,       /* with_list_element  */
  YYSYMBOL_1809_217 = 1809,                /* $@217  */
  YYSYMBOL_opt_with_column_list = 1810,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1811,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1812,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1813,            /* insert_ident  */
  YYSYMBOL_table_wild = 1814,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1815, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1816,             /* order_ident  */
  YYSYMBOL_simple_ident = 1817,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1818,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1819,             /* field_ident  */
  YYSYMBOL_table_ident = 1820,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1821,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1822,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1823,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1824,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1825,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1826,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1827,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1828,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1829,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1830,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1831,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1832,                   /* ident  */
  YYSYMBOL_label_ident = 1833,             /* label_ident  */
  YYSYMBOL_ident_or_text = 1834,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1835,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1836,            /* user_or_role  */
  YYSYMBOL_user = 1837,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1838,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1839,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1840,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1841,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1842,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1843,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_sp_var_not_label = 1844, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1845,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1846,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1847, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1848, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1849,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1850,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1851, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1852,                     /* set  */
  YYSYMBOL_1853_218 = 1853,                /* $@218  */
  YYSYMBOL_1854_219 = 1854,                /* $@219  */
  YYSYMBOL_1855_220 = 1855,                /* $@220  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1856, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1857, /* start_option_value_list  */
  YYSYMBOL_1858_221 = 1858,                /* $@221  */
  YYSYMBOL_1859_222 = 1859,                /* $@222  */
  YYSYMBOL_1860_223 = 1860,                /* $@223  */
  YYSYMBOL_start_option_value_list_following_option_type = 1861, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1862_224 = 1862,                /* $@224  */
  YYSYMBOL_option_value_list_continued = 1863, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1864,       /* option_value_list  */
  YYSYMBOL_1865_225 = 1865,                /* $@225  */
  YYSYMBOL_1866_226 = 1866,                /* $@226  */
  YYSYMBOL_option_value = 1867,            /* option_value  */
  YYSYMBOL_1868_227 = 1868,                /* $@227  */
  YYSYMBOL_option_type = 1869,             /* option_type  */
  YYSYMBOL_opt_var_type = 1870,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1871,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1872, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1873, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1874, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1875, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1876,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1877, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1878,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1879,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1880,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1881,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1882,                    /* lock  */
  YYSYMBOL_1883_228 = 1883,                /* $@228  */
  YYSYMBOL_opt_lock_wait_timeout = 1884,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1885,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1886,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1887,              /* table_lock  */
  YYSYMBOL_lock_option = 1888,             /* lock_option  */
  YYSYMBOL_unlock = 1889,                  /* unlock  */
  YYSYMBOL_1890_229 = 1890,                /* $@229  */
  YYSYMBOL_handler = 1891,                 /* handler  */
  YYSYMBOL_1892_230 = 1892,                /* $@230  */
  YYSYMBOL_handler_tail = 1893,            /* handler_tail  */
  YYSYMBOL_1894_231 = 1894,                /* $@231  */
  YYSYMBOL_handler_read_or_scan = 1895,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1896,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1897,   /* handler_rkey_function  */
  YYSYMBOL_1898_232 = 1898,                /* $@232  */
  YYSYMBOL_handler_rkey_mode = 1899,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1900,                  /* revoke  */
  YYSYMBOL_revoke_command = 1901,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1902,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1903,                   /* grant  */
  YYSYMBOL_grant_command = 1904,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1905,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1906,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1907,               /* role_list  */
  YYSYMBOL_current_role = 1908,            /* current_role  */
  YYSYMBOL_grant_role = 1909,              /* grant_role  */
  YYSYMBOL_opt_table = 1910,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1911,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1912,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1913,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1914,        /* object_privilege  */
  YYSYMBOL_1915_233 = 1915,                /* $@233  */
  YYSYMBOL_1916_234 = 1916,                /* $@234  */
  YYSYMBOL_1917_235 = 1917,                /* $@235  */
  YYSYMBOL_1918_236 = 1918,                /* $@236  */
  YYSYMBOL_opt_and = 1919,                 /* opt_and  */
  YYSYMBOL_require_list = 1920,            /* require_list  */
  YYSYMBOL_require_list_element = 1921,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1922,             /* grant_ident  */
  YYSYMBOL_user_list = 1923,               /* user_list  */
  YYSYMBOL_grant_list = 1924,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 1925,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 1926,             /* via_or_with  */
  YYSYMBOL_using_or_as = 1927,             /* using_or_as  */
  YYSYMBOL_grant_user = 1928,              /* grant_user  */
  YYSYMBOL_auth_expression = 1929,         /* auth_expression  */
  YYSYMBOL_auth_token = 1930,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 1931,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 1932,         /* opt_column_list  */
  YYSYMBOL_column_list = 1933,             /* column_list  */
  YYSYMBOL_column_list_id = 1934,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 1935,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 1936,         /* resource_option  */
  YYSYMBOL_resource_option_list = 1937,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 1938,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 1939,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 1940,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 1941,       /* grant_option_list  */
  YYSYMBOL_grant_option = 1942,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 1943,      /* begin_stmt_mariadb  */
  YYSYMBOL_1944_237 = 1944,                /* $@237  */
  YYSYMBOL_compound_statement = 1945,      /* compound_statement  */
  YYSYMBOL_opt_not = 1946,                 /* opt_not  */
  YYSYMBOL_opt_work = 1947,                /* opt_work  */
  YYSYMBOL_opt_chain = 1948,               /* opt_chain  */
  YYSYMBOL_opt_release = 1949,             /* opt_release  */
  YYSYMBOL_commit = 1950,                  /* commit  */
  YYSYMBOL_rollback = 1951,                /* rollback  */
  YYSYMBOL_savepoint = 1952,               /* savepoint  */
  YYSYMBOL_release = 1953,                 /* release  */
  YYSYMBOL_unit_type_decl = 1954,          /* unit_type_decl  */
  YYSYMBOL_union_option = 1955,            /* union_option  */
  YYSYMBOL_query_expression_option = 1956, /* query_expression_option  */
  YYSYMBOL_definer_opt = 1957,             /* definer_opt  */
  YYSYMBOL_no_definer = 1958,              /* no_definer  */
  YYSYMBOL_definer = 1959,                 /* definer  */
  YYSYMBOL_view_algorithm = 1960,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 1961,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 1962,               /* view_suid  */
  YYSYMBOL_view_list_opt = 1963,           /* view_list_opt  */
  YYSYMBOL_view_list = 1964,               /* view_list  */
  YYSYMBOL_view_select = 1965,             /* view_select  */
  YYSYMBOL_1966_238 = 1966,                /* $@238  */
  YYSYMBOL_view_check_option = 1967,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 1968,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 1969, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 1970,            /* trigger_tail  */
  YYSYMBOL_1971_239 = 1971,                /* $@239  */
  YYSYMBOL_1972_240 = 1972,                /* $@240  */
  YYSYMBOL_1973_241 = 1973,                /* $@241  */
  YYSYMBOL_1974_242 = 1974,                /* $@242  */
  YYSYMBOL_1975_243 = 1975,                /* $@243  */
  YYSYMBOL_sf_return_type = 1976,          /* sf_return_type  */
  YYSYMBOL_1977_244 = 1977,                /* $@244  */
  YYSYMBOL_sf_c_chistics_and_body = 1978,  /* sf_c_chistics_and_body  */
  YYSYMBOL_1979_245 = 1979,                /* $@245  */
  YYSYMBOL_sp_tail = 1980,                 /* sp_tail  */
  YYSYMBOL_1981_246 = 1981,                /* $@246  */
  YYSYMBOL_1982_247 = 1982,                /* $@247  */
  YYSYMBOL_xa = 1983,                      /* xa  */
  YYSYMBOL_opt_format_xid = 1984,          /* opt_format_xid  */
  YYSYMBOL_xid = 1985,                     /* xid  */
  YYSYMBOL_begin_or_start = 1986,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 1987,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 1988,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 1989,             /* opt_suspend  */
  YYSYMBOL_1990_248 = 1990,                /* $@248  */
  YYSYMBOL_opt_migrate = 1991,             /* opt_migrate  */
  YYSYMBOL_install = 1992,                 /* install  */
  YYSYMBOL_uninstall = 1993,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 1994           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 826 "/home/buildbot/git/sql/sql_yacc.yy"

/* avoid unintentional %union size increases, it's what a parser stack made of */
static_assert(sizeof(YYSTYPE) == sizeof(void*)*2+8, "%union size check");
bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2785 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  733
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   100877

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  780
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1215
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3398
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5888

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1012


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   773,     2,     2,     2,   762,   757,     2,
     769,   770,   760,   759,   772,   758,   777,   761,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   779,   776,
     755,   753,   754,     2,   778,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   763,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   774,   756,   775,   764,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   765,   766,
     767,   768,   771
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  2254,  2254,  2264,  2263,  2288,  2295,  2297,  2301,  2302,
    2303,  2308,  2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,
    2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,
    2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,  2335,  2336,
    2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,
    2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,
    2370,  2377,  2378,  2383,  2382,  2393,  2399,  2401,  2398,  2410,
    2412,  2411,  2421,  2426,  2438,  2437,  2454,  2453,  2462,  2463,
    2467,  2471,  2475,  2479,  2483,  2487,  2497,  2502,  2506,  2510,
    2514,  2518,  2522,  2527,  2531,  2536,  2564,  2568,  2572,  2577,
    2580,  2582,  2583,  2587,  2593,  2595,  2596,  2600,  2606,  2608,
    2609,  2613,  2620,  2624,  2639,  2643,  2649,  2655,  2661,  2671,
    2675,  2679,  2693,  2705,  2692,  2729,  2728,  2784,  2791,  2783,
    2803,  2809,  2802,  2821,  2827,  2820,  2839,  2838,  2853,  2851,
    2867,  2865,  2879,  2878,  2889,  2888,  2898,  2897,  2909,  2907,
    2921,  2919,  2931,  2938,  2945,  2952,  2956,  2960,  2960,  2966,
    2967,  2971,  2972,  2976,  2981,  2987,  2993,  3001,  3007,  3013,
    3021,  3029,  3037,  3045,  3053,  3061,  3073,  3089,  3089,  3093,
    3092,  3104,  3105,  3109,  3114,  3119,  3124,  3129,  3134,  3139,
    3147,  3146,  3179,  3178,  3185,  3192,  3193,  3199,  3205,  3215,
    3221,  3227,  3229,  3236,  3237,  3241,  3251,  3252,  3260,  3260,
    3302,  3314,  3315,  3319,  3324,  3332,  3333,  3337,  3338,  3343,
    3345,  3347,  3349,  3351,  3353,  3355,  3361,  3362,  3366,  3367,
    3372,  3371,  3382,  3381,  3392,  3391,  3404,  3406,  3409,  3411,
    3415,  3419,  3428,  3433,  3433,  3443,  3444,  3448,  3456,  3461,
    3468,  3474,  3479,  3484,  3492,  3494,  3498,  3499,  3503,  3507,
    3508,  3509,  3510,  3515,  3514,  3526,  3527,  3531,  3532,  3537,
    3540,  3552,  3557,  3563,  3569,  3578,  3586,  3590,  3595,  3603,
    3607,  3614,  3624,  3632,  3640,  3651,  3652,  3659,  3661,  3660,
    3679,  3678,  3692,  3694,  3699,  3709,  3708,  3727,  3728,  3729,
    3730,  3735,  3737,  3742,  3757,  3765,  3769,  3789,  3790,  3794,
    3798,  3804,  3810,  3816,  3822,  3832,  3837,  3845,  3853,  3868,
    3874,  3875,  3881,  3884,  3888,  3896,  3913,  3915,  3933,  3939,
    3941,  3943,  3945,  3947,  3949,  3951,  3953,  3955,  3957,  3959,
    3961,  3966,  3974,  3990,  3991,  3996,  4002,  4011,  4018,  4027,
    4036,  4041,  4050,  4052,  4054,  4063,  4068,  4075,  4084,  4093,
    4095,  4097,  4099,  4101,  4103,  4105,  4107,  4109,  4111,  4113,
    4115,  4117,  4122,  4123,  4131,  4143,  4158,  4159,  4172,  4173,
    4174,  4175,  4176,  4180,  4181,  4182,  4183,  4184,  4185,  4186,
    4187,  4188,  4189,  4193,  4194,  4195,  4196,  4201,  4200,  4211,
    4211,  4233,  4234,  4239,  4238,  4256,  4267,  4267,  4280,  4285,
    4290,  4296,  4305,  4310,  4315,  4321,  4331,  4339,  4347,  4355,
    4365,  4364,  4386,  4385,  4406,  4412,  4420,  4421,  4425,  4433,
    4438,  4443,  4451,  4452,  4460,  4478,  4494,  4513,  4519,  4536,
    4513,  4555,  4557,  4558,  4563,  4562,  4632,  4638,  4632,  4648,
    4653,  4654,  4658,  4659,  4664,  4670,  4663,  4691,  4697,  4690,
    4716,  4726,  4730,  4734,  4735,  4739,  4750,  4748,  4765,  4764,
    4779,  4778,  4795,  4796,  4801,  4800,  4814,  4819,  4826,  4835,
    4850,  4849,  4869,  4868,  4893,  4902,  4901,  4909,  4908,  4919,
    4924,  4933,  4918,  4943,  4942,  4953,  4952,  4962,  4961,  4974,
    4981,  4973,  4998,  4997,  5009,  5011,  5016,  5018,  5020,  5037,
    5042,  5048,  5055,  5056,  5064,  5070,  5079,  5085,  5091,  5092,
    5096,  5096,  5101,  5102,  5103,  5107,  5108,  5109,  5113,  5117,
    5118,  5119,  5123,  5124,  5125,  5126,  5127,  5128,  5129,  5130,
    5134,  5138,  5139,  5140,  5144,  5145,  5146,  5147,  5148,  5152,
    5156,  5157,  5158,  5162,  5163,  5164,  5165,  5166,  5167,  5168,
    5172,  5176,  5177,  5178,  5182,  5183,  5184,  5189,  5197,  5205,
    5213,  5226,  5239,  5244,  5249,  5257,  5265,  5273,  5281,  5289,
    5297,  5305,  5315,  5325,  5335,  5337,  5341,  5346,  5356,  5357,
    5370,  5369,  5372,  5373,  5387,  5388,  5392,  5393,  5402,  5407,
    5418,  5455,  5456,  5461,  5460,  5476,  5491,  5490,  5512,  5511,
    5517,  5525,  5524,  5527,  5529,  5532,  5531,  5540,  5543,  5542,
    5551,  5552,  5558,  5559,  5576,  5577,  5581,  5582,  5586,  5600,
    5610,  5621,  5630,  5631,  5644,  5646,  5645,  5650,  5648,  5659,
    5660,  5664,  5678,  5690,  5691,  5704,  5713,  5735,  5736,  5741,
    5740,  5764,  5776,  5792,  5791,  5806,  5805,  5819,  5824,  5829,
    5849,  5867,  5871,  5898,  5910,  5911,  5916,  5925,  5915,  5950,
    5951,  5955,  5966,  5985,  5998,  6024,  6025,  6030,  6029,  6066,
    6075,  6076,  6080,  6081,  6085,  6087,  6093,  6099,  6101,  6103,
    6105,  6107,  6109,  6114,  6115,  6115,  6122,  6138,  6141,  6158,
    6159,  6163,  6164,  6168,  6169,  6173,  6174,  6179,  6182,  6190,
    6193,  6200,  6204,  6210,  6212,  6216,  6217,  6221,  6222,  6223,
    6227,  6242,  6247,  6252,  6257,  6262,  6267,  6272,  6287,  6293,
    6308,  6313,  6328,  6334,  6352,  6357,  6362,  6367,  6372,  6377,
    6383,  6382,  6408,  6409,  6410,  6415,  6420,  6425,  6427,  6429,
    6431,  6437,  6442,  6447,  6456,  6465,  6471,  6477,  6482,  6485,
    6487,  6491,  6510,  6518,  6533,  6543,  6554,  6555,  6556,  6557,
    6558,  6559,  6560,  6564,  6565,  6566,  6570,  6571,  6572,  6573,
    6578,  6585,  6592,  6593,  6597,  6598,  6599,  6600,  6601,  6605,
    6607,  6613,  6612,  6620,  6619,  6627,  6626,  6634,  6633,  6643,
    6640,  6651,  6649,  6658,  6657,  6696,  6704,  6712,  6720,  6721,
    6725,  6735,  6736,  6740,  6741,  6745,  6750,  6749,  6787,  6787,
    6790,  6789,  6800,  6801,  6805,  6806,  6810,  6811,  6815,  6816,
    6820,  6821,  6822,  6823,  6825,  6824,  6830,  6835,  6843,  6844,
    6849,  6852,  6856,  6860,  6867,  6868,  6872,  6873,  6877,  6883,
    6889,  6890,  6898,  6897,  6919,  6920,  6930,  6938,  6950,  6950,
    6953,  6954,  6961,  6969,  6973,  6981,  6982,  6983,  6984,  6985,
    6989,  6990,  6991,  7007,  7011,  7015,  7019,  7021,  7028,  7030,
    7035,  7037,  7038,  7039,  7043,  7047,  7052,  7057,  7061,  7065,
    7070,  7075,  7083,  7101,  7102,  7109,  7116,  7124,  7129,  7134,
    7139,  7144,  7155,  7160,  7165,  7170,  7172,  7174,  7176,  7178,
    7180,  7182,  7184,  7192,  7194,  7199,  7200,  7201,  7202,  7203,
    7204,  7205,  7206,  7210,  7214,  7215,  7219,  7220,  7224,  7225,
    7226,  7227,  7228,  7232,  7233,  7234,  7235,  7236,  7240,  7246,
    7247,  7252,  7254,  7261,  7262,  7263,  7267,  7271,  7272,  7273,
    7274,  7275,  7276,  7280,  7281,  7282,  7283,  7287,  7288,  7292,
    7293,  7297,  7298,  7303,  7304,  7308,  7309,  7310,  7317,  7318,
    7324,  7331,  7335,  7336,  7340,  7341,  7345,  7353,  7361,  7370,
    7374,  7380,  7384,  7385,  7394,  7403,  7409,  7415,  7428,  7434,
    7444,  7445,  7449,  7454,  7458,  7459,  7463,  7464,  7468,  7475,
    7479,  7480,  7484,  7492,  7493,  7497,  7498,  7502,  7503,  7507,
    7508,  7509,  7516,  7520,  7521,  7525,  7526,  7527,  7528,  7529,
    7541,  7545,  7546,  7551,  7550,  7563,  7564,  7568,  7571,  7572,
    7573,  7574,  7578,  7586,  7593,  7594,  7598,  7608,  7609,  7613,
    7614,  7617,  7619,  7623,  7635,  7636,  7640,  7647,  7660,  7661,
    7663,  7665,  7671,  7676,  7682,  7688,  7695,  7705,  7706,  7707,
    7708,  7709,  7713,  7714,  7718,  7719,  7723,  7724,  7728,  7729,
    7730,  7734,  7735,  7739,  7743,  7755,  7756,  7760,  7761,  7765,
    7766,  7770,  7771,  7775,  7776,  7780,  7781,  7785,  7786,  7791,
    7792,  7793,  7797,  7799,  7804,  7809,  7811,  7819,  7827,  7833,
    7842,  7843,  7847,  7851,  7852,  7862,  7863,  7864,  7868,  7872,
    7879,  7885,  7897,  7898,  7902,  7904,  7914,  7930,  7913,  7952,
    7951,  7968,  7977,  7976,  7997,  7996,  8017,  8016,  8035,  8029,
    8048,  8047,  8086,  8091,  8096,  8101,  8107,  8106,  8113,  8120,
    8132,  8119,  8154,  8158,  8166,  8169,  8173,  8177,  8185,  8187,
    8188,  8189,  8190,  8194,  8195,  8196,  8197,  8201,  8202,  8214,
    8215,  8219,  8220,  8223,  8225,  8233,  8241,  8243,  8245,  8246,
    8254,  8255,  8261,  8270,  8268,  8281,  8294,  8293,  8306,  8304,
    8317,  8324,  8334,  8335,  8344,  8351,  8355,  8361,  8359,  8376,
    8378,  8383,  8391,  8390,  8404,  8408,  8407,  8419,  8420,  8424,
    8437,  8438,  8442,  8446,  8453,  8458,  8462,  8469,  8476,  8480,
    8485,  8493,  8501,  8511,  8522,  8532,  8543,  8553,  8559,  8565,
    8572,  8578,  8592,  8606,  8611,  8615,  8620,  8621,  8622,  8627,
    8632,  8636,  8646,  8648,  8649,  8650,  8651,  8655,  8660,  8668,
    8673,  8681,  8682,  8686,  8687,  8691,  8691,  8694,  8696,  8700,
    8701,  8705,  8706,  8714,  8715,  8716,  8720,  8721,  8726,  8735,
    8736,  8737,  8738,  8743,  8742,  8752,  8751,  8759,  8766,  8776,
    8793,  8796,  8803,  8807,  8814,  8818,  8822,  8829,  8829,  8835,
    8836,  8840,  8841,  8842,  8846,  8847,  8856,  8863,  8864,  8869,
    8868,  8880,  8881,  8882,  8886,  8888,  8887,  8894,  8893,  8914,
    8915,  8919,  8920,  8924,  8925,  8926,  8930,  8931,  8936,  8935,
    8956,  8957,  8961,  8966,  8967,  8974,  8976,  8981,  8983,  8982,
    8995,  8997,  8996,  9010,  9011,  9016,  9025,  9026,  9027,  9031,
    9038,  9048,  9056,  9065,  9067,  9066,  9072,  9071,  9094,  9095,
    9099,  9100,  9104,  9105,  9106,  9107,  9108,  9109,  9113,  9114,
    9119,  9118,  9139,  9140,  9141,  9146,  9145,  9155,  9162,  9168,
    9177,  9178,  9182,  9198,  9197,  9210,  9211,  9215,  9216,  9220,
    9231,  9242,  9243,  9248,  9247,  9262,  9263,  9267,  9268,  9272,
    9283,  9295,  9294,  9302,  9302,  9311,  9312,  9317,  9318,  9328,
    9327,  9342,  9341,  9360,  9359,  9376,  9374,  9395,  9396,  9401,
    9400,  9414,  9424,  9413,  9434,  9446,  9510,  9515,  9530,  9531,
    9546,  9545,  9561,  9560,  9573,  9575,  9590,  9598,  9596,  9612,
    9630,  9632,  9642,  9646,  9687,  9696,  9706,  9707,  9711,  9715,
    9721,  9728,  9730,  9739,  9743,  9747,  9754,  9763,  9767,  9774,
    9791,  9794,  9802,  9805,  9812,  9816,  9820,  9824,  9831,  9832,
    9836,  9837,  9846,  9859,  9865,  9876,  9879,  9888,  9891,  9896,
    9904,  9905,  9906,  9920,  9925,  9947,  9953,  9959,  9965,  9966,
    9967,  9968,  9969,  9973,  9974,  9975,  9979,  9980,  9981,  9985,
    9986,  9991, 10042, 10049, 10092, 10098, 10102, 10108, 10114, 10120,
   10126, 10132, 10138, 10144, 10150, 10156, 10162, 10168, 10172, 10178,
   10187, 10193, 10201, 10207, 10216, 10222, 10230, 10240, 10246, 10253,
   10260, 10268, 10274, 10283, 10287, 10293, 10299, 10305, 10311, 10318,
   10324, 10330, 10336, 10342, 10349, 10355, 10361, 10367, 10373, 10379,
   10385, 10391, 10397, 10401, 10402, 10406, 10407, 10411, 10412, 10416,
   10417, 10421, 10422, 10423, 10424, 10425, 10426, 10430, 10431, 10436,
   10440, 10444, 10445, 10446, 10450, 10451, 10452, 10453, 10454, 10455,
   10459, 10460, 10461, 10466, 10465, 10471, 10479, 10502, 10509, 10518,
   10519, 10520, 10521, 10525, 10534, 10535, 10536, 10537, 10538, 10539,
   10540, 10541, 10573, 10574, 10575, 10576, 10577, 10578, 10579, 10580,
   10581, 10589, 10597, 10598, 10605, 10611, 10616, 10626, 10631, 10636,
   10642, 10647, 10653, 10664, 10671, 10676, 10681, 10686, 10691, 10696,
   10701, 10709, 10710, 10711, 10712, 10720, 10721, 10729, 10730, 10736,
   10740, 10746, 10752, 10761, 10762, 10771, 10778, 10792, 10798, 10804,
   10813, 10822, 10828, 10834, 10840, 10846, 10861, 10872, 10878, 10884,
   10890, 10896, 10902, 10910, 10917, 10921, 10927, 10935, 10944, 10948,
   10952, 10956, 10976, 10983, 10989, 10996, 11003, 11009, 11015, 11021,
   11027, 11033, 11039, 11046, 11052, 11059, 11065, 11071, 11089, 11095,
   11101, 11106, 11113, 11120, 11128, 11135, 11142, 11149, 11156, 11173,
   11179, 11185, 11191, 11197, 11204, 11210, 11216, 11225, 11236, 11243,
   11249, 11255, 11262, 11270, 11276, 11282, 11288, 11294, 11302, 11308,
   11314, 11320, 11326, 11334, 11346, 11353, 11368, 11374, 11381, 11388,
   11395, 11402, 11409, 11413, 11420, 11438, 11437, 11505, 11510, 11518,
   11520, 11525, 11526, 11530, 11531, 11535, 11536, 11540, 11547, 11555,
   11582, 11588, 11594, 11600, 11606, 11612, 11621, 11628, 11630, 11627,
   11637, 11648, 11654, 11660, 11666, 11672, 11678, 11684, 11690, 11696,
   11703, 11702, 11727, 11736, 11754, 11756, 11758, 11773, 11780, 11787,
   11794, 11801, 11808, 11815, 11822, 11829, 11836, 11847, 11854, 11865,
   11876, 11896, 11895, 11901, 11918, 11924, 11933, 11942, 11952, 11951,
   11963, 11973, 11981, 11986, 11994, 11995, 12000, 12005, 12008, 12010,
   12014, 12019, 12027, 12028, 12032, 12036, 12043, 12050, 12057, 12070,
   12069, 12086, 12089, 12088, 12093, 12092, 12097, 12096, 12100, 12105,
   12106, 12110, 12111, 12112, 12113, 12114, 12115, 12116, 12117, 12121,
   12122, 12123, 12124, 12131, 12132, 12136, 12141, 12149, 12150, 12154,
   12161, 12169, 12178, 12188, 12189, 12200, 12201, 12213, 12224, 12225,
   12231, 12236, 12250, 12258, 12256, 12276, 12274, 12287, 12299, 12297,
   12317, 12316, 12328, 12341, 12339, 12360, 12359, 12372, 12386, 12387,
   12388, 12392, 12393, 12401, 12402, 12406, 12415, 12416, 12417, 12422,
   12426, 12427, 12431, 12432, 12436, 12437, 12445, 12453, 12461, 12462,
   12475, 12493, 12502, 12503, 12508, 12511, 12512, 12513, 12517, 12518,
   12523, 12522, 12528, 12527, 12535, 12536, 12539, 12541, 12541, 12545,
   12545, 12550, 12551, 12555, 12557, 12562, 12563, 12567, 12578, 12592,
   12593, 12594, 12595, 12596, 12597, 12598, 12599, 12600, 12601, 12602,
   12603, 12607, 12608, 12609, 12610, 12611, 12612, 12613, 12614, 12615,
   12619, 12620, 12621, 12622, 12625, 12627, 12628, 12632, 12633, 12637,
   12645, 12647, 12651, 12653, 12652, 12666, 12669, 12668, 12686, 12688,
   12692, 12697, 12705, 12706, 12723, 12746, 12747, 12753, 12754, 12758,
   12771, 12770, 12779, 12780, 12789, 12790, 12794, 12795, 12799, 12800,
   12814, 12815, 12819, 12829, 12838, 12845, 12852, 12862, 12863, 12870,
   12880, 12881, 12883, 12885, 12887, 12889, 12898, 12902, 12903, 12907,
   12921, 12922, 12928, 12927, 12938, 12944, 12953, 12954, 12955, 12960,
   12961, 12966, 12973, 12979, 12989, 12998, 13004, 13010, 13019, 13024,
   13029, 13033, 13039, 13045, 13054, 13063, 13067, 13074, 13075, 13079,
   13084, 13089, 13102, 13106, 13110, 13114, 13119, 13122, 13126, 13139,
   13147, 13160, 13162, 13166, 13167, 13171, 13172, 13173, 13174, 13175,
   13176, 13180, 13181, 13182, 13183, 13184, 13188, 13189, 13190, 13191,
   13195, 13196, 13197, 13198, 13199, 13203, 13204, 13205, 13206, 13207,
   13211, 13216, 13217, 13221, 13222, 13226, 13227, 13228, 13233, 13232,
   13264, 13265, 13269, 13270, 13274, 13284, 13284, 13296, 13297, 13300,
   13320, 13324, 13329, 13337, 13343, 13354, 13342, 13356, 13371, 13383,
   13382, 13405, 13404, 13414, 13413, 13436, 13442, 13456, 13471, 13479,
   13483, 13488, 13487, 13496, 13501, 13507, 13512, 13517, 13524, 13522,
   13536, 13537, 13541, 13553, 13566, 13567, 13571, 13585, 13589, 13598,
   13601, 13608, 13609, 13617, 13629, 13616, 13644, 13655, 13643, 13670,
   13678, 13679, 13686, 13690, 13691, 13700, 13701, 13705, 13705, 13718,
   13719, 13721, 13720, 13733, 13739, 13741, 13745, 13747, 13753, 13757,
   13758, 13762, 13763, 13767, 13777, 13778, 13782, 13783, 13787, 13788,
   13792, 13793, 13798, 13797, 13813, 13812, 13827, 13828, 13832, 13833,
   13837, 13842, 13850, 13858, 13869, 13870, 13879, 13880, 13888, 13890,
   13892, 13890, 13902, 13916, 13923, 13933, 13922, 13962, 13963, 13967,
   13974, 13982, 13983, 13987, 13997, 13998, 14005, 14004, 14025, 14028,
   14035, 14036, 14046, 14061, 14069, 14082, 14081, 14096, 14095, 14111,
   14113, 14117, 14118, 14122, 14137, 14155, 14156, 14160, 14161, 14165,
   14166, 14167, 14172, 14171, 14192, 14194, 14197, 14199, 14202, 14203,
   14206, 14210, 14214, 14218, 14222, 14226, 14230, 14234, 14238, 14246,
   14249, 14259, 14258, 14277, 14284, 14292, 14300, 14308, 14316, 14324,
   14331, 14338, 14344, 14346, 14348, 14357, 14361, 14366, 14365, 14372,
   14371, 14377, 14386, 14393, 14398, 14403, 14408, 14413, 14418, 14420,
   14422, 14424, 14431, 14439, 14441, 14449, 14456, 14463, 14471, 14477,
   14482, 14490, 14498, 14506, 14510, 14515, 14522, 14527, 14534, 14541,
   14547, 14553, 14559, 14567, 14572, 14579, 14586, 14593, 14600, 14605,
   14610, 14615, 14620, 14627, 14649, 14651, 14653, 14658, 14659, 14662,
   14664, 14668, 14669, 14673, 14674, 14678, 14679, 14683, 14684, 14688,
   14689, 14693, 14694, 14702, 14714, 14713, 14732, 14731, 14741, 14742,
   14743, 14744, 14745, 14746, 14750, 14751, 14755, 14762, 14763, 14765,
   14766, 14770, 14771, 14784, 14785, 14786, 14801, 14800, 14812, 14811,
   14823, 14828, 14829, 14844, 14847, 14846, 14859, 14860, 14865, 14867,
   14869, 14871, 14873, 14875, 14883, 14885, 14887, 14889, 14894, 14896,
   14904, 14906, 14908, 14910, 14912, 14929, 14930, 14934, 14938, 14951,
   14950, 14965, 14975, 14976, 14979, 14981, 14982, 14986, 15002, 15003,
   15008, 15007, 15017, 15018, 15022, 15022, 15026, 15025, 15031, 15035,
   15036, 15040, 15041, 15048, 15053, 15052, 15067, 15066, 15081, 15082,
   15083, 15087, 15088, 15089, 15098, 15099, 15103, 15107, 15115, 15115,
   15120, 15121, 15130, 15142, 15156, 15167, 15180, 15141, 15193, 15194,
   15198, 15199, 15203, 15204, 15212, 15216, 15217, 15218, 15221, 15223,
   15227, 15228, 15232, 15237, 15244, 15249, 15256, 15258, 15262, 15263,
   15267, 15272, 15280, 15281, 15285, 15287, 15295, 15296, 15300, 15301,
   15302, 15306, 15308, 15313, 15314, 15323, 15324, 15328, 15329, 15333,
   15346, 15351, 15356, 15361, 15369, 15377, 15382, 15390, 15398, 15413,
   15420, 15426, 15436, 15437, 15445, 15446, 15447, 15448, 15462, 15468,
   15474, 15480, 15486, 15492, 15511, 15521, 15531, 15537, 15544, 15554,
   15561, 15568, 15579, 15578, 15603, 15604, 15609, 15610, 15617, 15615,
   15642, 15643, 15649, 15654, 15663, 15681, 15682, 15686, 15691, 15699,
   15704, 15712, 15717, 15722, 15727, 15733, 15738, 15746, 15751, 15756,
   15761, 15767, 15775, 15776, 15787, 15795, 15799, 15805, 15811, 15821,
   15827, 15836, 15846, 15847, 15851, 15852, 15853, 15857, 15865, 15873,
   15881, 15889, 15890, 15898, 15899, 15907, 15908, 15913, 15922, 15923,
   15931, 15932, 15940, 15941, 15942, 15946, 15957, 15986, 15995, 15995,
   15997, 16007, 16008, 16009, 16010, 16011, 16012, 16013, 16014, 16019,
   16020, 16021, 16022, 16023, 16024, 16025, 16026, 16027, 16035, 16036,
   16037, 16038, 16042, 16043, 16044, 16045, 16046, 16047, 16048, 16049,
   16053, 16054, 16055, 16056, 16057, 16058, 16059, 16060, 16061, 16065,
   16066, 16067, 16068, 16069, 16070, 16071, 16072, 16085, 16086, 16087,
   16088, 16089, 16090, 16091, 16092, 16093, 16094, 16095, 16096, 16097,
   16098, 16099, 16100, 16101, 16102, 16103, 16104, 16105, 16106, 16107,
   16108, 16109, 16110, 16111, 16112, 16113, 16114, 16115, 16116, 16117,
   16118, 16119, 16120, 16121, 16122, 16123, 16124, 16125, 16126, 16127,
   16128, 16129, 16130, 16131, 16132, 16133, 16134, 16135, 16136, 16137,
   16138, 16139, 16180, 16181, 16182, 16183, 16184, 16185, 16196, 16197,
   16198, 16199, 16200, 16201, 16202, 16203, 16204, 16205, 16209, 16210,
   16211, 16218, 16219, 16220, 16224, 16225, 16226, 16235, 16236, 16237,
   16238, 16239, 16240, 16241, 16242, 16243, 16244, 16245, 16246, 16247,
   16248, 16249, 16250, 16251, 16252, 16253, 16254, 16255, 16256, 16257,
   16258, 16259, 16260, 16261, 16262, 16263, 16264, 16265, 16266, 16267,
   16268, 16276, 16277, 16278, 16279, 16280, 16281, 16282, 16283, 16284,
   16285, 16286, 16287, 16288, 16289, 16290, 16291, 16292, 16293, 16294,
   16295, 16296, 16297, 16298, 16299, 16300, 16301, 16302, 16303, 16304,
   16305, 16306, 16307, 16308, 16309, 16310, 16311, 16312, 16313, 16314,
   16315, 16316, 16317, 16318, 16319, 16320, 16321, 16322, 16327, 16328,
   16329, 16330, 16331, 16332, 16333, 16334, 16335, 16336, 16337, 16338,
   16339, 16340, 16341, 16342, 16343, 16344, 16345, 16346, 16347, 16348,
   16349, 16350, 16351, 16352, 16353, 16354, 16355, 16356, 16357, 16358,
   16359, 16360, 16361, 16362, 16363, 16364, 16365, 16366, 16367, 16368,
   16369, 16370, 16371, 16372, 16373, 16374, 16375, 16376, 16377, 16378,
   16379, 16380, 16381, 16382, 16383, 16384, 16385, 16386, 16387, 16388,
   16389, 16390, 16391, 16392, 16393, 16394, 16395, 16396, 16397, 16398,
   16399, 16400, 16401, 16402, 16403, 16404, 16405, 16406, 16407, 16408,
   16409, 16410, 16411, 16412, 16413, 16414, 16415, 16416, 16417, 16418,
   16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426, 16427, 16428,
   16429, 16430, 16431, 16432, 16433, 16434, 16435, 16436, 16437, 16438,
   16439, 16440, 16441, 16442, 16443, 16444, 16445, 16446, 16447, 16448,
   16449, 16450, 16451, 16452, 16453, 16454, 16455, 16456, 16457, 16458,
   16459, 16460, 16461, 16462, 16463, 16464, 16465, 16466, 16467, 16468,
   16469, 16470, 16471, 16472, 16473, 16474, 16475, 16476, 16477, 16478,
   16479, 16480, 16481, 16482, 16483, 16484, 16485, 16486, 16487, 16488,
   16489, 16490, 16491, 16492, 16493, 16494, 16495, 16496, 16497, 16498,
   16499, 16500, 16501, 16502, 16503, 16504, 16505, 16506, 16507, 16508,
   16509, 16510, 16511, 16512, 16513, 16514, 16515, 16516, 16517, 16518,
   16519, 16520, 16521, 16522, 16523, 16524, 16525, 16526, 16527, 16528,
   16529, 16530, 16531, 16532, 16533, 16534, 16535, 16536, 16537, 16538,
   16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546, 16547, 16548,
   16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556, 16557, 16558,
   16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566, 16567, 16568,
   16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576, 16577, 16578,
   16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586, 16587, 16588,
   16589, 16590, 16591, 16592, 16593, 16594, 16606, 16605, 16622, 16628,
   16621, 16648, 16649, 16655, 16654, 16661, 16660, 16670, 16669, 16680,
   16679, 16685, 16693, 16695, 16700, 16700, 16710, 16709, 16724, 16723,
   16728, 16732, 16733, 16734, 16738, 16739, 16740, 16741, 16745, 16746,
   16747, 16748, 16753, 16758, 16763, 16772, 16777, 16782, 16787, 16792,
   16797, 16802, 16807, 16821, 16832, 16851, 16869, 16881, 16889, 16894,
   16910, 16911, 16912, 16913, 16917, 16936, 16954, 16955, 16959, 16960,
   16961, 16962, 16966, 16980, 16984, 16989, 16994, 17005, 17006, 17007,
   17013, 17019, 17031, 17030, 17044, 17045, 17051, 17060, 17061, 17065,
   17066, 17070, 17089, 17090, 17091, 17096, 17097, 17102, 17101, 17119,
   17118, 17130, 17139, 17149, 17148, 17189, 17190, 17194, 17195, 17199,
   17200, 17201, 17202, 17204, 17203, 17216, 17217, 17218, 17219, 17220,
   17226, 17231, 17237, 17243, 17249, 17256, 17263, 17267, 17274, 17283,
   17285, 17290, 17295, 17302, 17309, 17316, 17323, 17330, 17337, 17349,
   17350, 17354, 17355, 17359, 17364, 17372, 17382, 17401, 17404, 17406,
   17410, 17411, 17418, 17420, 17424, 17425, 17430, 17429, 17433, 17432,
   17436, 17435, 17439, 17438, 17441, 17442, 17443, 17444, 17445, 17446,
   17447, 17448, 17449, 17450, 17451, 17452, 17453, 17454, 17455, 17456,
   17457, 17458, 17459, 17460, 17461, 17462, 17463, 17464, 17465, 17466,
   17467, 17471, 17472, 17476, 17477, 17481, 17488, 17495, 17505, 17515,
   17524, 17533, 17546, 17551, 17559, 17564, 17572, 17577, 17584, 17584,
   17585, 17585, 17588, 17594, 17600, 17605, 17612, 17618, 17625, 17634,
   17638, 17644, 17654, 17658, 17662, 17663, 17667, 17695, 17697, 17701,
   17705, 17709, 17716, 17721, 17726, 17731, 17736, 17744, 17745, 17749,
   17750, 17755, 17756, 17760, 17761, 17765, 17766, 17770, 17771, 17776,
   17775, 17785, 17794, 17795, 17799, 17800, 17805, 17806, 17807, 17812,
   17813, 17814, 17818, 17830, 17839, 17845, 17854, 17863, 17876, 17878,
   17880, 17888, 17889, 17890, 17894, 17895, 17901, 17902, 17903, 17904,
   17905, 17906, 17916, 17917, 17922, 17935, 17949, 17950, 17951, 17955,
   17956, 17960, 17961, 17966, 17967, 17971, 17977, 17986, 17986, 18000,
   18001, 18002, 18003, 18013, 18015, 18021, 18027, 18037, 18046, 18052,
   18057, 18061, 18035, 18111, 18110, 18127, 18126, 18142, 18150, 18141,
   18164, 18168, 18172, 18176, 18180, 18184, 18192, 18193, 18209, 18216,
   18223, 18233, 18234, 18235, 18239, 18240, 18241, 18245, 18246, 18251,
   18253, 18252, 18258, 18259, 18263, 18268, 18275, 18280, 18289
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM",
  "DES_KEY_FILE", "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM",
  "DISCARD", "DISK_SYM", "DO_SYM", "DUMPFILE", "DUPLICATE_SYM",
  "DYNAMIC_SYM", "ENABLE_SYM", "END", "ENDS_SYM", "ENGINES_SYM",
  "ENGINE_SYM", "ENUM", "ERROR_SYM", "ERRORS", "ESCAPE_SYM", "EVENTS_SYM",
  "EVENT_SYM", "EVERY_SYM", "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM",
  "EXECUTE_SYM", "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM",
  "EXIT_ORACLE_SYM", "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM",
  "EXTENDED_SYM", "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM",
  "FIRST_SYM", "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM",
  "FORCE_SYM", "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM",
  "GENERAL", "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM",
  "GET_FORMAT", "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM",
  "HARD_SYM", "HASH_SYM", "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM",
  "HOST_SYM", "HOSTS_SYM", "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM",
  "IGNORE_SERVER_IDS_SYM", "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM",
  "INDEXES", "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM",
  "INVOKER_SYM", "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM",
  "ISSUER_SYM", "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE",
  "LANGUAGE_SYM", "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES",
  "LESS_SYM", "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM",
  "LOCKS_SYM", "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "':'", "$accept",
  "query", "$@1", "opt_end_of_input", "verb_clause", "statement",
  "deallocate", "deallocate_or_drop", "prepare", "$@2", "execute", "$@3",
  "$@4", "execute_using", "$@5", "execute_params", "help", "$@6", "change",
  "$@7", "master_defs", "master_def", "ignore_server_id_list",
  "ignore_server_id", "do_domain_id_list", "do_domain_id",
  "ignore_domain_id_list", "ignore_domain_id", "master_file_def",
  "optional_connection_name", "connection_name", "create", "$@8", "$@9",
  "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17", "$@18",
  "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "$@25", "opt_sequence",
  "sequence_defs", "sequence_def", "force_lookahead", "server_def", "$@26",
  "server_options_list", "server_option", "event_tail", "$@27",
  "ev_schedule_time", "$@28", "opt_ev_status", "ev_starts", "ev_ends",
  "opt_ev_on_completion", "ev_on_completion", "opt_ev_comment",
  "ev_sql_stmt", "$@29", "clear_privileges", "opt_aggregate", "sp_name",
  "sp_a_chistics", "sp_c_chistics", "sp_chistic", "sp_c_chistic",
  "sp_suid", "call", "$@30", "$@31", "$@32", "opt_sp_cparam_list",
  "opt_sp_cparams", "sp_cparams", "sp_fdparam_list", "$@33", "sp_fdparams",
  "sp_param_name", "sp_param_name_and_type", "sp_pdparam_list",
  "sp_pdparams", "sp_pdparam", "sp_opt_inout",
  "sp_parenthesized_pdparam_list", "$@34", "sp_proc_stmts",
  "sp_proc_stmts1", "sp_decls", "sp_decl",
  "optionally_qualified_column_ident", "row_field_name",
  "row_field_definition", "row_field_definition_list", "row_type_body",
  "sp_decl_idents_init_vars", "sp_decl_variable_list", "sp_decl_body",
  "$@35", "sp_decl_handler", "$@36",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@37", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt_in_returns_clause", "sp_proc_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@38",
  "sp_proc_stmt_statement", "$@39", "RETURN_ALLMODES_SYM",
  "sp_proc_stmt_return", "$@40", "reset_lex_expr", "$@41",
  "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "assignment_source_lex", "assignment_source_expr", "$@42",
  "for_loop_bound_expr", "$@43", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@44", "$@45", "$@46", "sp_elseifs",
  "case_stmt_specification", "$@47", "case_stmt_body", "$@48", "$@49",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@50", "$@51", "searched_when_clause", "$@52",
  "$@53", "else_clause_opt", "sp_label", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@54", "sp_unlabeled_block", "$@55",
  "sp_unlabeled_block_not_atomic", "$@56", "opt_sp_for_loop_direction",
  "sp_for_loop_index_and_bounds", "$@57", "sp_for_loop_bounds",
  "loop_body", "while_body", "$@58", "repeat_body", "$@59",
  "pop_sp_loop_label", "sp_labeled_control", "$@60", "$@61", "$@62",
  "$@63", "$@64", "$@65", "sp_unlabeled_control", "$@66", "$@67", "$@68",
  "$@69", "$@70", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@71", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@72", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@73", "have_partitioning",
  "partition_entry", "$@74", "partition", "$@75", "part_type_def", "$@76",
  "$@77", "$@78", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@79",
  "$@80", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@81", "part_name", "opt_part_values", "$@82", "$@83", "part_func_max",
  "part_values_in", "part_value_list", "part_value_item", "$@84", "$@85",
  "part_value_item_list", "part_value_expr_item", "opt_sub_partition",
  "sub_part_list", "sub_part_definition", "$@86", "sub_name",
  "opt_part_options", "opt_part_option_list", "opt_part_option",
  "opt_versioning_rotation", "$@87", "opt_versioning_interval_start",
  "opt_as", "opt_create_database_options", "create_database_options",
  "create_database_option", "opt_if_not_exists_table_element",
  "opt_if_not_exists", "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@88", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@89", "$@90", "$@91", "$@92", "$@93", "$@94",
  "$@95", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@96", "field_type_or_serial", "$@97",
  "$@98", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@99",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@100",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "field_type_numeric", "opt_binary_and_compression",
  "field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1", "opt_precision", "attribute_list",
  "attribute", "opt_compression_method", "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "charset", "charset_name",
  "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@101", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@102", "$@103", "$@104", "$@105", "$@106", "$@107", "$@108",
  "$@109", "$@110", "$@111", "$@112", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@113", "$@114", "$@115",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@116", "add_part_extra", "reorg_partition_rule", "$@117",
  "reorg_parts_rule", "$@118", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@119", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@120", "$@121",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@122", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@123", "opt_checksum_type", "repair_table_or_view", "$@124", "repair",
  "$@125", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@126", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@127",
  "persistent_index_stat_spec", "$@128", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@129", "check", "$@130", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@131", "opt_no_write_to_binlog", "rename", "$@132", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@133",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@134",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@135", "cache_keys_spec",
  "$@136", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@137", "$@138", "select_into", "$@139", "$@140", "simple_table",
  "table_value_constructor", "$@141", "query_specification_start", "$@142",
  "$@143", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@144", "$@145",
  "query_expression_body_ext_parens", "query_expression_body", "$@146",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end", "select_alias",
  "opt_default_time_precision", "opt_time_precision", "optional_braces",
  "expr", "boolean_test", "predicate", "bit_expr", "or", "and", "not",
  "not2", "comp_op", "all_or_any", "opt_dyncol_type", "dyncol_type",
  "numeric_dyncol_type", "temporal_dyncol_type", "string_dyncol_type",
  "$@147", "dyncall_create_element", "dyncall_create_list",
  "plsql_cursor_attr", "explicit_cursor_attr", "trim_operands",
  "column_default_non_parenthesized_expr", "primary_expr",
  "string_factor_expr", "simple_expr", "mysql_concatenation_expr",
  "function_call_keyword_timestamp", "function_call_keyword",
  "substring_operands", "function_call_nonkeyword",
  "function_call_conflict", "geometry_function", "function_call_generic",
  "@148", "fulltext_options", "opt_natural_language_mode",
  "opt_query_expansion", "opt_udf_expr_list", "udf_expr_list", "udf_expr",
  "sum_expr", "$@149", "$@150", "$@151", "window_func_expr", "window_func",
  "simple_window_func", "inverse_distribution_function",
  "percentile_function", "$@152", "inverse_distribution_function_def",
  "order_by_single_element_list", "window_name", "variable", "$@153",
  "variable_aux", "opt_distinct", "opt_gconcat_separator",
  "opt_gorder_clause", "gorder_list", "opt_glimit_clause",
  "glimit_clause_init", "glimit_clause", "glimit_options", "in_sum_expr",
  "$@154", "cast_type", "$@155", "$@156", "$@157", "cast_type_numeric",
  "cast_type_temporal", "opt_expr_list", "expr_list", "ident_list_arg",
  "ident_list", "when_list", "when_list_opt_else", "table_ref",
  "join_table_list", "esc_table_ref", "derived_table_list", "join_table",
  "$@158", "$@159", "$@160", "$@161", "$@162", "$@163", "inner_join",
  "normal_join", "opt_use_partition", "use_partition", "table_factor",
  "table_primary_ident_opt_parens", "table_primary_derived_opt_parens",
  "table_reference_list_parens", "nested_table_reference_list",
  "join_table_parens", "table_primary_ident", "table_primary_derived",
  "opt_outer", "index_hint_clause", "index_hint_type",
  "index_hint_definition", "$@164", "$@165", "index_hints_list",
  "opt_index_hints_list", "$@166", "opt_key_definition", "$@167",
  "opt_key_usage_list", "key_usage_element", "key_usage_list",
  "using_list", "interval", "interval_time_stamp", "date_time_type",
  "table_alias", "opt_table_alias_clause", "table_alias_clause", "opt_all",
  "opt_where_clause", "$@168", "opt_having_clause", "$@169",
  "opt_group_clause", "group_list", "olap_opt", "opt_window_clause",
  "window_def_list", "window_def", "window_spec", "$@170",
  "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@171", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@172", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@173",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@174", "$@175", "do", "$@176", "drop", "$@177",
  "$@178", "$@179", "$@180", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@181", "$@182", "replace", "$@183", "$@184",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@185", "insert_field_spec", "$@186", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@187", "no_braces_with_names", "$@188", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@189", "$@190",
  "update_table_list", "update", "$@191", "$@192", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@193", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@194", "$@195", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@196", "opt_table_sym",
  "opt_profile_defs", "profile_defs", "profile_def", "opt_profile_args",
  "show", "$@197", "show_param", "$@198", "$@199", "show_engine_param",
  "master_or_binary", "opt_storage", "opt_db", "opt_full", "from_or_in",
  "binlog_in", "binlog_from", "wild_and_where", "describe", "$@200",
  "$@201", "explainable_command", "describe_command",
  "analyze_stmt_command", "opt_extended_describe", "opt_format_json",
  "opt_describe_column", "flush", "$@202", "flush_options", "$@203",
  "opt_flush_lock", "flush_lock", "$@204", "flush_options_list",
  "flush_option", "opt_table_list", "backup", "backup_statements", "$@205",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@206", "reset_options",
  "reset_option", "$@207", "$@208", "slave_reset_options",
  "master_reset_options", "purge", "$@209", "kill", "$@210", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@211",
  "shutdown_option", "use", "load", "$@212", "$@213", "$@214", "$@215",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@216",
  "opt_recursive", "with_list", "with_list_element", "$@217",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "label_ident", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@218", "$@219", "$@220",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@221", "$@222", "$@223",
  "start_option_value_list_following_option_type", "$@224",
  "option_value_list_continued", "option_value_list", "$@225", "$@226",
  "option_value", "$@227", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@228",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@229", "handler", "$@230",
  "handler_tail", "$@231", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@232", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@233", "$@234", "$@235",
  "$@236", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@237", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@238", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@239", "$@240", "$@241", "$@242", "$@243",
  "sf_return_type", "$@244", "sf_c_chistics_and_body", "$@245", "sp_tail",
  "$@246", "$@247", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@248",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5252)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3340)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
    7643,  3136,  1787, 93440, -5252,    90, -5252,   631, -5252, -5252,
   -5252,  3676, -5252, -5252, -5252, -5252, -5252, -5252,   186,    75,
   -5252,  1058, -5252, -5252,   634, 88960,   595,   865, -5252, 90240,
   -5252, -5252,   569, -5252, 90240, -5252, -5252, 93440, -5252, -5252,
    1179, -5252, -5252,   645,  1545,    66,  1175,    75,   708, -5252,
   -5252, 94080,  1058,  1242, -5252, -5252,  1427, 93440,  1058, -5252,
     708, 93440, -5252,   199,   198, -5252,  1546,  4221,   256,  1647,
    1580, -5252, -5252,  1158, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
    3494, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  2491, -5252,
   -5252, -5252, -5252,  4101,  1693, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, 78060, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252,   256, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, 93440, 93440,  1077,  1144, 93440,  1908,  1922, 89600,
   93440,  1922, -5252,    76, -5252, -5252,  1679, -5252,  1360, -5252,
      75,  2868, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,  1376, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,  1877,  1952,   480,  1914,
    2146, 93440,  1194,  1922, -5252,  1922,  1922,  1922,  1922,  2175,
    1922,  1922, 93440, -5252,  1922,  1922,   930, 93440, 37634, -5252,
    1336,   815,  2199, -5252, -5252, -5252, -5252, -5252, -5252, 56172,
      75, 23873,  2302, -5252, -5252,  1870,  4557,  1684, -5252,  2184,
   -5252, -5252, 93440, -5252, -5252, 56172, -5252,  2184, 38378,  3324,
   -5252, 36177,  8912,  2184,    75,  2276, -5252,  1700, 23873, -5252,
   -5252,  1064, -5252, -5252, 93440, -5252, -5252, -5252,  2179,   708,
   -5252, 89600, -5252, -5252, -5252, -5252,  2559, 23873,   248,  2204,
   -5252, -5252,  2136, 78700, 89600,  2479,  1952,  2536, -5252,  1711,
    1210, -5252,  1947,  2037,  1952,  1869,  2042,  1952,  2470,  1922,
    1922, -5252, -5252,  1845,  1845,  1845,  2295,  1845, -5252,  1845,
    2654,  1990,   234, -5252, -5252,  1987, 93440,  2479, -5252, -5252,
   -5252,  2479,  2479,  2116,  2685,  2694,  2733,   877,  1834,   159,
     159,  1679, 60254,  1082,  2493, -5252,  2654,  2523,  1791, -5252,
   -5252,  1904,  2523,   256,  2523, -5252,   177,  1360,  3177, 93440,
   -5252, -5252, -5252,  2078, -5252, -5252, -5252,  2135, -5252,  2111,
    1660, 58883, -5252, 93440,  2808, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  1434, -5252, -5252,  2634,   252,  2261,  2477,
    2189, -5252,  2667, 89600, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, 93440,  2164, -5252,  2866, 23873,  1877, -5252,  2681,
   -5252, -5252, -5252, -5252, 78700, -5252, 93440, -5252,  2949, -5252,
   -5252,  2862, -5252, -5252, 81920,   577, 93440,  2859, 93440, 93440,
   93440, 93440, 93440, -5252, 89600,  2298, -5252, -5252,  1922,  1922,
   -5252, -5252,  2390,  2371,  1669,  2250,  2565, -5252,  2458, -5252,
   -5252,  2343, -5252, -5252,   146, -5252, -5252, -5252,   259,   261,
     270,   283,  2876,   319,   825,   324,   328, -5252, -5252, -5252,
    2791,  2885,  2308, -5252,  2677, 23873, -5252, -5252, -5252,  2982,
   -5252, -5252,   906,  2751,  1171, 78700, 99200, 81270,100128,100128,
  100128, -5252,   260,  1545, 93440, 99664, 93440, 50106, -5252,  2334,
   -5252, -5252,  8473, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, 93440, -5252, -5252,  1747,  2784, -5252, -5252, -5252, -5252,
   -5252,  2347, -5252, -5252, -5252, -5252, -5252, -5252, 29025, -5252,
    2370,  2379,  2385, 19457,  2400,  2409,  2413,  2418,  2422,  2250,
    2250,  2250,  2428,  2439,  2440,  2443, -5252,  2455,  2459,  2465,
    2475, -5252,  2497, -5252,  2500,  2503,  2511, -5252, -5252,    58,
     218,  2516,  2524, 24609,  2530, -5252, 72940,  2546,  2549,  2563,
    2575, -5252, -5252, 23873,  2428,  2576, -5252, -5252,  2585, -5252,
    2586,  2590,  2607,  2621,  2625,  2629,  2642,  2645,  2932,  2648,
    2649,  2657,  2428, -5252, -5252, -5252,  2014,  2250,  2428,  2428,
    2668,  2678,  2686,  2692,  2698,  2699,  2718,  2719,  2728,  2753,
    2755, 90880,  2764,  2765,  2771,  2776,  2780,  2785,  2790,    25,
    2795,  2803,  2806,  2829,  2845,  2849,  2853,  2854,  2863,  2874,
    2877,  2879,  2883,  2886,  2534,  2898,  2903,  2905,  2906,  2908,
    2567,  2912,  2913,  2916,  2919,  2921,  2925,  2926,   339,  2928,
    2929,   349,  2930,  2933,  2934,  2940,  2941,  2945,  2948,  2950,
   29761, 30497, 29025, 17985, -5252, 93440, 94720, -5252, -5252, -5252,
    4013,   606,  1483,  3337, 29025, -5252, -5252, -5252,  3213, -5252,
    3109, -5252, -5252, -5252, -5252, -5252,  3064,  3114, -5252,  3191,
   -5252, -5252,  3212,  2731, -5252,  3179, -5252, -5252, -5252, -5252,
   -5252,  2783,  2951,  3356,  3395, -5252, -5252,  1401, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
    2873,  2917, -5252,  3179, -5252, -5252, 59583, 78700, 56846, -5252,
   -5252,  2390,  3050,  3544, -5252,  3631, -5252,  3551, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  3324,
   -5252, -5252, 64400,  3497,  -117,    21,   433,   435, 43169,   216,
   86400,   468,   220,  2959, 69100, 44631,  2960,    49,  2962, -5252,
    2963,  2964,  2968,  2972,  2973,  2976,  2978, -5252, -5252, -5252,
    3090,  2987,  2974,   308, -5252, -5252,    30,  3080,   365, -5252,
    3338, -5252,   308, -5252, 39044,  3620,  2430, -5252,   970, -5252,
    3671, -5252, -5252,  3092,  3084,  3117, -5252,  2856, -5252,  1952,
   -5252,   832, -5252,  3620,   308,  2430, -5252,  3293,  3379,  1157,
    3708, -5252,  -140, -5252, -5252, -5252,  2982, -5252,  3030, -5252,
   -5252,  3333, 93440, -5252,  3680, -5252, 78700, -5252, -5252, -5252,
    3032, 78700, 78700,   120,   162,  4013,  3035, 23873, -5252, -5252,
    4566, 39754,  3234,  1593,  -101, -5252, -5252,  1545, 93440, -5252,
   -5252,   688, -5252,  3462, -5252,  3040, -5252, 95360,   162,  3723,
   -5252, -5252, -5252,  1170,  3437, -5252,  3051, -5252, -5252, -5252,
   -5252, 78700, 93440,  1952, -5252, -5252, -5252, -5252,  3052, -5252,
   -5252,  3255,  3146, -5252,  3085, -5252, -5252,   278, -5252, -5252,
    3765, -5252, 93440, -5252, -5252,  2479, -5252,  2479, -5252, -5252,
    2479,  2479,  2479, -5252, -5252,  3113, -5252,  3397,  3399,  2667,
   -5252, 72300, 93440,  3757, -5252,  4840, -5252, -5252,  3082, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,  3656,  3591,  3591,
   -5252, 69740, -5252, -5252,  3760,  2493,  3576, 87040,  3736,  3837,
   -5252,  3620, -5252, -5252, -5252,  1977, 93440, -5252,  1977,  1977,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
     256, -5252, -5252,  2868, 46668, 93440,  2523,  1791,  3804,  3470,
   -5252, 93440, -5252, -5252, -5252,  2250,  3096, -5252, -5252, -5252,
   -5252, -5252,  3862, -5252, -5252, 78700,  3302,  3473,  3473,  3473,
    3874, -5252, -5252, -5252, 58883, 78700, -5252, -5252, -5252,   252,
   -5252,   873, 93440, 78700,  3145, -5252, 78700,  3103, 23873, -5252,
   23873, 56172,  3466,  4013, -5252, -5252, 78700,  1917, -5252, -5252,
   -5252,  3862,  3473, 78700,  3872, 78700,  3795,  2493, -5252,  3119,
   -5252,  3121, -5252, -5252,  3817, 93440, -5252, -5252, -5252,  3127,
    2298, 60953, -5252,  1322,  3489, 59583, 78700, -5252, -5252,  3499,
    3797, -5252, -5252, -5252, -5252, -5252,  3242, -5252, -5252,  3168,
   -5252, -5252, -5252,  3171, -5252,  3171,  3171, -5252, -5252,  3171,
   59583, -5252, -5252, 58883,  2005,  4475,  3830,  3410, -5252,  3680,
   -5252, 25345, -5252, 26081, -5252, -5252, -5252,  3448,   245,  1071,
   -5252, -5252,  3651, 93440,  3407,  3859,  3842, -5252, -5252, -5252,
   -5252, -5252, -5252,  3675,  3198,  3822,  3200, -5252, -5252, 23873,
    3202, -5252, -5252, -5252, -5252, -5252, -5252, -5252, 78700,  3208,
   29025, 29025, -5252,  3976,  3976,  3976, 23873,  3596,   383,  3569,
   23873, 23873, 23873,  2226,  3216, -5252, -5252, -5252,   318, -5252,
    3217, 23873, 23873, 74220,  3221,   395,  4206, 23873,  3925, 23873,
   23873, 23873, 23873, 17985,  3254, 23873, -5252, -5252, 94720, 74220,
    3677,  3228, -5252,  3227, -5252,  2264, 23873,  2407, 23873, -5252,
   -5252, 23873, 23873,  3236, 23873, 23873, 31233,  3237, 23873, 23873,
    3247,  3378,  3976,  3976,  2425, -5252, -5252, -5252, -5252, -5252,
   -5252,  3976,  3976, 23873, 23873, 18721, 23873, 23873,  2449, 23873,
   23873, 23873, -5252,  3248, 23873, 23873, 23873, 23873, 23873, 23873,
   23873, -5252, 23873, 23873, 23873, 23873,  1344, 23873, 23873, 78700,
   23873, 23873, 23873, 23873, 23873, 23873, 23873,  3934, 78700, 23873,
   23873, 23873, 23873,  3936, 23873, 23873, 23873,  3263, 23873, 78700,
   23873, -5252, 23873,  3737,  3737, -5252, 23873, 18721, 23873,  3265,
   74860, 23873, 23873, 23873, 23873, 24609, -5252, 24609, -5252, -5252,
    3266,  1551,   267,   256, 23873,  3260, 70380, -5252, -5252, -5252,
   -5252, 23873, 23873, 23873, 31233, -5252,  1486, -5252, -5252, -5252,
   -5252, -5252, 17249, 31233,  3270, 31233, 31233,  3902,  2395, 31233,
   31233, 31233, 31233, 31233, 31233, 31233, 31969, 32705, 31233, 31233,
   31233, 31233, -5252, 89600, 29025, 79980,  3275,  3945, -5252, 94720,
   -5252,  1729,   542, -5252,  1952,  4557, 34168, -5252,  3277, -5252,
    3777,  3278, -5252,  1301,  3276,  3282,  3963, 59583, 58883,  2048,
    3297, -5252,  3281,   517,  3288, -5252, -5252, 60953, 93440, -5252,
   -5252, -5252, -5252, -5252,  4028, 23873, -5252, 59583, -5252,  1139,
   16487, -5252,  1188,  1305,    49, -5252, -5252, -5252, -5252, -5252,
   16487, 93440, 65084,  3291,  3385,  3310,  2479, 93440, 78700, 93440,
   96000, 93440, 93440, 78700, 59583, 78700, -5252, -5252, -5252, 93440,
     308,  2430,  1005,   308,  3946, -5252,   961,   961, -5252, -5252,
   -5252, -5252, -5252, -5252,   308, 93440, 93440,   308, 58883, -5252,
    2430,  2030, -5252,  3592,  3381, -5252, -5252, -5252,  3634, -5252,
   -5252,  3982,  3305, -5252,  3654, -5252, -5252,  3405, -5252, -5252,
   78700, -5252, -5252,  2430, -5252,  2430,  2430, 23873,   308,   308,
     308, 73580,  3315,  3317, -5252,  3330, -5252,  3318, -5252, -5252,
   -5252, -5252, 78700, -5252, -5252,  3311,  3979,  3339, -5252, -5252,
    3920,    -1, -5252,  3770, -5252,  3906, -5252, 23873,  4013, 20193,
    3625, -5252, -5252,  3628,  3635,  3636, -5252, -5252, -5252, -5252,
    3783,  3638, -5252,  1952,  3639, -5252, -5252,  3362, -5252, -5252,
   -5252, 34168, 89600, -5252,  3370, -5252,  3390, -5252,   178, -5252,
   -5252,  4061,  3479, 23873, -5252, -5252, 78700,  3877, -5252,  1952,
    1711, 93440, -5252, -5252,  4144, -5252,  1710, -5252, -5252, -5252,
    3488,  1869, -5252, -5252,  1301, -5252, -5252,  1845,  3570, -5252,
   -5252, -5252, 89600, -5252, -5252, -5252, -5252, -5252, -5252, 60953,
   58883, 89600, -5252,  2479,  2479, -5252, 78700, -5252, -5252, -5252,
    2479,  2479,  2479,  3422,  1435,  3398,  3404,  3406,  3411,  2071,
    3413, 75500,  2643,   180,  4039,  4041, -5252,  3992,  2599,  3992,
   -5252, -5252, 75500, 73580,  3419,  3757, -5252, -5252, -5252, -5252,
   89600,  3423, -5252, -5252,  3414, -5252, 23873,  4170,  4096,  3760,
    1398, -5252, -5252,  3778, -5252, 90880,  3978,   857, -5252,  3434,
    3558, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,   209, -5252, -5252,
   -5252,  1333,  3805,  3501, -5252, -5252, 89600,  3501,  -132,  1410,
   -5252,  3452,  1952,  2532, -5252,  2532, -5252,  3747, -5252,  3753,
     195, -5252,  1301, -5252, -5252, -5252, -5252, -5252, 78700,  3461,
   -5252,  3650, 93440,  2164,  3469,  3468,  4013,  4013, 50780,  4212,
    3948,  5163,   114,  3523, -5252, -5252, -5252, -5252, -5252, 78700,
   -5252, -5252,  2415,  3149,  3966,  3656,  3564, -5252,  3480, -5252,
   -5252,   426,  4065, -5252, -5252,  4083, 93440,  4180, 82560, -5252,
   -5252,  4098, 93440,  1322,  3508, -5252, -5252, -5252, -5252, -5252,
      49, -5252,  3509,   126, 78700, 78700, 56172,  3647, -5252, -5252,
   -5252, 93440, -5252, -5252, -5252, -5252,  4015,   119, 34816, 76140,
   -5252, 76140, 76140, -5252, -5252, -5252, -5252, -5252,   825, -5252,
   -5252, -5252, -5252, -5252, -5252, 23873, 47368,  4013, -5252, -5252,
   78700, -5252,  4167, -5252, -5252, 97920,    68, -5252, -5252,   111,
   78700, -5252, -5252, 23873, -5252,  4171,  3649, 93440, -5252,  4236,
   -5252, -5252, -5252, -5252, -5252, -5252,  4013, 93440, 93440, 56172,
   56172, 23873, -5252,  1204, 23873, -5252,  3527, -5252,  3529,  3531,
    4043,  3889, 23873, 23873, -5252,  4003,   489,   240, -5252,  3538,
    3550, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  3541,
   -5252, -5252, -5252,   296,   337,  3547, -5252, -5252, -5252,  3548,
     256, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  4227, -5252,   193, -5252, -5252,   233,   251,   379,   436,
     617,  3568,   638,  3248,  2099,  3560, 74220, 94720,  3976,  3566,
     271,  3976,  3573,   731,   347,   778, -5252,   393,   787,  2752,
   -5252,   844,   939, -5252, -5252,  3574,  3575,  3976,  3578,  3582,
    3584,  1008,   225,  3586, 20929, 21665, 22401,  4070,  3589,  1129,
     896,  3976,  3593,  1069,  2113,  1076, 94720,  1180,  1444,  1259,
   -5252,  2141,  1271,  1382,  1421,  1426,  1566,  1671,  1466,  2157,
   -5252, -5252, -5252, -5252,  3562,  1739,  1852,  3567,  3595,  2167,
    1923,  1983,  2047,  2191,  2202,  2224, 78700,  3600,  2079,  2094,
    1492,  2225, 78700,  2106,  2112,  1515, -5252,  2123,  3590,  1519,
     282,  3599,  3604,  2149,  3607,  1529, -5252, 94720, 93440,  3609,
    3561,   286,   263,  1586,  2171,  3254,  3254, -5252, 23873,  3610,
     214, 94720,  1305, -5252,  4102,  2937,  1863, -5252,  1483, -5252,
   -5252, -5252, -5252,   257, -5252,  3614,  1483,  3615,  2732, 17985,
   -5252,  1559,  1545, 31233, 31233,  3617, 31233, 31233,  3624,  3624,
     299,  2017,  2017,  3401,  3156, 24609,   299, 24609,   299,  3624,
    3624,  3624, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
    4193,  3621,  1901,  3623, -5252, -5252, -5252, -5252, -5252, -5252,
     705,  4025, -5252,  3814,   196, 23873, -5252,  3644,  4139,  4146,
    4149, -5252, -5252, -5252, -5252, 59583, 59583, 78700,  4147, 23873,
    4310, 60953,  4321, -5252,  3648, 35464, 76140, 76140, 76140, -5252,
    3652, -5252, 23873, 93440, 93440, 16487, 64400,  4328,  4329,    49,
   63716, -5252,  4013,    49, -5252,  3658,  3660, -5252, -5252, 29025,
    2455, -5252,  4013, -5252,  1296,  3939, -5252,  3663,  3664, -5252,
    3653,  3666,  3667, 67820, 23873, -5252,    49,  1188, -5252, -5252,
   -5252, -5252, -5252,  3670, 93440, -5252, -5252, -5252, 93440, -5252,
   -5252, -5252, -5252, -5252, -5252,  1952, 23873, -5252, -5252,   308,
   93440,   308, -5252,  1952,  4342, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252,   308, -5252, -5252, -5252, -5252,
   -5252,  3848,  3620,  2856,  3946, -5252,  2430, 78700,   308,   308,
    4013, -5252, -5252, -5252, -5252,  4224,  3656, 20193,  3693,  3692,
   -5252, -5252, 56172, 93440, 93440, -5252, -5252,  1528, -5252,  3656,
    4236, 89600, 65768, 78700, -5252, -5252, -5252,  2527, -5252, -5252,
   -5252, -5252, -5252,  4013,  2204,  2455, -5252,  3694,  4013, -5252,
   -5252,  4406, -5252, -5252, -5252, -5252,  1952, -5252, -5252,  4738,
   -5252, 78700, -5252, 71660, -5252, 71660,  1775, -5252, 96640, -5252,
    1952,  4013, 78700,   897,   111, -5252,  4463, -5252, -5252,  3809,
   -5252, -5252, -5252,  3700, -5252,  3750, -5252, -5252, -5252,  3704,
   -5252,  4385, -5252,  1452,   187,   195, -5252, 93440, 93440, 93440,
   78700, -5252, 93440,  2479, -5252, -5252,  2479, 78700, 93440, 93440,
    2479, 75500, -5252, -5252, -5252, -5252, -5252, 75500, -5252,   224,
   -5252,  3913,  1841,  1841, -5252, -5252, -5252, -5252, -5252,  4355,
    3992,  3992, 75500,  4356,  3792, -5252, 93440,  6289,  1183, -5252,
   69740, 93440,  4013, 23873, -5252,  3749,  4096, -5252,   111, -5252,
   88320, -5252,  4059, 88320, 88320, 94720,  3961, 23873,  3727, -5252,
      49,    49,  3952,  4250,  4252,  3856,  1952,  4255,  4258,  4263,
   -5252, -5252, -5252,  1952,  1952, -5252, -5252,    49, -5252,  1780,
   -5252, -5252, -5252, -5252,  4259,  2344, -5252,    49,    49, -5252,
    3556, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  1521, -5252,
     227,   902, 58883,  4216, -5252,  4337,  3751, -5252, 78700,  4425,
   -5252, -5252, -5252, -5252, 23873,  4256, -5252, -5252,  3948, -5252,
    3771,  3779,  3781,  3782,  3784,  3786,  3787,  3789,  3791,  3794,
    3798,  3802,  3803,  3806,  3812,  3813,  3815,  3816,  3818,  3823,
    3826,  3827,  3832,  3833,  3759, -5252, -5252,  3824, -5252, -5252,
   -5252, -5252,    49,    49,    49,    49, -5252,  2613, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,  4024,  2535, -5252,  1841,
   93440,  4266, 82560, -5252,  3989,  4417, -5252, -5252, 73580, -5252,
    3793, 78700, -5252, -5252, 60953, -5252, 89600, 59583, -5252, -5252,
   -5252,  3820,  1204, 51454, -5252,  3835, -5252,  2230, -5252, 58883,
    4272, -5252, 76140,  3828, -5252,  3836,  4331,  4339,  4340,  4348,
   56172,  1528,  4013, -5252, -5252,  3850, -5252, -5252,  3920,  3591,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  3875,  4128,  4247, -5252, -5252, -5252,  2185, -5252, -5252,
    4013, -5252, -5252, -5252,  4505, 58178, 52128,  3853, -5252, -5252,
   -5252,  2245, -5252, -5252,100128,100128,100128,  4236, -5252,  1589,
   -5252, 23873, -5252, -5252, 23873, -5252,  4013,  4264,  3376, 46014,
   -5252, 46014,  3376, 23873, -5252,  3860, -5252,  4511,  4516, -5252,
   -5252, -5252, 23873, -5252, 23873, -5252, 23873, -5252, 23873, 23873,
   23873, 23873, 23873, 23873, -5252, 31233, -5252,  3863,  3871, -5252,
   -5252,  3873, -5252, 23873, -5252, 23873, -5252, -5252, 23873, 23873,
   23873, -5252, -5252,  3876, -5252, -5252, -5252, 23873, 23873, 23873,
   -5252, 23873,  4398, 23873,  4554, 23873,  4578, 23873, -5252, 26817,
   -5252,  3881, -5252, -5252, -5252, -5252, -5252, 23873, -5252, 23873,
   -5252, 23873, 23873, 23873, 23873, 23873, -5252, -5252, 23873, -5252,
   23873, -5252,  4451, 23873, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, 23873, -5252, -5252, -5252,
   -5252, 23873, -5252,   422, 27553, -5252, 23873, 23873, 23873, -5252,
   -5252, 23873,  3868,  3878, -5252, 93440, -5252, 23873,  2639,  3045,
     111,  3887, 23873, -5252,  3900,  3901,  3035, -5252, -5252, -5252,
   98560, 23873, -5252, -5252, -5252, -5252,   395, 31233,   293, 31233,
    1545,  3003, 17985, -5252,  1639,  1545,  3254,  3254, 93440,  4635,
    3892, -5252, 23873, 94720, 23873,  3894,  3895, -5252,  3899, 31233,
   -5252, -5252,  3903, -5252,  2103,  3045,  3990,  4344, -5252,  4013,
   34168,  4411, -5252, -5252, 78700,  2857,  4108, -5252, 59583, 58883,
   76140,  4590,  4592,  4597,  4598, -5252,  4013, -5252,  3918,    49,
      49, -5252, -5252,  8178, 59583, 16487, -5252, -5252, -5252, -5252,
    4431,  4432, -5252, -5252,   864,  4218,  4487, -5252, -5252, -5252,
    3927, -5252, -5252, -5252,   520, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  4013, 16487, -5252,  3291,  3930, 36890,   789,
   -5252, -5252, -5252,  4013, -5252, -5252, -5252, -5252,  3947, -5252,
   -5252, -5252,  4530, -5252, -5252,  4342,  2493,  2430, -5252, -5252,
   74860,  2892, -5252, -5252, -5252, 20193, 52802, -5252,  2259, -5252,
    4699, 74860,  4418, -5252, -5252, -5252, -5252,   258, -5252, -5252,
   53476, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  3949, -5252, -5252, 20193,  3970, -5252, -5252, -5252,  3820,
     332,  3971,  3959, -5252, -5252, -5252, -5252, -5252, -5252,   230,
     253,  3089,  2493, -5252, -5252,   118, -5252, -5252, -5252, -5252,
   -5252,   884, -5252, -5252, -5252, -5252,  1710,  3450, -5252,   111,
    4185, -5252, -5252,  1452,  4413, -5252,  4216,  4650,    92,  4564,
    4565, -5252,  4259, -5252, -5252, -5252, 93440, -5252,  3980,   630,
    3981, 78700,  4840,  4840, -5252,  1841,   352, -5252, 31233,  4741,
   -5252,  4478, 75500,  4624,  4626, -5252, 75500, -5252, -5252,  2265,
   -5252, -5252, 45359, -5252, -5252, -5252,  4013,   860,  2408, 23873,
   93440, -5252,  3749, -5252, -5252, -5252, 88320, -5252, -5252, -5252,
    1398,  3987,  2408,  3995, 63716, 45359, -5252,  4370,  4371,  1225,
   -5252, -5252, -5252, -5252, -5252, -5252,  4002,  1410, -5252,    49,
      49, -5252,   200,    49, -5252, -5252,   229, -5252, -5252,  2737,
      24,  4259, -5252,  1952,  1952,  1952,  1952,   111,  1952,  1952,
    2272, -5252,  4002,  4002,  2532, -5252,   871, -5252, -5252, -5252,
   -5252,   175, -5252, -5252, 89600, -5252,  4503,  4504, -5252,  4506,
   -5252, -5252,   298, -5252,  2541,    82,  6287,  1049, -5252,  4551,
   93440,  4763,  3751, -5252,  1156,  2164,  4013, 56172, 23873, -5252,
    4007,  4008,   111,  4009,   111,   111,  1952,  1952,  3947,  1952,
     111,  1952,  1952,  1952,  1952,  1952,  1952,  1952,   111,  1952,
    1222,  2253,  1952,   111,  5163, -5252,  1952,  3045,  4002,  4002,
    3149, -5252,  4680,    49, -5252,  3922, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4010, 73580,   458,
   -5252, 87680,  4568,  2493,  4033, -5252,  1301, -5252, -5252, -5252,
   -5252,  1236,  4701, -5252, -5252,  4730, -5252, 93440,   317,  4228,
    4533,  4046, 83200, 58883, 58883, 58883, 58883, 48084,  4627, 78700,
   -5252,  4698, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,  8748, -5252, -5252,
   -5252,  4353,  2547,  4050, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252,  4047, -5252, 23873, -5252, -5252,
    4414, -5252, -5252, -5252, -5252, -5252, 54150, 23873,  4013,  4013,
   23873,  4055,  4055,  4058,  4063, -5252,  4772, -5252,  4711,  4055,
    4055, -5252,  4055,  4713,  4055,  4055,  4071, -5252, -5252,  4073,
    4074,  4077,  3035, -5252, 23873, 23873,  2180,   150,  2195,  2251,
    1725,  1757,   304, -5252,  2263,  2901, 94720, -5252, -5252,  2316,
    2342,  2389,  2462,  2469, -5252,  1799,  4450,  1868,  4013, 23873,
    4013, 23873,  4013, 23873,  4013, 24609,  2495, -5252,  2278,  4502,
   -5252,  2318,  4589,  2504,   354,   372,  2513,  2531,  2553,  2335,
   -5252,  2290,  4673,  2336, 24609,  2570,  2587,  1893,  1979,  2652,
   94720, 93440,  4075,  2675,  4082,  4082,   172, -5252,  4087, -5252,
   -5252, -5252,  4088, -5252,  2703, 23873, 23873,  4078,  4013,  4092,
    1483, -5252, 23873,  1545, 31233,   404, 31233, -5252, -5252,  4193,
   -5252, 23873, -5252,  4684,  4095,  3035,  4103,  4013, -5252, -5252,
   93440,  4100,  3337, -5252,  3947, -5252,  4749, -5252,  4851,  4109,
    4126,  4114,  3903, -5252, 59583, -5252,  4666,  4793,  3509, -5252,
    4794, 58883, 58883, 58883, 58883, -5252, 42441, -5252, 83840, 16487,
   16487, -5252, -5252, -5252,  4120,  4121,    52,  4682, -5252, -5252,
   -5252, -5252, 93440, 93440, 16487, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  2693, -5252,  3620, -5252, -5252, -5252,   308,
    4122, -5252,    49,   314, -5252, 20193,  4125,  4127, -5252,  4599,
   -5252, 93440,  4132,  4134,  4130, -5252, -5252, -5252,  4131,   256,
   74860, -5252, -5252,  4143, 91520, -5252,  4148, -5252,  4704, -5252,
   -5252,  3456, 71660, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252,  3620,  4374, -5252, -5252, -5252,  4172,
   -5252,  4151, -5252, -5252, 58883,    82,  4528,  1127,  1127,  4747,
   78700, 78700,  9606,  6671,  4259,  4163, 93440, -5252,  3751, -5252,
     429, -5252, -5252, -5252, -5252,  3337,  1841,  1841,  4803,  4649,
   75500, 75500,  4811,  4651, 23873,  4165, -5252, 93440, -5252,  1406,
   -5252,  4571, -5252, -5252, 23873, -5252, -5252, -5252, -5252,  4013,
    4937,  4177, -5252, -5252, -5252, -5252, 23873, -5252, 23873,  4181,
    4182, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,   422,   422, -5252,
   -5252,   422,   422, -5252, -5252, -5252, -5252,   422,   422, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  2344, -5252,
   -5252, -5252,  1521, -5252, -5252,  4688,  1184, -5252,  4770, -5252,
   -5252, -5252, -5252,   872,   111,   111,   111,  2253,  2266, -5252,
    2541,  1121,  4524, -5252,  4539,  4591,  4765,  4591,  4768,  4695,
    3668,  4559,    49,  4771,  4943,    49, -5252,   174,    49,    49,
      49,    49,  4240,    49,    49,    49,    49,  4778,    49,    49,
    4569,    49,  4848,  4283,  4853,    49,  4784, -5252,  4288,    49,
      49,    49,    49,  4591,    49,    49,  4790,  4405,  4796,  4797,
      49,    49,  1203, 93440,    49,    49,  4798, -5252, -5252,  6671,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,   115, 76780, -5252,
   -5252, -5252, -5252,    49,  1545,  1664,  4719,  1965, -5252,  2341,
   -5252,  4984, -5252,   152, -5252, -5252, 48758,  4013,   281,   357,
   -5252,   373, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   93440,  4002,  2535, -5252, 82560,  2493, -5252, 93440,  4570,  4767,
    3297, -5252, -5252, -5252, -5252, -5252, -5252,  4229, 23873, -5252,
   -5252,  4898, -5252, -5252, 58883, -5252, -5252,   195,   195,   195,
     195,  2927,  4587, -5252, -5252, -5252,  4698,  4509, -5252,  1626,
   -5252,  4055,  4055,   413, -5252,  4058,  4799,  4058, -5252,  4625,
     535,  3110,  4625, -5252,   535,  4058, -5252,  4234, -5252,  4625,
   -5252,   535,  4055, -5252,  4055, -5252, -5252,   535,  4055, -5252,
    4237,  4058, -5252, -5252,  4625, -5252, -5252, -5252, -5252,  1317,
    2823,  4058, -5252, -5252, -5252,  4055,  1391,  4055,  4055,  4055,
    4437,  4055,  4055,  4948, -5252, -5252, -5252, -5252, -5252, -5252,
    4058,    42,  4055,  4055,  4055,  4055,  4063,  4917,  4919, -5252,
   93440, -5252,  4013, -5252, 56172,100128,   304,  4013,  2127, -5252,
   -5252, -5252,  2190, -5252, -5252, -5252,  4836, -5252, -5252,  4055,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  4244,  3254,  3254, -5252,  4989,  4781, -5252, -5252, 23873,
   23873, -5252, 23873, -5252,  1415,  4251,  4718, -5252, -5252, -5252,
   -5252, -5252, -5252, 23873, 23873, 23873,  4013,  4013,  4013,  3254,
   -5252, -5252,  3958, -5252, -5252,  3376, -5252, -5252, 23873, -5252,
   23873, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,   287,
    3254, -5252, -5252, 23873, 23873, -5252, -5252, -5252, 93440, -5252,
    3045,  4253,  4526, -5252, -5252, -5252,  3045,  4387, -5252, -5252,
    3045,   111, -5252, -5252, -5252, 93440, -5252,  2360,  1483, -5252,
   23873,  1545,  4839,  4254,  4999,  4257, -5252, 23873, 42441, -5252,
    4260,  4265, -5252, -5252, -5252, -5252, 23873,  4887,  4844, -5252,
    3045, 93440, -5252, -5252, -5252, 58883, 58883,  3648,  3648,  3648,
    3648, 92160, -5252, -5252, -5252, -5252,  1905, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252,    49,    49, -5252, 36890, 64400, -5252,
   -5252, -5252, -5252, -5252, -5252,  3620, -5252, 74860,  2493, 23137,
   -5252, -5252, -5252, 20193, -5252, -5252,   395, -5252, 74860, 84480,
    4274,  4273, -5252,    49, 40420, -5252,  4277, -5252,  4276, -5252,
    1951,  4600,  4889, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4280, -5252,
   -5252,  1952,  2101, -5252, -5252,  4306, -5252, -5252, -5252, -5252,
   -5252, 78700, -5252, -5252, 41780,  4913, 78700, -5252, -5252,  4858,
   -5252,  6466, -5252, -5252, -5252, -5252,  1238,  4875,  5045,  4287,
   -5252, -5252, -5252, -5252,  4392,  4287,  3751, -5252, -5252, -5252,
    4776, -5252, -5252, -5252,  4777,  4013, 93440, -5252, -5252, -5252,
    1423,  2237,  4920,  2408,  4295, 93440,  2408,  4013, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,   972, -5252, 89600, -5252, -5252, -5252, -5252, -5252,  4888,
    4890, -5252, -5252, -5252, -5252,  4485,   683, 77420,  2479, -5252,
    2452,  4345, -5252, -5252, -5252,  2109, -5252,  2479,  2527,  2527,
    4964,  2859,  1058,  2859, 40420,  1183,   382,  4951,  1922,  2529,
    4350,  4879,  2859,  2859,    49, 66452,  1058, 74860,   149, -5252,
   -5252, -5252, -5252, 78700,   202,   232,   237, -5252, -5252, 67136,
    3947,   111,   111,  1058,  1952,  1952,    49,   111, -5252, -5252,
   -5252, 89600, 93440, -5252,  1698,   111,  3947,  3947,  2859,   243,
    1952,  1058, -5252,  1058,  1058,  3128,   149, -5252, -5252, -5252,
     111,   149, 40420, -5252,  9249, -5252, -5252, -5252, 41780, 93440,
     987,  4869, -5252,  4309, 61646, -5252,  4491, 23873, 23873,  4908,
   93440,  4910, -5252,  4717, -5252, 93440, -5252,   395, -5252, -5252,
   -5252,  4617,  4827,  2383, -5252, -5252,  2393, -5252, -5252,  2394,
   -5252, -5252, -5252, -5252, -5252,  3793, -5252,  5000, -5252,  4670,
    3652,   395, -5252,  4013, -5252,  4518,   195,  4805,  4805,  4805,
    4805, 56172, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4979,
   -5252, -5252,  4625,    49,  4625, -5252, -5252,   945, -5252,   945,
   -5252,   290, 63716, -5252, -5252, -5252, -5252,  1153, 46014,  2522,
   -5252,  4727,  3497,  4625, -5252,  4815,   535, -5252, -5252,   945,
    1845, -5252, -5252,  4625, -5252, -5252, -5252,  1845,   945, -5252,
    4818, -5252, -5252, -5252,   945,  4625,  4545, 93440,  4948,   535,
   -5252, -5252, 97280,   535,   945, 23873, -5252,  4900, -5252,  1153,
    5099,   535,  4625,   945,   945, -5252,   273,  4352, -5252, 54824,
   -5252,  4347,  4349,  4357,  4358,  1153,  2420,  4351, -5252,  1153,
    1153, -5252,  4360,  4361, 23873,  1845,  4992,  2736,  2002,  2445,
    4637,  4596, -5252,  4531, -5252,  2748,  4013,  4013,  1916,  4058,
   -5252, -5252, -5252, -5252,  5012,  4055, -5252,  5106, -5252,  4055,
   -5252, -5252, -5252, -5252, -5252, -5252,  4369,  2759,  2778, -5252,
   -5252, -5252,  2478,  1921,  2782,  2815, -5252, -5252, -5252,  4372,
   -5252, -5252,   322, -5252,  4368, -5252, -5252,  2482,  5115,  2373,
   23873, -5252,  4375, -5252, -5252, 93440,  3254,  1220, -5252,  2486,
   -5252, -5252,  4376,  3648,  3648, -5252, -5252, 85120, 16487, 16487,
   -5252, -5252, -5252, -5252,  4083,  2455, -5252, -5252, -5252, -5252,
    4378, -5252, -5252,  4373, -5252, 74860, 20193, -5252,  4379,  4380,
   -5252, -5252, -5252, 91520, -5252,  2506, -5252, -5252,  5143, 20193,
   -5252, -5252, 89600, -5252,  4389,  4391, 79340,  3107,  2514, -5252,
   -5252, -5252, -5252, -5252, 78700, -5252,   239, -5252,  6962, -5252,
    6671,   484,  4270, -5252, -5252,  1470,  4515, -5252,  4396, 93440,
    1952,  4397,  5151, 23873,  4400, 23873,  4401,  2518, -5252,  2527,
   -5252,  2527, -5252,  1423,  5145,  5147,  5095,  5149,  2237, -5252,
    2423, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4407, -5252,
   -5252, -5252, -5252,  4742, -5252,  5001, -5252,  4860,  1545, -5252,
   -5252,  1058,  4412,  1545,  5087, -5252,  4415,  5053,  5055,  2527,
   -5252,  2479, 79340, -5252,  2479,  2479, -5252, 79340, 40420, 79340,
   -5252, 45359, 79340,  2859, 93440, -5252,  5093, -5252,  5057, 79340,
   79340,  1952, -5252, -5252, 40420,  4416, -5252,  2408, -5252, -5252,
   -5252,  2302, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4420,
   -5252, -5252, -5252, -5252, -5252,  3045, -5252, -5252,  1952, -5252,
   -5252,  4892, -5252, -5252, -5252, -5252, -5252, -5252, -5252, 79340,
   -5252, -5252, -5252, 40420, -5252, 40420, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4830,  3312,
   -5252,  4423,  4422, -5252, 93440, -5252, -5252, 78700, -5252, 43903,
   93440, -5252, -5252, -5252, -5252, -5252,  4013,  3254,  4819, -5252,
   -5252,  4541,  1952,  4788, -5252,  4904, -5252, 93440,   168, 56172,
   -5252,   111, -5252,   111, -5252,   111, 31233, -5252, -5252,   256,
   -5252,  4805,  1622, -5252, -5252, -5252, -5252, 55498, -5252,  5076,
    4945, -5252, -5252, 93440, -5252,  4905,  4931, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,    49, -5252,
   -5252, -5252, -5252,  2519, -5252, -5252,  2526, -5252, -5252, -5252,
   -5252, 97280, 10558, -5252,  2552, -5252, -5252, -5252,  4948,  4435,
   -5252, -5252,  4013,  4460, -5252, -5252, -5252, -5252,  5099, -5252,
   -5252, 80620, -5252, -5252, -5252, 93440,  5122,  5123, -5252, -5252,
   -5252, -5252, -5252,  5040, -5252, -5252, -5252, -5252,  4446,  2408,
   -5252, -5252,  4449, 88320, -5252, -5252, 23873, -5252,  4685, -5252,
    4791, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  1153, -5252,
   -5252, -5252, -5252,  3947, -5252, -5252, -5252,  4452, -5252,   111,
   -5252, 23873, -5252, -5252,  4454,  4440,  2408, -5252, -5252,  4555,
    4344,  4461, 93440, -5252,  4844, -5252, -5252, -5252, -5252,  4417,
   -5252, 85760, -5252, -5252, -5252, 93440, -5252, -5252,  3947,  4825,
   -5252,  2556,  4660,  4467, 93440, 93440, 93440, -5252, -5252, 41780,
    4469, -5252,  5226, -5252,  4858, -5252, -5252, -5252,  4470,  4471,
   -5252, 93440, -5252, -5252,  5175, 56172, -5252, -5252, -5252,  5064,
    1664, -5252,  4614,  4476,  9383, -5252, -5252, -5252,  4614, -5252,
    4013, 93440,  4013, 93440, -5252,  5156,  5156, -5252,  1845,  1845,
    5224,  1845, -5252,  5225,  5227,  2423, -5252,  4987,   683,  4854,
    1121,  5173, -5252, 93440,  5176, -5252, 23873,  2479, -5252, -5252,
   79340,  4975,  1567, 79340, 79340,  1623, -5252, 79340,  2415,  4028,
   -5252, 79340,  4380, 93440, -5252, -5252,  1236, -5252, -5252, 74860,
   -5252, -5252, 78700, -5252, -5252,  5002,   987, -5252, 93440, -5252,
   -5252, -5252,  4493,  1971,  4486,  4489,  2107,  2012,  4490,  4237,
    2024,  4492,  4494,   817,  4495,  4496,  4498,  4500,  1317,   369,
    2025,  4508,  4510,  4512,  4055,  4513,  2026,  2027,  2043,  4055,
    2046,  4514,  5235, -5252, -5252,  4517, -5252, -5252, -5252, -5252,
   -5252,  1068, -5252,  2557, -5252, -5252, -5252, -5252, 49432, -5252,
   -5252, -5252,  3173, -5252,  4694, -5252,  1622, -5252,  4998, 78700,
   -5252, -5252, -5252, -5252,  1153,  1845,  1153,  4948, -5252, -5252,
   93440, -5252, 93440,  5104, -5252, -5252, -5252, -5252, 41136, -5252,
   -5252, -5252,  4833, -5252,  2580, -5252, -5252,  4522, 23873, -5252,
   -5252, -5252,  1297,  2821, -5252, -5252, -5252,  4523, -5252,  4525,
    3987, -5252,  4447,  4642,  4139,  4146,  4149,  4692,  4859, -5252,
    4702, -5252,   111, -5252,  4529, 31233, -5252,  1618, -5252, -5252,
   -5252, -5252, -5252, -5252,  4946, -5252,  4534, 93440,  2581,  2408,
    4535,  2588,  4536, -5252, -5252, -5252,   258,   239, -5252,   443,
   -5252, -5252,  5208, -5252,  4908, -5252, -5252, 93440,  1403,  4734,
   -5252, -5252, -5252,  2596,  2611,  2139, -5252, -5252, -5252, -5252,
    1845, -5252,  1845,  1845, -5252,  4537, -5252, -5252, -5252, 79340,
    1253,  4538, -5252,  2830, 79340,  4975,  1617,  1127, -5252,  1127,
   -5252, -5252,  5247,  5248,   987, -5252, -5252, -5252, -5252, -5252,
    1058, -5252,  4542, 78700, -5252, -5252,  4380,   884, 93440,  5159,
    4154, 10558, -5252, -5252,  3440, 93440,  4638, -5252, 56172,  4739,
    5284,  5285, -5252, 93440, 92800, 31233, -5252, -5252, -5252,  3656,
   -5252, -5252, -5252, -5252, -5252,  4543, -5252, 80620, -5252, -5252,
   -5252, -5252,100128, -5252,  2408, 88320, 88320, -5252, -5252, -5252,
      96, -5252,  5309,  1629, -5252, -5252,   392, -5252, -5252, -5252,
   93440,  4553,  4634, -5252, -5252,  4623, -5252, -5252,  3796, -5252,
    2344,  2619,  1301, 93440, -5252,  5150,  1301, 93440,  5024, -5252,
   -5252, -5252, -5252, -5252,  1965, -5252, 10558,  4270, -5252, -5252,
    4760, -5252, 93440, -5252, -5252, -5252,  5303, -5252,  5305,  4563,
    4567, -5252, -5252, -5252, -5252,  5235,  3045,  4844, -5252, 93440,
   -5252, -5252, -5252,  1127, -5252,  4572, -5252,  4574,  4576, -5252,
   33441, -5252, -5252, -5252, -5252,  5210, -5252,  2637, -5252,   959,
    5158, -5252,  5209, -5252,  1952, -5252,  4647, -5252,  4154, -5252,
   -5252, -5252,  4615,  5216,  5172,    49, -5252, 89600, 33441, -5252,
    5068, -5252,  5025,  5292, -5252,  5344,  3605, -5252, -5252, -5252,
   23873,  4939,  5208, -5252,  4782,  4783, -5252, -5252,  2651, -5252,
   -5252,  3337, 74860, -5252, 93440, -5252, -5252, -5252, -5252, -5252,
   -5252,  4447, -5252, -5252,  4716,  1772, -5252,  2684, -5252, -5252,
   -5252,  3045, -5252,  4593, -5252,  4953,    49,    49,  4954,    49,
      49,    49,    49,  4594,  3796, -5252,  4947,  2712,  1301,  1287,
    2408,  4601,  1627,  4603, -5252, -5252, 78700,  4717, -5252, 57494,
   93440,  4595, -5252, -5252, 91520, 91520, -5252, -5252,  2722,  4607,
    4604,  4609, -5252, 93440,  4610, 93440, 93440,  2253,  2253, 17985,
   -5252, -5252, -5252, -5252, -5252, -5252,  2951, -5252,  4611, -5252,
   93440, -5252, -5252, -5252,   411, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, 62339, -5252, -5252,  5195, -5252,  4653,  1217,
      49, -5252,  3839,  4013, 23873, -5252, -5252, -5252, -5252, -5252,
   92800,  4612, -5252,    49,  1183, -5252, -5252, -5252, -5252, -5252,
   -5252, 93440, -5252,  4613, -5252, -5252,    65,    49,  1952,  1952,
      49,  3046,  3046,  3045, 89600,  4697, -5252, -5252,    49, -5252,
    1919,  4806,  1952,    49,   329,  1287, -5252, -5252,    49, -5252,
   -5252,   329,  1627, -5252, -5252, 93440,  5277,  4972,  5208,  4618,
   93440,  4619,  2760, -5252, -5252, 93440, 93440,  4628,  2769, 93440,
    2774,  2797, -5252, -5252,  4622,  4844, -5252,   415,   415, -5252,
   -5252, -5252, -5252,  4630, -5252,   802, -5252, -5252,  3839,  4013,
   -5252, 74860, 20193, -5252,  4634, -5252, -5252,  2809, -5252, 28289,
   -5252, -5252, -5252,  1952, -5252, -5252,  1952, -5252, -5252, -5252,
   -5252, -5252,  2810, -5252, 89600,  1127,  1127,   329,  1919, -5252,
   -5252, -5252,  3094, -5252,   111, -5252,  5250,  5077, -5252, 63032,
   -5252, -5252,  4632, -5252, -5252, -5252, 93440,  4629, -5252, -5252,
    2827,  2831, 93440,  1919,  2832,  1287,  1627, -5252,  2838, -5252,
   -5252,  1888,  5085,  5228,  5229,  1657, -5252,  3391,  3391,  1392,
   -5252, -5252,  5178, -5252, -5252,  4613, -5252,  4639, -5252,  3337,
   -5252, -5252, 89600, -5252,  4697, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, 93440,  4869,  1919,  2843, -5252,  1919, -5252, -5252,
   -5252, -5252, -5252, -5252,  5129,  5350, -5252,  4644, -5252,  3391,
   -5252, -5252, -5252, -5252, -5252,  1505,  4950,  4571, -5252, 28289,
    4646,  3796, -5252, -5252,  5343, -5252, -5252, -5252,  1919, -5252,
     415,   415, -5252, -5252, -5252,  1505, -5252,  5400,  4920, -5252,
   -5252, -5252,  4786, -5252, -5252, -5252, -5252,  1845,  5314, -5252,
   -5252,  5253,  4662,  1590,  1708, 68460,  5196, -5252, -5252, 89600,
   -5252, -5252, -5252, -5252, -5252, 89600,  2847, -5252, -5252, 74860,
   -5252, -5252, 56172, -5252, -5252, 71020,  4663, -5252,    49,  5208,
   -5252, 74860, -5252, -5252, -5252, 20193, -5252, -5252
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1126,  2351,     0,   454,     0,  1346,   721,  2206,  2344,
    2345,  2131,     2,   509,   220,   407,  2133,  2416,     0,     0,
     505,  1362,   862,   616,     0,   332,     0,     0,   512,   330,
     220,  1411,  3056,  2251,     0,  3147,  2194,     0,  1409,   507,
    2514,  3398,  2136,     0,  3299,     0,     0,     0,  3304,    71,
    2099,     0,  1362,   353,  3149,    84,     0,     0,  1362,  2400,
    3304,     0,  2428,     0,     0,  2232,     0,     0,     0,     0,
       3,     8,    22,     0,    44,    27,    32,    17,    21,    16,
      46,    59,    52,    29,  3301,   403,   404,   405,   406,    42,
    3334,    41,    11,    62,    63,    19,    49,    12,    15,    18,
      40,    48,    36,    43,    56,    57,  1432,  1408,  1436,  1407,
    1403,  1399,  1418,  1419,  1420,  1426,    25,    26,    33,    50,
      67,    23,    64,    60,    24,  2351,    13,    28,    14,    51,
      45,    37,    61,    68,    38,     0,    58,    39,    66,    31,
      53,    30,     9,    10,    20,    54,    55,    47,    69,    34,
      65,    35,  1171,     0,     0,     0,     0,     0,  2129,     0,
       0,  2129,  1255,  1476,  3332,  3333,  3334,  1363,     0,  1364,
       0,     0,  2552,  2553,  2760,  2806,  2807,  2702,  2835,  2654,
    2930,  2952,  2978,  2742,  2741,  2744,  2743,  2745,  2746,  2747,
    2748,  2749,  2750,  2627,  2751,  2752,  2753,  2755,  2754,  2756,
    2757,  2758,  2628,  2701,  2629,  2707,  2759,  2709,  2708,  2761,
    2630,  2631,  2762,  2763,  2764,  2765,  2685,  2633,  2632,  2766,
    2768,  2767,  2710,  2711,  2688,  2769,  2770,  2771,  2773,  2634,
    2635,  2636,  2637,  2638,  2772,  2639,  2774,  2689,  2775,  2776,
    2640,  2777,  2778,  2779,  2780,  2782,  2781,  2682,  2783,  2784,
    2786,  2787,  2788,  2785,  2789,  2790,  2792,  2791,  2713,  2793,
    2712,  2794,  2641,  2795,  2796,  2797,  2798,  2799,  2800,  2801,
    2802,  2690,  2803,  2804,  2805,  2827,  2703,  2808,  2810,  2809,
    2714,  2811,  2812,  2813,  2815,  2814,  2816,  2818,  2642,  2643,
    2644,  2817,  2819,  2820,  2821,  2822,  2823,  2825,  2824,  2829,
    2830,  2715,  2645,  2686,  2646,  2647,  2826,  2828,  3033,  2831,
    2832,  2716,  2717,  2833,  2648,  2704,  2834,  2691,  2837,  2836,
    2649,  2838,  2650,  2839,  2840,  2841,  2842,  2843,  2845,  2847,
    2844,  2848,  2849,  2855,  2651,  2846,  2850,  2851,  2852,  2853,
    2854,  2856,  2718,  2857,  2683,  2859,  2858,  2860,  2861,  2862,
    2863,  2719,  2864,  2705,  2865,  2866,  2867,  2880,  2881,  2871,
    2872,  2874,  2875,  2878,  2873,  2879,  2884,  2883,  2885,  2886,
    2887,  2888,  2889,  2882,  2869,  2876,  2877,  2870,  2890,  2891,
    2868,  2892,  2894,  2893,  2895,  2720,  2896,  2897,  2898,  2899,
    2900,  2901,  2902,  2903,  2905,  2904,  2906,  2721,  2722,  2723,
    2907,  2908,  2909,  2698,  2910,  2724,  2725,  2911,  2914,  2912,
    2913,  2915,  2916,  2921,  2922,  2923,  2684,  2918,  2917,  2919,
    2920,  2726,  2727,  2728,  2924,  2925,  2926,  2927,  2929,  2928,
    2692,  2653,  2652,  2655,  2931,  2932,  2656,  2933,  2935,  2934,
    2700,  2657,  2936,  2937,  2939,  2938,  2729,  2730,  2658,  2687,
    2659,  2660,  2940,  2941,  2942,  2943,  2944,  2945,  2946,  2947,
    2948,  2949,  2950,  2951,  2731,  2732,  2953,  2954,  2955,  2957,
    2956,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2661,  2965,
    2693,  2966,  2967,  2662,  2969,  2968,  2663,  2970,  2971,  2972,
    2973,  2974,  2699,  2694,  2975,  2976,  2977,  2733,  2979,  2980,
    2981,  2695,  2982,  2983,  2984,  2664,  2985,  2986,  2734,  2706,
    2665,  2987,  2989,  2696,  2666,  2988,  2668,  2669,  2990,  2991,
    2992,  2667,  2993,  2670,  2994,  2995,  2997,  2996,  2998,  2999,
    3000,  3001,  2671,  3002,  3003,  2672,  3004,  2673,  3005,  3006,
    3007,  3008,  3010,  3009,  3011,  3012,  3013,  3014,  3015,  3016,
    3018,  3020,  3019,  3017,  3021,  3022,  2735,  3023,  2674,  2736,
    3028,  3029,  2737,  3024,  3025,  3026,  3027,  2697,  3030,  3031,
    3032,  2677,  3034,  3035,  3037,  3036,  2675,  2676,  3038,  3039,
    2681,  3040,  3041,  3046,  2738,  2739,  3042,  3043,  3055,  3044,
    3045,  3048,  3047,  3049,  3050,  2597,  2678,  3051,  3052,  2679,
    3053,  2680,  3054,  2740,  2557,  2568,   240,  2569,  2594,  2592,
    2596,  2590,  2591,  2595,  2589,  2593,   456,   129,     0,     0,
       0,     0,  2227,  2129,  2103,  2129,  2129,  2129,  2129,     0,
    2129,  2129,     0,  2132,  2129,  2129,     0,     0,     0,   447,
    2139,  2418,     0,  2438,  2439,  2433,  3137,  3138,  3132,   409,
       0,     0,     0,  2318,  2317,     0,     0,   317,   329,   332,
     325,   328,     0,   220,  1365,   409,   331,   332,     0,  1441,
    3058,     0,  2323,   332,     0,  2204,  2432,     0,     0,  2515,
    2512,  2204,  2389,  2391,     0,  2387,  1548,  1547,     0,  3304,
    2558,     0,  1341,  1373,  1299,  3305,  3306,     0,    76,    79,
    2356,   354,     0,     0,     0,   719,     0,     0,  1307,     0,
    3306,  3316,  2430,     0,   129,  1280,     0,   129,  2234,  2129,
    2129,  3381,  3382,     0,     0,     0,  3376,     0,  3383,     0,
    1436,     0,  1422,     1,     5,     0,     0,   719,  1083,  1084,
    1082,   719,   719,     0,     0,     0,     0,     0,  3339,  3332,
    3333,  3334,     0,  2085,  1952,  1437,  1436,  2032,  2036,  3320,
    3319,  3321,     0,     0,  2032,  1427,  2822,  2647,  2935,     0,
    2336,  2350,  2334,  2546,  1405,  1401,  1129,  1172,  1132,   224,
       0,     0,  1134,     0,     0,  1149,  2574,  2573,  2572,  1146,
    1145,  1144,  1142,     0,   580,   220,     0,  1257,     0,     0,
       0,  3340,  3339,     0,  1318,  2338,  2339,  2340,  2341,  2342,
    2343,  2346,     0,   246,   467,   470,     0,   459,   462,     0,
     130,   131,  1344,  1347,     0,   722,     0,   166,     0,  2231,
    2230,     0,  2229,  2207,     0,  2227,     0,  2127,     0,     0,
       0,     0,     0,   220,     0,  2319,   220,  2111,  2129,  2129,
     510,   484,  3202,  3217,  3218,  1489,  3214,  3219,     0,  3216,
    3208,     0,  3212,  3206,     0,  3238,  3210,  3215,  2814,  2644,
    2829,  2944,  2948,  2964,  2967,  2696,  3011,  3196,  3181,  3197,
       0,     0,  3200,  3204,     0,     0,  2140,  2141,  2142,  1253,
    2419,  2420,  2424,     0,  2442,     0,   422,     0,     0,     0,
       0,   411,   412,   478,     0,   418,     0,   409,   393,     0,
     392,   394,     0,   413,   388,   396,   395,   397,   398,   399,
     400,     0,   401,   402,   475,     0,   389,   390,   506,   391,
    2570,     0,  2571,  2599,  2601,  2598,  2600,  1360,     0,  2502,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1489,
    1489,  1489,  1486,     0,     0,     0,  2507,     0,     0,     0,
       0,  2498,     0,  2508,     0,     0,     0,  2500,  2501,  2554,
    2555,     0,     0,     0,     0,  2505,     0,     0,     0,     0,
       0,  2481,  1550,     0,  1486,     0,  2497,  2504,     0,  2489,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1486,  2480,  2499,  2506,     0,  1489,  1486,  1486,
       0,     0,     0,     0,     0,  2743,  2627,  2758,  2685,  2769,
    2771,     0,  2634,  2635,  2636,  2637,  2638,  2682,  2793,  2712,
    2794,  2647,  2716,  2833,  2840,  2858,  2860,  2719,  2899,  2901,
    2906,  2721,  2722,  2723,  2912,  2913,  2926,  2700,  2729,  2730,
    2942,  2949,  2974,  2733,  2979,  2984,  2987,  3007,  2736,  3028,
    3029,  2737,  3027,  2697,  3040,  3046,  3049,  3050,  2678,  2740,
       0,     0,     0,     0,  1549,     0,     0,  1788,  1434,  1624,
     863,  1495,  1507,  1523,     0,  1622,  1621,  1625,  1627,  1633,
    1542,  1654,  1593,  1594,  1596,  1715,  1595,  1600,  1601,     0,
    1764,  1602,     0,     0,  1599,  2494,  1598,  1597,  2495,  2496,
    1592,  2532,  2568,     0,  2556,   618,   617,     0,   344,   339,
     347,   341,   343,   342,   348,   349,   350,   345,   340,   346,
     333,     0,   318,     0,   326,  3317,     0,     0,   409,   513,
     351,  3202,  2744,  2948,  3170,     0,  3180,     0,  3331,  3326,
    3328,  3327,  3324,  3325,  3329,  1462,  3330,  1461,  1412,  1442,
    1459,  1460,     0,     0,     0,  1001,  3081,  3082,  2698,  2700,
    2699,  3083,  3024,  2626,     0,     0,  2563,     0,     0,  2564,
    2623,  2621,  2625,  2620,  2624,  2619,  2622,  3057,  3067,  3063,
       0,     0,     0,  2331,  1079,  1078,     0,     0,     0,  2273,
       0,  1001,  2331,  2274,     0,  2009,  2321,  2324,     0,  3085,
    2287,  1080,  3086,  2317,     0,  2259,  2275,  2236,  2280,   129,
    3087,     0,  2320,  2009,  2331,     0,  2252,     0,     0,     0,
       0,  1475,     0,   327,  3148,  2205,  1253,  2174,  1410,  2160,
     508,     0,     0,  2144,  2147,  2143,     0,  2388,   480,  3300,
       0,     0,     0,     0,  3309,  1835,  2100,     0,    80,    75,
       0,     0,     0,     0,  2551,  3150,    85,     0,     0,  3395,
      73,     0,  2406,     0,  2404,  2401,  2403,     0,  3309,     0,
    2429,  1287,  1287,     0,     0,  1279,  1281,  1282,  1287,  1287,
    2235,     0,     0,     0,  2488,  2486,  2487,  2559,  3378,  2485,
    2484,  3387,  3389,  3372,     0,  3375,  3374,  3384,  1425,  1424,
       6,    70,     0,   220,   220,   719,   168,   719,   140,   143,
     719,   719,   719,   152,   156,     0,   222,     0,     0,  3339,
    1440,     0,     0,  1452,  1438,  1848,  1439,  1850,  1847,  1846,
    1845,  1876,  1877,  1879,  1878,  1880,  1882,  1873,     0,     0,
    2098,     0,  2093,  1953,  1958,  1952,     0,     0,     0,     0,
    2031,  2009,  2040,  2033,  1404,  2029,     0,  1400,  1465,  1465,
    3323,  3322,  3318,  2034,  1423,  1431,  1429,  1430,  2035,  1421,
       0,  2348,  2548,     0,  2353,     0,  2032,  2036,  1017,     0,
     225,     0,  3337,  3338,  3336,  1489,  2575,  2578,  3335,  2579,
     225,  1143,     0,   581,  2130,     0,     0,     0,     0,     0,
       0,   583,   582,   519,     0,     0,  1261,  1262,  1256,  1258,
    1260,     0,     0,     0,     0,  2352,     0,   242,   248,   241,
       0,   409,     0,   457,   463,    86,     0,  1348,  2120,  2122,
     165,     0,     0,     0,  2208,     0,  1450,  1952,  2210,  2215,
    2221,  2225,  2228,  2105,     0,     0,  2108,  2114,  2113,  2107,
    2319,     0,  2117,   594,     0,     0,     0,  2118,  2101,     0,
       0,  3203,  3201,  3235,  3234,  3239,     0,  3236,  3232,     0,
    3195,  3240,  3225,  3272,  3229,  3272,  3272,  3226,  3233,  3272,
       0,  3231,  3230,     0,  3198,     0,     0,     0,  1254,  2147,
    2425,     0,  2417,     0,  1383,  2444,  2443,  2440,  1944,  3134,
    3139,   416,   423,     0,     0,  2912,     0,   428,   427,   426,
     279,   444,   416,   419,   436,     0,     0,   277,   410,     0,
     442,   445,   499,   495,   503,   497,   476,   472,     0,     0,
       0,     0,  1628,  1950,  1950,  1950,     0,     0,  1843,     0,
       0,     0,     0,  1950,     0,  1664,  1639,  1640,     0,  1665,
       0,     0,     0,     0,     0,     0,     0,     0,  1794,     0,
       0,     0,     0,     0,     0,     0,  2554,  2555,     0,     0,
       0,  1837,  1839,  2532,  2556,  1950,     0,  1950,     0,  1494,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1950,  1950,  1950,  1677,  2482,  2503,  1681,  1683,
    1682,  1950,  1950,     0,     0,     0,     0,     0,  1950,     0,
       0,     0,  2491,  2490,     0,     0,     0,     0,     0,     0,
       0,  2509,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2511,     0,     0,     0,  2510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1630,     0,  1629,  1631,
       0,  1434,   864,     0,     0,     0,     0,  1546,  1545,  1544,
    1543,     0,     0,     0,     0,  1552,     0,  1554,  1556,  1551,
    1553,  1555,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1632,     0,     0,     0,     0,     0,  2483,     0,
    1725,     0,   630,  2414,     0,     0,     0,   316,  1367,  2580,
       0,  1366,  1370,  3134,   492,  3201,     0,     0,     0,  3198,
    1476,  1458,     0,     0,  3059,  3061,  1000,     0,     0,  1003,
    1005,  2165,  2164,  1004,  1013,     0,  1002,     0,  3122,     0,
       0,  3107,     0,  3088,     0,  1009,  1011,  1010,  3102,  1008,
       0,     0,     0,  3072,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,  2302,     0,  1475,  1475,  2253,     0,
    2331,  2321,     0,  2331,  2327,  2286,     0,     0,   775,  2014,
    2010,  2279,  2325,  2326,  2331,     0,     0,  2331,     0,  2293,
    2321,  2331,  2248,     0,     0,  2240,  2245,  2241,     0,  2247,
    2246,  2249,  2237,  2238,     0,  2266,  2295,     0,  2278,  2285,
       0,  2265,  2272,     0,  2283,  2321,  2321,     0,  2331,  2331,
    2331,     0,  1476,     0,   490,  2513,  2516,  2520,  2524,  2147,
    2137,  2146,     0,  2390,   279,     0,     0,  1375,  1377,  1376,
    1393,  1301,  3308,     0,  3310,     0,  3312,     0,    77,     0,
       0,  2383,  2381,     0,     0,     0,  2375,  2377,  2380,  2376,
       0,     0,  2382,   129,     0,  2378,  2357,  2360,  2367,  1475,
    2358,     0,     0,   352,   355,   357,     0,   360,  1944,  3153,
    3152,     0,     0,     0,  1305,  1308,     0,  2411,  2408,   129,
       0,  2695,  3315,  3313,     0,  1275,  1291,  1273,  1285,  1286,
       0,     0,  1278,  1277,  3134,  3396,  3397,     0,     0,  3373,
    3390,  3371,     0,  3385,  3386,  3370,     7,     4,   146,     0,
       0,     0,   137,   719,   719,   132,     0,   154,  1476,  1476,
     719,   719,   719,     0,     0,  1846,  1876,  1877,  1879,     0,
    1878,     0,     0,  1944,     0,     0,  1868,  1892,     0,  1892,
    1870,  1871,     0,     0,     0,  1452,  1874,  2560,  2094,  2097,
       0,  2086,  2088,  2089,  2572,  2091,     0,     0,  1955,  1958,
    1467,  2022,  2023,     0,  2021,     0,  2011,  2015,  2020,  2018,
       0,  2002,  2039,  2030,  2078,  1466,  2037,  2038,  1428,  2337,
    2335,  2354,  2355,  2547,  1406,  1402,  1018,  1017,   713,   716,
     715,     0,     0,  1133,   223,  2577,     0,  1135,     0,  2319,
    1150,     0,     0,  2319,   530,  2319,   584,  2578,  3265,     0,
    3277,  3254,  3134,  1259,  3341,  3342,  1140,  1138,     0,  1319,
    1320,  1323,     0,   246,     0,   249,   251,   468,   409,     0,
       0,     0,  1358,     0,  1356,  1355,  1353,  1354,  1352,     0,
    1343,  1349,  1350,  2319,   522,  1873,     0,  2211,  2217,  2124,
    2126,  2546,     0,  1451,  2213,  2000,     0,     0,     0,  2223,
    2128,     0,     0,   594,  2110,  3193,   597,   596,  2115,   595,
    2166,  3252,  2109,  1263,     0,     0,   409,   482,   485,  3228,
    1490,     0,  3209,  3213,  3207,  3211,     0,  3191,     0,     0,
    3199,     0,     0,  3237,  3220,  3224,  3223,  3221,     0,  3222,
    3227,  3205,   408,   448,  2134,  2841,  3040,  2426,  2422,  2421,
       0,  2441,     0,  1945,  1946,     0,     0,  1948,  3136,  2041,
       0,  3133,   424,     0,   416,     0,     0,     0,   439,   275,
     420,   416,   429,   438,   489,   278,   414,     0,     0,   409,
     409,     0,   279,  3134,     0,  1951,     0,  1809,     0,     0,
       0,     0,     0,     0,  1608,     0,     0,     0,  1747,     0,
    1809,  1771,  2071,  2072,  2052,  2053,  2051,  2054,  1487,     0,
    2055,  2070,  1693,     0,     0,     0,  1769,  1433,  1416,     0,
       0,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,
    1929,  1930,  1931,  1933,  1938,  1934,  1935,  1936,  1937,  1932,
    1939,     0,  1919,     0,  1795,  1760,     0,     0,     0,     0,
     864,     0,     0,     0,     0,     0,     0,     0,  1950,     0,
       0,  1950,     0,     0,     0,     0,  1770,     0,     0,     0,
    1768,     0,     0,  1767,  1652,     0,     0,  1950,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1584,     0,     0,
       0,  1950,     0,     0,     0,     0,     0,     0,     0,     0,
    1577,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1942,  1940,  1943,  1941,     0,     0,  1835,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,     0,     0,     0,
    2537,     0,  1049,     0,     0,     0,     0,  1623,     0,     0,
       0,     0,  3088,  1789,  1791,  1492,  1491,  1493,  1504,  1498,
    1502,  1496,  1500,     0,  1557,  2750,  1505,     0,     0,     0,
    1508,  1517,  1521,     0,     0,     0,     0,     0,  1539,  1540,
    1528,  1526,  1527,  1524,  1525,     0,  1530,     0,  1529,  1536,
    1537,  1538,  1541,  1626,  1012,  1634,  1970,  1762,  1763,  1787,
    1974,     0,  2533,  1476,  1580,  1579,  1581,  1582,  1583,   631,
       0,   625,   628,   642,     0,     0,  2413,     0,  2712,  2736,
    2737,   334,   337,   336,   338,     0,     0,     0,     0,     0,
       0,     0,     0,  3256,  3178,     0,     0,     0,     0,  1472,
    1413,  1471,     0,     0,     0,     0,     0,     0,  3105,     0,
       0,  3104,  3103,     0,  3124,     0,     0,  3109,  3130,  3131,
    3128,  3129,  3127,  3108,     0,     0,  3066,  3110,  3111,  3114,
       0,     0,     0,     0,     0,  3095,     0,  3024,  3068,  3069,
    3074,  3064,  2294,     0,     0,  2297,  2290,  2301,  2760,  2299,
    2311,  2298,  2292,  2303,  2291,     0,     0,  2308,  2304,  2331,
       0,  2331,  2306,     0,  2329,  2316,  2315,  2314,  2263,  2262,
    2256,  2322,  2309,  2305,   220,  2331,  2261,  2260,  2242,  2243,
    2244,     0,  2009,     0,  2327,  2296,  2321,     0,  2331,  2331,
    2312,  2313,  2282,  2284,  2193,     0,  1873,     0,     0,  2179,
    2172,  2159,   409,     0,     0,  2518,  2145,     0,  2148,  1873,
     275,     0,     0,     0,   615,  1393,  1379,  1395,  1303,  1302,
    1300,  3307,  3311,  1836,    79,  2187,  2185,    81,  2184,  2186,
      82,  2392,  2369,  2368,  2370,  2374,   129,  2379,  2371,     0,
    2384,  2385,   365,     0,   361,     0,     0,  3151,     0,   720,
       0,    74,     0,  1309,  2041,  2407,  2409,  2402,  3314,     0,
    1276,  1293,  1292,  1288,  1289,  1294,  1284,  1283,  2233,  3379,
    3388,  3392,  3377,   711,  3189,  3277,   189,     0,     0,     0,
       0,   135,     0,   719,   153,   157,   719,     0,     0,     0,
     719,     0,  1889,  1881,  1883,  1884,  1885,     0,  1888,     0,
    1455,     0,  1443,  1443,  1453,  1891,  1872,  1869,  1893,     0,
    1892,  1892,     0,     0,  1852,  1851,     0,  1944,  1006,  2090,
       0,     0,  1954,     0,  1956,  1965,  1955,  1469,  2041,  1463,
       0,  2490,     0,     0,     0,     0,     0,     0,     0,   714,
    2166,  2166,     0,     0,     0,     0,     0,     0,     0,     0,
     226,   235,  2576,     0,     0,   528,   529,  2166,   527,   570,
     571,   574,   575,   576,     0,     0,   577,  2166,  2166,   524,
     550,   551,   554,   555,   556,   557,   558,   520,     0,   525,
       0,     0,     0,  3289,  1127,  1163,  3343,  1136,     0,     0,
    1322,   244,   243,   247,     0,     0,   455,   464,   458,   460,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,    88,   109,     0,  1345,  1357,
    2121,  1351,  2166,  2166,  2166,  2166,   526,   559,   560,   563,
     564,   565,   566,   569,   567,   568,     0,  2319,  2212,  1443,
       0,     0,     0,  2549,     0,  2025,  2001,  2222,     0,  2226,
    2225,     0,  2106,  2116,     0,  2167,     0,     0,  1265,  1264,
    2112,  2119,  3134,   409,   483,   429,  3276,     0,  3275,     0,
       0,  3188,     0,  3248,  3251,  2546,     0,     0,     0,     0,
     409,     0,  2423,  2427,  1384,  1386,  1387,  1385,  1393,     0,
    2561,  1949,  2562,  2586,  2584,  2588,  2582,  2583,  2587,  2581,
    2585,     0,  3142,  3143,  3141,  2046,  2042,     0,  3135,  3140,
     417,   425,   440,   443,     0,     0,   409,     0,   421,   430,
     434,     0,   446,   500,   473,   473,   473,   275,  1361,     0,
    1742,     0,  1743,  1744,     0,  1609,  1844,     0,     0,     0,
    1637,     0,     0,     0,  1746,     0,  1488,     0,     0,  1612,
    1604,  1417,     0,  1773,     0,  1778,     0,  1776,     0,     0,
       0,     0,     0,     0,  1838,     0,  1840,  2533,     0,  1752,
    1783,     0,  1750,     0,  1772,     0,  1784,  1785,     0,     0,
       0,  1756,  1754,     0,  1758,  1755,  1757,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,     0,     0,  1655,     0,
    1689,     0,  1740,  1690,  1691,  1692,  2536,     0,  1686,     0,
    1687,     0,     0,     0,     0,     0,  1641,  1642,     0,  1717,
       0,  1643,  1697,     0,  1617,  1718,  1699,  1648,  1649,  1719,
    1720,  1721,  1614,  1615,  1701,  1702,     0,  1723,  1616,  1703,
    1706,     0,  1651,  2041,     0,  1635,     0,     0,     0,  1653,
    1680,     0,     0,     0,  1613,     0,  1709,     0,     0,     0,
    2041,     0,     0,  1657,     0,     0,   865,  1435,  1605,  2534,
       0,     0,  1499,  1503,  1497,  1501,     0,     0,     0,     0,
    1516,     0,     0,  1509,  1519,  1522,     0,     0,  1972,     0,
       0,  1781,  1833,     0,     0,     0,  1736,  1737,     0,     0,
     624,   623,     0,   627,   703,     0,   644,   632,   621,  2415,
       0,     0,  1368,  1371,     0,     0,     0,  3179,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1477,  2532,     0,
       0,  3092,  3062,     0,     0,     0,  1016,  1015,  1014,  3123,
       0,     0,  3116,  3117,     0,     0,     0,  3089,  3090,  3091,
       0,  2609,  2565,  2567,     0,  2566,  2607,  2605,  2608,  2603,
    2604,  2602,  2606,  3098,     0,  3071,  3072,  3073,     0,     0,
    2289,  2300,  2332,  2333,  2257,  2310,  2307,  2328,  2041,  2267,
    2288,  2258,     0,  2281,  2239,  2329,  1952,  2321,  2254,  2255,
       0,  1452,  1477,  2175,  1476,  2176,   409,  2517,     0,  2522,
       0,  2154,     0,  2151,  2158,   608,  2138,     0,  2149,  2123,
     409,  1342,  1382,  1374,  1381,  1378,  1393,  1391,  1380,  1075,
    1074,     0,  1394,    78,     0,     0,  2372,  2373,  2366,  2386,
    2361,     0,   356,   366,   358,   362,   363,   364,   359,  2830,
    2912,     0,  1952,  3155,  3394,  1316,  1314,  1313,  1315,  1304,
    1310,  1311,  2412,  2410,  2405,  2431,  1291,     0,  1274,  2041,
       0,  3391,   147,   712,     0,   164,  3289,     0,  1099,     0,
       0,   133,   169,  3367,   155,  3357,     0,   148,     0,   224,
       0,     0,  1886,  1887,  1849,  1443,  1445,  1444,     0,     0,
    1447,     0,     0,     0,     0,  1857,     0,  1853,  1855,     0,
    1917,  1909,     0,  2095,  2087,  2092,  2531,  1962,  2006,     0,
       0,  1414,  1965,  1468,  2024,  2013,     0,  2017,  2016,  2019,
    1467,  2003,  2006,  1476,     0,     0,  1131,     0,     0,     0,
     229,   232,   230,   231,   579,   578,     0,  2319,   572,  2166,
    2166,   183,  2166,  2166,   182,   184,     0,   178,   175,   185,
    2166,  1151,   171,     0,     0,     0,     0,  2041,     0,     0,
       0,   191,     0,     0,  2319,   552,   531,   532,   535,   536,
     537,     0,  3259,  3258,     0,  3279,     0,     0,  3281,     0,
    3280,  3278,  3244,  3255,     0,  1158,  1017,     0,  1165,  1167,
       0,     0,  3343,  1321,     0,   246,   250,   409,     0,   461,
       0,     0,  2041,     0,  2041,  2041,     0,     0,  2041,     0,
    2041,     0,     0,     0,     0,     0,     0,     0,  2041,     0,
       0,     0,     0,  2041,     0,  1359,     0,     0,     0,     0,
    2319,   561,     0,  2166,   521,   538,   539,   542,   543,   544,
     545,   546,   549,   547,   548,  2209,  2125,  2225,     0,  2547,
    1475,     0,  2219,  1952,     0,  2224,  3134,  3194,   593,   774,
    3253,  1263,     0,   304,   432,   487,  3273,     0,  3293,     0,
       0,     0,     0,     0,     0,     0,     0,   409,  2188,     0,
    1393,  1397,  2434,  3145,  3146,  3144,  2049,  2050,  2047,  2045,
    2048,   441,   308,   310,   307,   309,  2618,     0,   295,   281,
     297,     0,   384,   290,   382,   383,  2615,  2613,  2617,  2611,
    2612,  2616,  2610,  2614,   479,     0,   280,     0,   437,   429,
       0,   494,   496,   474,   504,   498,   409,     0,  1810,  1841,
       0,   967,   967,   953,   971,  1827,     0,  1821,  1824,     0,
     967,  1829,   967,  1822,   967,     0,     0,  1819,  1820,     0,
       0,     0,  1748,  1745,     0,     0,     0,  1798,     0,     0,
       0,     0,     0,  1533,     0,  1731,     0,  1753,  1751,     0,
       0,     0,     0,     0,  1759,     0,  1661,  1659,  1590,     0,
    1588,     0,  1589,     0,  1591,     0,     0,  1741,     0,  1559,
    1578,     0,     0,     0,     0,     0,     0,  1836,     0,     0,
    2057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2538,     0,     0,     0,  1038,  1044,  1047,  1048,
    1050,  1042,     0,  1711,     0,     0,     0,  1792,  1790,     0,
    1514,  1510,     0,  1518,     0,     0,     0,  1532,  1531,  1974,
    1973,     0,  1780,     0,     0,  1834,  2535,  1477,  1726,  1476,
     634,     0,   652,   626,  2041,   629,     0,   643,     0,   655,
       0,     0,     0,   335,     0,  1372,     0,     0,  3177,  3257,
       0,     0,     0,     0,     0,  1470,  1478,  1473,     0,     0,
       0,  3060,  3106,  3097,     0,     0,     0,     0,  3121,  3115,
    3112,  3113,     0,     0,     0,  3096,  3070,  3076,  3075,  3078,
    3080,  2277,  2276,     0,  2330,  2009,  2250,  2269,  2271,  2331,
    2195,  2198,     0,  1944,  2183,     0,     0,  2177,  2181,     0,
    2521,     0,     0,     0,  2155,  2157,  2526,  2525,  2537,     0,
       0,  2150,   481,     0,  1911,    83,     0,  2364,     0,  2359,
    2362,     0,     0,  3166,  3167,  3159,  3162,  3160,  3161,  3165,
    3168,  3169,  3156,  3163,  2009,     0,  1306,  1312,  1290,     0,
    1297,  1295,  3380,  3393,     0,  1158,     0,     0,     0,     0,
       0,     0,   723,   723,   170,     0,     0,   200,  3343,   160,
       0,   158,   150,  1454,  1446,  1448,  1443,  1443,     0,  1845,
       0,     0,     0,  1845,     0,     0,   615,     0,  1890,  1906,
    1007,  2448,  1963,  1964,     0,  1959,  2007,  2008,  1961,  1957,
       0,  1966,  1968,  1415,  2012,  1464,     0,  2005,     0,     0,
    2081,  2083,   773,   772,   234,   233,   238,   239,  2067,  2068,
    2065,  2066,   585,   598,  2069,   599,   573,  2041,  2041,  2171,
    2170,  2041,  2041,   177,   174,  2169,  2168,  2041,  2041,   172,
     195,   194,   196,   197,   199,   198,   193,  1147,     0,   586,
     587,   553,     0,   533,  3262,     0,  3269,  3264,  3267,  3247,
    3246,  3245,  3242,     0,  2041,  2041,  2041,     0,  2041,  3288,
    3290,     0,     0,  1148,  1251,  1251,     0,  1251,     0,     0,
    1251,     0,  2166,     0,     0,  2166,   615,  1269,  2166,  2166,
    2166,  2166,     0,  2166,  2166,  2166,  2166,     0,  2166,  2166,
       0,  2166,     0,     0,     0,  2166,     0,  1234,     0,  2166,
    2166,  2166,  2166,  1251,  2166,  2166,     0,     0,     0,     0,
    2166,  2166,     0,     0,  2166,  2166,     0,  1179,  1233,   725,
     768,   752,   753,  1128,  1178,  1180,  1192,   611,     0,  1210,
    1236,  1237,  1235,     0,  3302,     0,     0,   205,  3345,     0,
    3347,     0,  1325,     0,  1324,   245,   409,   465,  2041,  2041,
     102,  2041,    94,    95,    90,   122,   123,    92,    93,    98,
      97,    99,   100,   103,   104,   101,    96,    91,   126,   128,
     127,   105,   124,   125,    89,   592,   591,   590,   589,   562,
       0,     0,  2319,   540,     0,  1952,  2550,     0,     0,  2026,
    1476,  2214,  2216,  2104,  2102,   511,   305,     0,     0,   429,
    3274,     0,  3187,  3192,     0,  3250,  3249,  3277,  3277,  3277,
    3277,   451,     0,  2135,  1388,  1393,  1397,     0,  1389,  2445,
     947,   969,   967,   984,   933,   953,   949,   953,   943,   984,
     890,   890,   984,   946,   890,   953,   948,     0,   945,   984,
     944,   890,     0,   937,   969,   884,   885,   890,   967,   903,
       0,   953,   926,   925,   984,   929,   930,   928,   932,     0,
     934,   953,   939,   927,   931,     0,     0,   967,   967,   967,
       0,     0,   967,   386,   872,   875,   877,   876,   878,   879,
     953,   969,   969,     0,     0,   967,   971,     0,     0,   298,
       0,   276,   431,   435,   409,   473,     0,  1842,     0,   968,
    1811,  1812,     0,  1826,   955,   954,     0,   972,  1828,     0,
    1825,  1814,  1831,  1818,  1823,  1830,  1816,  1607,  1638,  1611,
    1610,     0,     0,     0,  1670,     0,  1796,  1779,  1777,     0,
       0,  1645,     0,  1647,     0,     0,  1733,  2535,  1700,  1775,
    1673,  1704,  1650,     0,     0,     0,  1587,  1585,  1586,     0,
    1662,  1684,     0,  1576,  1685,     0,  1716,  1668,     0,  1695,
       0,  1671,  1698,  1722,  1603,  2059,  2058,  2056,  1618,  2041,
       0,  1674,  1636,     0,     0,  1708,  2539,  2540,     0,  1710,
       0,     0,  1049,  1035,  1036,  1037,     0,  1039,  1041,  1043,
       0,  2041,  1724,  1535,  1534,     0,  1506,     0,  1515,  1512,
       0,  1520,  1976,  1975,     0,     0,  1727,  1833,  1478,  1738,
       0,   635,   636,   638,   640,   706,     0,   630,     0,   619,
       0,   634,   622,  1369,   493,     0,     0,  3174,  3173,  3172,
    3171,     0,  1474,  1482,  1481,  2529,  2533,  3094,  3093,  3126,
    3125,  3119,  3118,  3120,     0,     0,  3099,     0,     0,  2063,
    2064,  2062,  2060,  2061,  2268,  2009,  2264,     0,  1952,     0,
    1909,  1477,  2173,     0,   491,  2523,     0,  2153,     0,     0,
       0,  2152,  2162,     0,     0,  1914,     0,  1915,  1912,  1913,
    2041,     0,     0,   374,   369,   377,   371,   373,   372,   378,
     379,   380,   381,   375,   370,   376,   368,   367,     0,  3154,
    1317,     0,     0,  3190,   163,     0,  1115,  1117,  1116,  1100,
    1101,     0,   141,   144,   823,     0,     0,   134,   603,   611,
     724,   727,   600,   136,   273,   227,     0,     0,     0,   253,
     788,   789,   787,   786,     0,   253,  3343,  1457,  1456,  1858,
       0,  1862,  1867,  1863,     0,  1854,     0,  1875,  1918,  1910,
       0,     0,  2456,  2006,     0,     0,  2006,  1477,  2079,  1476,
     176,   181,   180,   173,   186,   179,   192,   534,  3263,  3261,
    3260,     0,  3268,     0,  3243,  3284,  3282,  3283,  3286,     0,
       0,  3285,  3287,  1152,  1153,  1159,  1154,  1122,   719,  1252,
     717,     0,  1214,  1218,  1215,     0,   824,   719,  1076,  1076,
     717,  2127,  1362,  2127,     0,     0,  2127,     0,  2129,  2127,
       0,     0,  2127,  2127,  2166,     0,  1362,     0,  2041,   613,
    1272,  1270,  1271,     0,  2041,  2041,  2041,   750,   771,     0,
    2041,  2041,  2041,  1362,     0,     0,  2166,  2041,  1227,  1174,
    1228,     0,     0,  1175,     0,  2041,  2041,  2041,  2127,  2041,
       0,  1362,  1194,  1362,  1362,     0,  2041,   758,   759,   757,
    2041,  2041,     0,   726,  1017,  1176,   612,  1177,   823,     0,
    1266,   799,   826,  2542,     0,  3303,     0,     0,     0,  1164,
       0,   208,   206,   216,  3344,     0,  1139,     0,  3347,  1327,
    1328,     0,     0,     0,   115,   117,     0,   119,   121,     0,
     111,   113,   523,   588,   541,  2225,  2218,     0,  2027,     0,
    2220,     0,   488,   433,   486,     0,  3277,  3291,  3291,  3291,
    3291,   409,   447,   450,  2189,  1390,  1398,  2447,  2446,     0,
     970,   896,   984,   982,   984,   910,   985,   957,   950,   957,
     913,  1027,     0,  1020,  1025,  1021,   919,  1023,     0,  1031,
    1030,   891,   933,   984,   921,     0,   890,   912,   918,   957,
       0,   907,   916,   984,   883,   920,   906,     0,   957,   922,
     935,   938,   940,   942,   957,   984,     0,     0,   386,   890,
     905,   904,     0,   890,   957,     0,   291,   951,   936,  1023,
    1031,   890,   984,   957,   957,   300,  2041,   302,   385,   409,
     477,     0,     0,     0,     0,  1023,     0,     0,  1832,  1023,
    1023,  1749,     0,     0,     0,     0,  1802,     0,     0,     0,
       0,     0,  1606,     0,  1729,     0,  1660,  1658,     0,   953,
    1566,  1568,  1564,  1567,     0,   967,  1570,     0,   934,   967,
    1573,  1575,  1560,  1561,  1562,  1563,     0,     0,     0,  2077,
    2076,  2075,     0,     0,     0,     0,  2541,  1033,  1713,     0,
    1046,  1040,  1038,  1045,     0,  1793,  1511,     0,     0,  1978,
       0,  1782,     0,  1739,   639,     0,     0,     0,   659,     0,
     657,   633,     0,  3176,  3175,  1480,  1479,     0,     0,     0,
    3077,  3079,  2270,  2197,  2000,  2199,  2200,  2192,  2182,  2180,
       0,  2156,  2527,  2538,   609,     0,     0,  1195,     0,  1196,
    1207,  1209,  1396,     0,  2397,     0,  2395,  2365,  2398,     0,
    1296,  1298,     0,   138,     0,     0,  1122,  2657,     0,   792,
     794,   795,   796,   797,     0,   604,  2445,   610,  1017,   728,
     723,   269,  3368,   514,   515,     0,     0,  3347,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
    1898,     0,  1904,  1908,     0,     0,     0,     0,  2449,  2451,
       0,  2096,  1960,  1969,  1967,  2004,  2084,  2082,     0,  3270,
    3266,  2044,  2043,     0,  1156,     0,  1155,  1160,     0,   825,
    1123,  1362,     0,     0,     0,  1238,     0,     0,     0,  1076,
     815,   719,  1122,  1077,   719,   719,  1212,     0,     0,     0,
    1186,     0,     0,  2127,     0,  1240,     0,  1239,     0,     0,
       0,     0,  1249,  1250,     0,  1996,  1998,  2006,  2074,  2073,
     747,     0,  1231,   740,   739,   742,   741,   744,   743,     0,
    1247,  1248,   736,   733,   745,     0,   735,   760,     0,   748,
     730,     0,   784,   785,   783,   754,   761,   731,   732,     0,
     738,   737,   734,     0,  1202,     0,   776,   781,   779,   778,
     777,   782,   780,   749,   767,   746,   762,  1191,  1251,  1251,
    1211,     0,   790,  2545,     0,  1268,  1213,     0,   800,     0,
       0,   766,   765,   763,   764,   215,   204,     0,     0,  1166,
    1168,     0,     0,  1169,  3346,  3349,  1137,  1333,     0,   409,
     107,  2041,   108,  2041,   106,  2041,     0,  2028,   306,     0,
    3294,  3291,     0,  3185,  3184,  3183,  3182,   409,   452,     0,
       0,   908,   986,     0,   909,   959,   960,   958,   886,   882,
    1028,  1022,   893,  1024,  1019,  1032,  1029,  1026,   982,   892,
     914,   915,   888,     0,  1124,   900,     0,   889,   941,   887,
     901,     0,     0,   287,     0,   285,   294,   917,   386,   282,
     898,   902,   387,     0,   911,   894,   895,   897,  1031,   880,
     881,  2041,   296,   315,   314,     0,     0,     0,   965,   963,
     966,   964,  1813,     0,  1815,  1817,  1666,  1667,  1799,  2006,
    1797,  1804,     0,     0,  1803,  1694,     0,  1646,     0,  1730,
       0,  1705,  1663,  1569,  1565,  1572,   935,  1571,  1023,  1688,
    1669,  1696,  1619,  2041,  1675,  1678,  1679,     0,  1712,  2041,
    1513,     0,  1981,  1980,     0,     0,  2006,  1728,   637,   707,
     632,     0,     0,   656,     0,   620,  2530,  3101,  3100,  2025,
    2519,     0,  2161,  2163,  1392,     0,  1916,  2393,  2041,     0,
    2363,     0,     0,     0,     0,     0,     0,   798,   791,   823,
       0,   602,   709,   729,   611,   272,   270,   271,     0,   265,
     267,     0,   236,   228,     0,   409,   518,   516,   517,     0,
       0,   149,     0,   254,     0,   256,   257,   162,     0,  3347,
    1859,     0,  1864,     0,  1856,  1894,  1894,  1905,     0,     0,
       0,     0,  2450,     0,     0,  2457,  2459,     0,  1154,     0,
       0,     0,  1197,     0,     0,  1216,     0,   719,  1072,  1073,
    1122,  1097,  2542,  1122,  1122,     0,  1185,     0,  1348,  1013,
    1223,     0,  1181,     0,  1225,  1226,  1263,   756,  1183,     0,
    1999,   614,  2385,  1190,   755,     0,  1266,  1182,  1204,  1188,
    1217,  1267,  1054,   969,   884,   885,   890,   967,   903,  2714,
     953,   926,   925,   984,   929,   930,   928,   932,  2724,   934,
     953,   939,   927,   931,  2732,   830,   967,   967,   967,  2739,
     967,     0,   818,   828,   873,  2544,   202,   207,   217,   218,
    1141,     0,  3348,     0,  1334,  1330,  1331,  1326,   409,   116,
     120,   112,     0,  3186,     0,  3298,  3292,  3296,     0,     0,
     983,   961,   962,   987,  1023,     0,  1023,   386,   286,   289,
       0,   292,     0,     0,   899,   324,   323,   321,   409,   311,
     319,   313,     0,   320,     0,   304,   501,     0,     0,  1801,
    1761,  1805,  1806,     0,  1732,  1734,  1574,     0,  1034,     0,
    1977,  1971,     0,     0,     0,     0,     0,     0,  1990,  1982,
       0,  1786,  2041,   705,     0,     0,   645,   662,   661,   658,
    2196,  2528,  1208,  2396,     0,  3164,     0,     0,     0,  2006,
    1120,     0,     0,   793,   605,   710,     0,  2445,   274,   269,
     268,   237,   187,  1476,   213,  3363,   227,     0,     0,     0,
     258,   227,   151,     0,     0,     0,  1902,  1900,  2454,  2455,
       0,  2452,     0,     0,  2458,     0,  1161,  1157,  1162,     0,
    1199,     0,   718,     0,  1122,  1097,  2542,     0,   801,     0,
     805,   807,     0,     0,  1266,  1187,  1232,  1224,  1241,  1222,
    1362,  1997,     0,     0,  1221,  1203,  1205,  1309,     0,  1058,
     832,     0,   827,   819,   840,     0,   209,  1170,   409,     0,
       0,     0,  1329,     0,  1336,     0,  3297,  3295,  2190,  1873,
     924,  1125,   923,   293,   288,   283,   952,  2041,   301,   322,
     303,   299,   473,   956,  2006,     0,     0,  1644,  1620,  1714,
       0,  1987,     0,     0,  1985,  1984,     0,  1979,  1986,   708,
       0,     0,   653,   669,   665,     0,   667,   668,   690,  2399,
       0,     0,  3134,     0,  1119,     0,  3134,     0,   769,   601,
     266,   188,  3369,  3358,   205,   214,     0,  3365,   161,   255,
       0,   263,     0,   159,  1861,  1866,     0,  1895,     0,     0,
       0,  2453,  2461,  2460,  3271,     0,     0,     0,  1198,     0,
     820,   813,   809,     0,  1098,     0,   803,     0,     0,  1230,
       0,  1220,  1184,   751,   615,     0,  1189,     0,  1057,     0,
    1062,  1052,   858,   998,     0,   861,     0,   831,   833,   991,
     992,   835,     0,     0,     0,     0,   874,     0,     0,   975,
       0,   978,     0,     0,   829,     0,   841,   974,   981,  2543,
       0,   211,   187,  3350,     0,     0,  1335,  1340,     0,  1337,
    1339,  1449,     0,  2435,     0,   312,   502,  1800,  1808,  1807,
    1988,     0,  1989,  1992,     0,     0,  1993,     0,   649,   651,
     641,     0,   646,     0,   663,     0,  2166,  2166,     0,  2166,
    2166,  2166,  2166,   683,   691,   693,     0,     0,  3134,  1087,
    2006,     0,  1089,     0,   607,   770,     0,   216,  3364,     0,
       0,     0,  1897,  1896,  1911,     0,  1219,  1201,     0,     0,
       0,     0,   811,     0,     0,     0,     0,     0,     0,     0,
     870,   871,  1229,   867,   868,   869,     0,  1193,     0,  1055,
       0,  1059,  1060,  1061,     0,  1053,   859,   860,   999,   834,
     997,   990,   989,     0,   980,   976,     0,   849,     0,     0,
     982,   973,   842,   210,     0,   203,   219,  3351,  3352,  1332,
       0,  2191,  2202,     0,  1006,   284,  1983,  1991,  1995,  1994,
     647,     0,   654,   676,   666,   672,     0,  2166,     0,     0,
    2166,     0,     0,     0,     0,     0,   660,   692,  2166,   190,
    1085,     0,     0,  2166,  1242,  1088,  1113,  1095,     0,  1118,
    1121,  1242,  1090,  1112,  1093,     0,     0,     0,   187,   261,
       0,     0,     0,  1200,   816,     0,     0,     0,     0,     0,
       0,     0,  2493,  2492,     0,     0,  1056,     0,     0,   996,
     995,   993,   994,  1483,   979,     0,   844,   988,   843,   212,
    1338,     0,     0,  2436,   653,   650,   676,     0,   674,     0,
     670,   664,   671,     0,   702,   696,     0,   698,   699,   697,
     694,   687,     0,   685,     0,     0,     0,  1242,  1086,  1111,
    1110,  1091,     0,  1105,  2041,   142,  1244,  1243,  1096,     0,
     145,  1094,     0,  1476,   218,  3366,     0,   259,  1903,  1901,
       0,     0,     0,  1085,     0,  1087,  1089,   866,     0,  1068,
    1067,     0,     0,  1064,  1063,     0,   977,   836,   836,   850,
    2201,  2203,  2462,   648,   673,     0,   681,   677,   679,   682,
     701,   700,     0,   684,     0,   695,  1102,  1103,   139,  1092,
    1114,  1104,  1246,  1245,  1109,  1108,  1106,  1107,   817,  3359,
     201,   262,     0,     0,  1085,     0,   802,  1085,   806,   808,
    1206,  1071,  1069,  1070,     0,     0,  1484,     0,   847,   837,
     839,   846,   852,   853,   851,   854,     0,  2448,   675,     0,
       0,   690,   689,   686,     0,   260,   814,   810,  1085,   804,
       0,     0,  1485,   838,   845,   855,   857,     0,  2456,   680,
     678,   688,     0,   812,  1066,  1065,   856,     0,  2464,  3360,
    2463,     0,  2468,  3355,     0,     0,  2475,  3353,  3354,     0,
    3361,  2466,  2467,  2465,  2470,     0,     0,  2472,  2473,     0,
    2437,  3356,   409,  2474,  2469,     0,  2476,  2478,     0,   187,
    2471,     0,  1476,  3362,  2477,     0,  1477,  2479
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5252, -5252, -5252, -5252,  2339,  4527, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  2864, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  2056, -5252,   546, -5252,   553, -5252,   557, -3091,  -621,
    4225, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  2219, -2557, -4161, -5252, -5252,    53,  1634, -5252, -5252,
     385, -5252,    43, -5252, -5252, -5252, -4314,   -89,  -274, -5252,
      23,  4709,    34,  4064,  1160, -4528, -5252, -5252, -5252, -5252,
   -5252, -5252, -1960, -5252, -5252,  1146, -5252,   498, -5252, -3683,
   -5252, -5252,   188, -5252, -5252, -5252, -2140,  -646, -1422, -5252,
     525, -5252,   262, -5252,   181, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,   246, -5252, -5252, -5252,   101,   894, -4424,
   -5252, -5252, -5252, -5252,   547, -5252,  2055, -5252, -1778,  3738,
   -5252, -5252, -5252, -5252, -5252,  2880, -2469, -5252, -5252, -5252,
    1774, -5252, -2808, -5252, -4336,   -72,  -899,    27, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -1190, -5252, -5252, -5252, -5252,
   -5252, -5252, -2700,  1999, -5252,  1500, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252,   978, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,  2734, -5252, -5252,  4664,
   -5252, -5252, -5252, -5252,  1408, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  3307, -5252, -5252,  3309,  3308, -5252,  3306,
   -5252, -2829, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252,  4049, -5252, -5252, -5252, -3038, -5252,
   -5252, -3110,  3446, -5252, -2495, -5252, -5252, -2541, -5252, -5252,
   -2393,  1128, -5252, -5252,  2120,  -267, -5252, -1831, -2609, -2591,
   -5252, -5252, -5252, -2667, -2659,  -782,  3392, -1369, -2253, -5252,
   -5252, -5252,   217,   221,   439,  1591,  2150, -5252, -3677, -5252,
   -5252,   689, -5252, -5252, -5252, -5252, -5252,  1306,   482,  1304,
   -5252,   851,  3086, -2738, -5252, -5252, -5252, -5252, -5252, -5252,
    -113,   254,  -184, -5252, -4976,   487, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -3628, -5252, -5252, -5252,  -307, -5252,
   -5252,  -261, -5252, -5252,  -306, -5252,   -20, -5252, -5252, -5252,
   -5252, -5252,  2893, -1911,  1137,  -676, -5252, -3598,  1619, -3956,
   -3206, -5252, -5252,   113, -1301, -1297,  -195, -5252, -5252, -5252,
   -5252, -5252, -5252,  1072,   475,  1620, -3708, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -3703, -3700,   751, -5252, -4768, -5252,
   -5252, -5252, -4440, -5252, -5252, -5252, -5252, -5252, -5252,  -232,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5251, -5252, -5252,
     -42,   -70, -5252,    55, -3742, -5252, -4551, -5252,   112, -5252,
   -5252, -5252, -5252, -5252, -2194,  1399,  1523, -5252, -5252, -5252,
   -5252, -3404, -2972, -1313, -2958, -3070, -1531,  1464,   -67, -4937,
   -4698,  -534, -3743, -5252, -5252, -3181, -3445, -5252,  -662, -2818,
   -3176,   -78, -5252, -5252, -1699,   418, -3178, -5252,  1017,  1010,
   -1371, -1086, -3391,  1966, -5252, -5252,  1373, -5252, -1348,  1372,
   -5252, -5252, -5252,  1383, -5252,  -249, -5252, -5252, -5252, -5252,
   -3423, -5252, -2496, -4007, -5252, -5252,  5456,  5458, -3332,  -196,
    -193, -5252, -5252, -5252,   235, -5252, -5252, -3227,  -164,   -97,
     -88, -3644, -3189,   153, -2892,  1011, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,   461,   466,
    1840, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  1659,
   -2429, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -4382, -4184,
   -5252, -5252,  1123, -3489, -3287, -3278, -3652,  4332, -5252, -5252,
   -5252, -5252,  4150, -3345, -4629, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252,  3640,  1612, -5252, -5252,  2354, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,   238,  2363, -5252, -5252,
   -5252, -5252, -5252,  2840, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252,   -34, -5252, -5252, -5252, -5252, -5252,   463,  3500,
   -5252, -5252, -5252, -5252,    -8, -5252, -5252, -5252, -5252,  3147,
   -5252, -5252, -5252, -5252,  3020, -5252, -5252, -5252, -5252, -5252,
   -5252,  2147, -5252,  2739, -5252, -2464, -5252, -5252,  1592,  -156,
   -5252, -5252,   -69, -5252, -5252, -5252, -5252, -5252,    38, -5252,
   -5252, -5252,  5450, -1537,     7,   -65, -5252, -5252,     4, -5252,
   -5252,  4213,  -512,  2558,  -678,  4842, -5252, -5252, -5252, -5252,
   -2524,  2441, -5252,  4262, -5252, -5252,  4441,  1510,  4230,  2321,
    1632,  2520, -1698,  -161, -3035,  1416, -5252,  1716,   670, 11066,
   -5252, -1458, -1550, -5252, -5252,   -43, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252,  2632,  2641, -5252, -5252,  3929,
   -2893, -5252, -5252,  -843, -5252, -2370, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,  1997, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252,  3884, -1636, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  1534, -5252, -2792, -5252, -5252, -5252, -5252,
   -5252,  1424,  -652, -5252,  4031, -5252,  4066, -1203, -1771,  3632,
   -5252,  4285, -5252, -5252, -5252, -5252, -5252, -5252,  3645, -5252,
   -2034, -5252, -2444,  4293,  4294,  4297, -5252,  4298, -5252, -5252,
   -1765,   528, -5252,   887, -5252, -5252, -5252, -5252, -5252,  1395,
   -5252,    78,   943,    84, -4139, -1499,  1672, -5252, -5252, -1835,
    3665,  4084, -1326, -5252,  2965, -5252,  3643,  2045, -5252,  2372,
   -5252,  1308,  1313, -5252, -5252,  2049, -5252, -5252, -5252, -5252,
     635,   138, -5252, -5252, -5252,   522,   979, -2054, -5252,   643,
   -3222,  4299,    83, -1181, -5252, -1345,  2380,   626,  4896,  -531,
   -5252, -5252,  4302, -5252, -2788, -5252,  2059, -1523,    20, -3069,
   -4349, -3208, -5252, -1973, -5252, -5252, -5252, -5252, -5252,  1342,
   -5252, -5252, -5252,  2991, -5252,  5564, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,  -690, -1194, -5252, -5252,
    2890, -1334,  -125,  5595,   -64, -5252, -5252,   -59, -5252, -5252,
   -5252, -5252,  4187,  3834, -5252,  2850, -5252, -5252, -5252, -5252,
    2528, -5252, -5252,  1009, -1022,  2091,  2386, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252,   998, -5252,  1459, -1839, -5252, -5252,
   -5252, -5252,   -58, -5252, -5252, -5252,  1462, -5252,     9,  5021,
     -53, -5252, -5252, -5252,  4871, -5252, -5252, -5252, -5252, -5252,
   -5252,  3611, -1402,  4868, -5252, -5252, -5252, -5252, -5252, -5252,
    3175, -5252, -5252, -5252, -5252, -5252, -5252,  3905,  5034,  -666,
   -1669, -5252,  -842,  3176,  2564,  -938, -5252, -5252, -5252,  4330,
    5044, -5252, -5252,  5593, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  3130,   588, -5252, -5252, -5252, -5252, -5252,
     684, -5252, -5252, -5252, -5252,  3808, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,  4220, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
    1726,   -87, -5252,   981,  -107, -5252,   637, -5252, -5252, -5252,
   -5252, -5252,  -141, -5252, -5252,  -146, -5252, -1359,  4731, -1310,
   -5252, -1715, -3319, -5252,    11, -5252, -5252, -5252,  3183, -5252,
   -5252, -5252, -5252,  1490, -5252, -5252, -2623,  -894, -1665, -3246,
    1321, -5252, -5252, -5252,  -764,  4549,    -2,  1484, -1257, -5252,
   -5252,  2710,    -3,  -882,   -55,  -650,  -726,  -917, -5252,  8847,
   -5252, -5252, -5252, -5252,  -641,  -639,  -638,  -180,  -634,    40,
    -538,  -275, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252,  2615, -5252, -5252, -5252,  1516, -5252,  5071,
   -5252,  3382, -1743,  5074,  3259,  2644,  2646, -5252, -5252, -5252,
   -5252, -1710, -5252, -5252, -1723,   145, -5252,  3587, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252, -5252,  3799,  -548,  -560,
    4000,  5084,  4616, -5252,  4261, -5252, -5252, -5252, -5252, -5252,
    1920, -5252, -1932,  2676, -1416, -1906, -5252, -5252,  3023,  1405,
   -5252, -5252,  1467, -5252,  2332, -2540, -2979, -5252,  2537, -3182,
   -5252, -5252,   564, -5252, -5252, -5252,  1847,   157,  5052,  4497,
   -5252, -5252, -5252, -5252,  5650, -5252, -5252,   204,  5675,  5677,
    5678,  -394, -5252, -3209, -5252, -4063, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252, -5252,   692, -5252,   481, -5252,
   -5252, -5252, -5252, -5252, -5252,  2108, -5252, -5252, -5252, -5252,
   -5252, -5252, -5252, -5252, -5252
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    69,   735,  1947,    70,    71,    72,    73,    74,  1913,
      75,  1257,  2574,  1259,  1879,  2577,    76,   704,    77,  2071,
    2774,  2775,  4479,  4480,  4473,  4474,  4476,  4477,  2776,   819,
     820,    78,  2630,  3732,  3232,  2627,  5043,  1953,  4704,  1954,
    4705,  2623,  3738,  4316,  1958,  2632,  1959,  4315,  4309,   743,
    3733,  3311,  3312,  5412,  1316,  3227,  3320,  3321,  2635,  4307,
    4459,  5346,  4463,  5491,  5605,  5414,  3348,  4883,  5347,  5348,
     638,  1327,   778,  2033,  5417,  2700,  5063,  2701,    79,   813,
    2063,  3355,  1429,  2064,  2065,  4728,  4729,  5073,  5074,  5075,
    5058,  5059,  5060,  5061,  4305,  4721,  2876,   907,  2169,  2877,
    4948,  4942,  4943,  4944,  4558,  3457,  3458,  3459,  4577,  3460,
    4961,  4966,  3976,  3977,  4491,  3461,  5218,  5219,  5220,   658,
    1133,  5221,    80,    81,   659,   667,   660,  1130,  2431,  1131,
      82,    83,   702,  1903,  1904,  1905,  1906,  3198,  2593,  3192,
    3193,  4276,  4949,  3463,  4566,   908,   909,   910,    85,   639,
     911,   912,   913,   914,  1529,  2162,  2163,   915,   916,   917,
     918,   919,  2879,  2880,  3477,  3425,  3978,  2881,  2173,   920,
     921,   922,   923,  1530,   884,   885,  2840,  3991,  4503,    86,
     616,   815,   816,  2070,  2748,   817,  2749,  3358,  4472,   818,
    1430,  2745,  1432,   924,  3481,   925,   926,  2182,   927,  1520,
      87,  1864,  2825,   850,  1470,  2118,   928,  1240,  2552,  1139,
    2439,  3482,   929,  2179,  2181,  2178,  3480,  5372,  2180,    88,
     649,   678,   637,  1469,   665,  4725,  5069,   790,   791,   827,
    2797,   792,  1440,  1401,  2039,  2727,  2728,  3326,  3327,  3394,
    3395,  3396,  2719,  2720,  2721,  2786,  2787,  2788,  2708,  2709,
    2710,  2043,  2705,  2706,   793,  1402,  1413,  2722,  2723,  2724,
    3400,  2790,  2791,  2792,  2793,  2725,  2108,  2726,  3792,  4297,
    4720,  4298,  5051,  3164,  4716,  4717,  4446,  4811,  3177,    89,
     652,  1116,  1732,  2423,  3622,  3062,  3064,  2424,  3621,  4190,
    4191,  4192,  3060,  3061,  5256,  3066,  3619,  5392,  5694,  5517,
    5518,  3611,  5522,  4199,  4659,  4660,  5022,  5257,  5398,  5626,
    5523,  5701,  5624,  5697,  5625,  5699,  5820,  5767,  5768,  5636,
    5712,  5713,  5772,  5821,  5533,  5534,  5535,  3615,  3616,  5253,
    5276,  3222,  2027,  2028,  4774,  1268,    90,  4299,  3898,  4300,
    4301,  4819,  5544,  3900,  3901,  3902,  3418,  1807,  4853,  4835,
    4314,  4861,  4302,  4708,  4709,  4710,  4711,  5445,  5564,  5447,
    5448,  5561,  5667,  5560,  4712,  4713,  5047,  5342,  4780,  4391,
    4375,  4376,  4451,  4869,  5172,  5344,  5340,  5467,  5468,  5808,
    5809,  5484,  5759,  5485,  5815,  5834,  5835,  5469,    91,   651,
    1680,  5570,  5571,  5572,  4053,  5173,  4054,  4055,  4545,  4056,
    4057,  4058,  4059,  4060,  4061,  4062,  4063,  4064,  4065,  4066,
    4954,  4548,  4084,  4918,  4079,  4546,  4544,  4088,  5486,  5487,
    4912,  4549,  4516,  4929,  5602,  5470,  5488,  5472,  4528,  1763,
    1764,  3263,  1777,  1778,  3097,  2461,  3098,  2031,  4529,  4530,
    4922,  4531,  4927,  4161,  5007,  4167,  4168,  4169,  3576,  3577,
    3578,  3579,  3580,  3021,  5473,  4868,  5339,  5457,  5460,  5585,
    5753,  4781,  4377,  4784,  1225,   744,  4378,  4379,  5717,  5644,
    5651,  5718,  5652,  5645,  5318,  3729,  5719,  5720,  5721,  5654,
    5647,  4289,  5268,  5269,  4769,  4933,    92,   162,  3346,  1388,
    1390,  1400,  3352,  2736,  2735,  1406,  1405,  2714,  4365,  4767,
    3843,  3349,  3917,  5180,   776,  3903,  5330,  5118,  5337,  3904,
    4688,  3905,  5310,  5438,  3906,  5138,  5335,  5455,  4689,  4690,
    3907,  3908,  3909,  5725,  5726,  5727,  4380,  1499,   796,   797,
    1418,  1419,  1420,  2820,  4866,  4403,    93,  2615,  2610,    94,
    1285,  1286,  1287,  1925,  1926,  2613,  2614,  3218,  3721,    95,
    1252,  2570,  1915,  2602,    96,  1271,  3209,  3210,  3211,  3716,
      97,  1426,  2059,  2060,  2740,  3924,  4471,  4887,  5187,  5354,
    5183,  5498,  5499,    98,   823,  1436,    99,   618,  2080,  2081,
    2082,  2778,   100,  1538,   170,   101,  1137,  1738,  1741,  1742,
     102,  1251,  1866,  1867,  1868,  1869,  3173,   103,  2150,  2844,
    2845,  2846,  2847,  2565,  3693,  2566,  2567,  3182,  3998,   104,
     758,  1387,   105,   757,  1386,   106,   107,   677,   730,   669,
    1750,   109,   110,  3165,  2218,   112,   764,   762,  1078,   114,
    1380,  1376,   115,  2219,  1079,   754,   755,  1334,  1158,  3248,
    3249,  2093,  2094,  2667,  2654,  1159,  1160,  1360,  2016,  2679,
    2450,  2451,  1848,  2452,  3636,  4212,  5756,  1559,  1480,  1255,
    1081,  1082,  1083,  1692,  1693,  1708,  1084,  1702,  2377,  4133,
    4622,  4623,  4624,  4625,  4998,  2300,  2301,  2418,  1085,  2288,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  2283,  1093,  1094,
    1095,  1096,  2413,  4115,  4116,  4604,  3055,  3056,  3057,  1097,
    2903,  4101,  2914,  1098,  1099,  1100,  1101,  1102,  3603,  1103,
    4185,  3770,  1104,  1686,  2363,  2245,  4596,  4106,  4978,  4982,
    4983,  4984,  5231,  2186,  2891,  3506,  4585,  4589,  4590,  3507,
    3508,  3604,  3026,  1580,  1581,  1548,  1549,  1335,  1336,  1337,
    1338,  1339,  3754,  3755,  4733,  4320,  4735,  4324,  1981,  1982,
    1985,  1986,  1340,  1341,  1342,  1343,  1969,  1344,  1345,  1346,
    2659,  5296,  4741,  4742,  5430,  5429,  4743,  4329,  4330,  3758,
    3759,  4256,  4257,  4258,  3259,  2241,  2242,  2314,  2155,  2156,
    2157,  2187,  1354,  1996,  2675,  3269,  1998,  3267,  3765,  3271,
    3771,  3772,  2408,  3048,  3599,  3050,  4649,  5014,  5015,  5248,
    5381,  5382,  5387,  3912,  4805,  4806,  2805,  1361,  2687,  3281,
    3768,  1809,  1810,  1811,  2006,  3274,  3275,  3412,  1363,  1364,
    1374,  1379,  1367,  1365,  2867,  4361,  4809,  3581,  3563,  4694,
    3793,  2210,  2211,  4810,  4632,  1368,  2688,  3779,  3780,  3781,
    1350,  1351,  1991,  1992,  1993,  1369,  1352,  2668,  3761,   116,
     697,   117,  2115,   837,  1466,  2114,  3189,  1438,  2558,  2088,
    2089,  1455,   785,   636,   118,   640,  2841,   119,   681,  2557,
     889,  1244,  1860,  1861,  1862,  3166,  3690,  3167,  3683,  3684,
    3168,  1238,  4251,  4252,  2815,  3806,  3807,  3801,  2551,  3155,
    1239,  1852,  3676,  2548,  3677,  2549,  2579,  3678,  3993,  4909,
    5502,  2545,   120,   675,  4238,  3670,  3671,  5611,  5612,  1236,
     121,   622,  2087,   833,  1444,  1447,  1448,  2097,  2801,  3971,
    1449,  1450,  2803,   834,   835,   122,   718,  1291,  1831,  1832,
    1833,  2532,   123,   672,  1226,  3665,  4235,  2518,   655,  1464,
    1814,  1229,  1815,  2514,  3139,  1798,   124,  1384,  1383,   811,
     125,   126,   770,   171,  2020,   127,  1260,  1896,  2591,  3699,
    3700,  4261,  1897,  1898,  3190,   128,   685,  1246,  3186,  4695,
    4696,  5040,   129,   709,  1275,  1276,  1919,  1917,  3214,  2605,
     130,  2425,   131,   641,   892,  1502,  1503,  2148,   132,   712,
    1280,   133,   134,   894,  3999,  5614,  5762,   645,  2152,  1507,
    5052,  4332,  4748,  4749,  4751,  5095,  5096,  5817,  5852,  5863,
    5856,  5866,  5867,  5870,  5876,  5877,  1105,  1298,  1299,  1106,
    5575,  1107,  1108,  1109,  2220,  1242,   680,  1855,  1856,  3160,
    2555,  3158,  1857,  3685,  3686,  3087,  3268,  1110,  3672,  4770,
    1439,  2090,  1263,   604,  1111,   605,   787,  1300,  1988,  2851,
    1177,  3114,  1113,   931,  1396,  1739,  2048,  2049,  2852,   607,
     932,  3115,  3465,  1179,   608,   609,   610,   611,   612,   613,
     614,   615,   136,   671,  1162,  2457,  1754,  1187,  1783,  1772,
    1782,  2488,  3126,  2491,  3127,  3128,  4227,  3658,  4228,  3659,
    1232,  2483,  1755,  3660,  2476,  2477,  2478,  2479,  3649,  1769,
    2467,  2473,   137,   895,  2161,   648,  1509,  1510,  2864,   138,
     674,   139,   703,  1265,  2598,  3202,  3203,  3712,  4278,  3713,
     140,  1144,  1145,   141,   878,  3225,  2831,  2104,  1399,  2105,
    2132,   881,  1472,   882,   883,  1486,  1483,  1489,  1485,  3833,
    3341,  3342,  2836,  2112,  2050,  2444,  3334,  4351,  2051,  3827,
    3828,  4352,  2122,  2827,  2828,  2733,  5195,  3840,  3345,  4903,
    3982,  5196,  5197,   142,   689,   143,  5064,   696,  1254,  1876,
     144,   145,   146,   147,   763,  1372,  1161,   163,   164,   165,
     166,   800,   801,  3351,  3919,  4466,  4467,  5182,  5859,  5860,
    2634,  3736,  5546,  5824,  5853,  5872,  5286,  5416,  5418,  5549,
    3234,  3735,  5065,   148,  1305,  1301,   729,  1945,  1939,  1941,
    2621,  3221,   149,   150,   151
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     606,   688,   799,   731,   113,  2349,  1228,   111,  1526,  1175,
    1224,   135,  2007,   650,  1512,   805,  1517,  1518,  1519,  1138,
    2438,  2433,   661,  1523,  2403,  2021,   661,    84,  2217,  1999,
    1180,   661,  1181,  1182,   676,  2209,   795,  1183,   108,  2489,
    2580,  2806,  1838,   692,   700,  1256,  2269,  2008,   699,  2099,
     708,  2798,  3637,   668,   707,  1398,  3484,  3485,   711,  3910,
    3777,  1312,  3951,  1463,  3282,  1313,  1314,  3462,  3911,  3664,
    2485,  3181,   732,  2597,  1333,  2251,  3974,  2127,   880,  4327,
    2544,  3509,  1582,  3510,  4290,  3226,  3760,  2029,  3794,  4083,
     879,  2030,  1989,  1282,  2109,  1542,  1289,  1934,  2505,  2506,
    2432,  3178,   806,  2742,   789,  4872,  3782,   807,  1146,  3783,
    3511,   935,   808,   809,  3794,  3794,  2689,  3674,   810,  3329,
     879,  2095,   773,  2592,  3191,  3424,  3720,   935,  1964,  3251,
    3401,  1397,  2509,  1185,  1437,  4303,  4372,  3330,  3402,   113,
    3899,  4373,   775,  3921,  4374,  4879,  1765,  1768,  1770,   777,
     779,  2525,  4963,   779,  2818,  1780,   788,   794,  4469,  2388,
    2389,  2390,  2391,  2392,  2393,  2394,  2396,  2398,  2399,  2400,
    2401,  2402,   664,   108,  5185,   113,  2538,  2539,   111,  4399,
    3794,  3794,   135,  1381,  4163,  4400,  2433,  4737,  3398,  2153,
     782,  2153,   694,  4381,  5062,  4383,  1487,  2837,  4393,  2838,
    2839,  2590,  1687,  1688,   716,   713,  3399,  2777,  2711,   108,
    4808,  2618,  1583,  3715,  2663,  3562,  2865,   710,  3255,  1740,
    2861,  5700,  4946,  1687,  1688,  3325,  3799,  1676,  1678,  1679,
    5203,  4428,  2061,  1378,  1687,  1688,  2368,  4164,  4831,  1526,
   -2347,  1722,  1687,  1688,  2376,  2378,  3391,  2381,  2382,  1687,
    1688,  1377,  2789,  3331,  2865, -2552,  2153,  1623, -1947, -2685,
    1687,  1688,  1761,  4813,  1805,  2432,  1974,  4527,  4527, -1947,
    2026,  4527,  1687,  1688,  3018,  3405,  1687,  1688,  4527,  2862,
    1687,  1688,  3250,  3250,  4527,  3963,  1839,  1761,  3823, -1130,
    1631,  1687,  1688,  4815,   748,  1687,  1688, -2347,  4817,  3936,
   -1130,   642,  1687,  1688,  4840,  1687,  1688,  2865,  3832,  1767,
   -3157,  3856,  1685,  1687,  1688,   804,  3298,   759,  5174,  -606,
    2948, -3157,  1163,  3805,  3613,  2153,  3067,   798, -2845,  2734,
    -606,   690,  2170, -3158,  4163,  4105,  4568,  2865,   646, -2845,
    -415,  1975,  2865,  3032, -3158,  4719,  1687,  1688,  2865,  2819,
    3663,  -415,  1976,  4507,  1325,   760,  1687,  1688,   935,  1977,
     935,   935,   935,  1687,  1688,  3839,  1416,   935,  1709,   935,
     802, -3157,  4785,  4629,   936,  2202,  3727,  1689,  2865,  1690,
    1874,  1687,  1688,  1840,  3441,  3803,  2865,  4164,  1687,  1688,
     936,  1978,  2865,  1799, -3158,  3162,  1186, -1947,  1689,  5136,
    1690,  3841,  1687,  1688,  5343,  4886,  1943,  2203,  1424,  1689,
   -2347,  1690,  5122,  1687,  1688, -2553,  2731,  1689,  2830,  1690,
    3170,  4080,  4081,  2204,  1689,  3697,  1690,  4221, -1947,  3250,
    4092, -3065,  4093,  3033,  4095,  1689,  2568,  1690,  1761, -3237,
    3824, -3220,  2560,  5749,  4401,  1687,  1688,  1689,  1796,  1690,
   -3224,  1689,  1979,  1690,  1761,  1689, -1947,  1690, -2347,  2192,
    2888,  5558,  2865, -3223,  1710, -2347,  1689,  2205,  1690,   933,
    1689,  1872,  1690, -2546,  5677,  3852, -2347,  1689,  2865,  1690,
    1689,  2703,  1690,  1980,  1326,   933,  3224,  4310,  1689,    31,
    1690,    31,  5513, -2347,  1454,  2206,  1691,  1907,   836, -3221,
     838,   839,   840,   841, -3222,   843,   844,  5334, -3227,   846,
     847,   761,  3151,  3081,  3082,  3083,  3084,  1691,  4358,  1757,
     657,  1689,  4087,  1690,  2901,  3169,  3332, -3157,  1691,  4308,
    3034,  1689, -2845,  1690,  2625,  4085,  1691,  4963,  1689,  1849,
    1690,  4091,  5510,  1691,    38,  4195,    38,  4096,  2111,  5601,
   -3158, -1947,  4521,  4311,  1691,  4508,  1689,    40,  1690,  1441,
    4630,  5055,  1871,  1689,  5836,  1690,  1691,  1163,  5056,  4522,
    1691,  3560,  4188,  2126,  1691,  1460,   666,  1689,  2619,  1690,
    3663,   673,   643,   877,  5846,  1691,  -822,  2704,  1689,  1691,
    1690,  1850,  2207,  2009,  1292,  1293,  1691, -1947,  1834,  1691,
     935,  4517,  5055,  4519,  1661,  1797,  2569,  1691,   617,  5056,
    -221,  4539,  5211,   877,  1665,   821,  3981,  3744,   794,  4523,
    1689,   936,  1690,   936,   936,   936,  1687,  1688,    31,   794,
     936,  3698,   936,  5057,   851,   788,  1250,  4554,  5750,  1951,
    1691,  1952,  4312,  1201,  1955,  1956,  1957,  1687,  1688,  1266,
    1691,   653,  5751,  1333, -3241,  3863,  4567,  1691,  3068,  1135,
    1758,  4552,  4452,  4553,  5071,   788,  3842,  5556,  1178,  2215,
    2713, -2704,  1802, -2705,  5057,  1691,  1385,  5324,  2103,  2193,
    1873,  1247,  1691,    38,  2419,  1582,  1136,  1694,   788,   934,
    5385,   829,  5678,  3899,    40,  5451,  1691,  1676,  1678,  5748,
    1264,   788, -3065,  1695,  1269,   934, -2706,  1691,  3152,  1800,
   -2225,  1184,   821,  3092,  2795,   821,   933,  3329,   933,   933,
     933,  3743,  1875,  1467,  1468,   933,  2029,   933,  3401,   830,
    2030,  2455,  1696,  1311,  2109,  3330,  3402,  3887,  1697,  1691,
    1687,  1688, -2225,   646,  4764,  3091,  2072,  3486,  1425,   773,
    2420,  5601,  2484,  3794,  3809,  1761,  5336,  3019,  1761,  3825,
    2887, -1947,  5053,   824,  2047,  3804,  1382,  1375,  2649,  4222,
     647,  2079,  5109,  2899, -2685,  1698,  2113,  1762,   788,  2664,
    1403,   849, -3241,  5514,  4347,  2068,  3398,  1687,  1688,  1462,
    5476,   682,  4513,  4527,  1632,   937,  1687,  1688, -2685,  1583,
     788,  1689,  1762,  1690,  3399,  4765,  3728,  4165,  3749,  1427,
   -3339,  4078,  3753,  2863,  2253,  1583,  4527,   619,  1414,  1234,
    4527,   773,  1689,  1403,  1690,  1417,  3663, -2552,  4527,  3821,
    2442,  1451,  3261,  1453,  5696,   779,   779,   779,  1459,  1403,
    1362,   788,  2434,  2047,   691,  1362,  1249,  1362,  2183,  3959,
    2463,  5262,  4484,  1687,  1688,  2024,  3024,  3025,   717,   714,
     688,  4362,  2508,   936,  4523,  2512,  1461,  3146,  1377,  1465,
    2866,  5363,  1456,  1457,  1458,  3250,  2520,  2503,  2711,  2523,
    1488,  2405,  4524,  2526,  4202,  2780,  2079,  4444,  1201,  5062,
    2079,  2732,   773,   935,  1516,  3253,  3254,  3328,  2079,  2196,
    3430,  1521,  5687,  1524,  3796,  1687,  1688,   715,  2866,  1944,
    2541,  2542,  2543,   879,  4513,  1689,   113,  1690,  1531,   111,
    1691,  4470,  1877,   135,   683,  3040,  3041,  4402,  3044,  3045,
    4166,  2154,  4512,  2154,   644,  1963,   934,  5186,   934,   934,
     934,  1691,  5293,  4963,  5294,   934, -2347,   934,  1687,  1688,
     108,   646,  5515,  1762, -1947,  1329,  2789,  4165,   933,  2814,
    3333,  2866,  1689,  2913,  1690,  2412,  3397,  2732,  2294,  1762,
    5415,  1689,  1583,  1690,  2871,  5752,  3996,  4559,  4560,  4561,
    3035,  2878,  4564,  2309, -3241, -1130,  2317, -2553,  2319,  3028,
   -1947,  2866,  2323,  2324,  2325,  4573,  2866,  2949,  2154,  3244,
    2331,  2537,  2866,  2915,  1309,  2916, -3157,  2434,   731,  3562,
    3562,  4525,  2902,  3562,  3562,  -606,  5292,  1687,  1688,  3562,
    3562,  2917,  2443,  2918, -2845,    68,  2380,    68,  1689, -3158,
    1690, -3237,  2866, -3220,  1691,  3020,  -415,  3413,  2421,  2358,
    2866,  2930, -3224,  4510,  1803,  4514,  2866,  4085,  4452,  4085,
    4360,  -114,  3005,  -114,  3006, -3223,  3016,  4085,  3017,  1718,
    1719,  1720,  1721,  3591,  4543,  3592,  4510,  2154,  2907,  3819,
    3820,  3058,  1684,  4085,  4111,  3646,  4112,  1681,  1687,  1688,
    1689,  1691,  1690,  4085,  1683,  1687,  1688,  4555,  2208,  2732,
    1691, -3221,  2524,  4563,  4087,  5516, -3222,   690,  1397,  3421,
   -3227,  5349,  4085,  4510,  4510,  4571,  4572,  4732,  1662,  2908,
    2494,  4752,  4313,  1766,  4755,  1771,  2866,  2934,  1666,  1774,
    1779,  1662,  5054,  1689,  4137,  1690,  4138,  -118,   646,  -118,
     620,  4588,  2866,   788,   773,  3957,  3958,  1583,  1687,  1688,
    1320,  4333,  4139,  -110,  4140,  -110, -2725,  1691,  3630,  1808,
    4372,  2919,   654,  4336,  3335,  4373,   936,  3910,  4374,  1753,
    3762,  3763,  3922,  2936,    68,   788,  3911,   788,  1397,  1526,
    4521,   788,   788,  1333,  4179,   647,  4180,  3809,   934,  4956,
    3561,  2866,  4078,  1491,   832,  1163, -2704,  4522, -2705,  1687,
    1688,  4701,  1689,   646,  1690,  4349,  4513,  2458, -2225,  1691,
    5208,   788,  4452,  2802,  2717,  4993,  4678,  4393,  2920,   879,
   -2704,  3661, -2705,  3329,   822,  1163,  1235,   821,  5757,   821,
    1253, -2706,  4317,  4318,  1911,  4915,  2603,   805,  3336,  2843,
   -2225,  3330,   167,  3191,  4766,  3414,  2422,   690,  3899,  1858,
     662,  2681,  1691,   773,  5680, -2706,  3794,   670,   773,   773,
    4916,   933,  4723,  1689,  -264,  1690,  4525,  2712,  3336,  2900,
    1689,  1877,  1690,  3740,  2818,  1912,   731,  4363,  1687,  1688,
    1762,  1348,  2587,  1762,  1922,  2054,   890,  2628,  2629,  3424,
    1687,  1688,  5707,  5708,  2637,  2638,  2639,  1500,   773,  1935,
     693,  1936,  3623,  1333,  2454,  3401,  1995,  3653,  2606,  1835,
    2047,  2794,  4756,  3402,  1333,  1333,  4321,  4322,   829,  1948,
    4864,  1691,  2689,  1689,   806,  1690,  4904,  4905,  4906,   807,
     684,  3206,  2029,  1505,   808,   809,  2030,   621,   773,  1971,
     810,  5606,  5290,  1816,  3206,  1681,  1949,  1950,  3277,  3278,
    2713,  4822,  1683,  4626,  4921,  3695,   830,  2707,  1994,  4550,
    5020,  3143,  2055,  3398,  4392,  2433,  3337,  4837,  4838,  1699,
    1700,  1701,  2926,  2014,  1689,  1163,  1690,  2690,  2510,  2691,
    2008,  3399,  1691,  2008,  2008,  3525,  3250,  3250,  5280,  1691,
    5785,  2022,  2023,   647,  1375,  3643,  3337,   113,  2034,  2921,
     111,  1687,  1688,   679,   135,  3925,  2718,   172,   173,  2474,
    4364,   879,   773,  4527,  2464,  1900,   877,  1391,  3415,  5581,
    2923,   788,   773,  3428,  3655,  1733,  1916,  5350,  2795,   779,
     773,   108,  1914,   773,  2821,  2822,  2683,  3914,  3404,  4865,
    1687,  1688,  1691,   773,  2432,  1687,  1688,  3095,  3242,  1407,
     773,  3099,  2091,  1689,  3243,  1690,   772,  4497,  4498,  4499,
    4500,   695,  2101,  1687,  1688,  1689,  2056,  1690,   788,  2819,
    3338,  2515,   788,   773,  3124,  1408,  2711,  1243,  4350,  1362,
    2823,   934,  3663,  4286,  3059,  1687,  1688,  1974,  3669,  5758,
    1277,   891,  4523,  1691, -1017,  1492, -1017,   788,   886,  3647,
     788,  3207,  1583,  2927,  1349,  3328,  3687,  5735,  1703,  2217,
    4524,  1687,  1688,  2933,  3207,  2516,  1201,  1409,   731,  3612,
    2165,  1836,  1501,  2026,  2853,  3648,  2854,  2855,  3071,  3072,
   -1907,  2857,  3923,  1843,  1687,  1688,  3662,  1321,  1687,  1688,
     935,  3441,  2966,  5066,  1138,   773,  1201,  4738,  1687,  1688,
    5582,  5115,  3617,  5117,  2061,  4995,  5120,  3597,  3598,  4997,
    2935,  1506,  1975,  5125,  5126,   169,  4758,  2937,  3339,  2789,
     647,  4724,  1691,  1976,  3397,  5351,  1689,  5214,  1690,   113,
    1977,  3134,  2369,  3136,  1691,  1687,  1688,  1681,   935,  3590,
     848,  3593,  4600,  3012,  1683,  5130,  5641,  3141,  3339,  4287,
    5067,   663,  3442,  4452, -2718,  1687,  1688,  3029,  1687,  1688,
    3148,  3149,  1978,  4917,  5419,  1689,  1410,  1690,  1704,  4551,
    1689,  3208,  1690,  4437,  3948,  5119,  2939,  2859,  5583,  1555,
    1556,  1557,  3663,  1705,  3208,   647,  1542,  3786,  1689,  2684,
    1690,  2364,  3764,   701,   759,  2158,   773,  3965,  3663,  3663,
    2517,   935,   935,  3822, -1422,   773,  1411,   733,  3340,  1817,
    1689,  4085,  1690,  2373,   686,   687,   773,   686,   687,   831,
     734,  5642,  2370,  1979,  3161,  3162,  2960,  2350,  2404,  2079,
    2475,  1734,   760,  5444,  5548,  5446,  1689,  1608,  1690,  5393,
    1687,  1688,  5021,   788,  2511,  1691,  1201,   113,  3088, -1907,
    2359,  2547, -1422,  3973,  1980,  3915,  5322, -1422,  3745,  1689,
    1706,  1690,   877,  1689,  3787,  1690,  4739,  3043,  4483,  2465,
    4924,  2940,  3967,  1689,  2202,  1690,   686,   687,  5883,  5193,
     788,  5194,  2409,  2466,  1691,  4207,  4208,  4209,  4210,  1691,
     686,   687,  2426,  4438,  1687,  1688, -1422,   172,   173,   887,
    4507,  2310,  1928,  2311,   788,   788,  2203,  1691,  1687,  1688,
    1689,  5068,  1690,   736,   788,  2459,  4554,  5229,  1844,  2371,
    4601,    31,  2204,  2480,   788,  3163,  1687,  1688,  2158,  1691,
    1689,  4288,  1690,  1689,  5643,  1690,   759,  5577,  2486,  1753,
    2947,  5329,  3949,  5462,   779,   773,   779,   779,   779,   779,
     773,   788,   773,   936,  5251,  1691,   779,  2633,  2636,  5562,
     888,   832,  2481,  4452,  1909, -1017,  2205,  2159,  1687,  1688,
     686,   687,  2521,   779,   760,   788,    38,  4535,  1691,  2527,
    3668,  2495,  1691,  2497,  2499,  2500,  2501,    40,   761,  1907,
     780,  1907,  1691,  2507,  2206,  5436,  4241,   773,  4240,  2963,
    1532,   936,  3116,  2160,  3117,  3118,  2965,  2594,   773,  3120,
    2522,  5861,  1845, -1907,  2717,  1689,  5271,  1690,  5685,   773,
    5323,  1687,  1688,  1294,  3956,  2158,  5375,  1846,  3102,  1691,
    4740,  4452,  1687,  1688,  4525,  5327,  3714,  1687,  1688,  5464,
    2860,  3077,  4783,  4783,  3950,  2106,  2707,  2622,   933,  1691,
    5111,   821,  1691,   879,   877,  5471,  2626,   781,  1533,   788,
    3420,  2959,  1687,  1688,   936,   936,  3156,  5394,  5395,  1689,
    1370,  1690,  3205,   773,   753,  1929,  2009,   821,  2608,  2009,
    2009,  3279,  2029,  1689,  1526,  1690,  2030,  2712,  2713,  4217,
    4218,  2207,  1687,  1688,  5237,  2669,   933,  5862,  4620,   788,
    2159,  1689,  4508,  1690,  4226,  3121,   788,   788,   788,  5801,
    1295,  1296,  2967,   773,  1910,  4790,  4901,  3235,  2482,  5618,
    3236,   167,  2677,  1333,  3241,  3187,  2008,  1534,   773,  1333,
     761,  4979,  1371,  2106,  1691,  2856,  2079,  3475,  5812,   773,
     773,  2702,  3039,  1689,  1333,  1690,  5569,   788,  1687,  1688,
    5465,  3328,  1687,  1688,  4457,  5698,  1366,  2707,  5702,   933,
     933,  5642,  3483,  3483,  3483,  2794,  3262,  3966,   783,  5396,
    2073,  1687,  1688,  4857,   935,  3403,   705,  3987,  3988,  3989,
    3990,  2795,  5437,  5589,  1262,  4253,  3404,  5016,  1691,   172,
     173,  2969,  1294,   788,   784,  5857,  1689,  2159,  1690,  1322,
    2716,  3103,  1691,  2972,  1412,  1535,  2718,  5404,  2312,  3748,
   -1362,  2313,  1689,  3752,  1690,   773,  1687,  1688,  2107,  2741,
    1691,  5171,  3596,  5435,  5802,  2035,  3969,  3639,  3640,  5376,
    1356,  5776,  5777,  1347,  5813,  5512,   773,  1689,  5401,  1690,
    1283,   155,  2047,  5397,  5619,   798,  1709,  3972,  1687,  1688,
    4458,  1222,  3654,  1451,   706,  2810,  4559,  4560,  4561,  2812,
    4564,  2008,  1691,  1687,  1688,  4556,  1323,  1689,   934,  1690,
    1297,   773,   773,   803,  5643,  1687,  1688,  5420,  2826,  1295,
    1296,  1687,  1688,  1358,  4521,  2835,  2835,  5814,  2835,  2835,
    1333,  3397,  1687,  1688,  2678,   719,  4178,  5818,  4181,  1163,
    4832,  4522,  4776,   788,  3834,  3835,  2107,   773,  3836,  3837,
    3838,  1707,  5507,   812,  2973,  1691,   934,   773,  1687,  1688,
    4557,  2111,  5730,  1689,  2874,  1690,  1691,  1689,  1284,  1690,
    1796,  1691,  4557,   814,  2882,   851,  2434,  3642,  2414,  2047,
    1687,  1688,  1710,  5858,  4581,  4510,  1689,  4833,  1690,  1687,
    1688,  1392,  4085,  2974,  3437,  2858,  1691,  2128,  2975, -2319,
    1711,  4777,  4085,  5715,  1687,  1688,  4555,  2641,  3122,  2372,
    2129,  4563,  2415,   720,  2968,  3663,  1508,   690,  5315,   934,
     934,  5320,  5321,  5388,   113,  -704,  1691,  2911,  5778,  1272,
     825,  1689,  2185,  1690,  3466,   168,  3467,  3468,  2978,  5426,
    2445,  3470,  3446,  5085,  3614,  5086,   826,  4581,  5672,  5673,
    3663,  3512,  3054,  2446,  3417,  5754,  2707,  1526,  4834,  1324,
    1687,  1688,  3517,  1689,  2996,  1690,   879,  5427,  2130,  2074,
    2185,  3475,  1687,  1688,  3447,   842,  4582,   936,  1689,  1606,
    1690,  5319,  1691,  4783,   169,   935,  1691,  3001,  2416,  3606,
    1689,  3004,  1690,  5642,  2198,   690,  1689,    68,  1690,  4663,
    4664,  3011,   935,  3119,  4583,  1691,  1583,  1689,  1474,  1690,
     956,  2130,  5646,  4778,   731,  5653,  4744,  1273,  5649,  4745,
    3551,  1309,   893,   773,  5428,  1687,  1688,  1797,  1115,   773,
    2611,  5443,  2258,  1689,  3448,  1690,  2976,  3472,   935,  4582,
    3195,  3196,   963,  2106,  4870,  3013,   935,   935,   935,  3559,
    1691,  1687,  1688,  3629,  2075,  1689,  2076,  1690,  3022,  5116,
    1393,  3487,  3449,  4392,  1689,  1475,  1690,  4586,  1476,  2417,
    1117,  1274,   933,  4461,  5668,  5128,  5670,  5671,  1394,  1689,
    4462,  1690,  1691,  1681,  2612,  3794,   877,  4779,  3282,  3116,
    1683,  3117,  3118,  3313,  4870,  1477,  3120,  1691,  1687,  1688,
    3605,  4584,   975,  1478,  4679,  2404,  5643,  5844,  5845,  1691,
    2384,  5796,  1132,  2185,  5137,  1691,  5139,  3197,  5646,  4746,
    3766,   656,  5441,  3794,  3794,  5653,  1691,  5806,  1235,  1397,
     987,  2185,   788,   788,   773,  1689,  4523,  1690,   788,  4145,
    5783,  2977,  2835,  2835,  2835,  2835,  2077,  1689,  5782,  1690,
    3089,  3090,  1691,  1753,  4524,  2185,  2131,   788,  1743,  3450,
    1201,  1222,  5827,  4854,  4584,  5829,  1175,  4146,  4856,  1237,
    4511,  1687,  1688,  3767,  1691,  2261,  5740,  5741,  1687,  1688,
    5744,  3113, -1362,  1691,  4234,  4671,  4513,  1180,  1258,  1181,
    1182,  3130,  3121,  2277,  1183,   779,  5843,  4109,  1691,  2447,
    1689,  4747,  1690,  3132,  1687,  1688,  3171,   779,  2073,  2981,
    1248,  3137,  2009,  1687,  1688,  2712,  2107,  2291,  5646,  5653,
    2385,  3794,  1687,  1688,  2078,  1812,  1689,  1005,  1690,  4110,
    4569,  4570,  3131,  4279,   773,  2386,  2044,  2045,  1526,  4925,
    1687,  1688,  1261,  5506,  3135,  3246,  4772,  3140,   936,  3247,
    1858,  3159,  3297,  5795,  1691,  1813,  4522,  5574,   788,  3174,
     773,   113,  1687,  1688,  4773,   936,  1691,  1863,  4496,  1253,
    2084,  4123,  1870,  1689,  1333,  1690,  5810,  5810,  1333,  1687,
    1688,  5012,  4068,  3687,   821,  5574,   752,  3475,   773,  1728,
    1185,  1267,   934,  3404,  4069,  3201,  1687,  1688,  3204,   773,
    3473,   936,  5013,  4592,  4593,  5374,  2757,  2758,  2794,   936,
     936,   936,  2387,  3403,   753,  1995,  1356,  1737,   935,  1691,
    2806,  2770,  2982,  4795,  3228,  3229,  3230,   773,  5833,   779,
    4608,  1270,   935,  5716,   773,  3239,   779,  4637,   773,  4486,
    4125,  1454,  3179,   933,   773,  1691,  1689,  2009,  1690,  2650,
    4239,  4633,  1347,  1689,  2651,  1690,  3574,  3180,  2652,   773,
     933,  1687,  1688,  3260,  1357,  4153,  3233,  1994,  3265,  1358,
    3052,  3575,  3238,  3240,  3052,  2922,  5093,  4661,  3053,  1689,
    2922,  1690,  4667,  1279,  1687,  1688,  4992,  5094,  1689,  2079,
    1690,  5004,  1691,  2986,  3290,  3469,   933,  1689,  1281,  1690,
    1590,  3294,  3295,  1288,   933,   933,   933,  4203,  1359,  4680,
    2866,  3926,  1687,  1688,  1134,  1689,  1975,  1690,  1605,  2772,
    2773, -2394,  1140, -2394,  1609,  1610,  2040,  1976,  1233,   788,
    1333,  4236,  4807,  1290,  2660,   773,  2052,  1689,  2653,  1690,
    4078,   828,  3037,  1304,  2057,  1687,  1688,  1703, -2707,   752,
    4229,  4154,   845,  2987,  1689,  3122,  1690,  1687,  1688,   877,
    1308,  3419,  4117,  1310,  2085,  1691,  2085,  2074,  1687,  1688,
    1315,  1689,  1691,  1690,  4986,  1716,  1717,  1718,  1719,  1720,
    1721,  4078,  4230,  2047,  2047,  2047,  2047,  1687,  1688, -2713,
    1353,  1687,  1688,  4082,  4082,  4078,  4078,  3407,  1691,  3409,
    1317, -2715, -2727, -2735, -2736,   773,  4156,  1691,   773,  1318,
    3314,   788,  4078,   788,   788,  4078,  1691,  2988,  4640,   935,
   -2737,  1709,  4642, -2740,  1687,  1688,   788,  2661,  4525,  2835,
    1687,  1688,  1302,  1303,  1691,  1306,  1689,  1307,  1690,  1687,
    1688,  2646,  4231,  2647,  1766,   113,  1766,  5033,  1319,  2994,
    3119,  5887,  2075,  1186,  2076,  1385,  1691,  1704,  1980,  1689,
    1389,  1690,  1822,   934,  2995,  2717,  1687,  1688,  2717,  2924,
    4232,  2256,  1705,  1691,  4216,  2013,  2999,  2938,  2015,  2015,
     934,   936,  3000,  2964, -2711,  1877, -2166,  1689,  1391,  1690,
    1691,  4454,  1404,  3002,  1927,   936,   788,  1415,   788,   935,
    1932,  1933,  1422,   686,   687,  2443,  2443,  2443,  2443,  2782,
    1421,  2970,  4674,  2971, -2166,  3471,   934,  1710,   798,  3009,
    1689,  3315,  1690,  1423,   934,   934,   934,  2979,  3316,  1877,
    4885,     8,  1689,  1428,  1690,  1711,  3317,  2985,  1907,  1877,
    4177,  3023,  1431,  1689,  2077,  1690,  1687,  1688,   935,  1706,
    4104,  1435,  2123,  2124,  1442,  1691,  2125,  1443,  5027,  5028,
    2318,  2989,  1689,  1877,  1690,  4107,  1689,  4233,  1690,  2327,
    1709,  1454,  2990,  3393,  1877,  1761,   933,   731,  1691,  1222,
    2338,  1397,  1397,  1397,  1397,  2092,  1972,  2782,    16,  1471,
     933,  1712,  1713,  3675,  2991,  2997,  1877,  1877,  4283,  1689,
    3426,  1690,  3427,  4501,  4502,  1689,  1691,  1690,  2707,  3318,
    1473,  2707,  3572,  3594,  1689,  3478,  1690,  3479,  1703,  1479,
    4253,  4108,  2078,  1786,  4359,  2866,  4114,  1526,  3113,  3680,
    1481,  3681, -2319,  4113,  1482,  3756,  3805,  3757,  1484,  1691,
     113,  1689,  3817,  1690,  3818,  3600,  1681,  4787,  4131,  4789,
    2971,  1691,  4792,  1683,  4672,  4796,  1490,  2718,  4799,  4800,
    2718,  1493,  1691,  3834,  3835,  1494,  1710,  3836,  3837,  3838,
    3319,   773,  1333,  1333,  1397,   788,   788,  2835,  2188,  2189,
    1495,  1691,   936,  3966,  1711,  1691,  4118,  2199,  4134,  2707,
    1877,   788,  2783,  1496,  4839,  2106,  1498,   113,  2106,  1504,
     111,    31,  2202,  2202,   135,  4144,  4148,  1877,  4149,  2496,
    1527,  4464,  4119,  4465,  2502,  4552,  2504,  4553,  1691,  2259,
      84,  2262,  3778,  1536,  1691,  1178,  1537,  4521,  1704,  1601,
    4646,   108,  1877,  1691,  2203,  2203,  2275,  2276,  2278,  1543,
    1712,  1713,  4532,  1705,  4522,  2279,  2280,  2350,  1544,    36,
    2204,  3788,  2292,  4890,  1545,  4891,    38,  5019,  3688,  4120,
    1691,  2536,   936,  4892,  4894,  4893,  4895,    40,  1184,  1550,
    2783,   113,  2546,  3689,   686,   687,  2106,   933,  1551,  1787,
    3403,  4934,  1552,  2559,    42,   152,  3703,  1553,  4934,  4846,
    4970,  1554,  4973,  3483,  2205,  3789,   934,  1558,  4955,  1823,
    5046,  4772,  4668,  4669,   172,   173,  4919,  1766,  1560,  1561,
     934,   936,  1562,  1222,  4972,  4987,  1222,  1877,  4974,  4975,
    1706,  3704,  2206,  3790,  1563,  1709,  4932,  2784,  1564,  2404,
    1766,  4686,  4121,   779,  1565,  4937,  4980,  1788,   773,  4122,
   -2349,  4939,  1709,  1824,  1566,  1825,  1789,  1723,  5002,   773,
    5003,  4951,  5010,   773,  1877, -1766,  5023,   933,  5024,   788,
    4959,  4960,  1647,  1687,  1688,  4130,  1567,  2409,  2107,  1568,
    3737,  2107,  1569,  3626,  4136,  1724,  5037,  2631,  5038,  3826,
    1570,   788,   788,  4141,  5048,  1571,  5049,  1790,  5084,  5204,
    3757,  5205,  1347,  1572,  1222,  1653,  5206, -2349,  5205,  1575,
    5250,  4142,  5133,  1347,  1347, -1765,   933,  2221,  2222,  2223,
    2224,  3810,  3811,  3812,  3813,  1585,  3815,  3816,  1586,  2207,
    3791,  1710,  5209,  4143,  5210,  5503,  5265,  5352,  4243,  5353,
    1148,   788,  1587,  2785,  2047,  2341,  2342,  1826,  1710,  1711,
    4151,   153,  1687,  1688,  1588,  1591,  5192,  3918,  4386,  2107,
    5370,  5402,  5287,  5403,  1592,  1593,  1711,  4152,  5406,  1594,
    5403,  2225,  2226,  2227,  3934,  3935,  5424,  3937,  3757,  3939,
    3940,  3941,  3942,  3943,  3944,  3945,  1595,  3947,  5176,  2737,
    3952,  5425,  1725,  3757,  3955,  3390,  1827, -3334,   935,  5538,
    1596,  5403,  1149,  3491,  1597,  1712,  1713,   934,  1598,  1791,
    1707,  4533,  4023,  1726,  4387,   773,  1709,  5579,  3492,  5580,
   -2349,  1599,  1712,  1713,  1600,  2228,  2229,  1602,  1603,  1687,
    1688,  5609,  4155,  5610,  2826,  1792,  1604,  3179,  4579,  2023,
     788,   788,   788,   788,  3493,  1828,   773,  1611,  1689,  4523,
    1690,  4923,  3180,  5355,  1297,  4159,  3494,  1612,  3054,  2834,
    2834,  -848,  2834,  2834,  5620,  1613,  5621,  4524, -2349,  5121,
    4599,  1614,   154,  1201,  4807, -2349,  3495,  1615,  1616,  4515,
    1709,  2848,  1727,  4172,  5477,  4520, -2349,   934,  4537,  2443,
    2443,  1508,  5639,  4923,  3818,  4541,  2230,  1617,  1618,  4513,
    1762,  4913,  5663, -2349,  5024, -2166, -2166,  1619,  3496,  4923,
    3497,  5478,  1710,  4923,  4923,  4847,  4985,  4848,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  -821,  1689,  4991,  1690,
    1711, -1051,  1620,  2782,  1621,  1829,   934,  5383,  4647,  5000,
    5739,  3705,  4693,  1624,  1625,  3605,   935,   935,   155,  5743,
    1626,  5403,  4849,   737,  5745,  1627,  5403,  1830,  5001,  1628,
     172,   173,  5005,  1731,  1629,  1397,  1397,  1691,  2231,  1630,
    1729, -3334,   686,   687,  1633,  1175,  1710,  5746,  4157,  5403,
   -1051,  4850,  1634,  1150,  1151,  1635,  1712,  1713,  3706,  5764,
    5773,  5765,  5774,  1152,  1711,  5006,  1180,   156,  1181,  1182,
     738,  5377, -2569,  1183,  1689,  5461,  1690,  5793,  1636,  5403,
    5440,  5794,  5797,  5403,  5403,  1687,  1688,  4193,  5800, -1081,
    5024,   686,   687,  5828,  1637,  5403,  5479,  5874,  1638,  5875,
    5480,   788,  1639,  1640,  1793,  2707,  1746,  5236,   788,   788,
     788,   788,  1641,  4214,  4213,   157,  1691,    68,  5232,  5477,
    1712,  1713,  3707,  1642,  5461,  1735,  1643,  2992,  1644,  4224,
    4225,   936,  1645,  2998,  2232,  1646,  3498,  1714,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  2693,  5478,  1648,  3499,  5462,
    1736,  1707,  1649,  2008,  1650,  1651,  2143,  1652,  4245,  5539,
    1526,  1654,  1655,  5542,  4369,  1656,  3708,  2350,  1657,  1185,
    1658,  4259,  4771,   113,  1659,  1660,  4250,  1663,  1664,  1667,
    1794,  4782,  1668,  1669,  4386,  3612,  2783,  4851,  1795,  1670,
    1671,  2694,  2106,  1691,  1672,   172,   173,  1673,  5462,  1674,
    1730,   788,  2233,  4791,  1747,   623,  1748,   773,   773,  5298,
    5299,  1749,  5301,   779,  1756, -1051, -2597, -2568,   739,  1781,
   -2594, -2592,  5463,  4852,  1854, -2596,   933,   773,   773, -2591,
   -2595,  1784,  2695, -2589,  4328, -2593,  1785, -2131,  1743,  1801,
    4387,  1357,  1804,  2784,  1818,  5464,  2834,  2834,  2834,  2834,
    4306,  1819,   740,  3500,  5481,  3501,   686,   687,  5594,  1820,
    1689,  5479,  1690,  3179,  1821,  5480,   158,  2234,  1153,  2235,
     159,   624,  2928,  1841,  2236,  2931,  5383,  1842,  3180,   936,
     936,  1847,  1853,  1859,  1865,  5501,  4263,  1877,  1908,  5461,
    1918,  2943,  1920,  4264,  5464,  5640,  1924,  4340,  4341,  1930,
     154,  4342,  4343,  1931,  1937,  2961,  1938,  4344,  4345,  4265,
    1222,  4525,   160,  5360,  1974,  5362,  1940,  5613,  1942,  4266,
    4267,  4268,  3709,  3710,  3711,  1946,  5361,  1960,  1961,  4269,
    1962,  1972,  1984,  5761,  1983,  4907,  1987,  2000,  3147,  2237,
    1997,  2010,   161,  2011,  4388,  2026,  2032,  2038,  2042,  2785,
   -3334,  4455,  -821,  5477,  2036,  2696,  5465,  2041,  2046,  2058,
    2062,   625,  2069,  5462,  3176,  2107,  2086,  2697,  2092,  2717,
    4439,  2096,  1546,  5482,   933,   933,   155,  4389,  2098,  1691,
    5478,  2100,  2238,  3606,  2102,  4453,  4913,  5463,  2110,  1975,
    2116,  5525,  4923,  5557,  1716,  1717,  1718,  1719,  1720,  1721,
    1976,  3466,  2117,  3467,  3468,  5465,  3502,  1977,  3470,  1714,
    1715,  1716,  1717,  1718,  1719,  1720,  1721,  2119,  2120,  5481,
    2121,  5431,  2142,  5432,  5433,  2151, -2349,  2164,   626,   172,
     173,  3231,  1186,  3719,  2167,  2757,  2758,  4482,  3237,  1978,
    2166,  4485,  1347,   935,  4487,  2168,   934,  2172,  1347, -1051,
    2770,  2171,  3257,  2174,  2177, -2319,  2175,  2184,  4911,  5464,
    4914,   788,  2185,  1347,  5600,  2194,  2201,  2212,  4270,  2698,
    4004,  2216,  2239,  2244,  1154,  1155,  1156,  1157,  5622,  4930,
    2256,  2255,  4271,  2240,  2257,  4390,  2266,  2270,  1526,  4935,
     686,   687,  1687,  1688,  2898,  5479,  4609,  2273,  2274,  5480,
    1979,  4940,  1687,  1688,  3472,  2296,  5613,  2326,  4610,  2332,
    5508,  5509,  2707,  2336,  3503,  2346,  2357,  2361,  4958,  2379,
    4369,   935,  2383,  5461,  2410,  2411,  5886,  2436,  4611,  2435,
    2437,  1980,  1687,  1688,  2440, -3039,  2441,  2449,  2453,  2202,
    2456,  2699,  2460,  2490,  2492,  2008,  2008,  4578,  2772,  2773,
    2493,  2513,  2528,  2529,  2530,  2531,  3258,  2533,  2534,  1687,
    1688,  2718,  4612,  3504,  2535, -2178,  2550,  2554,  4272,  2561,
    5465,  2203,  5483,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,   627,  2553,  4273,  2562,  5110,  3505,  3788,  5113,  5114,
    5709,  2563,   172,   173,   934,   934,  2564,  5462,  4923,  2106,
    4923,  2571,  4526,  4534,  2572,  2581,  4538,   628,  2582,  1347,
     741,  2585,  3416,  4542,  2589,  2583,  2584,  2232,  2586,  2588,
    4274,  5463,  2595,  2596, -2131,  2599,  2600,  2604,  -167,  5769,
    2609,  3789,  2616,  2834,  4275,  4636,  2640,  2620,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  2957,  5282,  2656,  2642,  2657,
    5526,  4613,  4645,  5481,  2643,   629,  2644,  5527,  3778,  3790,
    2658,  2645,  5466,  2648,   759,  4214,  4213,  1689,  2666,  1690,
    5868,  2671,  5528,   633, -1422,  2670,  2673,  1689,  4193,  1690,
    2674,  2816,   788,   788,  5878,  2233,  2680,  2682,  4666,  4665,
    5868,  2685,  2692,  5464,  2686, -2319,  5878, -2580,  2868,  2009,
     742,  2715,   760,  2730,  1178,  1753,   936,  1689,  3466,  1690,
    3467,  3468,  5807,  2738,  2350,  3470,  2739,  1222,  4614,  2743,
    2744,  2746, -1422,  5188,  2747,  3688,  4683, -1422,  2779,  2796,
     113,  4691,  2800,  4389,  1689,  2717,  1690,  5483,  2799,  2221,
    2222,  2223,  2224,  4794,   172,   173,  2804,  1184,  1359,  5769,
    2234,   -72,  2235,  1687,  1688,  2808,  3791,  2236,  2811,  4700,
    2814,  2817,  2824,  2849, -1051,  2829, -1422,  3473,   773,  1526,
    2873,  4453,  2107,   773,  2872,  2875,  2782,  2890,  3826,  2892,
    3466,  2893,  3467,  3468,   936,  2895,  1691,  3470,  2904,  2894,
    2905,  2906,   630,  2225,  2226,  2227,  1691,  2909,  2910,  5368,
    5529,   933,  2912,  3260,  5465,   686,   687,  2922,  3324,  2925,
     631,  3472,  2409,  5530,  2980,  4898,  2929, -3302,  3015,  2983,
    3031, -2319,  2237,  2932,  2941,  2942,  1691,  5466,  2944,  4759,
     788,   935,  2945,  5531,  2946,  4615,  2950,  4616,  5461,  2958,
    3393,  4390,  3003,  2962,  4453,  2984,  4830,  2228,  2229,   935,
    2993,  3007,   632,  1691,  4788,   633,  3008,  3010,   761,  3014,
    3027,  4691,  3469, -1558,  3036,  2238,  3042,  1721,  4804,  3049,
    3051,  3058,  4803, -1735,  2350,  3625,  3065,  3070,  2707,   933,
     773,  2834,   634,  3472,  1631,  4825,  4821,  1687,  1688,  3076,
     635,  1661,  4826,  4827,  1665,  3299,  3078,  3074,   788,  4691,
    3079,  3093,  3094,  4843,  3085,  4844,  4845,  3100,  4842,  3101,
    3107,  5314,  5462,  3104,  2693,  3105,  3106,  3138,  2230,  4691,
    3129,   686,   687,  3108,  3109,  4453,  4863,  2718,  1689,  5492,
    1690,  4874,  4873,  5593,  3142,  5242,  5463,   779,   939,  1687,
    1688,  3150,  4884,  3153,  3154,   939,  3184,  2404,  3185,  3213,
    3215,   113,  3216,  1766,  3217,  2239,  3219,  1222,  3220,  2783,
    2694,  3245,   853,  3252,  3256,  2106,  2240,  3276,  5850,  3270,
    3483,  5483,  5532,  3539,  4880,   113,  3283,   956,   111,  3280,
    3286,  3287,  4899,  3288,   956,  3289,  3291,  4617,  4618,  3292,
    2231,  1687,  1688,  4132,  3293,  3344,   854,  3347,  3354,   788,
    3350,  2695,  3357,  3392,  3360,   788,   961,   935,  5464,   963,
    3490,  3384,  3361,   961,  3362,  3363,   963,  3364,   856,  3365,
    3366,   934,  3367,  4124,  3368,   967,   968,  3369,   857,  3385,
    3408,  3370,   967,   968,  4945,  3371,  3372,  3410,  3411,  3373,
     721,   722,  3742,  1687,  1688,  3374,  3375,  1691,  3376,  3377,
    3414,  3378,  -823,  1347,   858,  4367,  3379,  1347,  4913,  3380,
    3381,  5466,  1689,  1880,  1690,  3382,  3383,  1687,  1688,   975,
     859,  5692,  2079,  3429,  3473,   860,   975,   723,  1687,  1688,
    4135,  3433,  3471,  1222,  3423,  3431,  2232,  3300,   981,  3434,
    3435,  2009,  2009,  3432,   936,   981,   986,   987,  3436,   934,
    3443,   861,  3439,   986,   987,  3444,  5729,  3445,  3451,  3476,
    3513,  -823,   936,  3514,  1689,   738,  1690,   724,  3515,  5465,
    3526,  3527, -1774,  3528,  2696,  3570,  3534,  5042,  4931,  3541,
     935,  3547,  4193,  3301,  3179,  3571,  2697,  3583,  2107,  3585,
    3586,  3601,  3602,  3212,  3608,  4619,  3473,  3609,  3610,  3180,
    3620,  4947,  3059,  3543,  2233,  4950,   172,   173,  3618,  4455,
     935,  3624,  2350,  4957,  3627,  3631,  1689,  3632,  1690,  3469,
    4259,   862,  3633,  3634,  3962,  3638,  3644,  3645,  2474,   788,
    2475,  1691,  3657,  4453,  3652,  1003,  2866,  3666,   863,   933,
    3682,   773,  1003,  1004,  1005,  1006,   864,    40,  3694,  3723,
    1004,  1005,  1006,  3696,  3701,  5101,  5076,   933,  5077,  1347,
    5104,  3702,  5536,  3302,  3724,  4368,  1766,  3273,  1689,  2234,
    1690,  2235,  3726,  -823,  3730,  3731,  2236,   865,  3747,  3739,
    3741,  3746,  3750,  1691,  3751,  1880,   866,   867,  2698,  3776,
    3995,  3469,  1689,  5102,  1690, -2080,  3784,  3785,  3829,  3830,
    3916,  3831,  5573,  1689,  3920,  1690,  3928,  3929,  3931,  5112,
    3960,  3284,  3285,   739,  4453,  4691,  4453,  3964,   788,  4453,
     936,  4691,  3970,  2809,  3975,  3303,  4453,  4453,  3296,  5127,
    5573,  4691,  3979,  3984,  3983,  1691,  3985,  3992,  3322,  3323,
     935,  2237,  3997,  4067,  3304,  3305,   725,  -823,  1881,  3306,
    3307,  3308,  4070,  4071,  4078,  4074,  5134,  4082,  4089,   646,
    2699,  5243,  4086,   726,   935,  4090,  4453,  4094,  5243,  5244,
    4691,  4097,  4691,  4098,  4099,  1974,  5244,  4100,   172,   173,
    4147,  4160,  4158,  1974,  2238,  4175,  5882,  1691,   727,  4170,
    4171,  5141,  4176,  -823,   773,  4186,  4367,  5175,  5536,  4184,
    4194,  4196,  4187,  3386,  3387,  3388,  3389,  4197,  4198,  4200,
    5178,  1691,  1974,  4201,  5184,   933,  4204,  3309,  4205,  4206,
    4219,  4220,  1691,  4223,  4237,  4242,  5466,  4244,   728,  4243,
    2133,  4246,  4248,   113,  4247,  2134,   775,  1118,  4249,  3471,
    5200,  4369,  4254,   936,  1119,  4262,  2135,  4260,  5222,  4280,
    1975,  5573,  -823,  4282,  4285,  4281,   738,  4291,  1975,   934,
    1120,  1976,  4304, -1860,  4326, -1865,  3310,  4331,  1977,  1976,
    1121,  1122,  1123,   936,  2239,  3179,  1977,   934,  4334,  4335,
    1124,  4338,  3262,  4348,  4339,  2240,  4353,  1975,  5223,  4366,
    3180,  4382,  5076,  4369,  4384,  4385,  4394,  4396,  1976,  4397,
    1978,  1882,  4408,  5879,  4413,  1977,  4416,  4418,  1978,  4419,
    4422,  3471,  4420,  4319,  4423,  1883,  4431,  1884,  4432,  4460,
    1881,  4323,  4433,  4434,  4442,  4468,  4489,  4495,  4488,  4492,
    4504,  4506,  4518,  4540,  4513,  4562,  4547,  1978,   933,  4565,
    4575,   935,  4576,  4587,  4591,  4594,  4595,  4603,  1885,  5258,
    3019,  4602,  4165,  4638,  4648,  4650,  3764,  4651,  4636,  2419,
    4654,  1979,  4691,  1886,  -823,  4698,  4697,  4655,   933,  1979,
    4658,  5270,  5270,  5272,  4684,  4685,  4453,  4692,  4693,  4699,
    4702,  4292,  4293,  4714,  3856,  4726,  4727,  -252,  5076,  4730,
    4734,  4736,  1980,  4750,  2406,  4761,  1887,  4762,  1979,  4763,
    1980,  1347,  1347,   936,   739,  2136,  4773,  4775,  3260,  3582,
    3260,  4793,  4797,  4798,  1888,  4867,  4870,  4875,  4878,  1125,
    4881,  4882,  4888,  4889,  4900,  4896,  2137,   936,  4897,  1980,
    5311,  2138,  4910,  1126,  4902,   934,  4928,  5316,  -823,  4568,
    4453,  4453,  4938,  4941,  4453,  4953,  4925,  4968,  4453,  4969,
    5328,  4965,  5413,  4973,  4370,  4988,  2350,  4970,  4971,   773,
    4976,  4977,  2139,  4981,  4989,  4691,  4994,  4990,  4996,  4999,
    5009,  5011,  5008,  1882,  5245,  5017,  5025,  5246,  5030,  5034,
    5031,  5245,  5035,  5039,  5246,  5536,  5247,  1883,  5044,  1884,
    5045,  5070,  5079,  5380,  2140,  1889,  5072,  5078,   933,  5081,
    5083,  5088,  1890,  5089,  5090,  5091,  5097,  5098,  5099,  5100,
    5046,  5103,  1891,  5107,  5106,  5108,  5123,  5124,  5129,  5132,
    1885,  5135,   933,  5140,  5049,  1892,   773,  3914,   930,  5179,
    1112,  5177,  4369,  5181,  1127,  1886,  5198,  4945,  5199,  5365,
    5201,  5202,  5212,  5213,   930,  5225,  5226,  5227,  5228,  5230,
    1176,  1231,  5238,  5234,  5241,  5235,  1893,  1112,   934,  1894,
    5255,  5252,  4371,  5264,  2750,  5266,  5267,  5275,  1887,  5274,
    5278,  1128,  5281,  5279,  5283,  1895,  1112,  5285,  5287,  5295,
    5300,  5302,  5305,  5303,  5307,  1129,  1888,  5309,   934,  5317,
    5312,   647,  5338, -2709,  5270,  5333, -2708, -2712,  4776, -2716,
    5356, -2717, -2719, -2721,   936, -2722,  2751, -2723,  3722,  5358,
     113,  5366,  5369,  5384,  5076, -2728,  5385, -2729,  5386, -2730,
   -2734,  5341,  5373,  5378,  5345,  5379,  5388,  5474,  5390,  5411,
    5399,  5474,  5422,  5400,  5405,  5407,  4453,  5434,  5449,  5450,
    5439,  4453,  5453,  5459,  5490,  5493,  2752,  5494,  5495,  5511,
    5504,  5521,  5452,  5520,  5222,  5524,  3862,  5541,  5550,  5552,
     773,  5553,  5554,  5578,   935,  5458,  5555,  1889,  5584,  5586,
    5588,  5563,  5489,  5565,  1890,  5566,  5591,  5590,  5592,  5596,
    5496,  5500,  5597,  5598,  1891,  5599,  5604,  5617,  5607,  5608,
    5627,  5630,  5623,  5635,  5223,  1112,  5638,  1892,  5683,   933,
    5733,  5650,  5660,  5665,  4455,  5655,  3814,  5664,  5666,  5669,
    5675,  5684,  5696,  5734,  5691,  5711,  5722,  5519,   934,  5738,
    3797,  3798,  5747,  3800,  3802,  5736,  3852,  5742,  1893,  5755,
    5270,  1894,  5788,  3863,  5543,  5803,  5792,  5816,  5804,  5805,
    5830,  5819,   934,  5831,  5832,  4370,  5840,  1895,  5842,  5551,
    5837,  3930,  2404,  3932,  3933,  5474,  5847,  5849,  5851,  3938,
    5854,  5855,  3641,  5869,  1112,  5881,  5559,  3946,  3183,  1528,
    3954,  5191,  3953,  5474,  5189,   930,  1837,   930,   930,   930,
    5190,  3734,  4346,  5537,   930,  5284,   930,  5547,  5657,  1328,
    5790,  4731,  5587,  5224,  2037,  4722,  5207,  5410,  5505,  5421,
    4962,  5371,  5364,  2427,   788,  3194,  4277,  5658,  4073,  4494,
    4908,  1434,  3359,  4580,  3961,  2883,  2885,  1112,  2884,  2886,
    2083,  2729,  1112,  5277,  5409,  2813,  3897,  5408,  4445,  2350,
    5131,  5615,  5254,  4657,   731,  4662,  5018,  3063,  5695,  5391,
    5763,  5259,  5839,  5823,  5637,  5841,  3223,  4786,  4443,  5775,
    4862,  5545,  1112,  4371,  5273,  5105,  5811,  5674,  4450,  5686,
    4574,  4621,  1112,  5595,  4536,  5688,  5693,  5326,  4920,  4926,
    4641,  4162,  4643,   773,  5826,  4639,   745,  5659,   746,  5798,
    5442,  4259,  4259,  5799,  5779,  5731,  5540,  5728,  4936,  5474,
    5270,  5308,  5270,  5270,  5306,  4284,  4447,  4860,  1851,  2053,
    3718,  2617,  5789,  1681,  3717,  5456,  5690,  5676,  3353,  5710,
    1683,  5325,  2781,  3175,  3073,   774,  3994,  3440,  4505,   934,
    5682,  5681,  3673,  2018,  3589,  1973,  2344,   936,  1355,  2017,
    1751,  3775,  4490,  3550,  4653,  3635,  4189,  5500,  3548,  2407,
    2254,  4652,  4703,  2191,  5297,  2665,  1965,  4715,  5519,  1112,
    1112,  1112,  1112,  2662,  1966,  1967,  5704,  5705,  1968,  1970,
    5087,   788,  5661,  1112,  2753,  4677,  5036,  2200,  2655,  5662,
    5723,  3272,  2676,  4754,  3773,  5474,  4183,  4753,  4182,  5616,
    5249,  5331,  5732,  5029,  5240,  5260,  3774,  5737,  1373,  3419,
    2012,  3264,  5270,  5270,  2754,  2755,  5270,  2756,  2757,  2758,
    2759,  2760,   756,  2761,  2762,  2763,  2764,  2765,  2766,  2767,
    2768,  4757,  2769,  2770,  2771,   747,  2144,   930,  2350,  2025,
    3406,  3438,   933,  2556,  5032,  3691,  3808,  5041,  4676,  4673,
    5760,  5770,  1245,  1452,  5771,  1446,  1227,  2807,  3144,  3667,
    3145,   788,  2519,  2019,  5474,  5474,  1230,  5822,   771,  3188,
    5332,  5885,  5263,  2149,  4812,  4509,  5787,  5786,  2607,  5092,
    5838,  5848,  5304,  5791,  5880,  5884,  3157,  1607,  4681,  5270,
    3587,  3656,  1188,  4670,  3030,  1189,  3125,  2869,  2624,  2448,
    3651,  3650,  1147,  4354,  3628,  3343,  2141,  1745,  4760,  3980,
    5357,  4456,  1278,  3725,   765,   749,  5474,   750,   751,   788,
    5291,     0,  5423,     0,     0,  1923,     0,     0,     0,     0,
       0,  2772,  2773,     0,     0,     0,     0,     0,     0,  5825,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5871,     0,  1112,     0,     0,  1899,
    5873,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2350,     0,     0,     0,   788,     0,     0,     0,
       0,     0,   788,     0,     0,     0,  2350,     0,     0,     0,
       0,     0,  2350,     0,     0,     0,     0,     0,  2350,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4355,  4356,  4357,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   934,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4395,     0,     0,  4398,     0,     0,  4404,
    4405,  4406,  4407,     0,  4409,  4410,  4411,  4412,     0,  4414,
    4415,     0,  4417,     0,     0,     0,  4421,     0,     0,     0,
    4424,  4425,  4426,  4427,     0,  4429,  4430,  1112,     0,  1112,
     930,  4435,  4436,     0,     0,  4440,  4441,  4475,  4478,     0,
    4481,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5050,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1112,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
    1112,     0,     0,     0,     0,  1112,     0,     0,     0,  1112,
    1112,  1112,     0,     0,     0,     0,     0,     0,     0,     0,
    1112,  1112,     0,     0,     0,     0,  1112,     0,  1112,  1112,
    1112,  1112,  1112,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1112,     0,  1112,     0,     0,
    1112,  1112,     0,  1112,  1112,  1112,     0,  1112,  1112,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1112,  1112,  1112,  1112,  1112,     0,  1112,  1112,
    1112,     0,     0,  1112,  1112,  1112,  1112,  1112,  1112,  1112,
       0,  1112,  1112,  1112,  1112,     0,  1112,  1112,  5142,  1112,
    1112,  1112,  1112,  1112,  1112,  1112,     0,     0,  1112,  1112,
    1112,  1112,     0,  1112,  1112,  1112,     0,  1112,  4631,  1112,
       0,  1112,     0,     0,     0,  1112,  1112,  1112,     0,     0,
    1112,  1112,  1112,  1112,  1112,     0,  1112,     0,     0,     0,
    4644,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
    1112,  1112,  1112,  1112,     0,     0,     0,     0,     0,     0,
       0,  1112,  1112,     0,  1112,  1112,     0,     0,  1112,  1112,
    1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,
    1112,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3844,     0,  3845,  3846,     0,     0,     0,     0,
    2153,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1112,     0,     0,     0,  3847,  1112,
    3848,     0,     0,     0,     0,     0,  3849,     0,     0,  1112,
       0, -1947,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3850,     0,     0,     0,     0,     0,     0, -1173,     0, -1947,
       0,     0, -1947,     0,     0,     0,     0,     0, -1173,     0,
   -1947,     0, -1947,     0,     0,     0,     0,     0,     0, -1947,
       0,     0,     0, -1947,     0,     0,  1112,   172,   173,     0,
       0,     0,  3851, -1947,     0,     0, -1947,     0,     0,     0,
   -1947,     0, -1947,     0,     0,     0,     0, -1947,     0,     0,
       0,     0,     0,     0, -1947,     0,  1112,     0,  1112,     0,
   -1947,     0,     0,  3852,     0, -1947,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1947,     0,     0,     0,
       0,     0,  1112,  4814,  4816,  4818,     0,     0,  3853, -1947,
    4823,  4824,  3854,     0, -1947,     0,  4829,     0,     0,     0,
    3855,     0,     0,  3856,  4836,  4801,     0,     0,  4841,     0,
       0,     0,     0,     0, -1947,     0,     0,     0, -1017,  4855,
   -1017,     0,     0,     0,     0,     0,  3857,  4828,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1947,     0,     0,
    5359,     0,     0,     0,     0,     0, -1947,  2026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3858,  3859,  3860,     0,  1112,     0,     0, -1947,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3861,     0, -1947,     0,     0,     0,
       0,     0, -1947, -1947,     0,     0,   172,   173,     0,     0,
       0,  3851,     0,     0,     0,     0, -1947,     0, -1947,  3862,
       0, -1947,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3863,     0,     0,     0,   930,     0,     0,
       0,  3864,     0,  3865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4964,     0,     0,     0,     0,
       0,     0,  3866,     0,     0,     0,     0,     0,     0,  3867,
       0,     0,     0,     0,  5454,     0,     0,     0,     0,  3855,
       0,  3868,     0,     0,     0,   930,     0,     0,  3869,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3870,     0,     0,     0,     0,     0,     0,
       0,  3871,     0,     0,  1112,  3872,  3873,     0,     0,     0,
       0,     0,  3874, -1017,  2850, -1017,  3875,     0,     0,     0,
       0,     0,  1112,     0,  3876,     0,     0,     0,     0,     0,
    3858,  3859,  3860,     0,     0,     0,     0,     0,   930,   930,
    1112,     0,  2026,  1112,  3877,     0, -1947,     0,     0,     0,
       0,  1112,  1112,  3861,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3878,     0,     0,     0,  3879,     0,     0,     0,  3862,     0,
       0,     0,     0,     0,  3880,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,  3851,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3864,     0,  3865,     0,     0,     0,     0,     0,     0,     0,
       0,  3881,     0,     0,     0,     0,     0,     0,     0, -1017,
       0,  3866,     0,     0,  3882,     0,  3883,     0,     0,     0,
       0,     0,     0,  1112,  1112,  1112,     0,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0,  3869,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3870,     0,  3855,  3884,     0,  5656,     0,     0,
    3871,  3885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3875,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3886,     0,
       0,     0,     0,     0,     0,     0,     0,  1112,     0,  3887,
    3888,  3889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3858,  3859,  3860,  1112,     0,
    3890,     0,  1112,  1112,     0,  1112,  1112,  3891,     0,     0,
       0,     0,     0,  3879,  1112,     0,  1112,     0,  3861,     0,
    4475,     0,  4478,  3880,  4481,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3892,     0,
       0,     0,     0,  3862,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,  3893,  3894,     0,     0,     0,  1112,     0,
    3881,     0,     0,     0,     0,     0,  3895,     0,     0,  3896,
       0,  1112,     0,  3882,  1112,  3864,     0,  3865,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
    4964,     0,     0,  2026, -1017,     0,  3866,     0,     0, -1947,
       0,     0,  3112,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,  2154,     0,  3884,  3868,     0,     0,     0,     0,
    3885,     0,  3869,     0,     0,  1112,     0,     0,     0, -1947,
       0, -1947,     0, -1173, -1947, -1947,     0,  3870,  5239,     0,
       0,     0,   172,   173,     0,  3871,     0,  3851,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3875,     0,     0,     0,     0,     0,  1112,     0,     0,     0,
       0,   930,     0,     0,     0,     0,     0,     0,     0,  3890,
       0,     0,     0,     0,     0,     0,  3891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,  3892,  3879,     0,
       0,     0,     0,     0,     0,  3855,     0,     0,  3880,     0,
       0,     0,  3893,  3894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3895,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3882,     0,
       0,     0,     0,     0,     0,     0,  3858,  3859,  3860,     0,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1112,     0,  4718,  3861,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3884,
       0,     0,     0,     0,     0,  3885,     0,     0,     0,     0,
       0,     0,     0,     0,  3862,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,  3864,     0,  3865,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5389,     0,     0,  3890,     0,     0,  3866,     0,     0,
       0,  3891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3868,     0,     0,     0,
       0,     0,     0,  3869,     0,     0,     0,     0,     0,     0,
       0,     0,  3892,     0,     0,     0,     0,     0,  3870,     0,
       0,     0,     0,     0,     0,     0,  3871,  3893,  3894,     0,
       0,     0,   930,     0,     0,     0,     0,     0,     0,     0,
    3895,  3875,     0,     0,     0,     0,     0,     0,     0,   930,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3464,   930,  4964,     0,     0,     0,
       0,     0,     0,   930,   930,   930,     0,     0,     0,  3879,
    1112,     0,     0,  1112,     0,     0,     0,     0,     0,  3880,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,  1112,     0,  1112,     0,  1112,  1112,  1112,
    1112,  1112,  1112,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,  1112,     0,  1112,     0,  3881,  1112,  1112,  1112,
       0,     0,     0,     0,     0,     0,  1112,  1112,  1112,  3882,
    1112,     0,  1112,     0,  1112,     0,  1112,     0,  1112,     0,
       0,     0,     0,     0,     0,     0,  1112,     0,  1112,     0,
    1112,  1112,  1112,  1112,  1112,     0,     0,  1112,     0,  1112,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
    3884,     0,     0,     0,     0,  1112,  3885,     0,     0,     0,
    1112,     0,     0,  1112,     0,  1112,  1112,  1112,     0,     0,
    1112,     0,     0,     0,     0,     0,  1112,     0,     0,     0,
       0,  1112,     0,     0,     0,     0,     0,     0,     0,  3112,
    1112,     0,     0,     0,     0,     0,  1112,     0,  1112,     0,
       0,  1112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,  1112,     0,  3890,     0,     0,  1112,     0,
       0,     0,  3891,     0,     0,     0,     0,  5628,  5629,     0,
    5631,  5632,  5633,  5634,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3892,  1112,     0,     0,     0,     0,     0,
       1,     2,     0,     0,     0,     0,     0,     0,  3893,  3894,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       3,  3895,     4,  1112,     5,     0,     6,  1176,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1112,   930,     8,     0,     9,    10,
       0,     0,     0,     0,     0,     0,    11,     0,  5703,   930,
       0,  5706,     0,    12,     0,     0,     0,     0,     0,  5714,
       0,     0,     0,  1112,  5724,     0,    13,     0,     0,     0,
       0,     0,    14,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    15,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    17,     0,     0,     0,     0,     0,
       0,     0,     0,  5781,     0,     0,     0,    18,     0,    19,
       0,     0,     0,     0,    20,     0,     0,  1112,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,    23,
       0,     0,     0,     0,     0,  3795,     0,     0,     0,    24,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,    27,    28,     0,    29,     0,     0,     0,     0,
      30,  3795,  3795,     0,     0,     0,    31,     0,     0,     0,
      32,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3913,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   930,  1112,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,    36,     0,    37,     0,     0,     0,
       0,    38,     0,     0,     0,     0,     0,  3795,  3795,     0,
       0,    39,    40,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,    44,     0,    45,     0,   930,     0,     0,     0,
       0,    46,     0,     0,     0,     0,     0,     0,    47,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
       0,     0,     0,     0,     0,     0,  1112,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1112,     0,     0,  1112,
       0,     0,     0,     0,    49,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    52,  1112,     0,
    1112,     0,  1112,     0,  1112,     0,     0,     0,     0,     0,
      53,     0,     0,    54,     0,     0,    55,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1112,  1112,     0,     0,     0,     0,
       0,  1112,     0,  1112,     0,  1112,     0,     0,     0,     0,
    1112,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     1,     2,     0,  1112,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,     0,     3,     0,     4,     0,     5,
       0,     6,     0,     0,     0,     0,     0,     0,     0,     7,
       0,     0,     0,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,     0,
       0,     8,     0,     9,    10,     0,     0,     0,     0,     0,
       0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,     0,
      59,    13,     0,     0,     0,     0,     0,    14,     0,     0,
      60,  3913,  3913,     0,     0,     0,     0,     0,    61,     0,
      15,     0,     0,     0,     0,     0,     0,     0,    16,     0,
      62,     0,     0,  1112,     0,     0,     0,     0,     0,    17,
       0,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
      63,     0,    18,    64,    19,  1112,     0,  1112,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    65,     0,     0,     0,    21,
       0,     0,     0,     0,     0,    66,     0,     0,     0,     0,
       0,     0,     0,    22,    23,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,    25,     0,     0,     0,     0,
      67,     0,     0,     0,     0,     0,    26,    27,    28,     0,
      29,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,    31,    68,     0,     0,    32,     0,     0,     0,    33,
      34,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3913,     0,
       0,     0,     0,     0,     0,     0,     0,    35,     0,    36,
       0,    37,     0,     0,     0,     0,    38,     0,     0,     0,
       0,     0,     0,     0,     0,   930,    39,    40,     0,     0,
       1,     2,     0,     0,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,     0,     0,     0,     0,     0,
       3,     0,     0,     0,     5,     0,     6,     0,     0,     0,
    3795,     0,     0,     0,     7,     0,    43,    44,     0,    45,
       0,     0,     0,     0,     0,     0,    46,  1112,     0,     0,
       0,     0,     0,    47,     0,     0,     8,     0,     9,    10,
       0,     0,     0,     0,     0,     0,    11,     0,     0,     0,
       0,     0,     0,     0,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    14,     0,     0,     0,     0,     0,     0,    49,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    17,     0,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,    19,
       0,     0,    52,   930,   930,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,     0,
       0,    55,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,    56,     0,  1112,  1112,
       0,  1112,     0,     0,     0,     0,     0,     0,    22,    23,
       0,     0,  1112,  1112,  1112,     0,     0,     0,     0,    24,
      25,     0,     0,     0,     0,     0,     0,  1112,     0,  1112,
       0,    26,    27,     0,     0,    29,     0,     0,     0,     0,
      30,     0,  1112,  1112,     0,     0,    31,     0,     0,     0,
      32,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
       0,     0,     0,     0,     0,     0,  1112,     0,     0,     0,
       0,     0,     0,     0,     0,  1112,     0,     0,     0,     0,
       0,     0,    35,     0,    36,     0,    37,     0,     0,     0,
       0,    38,     0,     0,  4000,  4001,     0,     0,     0,     0,
    4002,  4003,    40,    57,     0,     0,  1176,     0,     0,    41,
    4004,     0,     0,     0,     0,     0,     0,     0,  1112,    42,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    58,     0,     0,    59,  4005,     0,     0,     0,
       0,    43,     0,     0,    45,    60,     0,     0,  4006,     0,
       0,    46,     0,    61,     0,     0,     0,     0,    47,     0,
       0,     0,     0,     0,     0,    62,     0,     0,  4007,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
    3913,     0,     0,     0,     0,    63,     0,     0,    64,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4008,     0,    49,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
      65,     0,     0,     0,     0,  4009,  4010,     0,  4011,     0,
      66,     0,     0,    51,     0,     0,  4012,  4013,  4014,     0,
       0,     0,     0,     0,     0,     0,     0,    52,  1190,     0,
       0,     0,     0,     0,     0,    67,  4015,     0,     0,   653,
      53,     0,     0,    54,     0,     0,    55,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,    68,     0,     0,
       0,    56,  1191,  1192,     0,     0,     0,     0,     0,     0,
       0,  4016,  1193,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    10,     0,
       0,     0,     0,     0,     0,  4017,     0,     0,     0,     0,
       0,  4018,     0,  3913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1112,  1112,     0,     0,
       0,     0,     0,     0,     0,  4019,  4020,  4021,     0,     0,
       0,     0,   172,   173,     0,     0,     0,  1194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4022,
    4023,  1195,     0,     0,     0,     0,     0,     0,     0,     0,
     930,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4024,     0,  4025,  4026,     0,     0,     0,    58,     0,     0,
      59,     0,     0,     0,     0,     0,     0,     0,  4027,     0,
      60,  3464,     0,     0,  1112,     0,     0,  1196,    61,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   930,     0,
      62,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,     0,  4028,     0,  4029,     0,     0,
      63,     0,     0,    64,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4030,     0,
       0,     0,     0,     0,     0,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,  4031,     0,     0,     0,    66,     0,     0,     0,  1112,
       0,     0,  4032,  4033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1112,  1112,     0,
      67,     0,     0,     0,     0,  1198,     0,     0,     0,     0,
       0,     0,     0,     0,  4034,  1112,     0,     0,     0,     0,
       0,     0,    68,  4035,  1199,     0,     0,     0,  1112,     0,
       0,     0,     0,  1200,  4858,     0,  3845,     0,     0,     0,
       0,     0,     0,     0,     0,  1201,     0,  3913,     0,  3913,
       0,     0,     0,     0,     0,     0,  1202,     0,     0,     0,
    3847,     0,  1112,     0,  1112,     0,     0,     0,  3849,  4036,
    4037,  4038,     0,     0,     0,     0,     0,  4039,  4040,     0,
    1203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2026,     0,     0,     0,  4041,  4042,     0,     0,     0,     0,
       0,     0,  4859,     0,     0,     0,     0,     0,     0,     0,
   -2319,  1204,     0,     0,  1205,     0,  1206,     0,  4043,  4044,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4045,     0,   172,
     173,     0,  1207,  1208,  3851,     0,     0,     0,     0,     0,
    1209,  1210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1211,     0,  4046,
       0,     0,     0,     0,     0,  3852,     0,     0,     0,  4000,
    4001,     0,     0,     0,     0,  4002,  4003,     0,     0,  1212,
       0,     0,     0,     0,     0,  4004,     0,     0,  3464,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1213,     0,     0,     0,  3854,     0,     0,     0,   930,     0,
       0,  4005,  3855,     0,     0,  1112,     0,     0,     0,  4047,
       0,     0,  4048,  4006,     0,  4049,   930,     0,     0,     0,
       0,     0,  4050,     0,     0,     0,     0,     0,  3857,     0,
       0,     0,     0,  4007,     0,     0,     0,     0,  4051,     0,
       0,     0,     0,     0,     0,     0,  1214,     0,     0,     0,
    3464,     0,     0,     0,     0,     0,     0,  4052,  1114,     0,
    1215,     0,     0,  3858,  3859,  3860,     0,  4008,     0,     0,
       0,  1216,     0,     0,  1217,  1218,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,  3861,     0,     0,  1219,
    4009,  4010,     0,  4011,     0,  1112,     0,     0,     0,     0,
       0,  4012,  4013,  4014,  1114,     0,     0,     0,     0,     0,
       0,  3862,     0,     0,     0,     0,     0,     0,     0,     0,
    1112,  4015,     0,     0,     0,  1220,     0,     0,     0,     0,
       0,     0,  1221,     0,     0,  3863,     0,     0,     0,     0,
       0,     0,     0,  3864,     0,  3865,     0,     0,     0,     0,
       0, -3084,     0,  1222,     0,     0,  4016,     0,     0,     0,
       0,     0,     0,     0,  3866,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   930,     0,     0,     0,     0,     0,
    4017,     0,     0,  3868,     0,     0,  4018,     0,     0,     0,
    3869,     0,     0,     0,     0,     0,     0,     0, -1017,     0,
   -1017,     0,     0, -3084,     0,  3870,     0,     0,     0,  1223,
    4019,  4020,  4021,  3871,     0,  1112,     0,  3872,     0,     0,
       0,     0,     0,  1114,  3874,     0,     0,  2026,  3875,     0,
       0,     0,     0,     0,  4022,  4023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3877,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,  3851,     0,     0,     0,  4024,  3879,  4025,  4026,     0,
       0,     0,  1114,     0,     0,     0,  3880,   930,     0,     0,
       0,     0,  4294,  4027,  4295,     0,  4296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   930,     0,     0,
       0,     0,     0,  3881,     0,     0,     0,  1112,     0,     0,
    4028,     0,  4029,     0,     0,  1114,  3882,     0,  3883,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,  3855,
       0,     0,     0,  4030,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,  1584,     0,     0,  4031,  3884,     0,     0,
    1114,     0,     0,  3885,     0,     0,     0,  4032,  4033,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3858,  3859,  3860,     0,     0,     0,     0,     0,  1584,  4034,
       0,     0,     0,     0,     0,     0,     0,     0,  4035,     0,
       0,     0,     0,  3861,     0,     0,     0,     0,     0,  5475,
       0,     0,  3890,  5475,     0,     0,     0,   930,     0,  3891,
       0,     0,     0,     0,  1112,     0,     0,     0,  3862,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,  1114,  1114,
    1114,   930,     0,  1584,  4036,  4037,  4038,     0,     0,     0,
    3892,  1114,  4039,  4040,     0,     0,     0,     0,     0,     0,
    3864,     0,  3865,     0,     0,  3893,  3894,     0,     0,  4041,
    4042,     0,     0,     0,     0,     0,     0,     0,  3895, -1017,
       0,  3866,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4043,  4044,     0,     0,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0,  3869,     0,     0,
       0,     0,  4045,     0,     0,     0,     0,     0,     0,  5576,
       0,     0,  3870,     0,     0,     0,     0,     0,     0,     0,
    3871,     0,     0,     0,     0,     0,     0,  5475,     0,     0,
       0,     0,     0,     0,  5288,  3875,     0,  5576,     0,     0,
       0,     0,     0,     0,     0,  5475,     0,     0,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3879,  4047,     0,     0,  4048,  5648,     0,
    4049,  5648,     0,  3880,     0,     0,     0,  5289,   930,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,  1584,     0,
       0,     0,     0,  4051,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3881,     0,  4052,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3882,     0,     0,     0,     0,     0,     0,
       0,  5475,     0,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3884,     0,     0,     0,     0,  5648,
    3885,     0,     0,     0,  5648,     0,     0,     0,     0,     0,
       0,  5648,     0,     0,  1584,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5475,     0,     0,
       0,  1112,     0,     0,     0,     0,     0,     0,  1112,  3890,
       0,     0,     0,     0,     0,     0,  3891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5648,     0,     0,
       0,  5780,     0,     0,     0,  1114,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3892,     0,     0,
       0,     0,  5648,     0,  5648,  5648,     0,     0,     0,     0,
       0,     0,  3893,  3894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3895,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5648,     0,     0,  5648,     0,  1114,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,     0,     0,  1114,  5648,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,  1114,     0,
       0,     0,     0,  1114,     0,     0,     0,  1114,  1114,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,  1114,
    1584,     0,     0,     0,  1114,     0,  1114,  1114,  1114,  1114,
    1114,   930,  1114,     0,     0,  1584,  1584,     0,     0,     0,
       0,     0,     0,  1114,  1112,  1114,     0,     0,  1114,  1114,
       0,  1114,  1114,  1114,     0,  1114,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,  1114,  1114,  1114,  1114,     0,  1114,  1114,  1114,     0,
       0,  1114,  1114,  1114,  1114,  1114,  1114,  1114,     0,  1114,
    1114,  1114,  1114,     0,  1114,  1114,     0,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,     0,     0,  1114,  1114,  1114,  1114,
       0,  1114,  1114,  1114,     0,  1114,     0,  1114,     0,  1114,
       0,     0,     0,  1114,  1114,  1114,     0,     0,  1114,  1114,
    1114,  1114,  1114,     0,  1114,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,  1114,  1114,
    1114,  1114,     0,     0,     0,     0,     0,     0,     0,  1114,
    1114,     0,  1114,  1114,     0,     0,  1114,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,     0,
       0,  1114,     0,     0,  4000,  4001,  1584,     0,     0,     0,
    4002,  4003,     0,  1584,     0,     0,     0,     0,     0,     0,
    4004,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,  4005,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,  4006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4007,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4008,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4009,  4010,     0,  4011,     0,
       0,     0,     0,     0,     0,     0,  4012,  4013,  4014,     0,
       0,     0,     0,     0,  1114,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1584,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4016,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4017,     0,     0,     0,     0,
       0,  4018,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4019,  4020,  4021,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,  4022,
    4023,     0,  1584,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4024,     0,  4025,  4026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4027,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4028,     0,  4029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,  4031,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,  4032,  4033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,  1114,
    1114,     0,     0,     0,  4034,     0,     0,     0,     0,     0,
       0,     0,     0,  4035,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4036,
    4037,  4038,     0,  1584,  1584,     0,     0,  4039,  4040,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4041,  4042,     0,     0,     0,     0,
       0,  1114,  1114,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1584,     0,     0,     0,     0,  4043,  4044,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4045,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1584,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,  1584,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    1114,  1114,     0,  1114,  1114,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4047,
       0,     0,  4048,     0,     0,  4049,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,  4051,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
       0,     0,  1114,     0,     0,     0,     0,  4052,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1584,     0,  1584,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,  1584,     0,     0,
    1584,  1584,  1584,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1080,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,  1114,     0,     0,  1241,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
       0,  1114,     0,  1114,     0,  1114,  1114,  1114,  1114,  1114,
    1114,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,  1114,     0,     0,  1114,  1114,  1114,     0,     0,
       0,     0,     0,     0,  1114,  1114,  1114,     0,  1114,     0,
    1114,     0,  1114,     0,  1114,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,  1114,     0,  1114,  1114,
    1114,  1114,  1114,     0,     0,  1114,     0,  1114,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,  1114,     0,
       0,  1114,     0,  1114,  1114,  1114,     0,     0,  1114,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,  1433,     0,  1114,     0,  1114,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
    1584,  1114,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,  1497,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,  1547,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,  1574,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1589,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,  1584,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1682,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1584,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1878,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1584,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,  1114,     0,
    1114,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,  1584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,  1114,     0,     0,     0,     0,     0,  1114,
       0,  1114,     0,  1114,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1584,  1114,  1114,     0,     0,
       0,     0,     0,     0,  2066,     0,  2067,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2147,     0,  2147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2176,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,  2190,     0,     0,     0,  2195,     0,  2197,     0,
       0,     0,     0,  1114,     0,  1114,     0,  2213,  2214,     0,
       0,     0,     0,  2243,     0,  2246,  2247,  2248,  2249,  2250,
       0,  2252,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2260,     0,  2263,     0,     0,  2264,  2265,     0,
    2267,  2268,     0,     0,  2271,  2272,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2281,
    2282,  2287,  2289,  2290,     0,  2293,     0,  2295,     0,     0,
    2297,  2298,  2299,  2302,  2303,  2304,  2305,     0,  2306,  2307,
    2308,     0,     0,  2315,  2316,     0,     0,  2320,  2321,  2322,
       0,     0,     0,     0,     0,  2328,  2329,  2330,     0,     0,
    2333,  2334,  2335,     0,  2337,     0,  2339,     0,  2340,     0,
       0,     0,  2343,  2287,  2345,     0,     0,  2351,  2352,  2353,
    2354,  2355,     0,  2356,     0,     0,     0,     0,     0,     0,
    2360,     0,     0,     0,     0,     0,     0,  2365,  2366,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,     0,
       0,  2462,     0,     0,     0,     0,  2472,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2472,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2540,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2573,     0,  2578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,  1114,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,  1114,  1114,     0,     0,     0,     0,     0,     0,  2601,
       0,     0,     0,     0,     0,  1114,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2672,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2842,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2870,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1241,     0,     0,
    2889,     0,     0,     0,     0,     0,     0,     0,  2896,  2897,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2952,  2954,  2956,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,  3038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3046,     0,  3047,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3069,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,  3075,     0,     0,     0,     0,
       0,     0,     0,     0,  1584,  1114,  1114,     0,  3086,     0,
       0,  2472,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    3123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3133,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3266,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3266,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3356,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1584,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,  3488,     0,     0,
    3489,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3516,     0,
       0,     0,  3518,     0,  3519,  3520,  3521,  3522,  3523,  3524,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3529,
       0,  3530,     0,     0,  3531,  3532,  3533,     0,     0,     0,
       0,     0,     0,  3535,  3536,  3537,     0,  3538,     0,  3540,
       0,  3542,     0,  3544,     0,  3546,     0,     0,     0,     0,
       0,     0,     0,  2299,     0,  3549,     0,  2299,     0,  3552,
    3553,  3554,     0,     0,  3555,     0,  3556,     0,     0,  3557,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3558,     0,     0,     0,     0,     0,     0,     0,
    3565,     0,  3566,  3567,  3568,  1114,     0,  3569,     0,     0,
       0,     0,     0,  3573,     0,     0,     0,     0,  3584,     0,
       0,     0,     0,     0,     0,     0,     0,  3588,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,  3595,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2472,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2472,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2578,  1584,  1584,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2578,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1584,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3769,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,  3927,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
       0,     0,     0,  4072,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,  4076,     0,     0,  4077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4102,  4103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4126,     0,  4127,     0,  4128,
       0,  4129,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4150,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4173,  4174,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,  3266,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2472,  2472,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2472,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,  2578,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3266,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3266,     0,  4337,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4493,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4597,  4598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4605,
    4606,  4607,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4627,     0,  4628,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4634,
    4635,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2578,     0,     0,     0,  2578,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4876,  4877,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4952,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3266,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3266,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2472,  2472,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2578,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5080,
       0,  5082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3266,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3266,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2468,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2469,   939,   940,   941,   942,     0,
       0,     0,     0,     0,     0,     0,   943,   944,     0,   945,
       0,     0,     0,     0,     0,     0,   946,   947,     0,     0,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,  2470,     0,
       0,   958,     0,     0,     0,     0,  5603,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1682,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,  2471,     0,     0,
    5689,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,  2578,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,  2578,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
       0,     0,     0,     0,     0,  1070,  1071,     0,     0,     0,
       0,  1072,     0,     0,     0,  2374,  1073,     0,     0,     0,
    1074,  1075,     0,     0,  1076,  1077,   938,   939,   940,   941,
     942,     0,     0,     0,     0,     0,     0,     0,   943,   944,
       0,   945,     0,     0,     0,     0,     0,     0,   946,   947,
       0,     0,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,  2375,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,    38,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,  2284,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2285,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,  2286,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,  1546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,  2575,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,  2576,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,  2951,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,   983,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
    2953,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,  2955,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,  4675,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,  2576,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,   983,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1573,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,  2145,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  2146,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  2146,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,  3545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,  3564,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,  5766,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,  1539,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,     0,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1540,  1541,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,  1675,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,     0,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1540,
    1541,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,  1677,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,     0,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1540,  1541,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,     0,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,  2395,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,  2397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,     0,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,     0,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,  1539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,     0,     0,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,   939,   600,   601,   602,
    1069,     0,     0,     0,     0,     0,     0,     0,     0,  5567,
    5568,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5569,     0,     0,     0,     0,  1075,     0,     0,  1076,  1077,
       0,     0,     0,     0,     0,   956,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,     0,     0,   963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   967,   968,     0,     0,     0,  1576,  1577,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   981,     0,     0,     0,
       0,     0,     0,     0,   986,   987,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1003,     0,     0,     0,     0,     0,     0,
       0,  1004,  1005,  1006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,  1578,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  2428,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
    2832,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,  2429,   560,   561,  2430,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     0,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1076,  1077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,  3080,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,     0,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,  2833,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  1163,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2833,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1164,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1165,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,  1166,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,  1167,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,  1168,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1169,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,  1170,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
    1171,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1172,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,  1173,   596,   597,
     598,   599,  1163,   600,   601,   602,   603,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1164,     0,     0,     0,  1174,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1165,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,  1166,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,  1167,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,  1168,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,  1169,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,  1170,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,  1171,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1173,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     852,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1174,     0,
       0,     0,     0,     0,     0,   854,     0,     0,     0,     0,
     855,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   857,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,   859,
       0,     0,     0,     0,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
     861,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     862,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   863,     0,     0,
       0,     0,     0,     0,     0,   864,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,   865,     0,     0,     0,
       0,     0,     0,     0,     0,   866,   867,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   868,
     286,   287,   288,   289,   869,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   870,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   871,   457,   458,   459,   872,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   873,   478,   479,   480,   481,
     874,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   875,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   876,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,  1141,   853,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   854,
       0,     0,     0,     0,   855,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   858,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,   859,     0,     0,     0,     0,   860,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   786,     0,     0,
       0,     0,     0,     0,   861,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   862,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   863,     0,     0,     0,     0,     0,     0,     0,   864,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,     0,     0,
     865,     0,     0,     0,     0,     0,     0,     0,     0,   866,
     867,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,  1142,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   868,   286,   287,   288,   289,   869,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   870,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   871,   457,
     458,   459,  1143,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   873,
     478,   479,   480,   481,   874,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   875,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
    1806,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   876,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     0,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  1901,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1576,  1577,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,  4687,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,  1902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     4,   600,   601,   602,   603,
       0,     0,     0,     0,   896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,  4706,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   738,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
     172,   173,     0,     0,     0,  3179,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5367,     0,
    3180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,  4707,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,  4211,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,  4449,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   690,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,  1759,   600,   601,   602,
     603,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1761,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,  4000,
    4001,     0,  1762,     0,     0,  4002,  4003,     0,     0,     0,
       0,     0,     0,     0,     0,  4004,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4007,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4009,  4010,     0,  4011,     0,     0,     0,     0,     0,     0,
       0,  4012,  4013,  4014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4015,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4016,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4017,     0,     0,     0,     0,     0,  4018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4019,  4020,  4021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4022,  4023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,  5143,   206,  5144,  5145,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,  5146,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    5147,   259,  5148,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,  5149,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,  5150,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,  5151,  5152,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,  5153,
     343,   344,   345,   346,   347,   348,   349,   350,  5154,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,  5155,  5156,  5157,   400,   401,   402,
     403,   404,  5158,  5159,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,  5160,
    5161,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,  5162,  5163,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,  5164,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,  5165,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,  5166,   557,   558,  5167,   560,   561,
    5168,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,  5169,   586,   587,   588,   589,   590,   591,
     592,   593,   594,  3456,   596,   597,   598,   599,  1775,   600,
     601,   602,  5170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1776,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   690,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,  1759,   600,   601,   602,
     603,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,  1759,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,  1294,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1295,  1296,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1297,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,  1395,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   786,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     4,   600,   601,   602,   603,     0,     0,
       0,     0,   896,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1669,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -449,  -449,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    -449,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,  -469,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -469,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  -469,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,  -466,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -466,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,  -466,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,  1525,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     4,
     559,   560,   561,   562,   563,   564,   565,   566,   896,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   897,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   901,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   903,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   904,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,  -471,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,   905,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   906,     0,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     4,   559,   560,   561,   562,   563,   564,
     565,   566,   896,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    3422,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  3474,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,  3679,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,  3692,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     4,
     559,   560,   561,   562,   563,   564,   565,   566,   896,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   897,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   901,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   903,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   904,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,  4075,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,   905,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   906,     0,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     4,   559,   560,   561,   562,   563,   564,
     565,   566,   896,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    4967,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  -453,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,     0,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     4,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
    1744,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,    13,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,     0,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   568,   569,   570,
       0,   572,   573,   574,   575,  3452,  3453,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    3454,  3455,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  3456,   596,
     597,   598,   599,     0,   600,   601,   602,   603,  1395,   855,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,  1395,   600,
     601,   602,   603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,  1330,   600,
     601,   602,   603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   855,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1331,     0,     0,     0,     0,  1332,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,     0,   600,
     601,   602,   603,  2202,     0,     0,     0,  4871,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3788,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
    3791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,     0,   600,   601,   602,   603,  2202,     0,     0,     0,
    5679,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3788,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3789,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,  3791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,  2202,
       0,     0,     0,  5784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3788,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   690,     0,     0,
       0,     0,     0,     0,     0,     0,  3791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,     0,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,     0,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,  3096,   600,   601,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   786,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,  1752,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1752,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  2487,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  3172,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,  4802,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,     0,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,     0,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,  4820,   600,   601,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,  3110,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,     0,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3111,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2347,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5864,     0,     0,     0,     0,     0,     0,  2348,  5865,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1773,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1990,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2362,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2347,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2348,  5865,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    38,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  1578,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1579,
       0,     0,     0,     0,     0,     0,     0,  1076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,  1332,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  1578,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2347,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2348,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    2833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,  4768,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4448,
       0,     0,     0,     0,     0,     0,     0,  4449,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4449,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   766,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   767,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   768,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4449,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  2865,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2406,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   686,   687,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5215,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5216,   657,  5217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1513,   600,   601,   602,   603,
    1514,     0,     0,     0,     0,     0,     0,     0,     0,  2866,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,  1515,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1445,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    2809,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
    3986,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    4215,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
    4682,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    5026,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    5261,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1761,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,  1762,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3968,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4255,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5497,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   698,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,  1921,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2498,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,  3199,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,  3200,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3456,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,     0,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3111,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1511,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,     0,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,     0,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,     0,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   172,   173,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,   563,   564,
     565,   566,     0,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,     0,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,     0,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   172,   173,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,     0,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,     0,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,   563,   564,   565,   566,
       0,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603
};

static const yytype_int16 yycheck[] =
{
       3,    44,   163,    68,     0,  1670,   672,     0,   907,   671,
     672,     0,  1357,    21,   896,   171,   898,   899,   900,   665,
    1743,  1736,    25,   905,  1723,  1384,    29,     0,  1565,  1355,
     671,    34,   671,   671,    37,  1558,   161,   671,     0,  1782,
    1879,  2095,  1223,    45,    52,   697,  1596,  1357,    51,  1451,
      58,  2085,  3087,    30,    57,   781,  2885,  2886,    61,  3346,
    3282,   737,  3381,   845,  2687,   741,   742,  2875,  3346,  3138,
    1780,  2567,    68,  1908,   752,  1574,  3421,  1493,   638,  3756,
    1851,  2899,   976,  2901,  3728,  2625,  3262,  1388,  3296,  3493,
     638,  1388,  1349,   714,  1463,   938,   717,  1291,  1796,  1797,
    1736,  2565,   171,  2063,   159,  4454,  3284,   171,   668,  3285,
    2902,   649,   171,   171,  3322,  3323,  2027,  3152,   171,  2728,
     668,  1447,   125,  1901,  2593,  2825,  3217,   665,  1331,  2653,
    2797,   781,  1801,   671,   824,  3733,  3844,  2728,  2797,   135,
    3346,  3844,   135,  3352,  3844,  4459,  1168,  1169,  1170,   152,
     153,  1820,  4576,   156,    28,  1177,   159,   160,     6,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,    27,   135,     6,   171,  1845,  1846,   171,  3856,
    3388,  3389,   171,     6,    12,    11,  1901,  4326,  2797,    11,
     156,    11,    47,  3845,  4722,  3847,    50,  2129,  3850,  2131,
    2132,  1899,     9,    10,     6,     6,  2797,    93,  2039,   171,
      61,  1934,   976,    95,  1979,  3003,   105,    60,  2662,  1136,
     152,   156,  4558,     9,    10,  2720,    26,  1070,  1071,  1072,
    4928,  3883,  1426,   764,     9,    10,  1694,    65,  4422,  1138,
      63,  1084,     9,    10,  1702,  1703,  2787,  1705,  1706,     9,
      10,   763,  2083,    26,   105,   197,    11,  1021,    80,   238,
       9,    10,   238,    61,  1202,  1901,    42,  4010,  4011,    91,
      61,  4014,     9,    10,    11,  2799,     9,    10,  4021,   211,
       9,    10,  2652,  2653,  4027,  3395,  1224,   238,  3326,    80,
     265,     9,    10,    61,    90,     9,    10,   120,    61,  3368,
      91,   115,     9,    10,    61,     9,    10,   105,    10,    93,
      80,   196,  1076,     9,    10,   170,  2709,    83,  4869,    80,
      95,    91,    32,   299,  3062,    11,   130,   251,    80,  2052,
      91,   265,  1522,    80,    12,   185,   294,   105,   263,    91,
      80,   117,   105,    86,    91,  4301,     9,    10,   105,   223,
    3138,    91,   128,   114,   748,   121,     9,    10,   896,   135,
     898,   899,   900,     9,    10,  3344,   114,   905,    69,   907,
     166,   141,  4379,    86,   649,    57,   284,   184,   105,   186,
     218,     9,    10,  1225,  2848,   156,   105,    65,     9,    10,
     665,   167,   105,   363,   141,   137,   671,   152,   184,  4839,
     186,   319,     9,    10,  5172,  4468,   128,    89,   802,   184,
     233,   186,  4794,     9,    10,   197,   221,   184,   299,   186,
    2560,  3491,  3492,   105,   184,    93,   186,   375,   114,  2799,
    3500,   211,  3502,   176,  3504,   184,   437,   186,   238,   180,
     265,   180,  1864,    28,   270,     9,    10,   184,   140,   186,
     180,   184,   228,   186,   238,   184,   211,   186,   281,    76,
    2183,  5437,   105,   180,   165,   288,   184,   149,   186,   649,
     184,   351,   186,   574,    63,   146,   299,   184,   105,   186,
     184,   613,   186,   259,   325,   665,   299,    58,   184,   233,
     186,   233,   100,   316,   112,   177,   303,  1261,   623,   180,
     625,   626,   627,   628,   180,   630,   631,  5136,   180,   634,
     635,   277,  2546,  2445,  2446,  2447,  2448,   303,  3837,   636,
     247,   184,  3494,   186,   284,  2559,   299,   297,   303,  3738,
     273,   184,   284,   186,  1950,  3493,   303,  4961,   184,   679,
     186,  3499,   446,   303,   288,  3614,   288,  3505,  1465,  5486,
     297,   237,    17,   124,   303,   316,   184,   299,   186,   826,
     273,   118,  1252,   184,  5815,   186,   303,    32,   125,    34,
     303,   149,  3607,  1490,   303,   842,    29,   184,  1937,   186,
    3368,    34,   396,   638,  5835,   303,   204,   719,   184,   303,
     186,   731,   274,  1357,   719,   720,   303,   283,  1219,   303,
    1138,  4005,   118,  4007,   265,   297,   607,   303,   518,   125,
     451,  4015,  4948,   668,   265,   617,   299,   265,   621,   329,
     184,   896,   186,   898,   899,   900,     9,    10,   233,   632,
     905,   299,   907,   190,   637,   638,   691,  4041,   223,  1315,
     303,  1317,   213,   353,  1320,  1321,  1322,     9,    10,   704,
     303,    17,   237,  1331,   356,   326,  4060,   303,   462,   662,
     777,   292,  3908,   294,  4727,   668,   584,  5435,   671,  1563,
    2039,   238,   307,   238,   190,   303,   777,  5117,  1460,   296,
     560,   684,   303,   288,   142,  1579,   663,    81,   691,   649,
     594,   114,   281,  3899,   299,  5324,   303,  1540,  1541,  5675,
     703,   704,   482,    97,   706,   665,   238,   303,  2547,   679,
     284,   671,   714,  2456,  2083,   717,   896,  3326,   898,   899,
     900,  3245,   560,   848,   849,   905,  2027,   907,  3395,   152,
    2027,  1753,   126,   736,  2103,  3326,  3395,   622,   132,   303,
       9,    10,   284,   263,    61,  2455,  1436,  2887,   803,   752,
     208,  5688,  1774,  3961,  3311,   238,  5138,   494,   238,   584,
    2182,   447,  4718,   618,  1414,   536,   769,   763,  1971,   717,
     695,   772,  4779,   284,   753,   169,  1466,   753,   781,  1982,
     783,   636,   484,   391,  3822,  1431,  3395,     9,    10,   844,
    5341,   146,   379,  4536,   769,   650,     9,    10,   777,  1563,
     803,   184,   753,   186,  3395,   122,   714,   635,  3252,   812,
     734,   769,  3256,   745,  1578,  1579,  4559,   186,   795,   674,
    4563,   824,   184,   826,   186,   573,  3614,   769,  4571,  3324,
    1747,   834,  2667,   836,   769,   838,   839,   840,   841,   842,
     757,   844,  1736,  1493,   778,   762,   689,   764,  1538,  3390,
    1767,  5035,  3962,     9,    10,  1386,  2355,  2356,   660,   660,
     903,  3840,  1800,  1138,   329,  1803,   843,  2536,  1380,   846,
     759,  5207,   838,   839,   840,  3245,  1814,  1794,  2709,  1817,
     734,  1724,   347,  1821,  3622,  2079,   772,   772,   353,  5417,
     772,   772,   895,  1431,   897,  2660,  2661,  2728,   772,  1551,
    2832,   904,  5600,   906,  3297,     9,    10,   708,   759,   631,
    1848,  1849,  1850,  1461,   379,   184,   912,   186,   921,   912,
     303,   769,   772,   912,   279,  2383,  2384,   753,  2386,  2387,
     758,   753,  4002,   753,   748,  1329,   896,   769,   898,   899,
     900,   303,  5081,  5367,  5083,   905,   769,   907,     9,    10,
     912,   263,   560,   753,   776,   751,  2787,   635,  1138,   772,
     733,   759,   184,   770,   186,  1729,  2797,   772,  1620,   753,
    5284,   184,  1736,   186,  2164,   560,  3440,  4047,  4048,  4049,
     723,  2171,  4052,  1635,   686,   776,  1638,   769,  1640,   775,
     745,   759,  1644,  1645,  1646,  4065,   759,   772,   753,   775,
    1652,  1843,   759,   770,   770,   772,   776,  1901,  1073,  3797,
    3798,   721,   772,  3801,  3802,   776,  5079,     9,    10,  3807,
    3808,   770,  1748,   772,   776,   769,  1704,   769,   184,   776,
     186,   772,   759,   772,   303,   772,   776,  2808,   496,   772,
     759,   770,   772,  4001,   679,  4003,   759,  4005,  4294,  4007,
    3838,   770,   770,   772,   772,   772,   770,  4015,   772,   760,
     761,   762,   763,   770,  4022,   772,  4024,   753,   772,  3322,
    3323,   366,  1075,  4031,   770,   211,   772,  1073,     9,    10,
     184,   303,   186,  4041,  1073,     9,    10,  4045,   770,   772,
     303,   772,  1818,  4051,  4066,   703,   772,   265,  1748,  2822,
     772,    33,  4060,  4061,  4062,  4063,  4064,  4316,   769,   772,
    1786,  4333,   683,  1168,  4336,  1170,   759,   770,   769,  1174,
    1175,   769,  4720,   184,   770,   186,   772,   770,   263,   772,
     499,  4089,   759,  1136,  1137,  3388,  3389,  1901,     9,    10,
     263,  3764,   770,   770,   772,   772,   777,   303,  3080,  1204,
    4858,   772,   518,  3776,   252,  4858,  1431,  4444,  4858,  1162,
     300,   301,     6,   770,   769,  1168,  4444,  1170,  1818,  2068,
      17,  1174,  1175,  1851,   770,   695,   772,  3734,  1138,  4570,
     758,   759,   769,   358,   607,    32,   753,    34,   753,     9,
      10,  4282,   184,   263,   186,    11,   379,  1757,   772,   303,
    4942,  1204,  4448,   777,   333,  4609,  4241,  4859,   772,  1757,
     777,   422,   777,  3822,   734,    32,   152,  1219,   416,  1221,
      10,   753,  3746,  3747,  1267,   280,  1916,  1383,   356,  2146,
     772,  3822,   174,  3702,   551,   777,   694,   265,  4444,  1242,
     645,  2005,   303,  1246,  5593,   777,  4454,   678,  1251,  1252,
     305,  1431,    14,   184,   770,   186,   721,  2039,   356,   770,
     184,   772,   186,   633,    28,  1268,  1331,   146,     9,    10,
     753,   189,  1893,   753,  1277,   402,   461,  1953,  1954,  3979,
       9,    10,  5631,  5632,  1960,  1961,  1962,   381,  1291,  1292,
     115,  1293,  3070,  1971,   777,  3962,  1351,   777,  1919,   467,
    1950,  2083,  4337,  3962,  1982,  1983,  3750,  3751,   114,  1312,
     323,   303,  3223,   184,  1383,   186,  4498,  4499,  4500,  1383,
     675,   437,  2623,   152,  1383,  1383,  2623,   696,  1331,  1332,
    1383,  5492,  5074,   363,   437,  1331,  1313,  1314,  2683,  2684,
    2709,  4410,  1331,  4135,  4522,  3184,   152,   476,  1351,    32,
     130,  2532,   479,  3962,  3850,  3070,   484,  4426,  4427,   753,
     754,   755,  2256,  1366,   184,    32,   186,    34,   363,  2031,
    2680,  3962,   303,  2683,  2684,  2925,  3746,  3747,  5061,   303,
    5729,  1384,  1385,   695,  1380,  3095,   484,  1383,  1391,   772,
    1383,     9,    10,   214,  1383,  3355,   525,   110,   111,   211,
     279,  1949,  1405,  5146,   265,  1260,  1461,   777,  2810,   450,
     772,  1414,  1415,  2829,  3124,    14,  1271,   349,  2787,  1422,
    1423,  1383,   734,  1426,  2114,  2115,   569,   378,  2797,   442,
       9,    10,   303,  1436,  3070,     9,    10,  2459,  2641,     5,
    1443,  2463,  1445,   184,  2647,   186,   125,  3987,  3988,  3989,
    3990,   743,  1455,     9,    10,   184,  1422,   186,  1461,   223,
     558,   500,  1465,  1466,  2486,    31,  3297,   403,   284,  1386,
    2116,  1431,  4260,   346,   769,     9,    10,    42,  3147,   677,
     270,   666,   329,   303,    32,   660,    34,  1490,   152,   625,
    1493,   607,  2256,  2257,   412,  3326,  3161,  5658,    15,  3036,
     347,     9,    10,   772,   607,   544,   353,    73,  1573,  3059,
    1513,   679,   606,    61,  2155,   651,  2155,  2155,  2435,  2436,
     114,  2155,   366,   366,     9,    10,   737,   650,     9,    10,
    2068,  3995,  2296,    63,  2180,  1538,   353,   114,     9,    10,
     581,  4787,  3065,  4789,  2738,  4615,  4792,  3046,  3047,  4619,
     772,   380,   117,  4799,  4800,   497,   584,   770,   686,  3390,
     695,   323,   303,   128,  3395,   497,   184,  4958,   186,  1565,
     135,  2509,    86,  2511,   303,     9,    10,  1573,  2116,  3037,
     650,  3039,   167,  2347,  1573,  4807,   299,  2525,   686,   462,
     120,   726,  2849,  4839,   777,     9,    10,  2361,     9,    10,
    2538,  2539,   167,   658,  5287,   184,   172,   186,   125,   292,
     184,   727,   186,   410,   392,  4791,   772,  2155,   659,   949,
     950,   951,  4410,   140,   727,   695,  2469,   402,   184,   772,
     186,  1686,   772,   391,    83,   564,  1639,  3408,  4426,  4427,
     679,  2179,  2180,   772,    93,  1648,   212,     0,   746,   679,
     184,  4609,   186,  1696,   171,   172,  1659,   171,   172,   465,
      80,   374,   176,   228,   136,   137,   770,  1670,  1723,   772,
     482,   270,   121,  5317,  5416,  5319,   184,  1007,   186,    61,
       9,    10,   462,  1686,   679,   303,   353,  1683,  2452,   283,
    1683,  1852,   141,  3416,   259,   646,    73,   146,  3248,   184,
     217,   186,  1757,   184,   479,   186,   283,  2385,  3961,   570,
    4528,   772,  3410,   184,    57,   186,   171,   172,  5879,  4901,
    1723,    99,  1725,   584,   303,  3631,  3632,  3633,  3634,   303,
     171,   172,  1734,   530,     9,    10,   185,   110,   111,   403,
     114,   397,   572,   399,  1747,  1748,    89,   303,     9,    10,
     184,   281,   186,   595,  1757,  1758,  5160,  4979,   601,   273,
     345,   233,   105,   458,  1767,   237,     9,    10,   564,   303,
     184,   644,   186,   184,   487,   186,    83,  5454,  1781,  1782,
     772,  5126,   560,   278,  1787,  1788,  1789,  1790,  1791,  1792,
    1793,  1794,  1795,  2068,  5016,   303,  1799,  1958,  1959,  5443,
     464,   607,   497,  5049,   211,   353,   149,   736,     9,    10,
     171,   172,  1815,  1816,   121,  1818,   288,  4011,   303,  1821,
    3146,  1787,   303,  1789,  1790,  1791,  1792,   299,   277,  2593,
     753,  2595,   303,  1799,   177,   582,  3675,  1840,  3673,   770,
      93,  2116,  2483,   772,  2483,  2483,   770,  1902,  1851,  2483,
    1816,   143,   695,   447,   333,   184,  5045,   186,   641,  1862,
     237,     9,    10,    18,  3387,   564,   569,   710,   572,   303,
     447,  5117,     9,    10,   721,  5121,  3202,     9,    10,   374,
    2155,  2441,  4378,  4379,   662,   563,   476,  1942,  2068,   303,
    4782,  1893,   303,  2441,  1949,  5340,  1951,   753,   151,  1902,
    2817,   772,     9,    10,  2179,  2180,  2552,   289,   290,   184,
       6,   186,  2602,  1916,   123,   745,  2680,  1919,  1921,  2683,
    2684,  2685,  3223,   184,  2823,   186,  3223,  2709,  3297,  3639,
    3640,   274,     9,    10,  5003,  1990,  2116,   229,  4132,  1942,
     736,   184,   316,   186,  3654,  2483,  1949,  1950,  1951,    61,
     105,   106,   772,  1956,   361,  4384,  4496,  2633,   653,   187,
    2636,   174,   564,  2641,  2640,  2586,  3276,   220,  1971,  2647,
     277,  4594,    68,   563,   303,  2155,   772,  2876,   586,  1982,
    1983,  2036,   423,   184,  2662,   186,   769,  1990,     9,    10,
     485,  3822,     9,    10,   330,  5623,   205,   476,  5626,  2179,
    2180,   374,  2884,  2885,  2886,  2787,  2668,  3409,   100,   391,
      93,     9,    10,  4442,  2552,  2797,   589,  3433,  3434,  3435,
    3436,  3390,   769,  5468,   703,  3690,  3395,  4650,   303,   110,
     111,   772,    18,  2036,   112,   445,   184,   736,   186,   205,
    2042,   745,   303,   772,   610,   298,   525,  5269,   704,  3252,
     263,   707,   184,  3256,   186,  2058,     9,    10,   736,  2062,
     303,  4869,   423,  5309,   176,  1395,  3411,  3089,  3090,   772,
      93,  5715,  5716,   752,   682,   446,  2079,   184,  5267,   186,
     211,   402,  2732,   465,   312,   251,    69,  3413,     9,    10,
     426,   681,  3114,  2096,   667,  2098,  5166,  5167,  5168,  2102,
    5170,  3411,   303,     9,    10,   714,   272,   184,  2068,   186,
     265,  2114,  2115,   753,   487,     9,    10,   714,  2121,   105,
     106,     9,    10,   146,    17,  2128,  2129,   735,  2131,  2132,
    2808,  3962,     9,    10,   736,   589,  3594,  5765,  3596,    32,
     442,    34,    33,  2146,   522,   523,   736,  2150,   526,   527,
     528,   668,  5374,   777,   772,   303,  2116,  2160,     9,    10,
     769,  3078,  5651,   184,  2167,   186,   303,   184,   299,   186,
     140,   303,   769,   296,  2177,  2178,  3070,  3094,   449,  2829,
       9,    10,   165,   593,    57,  5143,   184,   489,   186,     9,
      10,   531,  5150,   772,  2840,  2155,   303,   192,   772,   419,
     183,    92,  5160,   284,     9,    10,  5164,   772,  2483,   723,
     205,  5169,   483,   667,   770,  5003,   895,   265,  5110,  2179,
    2180,  5113,  5114,   594,  2220,   122,   303,  2220,  5717,   518,
     316,   184,     6,   186,  2875,   448,  2875,  2875,   772,   100,
     192,  2875,    57,  4739,   141,  4741,   100,    57,  5567,  5568,
    5038,  2903,  2413,   205,  2814,  5678,   476,  3156,   560,   425,
       9,    10,  2914,   184,   772,   186,  2814,   128,   263,   352,
       6,  3170,     9,    10,    89,   100,   149,  2552,   184,   265,
     186,   714,   303,  4779,   497,  2823,   303,   772,   559,  3053,
     184,   772,   186,   374,    68,   265,   184,   769,   186,  4205,
    4206,   772,  2840,  2483,   177,   303,  3070,   184,   639,   186,
      57,   263,  5539,   204,  2379,  5542,    79,   606,  5540,    82,
    2972,   770,   123,  2326,   185,     9,    10,   297,    26,  2332,
     620,   714,    68,   184,   149,   186,   770,  2875,  2876,   149,
     565,   566,    89,   563,   777,  2348,  2884,  2885,  2886,  3001,
     303,     9,    10,  3079,   437,   184,   439,   186,   772,  4788,
     700,   772,   177,  4859,   184,   696,   186,   177,   699,   640,
     500,   660,  2552,   408,  5563,  4804,  5565,  5566,   718,   184,
     415,   186,   303,  2379,   674,  5593,  2441,   278,  5011,  3030,
    2379,  3030,  3030,    49,   777,   726,  3030,   303,     9,    10,
    3052,   274,   149,   734,  4243,  2460,   487,  5830,  5831,   303,
      15,  5743,   728,     6,  4843,   303,  4845,   642,  5645,   182,
      12,   237,  5314,  5631,  5632,  5652,   303,   770,   152,  3079,
     177,     6,  2435,  2436,  2437,   184,   329,   186,  2441,   149,
    5727,   770,  2445,  2446,  2447,  2448,   529,   184,  5726,   186,
    2453,  2454,   303,  2456,   347,     6,   451,  2460,  1137,   274,
     353,   681,  5794,  4436,   274,  5797,  3128,   177,  4441,   769,
    4001,     9,    10,    65,   303,    68,  5665,  5666,     9,    10,
    5669,  2483,   695,   303,  3665,  4228,   379,  3128,   284,  3128,
    3128,  2494,  3030,    68,  3128,  2498,  5828,   772,   303,   451,
     184,   264,   186,  2505,     9,    10,  2561,  2510,    93,   770,
     331,  2513,  3276,     9,    10,  3297,   736,    68,  5745,  5746,
     125,  5729,     9,    10,   607,    95,   184,   274,   186,   772,
    4061,  4062,  2498,  3714,  2537,   140,  1408,  1409,  3437,    17,
       9,    10,   406,  5372,  2510,   704,    94,  2524,  2823,   708,
    2553,  2554,   772,  5742,   303,   125,    34,  5450,  2561,  2562,
    2563,  2557,     9,    10,   112,  2840,   303,  1246,  3984,    10,
    1442,   772,  1251,   184,  3252,   186,  5757,  5758,  3256,     9,
      10,   208,    35,  4248,  2586,  5478,    95,  3486,  2591,  1105,
    3128,   112,  2552,  3962,    47,  2598,     9,    10,  2600,  2602,
    2875,  2876,   229,  4102,  4103,  5228,   505,   506,  3390,  2884,
    2885,  2886,   217,  3395,   123,  2670,    93,  1133,  3156,   303,
    4674,   520,   770,    94,  2627,  2628,  2629,  2630,  5809,  2632,
    4129,    95,  3170,   714,  2637,  2638,  2639,  4160,  2641,  3965,
     772,   112,   115,  2823,  2647,   303,   184,  3411,   186,     6,
    3672,  4150,  1331,   184,    11,   186,    17,   130,    15,  2662,
    2840,     9,    10,  2666,   141,   772,  2632,  2670,  2671,   146,
     769,    32,  2638,  2639,   769,   759,   253,  4200,   777,   184,
     759,   186,   777,   736,     9,    10,   770,   264,   184,   772,
     186,   770,   303,   770,  2696,  2875,  2876,   184,   661,   186,
     984,  2703,  2704,   661,  2884,  2885,  2886,  3624,   185,  4246,
     759,  3357,     9,    10,   659,   184,   117,   186,  1002,   618,
     619,   770,   667,   772,  1008,  1009,  1405,   128,   673,  2732,
    3408,  3669,  4397,   263,   135,  2738,  1415,   184,    95,   186,
     769,   621,    10,   448,  1423,     9,    10,    15,   777,    95,
      57,   772,   632,   770,   184,  3030,   186,     9,    10,  2814,
     770,  2816,  3526,   776,  1443,   303,  1445,   352,     9,    10,
     654,   184,   303,   186,   772,   758,   759,   760,   761,   762,
     763,   769,    89,  3433,  3434,  3435,  3436,     9,    10,   777,
     297,     9,    10,   769,   769,   769,   769,  2800,   303,  2802,
     115,   777,   777,   777,   777,  2808,  3570,   303,  2811,   115,
     466,  2814,   769,  2816,  2817,   769,   303,   770,  4166,  3357,
     777,    69,  4170,   777,     9,    10,  2829,   228,   721,  2832,
       9,    10,   724,   725,   303,   727,   184,   729,   186,     9,
      10,   770,   149,   772,  2899,  2841,  2901,  4686,   115,   770,
    3030,  5886,   437,  3128,   439,   777,   303,   125,   259,   184,
     725,   186,     6,  2823,   770,   333,     9,    10,   333,   770,
     177,   772,   140,   303,  3638,  1365,   770,   125,  1368,  1369,
    2840,  3156,   770,   770,   777,   772,   149,   184,   777,   186,
     303,  3913,    84,   770,  1282,  3170,  2899,   263,  2901,  3437,
    1288,  1289,   425,   171,   172,  3631,  3632,  3633,  3634,   374,
     649,   770,  4238,   772,   177,  2875,  2876,   165,   251,   770,
     184,   577,   186,   734,  2884,  2885,  2886,   770,   584,   772,
    4467,    63,   184,   769,   186,   183,   592,   770,  3702,   772,
    3592,   770,    76,   184,   529,   186,     9,    10,  3486,   217,
     770,   270,  1485,  1486,     5,   303,  1489,    95,  4668,  4669,
    1639,   770,   184,   772,   186,   770,   184,   274,   186,  1648,
      69,   112,   770,   438,   772,   238,  3156,  3042,   303,   681,
    1659,  3631,  3632,  3633,  3634,    93,    94,   374,   120,   599,
    3170,   239,   240,  3154,   770,   770,   772,   772,  3724,   184,
     770,   186,   772,    76,    77,   184,   303,   186,   476,   665,
     639,   476,  3015,    10,   184,   770,   186,   772,    15,   769,
    4685,   770,   607,    49,   758,   759,   125,  3926,  3030,   770,
     465,   772,   419,   770,   576,   770,   299,   772,   695,   303,
    3036,   184,   770,   186,   772,  3048,  3042,  4381,   770,  4383,
     772,   303,  4386,  3042,  4235,  4389,   180,   525,  4392,  4393,
     525,   270,   303,   522,   523,   180,   165,   526,   527,   528,
     726,  3074,  3750,  3751,  3724,  3078,  3079,  3080,  1544,  1545,
     772,   303,  3357,  4485,   183,   303,   770,  1553,   770,   476,
     772,  3094,   557,   416,  4428,   563,   114,  3093,   563,   348,
    3093,   233,    57,    57,  3093,   770,   770,   772,   772,  1788,
     776,   770,   770,   772,  1793,   292,  1795,   294,   303,  1585,
    3093,  1587,  3283,   339,   303,  3128,   779,    17,   125,   197,
     770,  3093,   772,   303,    89,    89,  1602,  1603,  1604,   769,
     239,   240,    32,   140,    34,  1611,  1612,  3150,   769,   281,
     105,   105,  1618,   770,   769,   772,   288,  4656,  3161,   770,
     303,  1840,  3437,   770,   770,   772,   772,   299,  3128,   769,
     557,  3167,  1851,  3162,   171,   172,   563,  3357,   769,   205,
    3962,  4540,   769,  1862,   316,    49,    97,   769,  4547,    61,
     770,   769,   772,  4075,   149,   149,  3156,   769,  4569,   343,
      93,    94,  4224,  4225,   110,   111,  4519,  3262,   769,   769,
    3170,  3486,   769,   681,  4585,   770,   681,   772,  4589,  4590,
     217,   132,   177,   177,   769,    69,  4539,   614,   769,  3284,
    3285,  4253,   770,  3236,   769,  4548,  4595,   263,  3241,   770,
      63,  4554,    69,   387,   769,   389,   272,    34,   770,  3252,
     772,  4564,   770,  3256,   772,   191,   770,  3437,   772,  3262,
    4573,  4574,   728,     9,    10,   770,   769,  3270,   736,   769,
    3236,   736,   769,   416,   770,   166,   770,  1956,   772,  3334,
     769,  3284,  3285,   770,   770,   769,   772,   313,   770,   770,
     772,   772,  1971,   769,   681,   728,   770,   120,   772,   769,
    5015,   770,  4825,  1982,  1983,   191,  3486,    53,    54,    55,
      56,  3313,  3314,  3315,  3316,   769,  3318,  3319,   769,   274,
     274,   165,   770,   770,   772,  5359,   770,   770,   772,   772,
       6,  3334,   769,   720,  3984,  1663,  1664,   481,   165,   183,
     770,   205,     9,    10,   769,   769,  4896,  3350,    36,   736,
     770,   770,   772,   772,   769,   769,   183,   770,   770,   769,
     772,   107,   108,   109,  3366,  3367,   770,  3369,   772,  3371,
    3372,  3373,  3374,  3375,  3376,  3377,   769,  3379,  4877,  2058,
    3382,   770,   191,   772,  3386,   772,   530,   251,  3926,   770,
     769,   772,    68,    17,   769,   239,   240,  3357,   769,   425,
     668,   291,   292,   191,    92,  3408,    69,   770,    32,   772,
     233,   769,   239,   240,   769,   161,   162,   769,   769,     9,
      10,   770,   770,   772,  3427,   451,   769,   115,  4074,  3432,
    3433,  3434,  3435,  3436,    58,   579,  3439,   769,   184,   329,
     186,  4527,   130,   270,   265,   770,    70,   769,  3609,  2128,
    2129,    11,  2131,  2132,   770,   769,   772,   347,   281,  4793,
    4112,   769,   326,   353,  5129,   288,    90,   769,   769,  4003,
      69,  2150,   741,   770,    34,  4009,   299,  3437,  4012,  4205,
    4206,  2160,   770,  4569,   772,  4019,   232,   769,   769,   379,
     753,  4513,   770,   316,   772,   758,   759,   769,   122,  4585,
     124,    61,   165,  4589,  4590,   377,   770,   379,   756,   757,
     758,   759,   760,   761,   762,   763,   204,   184,   770,   186,
     183,   130,   769,   374,   769,   669,  3486,  5242,  4180,   770,
     770,   442,   772,   769,   769,  4187,  4074,  4075,   402,   770,
     769,   772,   414,    49,   770,   769,   772,   691,   770,   769,
     110,   111,   770,   197,   769,  4205,  4206,   303,   304,   769,
     777,   425,   171,   172,   769,  4227,   165,   770,  3571,   772,
     130,   443,   769,   249,   250,   769,   239,   240,   489,   770,
     770,   772,   772,   259,   183,   770,  4227,   451,  4227,  4227,
      96,   770,   197,  4227,   184,   204,   186,   770,   769,   772,
     770,   770,   770,   772,   772,     9,    10,  3610,   770,   115,
     772,   171,   172,   770,   769,   772,   176,   770,   769,   772,
     180,  3624,   769,   769,   650,   476,   576,  4998,  3631,  3632,
    3633,  3634,   769,  3636,  3636,   499,   303,   769,  4983,    34,
     239,   240,   553,   769,   204,   772,   769,  2326,   769,  3652,
    3653,  3926,   769,  2332,   400,   769,   280,   756,   757,   758,
     759,   760,   761,   762,   763,   164,    61,   769,   292,   278,
     753,   668,   769,  4983,   769,   769,   266,   769,  3681,  5402,
    4579,   769,   769,  5406,   372,   769,   597,  3690,   769,  4227,
     769,  3694,  4368,  3689,   769,   769,  3689,   769,   769,   769,
     726,  4377,   769,   769,    36,  5255,   557,   579,   734,   769,
     769,   210,   563,   303,   769,   110,   111,   769,   278,   769,
     769,  3724,   468,  4385,   180,    49,    95,  3730,  3731,  5088,
    5089,   180,  5091,  3736,   237,   130,   777,   777,   244,   777,
     777,   777,   302,   615,   411,   777,  3926,  3750,  3751,   777,
     777,   661,   251,   777,  3757,   777,   769,   263,  2437,   679,
      92,   141,   424,   614,    93,   374,  2445,  2446,  2447,  2448,
    3736,   679,   278,   397,   334,   399,   171,   172,  5477,   695,
     184,   176,   186,   115,   667,   180,   650,   533,   464,   535,
     654,   115,  2258,   500,   540,  2261,  5511,   418,   130,  4074,
    4075,    93,   772,   123,   772,  5355,   350,   772,   574,   204,
     348,  2277,   772,   357,   374,  5538,    93,  3797,  3798,   382,
     326,  3801,  3802,   772,   772,  2291,   571,  3807,  3808,   373,
     681,   721,   696,  5204,    42,  5206,   690,  5502,   753,   383,
     384,   385,   753,   754,   755,    80,  5205,   734,   451,   393,
     451,    94,   196,  5692,   772,  4501,   265,   281,  2537,   605,
     100,   125,   726,    26,   196,    61,   396,     5,   395,   720,
     734,  3914,   204,    34,   778,   374,   485,   575,     4,   734,
     777,   205,   416,   278,  2563,   736,    14,   386,    93,   333,
    3893,   772,   296,   453,  4074,  4075,   402,   585,   777,   303,
      61,    84,   648,  4667,   777,  3908,  4928,   302,   419,   117,
     411,   115,  4998,  5436,   758,   759,   760,   761,   762,   763,
     128,  4562,   125,  4562,  4562,   485,   550,   135,  4562,   756,
     757,   758,   759,   760,   761,   762,   763,   695,   770,   334,
     769,  5300,   112,  5302,  5303,   497,   769,   296,   272,   110,
     111,  2630,  4227,   503,    95,   505,   506,  3960,  2637,   167,
     553,  3964,  2641,  4501,  3967,   123,  3926,   769,  2647,   130,
     520,   296,   180,   151,   772,   419,   776,   769,  4512,   374,
    4514,  3984,     6,  2662,   379,   416,   770,   770,   532,   488,
      32,   770,   738,    68,   670,   671,   672,   673,  5521,  4533,
     772,   324,   546,   749,   777,   693,   770,   770,  4907,  4543,
     171,   172,     9,    10,    11,   176,    58,   770,   640,   180,
     228,  4555,     9,    10,  4562,   777,  5691,    93,    70,    93,
    5375,  5376,   476,   770,   658,   770,   770,   777,  4572,   769,
     372,  4579,   140,   204,   769,   100,  5885,   270,    90,   772,
     772,   259,     9,    10,   772,   779,    93,   760,   777,    57,
     772,   560,    34,   772,   679,  5375,  5376,  4070,   618,   619,
     760,   125,   480,   692,   440,    93,   284,   772,   424,     9,
      10,   525,   124,   707,   679,   770,   769,   769,   632,   778,
     485,    89,   652,   756,   757,   758,   759,   760,   761,   762,
     763,   425,   772,   647,   125,  4781,   730,   105,  4784,  4785,
    5633,   772,   110,   111,  4074,  4075,   196,   278,  5204,   563,
    5206,   351,  4010,  4011,   218,   500,  4014,   451,   500,  2808,
     636,   348,  2811,  4021,   772,   500,   500,   400,   500,   500,
     684,   302,   772,   753,   650,    84,   667,   270,   654,  5699,
       6,   149,   664,  2832,   698,  4158,   734,   587,   757,   758,
     759,   760,   761,   762,   763,    95,  5065,   128,   770,   128,
     374,   213,  4175,   334,   770,   499,   770,   381,  4339,   177,
     188,   770,   742,   770,    83,  4188,  4188,   184,   769,   186,
    5855,   777,   396,   699,    93,   772,    26,   184,  4201,   186,
     104,  2110,  4205,  4206,  5869,   468,   428,   229,  4211,  4211,
    5875,   777,   407,   374,   656,   419,  5881,   470,  2159,  4983,
     726,   769,   121,   470,  4227,  4228,  4501,   184,  4869,   186,
    4869,  4869,  5755,   772,  4237,  4869,   586,   681,   280,   770,
     772,    29,   141,  4889,   296,  4248,  4249,   146,   725,   283,
    4246,  4254,   772,   585,   184,   333,   186,   652,   694,    53,
      54,    55,    56,  4388,   110,   111,   201,  4227,   185,  5819,
     533,   595,   535,     9,    10,    95,   274,   540,   180,  4281,
     772,   772,   635,   116,   130,   270,   185,  4562,  4291,  5188,
     641,  4294,   736,  4296,   123,    59,   374,   770,  4353,   770,
    4941,   770,  4941,  4941,  4579,   416,   303,  4941,   770,   266,
     760,   770,   636,   107,   108,   109,   303,   770,   770,  5218,
     524,  4501,    95,  4326,   485,   171,   172,   759,   772,   769,
     654,  4869,  4335,   537,   772,  4491,   770,    67,   777,   772,
     238,   419,   605,   770,   770,   770,   303,   742,   770,  4351,
    4353,  4889,   770,   557,   770,   397,   770,   399,   204,   770,
     438,   693,   772,   770,  4367,   770,  4421,   161,   162,  4907,
     770,   772,   696,   303,  4382,   699,   772,   770,   277,   770,
     770,  4384,  4562,   769,   769,   648,   769,   763,  4396,   196,
     769,   366,  4395,   770,  4397,  3074,   582,   753,   476,  4579,
    4403,  3080,   726,  4941,   265,  4413,  4409,     9,    10,    99,
     734,   265,  4414,  4415,   265,   156,    95,   270,  4421,  4422,
     772,    93,    93,  4431,   772,  4433,  4434,   769,  4430,   769,
     777,  5107,   278,   494,   164,   772,   772,    95,   232,  4442,
     770,   171,   172,   777,   777,  4448,  4449,   525,   184,  5348,
     186,  4454,  4454,  5475,   606,    15,   302,  4460,    18,     9,
      10,   237,  4465,   770,   772,    18,   772,  4522,    62,     6,
     661,  4467,   772,  4528,   724,   738,   772,   681,    93,   557,
     210,   568,     7,   128,   128,   563,   749,   428,  5847,   740,
    5372,   652,   696,    95,  4460,  4491,   769,    57,  4491,   538,
     548,   251,  4491,   251,    57,   649,   251,   549,   550,   251,
     304,     9,    10,    11,   251,   299,    41,   180,    93,  4522,
     769,   251,   266,   499,   753,  4528,    86,  5065,   374,    89,
     266,   772,   753,    86,   753,   753,    89,   753,    63,   753,
     753,  4501,   753,    93,   753,   105,   106,   753,    73,   725,
     284,   753,   105,   106,  4557,   753,   753,   568,   141,   753,
     339,   340,  3241,     9,    10,   753,   753,   303,   753,   753,
     777,   753,    33,  3252,    99,    36,   753,  3256,  5600,   753,
     753,   742,   184,    17,   186,   753,   753,     9,    10,   149,
     115,  5613,   772,   321,  4869,   120,   149,   376,     9,    10,
      11,   270,  4562,   681,   769,   777,   400,   348,   168,   270,
     270,  5375,  5376,   777,  4889,   168,   176,   177,   270,  4579,
     745,   146,   772,   176,   177,   497,  5648,   380,   123,   776,
     770,    92,  4907,   122,   184,    96,   186,   416,   122,   485,
     777,   770,   191,   770,   374,   777,   770,  4702,  4536,    95,
    5188,   770,  4655,   394,   115,   777,   386,   770,   736,   759,
     759,    26,   770,  2604,   770,   707,  4941,   772,   769,   130,
     326,  4559,   769,    95,   468,  4563,   110,   111,   688,  4722,
    5218,   270,  4685,  4571,   576,    95,   184,    95,   186,  4869,
    4693,   216,    95,    95,   772,   777,   265,   265,   211,  4702,
     482,   303,   772,  4706,   777,   265,   759,   177,   233,  4889,
      11,  4714,   265,   273,   274,   275,   241,   299,   769,   534,
     273,   274,   275,   753,   753,  4768,  4729,  4907,  4730,  3408,
    4773,   772,  5398,   474,   321,   196,  4791,  2678,   184,   533,
     186,   535,    92,   204,   180,   180,   540,   272,   270,   769,
     769,    10,   128,   303,   128,    17,   281,   282,   488,   772,
    3439,  4941,   184,  4771,   186,   770,   396,   396,   265,   265,
     219,   265,  5450,   184,    11,   186,   769,   769,   769,  4782,
     100,  2690,  2691,   244,  4787,  4788,  4789,   777,  4791,  4792,
    5065,  4794,   224,   760,    93,   536,  4799,  4800,  2707,  4801,
    5478,  4804,    72,   270,   576,   303,   760,   180,  2717,  2718,
    5348,   605,   114,   460,   555,   556,   595,   278,   252,   560,
     561,   562,   772,   776,   769,   411,  4828,   769,    56,   263,
     560,   391,   769,   612,  5372,   124,  4839,   124,   391,   399,
    4843,   770,  4845,   770,   770,    42,   399,   770,   110,   111,
     177,   769,   777,    42,   648,   777,  5878,   303,   637,   772,
     772,  4864,   770,    33,  4867,   770,    36,  4870,  5534,   185,
     770,   122,   769,  2782,  2783,  2784,  2785,    26,   769,   753,
    4882,   303,    42,   769,  4887,  5065,   220,   628,    95,    95,
     770,   770,   303,   211,   772,   770,   742,   298,   677,   772,
     425,   769,   772,  4899,   770,   430,  4899,   350,   777,  4869,
    4913,   372,   769,  5188,   357,   211,   441,   769,  4961,   545,
     117,  5599,    92,   772,   396,   753,    96,   180,   117,  4889,
     373,   128,   769,   284,   769,   284,   677,   366,   135,   128,
     383,   384,   385,  5218,   738,   115,   135,  4907,    11,   772,
     393,   770,  5614,   265,   772,   749,   186,   117,  4961,   435,
     130,   196,  4965,   372,   196,   270,   407,   196,   128,    26,
     167,   405,   732,  5872,   196,   135,   407,   129,   167,   696,
     196,  4941,   129,   180,   696,   419,   196,   421,   583,   270,
     252,   180,   196,   196,   196,    11,   229,    99,   428,   770,
     413,   492,   203,   769,   379,   568,   769,   167,  5188,    61,
      93,  5549,    93,   177,   770,    26,   235,   299,   452,  5022,
     494,   770,   635,   770,   185,    26,   772,   770,  5031,   142,
     770,   228,  5035,   467,   204,   146,   436,   772,  5218,   228,
     196,  5044,  5045,  5046,   770,   772,  5049,   770,   772,   769,
     744,  3730,  3731,   140,   196,   180,    11,   770,  5061,   667,
     284,   284,   259,   143,   769,   177,   500,   177,   228,   584,
     259,  3750,  3751,  5348,   244,   600,   112,   732,  5081,  3020,
    5083,   130,   732,   204,   518,   216,   777,   596,   180,   532,
     180,   374,   475,   266,   576,    95,   621,  5372,   428,   259,
    5103,   626,   123,   546,   299,  5065,   379,  5110,   278,   294,
    5113,  5114,   294,   568,  5117,   215,    17,   770,  5121,   770,
    5123,   769,  5283,   772,   585,   488,  5129,   770,   770,  5132,
     770,   770,   657,   141,   538,  5138,   124,   606,    32,   770,
     772,    26,   770,   405,   704,   770,   770,   707,   770,   770,
     777,   704,   772,    10,   707,  5821,   716,   419,   769,   421,
     769,   646,    11,   716,   689,   599,   770,   770,  5348,   769,
     769,    26,   606,    26,    79,    26,   769,   435,   177,   319,
      93,   769,   616,   130,   769,   130,    93,   130,   772,   769,
     452,   299,  5372,   770,   772,   629,  5199,   378,   649,   411,
     651,   660,   372,   299,   647,   467,   130,  5210,   263,  5212,
     305,   280,   777,   753,   665,    93,    93,   177,   772,   770,
     671,   672,   770,   538,   770,   434,   660,   678,  5188,   663,
     769,   676,   693,   408,    71,   575,   769,    11,   500,   770,
     770,   684,    67,   772,   180,   679,   697,   633,   772,    93,
      26,    26,   265,    26,   400,   698,   518,    84,  5218,   284,
      84,   695,   769,   777,  5267,   263,   777,   777,    33,   777,
     576,   777,   777,   777,  5549,   777,   113,   777,  3219,   281,
    5276,   177,   449,   641,  5287,   777,   594,   777,   429,   777,
     777,   777,   770,   770,   777,   770,   594,  5340,   769,    91,
     354,  5344,   568,   769,   769,   769,  5309,   770,    61,    61,
     772,  5314,   770,   154,   676,   576,   153,    33,    33,    10,
     777,   687,  5330,   770,  5367,   702,   302,   177,   568,    26,
    5333,    26,   769,   123,  5872,  5338,   769,   599,   180,   130,
     693,   769,  5345,   769,   606,   769,   130,   732,   176,   281,
    5353,  5354,   327,    61,   616,    11,   417,   641,   576,   576,
     407,   407,   769,   769,  5367,   816,   419,   629,   173,  5549,
      93,   770,   777,   769,  5417,   772,  3317,   770,   769,   769,
     769,   728,   769,   411,   772,   688,   580,  5390,  5348,   770,
    3299,  3300,   770,  3302,  3303,   777,   146,   769,   660,   769,
    5403,   663,   770,   326,  5407,   320,   777,   229,   180,   180,
     281,   772,  5372,    63,   770,   585,   770,   679,    75,  5422,
     470,  3362,  5477,  3364,  3365,  5468,    26,   641,   114,  3370,
     177,   769,  3093,   237,   885,   772,  5439,  3378,  2574,   912,
    3384,  4895,  3383,  5486,  4891,   896,  1221,   898,   899,   900,
    4893,  3232,  3818,  5400,   905,  5070,   907,  5414,  5547,   750,
    5734,  4315,  5464,  4965,  1400,  4305,  4941,  5279,  5367,  5288,
    4576,  5225,  5210,  1735,  5477,  2595,  3702,  5549,  3479,  3979,
    4502,   817,  2748,  4075,  3393,  2178,  2180,   938,  2179,  2181,
    1441,  2045,   943,  5054,  5277,  2103,  3346,  5276,  3907,  5502,
    4811,  5504,  5020,  4197,  5569,  4201,  4655,  2421,  5621,  5255,
    5694,  5024,  5819,  5774,  5534,  5821,  2623,  4380,  3899,  5714,
    4448,  5408,   973,   693,  5049,  4774,  5758,  5569,  3908,  5599,
    4066,  4132,   983,  5478,  4011,  5602,  5614,  5119,  4521,  4529,
    4167,  3575,  4170,  5546,  5793,  4162,    90,  5550,    90,  5745,
    5315,  5554,  5555,  5746,  5718,  5652,  5403,  5645,  4547,  5602,
    5563,  5100,  5565,  5566,  5098,  3725,  3907,  4444,  1236,  1419,
    3216,  1931,  5733,  5569,  3211,  5337,  5610,  5580,  2738,  5634,
    5569,  5118,  2082,  2563,  2437,   135,  3439,  2848,  3996,  5549,
    5593,  5593,  3151,  1380,  3036,  1333,  1667,  5872,   756,  1369,
    1159,  3280,  3970,  2971,  4188,  3085,  3609,  5610,  2967,  1725,
    1579,  4187,  4291,  1547,  5086,  1983,  1331,  4296,  5621,  1070,
    1071,  1072,  1073,  1978,  1331,  1331,  5628,  5629,  1331,  1331,
    4743,  5634,  5554,  1084,   471,  4240,  4693,  1553,  1973,  5555,
    5642,  2676,  1999,  4335,  3272,  5688,  3601,  4334,  3599,  5511,
    5015,  5129,  5655,  4674,  5011,  5029,  3276,  5660,   762,  5714,
    1361,  2670,  5665,  5666,   501,   502,  5669,   504,   505,   506,
     507,   508,   108,   510,   511,   512,   513,   514,   515,   516,
     517,  4339,   519,   520,   521,    90,  1499,  1138,  5691,  1387,
    2800,  2841,  5872,  1859,  4685,  3167,  3310,  4699,  4239,  4237,
    5691,  5703,   681,   835,  5706,   834,   672,  2096,  2533,  3145,
    2534,  5714,  1807,  1383,  5757,  5758,   672,  5772,   125,  2589,
    5132,  5882,  5038,  1503,  4403,  3999,  5729,  5729,  1920,  4748,
    5817,  5838,  5095,  5736,  5875,  5881,  2553,  1006,  4248,  5742,
    3030,  3126,   671,  4227,  2362,   671,  2487,  2160,  1949,  1749,
    3106,  3105,   668,  3833,  3078,  2732,  1495,  1141,  4353,  3427,
    5196,  3914,   710,  3226,   114,    90,  5809,    90,    90,  5772,
    5078,    -1,  5291,    -1,    -1,  1278,    -1,    -1,    -1,    -1,
      -1,   618,   619,    -1,    -1,    -1,    -1,    -1,    -1,  5792,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5859,    -1,  1257,    -1,    -1,  1260,
    5865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5855,    -1,    -1,    -1,  5859,    -1,    -1,    -1,
      -1,    -1,  5865,    -1,    -1,    -1,  5869,    -1,    -1,    -1,
      -1,    -1,  5875,    -1,    -1,    -1,    -1,    -1,  5881,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3834,  3835,  3836,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3852,    -1,    -1,  3855,    -1,    -1,  3858,
    3859,  3860,  3861,    -1,  3863,  3864,  3865,  3866,    -1,  3868,
    3869,    -1,  3871,    -1,    -1,    -1,  3875,    -1,    -1,    -1,
    3879,  3880,  3881,  3882,    -1,  3884,  3885,  1428,    -1,  1430,
    1431,  3890,  3891,    -1,    -1,  3894,  3895,  3928,  3929,    -1,
    3931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4714,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1501,    -1,  1503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1540,
    1541,    -1,    -1,    -1,    -1,  1546,    -1,    -1,    -1,  1550,
    1551,  1552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1561,  1562,    -1,    -1,    -1,    -1,  1567,    -1,  1569,  1570,
    1571,  1572,  1573,    -1,  1575,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1586,    -1,  1588,    -1,    -1,
    1591,  1592,    -1,  1594,  1595,  1596,    -1,  1598,  1599,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1613,  1614,  1615,  1616,  1617,    -1,  1619,  1620,
    1621,    -1,    -1,  1624,  1625,  1626,  1627,  1628,  1629,  1630,
      -1,  1632,  1633,  1634,  1635,    -1,  1637,  1638,  4867,  1640,
    1641,  1642,  1643,  1644,  1645,  1646,    -1,    -1,  1649,  1650,
    1651,  1652,    -1,  1654,  1655,  1656,    -1,  1658,  4149,  1660,
      -1,  1662,    -1,    -1,    -1,  1666,  1667,  1668,    -1,    -1,
    1671,  1672,  1673,  1674,  1675,    -1,  1677,    -1,    -1,    -1,
    4171,    -1,    -1,  1684,    -1,    -1,    -1,    -1,    -1,    -1,
    1691,  1692,  1693,  1694,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1702,  1703,    -1,  1705,  1706,    -1,    -1,  1709,  1710,
    1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,    -1,    -1,  1724,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     5,    -1,     7,     8,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1765,    -1,    -1,    -1,    31,  1770,
      33,    -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,  1780,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    80,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    91,    -1,
      91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,   104,    -1,    -1,  1847,   110,   111,    -1,
      -1,    -1,   115,   114,    -1,    -1,   117,    -1,    -1,    -1,
     121,    -1,   123,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,  1877,    -1,  1879,    -1,
     141,    -1,    -1,   146,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,
      -1,    -1,  1913,  4404,  4405,  4406,    -1,    -1,   181,   180,
    4411,  4412,   185,    -1,   185,    -1,  4417,    -1,    -1,    -1,
     193,    -1,    -1,   196,  4425,  4394,    -1,    -1,  4429,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    32,  4440,
      34,    -1,    -1,    -1,    -1,    -1,   219,  4416,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
    5199,    -1,    -1,    -1,    -1,    -1,   237,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   254,   255,   256,    -1,  1996,    -1,    -1,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,    -1,   277,    -1,    -1,    -1,
      -1,    -1,   283,   284,    -1,    -1,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,    -1,    -1,   297,    -1,   299,   302,
      -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,  2068,    -1,    -1,
      -1,   334,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4576,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      -1,    -1,    -1,    -1,  5333,    -1,    -1,    -1,    -1,   193,
      -1,   374,    -1,    -1,    -1,  2116,    -1,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,    -1,  2145,   408,   409,    -1,    -1,    -1,
      -1,    -1,   415,    32,  2155,    34,   419,    -1,    -1,    -1,
      -1,    -1,  2163,    -1,   427,    -1,    -1,    -1,    -1,    -1,
     254,   255,   256,    -1,    -1,    -1,    -1,    -1,  2179,  2180,
    2181,    -1,    61,  2184,   447,    -1,   447,    -1,    -1,    -1,
      -1,  2192,  2193,   277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     473,    -1,    -1,    -1,   477,    -1,    -1,    -1,   302,    -1,
      -1,    -1,    -1,    -1,   487,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     334,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,
      -1,   355,    -1,    -1,   537,    -1,   539,    -1,    -1,    -1,
      -1,    -1,    -1,  2284,  2285,  2286,    -1,    -1,    -1,    -1,
     374,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   396,    -1,   193,   578,    -1,  5546,    -1,    -1,
     404,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   611,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2358,    -1,   622,
     623,   624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,   255,   256,  2379,    -1,
     643,    -1,  2383,  2384,    -1,  2386,  2387,   650,    -1,    -1,
      -1,    -1,    -1,   477,  2395,    -1,  2397,    -1,   277,    -1,
    4891,    -1,  4893,   487,  4895,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,    -1,
      -1,    -1,    -1,   302,  2425,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   696,   697,    -1,    -1,    -1,  2439,    -1,
     524,    -1,    -1,    -1,    -1,    -1,   709,    -1,    -1,   712,
      -1,  2452,    -1,   537,  2455,   334,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2469,    -1,
    4961,    -1,    -1,    61,   353,    -1,   355,    -1,    -1,   740,
      -1,    -1,  2483,  2484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   753,    -1,   578,   374,    -1,    -1,    -1,    -1,
     584,    -1,   381,    -1,    -1,  2506,    -1,    -1,    -1,   770,
      -1,   772,    -1,   776,   775,   776,    -1,   396,  5009,    -1,
      -1,    -1,   110,   111,    -1,   404,    -1,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     419,    -1,    -1,    -1,    -1,    -1,  2547,    -1,    -1,    -1,
      -1,  2552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,
      -1,    -1,    -1,    -1,    -1,    -1,   650,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2589,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,   477,    -1,
      -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,   487,    -1,
      -1,    -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   709,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   537,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   254,   255,   256,    -1,
      -1,    -1,  2673,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2687,    -1,   772,   277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   578,
      -1,    -1,    -1,    -1,    -1,   584,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2744,    -1,    -1,   334,    -1,   336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5252,    -1,    -1,   643,    -1,    -1,   355,    -1,    -1,
      -1,   650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,
      -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   681,    -1,    -1,    -1,    -1,    -1,   396,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   696,   697,    -1,
      -1,    -1,  2823,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     709,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2875,  2876,  5367,    -1,    -1,    -1,
      -1,    -1,    -1,  2884,  2885,  2886,    -1,    -1,    -1,   477,
    2891,    -1,    -1,  2894,    -1,    -1,    -1,    -1,    -1,   487,
      -1,    -1,  2903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2912,    -1,  2914,    -1,  2916,    -1,  2918,  2919,  2920,
    2921,  2922,  2923,    -1,  2925,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2933,    -1,  2935,    -1,   524,  2938,  2939,  2940,
      -1,    -1,    -1,    -1,    -1,    -1,  2947,  2948,  2949,   537,
    2951,    -1,  2953,    -1,  2955,    -1,  2957,    -1,  2959,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2967,    -1,  2969,    -1,
    2971,  2972,  2973,  2974,  2975,    -1,    -1,  2978,    -1,  2980,
      -1,    -1,  2983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     578,    -1,    -1,    -1,    -1,  2996,   584,    -1,    -1,    -1,
    3001,    -1,    -1,  3004,    -1,  3006,  3007,  3008,    -1,    -1,
    3011,    -1,    -1,    -1,    -1,    -1,  3017,    -1,    -1,    -1,
      -1,  3022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3030,
    3031,    -1,    -1,    -1,    -1,    -1,  3037,    -1,  3039,    -1,
      -1,  3042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3052,    -1,  3054,    -1,   643,    -1,    -1,  3059,    -1,
      -1,    -1,   650,    -1,    -1,    -1,    -1,  5526,  5527,    -1,
    5529,  5530,  5531,  5532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   681,  3095,    -1,    -1,    -1,    -1,    -1,
       7,     8,    -1,    -1,    -1,    -1,    -1,    -1,   696,   697,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,   709,    29,  3124,    31,    -1,    33,  3128,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3155,  3156,    63,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,  5627,  3170,
      -1,  5630,    -1,    80,    -1,    -1,    -1,    -1,    -1,  5638,
      -1,    -1,    -1,  3184,  5643,    -1,    93,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5724,    -1,    -1,    -1,   144,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,  3248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3269,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,   196,
      -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,   220,    -1,   222,    -1,    -1,    -1,    -1,
     227,  3322,  3323,    -1,    -1,    -1,   233,    -1,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3346,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3357,  3358,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,  3388,  3389,    -1,
      -1,   298,   299,    -1,    -1,    -1,    -1,    -1,    -1,   306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   338,   339,    -1,   341,    -1,  3437,    -1,    -1,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,
      -1,    -1,    -1,    -1,    -1,    -1,  3477,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3486,  3487,    -1,    -1,  3490,
      -1,    -1,    -1,    -1,   401,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3514,  3515,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,  3539,    -1,
    3541,    -1,  3543,    -1,  3545,    -1,    -1,    -1,    -1,    -1,
     457,    -1,    -1,   460,    -1,    -1,   463,    -1,    -1,    -1,
      -1,    -1,    -1,  3564,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3585,  3586,    -1,    -1,    -1,    -1,
      -1,  3592,    -1,  3594,    -1,  3596,    -1,    -1,    -1,    -1,
    3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     7,     8,    -1,  3639,  3640,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3654,    -1,    27,    -1,    29,    -1,    31,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,  3675,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   595,    -1,
      -1,    63,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   624,    -1,    -1,
     627,    93,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,
     637,  3732,  3733,    -1,    -1,    -1,    -1,    -1,   645,    -1,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     657,    -1,    -1,  3754,    -1,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,  3764,    -1,    -1,    -1,    -1,    -1,    -1,
     677,    -1,   144,   680,   146,  3776,    -1,  3778,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   712,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,   722,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   195,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   206,   207,    -1,    -1,    -1,    -1,
     747,    -1,    -1,    -1,    -1,    -1,   218,   219,   220,    -1,
     222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
      -1,   233,   769,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3899,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,   281,
      -1,   283,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3926,   298,   299,    -1,    -1,
       7,     8,    -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   316,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    31,    -1,    33,    -1,    -1,    -1,
    3961,    -1,    -1,    -1,    41,    -1,   338,   339,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,   348,  3978,    -1,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    63,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,   401,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   411,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,   430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,   146,
      -1,    -1,   444,  4074,  4075,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   457,    -1,    -1,   460,    -1,
      -1,   463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,   478,    -1,  4109,  4110,
      -1,  4112,    -1,    -1,    -1,    -1,    -1,    -1,   195,   196,
      -1,    -1,  4123,  4124,  4125,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,  4138,    -1,  4140,
      -1,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,  4153,  4154,    -1,    -1,   233,    -1,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4180,
      -1,    -1,    -1,    -1,    -1,    -1,  4187,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,
      22,    23,   299,   595,    -1,    -1,  4227,    -1,    -1,   306,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4239,   316,
      -1,    -1,  4243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   624,    -1,    -1,   627,    58,    -1,    -1,    -1,
      -1,   338,    -1,    -1,   341,   637,    -1,    -1,    70,    -1,
      -1,   348,    -1,   645,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,    -1,    -1,    -1,   657,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,
    4301,    -1,    -1,    -1,    -1,   677,    -1,    -1,   680,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   124,    -1,   401,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,
     712,    -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,
     722,    -1,    -1,   430,    -1,    -1,   158,   159,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,     6,    -1,
      -1,    -1,    -1,    -1,    -1,   747,   178,    -1,    -1,    17,
     457,    -1,    -1,   460,    -1,    -1,   463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,   769,    -1,    -1,
      -1,   478,    40,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,
      -1,   243,    -1,  4444,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4457,  4458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,
     292,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   595,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     342,    -1,   344,   345,    -1,    -1,    -1,   624,    -1,    -1,
     627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,
     637,  4562,    -1,    -1,  4565,    -1,    -1,   205,   645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4579,    -1,
     657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4594,    -1,   397,    -1,   399,    -1,    -1,
     677,    -1,    -1,   680,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,
      -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   712,    -1,    -1,    -1,    -1,
      -1,   443,    -1,    -1,    -1,   722,    -1,    -1,    -1,  4650,
      -1,    -1,   454,   455,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4668,  4669,    -1,
     747,    -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,  4686,    -1,    -1,    -1,    -1,
      -1,    -1,   769,   495,   332,    -1,    -1,    -1,  4699,    -1,
      -1,    -1,    -1,   341,     5,    -1,     7,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   353,    -1,  4718,    -1,  4720,
      -1,    -1,    -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,
      31,    -1,  4733,    -1,  4735,    -1,    -1,    -1,    39,   541,
     542,   543,    -1,    -1,    -1,    -1,    -1,   549,   550,    -1,
     388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,   566,   567,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,   422,    -1,   424,    -1,   590,   591,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   609,    -1,   110,
     111,    -1,   450,   451,   115,    -1,    -1,    -1,    -1,    -1,
     458,   459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,   641,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    16,
      17,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,   497,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,  4869,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,    -1,    -1,    -1,   185,    -1,    -1,    -1,  4889,    -1,
      -1,    58,   193,    -1,    -1,  4896,    -1,    -1,    -1,   701,
      -1,    -1,   704,    70,    -1,   707,  4907,    -1,    -1,    -1,
      -1,    -1,   714,    -1,    -1,    -1,    -1,    -1,   219,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,   730,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,    -1,    -1,    -1,
    4941,    -1,    -1,    -1,    -1,    -1,    -1,   749,   651,    -1,
     588,    -1,    -1,   254,   255,   256,    -1,   124,    -1,    -1,
      -1,   599,    -1,    -1,   602,   603,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   678,   277,    -1,    -1,   617,
     147,   148,    -1,   150,    -1,  4986,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,   697,    -1,    -1,    -1,    -1,    -1,
      -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5011,   178,    -1,    -1,    -1,   653,    -1,    -1,    -1,    -1,
      -1,    -1,   660,    -1,    -1,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,   336,    -1,    -1,    -1,    -1,
      -1,   679,    -1,   681,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5065,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,   374,    -1,    -1,   243,    -1,    -1,    -1,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      34,    -1,    -1,   731,    -1,   396,    -1,    -1,    -1,   737,
     267,   268,   269,   404,    -1,  5106,    -1,   408,    -1,    -1,
      -1,    -1,    -1,   816,   415,    -1,    -1,    61,   419,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,    -1,   342,   477,   344,   345,    -1,
      -1,    -1,   885,    -1,    -1,    -1,   487,  5188,    -1,    -1,
      -1,    -1,   136,   360,   138,    -1,   140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5218,    -1,    -1,
      -1,    -1,    -1,   524,    -1,    -1,    -1,  5228,    -1,    -1,
     397,    -1,   399,    -1,    -1,   938,   537,    -1,   539,    -1,
     943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,   420,  5255,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     973,    -1,    -1,   976,    -1,    -1,   443,   578,    -1,    -1,
     983,    -1,    -1,   584,    -1,    -1,    -1,   454,   455,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     254,   255,   256,    -1,    -1,    -1,    -1,    -1,  1021,   486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,
      -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,  5340,
      -1,    -1,   643,  5344,    -1,    -1,    -1,  5348,    -1,   650,
      -1,    -1,    -1,    -1,  5355,    -1,    -1,    -1,   302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1070,  1071,  1072,
    1073,  5372,    -1,  1076,   541,   542,   543,    -1,    -1,    -1,
     681,  1084,   549,   550,    -1,    -1,    -1,    -1,    -1,    -1,
     334,    -1,   336,    -1,    -1,   696,   697,    -1,    -1,   566,
     567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   709,   353,
      -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   590,   591,    -1,    -1,    -1,    -1,    -1,
     374,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,   609,    -1,    -1,    -1,    -1,    -1,    -1,  5450,
      -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,    -1,    -1,    -1,    -1,    -1,    -1,  5468,    -1,    -1,
      -1,    -1,    -1,    -1,   641,   419,    -1,  5478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5486,    -1,    -1,    -1,  5490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,   701,    -1,    -1,   704,  5539,    -1,
     707,  5542,    -1,   487,    -1,    -1,    -1,   714,  5549,    -1,
      -1,    -1,    -1,    -1,  1257,    -1,    -1,    -1,  1261,    -1,
      -1,    -1,    -1,   730,    -1,    -1,    -1,    -1,  5569,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     524,    -1,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5602,    -1,  5604,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   578,    -1,    -1,    -1,    -1,  5640,
     584,    -1,    -1,    -1,  5645,    -1,    -1,    -1,    -1,    -1,
      -1,  5652,    -1,    -1,  1357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5688,    -1,    -1,
      -1,  5692,    -1,    -1,    -1,    -1,    -1,    -1,  5699,   643,
      -1,    -1,    -1,    -1,    -1,    -1,   650,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5718,    -1,    -1,
      -1,  5722,    -1,    -1,    -1,  1428,    -1,  1430,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,    -1,    -1,
      -1,    -1,  5743,    -1,  5745,  5746,    -1,    -1,    -1,    -1,
      -1,    -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   709,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5794,    -1,    -1,  5797,    -1,  1501,    -1,
    1503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5819,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1529,  5828,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1540,  1541,    -1,
      -1,    -1,    -1,  1546,    -1,    -1,    -1,  1550,  1551,  1552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1561,  1562,
    1563,    -1,    -1,    -1,  1567,    -1,  1569,  1570,  1571,  1572,
    1573,  5872,  1575,    -1,    -1,  1578,  1579,    -1,    -1,    -1,
      -1,    -1,    -1,  1586,  5885,  1588,    -1,    -1,  1591,  1592,
      -1,  1594,  1595,  1596,    -1,  1598,  1599,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1613,  1614,  1615,  1616,  1617,    -1,  1619,  1620,  1621,    -1,
      -1,  1624,  1625,  1626,  1627,  1628,  1629,  1630,    -1,  1632,
    1633,  1634,  1635,    -1,  1637,  1638,    -1,  1640,  1641,  1642,
    1643,  1644,  1645,  1646,    -1,    -1,  1649,  1650,  1651,  1652,
      -1,  1654,  1655,  1656,    -1,  1658,    -1,  1660,    -1,  1662,
      -1,    -1,    -1,  1666,  1667,  1668,    -1,    -1,  1671,  1672,
    1673,  1674,  1675,    -1,  1677,    -1,    -1,    -1,    -1,    -1,
      -1,  1684,    -1,    -1,    -1,    -1,    -1,    -1,  1691,  1692,
    1693,  1694,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1702,
    1703,    -1,  1705,  1706,    -1,    -1,  1709,  1710,  1711,  1712,
    1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,    -1,
      -1,  1724,    -1,    -1,    16,    17,  1729,    -1,    -1,    -1,
      22,    23,    -1,  1736,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1765,    -1,    -1,    -1,    58,  1770,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1780,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1847,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,
      -1,    -1,    -1,    -1,  1877,    -1,  1879,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1901,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,
      -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1996,    -1,    -1,    -1,    -1,    -1,   291,
     292,    -1,  2005,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     342,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   397,    -1,   399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2163,    -1,   454,   455,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2181,    -1,
      -1,  2184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2192,
    2193,    -1,    -1,    -1,   486,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   541,
     542,   543,    -1,  2256,  2257,    -1,    -1,   549,   550,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   566,   567,    -1,    -1,    -1,    -1,
      -1,  2284,  2285,  2286,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2296,    -1,    -1,    -1,    -1,   590,   591,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   609,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2358,    -1,    -1,  2361,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2379,    -1,    -1,    -1,
    2383,  2384,    -1,  2386,  2387,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2395,    -1,  2397,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   701,
      -1,    -1,   704,    -1,    -1,   707,    -1,    -1,    -1,    -1,
      -1,    -1,  2425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2439,    -1,   730,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2452,
      -1,    -1,  2455,    -1,    -1,    -1,    -1,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2469,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2506,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2547,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2593,    -1,  2595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2673,    -1,    -1,    -1,    -1,    -1,    -1,  2680,    -1,    -1,
    2683,  2684,  2685,    -1,  2687,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   651,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2891,    -1,
      -1,  2894,    -1,    -1,   678,    -1,    -1,    -1,    -1,    -1,
    2903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2912,
      -1,  2914,    -1,  2916,    -1,  2918,  2919,  2920,  2921,  2922,
    2923,    -1,  2925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2933,    -1,  2935,    -1,    -1,  2938,  2939,  2940,    -1,    -1,
      -1,    -1,    -1,    -1,  2947,  2948,  2949,    -1,  2951,    -1,
    2953,    -1,  2955,    -1,  2957,    -1,  2959,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2967,    -1,  2969,    -1,  2971,  2972,
    2973,  2974,  2975,    -1,    -1,  2978,    -1,  2980,    -1,    -1,
    2983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2996,    -1,    -1,    -1,    -1,  3001,    -1,
      -1,  3004,    -1,  3006,  3007,  3008,    -1,    -1,  3011,    -1,
      -1,    -1,    -1,    -1,  3017,    -1,    -1,    -1,    -1,  3022,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3031,    -1,
      -1,    -1,   816,    -1,  3037,    -1,  3039,    -1,    -1,  3042,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3052,
    3053,  3054,    -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3070,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3095,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3155,    -1,    -1,    -1,    -1,    -1,    -1,   943,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   973,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   983,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3269,    -1,    -1,    -1,
      -1,    -1,    -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1073,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1257,  3477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3487,    -1,    -1,  3490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3514,  3515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3539,    -1,  3541,    -1,
    3543,    -1,  3545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3564,    -1,    -1,    -1,    -1,    -1,  3570,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3585,  3586,    -1,    -1,    -1,    -1,    -1,  3592,
      -1,  3594,    -1,  3596,    -1,    -1,    -1,    -1,  3601,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3638,  3639,  3640,    -1,    -1,
      -1,    -1,    -1,    -1,  1428,    -1,  1430,    -1,    -1,    -1,
      -1,  3654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3675,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3702,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1501,    -1,  1503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1529,    -1,    -1,    -1,    -1,
      -1,  3754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3764,  1546,    -1,    -1,    -1,  1550,    -1,  1552,    -1,
      -1,    -1,    -1,  3776,    -1,  3778,    -1,  1561,  1562,    -1,
      -1,    -1,    -1,  1567,    -1,  1569,  1570,  1571,  1572,  1573,
      -1,  1575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1586,    -1,  1588,    -1,    -1,  1591,  1592,    -1,
    1594,  1595,    -1,    -1,  1598,  1599,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1613,
    1614,  1615,  1616,  1617,    -1,  1619,    -1,  1621,    -1,    -1,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,    -1,  1632,  1633,
    1634,    -1,    -1,  1637,  1638,    -1,    -1,  1641,  1642,  1643,
      -1,    -1,    -1,    -1,    -1,  1649,  1650,  1651,    -1,    -1,
    1654,  1655,  1656,    -1,  1658,    -1,  1660,    -1,  1662,    -1,
      -1,    -1,  1666,  1667,  1668,    -1,    -1,  1671,  1672,  1673,
    1674,  1675,    -1,  1677,    -1,    -1,    -1,    -1,    -1,    -1,
    1684,    -1,    -1,    -1,    -1,    -1,    -1,  1691,  1692,  1693,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3978,    -1,    -1,    -1,    -1,
      -1,  1765,    -1,    -1,    -1,    -1,  1770,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1847,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1877,    -1,  1879,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4109,  4110,    -1,  4112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4123,  4124,  4125,    -1,    -1,    -1,    -1,    -1,    -1,  1913,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,  4140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4153,  4154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4180,    -1,    -1,
      -1,    -1,    -1,    -1,  4187,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4239,    -1,    -1,    -1,
    4243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2181,    -1,    -1,
    2184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2192,  2193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4457,  4458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2284,  2285,  2286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4594,    -1,    -1,    -1,  2379,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2395,    -1,  2397,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2425,    -1,    -1,    -1,    -1,    -1,  4650,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2439,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4667,  4668,  4669,    -1,  2452,    -1,
      -1,  2455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4686,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4699,    -1,    -1,    -1,
    2484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4733,    -1,  4735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2547,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2673,
      -1,    -1,    -1,  4896,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2687,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4983,    -1,    -1,  4986,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5011,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5106,    -1,    -1,    -1,  2891,    -1,    -1,
    2894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2912,    -1,
      -1,    -1,  2916,    -1,  2918,  2919,  2920,  2921,  2922,  2923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2933,
      -1,  2935,    -1,    -1,  2938,  2939,  2940,    -1,    -1,    -1,
      -1,    -1,    -1,  2947,  2948,  2949,    -1,  2951,    -1,  2953,
      -1,  2955,    -1,  2957,    -1,  2959,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2967,    -1,  2969,    -1,  2971,    -1,  2973,
    2974,  2975,    -1,    -1,  2978,    -1,  2980,    -1,    -1,  2983,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3004,    -1,  3006,  3007,  3008,  5228,    -1,  3011,    -1,    -1,
      -1,    -1,    -1,  3017,    -1,    -1,    -1,    -1,  3022,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3031,    -1,    -1,
      -1,    -1,  5255,    -1,    -1,    -1,    -1,    -1,  3042,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3095,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3155,  5375,  5376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3269,    -1,  5490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5569,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3358,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5692,
      -1,    -1,    -1,  3477,    -1,    -1,  5699,    -1,    -1,    -1,
      -1,    -1,    -1,  3487,    -1,    -1,  3490,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3514,  3515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3539,    -1,  3541,    -1,  3543,
      -1,  3545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3564,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3585,  3586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5819,  3601,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3639,  3640,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3675,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3764,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3776,    -1,  3778,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3978,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4109,  4110,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4123,
    4124,  4125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4138,    -1,  4140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4153,
    4154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4239,    -1,    -1,    -1,  4243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4457,  4458,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4650,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4668,  4669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4686,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4699,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4733,
      -1,  4735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5011,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5228,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,  5490,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5569,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,   180,    -1,    -1,
    5604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,  5692,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,  5885,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   758,   759,    -1,    -1,    -1,
      -1,   764,    -1,    -1,    -1,     6,   769,    -1,    -1,    -1,
     773,   774,    -1,    -1,   777,   778,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,   288,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    25,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,   271,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,   114,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      95,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,   114,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,   156,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,    -1,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    18,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   758,
     759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,   774,    -1,    -1,   777,   778,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      24,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   777,   778,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    24,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   760,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    32,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    32,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
       6,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   281,   282,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
       6,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    35,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,     6,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    29,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    36,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    -1,
     704,   705,   706,   707,   708,   709,   710,   711,    -1,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    96,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   772,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    11,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    17,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    16,
      17,    -1,   753,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    17,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    17,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    17,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    18,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    45,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,    -1,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    29,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    29,
     704,   705,   706,   707,   708,   709,   710,   711,    38,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,    -1,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    29,   704,   705,   706,   707,   708,   709,
     710,   711,    38,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    29,
     704,   705,   706,   707,   708,   709,   710,   711,    38,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,    -1,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    29,   704,   705,   706,   707,   708,   709,
     710,   711,    38,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    29,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    -1,
     704,   705,   706,   707,   708,   709,   710,   711,    -1,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    93,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,    -1,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    -1,   704,   705,
     706,   707,   708,   709,   710,   711,    -1,   713,   714,   715,
      -1,   717,   718,   719,   720,    37,    38,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    45,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    74,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    46,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,   774,    -1,
      -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    57,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    57,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    61,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    61,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    61,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    61,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    61,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,    -1,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     770,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,   774,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   105,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    95,   746,   747,   748,   749,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   759,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    95,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,   753,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,    -1,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,    -1,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   110,   111,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    -1,   704,   705,   706,   707,   708,   709,
     710,   711,    -1,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,    -1,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   110,   111,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    -1,   704,   705,
     706,   707,   708,   709,   710,   711,    -1,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,    -1,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,    -1,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    -1,   704,   705,   706,   707,   708,   709,   710,   711,
      -1,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    63,    65,
      66,    73,    80,    93,    99,   112,   120,   131,   144,   146,
     151,   181,   195,   196,   206,   207,   218,   219,   220,   222,
     227,   233,   237,   241,   242,   279,   281,   283,   288,   298,
     299,   306,   316,   338,   339,   341,   348,   355,   376,   401,
     411,   430,   444,   457,   460,   463,   478,   595,   624,   627,
     637,   645,   657,   677,   680,   712,   722,   747,   769,   781,
     784,   785,   786,   787,   788,   790,   796,   798,   811,   858,
     902,   903,   910,   911,   927,   928,   959,   980,   999,  1059,
    1116,  1168,  1266,  1316,  1319,  1329,  1334,  1340,  1353,  1356,
    1362,  1365,  1370,  1377,  1389,  1392,  1395,  1396,  1398,  1401,
    1402,  1404,  1405,  1408,  1409,  1412,  1629,  1631,  1644,  1647,
    1682,  1690,  1705,  1712,  1726,  1730,  1731,  1735,  1745,  1752,
    1760,  1762,  1768,  1771,  1772,  1804,  1852,  1882,  1889,  1891,
    1900,  1903,  1943,  1945,  1950,  1951,  1952,  1953,  1983,  1992,
    1993,  1994,    49,   205,   326,   402,   451,   499,   650,   654,
     696,   726,  1267,  1957,  1958,  1959,  1960,   174,   448,   497,
    1364,  1733,   110,   111,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   366,   367,
     368,   369,   370,   371,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     746,   747,   748,   749,  1823,  1825,  1832,  1839,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,   960,   518,  1357,   186,
     499,   696,  1691,    49,   115,   205,   272,   425,   451,   499,
     636,   654,   696,   699,   726,   734,  1643,  1002,   850,   929,
    1645,  1763,   115,   396,   748,  1777,   263,   695,  1885,  1000,
    1364,  1169,  1060,    17,   518,  1718,   237,   247,   899,   904,
     906,  1832,   645,   726,  1885,  1004,   904,   905,   850,  1399,
     678,  1853,  1713,   904,  1890,  1683,  1832,  1397,  1001,   214,
    1806,  1648,   146,   279,   675,  1746,   171,   172,  1445,  1944,
     265,   778,  1826,   115,  1885,   743,  1947,  1630,   472,  1832,
    1364,   391,   912,  1892,   797,   589,   667,  1832,  1364,  1753,
    1947,  1832,  1769,     6,   660,   708,     6,   660,  1706,   589,
     667,   339,   340,   376,   416,   595,   612,   637,   677,  1986,
    1398,  1405,  1408,     0,    80,   782,   595,    49,    96,   244,
     278,   636,   726,   829,  1245,  1246,  1247,  1643,  1957,  1958,
    1959,  1960,    95,   123,  1415,  1416,  1625,  1393,  1390,    83,
     121,   277,  1407,  1954,  1406,  1954,   437,   448,   582,   777,
    1732,  1733,  1820,  1832,  1402,  1404,  1284,  1832,   852,  1832,
     753,   753,   852,   100,   112,  1642,   139,  1826,  1832,  1834,
    1007,  1008,  1011,  1034,  1832,  1642,  1308,  1309,   251,  1433,
    1961,  1962,  1957,   753,  1885,  1389,  1392,  1644,  1647,  1682,
    1690,  1729,   777,   859,   296,   961,   962,   965,   969,   809,
     810,  1826,   734,  1354,  1885,   316,   100,  1009,  1034,   114,
     152,   465,   607,  1693,  1703,  1704,  1642,  1633,  1642,  1642,
    1642,  1642,   100,  1642,  1642,  1034,  1642,  1642,   650,  1885,
     983,  1832,     6,     7,    41,    46,    63,    73,    99,   115,
     120,   146,   216,   233,   241,   272,   281,   282,   425,   430,
     441,   600,   604,   621,   626,   657,   689,  1834,  1904,  1908,
    1909,  1911,  1913,  1914,   954,   955,   152,   403,   464,  1650,
     461,   666,  1764,   123,  1773,  1883,    38,    87,    98,   127,
     134,   225,   226,   339,   361,   433,   574,   877,   925,   926,
     927,   930,   931,   932,   933,   937,   938,   939,   940,   941,
     949,   950,   951,   952,   973,   975,   976,   978,   986,   992,
    1825,  1833,  1840,  1847,  1849,  1850,  1851,  1885,    17,    18,
      19,    20,    21,    29,    30,    32,    39,    40,    43,    44,
      45,    46,    48,    49,    51,    52,    57,    61,    64,    84,
      85,    86,    88,    89,   101,   102,   103,   105,   106,   110,
     111,   112,   120,   122,   135,   149,   154,   155,   157,   163,
     165,   168,   171,   172,   173,   175,   176,   177,   179,   194,
     198,   199,   200,   202,   209,   220,   228,   231,   251,   257,
     258,   260,   261,   265,   273,   274,   275,   285,   286,   287,
     293,   295,   316,   317,   318,   322,   329,   337,   353,   362,
     364,   365,   367,   368,   369,   370,   371,   386,   398,   399,
     400,   448,   454,   456,   468,   490,   491,   495,   533,   535,
     540,   541,   542,   543,   553,   554,   570,   584,   590,   591,
     598,   605,   635,   641,   642,   648,   655,   685,   704,   705,
     706,   707,   711,   712,   726,   728,   738,   739,   741,   749,
     758,   759,   764,   769,   773,   774,   777,   778,  1408,  1414,
    1439,  1440,  1441,  1442,  1446,  1458,  1460,  1461,  1462,  1463,
    1464,  1465,  1466,  1468,  1469,  1470,  1471,  1479,  1483,  1484,
    1485,  1486,  1487,  1489,  1492,  1796,  1799,  1801,  1802,  1803,
    1817,  1824,  1825,  1832,  1839,    26,  1061,   500,   350,   357,
     373,   383,   384,   385,   393,   532,   546,   647,   684,   698,
     907,   909,   728,   900,   906,  1832,   850,  1366,   877,   989,
     906,     6,   321,   604,  1901,  1902,  1909,  1911,     6,    68,
     249,   250,   259,   464,   670,   671,   672,   673,  1418,  1425,
    1426,  1956,  1854,    32,    61,   353,   458,   497,   547,   584,
     636,   653,   708,   740,   778,  1208,  1825,  1830,  1832,  1843,
    1844,  1845,  1846,  1848,  1849,  1850,  1851,  1857,  1869,  1873,
       6,    40,    41,    50,   115,   129,   205,   263,   313,   332,
     341,   353,   364,   388,   419,   422,   424,   450,   451,   458,
     459,   475,   497,   518,   574,   588,   599,   602,   603,   617,
     653,   660,   681,   737,  1208,  1244,  1714,  1718,  1719,  1721,
    1730,  1825,  1870,   906,  1885,   152,  1689,   769,  1661,  1670,
     987,  1439,  1805,   403,  1651,  1689,  1747,  1832,   331,  1947,
    1834,  1371,  1330,    10,  1948,  1439,  1512,   791,   284,   793,
    1736,   406,  1820,  1822,  1832,  1893,  1834,   112,  1115,  1826,
      95,  1335,   518,   606,   660,  1754,  1755,   270,  1948,   736,
    1770,   661,   809,   211,   299,  1320,  1321,  1322,   661,   809,
     263,  1707,  1642,  1642,    18,   105,   106,   265,  1797,  1798,
    1827,  1985,  1985,  1985,   448,  1984,  1985,  1985,   770,   770,
     776,  1832,  1115,  1115,  1115,   654,   834,   115,   115,   115,
     263,   650,   205,   272,   425,  1961,   325,   851,   851,  1957,
      74,   769,   774,  1414,  1417,  1517,  1518,  1519,  1520,  1521,
    1532,  1533,  1534,  1535,  1537,  1538,  1539,  1820,   189,   412,
    1620,  1621,  1626,   297,  1562,  1415,    93,   141,   146,   185,
    1427,  1587,  1592,  1598,  1599,  1603,   205,  1602,  1615,  1625,
       6,    68,  1955,  1598,  1600,  1408,  1411,  1412,  1599,  1601,
    1410,     6,  1832,  1728,  1727,   777,  1394,  1391,  1269,   725,
    1270,   777,   531,   700,   718,    45,  1834,  1835,  1836,  1908,
    1271,  1013,  1035,  1832,    84,  1276,  1275,     5,    31,    73,
     172,   212,   610,  1036,   850,   263,   114,   573,  1310,  1311,
    1312,   649,   425,   734,  1961,  1834,  1341,  1832,   769,   862,
     970,    76,   972,  1439,   969,   270,  1355,  1636,  1637,  1820,
    1012,  1035,     5,    95,  1694,    95,  1694,  1695,  1696,  1700,
    1701,  1832,  1703,  1832,   112,  1641,   852,   852,   852,  1832,
    1035,   850,  1834,  1045,  1719,   850,  1634,  1642,  1642,  1003,
     984,   599,  1912,   639,   639,   696,   699,   726,   734,   769,
    1438,   465,   576,  1916,   695,  1918,  1915,    50,   734,  1917,
     180,   358,   660,   270,   180,   772,   416,  1439,   114,  1307,
     381,   606,  1765,  1766,   348,   152,   380,  1779,  1820,  1886,
    1887,   296,  1833,    95,   100,   553,  1832,  1833,  1833,  1833,
     979,  1832,   296,  1833,  1832,   416,   926,   776,   785,   934,
     953,  1832,    93,   151,   220,   298,   339,   779,  1363,   122,
     758,   759,  1463,   769,   769,   769,   296,  1439,  1515,  1516,
     769,   769,   769,   769,   769,  1438,  1438,  1438,   769,  1437,
     769,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,  1439,   769,   110,   111,   365,   769,
    1513,  1514,  1817,  1824,  1839,   769,   769,   769,   769,  1439,
    1437,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   197,   769,   769,   769,  1437,   265,  1798,  1438,  1437,
    1437,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   177,  1824,   769,   769,   769,   769,   769,   769,
     769,   265,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   728,   769,   769,
     769,   769,   769,   728,   769,   769,   769,   769,   769,   769,
     769,   265,   769,   769,   769,   265,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   122,  1463,   122,  1463,  1463,
    1170,  1408,  1439,  1804,  1832,  1824,  1493,     9,    10,   184,
     186,   303,  1443,  1444,    81,    97,   126,   132,   169,   753,
     754,   755,  1447,    15,   125,   140,   217,   668,  1445,    69,
     165,   183,   239,   240,   756,   757,   758,   759,   760,   761,
     762,   763,  1463,    34,   166,   191,   191,   741,  1827,   777,
     769,   197,  1062,    14,   270,   772,   753,  1827,  1367,  1835,
    1837,  1368,  1369,  1820,   724,  1912,   576,   180,    95,   180,
    1400,  1426,    61,  1832,  1856,  1872,   237,   636,   777,    17,
      61,   238,   753,  1209,  1210,  1664,  1834,    93,  1664,  1879,
    1664,  1834,  1859,   778,  1834,    17,    61,  1212,  1213,  1834,
    1664,   777,  1860,  1858,   661,   769,    49,   205,   263,   272,
     313,   425,   451,   650,   726,   734,   140,   297,  1725,   363,
     679,   679,   307,   679,   424,  1725,     6,  1127,  1834,  1591,
    1592,  1593,    95,   125,  1720,  1722,   363,   679,    93,   679,
     695,   667,     6,   343,   387,   389,   481,   530,   579,   669,
     691,  1708,  1709,  1710,   809,   467,   679,   810,  1593,  1725,
    1722,   500,   418,   366,   601,   695,   710,    93,  1432,   679,
     731,  1307,  1671,   772,   411,  1807,  1808,  1812,  1832,   123,
    1652,  1653,  1654,  1820,   981,   772,  1372,  1373,  1374,  1375,
    1820,  1636,   351,   560,   218,   560,  1949,   772,  1439,   794,
      17,   252,   405,   419,   421,   452,   467,   500,   518,   599,
     606,   616,   629,   660,   663,   679,  1737,  1742,  1743,  1825,
    1885,    35,   778,   913,   914,   915,   916,  1824,   574,   211,
     361,  1445,  1832,   789,   734,  1332,  1885,  1757,   348,  1756,
     772,   645,  1832,  1949,    93,  1323,  1324,  1323,   572,   745,
     382,   772,  1323,  1323,  1637,  1832,  1826,   772,   571,  1988,
     690,  1989,   753,   128,   631,  1987,    80,   783,  1832,   850,
     850,  1115,  1115,   817,   819,  1115,  1115,  1115,   824,   826,
     734,   451,   451,  1961,  1517,  1521,  1533,  1534,  1535,  1536,
    1537,  1832,    94,  1423,    42,   117,   128,   135,   167,   228,
     259,  1528,  1529,   772,   196,  1530,  1531,   265,  1828,  1828,
     778,  1622,  1623,  1624,  1832,  1834,  1563,   100,  1566,  1562,
     281,   149,   177,   229,   274,   365,  1594,  1595,  1799,  1824,
     125,    26,  1591,  1427,  1832,  1427,  1428,  1428,  1411,  1729,
    1734,  1797,  1832,  1832,  1599,  1602,    61,  1112,  1113,  1124,
    1125,  1217,   396,   853,  1832,  1438,   778,   853,     5,  1014,
    1820,   575,   395,  1031,  1031,  1031,     4,  1835,  1836,  1837,
    1924,  1928,  1820,  1312,   402,   479,   852,  1820,   734,  1342,
    1343,  1637,   777,   860,   863,   864,  1439,  1439,   877,   416,
     963,   799,  1636,    93,   352,   437,   439,   529,   607,   772,
    1358,  1359,  1360,  1014,  1031,  1820,    14,  1692,  1639,  1640,
    1821,  1832,    93,  1421,  1422,  1562,   772,  1697,   777,  1702,
      84,  1832,   777,  1045,  1907,  1909,   563,   736,  1046,  1047,
     419,  1837,  1923,  1636,  1635,  1632,   411,   125,   985,   695,
     770,   769,  1932,  1932,  1932,  1932,  1837,  1924,   192,   205,
     263,   451,  1910,   425,   430,   441,   600,   621,   626,   657,
     689,  1914,   112,   266,  1652,   469,   726,  1439,  1767,  1767,
    1378,   497,  1778,    11,   753,  1558,  1559,  1560,   564,   736,
     772,  1884,   935,   936,   296,  1832,   553,    95,   123,   878,
     935,   296,   769,   948,   151,   776,  1439,   772,   995,   993,
     998,   994,   977,  1636,   769,     6,  1503,  1561,  1503,  1503,
    1439,  1516,    76,   296,   416,  1439,  1512,  1439,    68,  1503,
    1561,   770,    57,    89,   105,   149,   177,   274,   770,  1607,
    1611,  1612,   770,  1439,  1439,  1817,   770,  1403,  1404,  1413,
    1804,    53,    54,    55,    56,   107,   108,   109,   161,   162,
     232,   304,   400,   468,   533,   535,   540,   605,   648,   738,
     749,  1555,  1556,  1439,    68,  1495,  1439,  1439,  1439,  1439,
    1439,  1555,  1439,  1824,  1514,   324,   772,   777,    68,  1503,
    1439,    68,  1503,  1439,  1439,  1439,   770,  1439,  1439,  1442,
     770,  1439,  1439,   770,   640,  1503,  1503,    68,  1503,  1503,
    1503,  1439,  1439,  1467,    25,   133,   271,  1439,  1459,  1439,
    1439,    68,  1503,  1439,  1512,  1439,   777,  1439,  1439,  1439,
    1455,  1456,  1439,  1439,  1439,  1439,  1439,  1439,  1439,  1512,
     397,   399,   704,   707,  1557,  1439,  1439,  1512,  1820,  1512,
    1439,  1439,  1439,  1512,  1512,  1512,    93,  1820,  1439,  1439,
    1439,  1512,    93,  1439,  1439,  1439,   770,  1439,  1820,  1439,
    1439,  1556,  1556,  1439,  1459,  1439,   770,   365,   777,  1818,
    1832,  1439,  1439,  1439,  1439,  1439,  1439,   770,   772,  1404,
    1439,   777,   778,  1494,  1834,  1439,  1439,  1439,  1441,    86,
     176,   273,   723,  1445,     6,   328,  1441,  1448,  1441,   769,
    1414,  1441,  1441,   140,    15,   125,   140,   217,  1442,  1442,
    1442,  1442,  1442,  1442,  1442,   122,  1442,   122,  1442,  1442,
    1442,  1442,  1442,  1214,  1834,  1463,   769,  1491,  1572,  1832,
     769,   100,  1824,  1472,   449,   483,   559,   640,  1457,   142,
     208,   496,   694,  1063,  1067,  1761,  1826,   909,   399,   704,
     707,   908,  1492,  1801,  1817,   772,   270,   772,  1884,   990,
     772,    93,  1837,  1836,  1925,   192,   205,   451,  1910,   760,
    1430,  1431,  1433,   777,   777,  1664,   772,  1855,  1909,  1832,
      34,  1215,  1439,  1837,   265,   570,   584,  1880,     6,    17,
      61,   180,  1439,  1881,   211,   482,  1874,  1875,  1876,  1877,
     458,   497,   653,  1871,  1664,  1881,  1832,   708,  1861,  1872,
     772,  1863,   679,   760,  1115,   852,  1820,   852,   307,   852,
     852,   852,  1820,  1837,  1820,  1432,  1432,   852,  1725,  1720,
     363,   679,  1725,   125,  1723,   500,   544,   679,  1717,  1717,
    1725,  1832,   852,  1725,  1836,  1720,  1725,  1826,   480,   692,
     440,    93,  1711,   772,   424,   679,  1820,  1722,  1720,  1720,
    1439,  1725,  1725,  1725,  1518,  1681,  1820,  1433,  1673,  1675,
     769,  1668,   988,   772,   769,  1810,  1653,  1649,  1638,  1820,
     878,   778,   125,   772,   196,  1383,  1385,  1386,   437,   607,
    1331,   351,   218,  1439,   792,    61,   114,   795,  1439,  1676,
    1677,   500,   500,   500,   500,   348,   500,   809,   500,   772,
    1432,  1738,   908,   918,  1834,   772,   753,  1559,  1894,    84,
     667,  1439,  1333,  1636,   270,  1759,   809,  1755,  1832,     6,
    1318,   620,   674,  1325,  1326,  1317,   664,  1322,  1884,  1797,
     587,  1990,  1834,   821,  1907,  1924,  1834,   815,  1115,  1115,
     812,  1820,   825,  1433,  1970,   838,  1433,  1115,  1115,  1115,
     734,   772,   770,   770,   770,   770,   770,   772,   770,  1517,
       6,    11,    15,    95,  1424,  1560,   128,   128,   188,  1540,
     135,   228,  1528,  1540,  1517,  1519,   769,  1423,  1627,  1834,
     772,   777,  1439,    26,   104,  1564,  1566,   564,   736,  1429,
     428,  1824,   229,   569,   772,   777,   656,  1588,  1616,  1113,
      34,  1208,   407,   164,   210,   251,   374,   386,   488,   560,
     855,   857,  1834,   613,   719,  1032,  1033,   476,  1028,  1029,
    1030,  1037,  1045,  1047,  1277,   769,  1826,   333,   525,  1022,
    1023,  1024,  1037,  1038,  1039,  1045,  1047,  1015,  1016,  1022,
     470,   221,   772,  1935,  1884,  1274,  1273,  1820,   772,   586,
    1344,  1832,   862,   770,   772,   971,    29,   296,   964,   966,
      71,   113,   153,   471,   501,   502,   504,   505,   506,   507,
     508,   510,   511,   512,   513,   514,   515,   516,   517,   519,
     520,   521,   618,   619,   800,   801,   808,    93,  1361,   725,
    1637,  1359,   374,   557,   614,   720,  1025,  1026,  1027,  1037,
    1041,  1042,  1043,  1044,  1045,  1047,   283,  1010,  1530,   694,
     772,  1698,   777,  1702,   201,  1586,  1587,  1701,    95,   760,
    1832,   180,  1832,  1046,   772,  1664,  1665,   772,    28,   223,
    1313,  1636,  1636,   877,   635,   982,  1832,  1933,  1934,   270,
     299,  1906,    24,   760,  1820,  1832,  1922,  1922,  1922,  1922,
     956,  1646,  1439,  1837,  1379,  1380,  1381,  1382,  1820,   116,
    1825,  1829,  1838,  1844,  1845,  1846,  1847,  1848,  1849,  1850,
    1851,   152,   211,   745,  1888,   105,   759,  1604,  1606,  1887,
    1439,   935,   123,   641,  1832,    59,   876,   879,   935,   942,
     943,   947,  1832,   983,   986,   989,   987,   878,  1884,  1439,
     770,  1504,   770,   770,   266,   416,  1439,  1439,    11,   284,
     770,   284,   772,  1480,   770,   760,   770,   772,   772,   770,
     770,  1404,    95,   770,  1482,   770,   772,   770,   772,   772,
     772,   772,   759,   772,   770,   769,  1817,  1824,  1503,   770,
     770,  1503,   770,   772,   770,   772,   770,   770,   125,   772,
     772,   770,   770,  1503,   770,   770,   770,   772,    95,   772,
     770,    95,  1439,    95,  1439,    95,  1439,    95,   770,   772,
     770,  1503,   770,   770,   770,   770,  1824,   772,   770,   772,
     770,   772,   772,   772,   772,   772,   770,   770,   772,   770,
     772,   770,   770,   772,   770,   770,   770,   770,   770,   770,
     770,   770,  1820,   770,   770,   770,   772,   770,  1820,   770,
     770,   772,   770,   772,   772,   770,   772,   772,   772,   770,
     770,   772,  1824,  1832,   770,   777,   770,   772,    11,   494,
     772,  1233,   772,   770,  1555,  1555,  1512,   770,   775,  1824,
    1871,   238,    86,   176,   273,   723,   769,    10,  1439,   423,
    1441,  1441,   769,  1414,  1441,  1441,  1439,  1439,  1573,   196,
    1575,   769,   769,   777,  1433,  1476,  1477,  1478,   366,   769,
    1072,  1073,  1065,  1072,  1066,   582,  1075,   130,   462,  1439,
     753,  1837,  1837,  1369,   270,  1439,    99,  1909,    95,   772,
      24,  1922,  1922,  1922,  1922,   772,  1439,  1815,  1824,  1832,
    1832,  1881,  1872,    93,    93,  1664,    61,  1214,  1216,  1664,
     769,   769,   572,   745,   494,   772,   772,   777,   777,   777,
      61,   740,  1825,  1826,  1831,  1841,  1844,  1845,  1846,  1847,
    1848,  1850,  1851,  1439,  1664,  1874,  1862,  1864,  1865,   770,
    1832,   852,  1826,  1439,  1725,   852,  1725,  1826,    95,  1724,
     850,  1725,   606,  1593,  1710,  1723,  1720,  1820,  1725,  1725,
     237,  1530,  1677,   770,   772,  1669,   877,  1808,  1811,  1832,
    1809,   136,   137,   237,  1053,  1403,  1655,  1657,  1660,  1530,
     876,  1834,    61,  1376,  1832,  1374,  1820,  1058,  1385,   115,
     130,  1242,  1387,   793,   772,    62,  1748,   809,  1743,  1636,
    1744,   916,   919,   920,   915,   565,   566,   642,   917,   442,
     553,  1832,  1895,  1896,  1826,  1636,   437,   607,   727,  1336,
    1337,  1338,  1606,     6,  1758,   661,   772,   724,  1327,   772,
      93,  1991,  1111,  1112,   299,  1905,  1935,   835,  1832,  1832,
    1832,  1820,   814,   852,  1980,  1115,  1115,  1820,   852,  1832,
     852,  1115,  1517,  1517,   775,   568,   704,   708,  1419,  1420,
    1465,  1420,   128,  1540,  1540,  1532,   128,   180,   284,  1554,
    1832,  1559,  1208,  1211,  1623,  1832,  1439,  1567,  1816,  1565,
     740,  1569,  1564,  1606,  1595,  1596,   428,  1595,  1595,  1824,
     538,  1589,  1816,   769,  1665,  1665,   548,   251,   251,   649,
    1826,   251,   251,   251,  1826,  1826,  1665,   772,  1030,   156,
     348,   394,   474,   536,   555,   556,   560,   561,   562,   628,
     677,   831,   832,    49,   466,   577,   584,   592,   665,   726,
     836,   837,  1665,  1665,   772,  1024,  1017,  1018,  1037,  1038,
    1039,    26,   299,   733,  1926,   252,   356,   484,   558,   686,
     746,  1920,  1921,  1928,   299,  1938,  1268,   180,   846,  1281,
     769,  1963,  1272,  1343,    93,   861,  1439,   266,   967,   966,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   772,   725,  1665,  1665,  1665,  1665,
     772,  1027,   499,   438,  1019,  1020,  1021,  1037,  1038,  1039,
    1040,  1043,  1044,  1045,  1047,  1420,  1640,  1832,   284,  1832,
     568,   141,  1597,  1518,   777,  1702,  1820,  1909,  1126,  1834,
    1837,  1884,   416,   769,   942,   945,   770,   772,  1924,   321,
    1922,   777,   777,   270,   270,   270,   270,   877,  1655,   772,
    1383,  1385,  1828,   745,   497,   380,    57,    89,   149,   177,
     274,   123,    37,    38,   432,   433,   740,   885,   886,   887,
     889,   895,   922,   923,  1825,  1842,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,   416,   926,   776,   944,   770,   772,
     996,   974,   991,  1833,   991,   991,   876,   772,  1439,  1439,
     266,    17,    32,    58,    70,    90,   122,   124,   280,   292,
     397,   399,   550,   658,   707,   730,  1505,  1509,  1510,  1209,
    1209,  1505,  1512,   770,   122,   122,  1439,  1512,  1439,  1439,
    1439,  1439,  1439,  1439,  1439,  1442,   777,   770,   770,  1439,
    1439,  1439,  1439,  1439,   770,  1439,  1439,  1439,  1439,    95,
    1439,    95,  1439,    95,  1439,   122,  1439,   770,  1456,  1439,
    1455,  1512,  1439,  1439,  1439,  1439,  1439,  1439,  1439,  1512,
     149,   758,  1604,  1608,   122,  1439,  1439,  1439,  1439,  1439,
     777,   777,  1832,  1439,    17,    32,  1228,  1229,  1230,  1231,
    1232,  1607,  1606,   770,  1439,   759,   759,  1831,  1439,  1413,
    1441,   770,   772,  1441,    10,  1439,   423,  1555,  1555,  1574,
    1832,    26,   770,  1488,  1511,  1512,  1824,  1439,   770,   772,
     769,  1081,  1442,  1073,   141,  1107,  1108,  1607,   688,  1076,
     326,  1068,  1064,   908,   270,  1820,   416,   576,  1923,  1836,
    1922,    95,    95,    95,    95,  1431,  1434,  1434,   777,  1664,
    1664,   784,  1837,  1881,   265,   265,   211,   625,   651,  1878,
    1876,  1875,   777,   777,  1664,  1881,  1863,   772,  1867,  1869,
    1873,   422,   737,  1604,  1609,  1715,   177,  1724,  1562,  1720,
    1685,  1686,  1818,  1421,  1434,  1433,  1672,  1674,  1677,   416,
     770,   772,    11,  1658,  1659,  1813,  1814,  1818,  1832,  1804,
    1656,  1660,   416,  1384,   769,  1677,   753,    93,   299,  1739,
    1740,   753,   772,    97,   132,   442,   489,   553,   597,   753,
     754,   755,  1897,  1899,  1562,    95,  1339,  1337,  1326,   503,
     808,  1328,  1606,   534,   321,  1938,    92,   284,   714,  1255,
     180,   180,   813,   830,   831,  1981,  1971,   852,   822,   769,
     633,   769,  1820,  1420,   265,  1442,    10,   270,  1517,  1532,
     128,   128,  1517,  1532,  1522,  1523,   770,   772,  1549,  1550,
    1210,  1628,   300,   301,   772,  1568,    12,    65,  1590,  1439,
    1491,  1570,  1571,  1569,  1596,  1429,   772,  1590,  1433,  1617,
    1618,  1619,  1216,  1210,   396,   396,   402,   479,   105,   149,
     177,   274,  1048,  1610,  1611,  1825,  1030,  1665,  1665,    26,
    1665,  1667,  1665,   156,   536,   299,  1665,  1666,  1666,   832,
    1826,  1826,  1826,  1826,  1606,  1826,  1826,   770,   772,  1048,
    1048,  1024,   772,  1018,   265,   584,  1834,  1929,  1930,   265,
     265,   265,    10,  1919,   522,   523,   526,   527,   528,  1936,
    1937,   319,   584,  1280,     5,     7,     8,    31,    33,    39,
      73,   115,   146,   181,   185,   193,   196,   219,   254,   255,
     256,   277,   302,   326,   334,   336,   355,   362,   374,   381,
     396,   404,   408,   409,   415,   419,   427,   447,   473,   477,
     487,   524,   537,   539,   578,   584,   611,   622,   623,   624,
     643,   650,   681,   696,   697,   709,   712,  1056,  1118,  1120,
    1123,  1124,  1125,  1285,  1289,  1291,  1294,  1300,  1301,  1302,
    1304,  1305,  1583,  1825,   378,   646,   219,  1282,  1832,  1964,
      11,  1963,     6,   366,  1345,   862,   877,  1439,   769,   769,
    1606,   769,  1606,  1606,  1826,  1826,  1609,  1826,  1606,  1826,
    1826,  1826,  1826,  1826,  1826,  1826,  1606,  1826,   392,   560,
     662,  1802,  1826,  1606,   801,  1826,  1607,  1048,  1048,  1027,
     100,  1665,   772,  1021,   777,  1518,  1702,  1432,   229,  1595,
     224,  1699,  1562,  1884,  1313,    93,   892,   893,   946,    72,
    1934,   299,  1940,   576,   270,   760,   760,  1924,  1924,  1924,
    1924,   957,   180,  1678,  1381,  1820,  1385,   114,  1388,  1774,
      16,    17,    22,    23,    32,    58,    70,    90,   124,   147,
     148,   150,   158,   159,   160,   178,   213,   237,   243,   267,
     268,   269,   291,   292,   342,   344,   345,   360,   397,   399,
     420,   443,   454,   455,   486,   495,   541,   542,   543,   549,
     550,   566,   567,   590,   591,   609,   641,   701,   704,   707,
     714,   730,   749,  1174,  1176,  1177,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,   460,    35,    47,
     772,   776,  1439,   943,   411,   416,  1439,  1439,   769,  1194,
    1195,  1195,   769,  1191,  1192,  1194,   769,  1192,  1197,    56,
     124,  1194,  1195,  1195,   124,  1195,  1194,   770,   770,   770,
     770,  1481,  1439,  1439,   770,   185,  1497,   770,   770,   772,
     772,   770,   772,   770,   125,  1473,  1474,  1824,   770,   770,
     770,   770,   770,   772,    93,   772,  1439,  1439,  1439,  1439,
     770,   770,    11,  1449,   770,    11,   770,   770,   772,   770,
     772,   770,   770,   770,   770,   149,   177,   177,   770,   772,
    1439,   770,   770,   772,   772,   770,  1824,  1832,   777,   770,
     769,  1223,  1223,    12,    65,   635,   758,  1225,  1226,  1227,
     772,   772,   770,  1439,  1439,   777,   770,  1512,  1441,   770,
     772,  1441,  1575,  1567,   185,  1490,   770,   769,  1434,  1478,
    1069,  1070,  1071,  1832,   770,  1609,   122,    26,   769,  1083,
     753,   769,  1073,  1837,   220,    95,    95,  1925,  1925,  1925,
    1925,    11,  1435,  1826,  1832,   760,  1824,  1881,  1881,   770,
     770,   375,   717,   211,  1832,  1832,  1881,  1866,  1868,    57,
      89,   149,   177,   274,  1593,  1716,  1725,   772,  1684,  1664,
    1559,  1677,   770,   772,   298,  1832,   769,   770,   772,   777,
    1404,  1662,  1663,  1818,   769,   204,  1551,  1552,  1553,  1832,
     769,  1741,   211,   350,   357,   373,   383,   384,   385,   393,
     532,   546,   632,   647,   684,   698,   921,   920,  1898,  1593,
     545,   753,   772,  1836,  1280,   396,   346,   462,   644,  1261,
    1261,   180,  1820,  1820,   136,   138,   140,  1049,  1051,  1117,
    1119,  1120,  1132,  1117,   769,   874,   852,   839,  1963,   828,
      58,   124,   213,   683,  1130,   827,   823,  1420,  1420,   180,
    1525,  1532,  1532,   180,  1527,  1439,   769,  1058,  1832,  1547,
    1548,   366,  1781,  1816,    11,   772,  1816,  1439,   770,   772,
    1608,  1608,  1608,  1608,  1608,  1608,   837,  1018,   265,    11,
     284,  1927,  1931,   186,  1920,  1606,  1606,  1606,  1802,   758,
    1604,  1605,  1936,   146,   279,  1278,   435,    36,   196,   372,
     585,   693,  1136,  1144,  1145,  1150,  1151,  1242,  1246,  1247,
    1306,  1306,   196,  1306,   196,   270,    36,    92,   196,   585,
     693,  1149,  1242,  1306,   407,  1665,   196,    26,  1665,  1058,
      11,   270,   753,  1315,  1665,  1665,  1665,  1665,   732,  1665,
    1665,  1665,  1665,   196,  1665,  1665,   407,  1665,   129,   696,
     129,  1665,   196,   696,  1665,  1665,  1665,  1665,  1306,  1665,
    1665,   196,   583,   196,   196,  1665,  1665,   410,   530,  1832,
    1665,  1665,   196,  1118,   772,  1055,  1056,  1289,   769,   777,
    1135,  1152,  1819,  1832,  1664,  1445,  1946,   330,   426,   840,
     270,   408,   415,   842,   770,   772,  1965,  1966,    11,     6,
     769,  1346,   968,   804,   805,  1606,   806,   807,  1606,   802,
     803,  1606,  1832,  1048,  1021,  1832,  1562,  1832,   428,   229,
    1430,   894,   770,  1439,   945,    99,  1924,  1935,  1935,  1935,
    1935,    76,    77,   958,   413,  1388,   492,   114,   316,  1780,
    1194,  1196,  1195,   379,  1194,  1201,  1202,  1191,   203,  1191,
    1201,    17,    34,   329,   347,   721,  1178,  1202,  1208,  1218,
    1219,  1221,    32,   291,  1178,  1184,  1186,  1201,  1178,  1191,
     769,  1201,  1178,  1194,  1196,  1178,  1195,   769,  1191,  1201,
      32,   292,   292,   294,  1191,  1194,   714,   769,   884,  1195,
    1195,  1195,   568,  1194,  1195,    61,   924,  1191,   294,  1196,
    1196,  1194,  1194,  1195,  1197,    93,    93,   888,  1832,   877,
     974,    57,   149,   177,   274,  1506,   177,   177,  1194,  1507,
    1508,   770,  1555,  1555,    26,   235,  1496,  1439,  1439,  1512,
     167,   345,   770,   299,  1475,  1439,  1439,  1439,  1555,    58,
      70,    90,   124,   213,   280,   397,   399,   549,   550,   707,
    1184,  1185,  1450,  1451,  1452,  1453,  1505,  1439,  1439,    86,
     273,  1606,  1614,  1555,  1439,  1439,  1832,  1607,   770,  1233,
    1228,  1226,  1228,  1229,  1606,  1832,   770,  1512,   185,  1576,
      26,   770,  1511,  1435,   770,   772,  1439,  1067,   196,  1084,
    1085,  1607,  1069,  1925,  1925,  1826,  1832,   777,  1664,  1664,
    1867,  1872,  1593,  1686,  1562,    61,  1676,  1549,  1434,  1677,
    1403,  1813,   760,  1832,   770,   772,  1664,     6,  1290,  1298,
    1299,  1832,   770,   772,  1609,  1749,  1750,   436,   146,   769,
    1826,   808,   744,  1820,   818,   820,    36,   585,  1133,  1134,
    1135,  1136,  1144,  1145,   140,  1820,  1054,  1055,   772,  1119,
    1050,   875,   854,    14,   323,  1005,   180,    11,   865,   866,
     667,   865,  1963,  1524,   284,  1526,   284,  1554,   114,   283,
     447,  1542,  1543,  1546,    79,    82,   182,   264,  1782,  1783,
     143,  1784,  1590,  1572,  1571,  1590,  1434,  1619,   584,  1826,
    1929,   177,   177,   584,    61,   122,   551,  1279,   112,  1264,
    1819,  1115,    94,   112,  1114,   732,    33,    92,   204,   278,
    1148,  1241,  1115,  1242,  1243,  1243,  1114,  1641,  1364,  1641,
    1290,  1208,  1641,   130,  1642,    94,  1641,   732,   204,  1641,
    1641,  1665,    61,  1832,  1364,  1584,  1585,  1818,    61,  1606,
    1613,  1057,  1820,    61,  1606,    61,  1606,    61,  1606,  1121,
      61,  1832,  1609,  1606,  1606,  1364,  1826,  1826,  1665,  1606,
    1834,  1299,   442,   489,   560,  1129,  1606,  1609,  1609,  1641,
      61,  1606,  1826,  1364,  1364,  1364,    61,   377,   379,   414,
     443,   579,   615,  1128,  1613,  1606,  1613,  1290,     5,    73,
    1302,  1131,  1133,  1832,   323,   442,  1314,   216,  1235,  1153,
     777,    61,  1610,  1826,  1832,   596,  1439,  1439,   180,   846,
     852,   180,   374,   847,  1832,  1403,  1965,  1347,   475,   266,
     770,   772,   770,   772,   770,   772,    95,   428,  1389,  1804,
     576,  1935,   299,  1939,  1939,  1939,  1939,   877,   954,  1679,
     123,  1201,  1200,  1664,  1201,   280,   305,   658,  1193,  1193,
    1218,  1216,  1220,  1221,  1209,    17,  1219,  1222,   379,  1203,
    1201,  1178,  1193,  1265,  1797,  1201,  1265,  1193,   294,  1193,
    1201,   568,   881,   882,   883,  1832,   924,  1178,   880,   922,
    1178,  1193,  1439,   215,  1190,  1220,  1222,  1178,  1201,  1193,
    1193,   890,   898,   899,  1606,   769,   891,   416,   770,   770,
     770,   770,  1220,   772,  1220,  1220,   770,   770,  1498,  1816,
    1797,   141,  1499,  1500,  1501,   770,   772,   770,   488,   538,
     606,   770,   770,  1191,   124,  1195,    32,  1195,  1454,   770,
     770,   770,   770,   772,   770,   770,   770,  1224,   770,   772,
     770,    26,   208,   229,  1577,  1578,  1816,   770,  1071,  1555,
     130,   462,  1086,   770,   772,   770,   760,  1881,  1881,  1586,
     770,   777,  1663,  1677,   770,   772,  1552,   770,   772,    10,
    1751,  1674,  1834,   816,   769,   769,    93,  1146,   770,   772,
    1820,  1052,  1780,  1119,  1117,   118,   125,   190,   870,   871,
     872,   873,   855,   856,  1946,  1982,    63,   120,   281,  1006,
     646,  1965,   770,   867,   868,   869,  1832,  1826,   770,    11,
    1439,   769,  1439,   769,   770,  1242,  1242,  1543,    26,    26,
      79,    26,  1783,   253,   264,  1785,  1786,   769,   435,   177,
     319,  1445,  1364,   769,  1445,  1146,   769,   130,   130,  1243,
    1115,  1264,  1832,  1115,  1115,  1819,  1290,  1819,  1287,  1210,
    1819,  1641,  1298,    93,   130,  1819,  1819,  1826,  1290,   772,
    1590,  1061,   769,  1607,  1826,   299,  1152,  1290,  1295,  1290,
     770,  1832,  1820,   342,   344,   345,   360,   397,   399,   420,
     443,   454,   455,   486,   495,   541,   542,   543,   549,   550,
     566,   567,   590,   591,   609,   652,   701,   704,   707,   730,
     749,   922,  1154,  1175,  1176,  1832,  1555,   660,  1826,   411,
    1283,   299,  1967,  1350,  1832,     6,   769,  1348,   877,   805,
     807,   803,  1442,  1939,    99,  1936,  1941,  1942,   130,   263,
    1832,   305,   280,  1200,   770,   772,   770,   880,  1174,   770,
     772,   924,   777,   753,  1222,   187,   246,   248,   896,   897,
     898,   901,  1445,  1832,   867,    93,    93,   177,   772,  1590,
     770,  1502,  1595,  1439,   538,   434,  1220,  1609,   770,  1606,
    1589,   770,    15,   391,   399,   704,   707,   716,  1579,  1580,
    1801,  1590,   676,  1109,  1068,   769,  1074,  1087,  1832,  1085,
    1597,   760,  1299,  1750,   408,   770,   575,   769,  1262,  1263,
    1832,  1262,  1832,  1134,   770,    11,  1110,  1054,   770,   772,
     869,    67,   926,   180,   840,   633,  1976,   772,   641,   714,
    1174,  1976,  1965,  1554,  1554,    93,  1541,  1541,  1797,  1797,
      26,  1797,    26,    26,  1786,   265,  1279,   400,  1278,    84,
    1292,  1832,    84,  1439,  1115,  1264,  1832,   284,  1254,   714,
    1264,  1264,    73,   237,  1152,  1358,  1215,  1819,  1832,  1313,
    1286,  1585,  1744,   263,  1314,  1296,  1298,  1288,   769,  1236,
    1156,   777,  1147,  1148,  1155,   777,   841,   848,   849,    33,
     349,   497,   770,   772,  1349,   270,   576,  1942,   281,  1820,
    1220,  1797,  1220,   924,   882,  1832,   177,   772,   926,   449,
     770,   893,   997,   770,  1816,   569,   772,   770,   770,   770,
     716,  1580,  1581,  1801,   641,   594,   429,  1582,   594,  1606,
     769,  1081,  1077,    61,   289,   290,   391,   465,  1088,   354,
     769,  1262,   770,   772,  1590,   769,   770,   769,  1053,  1052,
     872,    91,   833,  1433,   845,   846,  1977,   854,  1978,   869,
     714,   884,   568,  1978,   770,   770,   100,   128,   185,  1545,
    1544,  1797,  1797,  1797,   770,  1819,   582,   769,  1293,   772,
     770,  1264,  1254,   714,  1261,  1137,  1261,  1139,  1140,    61,
      61,  1314,  1364,   770,  1820,  1297,  1336,  1237,  1832,   154,
    1238,   204,   278,   302,   374,   485,   742,  1157,  1158,  1167,
    1205,  1206,  1207,  1234,  1445,  1825,  1176,    34,    61,   176,
     180,   334,   453,   652,  1161,  1163,  1198,  1199,  1206,  1832,
     676,   843,   926,   576,    33,    33,  1832,   204,  1351,  1352,
    1832,  1442,  1680,  1530,   777,   897,   991,  1590,  1595,  1595,
     446,    10,   446,   100,   391,   560,   703,  1079,  1080,  1832,
     770,   687,  1082,  1090,   702,   115,   374,   381,   396,   524,
     537,   557,   696,  1104,  1105,  1106,  1719,   836,   770,  1884,
    1263,   177,  1884,  1832,  1122,  1123,  1972,   842,  1174,  1979,
     568,  1832,    26,    26,   769,   769,  1148,  1607,  1084,  1832,
    1143,  1141,  1261,   769,  1138,   769,   769,   758,   759,   769,
    1171,  1172,  1173,  1414,  1460,  1800,  1825,  1058,   123,   770,
     772,   450,   581,   659,   180,  1239,   130,  1826,   693,  1206,
     732,   130,   176,  1664,  1214,  1173,   281,   327,    61,    11,
     379,  1199,  1204,  1439,   417,   844,   833,   576,   576,   770,
     772,  1687,  1688,  1818,  1775,  1832,  1581,   641,   187,   312,
     770,   772,  1607,   769,  1092,  1094,  1089,   407,  1665,  1665,
     407,  1665,  1665,  1665,  1665,   769,  1099,  1106,   419,   770,
    1884,   299,   374,   487,  1249,  1253,  1257,  1260,  1825,  1590,
     770,  1250,  1252,  1257,  1259,   772,  1820,   847,   925,  1832,
     777,  1551,  1553,   770,   770,   769,   769,  1142,  1262,   769,
    1262,  1262,  1802,  1802,  1170,   769,  1832,    63,   281,    61,
    1610,  1826,  1832,   173,   728,   641,  1171,  1200,  1198,  1439,
    1352,   772,  1664,  1211,  1078,  1080,   769,  1093,  1094,  1095,
     156,  1091,  1094,  1665,  1826,  1826,  1665,  1610,  1610,  1607,
    1834,   688,  1100,  1101,  1665,   284,   714,  1248,  1251,  1256,
    1257,  1258,   580,  1826,  1665,  1303,  1304,  1305,  1260,  1664,
    1303,  1259,  1832,    93,   411,   833,   777,  1832,   770,   770,
    1262,  1262,   769,   770,  1262,   770,   770,   770,  1084,    28,
     223,   237,   560,  1240,  1240,   769,  1436,   416,   677,  1162,
    1688,  1677,  1776,  1082,   770,   772,   156,  1097,  1098,  1442,
    1826,  1826,  1102,   770,   772,  1126,  1261,  1261,  1303,  1258,
    1825,  1606,  1305,  1304,    61,  1610,  1826,  1832,   770,  1433,
     848,  1832,   777,   770,   770,  1262,  1248,   770,  1249,  1250,
     770,    61,   176,   320,   180,   180,   770,  1607,  1159,  1160,
    1205,  1159,   586,   682,   735,  1164,   229,  1787,  1094,   772,
    1096,  1103,  1834,  1101,  1973,  1832,  1235,  1248,   770,  1248,
     281,    63,   770,  1205,  1165,  1166,  1167,   470,  1781,  1098,
     770,  1104,    75,  1248,  1240,  1240,  1167,    26,  1784,   641,
    1797,   114,  1788,  1974,   177,   769,  1790,   445,   593,  1968,
    1969,   143,   229,  1789,   770,   778,  1791,  1792,  1818,   237,
    1793,  1834,  1975,  1834,   770,   772,  1794,  1795,  1818,   926,
    1792,   772,  1664,   833,  1795,  1433,  1677,  1434
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   780,   781,   782,   781,   781,   783,   783,   784,   784,
     784,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     786,   787,   787,   789,   788,   790,   791,   792,   790,   793,
     794,   793,   795,   795,   797,   796,   799,   798,   800,   800,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     802,   802,   802,   803,   804,   804,   804,   805,   806,   806,
     806,   807,   808,   808,   808,   808,   808,   808,   808,   809,
     809,   810,   812,   813,   811,   814,   811,   815,   816,   811,
     817,   818,   811,   819,   820,   811,   821,   811,   822,   811,
     823,   811,   824,   811,   825,   811,   826,   811,   827,   811,
     828,   811,   811,   811,   811,   811,   811,   829,   811,   830,
     830,   831,   831,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   833,   833,   835,
     834,   836,   836,   837,   837,   837,   837,   837,   837,   837,
     839,   838,   841,   840,   840,   842,   842,   842,   842,   843,
     843,   844,   844,   845,   845,   846,   847,   847,   849,   848,
     850,   851,   851,   852,   852,   853,   853,   854,   854,   855,
     855,   855,   855,   855,   855,   855,   856,   856,   857,   857,
     859,   858,   860,   858,   861,   858,   862,   862,   863,   863,
     864,   864,   865,   866,   865,   867,   867,   868,   869,   869,
     869,   869,   869,   869,   870,   870,   871,   871,   872,   873,
     873,   873,   873,   875,   874,   876,   876,   877,   877,   878,
     878,   879,   880,   880,   880,   881,   882,   883,   883,   884,
     885,   886,   886,   886,   886,   887,   887,   887,   888,   887,
     890,   889,   891,   891,   892,   894,   893,   895,   895,   895,
     895,   896,   896,   897,   898,   898,   899,   900,   900,   901,
     901,   901,   901,   901,   901,   902,   902,   903,   904,   904,
     905,   905,   906,   906,   907,   907,   908,   908,   908,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     909,   910,   911,   912,   912,   913,   913,   914,   914,   915,
     916,   916,   917,   917,   917,   918,   919,   919,   920,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   922,   922,   923,   923,   924,   924,   925,   925,
     925,   925,   925,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   927,   927,   927,   927,   929,   928,   931,
     930,   932,   932,   934,   933,   933,   936,   935,   937,   937,
     937,   937,   938,   938,   938,   938,   939,   940,   941,   942,
     944,   943,   946,   945,   947,   947,   948,   948,   949,   950,
     950,   950,   951,   951,   952,   953,   953,   955,   956,   957,
     954,   958,   958,   958,   960,   959,   962,   963,   961,   961,
     964,   964,   965,   965,   967,   968,   966,   970,   971,   969,
     972,   972,   973,   974,   974,   975,   977,   976,   979,   978,
     981,   980,   982,   982,   984,   983,   985,   985,   985,   986,
     988,   987,   990,   989,   991,   993,   992,   994,   992,   995,
     996,   997,   992,   998,   992,  1000,   999,  1001,   999,  1002,
    1003,   999,  1004,   999,  1005,  1005,  1006,  1006,  1006,  1007,
    1008,  1009,  1010,  1010,  1011,  1011,  1012,  1013,  1014,  1014,
    1016,  1015,  1017,  1017,  1017,  1018,  1018,  1018,  1019,  1020,
    1020,  1020,  1021,  1021,  1021,  1021,  1021,  1021,  1021,  1021,
    1022,  1023,  1023,  1023,  1024,  1024,  1024,  1024,  1024,  1025,
    1026,  1026,  1026,  1027,  1027,  1027,  1027,  1027,  1027,  1027,
    1028,  1029,  1029,  1029,  1030,  1030,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1036,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1046,  1047,  1047,  1048,  1048,
    1050,  1049,  1049,  1049,  1051,  1051,  1052,  1052,  1053,  1053,
    1054,  1055,  1055,  1057,  1056,  1058,  1060,  1059,  1062,  1061,
    1063,  1064,  1063,  1063,  1063,  1065,  1063,  1063,  1066,  1063,
    1067,  1067,  1068,  1068,  1069,  1069,  1070,  1070,  1071,  1072,
    1073,  1074,  1075,  1075,  1076,  1077,  1076,  1078,  1076,  1079,
    1079,  1080,  1081,  1082,  1082,  1083,  1083,  1084,  1084,  1086,
    1085,  1087,  1088,  1089,  1088,  1090,  1088,  1088,  1088,  1088,
    1091,  1091,  1092,  1092,  1093,  1093,  1095,  1096,  1094,  1097,
    1097,  1098,  1098,  1099,  1099,  1100,  1100,  1102,  1101,  1103,
    1104,  1104,  1105,  1105,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1107,  1108,  1107,  1107,  1109,  1109,  1110,
    1110,  1111,  1111,  1112,  1112,  1113,  1113,  1114,  1114,  1115,
    1115,  1116,  1116,  1117,  1117,  1118,  1118,  1119,  1119,  1119,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1121,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1122,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1128,  1128,  1128,
    1128,  1128,  1128,  1129,  1129,  1129,  1130,  1130,  1130,  1130,
    1131,  1132,  1133,  1133,  1134,  1134,  1134,  1134,  1134,  1135,
    1135,  1137,  1136,  1138,  1136,  1139,  1136,  1140,  1136,  1141,
    1136,  1142,  1136,  1143,  1136,  1144,  1145,  1146,  1147,  1147,
    1148,  1149,  1149,  1150,  1150,  1151,  1153,  1152,  1155,  1154,
    1156,  1154,  1157,  1157,  1158,  1158,  1159,  1159,  1160,  1160,
    1161,  1161,  1161,  1161,  1162,  1161,  1161,  1161,  1163,  1163,
    1164,  1164,  1164,  1164,  1165,  1165,  1166,  1166,  1167,  1167,
    1167,  1167,  1169,  1168,  1170,  1170,  1171,  1171,  1172,  1172,
    1173,  1173,  1174,  1175,  1175,  1176,  1176,  1176,  1176,  1176,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1178,  1178,  1178,  1178,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1180,  1180,  1180,  1180,  1180,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1182,  1182,  1183,  1183,  1183,  1183,  1183,
    1183,  1183,  1183,  1184,  1185,  1185,  1186,  1186,  1187,  1187,
    1187,  1187,  1187,  1188,  1188,  1188,  1188,  1188,  1189,  1189,
    1189,  1190,  1190,  1191,  1191,  1191,  1192,  1193,  1193,  1193,
    1193,  1193,  1193,  1194,  1194,  1194,  1194,  1195,  1195,  1196,
    1196,  1197,  1197,  1198,  1198,  1199,  1199,  1199,  1199,  1199,
    1199,  1199,  1200,  1200,  1201,  1201,  1202,  1203,  1204,  1205,
    1205,  1205,  1206,  1206,  1206,  1206,  1206,  1206,  1207,  1207,
    1208,  1208,  1209,  1209,  1210,  1210,  1211,  1211,  1212,  1212,
    1213,  1213,  1214,  1215,  1215,  1216,  1216,  1217,  1217,  1218,
    1218,  1218,  1219,  1220,  1220,  1221,  1221,  1221,  1221,  1221,
    1221,  1222,  1222,  1224,  1223,  1225,  1225,  1226,  1227,  1227,
    1227,  1227,  1228,  1229,  1230,  1230,  1231,  1232,  1232,  1233,
    1233,  1234,  1234,  1235,  1236,  1236,  1237,  1237,  1238,  1238,
    1238,  1238,  1239,  1239,  1239,  1239,  1239,  1240,  1240,  1240,
    1240,  1240,  1241,  1241,  1242,  1242,  1243,  1243,  1244,  1244,
    1244,  1245,  1245,  1246,  1247,  1248,  1248,  1249,  1249,  1250,
    1250,  1251,  1251,  1252,  1252,  1253,  1253,  1254,  1254,  1255,
    1255,  1255,  1256,  1256,  1257,  1257,  1257,  1257,  1257,  1257,
    1258,  1258,  1259,  1260,  1260,  1261,  1261,  1261,  1262,  1262,
    1263,  1263,  1264,  1264,  1265,  1265,  1267,  1268,  1266,  1269,
    1266,  1266,  1270,  1266,  1271,  1266,  1272,  1266,  1273,  1266,
    1274,  1266,  1266,  1266,  1266,  1266,  1275,  1266,  1266,  1276,
    1277,  1266,  1278,  1278,  1279,  1279,  1279,  1279,  1280,  1280,
    1280,  1280,  1280,  1281,  1281,  1281,  1281,  1282,  1282,  1283,
    1283,  1284,  1284,  1285,  1285,  1285,  1285,  1285,  1285,  1285,
    1285,  1285,  1285,  1286,  1285,  1285,  1287,  1285,  1288,  1285,
    1285,  1285,  1285,  1285,  1289,  1290,  1290,  1292,  1291,  1293,
    1293,  1293,  1295,  1294,  1296,  1297,  1296,  1298,  1298,  1299,
    1300,  1300,  1301,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1303,  1303,  1303,  1303,  1303,  1304,  1304,  1305,
    1305,  1306,  1306,  1307,  1307,  1309,  1308,  1310,  1310,  1311,
    1311,  1312,  1312,  1313,  1313,  1313,  1314,  1314,  1314,  1315,
    1315,  1315,  1315,  1317,  1316,  1318,  1316,  1316,  1316,  1319,
    1320,  1320,  1321,  1321,  1322,  1322,  1322,  1324,  1323,  1325,
    1325,  1326,  1326,  1326,  1327,  1327,  1327,  1328,  1328,  1330,
    1329,  1331,  1331,  1331,  1332,  1333,  1332,  1335,  1334,  1336,
    1336,  1337,  1337,  1338,  1338,  1338,  1339,  1339,  1341,  1340,
    1342,  1342,  1343,  1344,  1344,  1345,  1345,  1346,  1347,  1346,
    1348,  1349,  1348,  1350,  1350,  1350,  1351,  1351,  1351,  1352,
    1352,  1353,  1353,  1354,  1355,  1354,  1357,  1356,  1358,  1358,
    1359,  1359,  1360,  1360,  1360,  1360,  1360,  1360,  1361,  1361,
    1363,  1362,  1364,  1364,  1364,  1366,  1365,  1365,  1367,  1367,
    1368,  1368,  1369,  1371,  1370,  1372,  1372,  1373,  1373,  1374,
    1375,  1376,  1376,  1378,  1377,  1379,  1379,  1380,  1380,  1381,
    1382,  1384,  1383,  1386,  1385,  1387,  1387,  1388,  1388,  1390,
    1389,  1391,  1389,  1393,  1392,  1394,  1392,  1395,  1395,  1397,
    1396,  1399,  1400,  1398,  1401,  1402,  1403,  1403,  1404,  1404,
    1406,  1405,  1407,  1405,  1408,  1408,  1409,  1410,  1409,  1409,
    1411,  1411,  1412,  1413,  1414,  1414,  1415,  1415,  1416,  1417,
    1417,  1418,  1418,  1419,  1419,  1419,  1420,  1420,  1420,  1421,
    1422,  1422,  1423,  1423,  1424,  1424,  1424,  1424,  1425,  1425,
    1426,  1426,  1426,  1427,  1427,  1428,  1428,  1429,  1429,  1429,
    1430,  1430,  1430,  1431,  1431,  1432,  1433,  1434,  1435,  1435,
    1435,  1435,  1435,  1436,  1436,  1436,  1437,  1437,  1437,  1438,
    1438,  1439,  1439,  1439,  1439,  1439,  1440,  1440,  1440,  1440,
    1440,  1440,  1440,  1440,  1440,  1440,  1440,  1440,  1441,  1441,
    1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,
    1441,  1441,  1441,  1441,  1442,  1442,  1442,  1442,  1442,  1442,
    1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,
    1442,  1442,  1442,  1443,  1443,  1444,  1444,  1445,  1445,  1446,
    1446,  1447,  1447,  1447,  1447,  1447,  1447,  1448,  1448,  1449,
    1449,  1450,  1450,  1450,  1451,  1451,  1451,  1451,  1451,  1451,
    1452,  1452,  1452,  1454,  1453,  1453,  1455,  1456,  1456,  1457,
    1457,  1457,  1457,  1458,  1459,  1459,  1459,  1459,  1459,  1459,
    1459,  1459,  1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,
    1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,
    1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,  1460,
    1460,  1461,  1461,  1461,  1461,  1462,  1462,  1463,  1463,  1463,
    1463,  1463,  1463,  1464,  1464,  1465,  1465,  1466,  1466,  1466,
    1466,  1466,  1466,  1466,  1466,  1466,  1466,  1466,  1466,  1466,
    1466,  1466,  1466,  1466,  1466,  1466,  1466,  1466,  1467,  1467,
    1467,  1467,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1469,
    1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,
    1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,  1469,
    1469,  1469,  1469,  1469,  1469,  1469,  1470,  1470,  1470,  1470,
    1470,  1470,  1470,  1470,  1470,  1472,  1471,  1471,  1471,  1473,
    1473,  1474,  1474,  1475,  1475,  1476,  1476,  1477,  1477,  1478,
    1479,  1479,  1479,  1479,  1479,  1479,  1479,  1480,  1481,  1479,
    1479,  1479,  1479,  1479,  1479,  1479,  1479,  1479,  1479,  1479,
    1482,  1479,  1483,  1483,  1484,  1484,  1484,  1485,  1485,  1485,
    1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,  1485,
    1486,  1488,  1487,  1487,  1489,  1489,  1490,  1491,  1493,  1492,
    1494,  1494,  1494,  1494,  1495,  1495,  1496,  1496,  1497,  1497,
    1498,  1498,  1499,  1499,  1500,  1501,  1502,  1502,  1502,  1504,
    1503,  1505,  1506,  1505,  1507,  1505,  1508,  1505,  1505,  1505,
    1505,  1509,  1509,  1509,  1509,  1509,  1509,  1509,  1509,  1510,
    1510,  1510,  1510,  1511,  1511,  1512,  1512,  1513,  1513,  1514,
    1514,  1515,  1515,  1516,  1516,  1517,  1517,  1518,  1519,  1519,
    1520,  1520,  1521,  1522,  1521,  1523,  1521,  1521,  1524,  1521,
    1525,  1521,  1521,  1526,  1521,  1527,  1521,  1521,  1528,  1528,
    1528,  1529,  1529,  1530,  1530,  1531,  1532,  1532,  1532,  1532,
    1533,  1533,  1534,  1534,  1535,  1535,  1536,  1536,  1537,  1537,
    1538,  1539,  1540,  1540,  1541,  1541,  1541,  1541,  1542,  1542,
    1544,  1543,  1545,  1543,  1546,  1546,  1547,  1548,  1547,  1550,
    1549,  1551,  1551,  1552,  1552,  1553,  1553,  1554,  1554,  1555,
    1555,  1555,  1555,  1555,  1555,  1555,  1555,  1555,  1555,  1555,
    1555,  1556,  1556,  1556,  1556,  1556,  1556,  1556,  1556,  1556,
    1557,  1557,  1557,  1557,  1558,  1558,  1558,  1559,  1559,  1560,
    1561,  1561,  1562,  1563,  1562,  1564,  1565,  1564,  1566,  1566,
    1567,  1567,  1568,  1568,  1568,  1569,  1569,  1570,  1570,  1571,
    1573,  1572,  1574,  1574,  1575,  1575,  1576,  1576,  1577,  1577,
    1578,  1578,  1579,  1579,  1580,  1580,  1580,  1581,  1581,  1581,
    1582,  1582,  1582,  1582,  1582,  1582,  1583,  1584,  1584,  1585,
    1586,  1586,  1588,  1587,  1589,  1589,  1590,  1590,  1590,  1591,
    1591,  1592,  1592,  1592,  1593,  1594,  1594,  1594,  1595,  1595,
    1595,  1595,  1595,  1595,  1596,  1597,  1597,  1597,  1597,  1598,
    1598,  1598,  1599,  1599,  1600,  1601,  1602,  1602,  1602,  1603,
    1603,  1604,  1604,  1605,  1605,  1606,  1606,  1606,  1606,  1606,
    1606,  1607,  1607,  1607,  1607,  1607,  1608,  1608,  1608,  1608,
    1609,  1609,  1609,  1609,  1609,  1610,  1610,  1610,  1610,  1610,
    1611,  1612,  1612,  1613,  1613,  1614,  1614,  1614,  1616,  1615,
    1617,  1617,  1618,  1618,  1619,  1621,  1620,  1622,  1622,  1623,
    1624,  1624,  1624,  1625,  1627,  1628,  1626,  1626,  1626,  1630,
    1629,  1632,  1631,  1633,  1631,  1631,  1631,  1631,  1631,  1631,
    1631,  1634,  1631,  1631,  1631,  1631,  1631,  1631,  1635,  1631,
    1636,  1636,  1637,  1638,  1639,  1639,  1640,  1641,  1641,  1642,
    1642,  1643,  1643,  1645,  1646,  1644,  1648,  1649,  1647,  1650,
    1650,  1650,  1650,  1651,  1651,  1652,  1652,  1654,  1653,  1655,
    1655,  1656,  1655,  1657,  1658,  1658,  1659,  1659,  1660,  1661,
    1661,  1662,  1662,  1663,  1664,  1664,  1665,  1665,  1666,  1666,
    1667,  1667,  1669,  1668,  1671,  1670,  1672,  1672,  1673,  1673,
    1674,  1674,  1675,  1675,  1676,  1676,  1677,  1677,  1678,  1679,
    1680,  1678,  1681,  1681,  1683,  1684,  1682,  1685,  1685,  1686,
    1686,  1687,  1687,  1688,  1689,  1689,  1691,  1690,  1692,  1692,
    1693,  1693,  1694,  1695,  1696,  1697,  1696,  1698,  1696,  1699,
    1699,  1700,  1700,  1701,  1701,  1702,  1702,  1703,  1703,  1704,
    1704,  1704,  1706,  1705,  1707,  1707,  1708,  1708,  1709,  1709,
    1710,  1710,  1710,  1710,  1710,  1710,  1710,  1710,  1710,  1711,
    1711,  1713,  1712,  1714,  1714,  1714,  1714,  1714,  1714,  1714,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1715,  1714,  1716,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,
    1714,  1714,  1714,  1714,  1717,  1717,  1717,  1718,  1718,  1719,
    1719,  1720,  1720,  1721,  1721,  1722,  1722,  1723,  1723,  1724,
    1724,  1725,  1725,  1725,  1727,  1726,  1728,  1726,  1729,  1729,
    1729,  1729,  1729,  1729,  1730,  1730,  1731,  1732,  1732,  1732,
    1732,  1733,  1733,  1734,  1734,  1734,  1736,  1735,  1738,  1737,
    1737,  1739,  1739,  1740,  1741,  1740,  1742,  1742,  1743,  1743,
    1743,  1743,  1743,  1743,  1743,  1743,  1743,  1743,  1743,  1743,
    1743,  1743,  1743,  1743,  1743,  1744,  1744,  1745,  1746,  1747,
    1746,  1746,  1748,  1748,  1749,  1749,  1749,  1750,  1751,  1751,
    1753,  1752,  1754,  1754,  1756,  1755,  1757,  1755,  1755,  1758,
    1758,  1759,  1759,  1760,  1761,  1760,  1763,  1762,  1764,  1764,
    1764,  1765,  1765,  1765,  1766,  1766,  1767,  1767,  1769,  1768,
    1770,  1770,  1771,  1773,  1774,  1775,  1776,  1772,  1777,  1777,
    1778,  1778,  1779,  1779,  1779,  1780,  1780,  1780,  1781,  1781,
    1782,  1782,  1783,  1783,  1783,  1783,  1784,  1784,  1785,  1785,
    1786,  1786,  1787,  1787,  1788,  1788,  1789,  1789,  1790,  1790,
    1790,  1791,  1791,  1792,  1792,  1793,  1793,  1794,  1794,  1795,
    1796,  1796,  1796,  1796,  1797,  1797,  1798,  1798,  1798,  1799,
    1799,  1799,  1800,  1800,  1801,  1801,  1801,  1801,  1801,  1801,
    1801,  1801,  1801,  1801,  1802,  1802,  1802,  1802,  1802,  1803,
    1803,  1803,  1805,  1804,  1806,  1806,  1807,  1807,  1809,  1808,
    1810,  1810,  1811,  1811,  1812,  1813,  1813,  1814,  1814,  1815,
    1815,  1816,  1817,  1817,  1817,  1817,  1817,  1818,  1818,  1818,
    1818,  1818,  1819,  1819,  1819,  1819,  1820,  1820,  1820,  1821,
    1821,  1822,  1823,  1823,  1824,  1824,  1824,  1825,  1826,  1827,
    1828,  1829,  1829,  1830,  1830,  1831,  1831,  1831,  1832,  1832,
    1833,  1833,  1834,  1834,  1834,  1835,  1835,  1835,  1836,  1836,
    1837,  1838,  1838,  1838,  1838,  1838,  1838,  1838,  1838,  1839,
    1839,  1839,  1839,  1839,  1839,  1839,  1839,  1839,  1840,  1840,
    1840,  1840,  1841,  1841,  1841,  1841,  1841,  1841,  1841,  1841,
    1842,  1842,  1842,  1842,  1842,  1842,  1842,  1842,  1842,  1843,
    1843,  1843,  1843,  1843,  1843,  1843,  1843,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,  1844,
    1844,  1844,  1845,  1845,  1845,  1845,  1845,  1845,  1846,  1846,
    1846,  1846,  1846,  1846,  1846,  1846,  1846,  1846,  1847,  1847,
    1847,  1848,  1848,  1848,  1849,  1849,  1849,  1850,  1850,  1850,
    1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,
    1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,
    1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,  1850,
    1850,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1853,  1852,  1854,  1855,
    1852,  1856,  1856,  1858,  1857,  1859,  1857,  1860,  1857,  1862,
    1861,  1861,  1863,  1863,  1865,  1864,  1866,  1864,  1868,  1867,
    1867,  1869,  1869,  1869,  1870,  1870,  1870,  1870,  1871,  1871,
    1871,  1871,  1872,  1872,  1872,  1873,  1873,  1873,  1873,  1873,
    1873,  1873,  1873,  1873,  1873,  1873,  1873,  1873,  1873,  1873,
    1874,  1874,  1874,  1874,  1875,  1876,  1877,  1877,  1878,  1878,
    1878,  1878,  1879,  1879,  1880,  1880,  1880,  1881,  1881,  1881,
    1881,  1881,  1883,  1882,  1884,  1884,  1884,  1885,  1885,  1886,
    1886,  1887,  1888,  1888,  1888,  1888,  1888,  1890,  1889,  1892,
    1891,  1893,  1893,  1894,  1893,  1895,  1895,  1896,  1896,  1897,
    1897,  1897,  1897,  1898,  1897,  1899,  1899,  1899,  1899,  1899,
    1900,  1901,  1901,  1901,  1901,  1901,  1901,  1901,  1901,  1902,
    1902,  1903,  1904,  1904,  1904,  1904,  1904,  1904,  1904,  1905,
    1905,  1906,  1906,  1907,  1907,  1908,  1909,  1909,  1910,  1910,
    1911,  1911,  1912,  1912,  1913,  1913,  1915,  1914,  1916,  1914,
    1917,  1914,  1918,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1919,  1919,  1920,  1920,  1921,  1921,  1921,  1922,  1922,
    1922,  1922,  1923,  1923,  1924,  1924,  1925,  1925,  1926,  1926,
    1927,  1927,  1928,  1928,  1928,  1928,  1929,  1929,  1930,  1931,
    1931,  1931,  1932,  1932,  1933,  1933,  1934,  1935,  1935,  1935,
    1935,  1935,  1936,  1936,  1936,  1936,  1936,  1937,  1937,  1938,
    1938,  1939,  1939,  1940,  1940,  1941,  1941,  1942,  1942,  1944,
    1943,  1945,  1946,  1946,  1947,  1947,  1948,  1948,  1948,  1949,
    1949,  1949,  1950,  1951,  1951,  1951,  1952,  1953,  1954,  1954,
    1954,  1955,  1955,  1955,  1956,  1956,  1956,  1956,  1956,  1956,
    1956,  1956,  1957,  1957,  1958,  1959,  1960,  1960,  1960,  1961,
    1961,  1962,  1962,  1963,  1963,  1964,  1964,  1966,  1965,  1967,
    1967,  1967,  1967,  1968,  1968,  1969,  1969,  1971,  1972,  1973,
    1974,  1975,  1970,  1977,  1976,  1979,  1978,  1981,  1982,  1980,
    1983,  1983,  1983,  1983,  1983,  1983,  1984,  1984,  1985,  1985,
    1985,  1986,  1986,  1986,  1987,  1987,  1987,  1988,  1988,  1989,
    1990,  1989,  1991,  1991,  1992,  1992,  1993,  1993,  1994
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     0,     5,     3,     0,     0,     6,     0,
       0,     3,     1,     3,     0,     3,     0,     6,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     1,
       0,     1,     3,     1,     0,     1,     3,     1,     0,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     1,     0,     0,     8,     0,     8,     0,     0,    16,
       0,     0,    15,     0,     0,    15,     0,     6,     0,    10,
       0,    11,     0,     5,     0,     6,     0,     5,     0,    12,
       0,    12,    10,     8,     6,     4,     3,     0,     3,     0,
       1,     1,     2,     3,     2,     1,     3,     2,     1,     3,
       3,     3,     1,     1,     1,     1,     3,     0,     1,     0,
      12,     1,     3,     2,     2,     2,     2,     2,     2,     2,
       0,    12,     0,     6,     2,     0,     1,     3,     1,     0,
       2,     0,     2,     0,     1,     4,     0,     2,     0,     3,
       0,     0,     1,     3,     1,     0,     2,     0,     2,     2,
       2,     2,     2,     3,     3,     1,     1,     2,     3,     3,
       0,     4,     0,     6,     0,     8,     0,     3,     0,     1,
       3,     1,     0,     0,     2,     3,     1,     1,     2,     6,
       8,     5,     7,     3,     0,     1,     3,     1,     2,     0,
       1,     1,     1,     0,     4,     0,     3,     2,     3,     0,
       3,     2,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     6,     4,     1,     4,     1,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     0,
       2,     1,     1,     0,     3,     1,     0,     2,     1,     2,
       3,     4,     1,     2,     3,     4,     2,     2,     2,     0,
       0,     3,     0,     3,     1,     3,     0,     3,     3,     3,
       4,     5,     2,     4,     2,     1,     3,     0,     0,     0,
       7,     0,     2,     2,     0,     6,     0,     0,     4,     1,
       1,     2,     1,     2,     0,     0,     6,     0,     0,     6,
       0,     2,     2,     0,     1,     1,     0,     7,     0,     5,
       0,     7,     0,     1,     0,     3,     5,     3,     5,     3,
       0,     6,     0,     6,     1,     0,     5,     0,     5,     0,
       0,     0,    11,     0,     5,     0,     3,     0,     3,     0,
       0,     8,     0,     3,     1,     1,     1,     1,     1,     2,
       4,     5,     0,     4,     4,     4,     3,     3,     2,     2,
       0,     2,     1,     2,     3,     1,     1,     1,     1,     1,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       0,     5,     3,     1,     2,     4,     0,     4,     1,     4,
       1,     0,     1,     0,     4,     0,     0,     3,     0,     6,
       6,     0,     4,     2,     2,     0,     3,     2,     0,     3,
       0,     1,     0,     3,     0,     1,     1,     3,     1,     4,
       3,     3,     0,     2,     0,     0,     7,     0,    10,     1,
       3,     1,     1,     0,     2,     0,     3,     1,     3,     0,
       6,     1,     0,     0,     4,     0,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     0,     0,     5,     1,
       3,     1,     1,     0,     3,     1,     3,     0,     4,     1,
       0,     1,     2,     1,     3,     4,     3,     3,     3,     3,
       4,     4,     3,     0,     0,     5,     2,     0,     2,     0,
       1,     0,     1,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     3,     0,     1,     1,     2,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       0,     6,     1,     1,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     0,
       1,     2,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     2,     1,
       2,     0,     9,     0,    10,     0,     9,     0,     9,     0,
      10,     0,    11,     0,    10,     2,     7,     7,     0,     1,
       4,     0,     1,     0,     1,     2,     0,     4,     0,     3,
       0,     3,     0,     1,     2,     1,     0,     1,     2,     1,
       0,     1,     2,     3,     0,     6,     5,     5,     0,     2,
       0,     1,     1,     1,     0,     1,     2,     1,     1,     2,
       2,     1,     0,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     3,     3,     2,     1,     1,     3,     3,     3,     3,
       0,     1,     2,     2,     3,     3,     2,     3,     3,     4,
       3,     3,     3,     1,     2,     2,     2,     2,     3,     3,
       2,     3,     2,     2,     3,     3,     2,     3,     2,     2,
       2,     2,     2,     5,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     0,     3,     0,     1,     1,     5,     0,     1,     1,
       1,     2,     2,     3,     3,     3,     3,     0,     1,     0,
       1,     0,     1,     2,     1,     1,     2,     4,     1,     3,
       2,     1,     0,     2,     0,     1,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     3,     3,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     0,     1,     2,
       1,     1,     2,     0,     1,     1,     2,     1,     2,     2,
       1,     0,     1,     0,     4,     1,     1,     1,     0,     1,
       2,     1,     1,     2,     1,     3,     3,     1,     1,     0,
       2,     0,     1,     5,     0,     3,     3,     1,     0,     2,
       2,     2,     0,     3,     3,     6,     6,     1,     1,     2,
       2,     2,     2,     2,     1,     1,     0,     1,     1,     1,
       1,     0,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     1,     2,     1,     2,     1,     2,     0,     2,     0,
       2,     2,     2,     2,     3,     2,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     1,     1,     1,     4,     2,
       1,     4,     0,     1,     1,     3,     0,     0,     8,     0,
       5,     7,     0,     5,     0,     5,     0,    10,     0,     9,
       0,    11,     3,     4,     3,     3,     0,     8,     8,     0,
       0,     7,     1,     1,     0,     1,     1,     3,     0,     2,
       3,     5,     5,     0,     3,     1,     4,     0,     3,     0,
       2,     0,     1,     0,     2,     2,     2,     2,     1,     1,
       1,     4,     4,     0,     6,     4,     0,     5,     0,     6,
       4,     3,     1,     7,     2,     1,     1,     0,     6,     0,
       3,     2,     0,     5,     0,     0,     6,     1,     3,     1,
       1,     3,     3,     3,     2,     2,     4,     4,     2,     7,
       6,     5,     5,     4,     5,     4,     4,     2,     2,     7,
       6,     3,     5,     1,     1,     1,     1,     1,     3,     3,
       3,     5,     0,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     2,     0,     1,     2,
       1,     1,     1,     0,     1,     1,     0,     2,     1,     0,
       1,     1,     1,     0,     6,     0,     5,     4,     4,     3,
       0,     1,     1,     3,     3,     2,     2,     0,     2,     1,
       3,     0,     1,     1,     0,     2,     4,     1,     3,     0,
       5,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     2,     1,     1,     1,     0,     2,     0,     5,
       1,     3,     2,     0,     3,     1,     4,     1,     0,     4,
       1,     0,     4,     0,     1,     3,     0,     1,     3,     1,
       1,     2,     6,     3,     0,     4,     0,     3,     0,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       0,     6,     0,     1,     1,     0,     4,     4,     3,     5,
       1,     3,     4,     0,     6,     1,     1,     1,     3,     2,
       3,     1,     1,     0,     6,     1,     1,     1,     3,     3,
       4,     0,     6,     0,     2,     0,     4,     0,     2,     0,
       3,     0,     4,     0,     3,     0,     4,     1,     1,     0,
       3,     0,     0,     5,     6,     7,     1,     2,     1,     1,
       0,     3,     0,     3,     3,     3,     1,     0,     4,     3,
       1,     1,     1,     1,     1,     4,     0,     1,     2,     1,
       1,     0,     1,     0,     1,     1,     2,     1,     2,     9,
       0,     1,     0,     2,     3,     1,     4,     4,     2,     1,
       1,     1,     1,     3,     5,     0,     1,     0,     2,     1,
       3,     1,     1,     3,     4,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     4,     4,     4,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     7,     6,     3,     4,
       6,     6,     4,     4,     4,     4,     4,     4,     6,     8,
      10,     1,     1,     3,     1,     1,     3,     1,     2,     2,
       2,     2,     2,     1,     3,     4,     6,     4,     6,     2,
       2,     4,     4,     4,    10,     6,     8,     6,     4,     4,
       6,     4,     3,     4,     1,     4,     3,     4,     5,     3,
       5,     3,     6,     8,     2,     2,     8,     8,     6,     8,
       6,     6,     2,     6,     6,     8,     4,     2,     8,     8,
       4,     2,     2,     2,     6,     6,     4,     4,     8,     4,
       4,     4,     4,     3,     8,     6,     8,     4,     6,     4,
       6,     4,     4,     4,     6,     8,     4,     3,     6,     4,
       6,     5,     8,     7,    10,     1,     6,     4,     4,     4,
       4,     4,     6,     4,     6,     0,     5,     6,     8,     2,
       3,     0,     4,     0,     3,     0,     1,     1,     3,     4,
       4,     5,     4,     4,     4,     5,     4,     0,     0,     7,
       4,     5,     4,     5,     4,     4,     4,     4,     4,     5,
       0,     9,     3,     3,     1,     1,     1,     3,     3,     3,
       3,     3,     4,     4,     4,     6,     4,     6,     4,     6,
       5,     0,     7,     4,     4,     4,     4,     1,     0,     3,
       3,     1,     3,     5,     0,     1,     0,     2,     0,     3,
       4,     2,     0,     1,     1,     2,     1,     3,     3,     0,
       3,     2,     0,     4,     0,     4,     0,     4,     2,     1,
       1,     1,     1,     2,     1,     2,     2,     1,     2,     1,
       2,     2,     3,     0,     1,     1,     3,     1,     3,     1,
       3,     4,     5,     1,     3,     1,     1,     1,     1,     4,
       1,     3,     3,     0,     6,     0,     8,     4,     0,     8,
       0,    10,     6,     0,     8,     0,    10,     6,     1,     2,
       1,     1,     2,     0,     1,     5,     1,     1,     1,     1,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       5,     3,     0,     1,     0,     2,     3,     3,     1,     1,
       0,     7,     0,     7,     1,     2,     0,     0,     2,     0,
       2,     0,     1,     1,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     0,     1,     2,
       0,     1,     0,     0,     3,     0,     0,     3,     0,     4,
       4,     2,     0,     1,     1,     0,     2,     3,     1,     3,
       0,     7,     0,     1,     0,     3,     0,     3,     0,     3,
       1,     1,     1,     4,     2,     2,     2,     1,     2,     2,
       0,     3,     2,     2,     3,     3,     3,     3,     1,     2,
       0,     1,     0,     4,     4,     2,     0,     1,     1,     0,
       1,     2,     5,     4,     1,     1,     3,     3,     1,     3,
       1,     1,     1,     1,     1,     0,     2,     3,     4,     1,
       2,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       1,     0,     1,     2,     2,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     6,
       0,     1,     3,     1,     3,     0,     2,     3,     1,     1,
       2,     1,     3,     2,     0,     0,     7,     2,     1,     0,
       3,     0,     8,     0,     8,     4,     6,     4,     4,     5,
       5,     0,     6,     4,     4,     5,     6,     4,     0,     6,
       1,     3,     1,     2,     1,     3,     1,     0,     2,     0,
       2,     0,     1,     0,     0,     8,     0,     0,     6,     0,
       1,     1,     1,     1,     1,     2,     1,     0,     2,     1,
       2,     0,     3,     3,     0,     1,     3,     1,     1,     3,
       1,     3,     1,     3,     1,     1,     0,     1,     1,     1,
       1,     1,     0,     4,     0,     4,     0,     1,     0,     1,
       3,     1,     5,     3,     1,     1,     1,     1,     0,     0,
       0,     7,     5,     1,     0,     0,    11,     3,     1,     3,
       3,     3,     1,     3,     0,     1,     0,     3,     0,     3,
       2,     3,     3,     2,     5,     0,     5,     0,     6,     0,
       2,     1,     3,     2,     4,     0,     2,     0,     2,     1,
       1,     1,     0,     5,     0,     1,     0,     1,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     0,
       3,     0,     3,     2,     4,     4,     3,     4,     4,     1,
       3,     3,     3,     3,     6,     2,     2,     0,     6,     0,
       7,     5,     2,     1,     1,     1,     5,     5,     2,     2,
       1,     4,     3,     2,     3,     2,     2,     1,     4,     4,
       3,     3,     3,     2,     3,     2,     3,     3,     3,     3,
       4,     3,     2,     3,     3,     3,     3,     4,     3,     3,
       4,     3,     3,     3,     1,     1,     1,     1,     1,     0,
       1,     0,     2,     0,     1,     1,     1,     0,     2,     0,
       2,     0,     3,     3,     0,     4,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     1,
       1,     0,     3,     0,     1,     1,     0,     4,     0,     4,
       1,     0,     1,     4,     0,     3,     3,     1,     2,     2,
       2,     2,     3,     3,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     0,     1,     2,     2,     0,
       3,     1,     0,     5,     0,     1,     3,     1,     0,     3,
       0,     3,     3,     1,     0,     4,     0,     3,     2,     0,
       1,     0,     2,     5,     0,     6,     0,     4,     0,     1,
       1,     2,     2,     3,     0,     1,     1,     2,     0,     3,
       0,     4,     2,     0,     0,     0,     0,    22,     1,     1,
       0,     1,     0,     1,     1,     0,     1,     1,     0,     2,
       2,     1,     3,     4,     3,     3,     0,     2,     2,     1,
       3,     3,     0,     4,     0,     3,     1,     1,     0,     3,
       2,     3,     1,     1,     2,     0,     2,     3,     1,     5,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       2,     2,     0,     4,     0,     1,     1,     3,     0,     7,
       0,     3,     1,     3,     1,     1,     1,     3,     5,     3,
       5,     1,     1,     3,     4,     5,     4,     1,     3,     4,
       4,     5,     1,     5,     3,     2,     1,     3,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     3,     0,     0,
       7,     1,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     2,     0,     2,     0,     2,     0,     4,     0,     3,
       1,     1,     1,     1,     0,     1,     1,     1,     0,     2,
       2,     2,     3,     5,     5,     3,     5,     5,     4,     6,
       8,     8,     2,     3,     3,     3,     5,     2,     3,     3,
       1,     1,     3,     3,     1,     3,     2,     2,     2,     2,
       2,     1,     1,     3,     1,     4,     4,     1,     1,     1,
       1,     1,     0,     5,     0,     2,     1,     1,     1,     1,
       3,     3,     1,     1,     2,     2,     2,     0,     3,     0,
       3,     3,     2,     0,     6,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     5,     1,     1,     1,     1,     1,
       3,     6,     6,     6,     6,     7,     7,     5,     3,     4,
       1,     3,     8,     8,     8,     8,     9,     6,     4,     0,
       3,     0,     3,     1,     3,     2,     1,     1,     0,     1,
       1,     2,     0,     1,     1,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       2,     0,     1,     3,     1,     2,     2,     2,     1,     3,
       3,     1,     1,     3,     1,     3,     1,     3,     1,     1,
       1,     1,     4,     5,     4,     1,     3,     1,     2,     0,
       2,     5,     0,     3,     3,     1,     1,     0,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     0,
       2,     0,     2,     0,     3,     2,     1,     2,     1,     0,
       3,     1,     0,     1,     0,     1,     0,     3,     2,     0,
       1,     2,     4,     4,     5,     4,     2,     3,     2,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     3,     3,     3,     0,
       1,     3,     3,     0,     3,     1,     3,     0,     3,     0,
       3,     4,     4,     1,     1,     0,     2,     0,     0,     0,
       0,     0,    20,     0,     3,     0,     4,     0,     0,     7,
       4,     4,     3,     4,     3,     3,     0,     3,     1,     3,
       5,     1,     1,     1,     0,     1,     1,     0,     2,     0,
       0,     3,     0,     2,     6,     3,     4,     4,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 2255 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 27516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3: /* $@1: %empty  */
#line 2264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 27543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 2289 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 27552 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 70: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 2371 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 27560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 73: /* $@2: %empty  */
#line 2383 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 27566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 74: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 2385 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 27576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 75: /* execute: EXECUTE_SYM ident execute_using  */
#line 2394 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 76: /* $@3: %empty  */
#line 2399 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 27591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 77: /* $@4: %empty  */
#line 2401 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 27597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 78: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 2403 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 79: /* execute_using: %empty  */
#line 2410 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item_list)= NULL; }
#line 27612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 80: /* $@5: %empty  */
#line 2412 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 27618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 81: /* execute_using: USING $@5 execute_params  */
#line 2414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 27627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 82: /* execute_params: expr_or_ignore_or_default  */
#line 2422 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 27636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 83: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 2427 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 27645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 84: /* $@6: %empty  */
#line 2438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 27654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 85: /* help: HELP_SYM $@6 ident_or_text  */
#line 2443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 27664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 86: /* $@7: %empty  */
#line 2454 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 27672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 87: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 2458 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 27678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 90: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 2468 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 27686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 91: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 2472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 27694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 92: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 2476 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 27702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 93: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 2480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 27710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 94: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 2484 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 27718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 95: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 2488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 27732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 96: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2498 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 97: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2503 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 27749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2507 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 27757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 27765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2515 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 27773 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 101: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2519 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 27781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 102: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 103: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 27798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2532 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 27806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 105: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2537 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 106: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2565 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 27846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 107: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 108: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 113: /* ignore_server_id: ulong_num  */
#line 2588 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 117: /* do_domain_id: ulong_num  */
#line 2601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 121: /* ignore_domain_id: ulong_num  */
#line 2614 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 122: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2621 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 27894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2625 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 27913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 124: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2640 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 27921 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2644 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 27931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 126: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 27941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2656 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 27951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2662 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 27961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 129: /* optional_connection_name: %empty  */
#line 2671 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 27970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 131: /* connection_name: TEXT_STRING_sys  */
#line 2680 "/home/buildbot/git/sql/sql_yacc.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 27982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 132: /* $@8: %empty  */
#line 2693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 27998 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 133: /* $@9: %empty  */
#line 2705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                    TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
            lex->inc_select_stack_outer_barrier();
          }
#line 28020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 134: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2723 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 28030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 135: /* $@10: %empty  */
#line 2729 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                   TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 28064 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 136: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2759 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 28093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 137: /* $@11: %empty  */
#line 2784 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 138: /* $@12: %empty  */
#line 2791 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 139: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2799 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 140: /* $@13: %empty  */
#line 2803 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 141: /* $@14: %empty  */
#line 2809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 142: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2817 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 143: /* $@15: %empty  */
#line 2821 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 144: /* $@16: %empty  */
#line 2827 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 145: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2835 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 146: /* $@17: %empty  */
#line 2839 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 28186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 147: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2844 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 28198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 148: /* $@18: %empty  */
#line 2853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 28211 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 149: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 150: /* $@19: %empty  */
#line 2867 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table))))
              MYSQL_YYABORT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 28231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 151: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2875 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 152: /* $@20: %empty  */
#line 2879 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 153: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2885 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 154: /* $@21: %empty  */
#line 2889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28266 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 155: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail  */
#line 2894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 156: /* $@22: %empty  */
#line 2898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 157: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2904 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28292 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 158: /* $@23: %empty  */
#line 2909 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 159: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@23 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2916 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 160: /* $@24: %empty  */
#line 2921 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 161: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2928 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28326 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 162: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 28336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 163: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2940 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 164: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2947 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 165: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2953 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 28364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 166: /* create: CREATE TABLESPACE tablespace_info  */
#line 2957 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 28372 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 167: /* $@25: %empty  */
#line 2960 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 28378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 168: /* create: create_or_replace $@25 server_def  */
#line 2962 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 28384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 169: /* opt_sequence: %empty  */
#line 2966 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 28390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 173: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 174: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2982 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 175: /* sequence_def: NOMINVALUE_SYM  */
#line 2988 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 176: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 2994 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 177: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 3002 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 178: /* sequence_def: NOMAXVALUE_SYM  */
#line 3008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 179: /* sequence_def: START_SYM opt_with longlong_num  */
#line 3014 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 28463 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 180: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 3022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 28475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 181: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 3030 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 182: /* sequence_def: NOCACHE_SYM  */
#line 3038 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28499 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 183: /* sequence_def: CYCLE_SYM  */
#line 3046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 184: /* sequence_def: NOCYCLE_SYM  */
#line 3054 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 185: /* sequence_def: RESTART_SYM  */
#line 3062 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 28539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 186: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 3074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 28556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 187: /* force_lookahead: %empty  */
#line 3089 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 28562 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 188: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 3089 "/home/buildbot/git/sql/sql_yacc.yy"
                                      {}
#line 28568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 189: /* $@26: %empty  */
#line 3093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 28578 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 190: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@26 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 3100 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 28584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 193: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 3110 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 28593 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 194: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 3115 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 28602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 195: /* server_option: DATABASE TEXT_STRING_sys  */
#line 3120 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 28611 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 196: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 3125 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 28620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 197: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 3130 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 28629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 198: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 3135 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 28638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 199: /* server_option: PORT_SYM ulong_num  */
#line 3140 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 28646 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 200: /* $@27: %empty  */
#line 3147 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 28667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 201: /* event_tail: remember_name opt_if_not_exists sp_name $@27 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 3168 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 28679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 202: /* $@28: %empty  */
#line 3179 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 28688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 204: /* ev_schedule_time: AT_SYM expr  */
#line 3186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 28696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 205: /* opt_ev_status: %empty  */
#line 3192 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 206: /* opt_ev_status: ENABLE_SYM  */
#line 3194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 207: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 3200 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 28722 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 208: /* opt_ev_status: DISABLE_SYM  */
#line 3206 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 209: /* ev_starts: %empty  */
#line 3215 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 28743 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 210: /* ev_starts: STARTS_SYM expr  */
#line 3222 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 28751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 212: /* ev_ends: ENDS_SYM expr  */
#line 3230 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 28759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 213: /* opt_ev_on_completion: %empty  */
#line 3236 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 215: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3242 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 28776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 216: /* opt_ev_comment: %empty  */
#line 3251 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 217: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 28791 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 218: /* $@29: %empty  */
#line 3260 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 28828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 219: /* ev_sql_stmt: $@29 sp_proc_stmt force_lookahead  */
#line 3293 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 28838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 220: /* clear_privileges: %empty  */
#line 3302 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 28852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 221: /* opt_aggregate: %empty  */
#line 3314 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 28858 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 222: /* opt_aggregate: AGGREGATE_SYM  */
#line 3315 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 28864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 223: /* sp_name: ident '.' ident  */
#line 3320 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28873 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 224: /* sp_name: ident  */
#line 3325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 225: /* sp_a_chistics: %empty  */
#line 3332 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 226: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3333 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 28894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 227: /* sp_c_chistics: %empty  */
#line 3337 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 228: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3338 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 28906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 229: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3344 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 28912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 230: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3346 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 28918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 231: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3348 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 28924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 232: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3350 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 28930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 233: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3352 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 28936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 234: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3354 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 28942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 235: /* sp_chistic: sp_suid  */
#line 3356 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 28948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 236: /* sp_c_chistic: sp_chistic  */
#line 3361 "/home/buildbot/git/sql/sql_yacc.yy"
                                { }
#line 28954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 237: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3362 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 28960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 238: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3366 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 28966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 239: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3367 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 28972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 240: /* $@30: %empty  */
#line 3372 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 241: /* call: CALL_SYM ident $@30 opt_sp_cparam_list  */
#line 3377 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 242: /* $@31: %empty  */
#line 3382 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 243: /* call: CALL_SYM ident '.' ident $@31 opt_sp_cparam_list  */
#line 3387 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 244: /* $@32: %empty  */
#line 3392 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 245: /* call: CALL_SYM ident '.' ident '.' ident $@32 opt_sp_cparam_list  */
#line 3397 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 250: /* sp_cparams: sp_cparams ',' expr  */
#line 3416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 29034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 251: /* sp_cparams: expr  */
#line 3420 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 29042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 252: /* sp_fdparam_list: %empty  */
#line 3428 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 29051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 253: /* $@33: %empty  */
#line 3433 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 29059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 254: /* sp_fdparam_list: $@33 sp_fdparams  */
#line 3437 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 29067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 257: /* sp_param_name: ident  */
#line 3449 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29076 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 258: /* sp_param_name_and_type: sp_param_name field_type  */
#line 3457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 29085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 259: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident  */
#line 3462 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd,
                                                                (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-2].ident_sys),
                                                                (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 260: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident '.' ident  */
#line 3469 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar),
                                                                (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 261: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident  */
#line 3475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-4].spvar), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 262: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident '.' ident  */
#line 3480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-6].spvar), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 263: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3485 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 29133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 268: /* sp_pdparam: sp_opt_inout sp_param_name_and_type  */
#line 3503 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyvsp[0].spvar)->mode=(yyvsp[-1].spvar_mode); }
#line 29139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 269: /* sp_opt_inout: %empty  */
#line 3507 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 270: /* sp_opt_inout: IN_SYM  */
#line 3508 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 271: /* sp_opt_inout: OUT_SYM  */
#line 3509 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 29157 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 272: /* sp_opt_inout: INOUT_SYM  */
#line 3510 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 29163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 273: /* $@34: %empty  */
#line 3515 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 29171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 274: /* sp_parenthesized_pdparam_list: '(' $@34 sp_pdparam_list ')'  */
#line 3520 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 29179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 275: /* sp_proc_stmts: %empty  */
#line 3526 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 29185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 277: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3531 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 29191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 279: /* sp_decls: %empty  */
#line 3537 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spblock).init();
          }
#line 29199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 280: /* sp_decls: sp_decls sp_decl ';'  */
#line 3541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* We check for declarations out of (standard) order this way
              because letting the grammar rules reflect it caused tricky
               shift/reduce conflicts with the wrong result. (And we get
               better error handling this way.) */
            if (unlikely(Lex->sp_declarations_join(&(yyval.spblock), (yyvsp[-2].spblock), (yyvsp[-1].spblock))))
              MYSQL_YYABORT;
          }
#line 29212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 281: /* sp_decl: DECLARE_MARIADB_SYM sp_decl_body  */
#line 3552 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.spblock)= (yyvsp[0].spblock); }
#line 29218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 282: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3558 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 283: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3564 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 284: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3570 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 285: /* row_field_name: ident  */
#line 3579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 287: /* row_field_definition_list: row_field_definition  */
#line 3591 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 29266 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 288: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 29275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 289: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3603 "/home/buildbot/git/sql/sql_yacc.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 29281 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 290: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3608 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 29289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 291: /* sp_decl_variable_list: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 29301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 292: /* sp_decl_variable_list: sp_decl_idents_init_vars TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3627 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 29311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 293: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3635 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-5].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-5].num));
          }
#line 29321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 294: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3643 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 29331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 296: /* sp_decl_body: sp_decl_ident CONDITION_SYM FOR_SYM sp_cond  */
#line 3653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 29342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 298: /* $@35: %empty  */
#line 3661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 29350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 299: /* sp_decl_body: sp_decl_ident CURSOR_SYM $@35 opt_parenthesized_cursor_formal_parameters FOR_SYM sp_cursor_stmt  */
#line 3666 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-5].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, true)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 29364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 300: /* $@36: %empty  */
#line 3679 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 29373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 301: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@36 sp_hcond_list sp_proc_stmt  */
#line 3684 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 29384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 304: /* sp_cursor_stmt_lex: %empty  */
#line 3699 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 305: /* $@37: %empty  */
#line 3709 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 306: /* sp_cursor_stmt: sp_cursor_stmt_lex $@37 select  */
#line 3716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 29419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 307: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3727 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 29425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 308: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3728 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 29431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 309: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3729 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 29437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 310: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3730 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 29443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 311: /* sp_hcond_list: sp_hcond_element  */
#line 3736 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 29449 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 312: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3738 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)+= 1; }
#line 29455 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 313: /* sp_hcond_element: sp_hcond  */
#line 3743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 29471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 314: /* sp_cond: ulong_num  */
#line 3758 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 316: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3770 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 317: /* opt_value: %empty  */
#line 3789 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29510 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 318: /* opt_value: VALUE_SYM  */
#line 3790 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 319: /* sp_hcond: sp_cond  */
#line 3795 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 29524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 320: /* sp_hcond: ident  */
#line 3799 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 29534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 321: /* sp_hcond: SQLWARNING_SYM  */
#line 3805 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 322: /* sp_hcond: not FOUND_SYM  */
#line 3811 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 323: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3817 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 324: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 325: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3833 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 326: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 327: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3846 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 29601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 328: /* signal_value: ident  */
#line 3854 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(cond->type != sp_condition_value::SQLSTATE))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 29620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 329: /* signal_value: sqlstate  */
#line 3869 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29626 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 330: /* opt_signal_value: %empty  */
#line 3874 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= NULL; }
#line 29632 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 331: /* opt_signal_value: signal_value  */
#line 3876 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 332: /* opt_set_signal_information: %empty  */
#line 3881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 29646 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 334: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 335: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 336: /* signal_allowed_expr: literal  */
#line 3914 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 337: /* signal_allowed_expr: variable  */
#line 3916 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 29700 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 338: /* signal_allowed_expr: simple_ident  */
#line 3934 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 339: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3940 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 29712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 340: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3942 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 29718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 341: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3944 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 29724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 342: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3946 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 29730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 343: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3948 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 29736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 344: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3950 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 29742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 345: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3952 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 29748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 346: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3954 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 29754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 347: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3956 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 29760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 348: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3958 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 29766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 349: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3960 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 29772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 350: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3962 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 29778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 351: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 352: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3975 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 29803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 353: /* which_area: %empty  */
#line 3990 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29809 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 354: /* which_area: CURRENT_SYM  */
#line 3992 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 355: /* diagnostics_information: statement_information  */
#line 3997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 356: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 4003 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 357: /* statement_information: statement_information_item  */
#line 4012 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 358: /* statement_information: statement_information ',' statement_information_item  */
#line 4019 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 29856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 359: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 4028 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 360: /* simple_target_specification: ident_cli  */
#line 4037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 29875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 361: /* simple_target_specification: '@' ident_or_text  */
#line 4042 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 29885 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 362: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 4051 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 363: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 4053 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 364: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 4055 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 29903 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 365: /* condition_number: signal_allowed_expr  */
#line 4064 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 366: /* condition_information: condition_information_item  */
#line 4069 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 367: /* condition_information: condition_information ',' condition_information_item  */
#line 4076 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 29930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 368: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 4085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 369: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 4094 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 29946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 370: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 4096 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 29952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 371: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 4098 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 29958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 372: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 4100 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 29964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 373: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 4102 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 29970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 374: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 4104 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 29976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 375: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 4106 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 29982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 376: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4108 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 29988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 377: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4110 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 29994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 378: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4112 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 30000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 379: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4114 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 30006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 380: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4116 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 30012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 381: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4118 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 30018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 383: /* sp_decl_ident: keyword_sp_decl  */
#line 4124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 30027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 384: /* sp_decl_idents: sp_decl_ident  */
#line 4132 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 30043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 385: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 30059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 386: /* sp_opt_default: %empty  */
#line 4158 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = NULL; }
#line 30065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 387: /* sp_opt_default: DEFAULT expr  */
#line 4159 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 30071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 407: /* $@38: %empty  */
#line 4201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 30081 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 408: /* sp_proc_stmt_if: IF_SYM $@38 sp_if END IF_SYM  */
#line 4207 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 30087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 409: /* $@39: %empty  */
#line 4211 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only a new LEX for the
              statement here as if it is start of parsing a new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 30104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 410: /* sp_proc_stmt_statement: $@39 statement  */
#line 4224 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 413: /* $@40: %empty  */
#line 4239 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 414: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@40 expr  */
#line 4245 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 415: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4257 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 30152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 416: /* $@41: %empty  */
#line 4267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 417: /* reset_lex_expr: $@41 expr  */
#line 4273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            (yyval.item)= (yyvsp[0].item);
          }
#line 30171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 418: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4281 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30180 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 419: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4286 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30189 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 420: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 421: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 422: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4306 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 423: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 424: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4316 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30237 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 425: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4322 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30247 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 426: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4332 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 427: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 428: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4348 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 429: /* assignment_source_lex: %empty  */
#line 4355 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 30285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 430: /* $@42: %empty  */
#line 4365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 431: /* assignment_source_expr: assignment_source_lex $@42 expr  */
#line 4372 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //min select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 432: /* $@43: %empty  */
#line 4386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 30322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 433: /* for_loop_bound_expr: assignment_source_lex $@43 expr  */
#line 4393 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 30337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 434: /* cursor_actual_parameters: assignment_source_expr  */
#line 4407 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 435: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4413 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 436: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4420 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 30362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 437: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4421 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 30368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 438: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4426 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 30377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 439: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4434 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 440: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4439 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 441: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4444 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 442: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4451 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 30410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 443: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4453 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 30419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 444: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4461 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30438 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 445: /* sp_fetch_list: ident  */
#line 4479 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 446: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4495 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 447: /* $@44: %empty  */
#line 4513 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 448: /* $@45: %empty  */
#line 4519 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 449: /* $@46: %empty  */
#line 4536 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 30525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 450: /* sp_if: $@44 expr THEN_SYM $@45 sp_proc_stmts1 $@46 sp_elseifs  */
#line 4548 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 30535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 454: /* $@47: %empty  */
#line 4563 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 30589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 455: /* case_stmt_specification: CASE_SYM $@47 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 30607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 456: /* $@48: %empty  */
#line 4632 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30617 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 457: /* $@49: %empty  */
#line 4638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 458: /* case_stmt_body: $@48 expr $@49 simple_when_clause_list  */
#line 4647 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 30636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 459: /* case_stmt_body: searched_when_clause_list  */
#line 4649 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 30642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 464: /* $@50: %empty  */
#line 4664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30652 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 465: /* $@51: %empty  */
#line 4670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 466: /* simple_when_clause: WHEN_SYM $@50 expr $@51 THEN_SYM sp_proc_stmts1  */
#line 4683 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 467: /* $@52: %empty  */
#line 4691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 468: /* $@53: %empty  */
#line 4697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 469: /* searched_when_clause: WHEN_SYM $@52 expr $@53 THEN_SYM sp_proc_stmts1  */
#line 4708 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 470: /* else_clause_opt: %empty  */
#line 4716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 472: /* sp_label: label_ident ':'  */
#line 4730 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)= (yyvsp[-1].ident_sys); }
#line 30731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 473: /* sp_opt_label: %empty  */
#line 4734 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 30737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 474: /* sp_opt_label: label_ident  */
#line 4735 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 30743 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 475: /* sp_block_label: sp_label  */
#line 4740 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 30753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 476: /* $@54: %empty  */
#line 4750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 30761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 477: /* sp_labeled_block: sp_block_label BEGIN_MARIADB_SYM $@54 sp_decls sp_proc_stmts END sp_opt_label  */
#line 4757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 478: /* $@55: %empty  */
#line 4765 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 30778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 479: /* sp_unlabeled_block: BEGIN_MARIADB_SYM $@55 sp_decls sp_proc_stmts END  */
#line 4771 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 480: /* $@56: %empty  */
#line 4779 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 30797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 481: /* sp_unlabeled_block_not_atomic: BEGIN_MARIADB_SYM not ATOMIC_SYM $@56 sp_decls sp_proc_stmts END  */
#line 4787 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 482: /* opt_sp_for_loop_direction: %empty  */
#line 4795 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 30812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 483: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4796 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= -1; }
#line 30818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 484: /* $@57: %empty  */
#line 4801 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 485: /* sp_for_loop_index_and_bounds: ident $@57 sp_for_loop_bounds  */
#line 4806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 30837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 486: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4816 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 30845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 487: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 30856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 488: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4827 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 30866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 489: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 490: /* $@58: %empty  */
#line 4850 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 30896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 491: /* while_body: expr DO_SYM $@58 sp_proc_stmts1 END WHILE_SYM  */
#line 4861 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 30905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 492: /* $@59: %empty  */
#line 4869 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30915 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 493: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@59 expr END REPEAT_SYM  */
#line 4875 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 30935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 494: /* pop_sp_loop_label: sp_opt_label  */
#line 4894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 495: /* $@60: %empty  */
#line 4902 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 496: /* sp_labeled_control: sp_label LOOP_SYM $@60 loop_body pop_sp_loop_label  */
#line 4907 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30959 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 497: /* $@61: %empty  */
#line 4909 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 498: /* sp_labeled_control: sp_label WHILE_SYM $@61 while_body pop_sp_loop_label  */
#line 4917 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 499: /* $@62: %empty  */
#line 4919 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30986 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 500: /* $@63: %empty  */
#line 4924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 501: /* $@64: %empty  */
#line 4933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 31006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 502: /* sp_labeled_control: sp_label FOR_SYM $@62 sp_for_loop_index_and_bounds $@63 DO_SYM sp_proc_stmts1 END FOR_SYM $@64 pop_sp_loop_label  */
#line 4938 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 31015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 503: /* $@65: %empty  */
#line 4943 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 31024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 504: /* sp_labeled_control: sp_label REPEAT_SYM $@65 repeat_body pop_sp_loop_label  */
#line 4948 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 31030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 505: /* $@66: %empty  */
#line 4953 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 31039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 506: /* sp_unlabeled_control: LOOP_SYM $@66 loop_body  */
#line 4958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 507: /* $@67: %empty  */
#line 4962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 31059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 508: /* sp_unlabeled_control: WHILE_SYM $@67 while_body  */
#line 4970 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 509: /* $@68: %empty  */
#line 4974 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 31078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 510: /* $@69: %empty  */
#line 4981 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 31089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 511: /* sp_unlabeled_control: FOR_SYM $@68 sp_for_loop_index_and_bounds $@69 DO_SYM sp_proc_stmts1 END FOR_SYM  */
#line 4990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 31101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 512: /* $@70: %empty  */
#line 4998 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 31110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 513: /* sp_unlabeled_control: REPEAT_SYM $@70 repeat_body  */
#line 5003 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31118 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 514: /* trg_action_time: BEFORE_SYM  */
#line 5010 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 31124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 515: /* trg_action_time: AFTER_SYM  */
#line 5012 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 31130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 516: /* trg_event: INSERT  */
#line 5017 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 31136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 517: /* trg_event: UPDATE_SYM  */
#line 5019 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 31142 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 518: /* trg_event: DELETE_SYM  */
#line 5021 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 31148 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 522: /* opt_logfile_group_name: %empty  */
#line 5055 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31154 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 523: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 31163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 524: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5067 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 31171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 525: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5073 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 31179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 530: /* $@71: %empty  */
#line 5096 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 577: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 31194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 578: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5198 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 579: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5206 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 580: /* tablespace_name: ident  */
#line 5214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 581: /* logfile_group_name: ident  */
#line 5227 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 582: /* ts_access_mode: READ_ONLY_SYM  */
#line 5240 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 31249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 583: /* ts_access_mode: READ_WRITE_SYM  */
#line 5245 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 31258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 584: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5250 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 31267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 585: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 31276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 586: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 31285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 587: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5274 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 31294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 588: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5282 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 31303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 589: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5290 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 590: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5298 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 591: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5306 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 31332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 592: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5316 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 31343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 593: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5326 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 31355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 596: /* ts_wait: WAIT_SYM  */
#line 5342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 31364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 597: /* ts_wait: NO_WAIT_SYM  */
#line 5347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 31375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 598: /* size_number: real_ulonglong_num  */
#line 5356 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 31381 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 599: /* size_number: IDENT_sys  */
#line 5358 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 31390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 600: /* $@72: %empty  */
#line 5370 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.option_list= NULL; }
#line 31396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 601: /* create_body: create_field_list_parens $@72 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5371 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31402 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 602: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5372 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 603: /* create_body: create_like  */
#line 5374 "/home/buildbot/git/sql/sql_yacc.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 31423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 604: /* create_like: LIKE table_ident  */
#line 5387 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 31429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 605: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5388 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 31435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 606: /* opt_create_select: %empty  */
#line 5392 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 607: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 31450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 608: /* create_select_query_expression: query_expression  */
#line 5403 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 31459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 609: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5408 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 31471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 610: /* opt_create_partitioning: opt_partitioning  */
#line 5419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 31485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 611: /* opt_partitioning: %empty  */
#line 5455 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 613: /* $@73: %empty  */
#line 5461 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 31506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 615: /* have_partitioning: %empty  */
#line 5476 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 31522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 616: /* $@74: %empty  */
#line 5491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
          }
#line 31540 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 617: /* partition_entry: PARTITION_SYM $@74 partition  */
#line 5505 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 31548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 618: /* $@75: %empty  */
#line 5512 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->safe_to_cache_query= 1; }
#line 31554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 620: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 31565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 621: /* $@76: %empty  */
#line 5525 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 31571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 622: /* part_type_def: opt_linear HASH_SYM $@76 part_func  */
#line 5526 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 31577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 623: /* part_type_def: RANGE_SYM part_func  */
#line 5528 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 624: /* part_type_def: RANGE_SYM part_column_list  */
#line 5530 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 625: /* $@77: %empty  */
#line 5532 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 31597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 626: /* part_type_def: LIST_SYM $@77 part_func  */
#line 5536 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 31606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 627: /* part_type_def: LIST_SYM part_column_list  */
#line 5541 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 31612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 628: /* $@78: %empty  */
#line 5543 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 31621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 630: /* opt_linear: %empty  */
#line 5551 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 631: /* opt_linear: LINEAR_SYM  */
#line 5553 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 31633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 632: /* opt_key_algo: %empty  */
#line 5558 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 31639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 633: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5560 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 31657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 634: /* part_field_list: %empty  */
#line 5576 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 635: /* part_field_list: part_field_item_list  */
#line 5577 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 31669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 636: /* part_field_item_list: part_field_item  */
#line 5581 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 637: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5582 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 31681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 638: /* part_field_item: ident  */
#line 5587 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 31696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 639: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 31706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 640: /* part_func: '(' part_func_expr ')'  */
#line 5611 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 31718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 641: /* sub_part_func: '(' part_func_expr ')'  */
#line 5622 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 31727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 642: /* opt_num_parts: %empty  */
#line 5630 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 643: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5632 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 644: /* opt_sub_part: %empty  */
#line 5644 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 645: /* $@79: %empty  */
#line 5646 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 31759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 646: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@79 opt_num_subparts  */
#line 5647 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 647: /* $@80: %empty  */
#line 5650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 31775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 648: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@80 opt_num_subparts  */
#line 5655 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 649: /* sub_part_field_list: sub_part_field_item  */
#line 5659 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 31787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 650: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5660 "/home/buildbot/git/sql/sql_yacc.yy"
                                                      {}
#line 31793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 651: /* sub_part_field_item: ident  */
#line 5665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 31808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 652: /* part_func_expr: bit_expr  */
#line 5679 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 31821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 653: /* opt_num_subparts: %empty  */
#line 5690 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 654: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5692 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 31840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 655: /* part_defs: %empty  */
#line 5704 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 31854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 656: /* part_defs: '(' part_def_list ')'  */
#line 5714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 657: /* part_def_list: part_definition  */
#line 5735 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 658: /* part_def_list: part_def_list ',' part_definition  */
#line 5736 "/home/buildbot/git/sql/sql_yacc.yy"
                                            {}
#line 31889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 659: /* $@81: %empty  */
#line 5741 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 660: /* part_definition: PARTITION_SYM $@81 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5760 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 31915 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 661: /* part_name: ident  */
#line 5765 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 31927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 662: /* opt_part_values: %empty  */
#line 5776 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31947 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 663: /* $@82: %empty  */
#line 5792 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 664: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@82 part_func_max  */
#line 5804 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 31970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 665: /* $@83: %empty  */
#line 5806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 666: /* opt_part_values: VALUES_IN_SYM $@83 part_values_in  */
#line 5818 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 31993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 667: /* opt_part_values: CURRENT_SYM  */
#line 5820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 32002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 668: /* opt_part_values: HISTORY_SYM  */
#line 5825 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 32011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 669: /* opt_part_values: DEFAULT  */
#line 5830 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 32032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 670: /* part_func_max: MAXVALUE_SYM  */
#line 5850 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 32054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 671: /* part_func_max: part_value_item  */
#line 5867 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 672: /* part_values_in: part_value_item  */
#line 5872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 32091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 673: /* part_values_in: '(' part_value_list ')'  */
#line 5899 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 674: /* part_value_list: part_value_item  */
#line 5910 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 675: /* part_value_list: part_value_list ',' part_value_item  */
#line 5911 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 676: /* $@84: %empty  */
#line 5916 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 32130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 677: /* $@85: %empty  */
#line 5925 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 678: /* part_value_item: '(' $@84 part_value_item_list $@85 ')'  */
#line 5927 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 32161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 679: /* part_value_item_list: part_value_expr_item  */
#line 5950 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 680: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5951 "/home/buildbot/git/sql/sql_yacc.yy"
                                                        {}
#line 32173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 681: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 32188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 682: /* part_value_expr_item: bit_expr  */
#line 5967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 32206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 683: /* opt_sub_partition: %empty  */
#line 5985 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 684: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 5999 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 32251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 685: /* sub_part_list: sub_part_definition  */
#line 6024 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 686: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6025 "/home/buildbot/git/sql/sql_yacc.yy"
                                                {}
#line 32263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 687: /* $@86: %empty  */
#line 6030 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 32300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 688: /* sub_part_definition: SUBPARTITION_SYM $@86 sub_name opt_part_options  */
#line 6062 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 32306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 689: /* sub_name: ident_or_text  */
#line 6067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 32316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 690: /* opt_part_options: %empty  */
#line 6075 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 691: /* opt_part_options: opt_part_option_list  */
#line 6076 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 692: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6080 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 693: /* opt_part_option_list: opt_part_option  */
#line 6081 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 32340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 694: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6086 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 32346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 695: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6088 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 32356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 696: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6094 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 32366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 697: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6100 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 32372 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 698: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6102 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 699: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6104 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 700: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6106 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 32390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 701: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6108 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 32396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 702: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6110 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 32402 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 703: /* opt_versioning_rotation: %empty  */
#line 6114 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 704: /* $@87: %empty  */
#line 6115 "/home/buildbot/git/sql/sql_yacc.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 32414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 705: /* opt_versioning_rotation: $@87 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6117 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 32424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 706: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6123 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 32439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 707: /* opt_versioning_interval_start: %empty  */
#line 6138 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 32447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 708: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6142 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 32461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 709: /* opt_as: %empty  */
#line 6158 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 710: /* opt_as: AS  */
#line 6159 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 32473 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 711: /* opt_create_database_options: %empty  */
#line 6163 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 712: /* opt_create_database_options: create_database_options  */
#line 6164 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 32485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 713: /* create_database_options: create_database_option  */
#line 6168 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 32491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 714: /* create_database_options: create_database_options create_database_option  */
#line 6169 "/home/buildbot/git/sql/sql_yacc.yy"
                                                         {}
#line 32497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 715: /* create_database_option: default_collation  */
#line 6173 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 32503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 716: /* create_database_option: default_charset  */
#line 6174 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 717: /* opt_if_not_exists_table_element: %empty  */
#line 6179 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 32517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 718: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6183 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 32525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 719: /* opt_if_not_exists: %empty  */
#line 6190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 720: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 32541 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 721: /* create_or_replace: CREATE  */
#line 6201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 722: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 32557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 730: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6228 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 32576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 731: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6243 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 32585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 732: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6248 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 32594 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 733: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 32603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 734: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 32612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 735: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6263 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 32621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 736: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 32630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 737: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 738: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6288 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 739: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6294 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 740: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 741: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6314 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 742: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6329 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32716 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 743: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 744: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6353 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 745: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6358 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32756 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 746: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6363 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 747: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 32774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 748: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6373 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 32783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 749: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6378 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 32792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 750: /* $@88: %empty  */
#line 6383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 32800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 751: /* create_table_option: UNION_SYM opt_equal $@88 '(' opt_table_list ')'  */
#line 6387 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 32826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 754: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 32835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 755: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 32844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 756: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 32853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 757: /* create_table_option: TABLESPACE ident  */
#line 6426 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 32859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 758: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6428 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 32865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 759: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6430 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 32871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 760: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6432 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 32881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 761: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 32890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 762: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 32899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 763: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6448 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 764: /* create_table_option: IDENT_sys equal ident  */
#line 6457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 765: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6466 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 32935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 766: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 767: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 771: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6492 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32974 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 772: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32983 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 773: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6519 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 774: /* storage_engines: ident_or_text  */
#line 6534 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 33010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 775: /* known_storage_engines: ident_or_text  */
#line 6544 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 33022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 776: /* row_types: DEFAULT  */
#line 6554 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 33028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 777: /* row_types: FIXED_SYM  */
#line 6555 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 33034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 778: /* row_types: DYNAMIC_SYM  */
#line 6556 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 33040 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 779: /* row_types: COMPRESSED_SYM  */
#line 6557 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 33046 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 780: /* row_types: REDUNDANT_SYM  */
#line 6558 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 33052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 781: /* row_types: COMPACT_SYM  */
#line 6559 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 33058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 782: /* row_types: PAGE_SYM  */
#line 6560 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 33064 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 783: /* merge_insert_types: NO_SYM  */
#line 6564 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 33070 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 784: /* merge_insert_types: FIRST_SYM  */
#line 6565 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 33076 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 785: /* merge_insert_types: LAST_SYM  */
#line 6566 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 33082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 786: /* udf_type: STRING_SYM  */
#line 6570 "/home/buildbot/git/sql/sql_yacc.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 33088 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 787: /* udf_type: REAL  */
#line 6571 "/home/buildbot/git/sql/sql_yacc.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 33094 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 788: /* udf_type: DECIMAL_SYM  */
#line 6572 "/home/buildbot/git/sql/sql_yacc.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 33100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 789: /* udf_type: INT_SYM  */
#line 6573 "/home/buildbot/git/sql/sql_yacc.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 33106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 790: /* create_field_list: field_list  */
#line 6579 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 791: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6586 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 794: /* field_list_item: column_def  */
#line 6597 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 33128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 798: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6601 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { }
#line 33134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 799: /* column_def: field_spec  */
#line 6606 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 33140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 800: /* column_def: field_spec references  */
#line 6608 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 33146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 801: /* $@89: %empty  */
#line 6613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 802: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@89 '(' key_list ')' normal_key_options  */
#line 6618 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 803: /* $@90: %empty  */
#line 6620 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33172 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 804: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@90 '(' key_list ')' normal_key_options  */
#line 6625 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33178 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 805: /* $@91: %empty  */
#line 6627 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 806: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@91 '(' key_list ')' fulltext_key_options  */
#line 6632 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { }
#line 33194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 807: /* $@92: %empty  */
#line 6634 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 808: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@92 '(' key_list ')' spatial_key_options  */
#line 6639 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 33210 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 809: /* $@93: %empty  */
#line 6643 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 810: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@93 '(' key_list ')' normal_key_options  */
#line 6648 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 811: /* $@94: %empty  */
#line 6651 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 812: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@94 '(' key_list ')' normal_key_options  */
#line 6656 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33242 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 813: /* $@95: %empty  */
#line 6658 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 33256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 814: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@95 '(' key_list ')' references  */
#line 6668 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 33286 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 815: /* constraint_def: opt_constraint check_constraint  */
#line 6697 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 33294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 816: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 33303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 817: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6713 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 33312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 818: /* opt_check_constraint: %empty  */
#line 6720 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 33318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 819: /* opt_check_constraint: check_constraint  */
#line 6721 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 33324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 820: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6726 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33335 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 821: /* opt_constraint_no_id: %empty  */
#line 6735 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 822: /* opt_constraint_no_id: CONSTRAINT  */
#line 6736 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 823: /* opt_constraint: %empty  */
#line 6740 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 33353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 824: /* opt_constraint: constraint  */
#line 6741 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 33359 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 825: /* constraint: CONSTRAINT opt_ident  */
#line 6745 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 33365 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 826: /* @96: %empty  */
#line 6750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 33385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 827: /* field_spec: field_ident @96 field_type_or_serial opt_check_constraint  */
#line 6766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 33408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 828: /* $@97: %empty  */
#line 6787 "/home/buildbot/git/sql/sql_yacc.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 33414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 830: /* $@98: %empty  */
#line 6790 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 832: /* opt_serial_attribute: %empty  */
#line 6800 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 833: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6801 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 33437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 834: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6805 "/home/buildbot/git/sql/sql_yacc.yy"
                                                     {}
#line 33443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 836: /* opt_asrow_attribute: %empty  */
#line 6810 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33449 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 837: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6811 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33455 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 838: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6815 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 33461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 840: /* field_def: %empty  */
#line 6820 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 33467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 844: /* $@99: %empty  */
#line 6825 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 33476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 846: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6831 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 33485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 847: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 33494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 848: /* opt_generated_always: %empty  */
#line 6843 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 849: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6844 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 850: /* vcol_opt_specifier: %empty  */
#line 6849 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33514 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 851: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 852: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6857 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 853: /* vcol_opt_specifier: STORED_SYM  */
#line 6861 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 854: /* vcol_opt_attribute: %empty  */
#line 6867 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 855: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6868 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 33550 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 856: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6872 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 {}
#line 33556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 858: /* vcol_attribute: UNIQUE_SYM  */
#line 6878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 859: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6884 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 860: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6889 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 33582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 861: /* vcol_attribute: INVISIBLE_SYM  */
#line 6891 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 33590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 862: /* $@100: %empty  */
#line 6898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 33605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 863: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@100 expr  */
#line 6909 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 33617 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 865: /* parenthesized_expr: expr ',' expr_list  */
#line 6921 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 33628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 866: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33640 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 867: /* virtual_column_func: subquery  */
#line 6939 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 871: /* column_default_expr: expr_or_literal  */
#line 6955 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 33663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 872: /* field_type: field_type_all  */
#line 6962 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 873: /* qualified_field_type: field_type_all  */
#line 6970 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 33680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 874: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 6974 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 33689 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 880: /* field_type_numeric: int_type opt_field_length field_options  */
#line 6989 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 33695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 881: /* field_type_numeric: real_type opt_precision field_options  */
#line 6990 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 33701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 882: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 6992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 33721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 883: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 33729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 884: /* field_type_numeric: BOOL_SYM  */
#line 7012 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 885: /* field_type_numeric: BOOLEAN_SYM  */
#line 7016 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 886: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7020 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 887: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 33762 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 888: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7029 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33768 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 889: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7031 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 894: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 33782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 895: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7048 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33791 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 896: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7053 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 33800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 897: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7058 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 898: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7062 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 899: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7066 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 900: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33834 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 901: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7076 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33843 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 902: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7084 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 33865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 903: /* field_type_temporal: DATE_SYM  */
#line 7101 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 33871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 904: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7103 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 905: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7110 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33893 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 906: /* field_type_temporal: DATETIME opt_field_length  */
#line 7117 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 907: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7125 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 908: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7130 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 909: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7135 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 910: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7140 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 911: /* field_type_lob: spatial_type float_options srid_option  */
#line 7145 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 912: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7156 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 913: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 914: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7166 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 915: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7171 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 916: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7173 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 917: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7175 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 918: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7177 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 34003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 919: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7179 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 34009 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 920: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7181 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 34015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 921: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7183 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 34021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 922: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7185 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 34030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 923: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7193 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 34036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 924: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7195 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 34042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 925: /* spatial_type: GEOMETRY_SYM  */
#line 7199 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 34048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 926: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7200 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 34054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 927: /* spatial_type: POINT_SYM  */
#line 7201 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 34060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 928: /* spatial_type: MULTIPOINT  */
#line 7202 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 34066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 929: /* spatial_type: LINESTRING  */
#line 7203 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 34072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 930: /* spatial_type: MULTILINESTRING  */
#line 7204 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 34078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 931: /* spatial_type: POLYGON  */
#line 7205 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 34084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 932: /* spatial_type: MULTIPOLYGON  */
#line 7206 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 34090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 933: /* char: CHAR_SYM  */
#line 7210 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 34096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 934: /* nchar: NCHAR_SYM  */
#line 7214 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 935: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7215 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 34108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 936: /* varchar: char VARYING  */
#line 7219 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 937: /* varchar: VARCHAR  */
#line 7220 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34120 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 938: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7224 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 34126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 939: /* nvarchar: NVARCHAR_SYM  */
#line 7225 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 940: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7226 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 941: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7227 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 34144 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 942: /* nvarchar: NCHAR_SYM VARYING  */
#line 7228 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 943: /* int_type: INT_SYM  */
#line 7232 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 34156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 944: /* int_type: TINYINT  */
#line 7233 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 34162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 945: /* int_type: SMALLINT  */
#line 7234 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 34168 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 946: /* int_type: MEDIUMINT  */
#line 7235 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 34174 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 947: /* int_type: BIGINT  */
#line 7236 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 34180 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 948: /* real_type: REAL  */
#line 7241 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 34190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 949: /* real_type: DOUBLE_SYM  */
#line 7246 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 950: /* real_type: DOUBLE_SYM PRECISION  */
#line 7247 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 951: /* srid_option: %empty  */
#line 7252 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->srid= 0; }
#line 34208 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 952: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7255 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 34216 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 953: /* float_options: %empty  */
#line 7261 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 34222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 954: /* float_options: field_length  */
#line 7262 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 34228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 955: /* float_options: precision  */
#line 7263 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34234 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 956: /* precision: '(' NUM ',' NUM ')'  */
#line 7267 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 34240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 957: /* field_options: %empty  */
#line 7271 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 958: /* field_options: SIGNED_SYM  */
#line 7272 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 34252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 959: /* field_options: UNSIGNED  */
#line 7273 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 34258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 960: /* field_options: ZEROFILL  */
#line 7274 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 961: /* field_options: UNSIGNED ZEROFILL  */
#line 7275 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34270 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 962: /* field_options: ZEROFILL UNSIGNED  */
#line 7276 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 963: /* field_length: '(' LONG_NUM ')'  */
#line 7280 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34282 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 964: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7281 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 965: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7282 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 966: /* field_length: '(' NUM ')'  */
#line 7283 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 967: /* opt_field_length: %empty  */
#line 7287 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 34306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 968: /* opt_field_length: field_length  */
#line 7288 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 969: /* opt_field_length_default_1: %empty  */
#line 7292 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 34318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 970: /* opt_field_length_default_1: field_length  */
#line 7293 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 971: /* opt_precision: %empty  */
#line 7297 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 34330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 972: /* opt_precision: precision  */
#line 7298 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 973: /* attribute_list: attribute_list attribute  */
#line 7303 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 34342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 975: /* attribute: NULL_SYM  */
#line 7308 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 34348 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 976: /* attribute: DEFAULT column_default_expr  */
#line 7309 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 34354 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 977: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 34365 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 978: /* attribute: AUTO_INC  */
#line 7317 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 34371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 979: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7319 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34381 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 980: /* attribute: COLLATE_SYM collation_name  */
#line 7325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 34392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 982: /* opt_compression_method: %empty  */
#line 7335 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 34398 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 983: /* opt_compression_method: equal ident  */
#line 7336 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 34404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 984: /* opt_compressed: %empty  */
#line 7340 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 985: /* opt_compressed: compressed  */
#line 7341 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 34416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 986: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7346 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 987: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7354 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 988: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34444 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 989: /* asrow_attribute: not NULL_SYM  */
#line 7371 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 34452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 990: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 993: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 994: /* serial_attribute: IDENT_sys equal ident  */
#line 7395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 995: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 34498 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 996: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7410 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 997: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 34522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 998: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 34532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 999: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7435 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 34542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1000: /* charset: CHAR_SYM SET  */
#line 7444 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1001: /* charset: CHARSET  */
#line 7445 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1002: /* charset_name: ident_or_text  */
#line 7450 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1003: /* charset_name: BINARY  */
#line 7454 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1004: /* charset_name_or_default: charset_name  */
#line 7458 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 34575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1005: /* charset_name_or_default: DEFAULT  */
#line 7459 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1006: /* opt_load_data_charset: %empty  */
#line 7463 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)= NULL; }
#line 34587 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1007: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7464 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 34593 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1008: /* old_or_new_charset_name: ident_or_text  */
#line 7469 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1009: /* old_or_new_charset_name: BINARY  */
#line 7475 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1010: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7479 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 34616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1011: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7480 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1012: /* collation_name: ident_or_text  */
#line 7485 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 34631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1013: /* opt_collate: %empty  */
#line 7492 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)=NULL; }
#line 34637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1014: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7493 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 34643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1015: /* collation_name_or_default: collation_name  */
#line 7497 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 34649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1016: /* collation_name_or_default: DEFAULT  */
#line 7498 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1017: /* opt_default: %empty  */
#line 7502 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1018: /* opt_default: DEFAULT  */
#line 7503 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1019: /* charset_or_alias: charset charset_name  */
#line 7507 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1020: /* charset_or_alias: ASCII_SYM  */
#line 7508 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 34679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1021: /* charset_or_alias: UNICODE_SYM  */
#line 7510 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 34688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1022: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7516 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1023: /* opt_binary: %empty  */
#line 7520 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, false); }
#line 34700 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1024: /* opt_binary: binary  */
#line 7521 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 34706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1025: /* binary: BYTE_SYM  */
#line 7525 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 34712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1026: /* binary: charset_or_alias opt_bin_mod  */
#line 7526 "/home/buildbot/git/sql/sql_yacc.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 34718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1027: /* binary: BINARY  */
#line 7527 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, true); }
#line 34724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1028: /* binary: BINARY charset_or_alias  */
#line 7528 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 34730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1029: /* binary: charset_or_alias collate  */
#line 7530 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 34746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1030: /* binary: collate  */
#line 7541 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 34752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1031: /* opt_bin_mod: %empty  */
#line 7545 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= false; }
#line 34758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1032: /* opt_bin_mod: BINARY  */
#line 7546 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= true; }
#line 34764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1033: /* $@101: %empty  */
#line 7551 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 34776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1034: /* ws_nweights: '(' real_ulong_num $@101 ')'  */
#line 7559 "/home/buildbot/git/sql/sql_yacc.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 34782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1035: /* ws_level_flag_desc: ASC  */
#line 7563 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.ulong_num)= 0; }
#line 34788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1036: /* ws_level_flag_desc: DESC  */
#line 7564 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 34794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1037: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7568 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 34800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1038: /* ws_level_flags: %empty  */
#line 7571 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 34806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1039: /* ws_level_flags: ws_level_flag_desc  */
#line 7572 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1040: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7573 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 34818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1041: /* ws_level_flags: ws_level_flag_reverse  */
#line 7574 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 34824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1042: /* ws_level_number: real_ulong_num  */
#line 7579 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 34833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1043: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7587 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 34841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1044: /* ws_level_list: ws_level_list_item  */
#line 7593 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1045: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7594 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1046: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7599 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1047: /* ws_level_list_or_range: ws_level_list  */
#line 7608 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1048: /* ws_level_list_or_range: ws_level_range  */
#line 7609 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1049: /* opt_ws_levels: %empty  */
#line 7613 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.ulong_num)= 0; }
#line 34882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1050: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7614 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1053: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1054: /* opt_ref_list: %empty  */
#line 7635 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->ref_list.empty(); }
#line 34902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1056: /* ref_list: ref_list ',' ident  */
#line 7641 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1057: /* ref_list: ident  */
#line 7648 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34926 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1058: /* opt_match_clause: %empty  */
#line 7660 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1059: /* opt_match_clause: MATCH FULL  */
#line 7662 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34938 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1060: /* opt_match_clause: MATCH PARTIAL  */
#line 7664 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1061: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7666 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34950 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1062: /* opt_on_update_delete: %empty  */
#line 7671 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1063: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7677 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1064: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7683 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34980 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1065: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7690 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1066: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 35000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1067: /* delete_option: RESTRICT  */
#line 7705 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 35006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1068: /* delete_option: CASCADE  */
#line 7706 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 35012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1069: /* delete_option: SET NULL_SYM  */
#line 7707 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 35018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1070: /* delete_option: NO_SYM ACTION  */
#line 7708 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 35024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1071: /* delete_option: SET DEFAULT  */
#line 7709 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 35030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1072: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7713 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 35036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1073: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7714 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 35042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1074: /* key_or_index: KEY_SYM  */
#line 7718 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 35048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1075: /* key_or_index: INDEX_SYM  */
#line 7719 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 35054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1076: /* opt_key_or_index: %empty  */
#line 7723 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1078: /* keys_or_index: KEYS  */
#line 7728 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 35066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1079: /* keys_or_index: INDEX_SYM  */
#line 7729 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 35072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1080: /* keys_or_index: INDEXES  */
#line 7730 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 35078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1081: /* opt_unique: %empty  */
#line 7734 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 35084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1082: /* opt_unique: UNIQUE_SYM  */
#line 7735 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 35090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1083: /* fulltext: FULLTEXT_SYM  */
#line 7739 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 35096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1084: /* spatial: SPATIAL_SYM  */
#line 7744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 35109 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1085: /* normal_key_options: %empty  */
#line 7755 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1086: /* normal_key_options: normal_key_opts  */
#line 7756 "/home/buildbot/git/sql/sql_yacc.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 35121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1087: /* fulltext_key_options: %empty  */
#line 7760 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1088: /* fulltext_key_options: fulltext_key_opts  */
#line 7761 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 35133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1089: /* spatial_key_options: %empty  */
#line 7765 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1090: /* spatial_key_options: spatial_key_opts  */
#line 7766 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 35145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1097: /* opt_USING_key_algorithm: %empty  */
#line 7785 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1098: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7786 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35157 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1099: /* opt_key_algorithm_clause: %empty  */
#line 7791 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1100: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7792 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1101: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7793 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1102: /* key_using_alg: USING btree_or_rtree  */
#line 7798 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35181 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1103: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7800 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35187 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1104: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7805 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 35196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1105: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7810 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 35202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1106: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35214 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1107: /* all_key_opt: IDENT_sys equal ident  */
#line 7820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1108: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7828 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 35236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1109: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7834 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1114: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1115: /* btree_or_rtree: BTREE_SYM  */
#line 7862 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 35263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1116: /* btree_or_rtree: RTREE_SYM  */
#line 7863 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 35269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1117: /* btree_or_rtree: HASH_SYM  */
#line 7864 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 35275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1118: /* key_list: key_list ',' key_part order_dir  */
#line 7869 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1119: /* key_list: key_part order_dir  */
#line 7873 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1120: /* key_part: ident  */
#line 7880 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1121: /* key_part: ident '(' NUM ')'  */
#line 7886 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1122: /* opt_ident: %empty  */
#line 7897 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 35320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1123: /* opt_ident: field_ident  */
#line 7898 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 35326 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1124: /* string_list: text_string  */
#line 7903 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1125: /* string_list: string_list ',' text_string  */
#line 7905 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35338 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1126: /* $@102: %empty  */
#line 7914 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 35358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1127: /* $@103: %empty  */
#line 7930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                   TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 35373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1128: /* alter: ALTER $@102 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@103 alter_commands  */
#line 7941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 35388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1129: /* $@104: %empty  */
#line 7952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 35399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1130: /* alter: ALTER DATABASE ident_or_empty $@104 create_database_options  */
#line 7959 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 35413 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1131: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 7969 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 35425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1132: /* $@105: %empty  */
#line 7977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1133: /* alter: ALTER PROCEDURE_SYM sp_name $@105 sp_a_chistics  */
#line 7987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1134: /* $@106: %empty  */
#line 7997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1135: /* alter: ALTER FUNCTION_SYM sp_name $@106 sp_a_chistics  */
#line 8007 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1136: /* $@107: %empty  */
#line 8017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1137: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@107 view_list_opt AS view_select  */
#line 8024 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1138: /* $@108: %empty  */
#line 8035 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1139: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@108 view_list_opt AS view_select  */
#line 8042 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1140: /* $@109: %empty  */
#line 8048 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 35546 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1141: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@109 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 35566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1142: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8087 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 35575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1143: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8092 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 35584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1144: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8097 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 35593 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1145: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 35602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1146: /* $@110: %empty  */
#line 8107 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 35612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1147: /* alter: ALTER SERVER_SYM ident_or_text $@110 OPTIONS_SYM '(' server_options_list ')'  */
#line 8111 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    { }
#line 35618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1148: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8115 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 35627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1149: /* $@111: %empty  */
#line 8120 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->name= null_clex_str;
            lex->table_type= TABLE_TYPE_UNKNOWN;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            lex->create_info.init();
            lex->no_write_to_binlog= 0;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 35643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1150: /* $@112: %empty  */
#line 8132 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 35657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1151: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@111 table_ident $@112 sequence_defs  */
#line 8142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1152: /* account_locking_option: LOCK_SYM  */
#line 8155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 35679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1153: /* account_locking_option: UNLOCK_SYM  */
#line 8159 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 35687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1154: /* opt_password_expire_option: %empty  */
#line 8166 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 35695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1155: /* opt_password_expire_option: NEVER_SYM  */
#line 8170 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 35703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1156: /* opt_password_expire_option: DEFAULT  */
#line 8174 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 35711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1157: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 35721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1163: /* ev_alter_on_schedule_completion: %empty  */
#line 8194 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1164: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8195 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.num)= 1; }
#line 35733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1165: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8196 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.num)= 1; }
#line 35739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1166: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8197 "/home/buildbot/git/sql/sql_yacc.yy"
                                                            { (yyval.num)= 1; }
#line 35745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1167: /* opt_ev_rename_to: %empty  */
#line 8201 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1168: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8203 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 35764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1169: /* opt_ev_sql_stmt: %empty  */
#line 8214 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= 0;}
#line 35770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1170: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8215 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 35776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1171: /* ident_or_empty: %empty  */
#line 8219 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 35782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1174: /* alter_commands: DISCARD TABLESPACE  */
#line 8226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1175: /* alter_commands: IMPORT TABLESPACE  */
#line 8234 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1181: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8256 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 35816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1182: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8263 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 35826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1183: /* $@113: %empty  */
#line 8270 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1185: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8283 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1186: /* $@114: %empty  */
#line 8294 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1188: /* $@115: %empty  */
#line 8306 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35885 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1190: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1191: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1193: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8337 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1194: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8345 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1195: /* all_or_alt_part_name_list: ALL  */
#line 8352 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1197: /* $@116: %empty  */
#line 8361 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1198: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@116 add_part_extra  */
#line 8373 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 35957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1200: /* add_part_extra: '(' part_def_list ')'  */
#line 8379 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1201: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35974 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1202: /* $@117: %empty  */
#line 8391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1204: /* reorg_parts_rule: %empty  */
#line 8404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1205: /* $@118: %empty  */
#line 8408 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 36003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1206: /* reorg_parts_rule: alt_part_name_list $@118 INTO '(' part_def_list ')'  */
#line 8412 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 36012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1207: /* alt_part_name_list: alt_part_name_item  */
#line 8419 "/home/buildbot/git/sql/sql_yacc.yy"
                             {}
#line 36018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1208: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8420 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    {}
#line 36024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1209: /* alt_part_name_item: ident  */
#line 8425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1213: /* alter_list_item: add_column column_def opt_place  */
#line 8447 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1214: /* alter_list_item: ADD key_def  */
#line 8454 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 36054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1215: /* alter_list_item: ADD period_for_system_time  */
#line 8459 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 36062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1216: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 36072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1217: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8470 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 36083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1218: /* alter_list_item: ADD constraint_def  */
#line 8477 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 36091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1219: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8481 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 36100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1220: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8487 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1221: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8495 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1222: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8502 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 36136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1223: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8512 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1224: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 36165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1225: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8533 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36180 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1226: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8544 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1227: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8554 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1228: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8560 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36214 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1229: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 36225 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1230: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 36235 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1231: /* alter_list_item: RENAME opt_to table_ident  */
#line 8579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 36253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1232: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8593 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 36271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1233: /* alter_list_item: create_table_options_space_separated  */
#line 8607 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 36280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1234: /* alter_list_item: FORCE_SYM  */
#line 8612 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 36288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1235: /* alter_list_item: alter_order_clause  */
#line 8616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 36297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1238: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8623 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 36306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1239: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 36315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1240: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8633 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 36323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1241: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36335 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1247: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8656 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 36344 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1248: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1249: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8669 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 36362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1250: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8674 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1251: /* opt_column: %empty  */
#line 8681 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1252: /* opt_column: COLUMN_SYM  */
#line 8682 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 36383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1253: /* opt_ignore: %empty  */
#line 8686 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->ignore= 0;}
#line 36389 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1254: /* opt_ignore: IGNORE_SYM  */
#line 8687 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1255: /* $@119: %empty  */
#line 8691 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->ignore= 0;}
#line 36401 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1261: /* alter_option: IGNORE_SYM  */
#line 8705 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36407 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1262: /* alter_option: ONLINE_SYM  */
#line 8707 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 36416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1263: /* opt_restrict: %empty  */
#line 8714 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 36422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1264: /* opt_restrict: RESTRICT  */
#line 8715 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 36428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1265: /* opt_restrict: CASCADE  */
#line 8716 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 36434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1266: /* opt_place: %empty  */
#line 8720 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 36440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1267: /* opt_place: AFTER_SYM ident  */
#line 8722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36449 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1268: /* opt_place: FIRST_SYM  */
#line 8727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1269: /* opt_to: %empty  */
#line 8735 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36465 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1270: /* opt_to: TO_SYM  */
#line 8736 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 36471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1271: /* opt_to: '='  */
#line 8737 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36477 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1272: /* opt_to: AS  */
#line 8738 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 36483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1273: /* $@120: %empty  */
#line 8743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 36494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1274: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@120 slave_until  */
#line 8750 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1275: /* $@121: %empty  */
#line 8752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 36511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1276: /* slave: START_SYM ALL SLAVES slave_thread_opts $@121  */
#line 8758 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1277: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8760 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1278: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8767 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1279: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8777 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 36556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1280: /* opt_start_transaction_option_list: %empty  */
#line 8793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= 0;
          }
#line 36564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1281: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8797 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36572 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1282: /* start_transaction_option_list: start_transaction_option  */
#line 8804 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1283: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 36588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1284: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 36596 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1285: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8819 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 36604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1286: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 36612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1287: /* $@122: %empty  */
#line 8829 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->slave_thd_opt= 0; }
#line 36618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1288: /* slave_thread_opts: $@122 slave_thread_opt_list  */
#line 8831 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1291: /* slave_thread_opt: %empty  */
#line 8840 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1292: /* slave_thread_opt: SQL_THREAD  */
#line 8841 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 36636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1293: /* slave_thread_opt: RELAY_THREAD  */
#line 8842 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 36642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1294: /* slave_until: %empty  */
#line 8846 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1295: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8848 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 36661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1296: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8857 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 36669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1299: /* $@123: %empty  */
#line 8869 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1300: /* checksum: CHECKSUM_SYM table_or_tables $@123 table_list opt_checksum_type  */
#line 8876 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1301: /* opt_checksum_type: %empty  */
#line 8880 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= 0; }
#line 36692 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1302: /* opt_checksum_type: QUICK  */
#line 8881 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 36698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1303: /* opt_checksum_type: EXTENDED_SYM  */
#line 8882 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 36704 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1305: /* $@124: %empty  */
#line 8888 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1307: /* $@125: %empty  */
#line 8894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1308: /* repair: REPAIR opt_no_write_to_binlog $@125 repair_table_or_view  */
#line 8904 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1309: /* opt_mi_repair_type: %empty  */
#line 8914 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1310: /* opt_mi_repair_type: mi_repair_types  */
#line 8915 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 36748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1311: /* mi_repair_types: mi_repair_type  */
#line 8919 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 36754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1312: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 8920 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 36760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1313: /* mi_repair_type: QUICK  */
#line 8924 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 36766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1314: /* mi_repair_type: EXTENDED_SYM  */
#line 8925 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 36772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1315: /* mi_repair_type: USE_FRM  */
#line 8926 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 36778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1316: /* opt_view_repair_type: %empty  */
#line 8930 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 36784 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1317: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 8931 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 36790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1318: /* $@126: %empty  */
#line 8936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36804 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1319: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@126 analyze_table_list  */
#line 8946 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1323: /* opt_persistent_stat_clause: %empty  */
#line 8966 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1324: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 8968 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 36830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1325: /* persistent_stat_spec: ALL  */
#line 8975 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1326: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 8977 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1327: /* persistent_column_stat_spec: ALL  */
#line 8981 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1328: /* $@127: %empty  */
#line 8983 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1329: /* persistent_column_stat_spec: '(' $@127 table_column_list ')'  */
#line 8991 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1330: /* persistent_index_stat_spec: ALL  */
#line 8995 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1331: /* $@128: %empty  */
#line 8997 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1332: /* persistent_index_stat_spec: '(' $@128 table_index_list ')'  */
#line 9005 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1333: /* table_column_list: %empty  */
#line 9010 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1334: /* table_column_list: ident  */
#line 9012 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36903 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1335: /* table_column_list: table_column_list ',' ident  */
#line 9017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1336: /* table_index_list: %empty  */
#line 9025 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1339: /* table_index_name: ident  */
#line 9032 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1340: /* table_index_name: PRIMARY_SYM  */
#line 9039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1341: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36950 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1342: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1344: /* $@129: %empty  */
#line 9067 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1346: /* $@130: %empty  */
#line 9072 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36980 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1347: /* check: CHECK_SYM $@130 check_view_or_table  */
#line 9082 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1348: /* opt_mi_check_type: %empty  */
#line 9094 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 37000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1349: /* opt_mi_check_type: mi_check_types  */
#line 9095 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 37006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1350: /* mi_check_types: mi_check_type  */
#line 9099 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 37012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1351: /* mi_check_types: mi_check_type mi_check_types  */
#line 9100 "/home/buildbot/git/sql/sql_yacc.yy"
                                       {}
#line 37018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1352: /* mi_check_type: QUICK  */
#line 9104 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 37024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1353: /* mi_check_type: FAST_SYM  */
#line 9105 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 37030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1354: /* mi_check_type: MEDIUM_SYM  */
#line 9106 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 37036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1355: /* mi_check_type: EXTENDED_SYM  */
#line 9107 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 37042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1356: /* mi_check_type: CHANGED  */
#line 9108 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 37048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1357: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9109 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 37054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1358: /* opt_view_check_type: %empty  */
#line 9113 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 37060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1359: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9114 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 37066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1360: /* $@131: %empty  */
#line 9119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 37080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1361: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@131 table_list opt_lock_wait_timeout  */
#line 9129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 37092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1362: /* opt_no_write_to_binlog: %empty  */
#line 9139 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 37098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1363: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9140 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 37104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1364: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9141 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 1; }
#line 37110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1365: /* $@132: %empty  */
#line 9146 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37120 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1366: /* rename: RENAME table_or_tables $@132 table_to_table_list  */
#line 9152 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1367: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9156 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 37136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1368: /* rename_list: user TO_SYM user  */
#line 9163 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1369: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9169 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1372: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9183 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 37172 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1373: /* $@133: %empty  */
#line 9198 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.reset();
          }
#line 37180 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1374: /* keycache: CACHE_SYM INDEX_SYM $@133 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9202 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 37190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1379: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9221 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1380: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37214 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1381: /* key_cache_name: ident  */
#line 9242 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 37220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1382: /* key_cache_name: DEFAULT  */
#line 9243 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 37226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1383: /* $@134: %empty  */
#line 9248 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1384: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@134 preload_list_or_parts  */
#line 9256 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1389: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1390: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9284 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37270 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1391: /* $@135: %empty  */
#line 9295 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 37278 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1393: /* $@136: %empty  */
#line 9302 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Select->set_index_hint_type(INDEX_HINT_USE,
                                        INDEX_HINT_MASK_ALL);
          }
#line 37288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1395: /* cache_key_list_or_empty: %empty  */
#line 9311 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 37294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1397: /* opt_ignore_leaves: %empty  */
#line 9317 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 37300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1398: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9318 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 37306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1399: /* $@137: %empty  */
#line 9328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37317 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1400: /* select: query_expression_no_with_clause $@137 opt_procedure_or_into  */
#line 9335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1401: /* $@138: %empty  */
#line 9342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1402: /* select: with_clause query_expression_no_with_clause $@138 opt_procedure_or_into  */
#line 9349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1403: /* $@139: %empty  */
#line 9360 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37360 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1404: /* select_into: select_into_query_specification $@139 opt_order_limit_lock  */
#line 9365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1405: /* $@140: %empty  */
#line 9376 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1406: /* select_into: with_clause select_into_query_specification $@140 opt_order_limit_lock  */
#line 9381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1407: /* simple_table: query_specification  */
#line 9395 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37405 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1408: /* simple_table: table_value_constructor  */
#line 9396 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37411 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1409: /* $@141: %empty  */
#line 9401 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 37420 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1410: /* table_value_constructor: VALUES $@141 values_list  */
#line 9406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 37429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1411: /* $@142: %empty  */
#line 9414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 37443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1412: /* $@143: %empty  */
#line 9424 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 37451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1413: /* query_specification_start: SELECT_SYM $@142 select_options $@143 select_item_list  */
#line 9428 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 37459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1414: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9440 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1415: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1416: /* query_expression: query_expression_no_with_clause  */
#line 9511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1417: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9517 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1418: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9530 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1419: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9531 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1420: /* $@144: %empty  */
#line 9546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 37518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1421: /* query_expression_body_ext: query_expression_body $@144 opt_query_expression_tail  */
#line 9554 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 37529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1422: /* $@145: %empty  */
#line 9561 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 37538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1423: /* query_expression_body_ext: query_expression_body_ext_parens $@145 query_expression_tail  */
#line 9566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 37547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1424: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9574 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 37553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1425: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9576 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 37564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1426: /* query_expression_body: query_simple  */
#line 9591 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 37574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1427: /* $@146: %empty  */
#line 9598 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 37585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1428: /* query_expression_body: query_expression_body unit_type_decl $@146 query_primary  */
#line 9605 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                FALSE)))
              MYSQL_YYABORT;
          }
#line 37597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1429: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9615 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 37609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1430: /* query_primary: query_simple  */
#line 9631 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1431: /* query_primary: query_expression_body_ext_parens  */
#line 9633 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 37621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1432: /* query_simple: simple_table  */
#line 9642 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 37627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1433: /* subselect: query_expression  */
#line 9647 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1434: /* subquery: query_expression_body_ext_parens  */
#line 9688 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1435: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1439: /* table_reference_list: join_table_list  */
#line 9716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 37670 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1442: /* select_options: select_option_list  */
#line 9731 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 37680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1443: /* opt_history_unit: %empty  */
#line 9740 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 37688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1444: /* opt_history_unit: TRANSACTION_SYM  */
#line 9744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 37696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1445: /* opt_history_unit: TIMESTAMP  */
#line 9748 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 37704 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1446: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9755 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime.create_literal_item(thd,
                                                     (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                     YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 37717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1447: /* history_point: function_call_keyword_timestamp  */
#line 9764 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 37725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1448: /* history_point: opt_history_unit bit_expr  */
#line 9768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 37733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1449: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9776 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 37749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1450: /* opt_for_portion_of_time_clause: %empty  */
#line 9791 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1451: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9795 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1452: /* opt_for_system_time_clause: %empty  */
#line 9802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37773 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1453: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1454: /* system_time_expr: AS OF_SYM history_point  */
#line 9813 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 37789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1455: /* system_time_expr: ALL  */
#line 9817 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 37797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1456: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9821 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1457: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9825 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37813 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1461: /* select_option: SQL_NO_CACHE_SYM  */
#line 9838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 37826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1462: /* select_option: SQL_CACHE_SYM  */
#line 9847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 37839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1463: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1464: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9866 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1465: /* opt_select_lock_type: %empty  */
#line 9876 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37867 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1466: /* opt_select_lock_type: select_lock_type  */
#line 9880 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1467: /* opt_lock_wait_timeout_new: %empty  */
#line 9888 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1468: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 9892 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1469: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 9897 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1472: /* select_item_list: '*'  */
#line 9907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1473: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 9921 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1474: /* select_item: remember_name expr remember_end select_alias  */
#line 9926 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1475: /* remember_tok_start: %empty  */
#line 9947 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37956 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1476: /* remember_name: %empty  */
#line 9953 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1477: /* remember_end: %empty  */
#line 9959 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1478: /* select_alias: %empty  */
#line 9965 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1479: /* select_alias: AS ident  */
#line 9966 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1480: /* select_alias: AS TEXT_STRING_sys  */
#line 9967 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1481: /* select_alias: ident  */
#line 9968 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1482: /* select_alias: TEXT_STRING_sys  */
#line 9969 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 38002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1483: /* opt_default_time_precision: %empty  */
#line 9973 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 38008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1484: /* opt_default_time_precision: '(' ')'  */
#line 9974 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 38014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1485: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 9975 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 38020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1486: /* opt_time_precision: %empty  */
#line 9979 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 38026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1487: /* opt_time_precision: '(' ')'  */
#line 9980 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 38032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1488: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 9981 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 38038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1489: /* optional_braces: %empty  */
#line 9985 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 38044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1490: /* optional_braces: '(' ')'  */
#line 9986 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 38050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1491: /* expr: expr or expr  */
#line 9992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1492: /* expr: expr XOR expr  */
#line 10043 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1493: /* expr: expr and expr  */
#line 10050 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1494: /* expr: NOT_SYM expr  */
#line 10093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1496: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10103 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1497: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10109 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1498: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10115 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1499: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10121 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1500: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10127 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1501: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1502: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10139 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38243 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1503: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10145 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1504: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10151 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1505: /* boolean_test: boolean_test comp_op predicate  */
#line 10157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1506: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10163 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1508: /* predicate: predicate IN_SYM subquery  */
#line 10173 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1509: /* predicate: predicate not IN_SYM subquery  */
#line 10179 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1510: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10188 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1511: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1512: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10202 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38338 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1513: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10208 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1514: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1515: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10223 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1516: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10231 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1517: /* predicate: predicate LIKE predicate  */
#line 10241 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1518: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10247 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1519: /* predicate: predicate not LIKE predicate  */
#line 10254 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1520: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1521: /* predicate: predicate REGEXP predicate  */
#line 10269 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1522: /* predicate: predicate not REGEXP predicate  */
#line 10275 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1524: /* bit_expr: bit_expr '|' bit_expr  */
#line 10288 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38464 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1525: /* bit_expr: bit_expr '&' bit_expr  */
#line 10294 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38474 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1526: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1527: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10306 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1528: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10312 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1529: /* bit_expr: bit_expr '+' bit_expr  */
#line 10319 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1530: /* bit_expr: bit_expr '-' bit_expr  */
#line 10325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1531: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10331 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1532: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10337 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1533: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10344 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1534: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10350 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1535: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10356 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1536: /* bit_expr: bit_expr '*' bit_expr  */
#line 10362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1537: /* bit_expr: bit_expr '/' bit_expr  */
#line 10368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1538: /* bit_expr: bit_expr '%' bit_expr  */
#line 10374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1539: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10380 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1540: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1541: /* bit_expr: bit_expr '^' bit_expr  */
#line 10392 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38635 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1551: /* comp_op: '='  */
#line 10421 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 38641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1552: /* comp_op: GE  */
#line 10422 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 38647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1553: /* comp_op: '>'  */
#line 10423 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 38653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1554: /* comp_op: LE  */
#line 10424 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 38659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1555: /* comp_op: '<'  */
#line 10425 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 38665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1556: /* comp_op: NE  */
#line 10426 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 38671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1557: /* all_or_any: ALL  */
#line 10430 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 1; }
#line 38677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1558: /* all_or_any: ANY_SYM  */
#line 10431 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 0; }
#line 38683 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1559: /* opt_dyncol_type: %empty  */
#line 10436 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 38692 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1560: /* opt_dyncol_type: AS dyncol_type  */
#line 10440 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1561: /* dyncol_type: numeric_dyncol_type  */
#line 10444 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38704 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1562: /* dyncol_type: temporal_dyncol_type  */
#line 10445 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1563: /* dyncol_type: string_dyncol_type  */
#line 10446 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38716 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1564: /* numeric_dyncol_type: INT_SYM  */
#line 10450 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 38722 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1565: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10451 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 38728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1566: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10452 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 38734 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1567: /* numeric_dyncol_type: REAL  */
#line 10453 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1568: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10454 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1569: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10455 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 38752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1570: /* temporal_dyncol_type: DATE_SYM  */
#line 10459 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 38758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1571: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10460 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 38764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1572: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10461 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 38770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1573: /* $@147: %empty  */
#line 10466 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 38776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1574: /* string_dyncol_type: char $@147 opt_binary  */
#line 10468 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 38784 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1575: /* string_dyncol_type: nchar  */
#line 10472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 38793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1576: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10480 "/home/buildbot/git/sql/sql_yacc.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 38817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1577: /* dyncall_create_list: dyncall_create_element  */
#line 10503 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 38828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1578: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10510 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1579: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10518 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38843 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1580: /* plsql_cursor_attr: FOUND_SYM  */
#line 10519 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1581: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10520 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38855 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1582: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10521 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38861 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1583: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10526 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1584: /* trim_operands: expr  */
#line 10534 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1585: /* trim_operands: LEADING expr FROM expr  */
#line 10535 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1586: /* trim_operands: TRAILING expr FROM expr  */
#line 10536 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1587: /* trim_operands: BOTH expr FROM expr  */
#line 10537 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1588: /* trim_operands: LEADING FROM expr  */
#line 10538 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1589: /* trim_operands: TRAILING FROM expr  */
#line 10539 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1590: /* trim_operands: BOTH FROM expr  */
#line 10540 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1591: /* trim_operands: expr FROM expr  */
#line 10541 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1598: /* column_default_non_parenthesized_expr: param_marker  */
#line 10579 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1600: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1601: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10590 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1603: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10599 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38959 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1604: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1605: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10612 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1606: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38992 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1607: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10627 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 39001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1608: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10632 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1609: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1610: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10643 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 39029 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1611: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10648 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1612: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10654 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 39054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1613: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1614: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10672 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 39074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1615: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10677 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 39083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1616: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10682 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 39092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1617: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10687 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 39101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1618: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10692 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 39110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1619: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39119 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1620: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10702 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1623: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10711 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 39134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1624: /* primary_expr: subquery  */
#line 10713 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 39143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1626: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 39152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1628: /* simple_expr: BINARY simple_expr  */
#line 10731 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 39162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1629: /* simple_expr: '+' simple_expr  */
#line 10737 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1630: /* simple_expr: '-' simple_expr  */
#line 10741 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39180 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1631: /* simple_expr: '~' simple_expr  */
#line 10747 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1632: /* simple_expr: not2 simple_expr  */
#line 10753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1634: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10763 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39210 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1635: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10772 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1636: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10779 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1637: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1638: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10799 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1639: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10805 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1640: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10814 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1641: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1642: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10829 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1643: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10835 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1644: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10841 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39317 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1645: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1646: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1647: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 10873 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1648: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 10879 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1649: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 10885 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39381 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1650: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 10891 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1651: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 10897 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39401 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1652: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 10903 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39413 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1653: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 10911 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1654: /* function_call_keyword: function_call_keyword_timestamp  */
#line 10918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1655: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 10922 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 39442 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1656: /* function_call_keyword: USER_SYM '(' ')'  */
#line 10928 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 39454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1657: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 10936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39464 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1658: /* substring_operands: expr ',' expr ',' expr  */
#line 10945 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1659: /* substring_operands: expr ',' expr  */
#line 10949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1660: /* substring_operands: expr FROM expr FOR_SYM expr  */
#line 10953 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1661: /* substring_operands: expr FROM expr  */
#line 10957 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39496 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1662: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 10977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39507 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1663: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 10984 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1664: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 10990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1665: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 10997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1666: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11004 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1667: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11010 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39559 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1668: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11016 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1669: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1670: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11028 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1671: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11034 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1672: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11040 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1673: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11047 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1674: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11053 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1675: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11060 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1676: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11066 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 39651 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1677: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11072 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1678: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11090 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39683 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1679: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1680: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 39702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1681: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11107 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1682: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11114 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1683: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11121 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1684: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1685: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11136 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1686: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11143 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1687: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11150 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1688: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1689: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11174 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1690: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11180 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1691: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1692: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11192 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1693: /* function_call_conflict: DATABASE '(' ')'  */
#line 11198 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1694: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1695: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11211 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1696: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1697: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1698: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11237 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1699: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11244 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1700: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11250 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39915 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1701: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11256 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39926 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1702: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11263 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39938 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1703: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11271 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1704: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11277 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1705: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11283 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39968 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1706: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11289 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1707: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11295 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1708: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11303 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1709: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1710: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11315 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1711: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11321 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1712: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11327 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1713: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1714: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1715: /* function_call_conflict: geometry_function  */
#line 11354 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 40085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1716: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11369 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 40095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1717: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 40106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1718: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11382 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 40117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1719: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 40128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1720: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 40139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1721: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11403 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 40150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1722: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11410 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 40158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1723: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 40169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1724: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 40178 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1725: /* @148: %empty  */
#line 11438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 40201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1726: /* function_call_generic: IDENT_sys '(' @148 opt_udf_expr_list ')'  */
#line 11457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= native_functions_hash.find(thd, (yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 40254 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1727: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11506 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1728: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1729: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11519 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 40278 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1730: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11521 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= FT_BOOL; }
#line 40284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1731: /* opt_natural_language_mode: %empty  */
#line 11525 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40290 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1732: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11526 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1733: /* opt_query_expansion: %empty  */
#line 11530 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= 0;         }
#line 40302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1734: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11531 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 40308 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1735: /* opt_udf_expr_list: %empty  */
#line 11535 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= NULL; }
#line 40314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1736: /* opt_udf_expr_list: udf_expr_list  */
#line 11536 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1737: /* udf_expr_list: udf_expr  */
#line 11541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 40331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1738: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11548 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1739: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11556 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 40368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1740: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11583 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1741: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11589 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1742: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11595 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40398 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1743: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1744: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11607 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1745: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1746: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11622 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1747: /* $@149: %empty  */
#line 11628 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1748: /* $@150: %empty  */
#line 11630 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr--; }
#line 40453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1749: /* sum_expr: COUNT_SYM '(' DISTINCT $@149 expr_list $@150 ')'  */
#line 11632 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40463 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1750: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40473 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1751: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11649 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1752: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40493 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1753: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1754: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11667 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1755: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11673 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1756: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11679 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1757: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11685 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1758: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1759: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1760: /* $@151: %empty  */
#line 11703 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1761: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@151 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11707 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 40591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1762: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11728 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1763: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11737 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1766: /* window_func: function_call_generic  */
#line 11759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1767: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1768: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11781 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1769: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11788 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1770: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11795 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1771: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1772: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1773: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11816 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1774: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1775: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1776: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 11837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1777: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 11848 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1778: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 11855 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1779: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 11866 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1780: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 11878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1781: /* $@152: %empty  */
#line 11896 "/home/buildbot/git/sql/sql_yacc.yy"
           { Select->prepare_add_window_spec(thd); }
#line 40801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1782: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@152 order_by_single_element_list ')'  */
#line 11898 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 40809 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1783: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 11902 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1784: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 11919 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1785: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 11925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1786: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 11934 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1787: /* window_name: ident  */
#line 11943 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1788: /* $@153: %empty  */
#line 11952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1789: /* variable: '@' $@153 variable_aux  */
#line 11957 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1790: /* variable_aux: ident_or_text SET_VAR expr  */
#line 11964 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1791: /* variable_aux: ident_or_text  */
#line 11974 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1792: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 11982 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1793: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 11987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1794: /* opt_distinct: %empty  */
#line 11994 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1795: /* opt_distinct: DISTINCT  */
#line 11995 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 1; }
#line 40939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1796: /* opt_gconcat_separator: %empty  */
#line 12000 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1797: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12005 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1800: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12015 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1801: /* gorder_list: order_ident order_dir  */
#line 12020 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40973 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1802: /* opt_glimit_clause: %empty  */
#line 12027 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1803: /* opt_glimit_clause: glimit_clause  */
#line 12028 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num) = 1; }
#line 40985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1804: /* glimit_clause_init: LIMIT  */
#line 12032 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 40991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1805: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1806: /* glimit_options: limit_option  */
#line 12044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 41010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1807: /* glimit_options: limit_option ',' limit_option  */
#line 12051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 41021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1808: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12058 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 41032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1809: /* $@154: %empty  */
#line 12070 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1810: /* in_sum_expr: opt_all $@154 expr  */
#line 12079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 41054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1811: /* cast_type: BINARY opt_field_length  */
#line 12087 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 41060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1812: /* $@155: %empty  */
#line 12089 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1813: /* cast_type: CHAR_SYM opt_field_length $@155 opt_binary  */
#line 12091 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1814: /* $@156: %empty  */
#line 12093 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1815: /* cast_type: VARCHAR field_length $@156 opt_binary  */
#line 12095 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1816: /* $@157: %empty  */
#line 12097 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1817: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@157 opt_binary  */
#line 12099 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1818: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12101 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 41105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1819: /* cast_type: cast_type_numeric  */
#line 12105 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1820: /* cast_type: cast_type_temporal  */
#line 12106 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1821: /* cast_type_numeric: INT_SYM  */
#line 12110 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1822: /* cast_type_numeric: SIGNED_SYM  */
#line 12111 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1823: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12112 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1824: /* cast_type_numeric: UNSIGNED  */
#line 12113 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1825: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12114 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1826: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12115 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 41153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1827: /* cast_type_numeric: FLOAT_SYM  */
#line 12116 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 41159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1828: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12117 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 41165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1829: /* cast_type_temporal: DATE_SYM  */
#line 12121 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 41171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1830: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12122 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 41177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1831: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12123 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 41183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1832: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12125 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 41191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1833: /* opt_expr_list: %empty  */
#line 12131 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item_list)= NULL; }
#line 41197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1834: /* opt_expr_list: expr_list  */
#line 12132 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 41203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1835: /* expr_list: expr  */
#line 12137 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 41212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1836: /* expr_list: expr_list ',' expr  */
#line 12142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1837: /* ident_list_arg: ident_list  */
#line 12149 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 41227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1838: /* ident_list_arg: '(' ident_list ')'  */
#line 12150 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 41233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1839: /* ident_list: simple_ident  */
#line 12155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1840: /* ident_list: ident_list ',' simple_ident  */
#line 12162 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1841: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12170 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41266 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1842: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12179 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 41277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1844: /* when_list_opt_else: when_list ELSE expr  */
#line 12190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1845: /* table_ref: table_factor  */
#line 12200 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1846: /* table_ref: join_table  */
#line 12202 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1847: /* join_table_list: derived_table_list  */
#line 12213 "/home/buildbot/git/sql/sql_yacc.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 41312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1848: /* esc_table_ref: table_ref  */
#line 12224 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 41318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1849: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12225 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 41324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1850: /* derived_table_list: esc_table_ref  */
#line 12232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1851: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12237 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1852: /* join_table: table_ref normal_join table_ref  */
#line 12251 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 41352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1853: /* $@158: %empty  */
#line 12258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1854: /* join_table: table_ref normal_join table_ref ON $@158 expr  */
#line 12268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1855: /* $@159: %empty  */
#line 12276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 41387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1856: /* join_table: table_ref normal_join table_ref USING $@159 '(' using_list ')'  */
#line 12282 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1857: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12288 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 41409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1858: /* $@160: %empty  */
#line 12299 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1859: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@160 expr  */
#line 12309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 41435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1860: /* $@161: %empty  */
#line 12317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1861: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@161 USING '(' using_list ')'  */
#line 12323 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41455 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1862: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12329 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 41468 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1863: /* $@162: %empty  */
#line 12341 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41482 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1864: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@162 expr  */
#line 12351 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1865: /* $@163: %empty  */
#line 12360 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1866: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@163 USING '(' using_list ')'  */
#line 12366 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 41516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1867: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12373 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 41530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1868: /* inner_join: JOIN_SYM  */
#line 12386 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41536 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1869: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12387 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1870: /* inner_join: STRAIGHT_JOIN  */
#line 12388 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 1; }
#line 41548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1871: /* normal_join: inner_join  */
#line 12392 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 41554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1872: /* normal_join: CROSS JOIN_SYM  */
#line 12393 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1873: /* opt_use_partition: %empty  */
#line 12401 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.string_list)= 0;}
#line 41566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1875: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12407 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 41576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1876: /* table_factor: table_primary_ident_opt_parens  */
#line 12415 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1877: /* table_factor: table_primary_derived_opt_parens  */
#line 12416 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1878: /* table_factor: join_table_parens  */
#line 12418 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 41597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1879: /* table_factor: table_reference_list_parens  */
#line 12422 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1880: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12426 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1881: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12427 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1882: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12431 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1883: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12432 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1884: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12436 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1885: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 41642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1886: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12446 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 41654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1887: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12454 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 41663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1888: /* join_table_parens: '(' join_table_parens ')'  */
#line 12461 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1889: /* join_table_parens: '(' join_table ')'  */
#line 12463 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1890: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12477 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 41700 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1891: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12495 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 41709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1892: /* opt_outer: %empty  */
#line 12502 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 41715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1893: /* opt_outer: OUTER  */
#line 12503 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 41721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1894: /* index_hint_clause: %empty  */
#line 12508 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 41729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1895: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12511 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 41735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1896: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12512 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 41741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1897: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12513 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 41747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1898: /* index_hint_type: FORCE_SYM  */
#line 12517 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 41753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1899: /* index_hint_type: IGNORE_SYM  */
#line 12518 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 41759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1900: /* $@164: %empty  */
#line 12523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 41767 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1902: /* $@165: %empty  */
#line 12528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 41775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1907: /* $@166: %empty  */
#line 12541 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->alloc_index_hints(thd); }
#line 41781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1909: /* $@167: %empty  */
#line 12545 "/home/buildbot/git/sql/sql_yacc.yy"
          {  Select->clear_index_hints(); }
#line 41787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1911: /* opt_key_usage_list: %empty  */
#line 12550 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 41793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1912: /* opt_key_usage_list: key_usage_list  */
#line 12551 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 41799 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1913: /* key_usage_element: ident  */
#line 12556 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 41805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1914: /* key_usage_element: PRIMARY_SYM  */
#line 12558 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 41811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1917: /* using_list: ident  */
#line 12568 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 41826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1918: /* using_list: using_list ',' ident  */
#line 12579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1919: /* interval: interval_time_stamp  */
#line 12592 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 41847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1920: /* interval: DAY_HOUR_SYM  */
#line 12593 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1921: /* interval: DAY_MICROSECOND_SYM  */
#line 12594 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1922: /* interval: DAY_MINUTE_SYM  */
#line 12595 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1923: /* interval: DAY_SECOND_SYM  */
#line 12596 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1924: /* interval: HOUR_MICROSECOND_SYM  */
#line 12597 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1925: /* interval: HOUR_MINUTE_SYM  */
#line 12598 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1926: /* interval: HOUR_SECOND_SYM  */
#line 12599 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1927: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12600 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1928: /* interval: MINUTE_SECOND_SYM  */
#line 12601 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1929: /* interval: SECOND_MICROSECOND_SYM  */
#line 12602 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1930: /* interval: YEAR_MONTH_SYM  */
#line 12603 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1931: /* interval_time_stamp: DAY_SYM  */
#line 12607 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1932: /* interval_time_stamp: WEEK_SYM  */
#line 12608 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1933: /* interval_time_stamp: HOUR_SYM  */
#line 12609 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1934: /* interval_time_stamp: MINUTE_SYM  */
#line 12610 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1935: /* interval_time_stamp: MONTH_SYM  */
#line 12611 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1936: /* interval_time_stamp: QUARTER_SYM  */
#line 12612 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1937: /* interval_time_stamp: SECOND_SYM  */
#line 12613 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1938: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12614 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1939: /* interval_time_stamp: YEAR_SYM  */
#line 12615 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1940: /* date_time_type: DATE_SYM  */
#line 12619 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41973 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1941: /* date_time_type: TIME_SYM  */
#line 12620 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1942: /* date_time_type: DATETIME  */
#line 12621 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1943: /* date_time_type: TIMESTAMP  */
#line 12622 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1947: /* opt_table_alias_clause: %empty  */
#line 12632 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1948: /* opt_table_alias_clause: table_alias_clause  */
#line 12633 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 42003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1949: /* table_alias_clause: table_alias ident_table_alias  */
#line 12638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 42013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1952: /* opt_where_clause: %empty  */
#line 12651 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->where= 0; }
#line 42019 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1953: /* $@168: %empty  */
#line 12653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 42027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1954: /* opt_where_clause: WHERE $@168 expr  */
#line 12657 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 42039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1956: /* $@169: %empty  */
#line 12669 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 42047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1957: /* opt_having_clause: HAVING $@169 expr  */
#line 12673 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 42059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1960: /* group_list: group_list ',' order_ident order_dir  */
#line 12693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 42068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1961: /* group_list: order_ident order_dir  */
#line 12698 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 42077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1962: /* olap_opt: %empty  */
#line 12705 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1963: /* olap_opt: WITH_CUBE_SYM  */
#line 12707 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 42104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1964: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12724 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 42123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1965: /* opt_window_clause: %empty  */
#line 12746 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1966: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12749 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1969: /* window_def: window_name AS window_spec  */
#line 12759 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 42148 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1970: /* $@170: %empty  */
#line 12771 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->prepare_add_window_spec(thd); }
#line 42154 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1971: /* window_spec: '(' $@170 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12775 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 42160 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1972: /* opt_window_ref: %empty  */
#line 12779 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42166 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1973: /* opt_window_ref: ident  */
#line 12781 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 42176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1974: /* opt_window_partition_clause: %empty  */
#line 12789 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1976: /* opt_window_order_clause: %empty  */
#line 12794 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1977: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12795 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 42194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1978: /* opt_window_frame_clause: %empty  */
#line 12799 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1979: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12801 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 42215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1980: /* window_frame_units: ROWS_SYM  */
#line 12814 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 42221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1981: /* window_frame_units: RANGE_SYM  */
#line 12815 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 42227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1982: /* window_frame_extent: window_frame_start  */
#line 12820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 42241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1983: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 42251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1984: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 12839 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42262 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1985: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 12846 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1986: /* window_frame_start: literal PRECEDING_SYM  */
#line 12853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1987: /* window_frame_bound: window_frame_start  */
#line 12862 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 42290 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1988: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 12864 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1989: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 12871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1990: /* opt_window_frame_exclusion: %empty  */
#line 12880 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1991: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 12882 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 42324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1992: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 12884 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 42330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1993: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 12886 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 42336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1994: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 12888 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1995: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 12890 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42348 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1999: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 12908 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 42358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2000: /* opt_order_clause: %empty  */
#line 12921 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= NULL; }
#line 42364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2001: /* opt_order_clause: order_clause  */
#line 12923 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 42370 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2002: /* $@171: %empty  */
#line 12928 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->where= "ORDER clause";
          }
#line 42378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2003: /* order_clause: ORDER_SYM BY $@171 order_list  */
#line 12932 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 42386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2004: /* order_list: order_list ',' order_ident order_dir  */
#line 12939 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2005: /* order_list: order_ident order_dir  */
#line 12945 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2006: /* order_dir: %empty  */
#line 12953 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) =  1; }
#line 42412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2007: /* order_dir: ASC  */
#line 12954 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =1; }
#line 42418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2008: /* order_dir: DESC  */
#line 12955 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =0; }
#line 42424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2009: /* opt_limit_clause: %empty  */
#line 12960 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit).empty(); }
#line 42430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2010: /* opt_limit_clause: limit_clause  */
#line 12962 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 42436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2011: /* limit_clause: LIMIT limit_options  */
#line 12967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2012: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 12975 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42456 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2013: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 12980 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 0;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2014: /* opt_global_limit_clause: opt_limit_clause  */
#line 12990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 42477 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2015: /* limit_options: limit_option  */
#line 12999 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2016: /* limit_options: limit_option ',' limit_option  */
#line 13005 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2017: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42507 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2018: /* limit_option: ident_cli  */
#line 13020 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2019: /* limit_option: ident_cli '.' ident_cli  */
#line 13025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2020: /* limit_option: param_marker  */
#line 13030 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 42533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2021: /* limit_option: ULONGLONG_NUM  */
#line 13034 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2022: /* limit_option: LONG_NUM  */
#line 13040 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2023: /* limit_option: NUM  */
#line 13046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2024: /* limit_rows_option: limit_option  */
#line 13055 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 42572 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2025: /* delete_limit_clause: %empty  */
#line 13063 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 42581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2026: /* delete_limit_clause: LIMIT limit_option  */
#line 13068 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 42592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2027: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13074 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 42598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2028: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13075 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 42604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2029: /* order_limit_lock: order_or_limit  */
#line 13080 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 42613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2030: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2031: /* order_limit_lock: select_lock_type  */
#line 13090 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42635 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2032: /* opt_order_limit_lock: %empty  */
#line 13102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 42644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2033: /* opt_order_limit_lock: order_limit_lock  */
#line 13106 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 42650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2036: /* opt_procedure_or_into: %empty  */
#line 13119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock).empty();
          }
#line 42658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2037: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13123 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2038: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13127 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2039: /* order_or_limit: order_clause opt_limit_clause  */
#line 13140 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42692 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2040: /* order_or_limit: limit_clause  */
#line 13148 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2043: /* int_num: opt_plus NUM  */
#line 13166 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2044: /* int_num: '-' NUM  */
#line 13167 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2045: /* ulong_num: opt_plus NUM  */
#line 13171 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2046: /* ulong_num: HEX_NUM  */
#line 13172 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2047: /* ulong_num: opt_plus LONG_NUM  */
#line 13173 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2048: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13174 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2049: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13175 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2050: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13176 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2051: /* real_ulong_num: NUM  */
#line 13180 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2052: /* real_ulong_num: HEX_NUM  */
#line 13181 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2053: /* real_ulong_num: LONG_NUM  */
#line 13182 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2054: /* real_ulong_num: ULONGLONG_NUM  */
#line 13183 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2055: /* real_ulong_num: dec_num_error  */
#line 13184 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42784 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2056: /* longlong_num: opt_plus NUM  */
#line 13188 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2057: /* longlong_num: LONG_NUM  */
#line 13189 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42796 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2058: /* longlong_num: '-' NUM  */
#line 13190 "/home/buildbot/git/sql/sql_yacc.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2059: /* longlong_num: '-' LONG_NUM  */
#line 13191 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2060: /* ulonglong_num: opt_plus NUM  */
#line 13195 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42814 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2061: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13196 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42820 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2062: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13197 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2063: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13198 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42832 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2064: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13199 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2065: /* real_ulonglong_num: NUM  */
#line 13203 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2066: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13204 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2067: /* real_ulonglong_num: HEX_NUM  */
#line 13205 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2068: /* real_ulonglong_num: LONG_NUM  */
#line 13206 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2069: /* real_ulonglong_num: dec_num_error  */
#line 13207 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2070: /* dec_num_error: dec_num  */
#line 13212 "/home/buildbot/git/sql/sql_yacc.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2073: /* choice: ulong_num  */
#line 13221 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2074: /* choice: DEFAULT  */
#line 13222 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2075: /* bool: ulong_num  */
#line 13226 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2076: /* bool: TRUE_SYM  */
#line 13227 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1; }
#line 42898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2077: /* bool: FALSE_SYM  */
#line 13228 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 42904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2078: /* $@172: %empty  */
#line 13233 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2079: /* procedure_clause: PROCEDURE_SYM ident $@172 '(' procedure_list ')'  */
#line 13257 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2080: /* procedure_list: %empty  */
#line 13264 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42947 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2081: /* procedure_list: procedure_list2  */
#line 13265 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 42953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2084: /* procedure_item: remember_name expr remember_end  */
#line 13275 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2085: /* $@173: %empty  */
#line 13284 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2086: /* select_var_list_init: $@173 select_var_list  */
#line 13292 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2088: /* select_var_list: select_var_ident  */
#line 13297 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 42988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2089: /* select_var_ident: select_outvar  */
#line 13301 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 43009 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2090: /* select_outvar: '@' ident_or_text  */
#line 13321 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 43017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2091: /* select_outvar: ident_or_text  */
#line 13325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 43026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2092: /* select_outvar: ident '.' ident  */
#line 13330 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 43035 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2093: /* into: INTO into_destination  */
#line 13338 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2094: /* $@174: %empty  */
#line 13343 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 43056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2095: /* $@175: %empty  */
#line 13354 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 43062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2097: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13357 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 43081 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2098: /* into_destination: select_var_list_init  */
#line 13372 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 43089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2099: /* $@176: %empty  */
#line 13383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 43101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2100: /* do: DO_SYM $@176 expr_list  */
#line 13391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43112 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2101: /* $@177: %empty  */
#line 13405 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2102: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@177 table_list opt_lock_wait_timeout opt_restrict  */
#line 13412 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2103: /* $@178: %empty  */
#line 13414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 43138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2104: /* drop: DROP INDEX_SYM $@178 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 43160 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2105: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13437 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 43170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2106: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2107: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2108: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2109: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 43227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2110: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13484 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 43235 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2111: /* $@179: %empty  */
#line 13488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2112: /* drop: DROP VIEW_SYM opt_if_exists $@179 table_list opt_restrict  */
#line 13495 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2113: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 43261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2114: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13502 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2115: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13508 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 43280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2116: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13513 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 43289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2117: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 43298 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2118: /* $@180: %empty  */
#line 13524 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2119: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@180 table_list  */
#line 13532 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2122: /* table_name: table_ident  */
#line 13542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 43329 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2123: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13554 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 43343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2126: /* table_alias_ref: table_ident_opt_wild  */
#line 13572 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43357 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2127: /* opt_if_exists_table_element: %empty  */
#line 13585 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 43366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2128: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13590 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 43375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2129: /* opt_if_exists: %empty  */
#line 13598 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 43383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2130: /* opt_if_exists: IF_SYM EXISTS  */
#line 13602 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 43391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2131: /* opt_temporary: %empty  */
#line 13608 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 43397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2132: /* opt_temporary: TEMPORARY  */
#line 13609 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 43403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2133: /* $@181: %empty  */
#line 13617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2134: /* $@182: %empty  */
#line 13629 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2135: /* insert: INSERT $@181 insert_lock_option opt_ignore insert2 $@182 insert_field_spec opt_insert_update  */
#line 13634 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43438 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2136: /* $@183: %empty  */
#line 13644 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2137: /* $@184: %empty  */
#line 13655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2138: /* replace: REPLACE $@183 replace_lock_option insert2 $@184 insert_field_spec  */
#line 13660 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43473 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2139: /* insert_lock_option: %empty  */
#line 13670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 43486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2140: /* insert_lock_option: LOW_PRIORITY  */
#line 13678 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2141: /* insert_lock_option: DELAYED_SYM  */
#line 13680 "/home/buildbot/git/sql/sql_yacc.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2142: /* insert_lock_option: HIGH_PRIORITY  */
#line 13686 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 43509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2143: /* replace_lock_option: opt_low_priority  */
#line 13690 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 43515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2144: /* replace_lock_option: DELAYED_SYM  */
#line 13692 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2145: /* insert2: INTO insert_table  */
#line 13700 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 43531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2146: /* insert2: insert_table  */
#line 13701 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 43537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2147: /* $@185: %empty  */
#line 13705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 43545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2148: /* insert_table: $@185 table_name_with_opt_use_partition  */
#line 13709 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 43556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2149: /* insert_field_spec: insert_values  */
#line 13718 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 43562 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2150: /* insert_field_spec: insert_field_list insert_values  */
#line 13719 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2151: /* $@186: %empty  */
#line 13721 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 43581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2153: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 43589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2156: /* fields: fields ',' insert_ident  */
#line 13746 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2157: /* fields: insert_ident  */
#line 13747 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2158: /* insert_values: create_select_query_expression  */
#line 13753 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 43607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2163: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2164: /* equal: '='  */
#line 13777 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 43624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2165: /* equal: SET_VAR  */
#line 13778 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 43630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2166: /* opt_equal: %empty  */
#line 13782 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2167: /* opt_equal: equal  */
#line 13783 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 43642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2168: /* opt_with: opt_equal  */
#line 13787 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2169: /* opt_with: WITH  */
#line 13788 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 43654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2170: /* opt_by: opt_equal  */
#line 13792 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2171: /* opt_by: BY  */
#line 13793 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 43666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2172: /* $@187: %empty  */
#line 13798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2173: /* no_braces: '(' $@187 opt_values ')'  */
#line 13803 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2174: /* $@188: %empty  */
#line 13813 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2175: /* no_braces_with_names: '(' $@188 opt_values_with_names ')'  */
#line 13818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2176: /* opt_values: %empty  */
#line 13827 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2178: /* opt_values_with_names: %empty  */
#line 13832 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2180: /* values: values ',' expr_or_ignore_or_default  */
#line 13838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2181: /* values: expr_or_ignore_or_default  */
#line 13843 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2182: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 13851 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 43748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2183: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 13859 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 43760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2184: /* expr_or_ignore: expr  */
#line 13869 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 43766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2185: /* expr_or_ignore: IGNORE_SYM  */
#line 13871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2186: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 13879 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 43782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2187: /* expr_or_ignore_or_default: DEFAULT  */
#line 13881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2189: /* $@189: %empty  */
#line 13890 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 43798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2190: /* $@190: %empty  */
#line 13892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 43806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2191: /* opt_insert_update: ON DUPLICATE_SYM $@189 KEY_SYM UPDATE_SYM $@190 insert_update_list  */
#line 13896 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43814 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2192: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 13904 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2193: /* update_table_list: join_table_list  */
#line 13916 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2194: /* $@191: %empty  */
#line 13923 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2195: /* $@192: %empty  */
#line 13933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43873 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2196: /* update: UPDATE_SYM $@191 opt_low_priority opt_ignore update_table_list SET update_list $@192 opt_where_clause opt_order_clause delete_limit_clause  */
#line 13952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43885 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2199: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 13968 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2200: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 13975 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2203: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13988 "/home/buildbot/git/sql/sql_yacc.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2204: /* opt_low_priority: %empty  */
#line 13997 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2205: /* opt_low_priority: LOW_PRIORITY  */
#line 13998 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2206: /* $@193: %empty  */
#line 14005 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2207: /* delete: DELETE_SYM $@193 delete_part2  */
#line 14017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2208: /* opt_delete_system_time: %empty  */
#line 14025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_HISTORY);
          }
#line 43961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2209: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14029 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2210: /* delete_part2: opt_delete_options single_multi  */
#line 14035 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2211: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43986 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2212: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14047 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2213: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14062 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
        }
#line 44011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2214: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2215: /* $@194: %empty  */
#line 14082 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2216: /* single_multi: table_wild_list $@194 FROM join_table_list opt_where_clause  */
#line 14088 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2217: /* $@195: %empty  */
#line 14096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44055 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2218: /* single_multi: FROM table_alias_ref_list $@195 USING join_table_list opt_where_clause  */
#line 14102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2223: /* table_wild_one: ident opt_wild  */
#line 14123 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2224: /* table_wild_one: ident '.' ident opt_wild  */
#line 14138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2225: /* opt_wild: %empty  */
#line 14155 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2226: /* opt_wild: '.' '*'  */
#line 14156 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 44117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2227: /* opt_delete_options: %empty  */
#line 14160 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2228: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14161 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 44129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2229: /* opt_delete_option: QUICK  */
#line 14165 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->options|= OPTION_QUICK; }
#line 44135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2230: /* opt_delete_option: LOW_PRIORITY  */
#line 14166 "/home/buildbot/git/sql/sql_yacc.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 44141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2231: /* opt_delete_option: IGNORE_SYM  */
#line 14167 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->ignore= 1; }
#line 44147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2232: /* $@196: %empty  */
#line 14172 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 44162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2233: /* truncate: TRUNCATE_SYM $@196 opt_table_sym table_name opt_lock_wait_timeout  */
#line 14183 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 44174 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2240: /* profile_def: CPU_SYM  */
#line 14207 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 44182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2241: /* profile_def: MEMORY_SYM  */
#line 14211 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 44190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2242: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14215 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 44198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2243: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14219 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 44206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2244: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14223 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 44214 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2245: /* profile_def: IPC_SYM  */
#line 14227 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 44222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2246: /* profile_def: SWAPS_SYM  */
#line 14231 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 44230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2247: /* profile_def: SOURCE_SYM  */
#line 14235 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 44238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2248: /* profile_def: ALL  */
#line 14239 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 44246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2249: /* opt_profile_args: %empty  */
#line 14246 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 44254 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2250: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14250 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 44262 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2251: /* $@197: %empty  */
#line 14259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 44277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2252: /* show: SHOW $@197 show_param  */
#line 14270 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44286 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2253: /* show_param: DATABASES wild_and_where  */
#line 14278 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 44297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2254: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14285 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 44309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2255: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14293 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 44321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2256: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14301 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 44333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2257: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14309 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 44345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2258: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 44357 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2259: /* show_param: PLUGINS_SYM  */
#line 14325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2260: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14332 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2261: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14339 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44389 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2262: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14345 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 44395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2263: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14347 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= NULL; }
#line 44401 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2264: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2265: /* show_param: master_or_binary LOGS_SYM  */
#line 14358 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 44422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2266: /* show_param: SLAVE HOSTS_SYM  */
#line 14362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 44430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2267: /* $@198: %empty  */
#line 14366 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 44439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2269: /* $@199: %empty  */
#line 14372 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 44448 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2271: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14378 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 44461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2272: /* show_param: opt_storage ENGINES_SYM  */
#line 14387 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 44472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2273: /* show_param: AUTHORS_SYM  */
#line 14394 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 44481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2274: /* show_param: CONTRIBUTORS_SYM  */
#line 14399 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 44490 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2275: /* show_param: PRIVILEGES  */
#line 14404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 44499 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2276: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14409 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2277: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2278: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14419 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 44523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2279: /* show_param: ERRORS opt_global_limit_clause  */
#line 14421 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 44529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2280: /* show_param: PROFILES_SYM  */
#line 14423 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 44535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2281: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14425 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 44546 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2282: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14432 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 44558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2283: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14440 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 44564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2284: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 44576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2285: /* show_param: charset wild_and_where  */
#line 14450 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 44587 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2286: /* show_param: COLLATION_SYM wild_and_where  */
#line 14457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 44598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2287: /* show_param: GRANTS  */
#line 14464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 44610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2288: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 44620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2289: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 44629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2290: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14483 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 44641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2291: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 44653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2292: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14499 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 44665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2293: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14507 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 44673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2294: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 44682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2295: /* show_param: SLAVE STATUS_SYM  */
#line 14516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 44693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2296: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 44702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2297: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2298: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14535 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2299: /* show_param: CREATE PACKAGE_MARIADB_SYM sp_name  */
#line 14542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 44734 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2300: /* show_param: CREATE PACKAGE_MARIADB_SYM BODY_MARIADB_SYM sp_name  */
#line 14548 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 44744 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2301: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14554 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 44754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2302: /* show_param: CREATE USER_SYM  */
#line 14560 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 44766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2303: /* show_param: CREATE USER_SYM user  */
#line 14568 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 44775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2304: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44786 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2305: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14580 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2306: /* show_param: PACKAGE_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14587 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2307: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14594 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44819 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2308: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2309: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2310: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM CODE_SYM sp_name  */
#line 14611 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2311: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44855 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2312: /* show_param: describe_command FOR_SYM expr  */
#line 14621 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2313: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14628 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2314: /* show_engine_param: STATUS_SYM  */
#line 14650 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2315: /* show_engine_param: MUTEX_SYM  */
#line 14652 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2316: /* show_engine_param: LOGS_SYM  */
#line 14654 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2321: /* opt_db: %empty  */
#line 14668 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2322: /* opt_db: from_or_in ident  */
#line 14669 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2323: /* opt_full: %empty  */
#line 14673 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=0; }
#line 44925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2324: /* opt_full: FULL  */
#line 14674 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=1; }
#line 44931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2327: /* binlog_in: %empty  */
#line 14683 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2328: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14684 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2329: /* binlog_from: %empty  */
#line 14688 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2330: /* binlog_from: FROM ulonglong_num  */
#line 14689 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2331: /* wild_and_where: %empty  */
#line 14693 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.simple_string)= 0; }
#line 44961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2332: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14695 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44973 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2333: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14703 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2334: /* $@200: %empty  */
#line 14714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 45001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2335: /* describe: describe_command table_ident $@200 opt_describe_column  */
#line 14727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 45010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2336: /* $@201: %empty  */
#line 14732 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 45016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2337: /* describe: describe_command opt_extended_describe $@201 explainable_command  */
#line 14734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 45025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2346: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14756 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 45033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2347: /* opt_extended_describe: EXTENDED_SYM  */
#line 14762 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 45039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2348: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14764 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 45045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2349: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14765 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 45051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2350: /* opt_extended_describe: opt_format_json  */
#line 14766 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 45057 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2351: /* opt_format_json: %empty  */
#line 14770 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2352: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14772 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 45077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2353: /* opt_describe_column: %empty  */
#line 14784 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2354: /* opt_describe_column: text_string  */
#line 14785 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 45089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2355: /* opt_describe_column: ident  */
#line 14787 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 45101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2356: /* $@202: %empty  */
#line 14801 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 45112 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2357: /* flush: FLUSH_SYM opt_no_write_to_binlog $@202 flush_options  */
#line 14807 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45118 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2358: /* $@203: %empty  */
#line 14812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 45132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2359: /* flush_options: table_or_tables $@203 opt_table_list opt_flush_lock  */
#line 14822 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2360: /* flush_options: flush_options_list  */
#line 14824 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45144 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2361: /* opt_flush_lock: %empty  */
#line 14828 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2362: /* opt_flush_lock: flush_lock  */
#line 14830 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 45166 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2363: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 14845 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 45172 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2364: /* $@204: %empty  */
#line 14847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 45186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2365: /* flush_lock: FOR_SYM $@204 EXPORT_SYM  */
#line 14855 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45192 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2367: /* flush_options_list: flush_option  */
#line 14861 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2368: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 14866 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 45204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2369: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 14868 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 45210 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2370: /* flush_option: GENERAL LOGS_SYM  */
#line 14870 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 45216 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2371: /* flush_option: SLOW LOGS_SYM  */
#line 14872 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 45222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2372: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 14874 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 45228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2373: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 14876 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 45240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2374: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 14884 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 45246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2375: /* flush_option: HOSTS_SYM  */
#line 14886 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 45252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2376: /* flush_option: PRIVILEGES  */
#line 14888 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 45258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2377: /* flush_option: LOGS_SYM  */
#line 14890 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 45267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2378: /* flush_option: STATUS_SYM  */
#line 14895 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 45273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2379: /* flush_option: SLAVE optional_connection_name  */
#line 14897 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 45285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2380: /* flush_option: MASTER_SYM  */
#line 14905 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 45291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2381: /* flush_option: DES_KEY_FILE  */
#line 14907 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 45297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2382: /* flush_option: RESOURCES  */
#line 14909 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 45303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2383: /* flush_option: SSL_SYM  */
#line 14911 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SSL;}
#line 45309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2384: /* flush_option: IDENT_sys remember_tok_start  */
#line 14913 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 45327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2385: /* opt_table_list: %empty  */
#line 14929 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2386: /* opt_table_list: table_list  */
#line 14930 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 45339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2387: /* backup: BACKUP_SYM backup_statements  */
#line 14934 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 45345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2388: /* backup_statements: STAGE_SYM ident  */
#line 14939 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 45361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2389: /* $@205: %empty  */
#line 14951 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP LOCK"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 45372 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2390: /* backup_statements: LOCK_SYM $@205 table_ident  */
#line 14958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 45384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2391: /* backup_statements: UNLOCK_SYM  */
#line 14966 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP UNLOCK"));
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 45395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2392: /* opt_delete_gtid_domain: %empty  */
#line 14975 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45401 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2393: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 14977 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45407 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2397: /* delete_domain_id: ulonglong_num  */
#line 14987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 45424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2398: /* optional_flush_tables_arguments: %empty  */
#line 15002 "/home/buildbot/git/sql/sql_yacc.yy"
                             {(yyval.num)= 0;}
#line 45430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2399: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15003 "/home/buildbot/git/sql/sql_yacc.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 45436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2400: /* $@206: %empty  */
#line 15008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 45445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2401: /* reset: RESET_SYM $@206 reset_options  */
#line 15013 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2404: /* $@207: %empty  */
#line 15022 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 45457 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2405: /* reset_option: SLAVE $@207 optional_connection_name slave_reset_options  */
#line 15024 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 45463 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2406: /* $@208: %empty  */
#line 15026 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 45472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2408: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15031 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 45478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2409: /* slave_reset_options: %empty  */
#line 15035 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= false; }
#line 45484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2410: /* slave_reset_options: ALL  */
#line 15036 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= true; }
#line 45490 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2411: /* master_reset_options: %empty  */
#line 15040 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45496 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2412: /* master_reset_options: TO_SYM ulong_num  */
#line 15042 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 45504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2413: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 45512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2414: /* $@209: %empty  */
#line 15053 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 45518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2415: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@209 expr  */
#line 15055 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 45528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2416: /* $@210: %empty  */
#line 15067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 45540 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2417: /* kill: KILL_SYM $@210 kill_type kill_option  */
#line 15075 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 45548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2418: /* kill_type: %empty  */
#line 15081 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2419: /* kill_type: HARD_SYM  */
#line 15082 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2420: /* kill_type: SOFT_SYM  */
#line 15083 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 45566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2421: /* kill_option: opt_connection kill_expr  */
#line 15087 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 45572 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2422: /* kill_option: QUERY_SYM kill_expr  */
#line 15088 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 45578 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2423: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15090 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 45588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2424: /* opt_connection: %empty  */
#line 15098 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45594 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2425: /* opt_connection: CONNECTION_SYM  */
#line 15099 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2426: /* kill_expr: expr  */
#line 15104 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 45608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2427: /* kill_expr: USER_SYM user  */
#line 15108 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 45617 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2428: /* $@211: %empty  */
#line 15115 "/home/buildbot/git/sql/sql_yacc.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 45623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2429: /* shutdown: SHUTDOWN $@211 shutdown_option  */
#line 15116 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2430: /* shutdown_option: %empty  */
#line 15120 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 45635 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2431: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15122 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 45643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2432: /* use: USE_SYM ident  */
#line 15131 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 45653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2433: /* $@212: %empty  */
#line 15142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 45671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2434: /* $@213: %empty  */
#line 15156 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 45686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2435: /* $@214: %empty  */
#line 15167 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 45703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2436: /* $@215: %empty  */
#line 15180 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 45709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2437: /* load: LOAD data_or_xml $@212 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@213 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@214 opt_load_data_charset $@215 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15184 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 45720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2438: /* data_or_xml: DATA_SYM  */
#line 15193 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 45726 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2439: /* data_or_xml: XML_SYM  */
#line 15194 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 45732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2440: /* opt_local: %empty  */
#line 15198 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=0;}
#line 45738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2441: /* opt_local: LOCAL_SYM  */
#line 15199 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1;}
#line 45744 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2442: /* load_data_lock: %empty  */
#line 15203 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 45750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2443: /* load_data_lock: CONCURRENT  */
#line 15205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 45762 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2444: /* load_data_lock: LOW_PRIORITY  */
#line 15212 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 45768 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2445: /* opt_duplicate: %empty  */
#line 15216 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 45774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2446: /* opt_duplicate: REPLACE  */
#line 15217 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 45780 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2447: /* opt_duplicate: IGNORE_SYM  */
#line 15218 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1; }
#line 45786 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2452: /* field_term: TERMINATED BY text_string  */
#line 15233 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 45795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2453: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15238 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 45806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2454: /* field_term: ENCLOSED BY text_string  */
#line 15245 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2455: /* field_term: ESCAPED BY text_string  */
#line 15250 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2460: /* line_term: TERMINATED BY text_string  */
#line 15268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2461: /* line_term: STARTING BY text_string  */
#line 15273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2462: /* opt_xml_rows_identified_by: %empty  */
#line 15280 "/home/buildbot/git/sql/sql_yacc.yy"
                    { }
#line 45848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2463: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15282 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2465: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15288 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45863 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2466: /* lines_or_rows: LINES  */
#line 15295 "/home/buildbot/git/sql/sql_yacc.yy"
                { }
#line 45869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2467: /* lines_or_rows: ROWS_SYM  */
#line 15296 "/home/buildbot/git/sql/sql_yacc.yy"
                   { }
#line 45875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2468: /* opt_field_or_var_spec: %empty  */
#line 15300 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2469: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15301 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45887 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2470: /* opt_field_or_var_spec: '(' ')'  */
#line 15302 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 45893 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2471: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15307 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2472: /* fields_or_vars: field_or_var  */
#line 15309 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2473: /* field_or_var: simple_ident_nospvar  */
#line 15313 "/home/buildbot/git/sql/sql_yacc.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2474: /* field_or_var: '@' ident_or_text  */
#line 15315 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45921 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2475: /* opt_load_data_set_spec: %empty  */
#line 15323 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2476: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15324 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2479: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2480: /* text_literal: TEXT_STRING  */
#line 15347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2481: /* text_literal: NCHAR_STRING  */
#line 15352 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2482: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15357 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2483: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2484: /* text_string: TEXT_STRING_literal  */
#line 15370 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2485: /* text_string: hex_or_bin_String  */
#line 15377 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2486: /* hex_or_bin_String: HEX_NUM  */
#line 15383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 46011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2487: /* hex_or_bin_String: HEX_STRING  */
#line 15391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 46023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2488: /* hex_or_bin_String: BIN_NUM  */
#line 15399 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 46039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2489: /* param_marker: PARAM_MARKER  */
#line 15414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 46050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2490: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 46060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2491: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15427 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 46071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2492: /* signed_literal: '+' NUM_literal  */
#line 15436 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 46077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2493: /* signed_literal: '-' NUM_literal  */
#line 15438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 46086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2494: /* literal: text_literal  */
#line 15445 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 46092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2495: /* literal: NUM_literal  */
#line 15446 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 46098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2496: /* literal: temporal_literal  */
#line 15447 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 46104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2497: /* literal: NULL_SYM  */
#line 15449 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 46122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2498: /* literal: FALSE_SYM  */
#line 15463 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2499: /* literal: TRUE_SYM  */
#line 15469 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46142 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2500: /* literal: HEX_NUM  */
#line 15475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2501: /* literal: HEX_STRING  */
#line 15481 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2502: /* literal: BIN_NUM  */
#line 15487 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46172 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2503: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15493 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 46192 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2504: /* NUM_literal: NUM  */
#line 15512 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2505: /* NUM_literal: LONG_NUM  */
#line 15522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2506: /* NUM_literal: ULONGLONG_NUM  */
#line 15532 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2507: /* NUM_literal: DECIMAL_NUM  */
#line 15538 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2508: /* NUM_literal: FLOAT_NUM  */
#line 15545 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2509: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15555 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46262 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2510: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15562 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2511: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime.create_literal_item(thd,
                                                            (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                            YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2512: /* $@216: %empty  */
#line 15579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 46304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2513: /* with_clause: WITH opt_recursive $@216 with_list  */
#line 15595 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 46313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2514: /* opt_recursive: %empty  */
#line 15603 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 0; }
#line 46319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2515: /* opt_recursive: RECURSIVE_SYM  */
#line 15604 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 46325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2518: /* $@217: %empty  */
#line 15617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 46336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2519: /* with_list_element: with_element_head opt_with_column_list $@217 AS '(' query_expression ')'  */
#line 15624 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 46354 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2520: /* opt_with_column_list: %empty  */
#line 15642 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46360 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2521: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15644 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2522: /* with_column_list: ident  */
#line 15650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 46375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2523: /* with_column_list: with_column_list ',' ident  */
#line 15655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 46384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2524: /* with_element_head: ident  */
#line 15664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 46397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2525: /* insert_ident: simple_ident_nospvar  */
#line 15681 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 46403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2526: /* insert_ident: table_wild  */
#line 15682 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 46409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2527: /* table_wild: ident '.' '*'  */
#line 15687 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2528: /* table_wild: ident '.' ident '.' '*'  */
#line 15692 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2529: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2530: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2531: /* order_ident: expr  */
#line 15712 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2532: /* simple_ident: ident_cli  */
#line 15718 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2533: /* simple_ident: ident_cli '.' ident_cli  */
#line 15723 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46469 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2534: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15728 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2535: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2536: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15739 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2537: /* simple_ident_nospvar: ident  */
#line 15747 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2538: /* simple_ident_nospvar: ident '.' ident  */
#line 15752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2539: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2540: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15762 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2541: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2542: /* field_ident: ident  */
#line 15775 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2543: /* field_ident: ident '.' ident '.' ident  */
#line 15777 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2544: /* field_ident: ident '.' ident  */
#line 15788 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2545: /* field_ident: '.' ident  */
#line 15795 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2546: /* table_ident: ident  */
#line 15800 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2547: /* table_ident: ident '.' ident  */
#line 15806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2548: /* table_ident: '.' ident  */
#line 15812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2549: /* table_ident_opt_wild: ident opt_wild  */
#line 15822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2550: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 15828 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2551: /* table_ident_nodb: ident  */
#line 15837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2556: /* ident_cli: keyword_ident  */
#line 15853 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 46650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2557: /* IDENT_sys: IDENT_cli  */
#line 15858 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 46659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2558: /* TEXT_STRING_sys: TEXT_STRING  */
#line 15866 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2559: /* TEXT_STRING_literal: TEXT_STRING  */
#line 15874 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2560: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 15882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2562: /* ident_table_alias: keyword_table_alias  */
#line 15891 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2564: /* ident_set_usual_case: keyword_set_usual_case  */
#line 15900 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46704 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2566: /* ident_sysvar_name: keyword_sysvar_name  */
#line 15909 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2567: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 15914 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 46722 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2569: /* ident: keyword_ident  */
#line 15924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2571: /* label_ident: keyword_label  */
#line 15933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2572: /* ident_or_text: ident  */
#line 15940 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2573: /* ident_or_text: TEXT_STRING_sys  */
#line 15941 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2574: /* ident_or_text: LEX_HOSTNAME  */
#line 15942 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2575: /* user_maybe_role: ident_or_text  */
#line 15947 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 46773 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2576: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 15958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2577: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 15987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2580: /* user: user_maybe_role  */
#line 15998 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3056: /* $@218: %empty  */
#line 16606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3057: /* set: SET $@218 start_option_value_list  */
#line 16616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46851 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3058: /* $@219: %empty  */
#line 16622 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46861 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3059: /* $@220: %empty  */
#line 16628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3060: /* set: SET STATEMENT_SYM $@219 set_stmt_option_value_following_option_type_list $@220 FOR_SYM verb_clause  */
#line 16639 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 46882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3063: /* $@221: %empty  */
#line 16655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3065: /* $@222: %empty  */
#line 16661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3066: /* start_option_value_list: TRANSACTION_SYM $@222 transaction_characteristics  */
#line 16665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3067: /* $@223: %empty  */
#line 16670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3069: /* $@224: %empty  */
#line 16680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3071: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16686 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3074: /* $@225: %empty  */
#line 16700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3075: /* option_value_list: $@225 option_value  */
#line 16705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3076: /* $@226: %empty  */
#line 16710 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3077: /* option_value_list: option_value_list ',' $@226 option_value  */
#line 16715 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3078: /* $@227: %empty  */
#line 16724 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3081: /* option_type: GLOBAL_SYM  */
#line 16732 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3082: /* option_type: LOCAL_SYM  */
#line 16733 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3083: /* option_type: SESSION_SYM  */
#line 16734 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3084: /* opt_var_type: %empty  */
#line 16738 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 47002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3085: /* opt_var_type: GLOBAL_SYM  */
#line 16739 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 47008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3086: /* opt_var_type: LOCAL_SYM  */
#line 16740 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 47014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3087: /* opt_var_type: SESSION_SYM  */
#line 16741 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 47020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3088: /* opt_var_ident_type: %empty  */
#line 16745 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 47026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3089: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 16746 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 47032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3090: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 16747 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 47038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3091: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 16748 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 47044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3092: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 16754 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3093: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 16759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3094: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16764 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3095: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 16773 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3096: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 16778 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3097: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16783 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3098: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 16788 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3099: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 16793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3100: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 16798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3101: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 16803 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3102: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 16808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 47152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3103: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 16822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 47167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3104: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 16833 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3105: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 16852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3106: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 16870 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3107: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 16882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3108: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 16890 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3109: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 16895 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3114: /* transaction_access_mode: transaction_access_mode_types  */
#line 16918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3115: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 16937 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3116: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 16954 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= true; }
#line 47310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3117: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 16955 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= false; }
#line 47316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3118: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 16959 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 47322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3119: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 16960 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 47328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3120: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 16961 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 47334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3121: /* isolation_types: SERIALIZABLE_SYM  */
#line 16962 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 47340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3122: /* opt_for_user: equal  */
#line 16967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 47358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3123: /* opt_for_user: FOR_SYM user equal  */
#line 16980 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 47364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3124: /* text_or_password: TEXT_STRING  */
#line 16985 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3125: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 16990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 47382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3126: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 16995 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 47394 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3127: /* set_expr_or_default: expr  */
#line 17005 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 47400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3128: /* set_expr_or_default: DEFAULT  */
#line 17006 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.item)=0; }
#line 47406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3129: /* set_expr_or_default: ON  */
#line 17008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3130: /* set_expr_or_default: ALL  */
#line 17014 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47426 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3131: /* set_expr_or_default: BINARY  */
#line 17020 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3132: /* $@228: %empty  */
#line 17031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 47448 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3133: /* lock: LOCK_SYM table_or_tables $@228 table_lock_list opt_lock_wait_timeout  */
#line 17039 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3134: /* opt_lock_wait_timeout: %empty  */
#line 17044 "/home/buildbot/git/sql/sql_yacc.yy"
        {}
#line 47460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3135: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17046 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 47470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3136: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17052 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 47480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3137: /* table_or_tables: TABLE_SYM  */
#line 17060 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3138: /* table_or_tables: TABLES  */
#line 17061 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3141: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 47512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3142: /* lock_option: READ_SYM  */
#line 17089 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 47518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3143: /* lock_option: WRITE_SYM  */
#line 17090 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 47524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3144: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17092 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 47532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3145: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17096 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 47538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3146: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17097 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ; }
#line 47544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3147: /* $@229: %empty  */
#line 17102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 47556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3148: /* unlock: UNLOCK_SYM $@229 table_or_tables  */
#line 17110 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47562 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3149: /* $@230: %empty  */
#line 17119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 47571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3150: /* handler: HANDLER_SYM $@230 handler_tail  */
#line 17124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 47579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3151: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17131 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 47592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3152: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17140 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3153: /* $@231: %empty  */
#line 17149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47626 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3154: /* handler_tail: table_ident_nodb READ_SYM $@231 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17166 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 47651 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3155: /* handler_read_or_scan: handler_scan_function  */
#line 17189 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= null_clex_str; }
#line 47657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3156: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17190 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 47663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3157: /* handler_scan_function: FIRST_SYM  */
#line 17194 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3158: /* handler_scan_function: NEXT_SYM  */
#line 17195 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3159: /* handler_rkey_function: FIRST_SYM  */
#line 17199 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3160: /* handler_rkey_function: NEXT_SYM  */
#line 17200 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3161: /* handler_rkey_function: PREV_SYM  */
#line 17201 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 47693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3162: /* handler_rkey_function: LAST_SYM  */
#line 17202 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 47699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3163: /* $@232: %empty  */
#line 17204 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3164: /* handler_rkey_function: handler_rkey_mode $@232 '(' values ')'  */
#line 17212 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3165: /* handler_rkey_mode: '='  */
#line 17216 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3166: /* handler_rkey_mode: GE  */
#line 17217 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3167: /* handler_rkey_mode: LE  */
#line 17218 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3168: /* handler_rkey_mode: '>'  */
#line 17219 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3169: /* handler_rkey_mode: '<'  */
#line 17220 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3170: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17227 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3171: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3172: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17238 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47773 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3173: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17244 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3174: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17251 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3175: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3176: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3177: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3178: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17275 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47832 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3179: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17284 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3180: /* admin_option_for_role: grant_role  */
#line 17286 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3181: /* grant: GRANT clear_privileges grant_command  */
#line 17291 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3182: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3183: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3184: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3185: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3186: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3187: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17331 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3188: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17338 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3189: /* opt_with_admin: %empty  */
#line 17349 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = 0; }
#line 47929 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3190: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17350 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3191: /* opt_with_admin_option: %empty  */
#line 17354 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= false; }
#line 47941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3192: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17355 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= true; }
#line 47947 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3193: /* role_list: grant_role  */
#line 17360 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47956 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3194: /* role_list: role_list ',' grant_role  */
#line 17365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3195: /* current_role: CURRENT_ROLE optional_braces  */
#line 17373 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3196: /* grant_role: ident_or_text  */
#line 17383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3200: /* grant_privileges: object_privilege_list  */
#line 17410 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 48005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3201: /* grant_privileges: ALL opt_privileges  */
#line 17412 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 48014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3206: /* $@233: %empty  */
#line 17430 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 48020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3207: /* object_privilege: SELECT_SYM $@233 opt_column_list  */
#line 17431 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3208: /* $@234: %empty  */
#line 17433 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 48032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3209: /* object_privilege: INSERT $@234 opt_column_list  */
#line 17434 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3210: /* $@235: %empty  */
#line 17436 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 48044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3211: /* object_privilege: UPDATE_SYM $@235 opt_column_list  */
#line 17437 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3212: /* $@236: %empty  */
#line 17439 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 48056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3213: /* object_privilege: REFERENCES $@236 opt_column_list  */
#line 17440 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3214: /* object_privilege: DELETE_SYM  */
#line 17441 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 48068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3215: /* object_privilege: USAGE  */
#line 17442 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 48074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3216: /* object_privilege: INDEX_SYM  */
#line 17443 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 48080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3217: /* object_privilege: ALTER  */
#line 17444 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 48086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3218: /* object_privilege: CREATE  */
#line 17445 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 48092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3219: /* object_privilege: DROP  */
#line 17446 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 48098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3220: /* object_privilege: EXECUTE_SYM  */
#line 17447 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 48104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3221: /* object_privilege: RELOAD  */
#line 17448 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 48110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3222: /* object_privilege: SHUTDOWN  */
#line 17449 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 48116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3223: /* object_privilege: PROCESS  */
#line 17450 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 48122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3224: /* object_privilege: FILE_SYM  */
#line 17451 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 48128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3225: /* object_privilege: GRANT OPTION  */
#line 17452 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 48134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3226: /* object_privilege: SHOW DATABASES  */
#line 17453 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 48140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3227: /* object_privilege: SUPER_SYM  */
#line 17454 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 48146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3228: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17455 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 48152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3229: /* object_privilege: LOCK_SYM TABLES  */
#line 17456 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 48158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3230: /* object_privilege: REPLICATION SLAVE  */
#line 17457 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 48164 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3231: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17458 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 48170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3232: /* object_privilege: CREATE VIEW_SYM  */
#line 17459 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 48176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3233: /* object_privilege: SHOW VIEW_SYM  */
#line 17460 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 48182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3234: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17461 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 48188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3235: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17462 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 48194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3236: /* object_privilege: CREATE USER_SYM  */
#line 17463 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 48200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3237: /* object_privilege: EVENT_SYM  */
#line 17464 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 48206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3238: /* object_privilege: TRIGGER_SYM  */
#line 17465 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 48212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3239: /* object_privilege: CREATE TABLESPACE  */
#line 17466 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 48218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3240: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17467 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 48224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3241: /* opt_and: %empty  */
#line 17471 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3242: /* opt_and: AND_SYM  */
#line 17472 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 48236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3245: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17482 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 48247 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3246: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17489 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 48258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3247: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17496 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 48269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3248: /* grant_ident: '*'  */
#line 17506 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3249: /* grant_ident: ident '.' '*'  */
#line 17516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3250: /* grant_ident: '*' '.' '*'  */
#line 17525 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3251: /* grant_ident: table_ident  */
#line 17534 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 48323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3252: /* user_list: user  */
#line 17547 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3253: /* user_list: user_list ',' user  */
#line 17552 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3254: /* grant_list: grant_user  */
#line 17560 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3255: /* grant_list: grant_list ',' grant_user  */
#line 17565 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48359 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3256: /* user_and_role_list: user_or_role  */
#line 17573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3257: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17578 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3262: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17589 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 48387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3263: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17595 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 48397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3264: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 48406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3265: /* grant_user: user_or_role  */
#line 17606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 48414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3266: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 48424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3267: /* auth_expression: auth_token  */
#line 17619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 48432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3268: /* auth_token: ident_or_text opt_auth_str  */
#line 17626 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 48441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3269: /* opt_auth_str: %empty  */
#line 17634 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 48450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3270: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17639 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 48460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3271: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17645 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 48470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3272: /* opt_column_list: %empty  */
#line 17654 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 48479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3273: /* opt_column_list: '(' column_list ')'  */
#line 17658 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 48485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3276: /* column_list_id: ident  */
#line 17668 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 48515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3278: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17698 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 48523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3279: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17702 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 48531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3280: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17706 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 48539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3281: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17710 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 48547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3282: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17717 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 48556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3283: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 48565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3284: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 17727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 48574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3285: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 17732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 48583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3286: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 17737 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 48592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3287: /* resource_option_list: resource_option_list resource_option  */
#line 17744 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 48598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3288: /* resource_option_list: resource_option  */
#line 17745 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3289: /* opt_resource_options: %empty  */
#line 17749 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3291: /* opt_grant_options: %empty  */
#line 17755 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3292: /* opt_grant_options: WITH grant_option_list  */
#line 17756 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 48622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3293: /* opt_grant_option: %empty  */
#line 17760 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3294: /* opt_grant_option: WITH GRANT OPTION  */
#line 17761 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 48634 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3295: /* grant_option_list: grant_option_list grant_option  */
#line 17765 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 48640 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3296: /* grant_option_list: grant_option  */
#line 17766 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 48646 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3297: /* grant_option: GRANT OPTION  */
#line 17770 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 48652 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3298: /* grant_option: resource_option  */
#line 17771 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3299: /* $@237: %empty  */
#line 17776 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 48668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3300: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@237 opt_work  */
#line 17781 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 48674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3301: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 17786 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 48684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3302: /* opt_not: %empty  */
#line 17794 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 48690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3303: /* opt_not: not  */
#line 17795 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 1; }
#line 48696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3304: /* opt_work: %empty  */
#line 17799 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3305: /* opt_work: WORK_SYM  */
#line 17800 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 48708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3306: /* opt_chain: %empty  */
#line 17805 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48714 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3307: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 17806 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3308: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 17807 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48726 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3309: /* opt_release: %empty  */
#line 17812 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3310: /* opt_release: RELEASE_SYM  */
#line 17813 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3311: /* opt_release: NO_SYM RELEASE_SYM  */
#line 17814 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48744 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3312: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 17819 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3313: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 17831 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3314: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 17840 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48780 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3315: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 17846 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3316: /* savepoint: SAVEPOINT_SYM ident  */
#line 17855 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3317: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 17864 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48810 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3318: /* unit_type_decl: UNION_SYM union_option  */
#line 17877 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3319: /* unit_type_decl: INTERSECT_SYM  */
#line 17879 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3320: /* unit_type_decl: EXCEPT_SYM  */
#line 17881 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3321: /* union_option: %empty  */
#line 17888 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=1; }
#line 48834 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3322: /* union_option: DISTINCT  */
#line 17889 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1; }
#line 48840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3323: /* union_option: ALL  */
#line 17890 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=0; }
#line 48846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3324: /* query_expression_option: STRAIGHT_JOIN  */
#line 17894 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3325: /* query_expression_option: HIGH_PRIORITY  */
#line 17896 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3326: /* query_expression_option: DISTINCT  */
#line 17901 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3327: /* query_expression_option: SQL_SMALL_RESULT  */
#line 17902 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3328: /* query_expression_option: SQL_BIG_RESULT  */
#line 17903 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3329: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 17904 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3330: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 17905 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3331: /* query_expression_option: ALL  */
#line 17906 "/home/buildbot/git/sql/sql_yacc.yy"
              { Select->options|= SELECT_ALL; }
#line 48898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3334: /* no_definer: %empty  */
#line 17922 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3335: /* definer: DEFINER_SYM '=' user_or_role  */
#line 17936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3336: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 17949 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3337: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 17950 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3338: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 17951 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3339: /* opt_view_suid: %empty  */
#line 17955 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3340: /* opt_view_suid: view_suid  */
#line 17956 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3341: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 17960 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3342: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 17961 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3343: /* view_list_opt: %empty  */
#line 17966 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 48970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3344: /* view_list_opt: '(' view_list ')'  */
#line 17967 "/home/buildbot/git/sql/sql_yacc.yy"
                            { }
#line 48976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3345: /* view_list: ident  */
#line 17972 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48986 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3346: /* view_list: view_list ',' ident  */
#line 17978 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3347: /* $@238: %empty  */
#line 17986 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 49006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3348: /* view_select: $@238 query_expression view_check_option  */
#line 17993 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 49015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3349: /* view_check_option: %empty  */
#line 18000 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 49021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3350: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18001 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 49027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3351: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18002 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 49033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3352: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18003 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 49039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3353: /* trigger_action_order: FOLLOWS_SYM  */
#line 18014 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 49045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3354: /* trigger_action_order: PRECEDES_SYM  */
#line 18016 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 49051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3355: /* trigger_follows_precedes_clause: %empty  */
#line 18021 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 49061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3356: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18028 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 49070 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3357: /* $@239: %empty  */
#line 18037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 49079 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3358: /* $@240: %empty  */
#line 18046 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 49087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3359: /* $@241: %empty  */
#line 18052 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 49095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3360: /* $@242: %empty  */
#line 18057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 49103 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3361: /* $@243: %empty  */
#line 18061 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 49128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3362: /* trigger_tail: remember_name opt_if_not_exists $@239 sp_name trg_action_time trg_event ON remember_name $@240 table_ident FOR_SYM remember_name $@241 EACH_SYM ROW_SYM $@242 trigger_follows_precedes_clause $@243 sp_proc_stmt force_lookahead  */
#line 18082 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                   TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                   MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 49151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3363: /* $@244: %empty  */
#line 18111 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 49162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3364: /* sf_return_type: RETURNS_SYM $@244 field_type  */
#line 18118 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 49172 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3365: /* $@245: %empty  */
#line 18127 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3366: /* sf_c_chistics_and_body: sp_c_chistics $@245 sp_proc_stmt_in_returns_clause force_lookahead  */
#line 18133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 49191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3367: /* $@246: %empty  */
#line 18142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 49202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3368: /* $@247: %empty  */
#line 18150 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49211 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3369: /* sp_tail: sp_name $@246 sp_parenthesized_pdparam_list sp_c_chistics $@247 sp_proc_stmt force_lookahead  */
#line 18155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure(thd)))
              MYSQL_YYABORT;
          }
#line 49220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3370: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18165 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 49228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3371: /* xa: XA_SYM END xid opt_suspend  */
#line 18169 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 49236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3372: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18173 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 49244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3373: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18177 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 49252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3374: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18181 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 49260 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3375: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18185 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 49269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3376: /* opt_format_xid: %empty  */
#line 18192 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= false; }
#line 49275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3377: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 49292 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3378: /* xid: text_string  */
#line 18210 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 49303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3379: /* xid: text_string ',' text_string  */
#line 18217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 49314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3380: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18224 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 49325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3381: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18233 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 49331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3382: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18234 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 49337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3383: /* begin_or_start: START_SYM  */
#line 18235 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 49343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3384: /* opt_join_or_resume: %empty  */
#line 18239 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 49349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3385: /* opt_join_or_resume: JOIN_SYM  */
#line 18240 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 49355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3386: /* opt_join_or_resume: RESUME_SYM  */
#line 18241 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 49361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3387: /* opt_one_phase: %empty  */
#line 18245 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 49367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3388: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18246 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 49373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3389: /* opt_suspend: %empty  */
#line 18251 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 49379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3390: /* $@248: %empty  */
#line 18253 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 49385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3392: /* opt_migrate: %empty  */
#line 18258 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 49391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3393: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18259 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 49397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3394: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3395: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18269 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 49414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3396: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 49423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3397: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18281 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3398: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18290 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYERROR;
          }
#line 49440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;


#line 49444 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

