/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ORAparse
#define yylex           ORAlex
#define yyerror         ORAerror
#define yydebug         ORAdebug
#define yynerrs         ORAnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc_ora.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                          \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void ORAerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}




#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


#line 229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc_ora.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DEFINER_SYM = 402,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 403,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 404,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 405,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 406,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 407,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 408,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 409,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 410,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 411,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 412,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 413,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 414,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 415,               /* ENABLE_SYM  */
  YYSYMBOL_END = 416,                      /* END  */
  YYSYMBOL_ENDS_SYM = 417,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 418,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 419,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 420,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 421,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 422,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 423,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 424,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 425,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 426,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 427,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 428,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 429,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 430,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 431,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 432,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 433,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 434,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 435,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 436,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 437,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 438,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 439,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 440,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 441,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 442,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 443,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 444,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 445,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 446,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 447,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 448,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 449,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 450,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 451,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 452,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 453,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 454,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 455,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 456,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 457,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 458,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 459,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 460,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 461,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 462,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 463,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 464,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 465,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 466,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 467,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 468,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 469,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 470,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 471,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 472,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 473,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 474,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 475,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 476,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 477,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 478,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 479,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 480,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 481,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 482,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 483,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 484,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 485,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 486,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 487,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 488,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 489,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 490,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 491,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 492,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 493,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 494,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 495,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 496,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 497,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 498,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 499,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 500,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 501, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 502,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 503,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 504,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 505,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 506,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 507,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 508,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 509,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 510,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 511,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 512,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 513,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 514,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 515,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 516,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 517,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 518,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 519,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 520,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 521, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 522, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 523,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 524,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 525,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 526,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 527,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 528, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 529,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 530,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 531,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 532,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 533,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 534,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 535,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 536,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 537,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 538,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 539,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 540,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 541,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 542,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 543,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 544,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 545,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 546,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 547,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 548,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 549,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 550,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 551,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 552,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 553,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 554,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 555,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 556,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 557,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 558,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 559,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 560,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 561,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 562,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 563,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 564,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 565,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 566,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 567,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 568,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 569,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 570,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 571,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 572,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 573,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 574,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 575,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 576,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 577,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 578,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 579,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 580,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 581,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 582,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 583,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 584,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 585,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 586,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 587,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 588,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 589,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 590,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 591,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 592,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 593,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 594,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 595,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 596,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 597,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 598,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 599,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 600,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 601,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 602,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 603,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 604,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 605,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 606,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 607,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 608,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 609,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 610,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 611,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 612,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 613,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 614,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 615,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 616,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 617,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 618,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 619,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 620,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 621,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 622,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 623,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 624,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 625,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 626,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 627,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 628,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 629,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 630,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 631,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 632,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 633,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 634,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 635,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 636,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 637,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 638,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 639,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 640,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 641,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 642,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 643,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 644,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 645,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 646,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 647,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 648,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 649,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 650,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 651,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 652,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 653,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 654,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 655,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 656,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 657,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 658,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 659,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 660,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 661,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 662,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 663,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 664,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 665,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 666,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 667,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 668,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 669,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 670,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 671,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 672,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 673,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 674,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 675,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 676,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 677,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 678,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 679,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 680,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 681,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 682,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 683,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 684,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 685,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 686,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 687,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 688,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 689,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 690,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 691,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 692,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 693,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 694,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 695,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 696,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 697,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 698,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 699,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 700,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 701,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 702,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 703,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 704,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 705,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 706,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 707,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 708,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 709,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 710,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 711,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 712,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 713,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 714,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 715,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 716,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 717,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 718,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 719,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 720,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 721,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 722,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 723,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 724,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 725,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 726,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 727,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 728,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 729,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 730,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 731,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 732,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 733,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 734,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 735,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 736,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 737,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 738,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 739,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 740,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 741,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 742,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 743,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 744,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 745,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 746,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 747,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 748,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 749,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 750,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 751,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 752,           /* PREC_BELOW_NOT  */
  YYSYMBOL_753_ = 753,                     /* '='  */
  YYSYMBOL_754_ = 754,                     /* '>'  */
  YYSYMBOL_755_ = 755,                     /* '<'  */
  YYSYMBOL_756_ = 756,                     /* '|'  */
  YYSYMBOL_757_ = 757,                     /* '&'  */
  YYSYMBOL_758_ = 758,                     /* '-'  */
  YYSYMBOL_759_ = 759,                     /* '+'  */
  YYSYMBOL_760_ = 760,                     /* '*'  */
  YYSYMBOL_761_ = 761,                     /* '/'  */
  YYSYMBOL_762_ = 762,                     /* '%'  */
  YYSYMBOL_763_ = 763,                     /* '^'  */
  YYSYMBOL_764_ = 764,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 765,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 766, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 767,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 768, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_769_ = 769,                     /* '('  */
  YYSYMBOL_770_ = 770,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 771,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_772_ = 772,                     /* ','  */
  YYSYMBOL_773_ = 773,                     /* '!'  */
  YYSYMBOL_774_ = 774,                     /* '{'  */
  YYSYMBOL_775_ = 775,                     /* '}'  */
  YYSYMBOL_776_ = 776,                     /* ';'  */
  YYSYMBOL_777_ = 777,                     /* '.'  */
  YYSYMBOL_778_ = 778,                     /* '@'  */
  YYSYMBOL_YYACCEPT = 779,                 /* $accept  */
  YYSYMBOL_query = 780,                    /* query  */
  YYSYMBOL_781_1 = 781,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 782,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 783,              /* verb_clause  */
  YYSYMBOL_statement = 784,                /* statement  */
  YYSYMBOL_deallocate = 785,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 786,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 787,                  /* prepare  */
  YYSYMBOL_788_2 = 788,                    /* $@2  */
  YYSYMBOL_execute = 789,                  /* execute  */
  YYSYMBOL_790_3 = 790,                    /* $@3  */
  YYSYMBOL_791_4 = 791,                    /* $@4  */
  YYSYMBOL_execute_using = 792,            /* execute_using  */
  YYSYMBOL_793_5 = 793,                    /* $@5  */
  YYSYMBOL_execute_params = 794,           /* execute_params  */
  YYSYMBOL_help = 795,                     /* help  */
  YYSYMBOL_796_6 = 796,                    /* $@6  */
  YYSYMBOL_change = 797,                   /* change  */
  YYSYMBOL_798_7 = 798,                    /* $@7  */
  YYSYMBOL_master_defs = 799,              /* master_defs  */
  YYSYMBOL_master_def = 800,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 801,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 802,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 803,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 804,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 805,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 806,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 807,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 808, /* optional_connection_name  */
  YYSYMBOL_connection_name = 809,          /* connection_name  */
  YYSYMBOL_create = 810,                   /* create  */
  YYSYMBOL_811_8 = 811,                    /* $@8  */
  YYSYMBOL_812_9 = 812,                    /* $@9  */
  YYSYMBOL_813_10 = 813,                   /* $@10  */
  YYSYMBOL_814_11 = 814,                   /* $@11  */
  YYSYMBOL_815_12 = 815,                   /* $@12  */
  YYSYMBOL_816_13 = 816,                   /* $@13  */
  YYSYMBOL_817_14 = 817,                   /* $@14  */
  YYSYMBOL_818_15 = 818,                   /* $@15  */
  YYSYMBOL_819_16 = 819,                   /* $@16  */
  YYSYMBOL_820_17 = 820,                   /* $@17  */
  YYSYMBOL_821_18 = 821,                   /* $@18  */
  YYSYMBOL_822_19 = 822,                   /* $@19  */
  YYSYMBOL_823_20 = 823,                   /* $@20  */
  YYSYMBOL_824_21 = 824,                   /* $@21  */
  YYSYMBOL_825_22 = 825,                   /* $@22  */
  YYSYMBOL_826_23 = 826,                   /* $@23  */
  YYSYMBOL_827_24 = 827,                   /* $@24  */
  YYSYMBOL_828_25 = 828,                   /* $@25  */
  YYSYMBOL_829_26 = 829,                   /* $@26  */
  YYSYMBOL_830_27 = 830,                   /* $@27  */
  YYSYMBOL_831_28 = 831,                   /* $@28  */
  YYSYMBOL_832_29 = 832,                   /* $@29  */
  YYSYMBOL_833_30 = 833,                   /* $@30  */
  YYSYMBOL_834_31 = 834,                   /* $@31  */
  YYSYMBOL_package_implementation_executable_section = 835, /* package_implementation_executable_section  */
  YYSYMBOL_package_implementation_declare_section = 836, /* package_implementation_declare_section  */
  YYSYMBOL_package_implementation_declare_section_list1 = 837, /* package_implementation_declare_section_list1  */
  YYSYMBOL_package_implementation_declare_section_list2 = 838, /* package_implementation_declare_section_list2  */
  YYSYMBOL_package_routine_lex = 839,      /* package_routine_lex  */
  YYSYMBOL_package_specification_function = 840, /* package_specification_function  */
  YYSYMBOL_841_32 = 841,                   /* $@32  */
  YYSYMBOL_package_specification_procedure = 842, /* package_specification_procedure  */
  YYSYMBOL_843_33 = 843,                   /* $@33  */
  YYSYMBOL_package_implementation_routine_definition = 844, /* package_implementation_routine_definition  */
  YYSYMBOL_package_implementation_function_body = 845, /* package_implementation_function_body  */
  YYSYMBOL_846_34 = 846,                   /* $@34  */
  YYSYMBOL_package_implementation_procedure_body = 847, /* package_implementation_procedure_body  */
  YYSYMBOL_848_35 = 848,                   /* $@35  */
  YYSYMBOL_package_implementation_item_declaration = 849, /* package_implementation_item_declaration  */
  YYSYMBOL_opt_package_specification_element_list = 850, /* opt_package_specification_element_list  */
  YYSYMBOL_package_specification_element_list = 851, /* package_specification_element_list  */
  YYSYMBOL_package_specification_element = 852, /* package_specification_element  */
  YYSYMBOL_opt_sequence = 853,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 854,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 855,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 856,          /* force_lookahead  */
  YYSYMBOL_server_def = 857,               /* server_def  */
  YYSYMBOL_858_36 = 858,                   /* $@36  */
  YYSYMBOL_server_options_list = 859,      /* server_options_list  */
  YYSYMBOL_server_option = 860,            /* server_option  */
  YYSYMBOL_event_tail = 861,               /* event_tail  */
  YYSYMBOL_862_37 = 862,                   /* $@37  */
  YYSYMBOL_ev_schedule_time = 863,         /* ev_schedule_time  */
  YYSYMBOL_864_38 = 864,                   /* $@38  */
  YYSYMBOL_opt_ev_status = 865,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 866,                /* ev_starts  */
  YYSYMBOL_ev_ends = 867,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 868,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 869,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 870,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 871,              /* ev_sql_stmt  */
  YYSYMBOL_872_39 = 872,                   /* $@39  */
  YYSYMBOL_clear_privileges = 873,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 874,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 875,                  /* sp_name  */
  YYSYMBOL_opt_sp_name = 876,              /* opt_sp_name  */
  YYSYMBOL_sp_a_chistics = 877,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 878,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 879,               /* sp_chistic  */
  YYSYMBOL_create_package_chistic = 880,   /* create_package_chistic  */
  YYSYMBOL_create_package_chistics = 881,  /* create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics = 882, /* opt_create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics_init = 883, /* opt_create_package_chistics_init  */
  YYSYMBOL_884_40 = 884,                   /* $@40  */
  YYSYMBOL_sp_c_chistic = 885,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 886,                  /* sp_suid  */
  YYSYMBOL_call = 887,                     /* call  */
  YYSYMBOL_888_41 = 888,                   /* $@41  */
  YYSYMBOL_889_42 = 889,                   /* $@42  */
  YYSYMBOL_890_43 = 890,                   /* $@43  */
  YYSYMBOL_opt_sp_cparam_list = 891,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 892,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 893,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 894,          /* sp_fdparam_list  */
  YYSYMBOL_895_44 = 895,                   /* $@44  */
  YYSYMBOL_sp_fdparams = 896,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 897,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 898,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 899,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 900,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 901,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 902,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 903, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_904_45 = 904,                   /* $@45  */
  YYSYMBOL_sp_no_param = 905,              /* sp_no_param  */
  YYSYMBOL_opt_sp_parenthesized_fdparam_list = 906, /* opt_sp_parenthesized_fdparam_list  */
  YYSYMBOL_opt_sp_parenthesized_pdparam_list = 907, /* opt_sp_parenthesized_pdparam_list  */
  YYSYMBOL_sp_proc_stmts = 908,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 909,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_proc_stmts1_implicit_block = 910, /* sp_proc_stmts1_implicit_block  */
  YYSYMBOL_911_46 = 911,                   /* $@46  */
  YYSYMBOL_opt_sp_decl_body_list = 912,    /* opt_sp_decl_body_list  */
  YYSYMBOL_sp_decl_body_list = 913,        /* sp_decl_body_list  */
  YYSYMBOL_914_47 = 914,                   /* $@47  */
  YYSYMBOL_sp_decl_non_handler_list = 915, /* sp_decl_non_handler_list  */
  YYSYMBOL_sp_decl_handler_list = 916,     /* sp_decl_handler_list  */
  YYSYMBOL_opt_sp_decl_handler_list = 917, /* opt_sp_decl_handler_list  */
  YYSYMBOL_optionally_qualified_column_ident = 918, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 919,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 920,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 921, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 922,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 923, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_vars = 924,             /* sp_decl_vars  */
  YYSYMBOL_sp_decl_non_handler = 925,      /* sp_decl_non_handler  */
  YYSYMBOL_926_48 = 926,                   /* $@48  */
  YYSYMBOL_sp_decl_handler = 927,          /* sp_decl_handler  */
  YYSYMBOL_928_49 = 928,                   /* $@49  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 929, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 930,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 931,           /* sp_cursor_stmt  */
  YYSYMBOL_932_50 = 932,                   /* $@50  */
  YYSYMBOL_sp_handler_type = 933,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 934,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 935,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 936,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 937,                 /* sqlstate  */
  YYSYMBOL_opt_value = 938,                /* opt_value  */
  YYSYMBOL_sp_hcond = 939,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 940,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 941,              /* signal_stmt  */
  YYSYMBOL_signal_value = 942,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 943,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 944, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 945, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 946,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 947, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 948,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 949,          /* get_diagnostics  */
  YYSYMBOL_which_area = 950,               /* which_area  */
  YYSYMBOL_diagnostics_information = 951,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 952,    /* statement_information  */
  YYSYMBOL_statement_information_item = 953, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 954, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 955, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 956,         /* condition_number  */
  YYSYMBOL_condition_information = 957,    /* condition_information  */
  YYSYMBOL_condition_information_item = 958, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 959, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 960,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 961,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 962,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt = 963,             /* sp_proc_stmt  */
  YYSYMBOL_sp_labelable_stmt = 964,        /* sp_labelable_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 965, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 966,          /* sp_proc_stmt_if  */
  YYSYMBOL_967_51 = 967,                   /* $@51  */
  YYSYMBOL_sp_statement = 968,             /* sp_statement  */
  YYSYMBOL_969_52 = 969,                   /* $@52  */
  YYSYMBOL_970_53 = 970,                   /* $@53  */
  YYSYMBOL_971_54 = 971,                   /* $@54  */
  YYSYMBOL_sp_proc_stmt_statement = 972,   /* sp_proc_stmt_statement  */
  YYSYMBOL_973_55 = 973,                   /* $@55  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 974,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 975,      /* sp_proc_stmt_return  */
  YYSYMBOL_976_56 = 976,                   /* $@56  */
  YYSYMBOL_reset_lex_expr = 977,           /* reset_lex_expr  */
  YYSYMBOL_978_57 = 978,                   /* $@57  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 979, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 980, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 981,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 982,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 983, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_remember_lex = 984,             /* remember_lex  */
  YYSYMBOL_assignment_source_lex = 985,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 986,   /* assignment_source_expr  */
  YYSYMBOL_987_58 = 987,                   /* $@58  */
  YYSYMBOL_for_loop_bound_expr = 988,      /* for_loop_bound_expr  */
  YYSYMBOL_989_59 = 989,                   /* $@59  */
  YYSYMBOL_cursor_actual_parameters = 990, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 991, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 992,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 993,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 994,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 995,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 996,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 997,                    /* sp_if  */
  YYSYMBOL_998_60 = 998,                   /* $@60  */
  YYSYMBOL_999_61 = 999,                   /* $@61  */
  YYSYMBOL_1000_62 = 1000,                 /* $@62  */
  YYSYMBOL_sp_elseifs = 1001,              /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 1002, /* case_stmt_specification  */
  YYSYMBOL_1003_63 = 1003,                 /* $@63  */
  YYSYMBOL_case_stmt_body = 1004,          /* case_stmt_body  */
  YYSYMBOL_1005_64 = 1005,                 /* $@64  */
  YYSYMBOL_1006_65 = 1006,                 /* $@65  */
  YYSYMBOL_simple_when_clause_list = 1007, /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 1008, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 1009,      /* simple_when_clause  */
  YYSYMBOL_1010_66 = 1010,                 /* $@66  */
  YYSYMBOL_1011_67 = 1011,                 /* $@67  */
  YYSYMBOL_searched_when_clause = 1012,    /* searched_when_clause  */
  YYSYMBOL_1013_68 = 1013,                 /* $@68  */
  YYSYMBOL_1014_69 = 1014,                 /* $@69  */
  YYSYMBOL_else_clause_opt = 1015,         /* else_clause_opt  */
  YYSYMBOL_sp_opt_label = 1016,            /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 1017,          /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 1018,        /* sp_labeled_block  */
  YYSYMBOL_1019_70 = 1019,                 /* $@70  */
  YYSYMBOL_1020_71 = 1020,                 /* $@71  */
  YYSYMBOL_1021_72 = 1021,                 /* $@72  */
  YYSYMBOL_opt_not_atomic = 1022,          /* opt_not_atomic  */
  YYSYMBOL_sp_unlabeled_block = 1023,      /* sp_unlabeled_block  */
  YYSYMBOL_1024_73 = 1024,                 /* $@73  */
  YYSYMBOL_1025_74 = 1025,                 /* $@74  */
  YYSYMBOL_1026_75 = 1026,                 /* $@75  */
  YYSYMBOL_sp_instr_addr = 1027,           /* sp_instr_addr  */
  YYSYMBOL_sp_body = 1028,                 /* sp_body  */
  YYSYMBOL_1029_76 = 1029,                 /* $@76  */
  YYSYMBOL_1030_77 = 1030,                 /* $@77  */
  YYSYMBOL_1031_78 = 1031,                 /* $@78  */
  YYSYMBOL_sp_block_statements_and_exceptions = 1032, /* sp_block_statements_and_exceptions  */
  YYSYMBOL_1033_79 = 1033,                 /* $@79  */
  YYSYMBOL_opt_exception_clause = 1034,    /* opt_exception_clause  */
  YYSYMBOL_exception_handlers = 1035,      /* exception_handlers  */
  YYSYMBOL_exception_handler = 1036,       /* exception_handler  */
  YYSYMBOL_1037_80 = 1037,                 /* $@80  */
  YYSYMBOL_opt_sp_for_loop_direction = 1038, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 1039, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_1040_81 = 1040,                 /* $@81  */
  YYSYMBOL_sp_for_loop_bounds = 1041,      /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 1042,               /* loop_body  */
  YYSYMBOL_while_body = 1043,              /* while_body  */
  YYSYMBOL_1044_82 = 1044,                 /* $@82  */
  YYSYMBOL_repeat_body = 1045,             /* repeat_body  */
  YYSYMBOL_1046_83 = 1046,                 /* $@83  */
  YYSYMBOL_pop_sp_loop_label = 1047,       /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 1048,      /* sp_labeled_control  */
  YYSYMBOL_1049_84 = 1049,                 /* $@84  */
  YYSYMBOL_1050_85 = 1050,                 /* $@85  */
  YYSYMBOL_1051_86 = 1051,                 /* $@86  */
  YYSYMBOL_1052_87 = 1052,                 /* $@87  */
  YYSYMBOL_1053_88 = 1053,                 /* $@88  */
  YYSYMBOL_1054_89 = 1054,                 /* $@89  */
  YYSYMBOL_sp_unlabeled_control = 1055,    /* sp_unlabeled_control  */
  YYSYMBOL_1056_90 = 1056,                 /* $@90  */
  YYSYMBOL_1057_91 = 1057,                 /* $@91  */
  YYSYMBOL_1058_92 = 1058,                 /* $@92  */
  YYSYMBOL_1059_93 = 1059,                 /* $@93  */
  YYSYMBOL_1060_94 = 1060,                 /* $@94  */
  YYSYMBOL_trg_action_time = 1061,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1062,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1063, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1064,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1065,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1066,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1067,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1068,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1069, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1070,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1071,   /* change_ts_option_list  */
  YYSYMBOL_1072_95 = 1072,                 /* $@95  */
  YYSYMBOL_change_ts_options = 1073,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1074,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1075,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1076,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1077,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1078, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1079, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1080, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1081, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1082,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1083,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1084, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1085, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1086, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1087,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1088,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1089,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1090,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1091,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1092,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1093,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1094,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1095,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1096,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1097, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1098, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1099,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1100,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1101,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1102,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1103,                 /* ts_wait  */
  YYSYMBOL_size_number = 1104,             /* size_number  */
  YYSYMBOL_create_body = 1105,             /* create_body  */
  YYSYMBOL_1106_96 = 1106,                 /* $@96  */
  YYSYMBOL_create_like = 1107,             /* create_like  */
  YYSYMBOL_opt_create_select = 1108,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1109, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1110, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1111,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1112,            /* partitioning  */
  YYSYMBOL_1113_97 = 1113,                 /* $@97  */
  YYSYMBOL_have_partitioning = 1114,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1115,         /* partition_entry  */
  YYSYMBOL_1116_98 = 1116,                 /* $@98  */
  YYSYMBOL_partition = 1117,               /* partition  */
  YYSYMBOL_1118_99 = 1118,                 /* $@99  */
  YYSYMBOL_part_type_def = 1119,           /* part_type_def  */
  YYSYMBOL_1120_100 = 1120,                /* $@100  */
  YYSYMBOL_1121_101 = 1121,                /* $@101  */
  YYSYMBOL_1122_102 = 1122,                /* $@102  */
  YYSYMBOL_opt_linear = 1123,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1124,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1125,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1126,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1127,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1128,        /* part_column_list  */
  YYSYMBOL_part_func = 1129,               /* part_func  */
  YYSYMBOL_sub_part_func = 1130,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1131,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1132,            /* opt_sub_part  */
  YYSYMBOL_1133_103 = 1133,                /* $@103  */
  YYSYMBOL_1134_104 = 1134,                /* $@104  */
  YYSYMBOL_sub_part_field_list = 1135,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1136,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1137,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1138,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1139,               /* part_defs  */
  YYSYMBOL_part_def_list = 1140,           /* part_def_list  */
  YYSYMBOL_part_definition = 1141,         /* part_definition  */
  YYSYMBOL_1142_105 = 1142,                /* $@105  */
  YYSYMBOL_part_name = 1143,               /* part_name  */
  YYSYMBOL_opt_part_values = 1144,         /* opt_part_values  */
  YYSYMBOL_1145_106 = 1145,                /* $@106  */
  YYSYMBOL_1146_107 = 1146,                /* $@107  */
  YYSYMBOL_part_func_max = 1147,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1148,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1149,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1150,         /* part_value_item  */
  YYSYMBOL_1151_108 = 1151,                /* $@108  */
  YYSYMBOL_1152_109 = 1152,                /* $@109  */
  YYSYMBOL_part_value_item_list = 1153,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1154,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1155,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1156,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1157,     /* sub_part_definition  */
  YYSYMBOL_1158_110 = 1158,                /* $@110  */
  YYSYMBOL_sub_name = 1159,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1160,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1161,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1162,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1163, /* opt_versioning_rotation  */
  YYSYMBOL_1164_111 = 1164,                /* $@111  */
  YYSYMBOL_opt_versioning_interval_start = 1165, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1166,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1167, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1168, /* create_database_options  */
  YYSYMBOL_create_database_option = 1169,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1170, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1171,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1172,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1173, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1174, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1175,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1176,     /* create_table_option  */
  YYSYMBOL_1177_112 = 1177,                /* $@112  */
  YYSYMBOL_opt_versioning_option = 1178,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1179,       /* versioning_option  */
  YYSYMBOL_default_charset = 1180,         /* default_charset  */
  YYSYMBOL_default_collation = 1181,       /* default_collation  */
  YYSYMBOL_storage_engines = 1182,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1183,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1184,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1185,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1186,                /* udf_type  */
  YYSYMBOL_create_field_list = 1187,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1188, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1189,              /* field_list  */
  YYSYMBOL_field_list_item = 1190,         /* field_list_item  */
  YYSYMBOL_column_def = 1191,              /* column_def  */
  YYSYMBOL_key_def = 1192,                 /* key_def  */
  YYSYMBOL_1193_113 = 1193,                /* $@113  */
  YYSYMBOL_1194_114 = 1194,                /* $@114  */
  YYSYMBOL_1195_115 = 1195,                /* $@115  */
  YYSYMBOL_1196_116 = 1196,                /* $@116  */
  YYSYMBOL_1197_117 = 1197,                /* $@117  */
  YYSYMBOL_1198_118 = 1198,                /* $@118  */
  YYSYMBOL_1199_119 = 1199,                /* $@119  */
  YYSYMBOL_constraint_def = 1200,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1201,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1202, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1203,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1204,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1205,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1206,          /* opt_constraint  */
  YYSYMBOL_constraint = 1207,              /* constraint  */
  YYSYMBOL_field_spec = 1208,              /* field_spec  */
  YYSYMBOL_1209_120 = 1209,                /* @120  */
  YYSYMBOL_field_type_or_serial = 1210,    /* field_type_or_serial  */
  YYSYMBOL_1211_121 = 1211,                /* $@121  */
  YYSYMBOL_1212_122 = 1212,                /* $@122  */
  YYSYMBOL_opt_serial_attribute = 1213,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1214, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1215,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1216, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1217,               /* field_def  */
  YYSYMBOL_1218_123 = 1218,                /* $@123  */
  YYSYMBOL_opt_generated_always = 1219,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1220,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1221,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1222, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1223,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1224,         /* parse_vcol_expr  */
  YYSYMBOL_1225_124 = 1225,                /* $@124  */
  YYSYMBOL_parenthesized_expr = 1226,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1227,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1228,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1229,     /* column_default_expr  */
  YYSYMBOL_field_type = 1230,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1231,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1232,          /* field_type_all  */
  YYSYMBOL_sp_param_field_type = 1233,     /* sp_param_field_type  */
  YYSYMBOL_field_type_numeric = 1234,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1235, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1236,       /* field_type_string  */
  YYSYMBOL_sp_param_field_type_string = 1237, /* sp_param_field_type_string  */
  YYSYMBOL_field_type_temporal = 1238,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1239,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1240,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1241,            /* spatial_type  */
  YYSYMBOL_char = 1242,                    /* char  */
  YYSYMBOL_nchar = 1243,                   /* nchar  */
  YYSYMBOL_varchar = 1244,                 /* varchar  */
  YYSYMBOL_nvarchar = 1245,                /* nvarchar  */
  YYSYMBOL_int_type = 1246,                /* int_type  */
  YYSYMBOL_real_type = 1247,               /* real_type  */
  YYSYMBOL_srid_option = 1248,             /* srid_option  */
  YYSYMBOL_float_options = 1249,           /* float_options  */
  YYSYMBOL_precision = 1250,               /* precision  */
  YYSYMBOL_field_options = 1251,           /* field_options  */
  YYSYMBOL_field_length = 1252,            /* field_length  */
  YYSYMBOL_opt_field_length = 1253,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1254, /* opt_field_length_default_1  */
  YYSYMBOL_opt_field_length_default_sp_param_varchar = 1255, /* opt_field_length_default_sp_param_varchar  */
  YYSYMBOL_opt_field_length_default_sp_param_char = 1256, /* opt_field_length_default_sp_param_char  */
  YYSYMBOL_opt_precision = 1257,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1258,          /* attribute_list  */
  YYSYMBOL_attribute = 1259,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1260,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1261,          /* opt_compressed  */
  YYSYMBOL_compressed = 1262,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1263, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1264, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1265,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1266,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1267,  /* with_or_without_system  */
  YYSYMBOL_sp_param_type = 1268,           /* sp_param_type  */
  YYSYMBOL_charset = 1269,                 /* charset  */
  YYSYMBOL_charset_name = 1270,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1271, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1272,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1273, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1274, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1275,          /* collation_name  */
  YYSYMBOL_opt_collate = 1276,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1277, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1278,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1279,        /* charset_or_alias  */
  YYSYMBOL_collate = 1280,                 /* collate  */
  YYSYMBOL_opt_binary = 1281,              /* opt_binary  */
  YYSYMBOL_binary = 1282,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1283,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1284,             /* ws_nweights  */
  YYSYMBOL_1285_125 = 1285,                /* $@125  */
  YYSYMBOL_ws_level_flag_desc = 1286,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1287,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1288,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1289,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1290,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1291,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1292,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1293,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1294,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1295,             /* opt_primary  */
  YYSYMBOL_references = 1296,              /* references  */
  YYSYMBOL_opt_ref_list = 1297,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1298,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1299,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1300,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1301,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1302,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1303,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1304,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1305,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1306,              /* opt_unique  */
  YYSYMBOL_fulltext = 1307,                /* fulltext  */
  YYSYMBOL_spatial = 1308,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1309,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1310,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1311,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1312,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1313,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1314,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1315, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1316, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1317,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1318,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1319,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1320,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1321,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1322,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1323,                /* key_list  */
  YYSYMBOL_key_part = 1324,                /* key_part  */
  YYSYMBOL_opt_ident = 1325,               /* opt_ident  */
  YYSYMBOL_string_list = 1326,             /* string_list  */
  YYSYMBOL_alter = 1327,                   /* alter  */
  YYSYMBOL_1328_126 = 1328,                /* $@126  */
  YYSYMBOL_1329_127 = 1329,                /* $@127  */
  YYSYMBOL_1330_128 = 1330,                /* $@128  */
  YYSYMBOL_1331_129 = 1331,                /* $@129  */
  YYSYMBOL_1332_130 = 1332,                /* $@130  */
  YYSYMBOL_1333_131 = 1333,                /* $@131  */
  YYSYMBOL_1334_132 = 1334,                /* $@132  */
  YYSYMBOL_1335_133 = 1335,                /* $@133  */
  YYSYMBOL_1336_134 = 1336,                /* $@134  */
  YYSYMBOL_1337_135 = 1337,                /* $@135  */
  YYSYMBOL_1338_136 = 1338,                /* $@136  */
  YYSYMBOL_account_locking_option = 1339,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1340, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1341, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1342, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1343,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1344,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1345,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1346,          /* alter_commands  */
  YYSYMBOL_1347_137 = 1347,                /* $@137  */
  YYSYMBOL_1348_138 = 1348,                /* $@138  */
  YYSYMBOL_1349_139 = 1349,                /* $@139  */
  YYSYMBOL_remove_partitioning = 1350,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1351, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1352,      /* add_partition_rule  */
  YYSYMBOL_1353_140 = 1353,                /* $@140  */
  YYSYMBOL_add_part_extra = 1354,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1355,    /* reorg_partition_rule  */
  YYSYMBOL_1356_141 = 1356,                /* $@141  */
  YYSYMBOL_reorg_parts_rule = 1357,        /* reorg_parts_rule  */
  YYSYMBOL_1358_142 = 1358,                /* $@142  */
  YYSYMBOL_alt_part_name_list = 1359,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1360,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1361,              /* alter_list  */
  YYSYMBOL_add_column = 1362,              /* add_column  */
  YYSYMBOL_alter_list_item = 1363,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1364, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1365,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1366,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1367,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1368,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1369,           /* alter_options  */
  YYSYMBOL_1370_143 = 1370,                /* $@143  */
  YYSYMBOL_alter_options_part2 = 1371,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1372,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1373,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1374,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1375,               /* opt_place  */
  YYSYMBOL_opt_to = 1376,                  /* opt_to  */
  YYSYMBOL_slave = 1377,                   /* slave  */
  YYSYMBOL_1378_144 = 1378,                /* $@144  */
  YYSYMBOL_1379_145 = 1379,                /* $@145  */
  YYSYMBOL_start = 1380,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1381, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1382, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1383, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1384,       /* slave_thread_opts  */
  YYSYMBOL_1385_146 = 1385,                /* $@146  */
  YYSYMBOL_slave_thread_opt_list = 1386,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1387,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1388,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1389,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1390,                /* checksum  */
  YYSYMBOL_1391_147 = 1391,                /* $@147  */
  YYSYMBOL_opt_checksum_type = 1392,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1393,    /* repair_table_or_view  */
  YYSYMBOL_1394_148 = 1394,                /* $@148  */
  YYSYMBOL_repair = 1395,                  /* repair  */
  YYSYMBOL_1396_149 = 1396,                /* $@149  */
  YYSYMBOL_opt_mi_repair_type = 1397,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1398,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1399,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1400,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1401,                 /* analyze  */
  YYSYMBOL_1402_150 = 1402,                /* $@150  */
  YYSYMBOL_analyze_table_list = 1403,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1404, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1405, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1406,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1407, /* persistent_column_stat_spec  */
  YYSYMBOL_1408_151 = 1408,                /* $@151  */
  YYSYMBOL_persistent_index_stat_spec = 1409, /* persistent_index_stat_spec  */
  YYSYMBOL_1410_152 = 1410,                /* $@152  */
  YYSYMBOL_table_column_list = 1411,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1412,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1413,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1414,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1415,     /* check_view_or_table  */
  YYSYMBOL_1416_153 = 1416,                /* $@153  */
  YYSYMBOL_check = 1417,                   /* check  */
  YYSYMBOL_1418_154 = 1418,                /* $@154  */
  YYSYMBOL_opt_mi_check_type = 1419,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1420,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1421,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1422,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1423,                /* optimize  */
  YYSYMBOL_1424_155 = 1424,                /* $@155  */
  YYSYMBOL_opt_no_write_to_binlog = 1425,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1426,                  /* rename  */
  YYSYMBOL_1427_156 = 1427,                /* $@156  */
  YYSYMBOL_rename_list = 1428,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1429,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1430,          /* table_to_table  */
  YYSYMBOL_keycache = 1431,                /* keycache  */
  YYSYMBOL_1432_157 = 1432,                /* $@157  */
  YYSYMBOL_keycache_list_or_parts = 1433,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1434,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1435,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1436, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1437,          /* key_cache_name  */
  YYSYMBOL_preload = 1438,                 /* preload  */
  YYSYMBOL_1439_158 = 1439,                /* $@158  */
  YYSYMBOL_preload_list_or_parts = 1440,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1441,            /* preload_list  */
  YYSYMBOL_preload_keys = 1442,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1443,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1444,           /* adm_partition  */
  YYSYMBOL_1445_159 = 1445,                /* $@159  */
  YYSYMBOL_cache_keys_spec = 1446,         /* cache_keys_spec  */
  YYSYMBOL_1447_160 = 1447,                /* $@160  */
  YYSYMBOL_cache_key_list_or_empty = 1448, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1449,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1450,                  /* select  */
  YYSYMBOL_1451_161 = 1451,                /* $@161  */
  YYSYMBOL_1452_162 = 1452,                /* $@162  */
  YYSYMBOL_select_into = 1453,             /* select_into  */
  YYSYMBOL_1454_163 = 1454,                /* $@163  */
  YYSYMBOL_1455_164 = 1455,                /* $@164  */
  YYSYMBOL_simple_table = 1456,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1457, /* table_value_constructor  */
  YYSYMBOL_1458_165 = 1458,                /* $@165  */
  YYSYMBOL_query_specification_start = 1459, /* query_specification_start  */
  YYSYMBOL_1460_166 = 1460,                /* $@166  */
  YYSYMBOL_1461_167 = 1461,                /* $@167  */
  YYSYMBOL_query_specification = 1462,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1463, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1464,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1465, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1466, /* query_expression_body_ext  */
  YYSYMBOL_1467_168 = 1467,                /* $@168  */
  YYSYMBOL_1468_169 = 1468,                /* $@169  */
  YYSYMBOL_query_expression_body_ext_parens = 1469, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1470,   /* query_expression_body  */
  YYSYMBOL_1471_170 = 1471,                /* $@170  */
  YYSYMBOL_query_primary = 1472,           /* query_primary  */
  YYSYMBOL_query_simple = 1473,            /* query_simple  */
  YYSYMBOL_subselect = 1474,               /* subselect  */
  YYSYMBOL_subquery = 1475,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1476,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1477,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1478,    /* table_reference_list  */
  YYSYMBOL_select_options = 1479,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1480,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1481,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1482, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1483, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1484, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1485,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1486,      /* select_option_list  */
  YYSYMBOL_select_option = 1487,           /* select_option  */
  YYSYMBOL_select_lock_type = 1488,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1489,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1490, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1491,        /* select_item_list  */
  YYSYMBOL_select_item = 1492,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1493,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1494,           /* remember_name  */
  YYSYMBOL_remember_end = 1495,            /* remember_end  */
  YYSYMBOL_remember_end_opt = 1496,        /* remember_end_opt  */
  YYSYMBOL_select_alias = 1497,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1498, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1499,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1500,         /* optional_braces  */
  YYSYMBOL_expr = 1501,                    /* expr  */
  YYSYMBOL_boolean_test = 1502,            /* boolean_test  */
  YYSYMBOL_predicate = 1503,               /* predicate  */
  YYSYMBOL_bit_expr = 1504,                /* bit_expr  */
  YYSYMBOL_or = 1505,                      /* or  */
  YYSYMBOL_and = 1506,                     /* and  */
  YYSYMBOL_not = 1507,                     /* not  */
  YYSYMBOL_not2 = 1508,                    /* not2  */
  YYSYMBOL_comp_op = 1509,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1510,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1511,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1512,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1513,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1514,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1515,      /* string_dyncol_type  */
  YYSYMBOL_1516_171 = 1516,                /* $@171  */
  YYSYMBOL_dyncall_create_element = 1517,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1518,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1519,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1520,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1521,           /* trim_operands  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1522, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1523,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1524,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1525,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1526, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1527, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1528,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1529,      /* substring_operands  */
  YYSYMBOL_function_call_nonkeyword = 1530, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1531,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1532,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1533,   /* function_call_generic  */
  YYSYMBOL_1534_172 = 1534,                /* @172  */
  YYSYMBOL_fulltext_options = 1535,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1536, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1537,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1538,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1539,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1540,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1541,                /* sum_expr  */
  YYSYMBOL_1542_173 = 1542,                /* $@173  */
  YYSYMBOL_1543_174 = 1543,                /* $@174  */
  YYSYMBOL_1544_175 = 1544,                /* $@175  */
  YYSYMBOL_window_func_expr = 1545,        /* window_func_expr  */
  YYSYMBOL_window_func = 1546,             /* window_func  */
  YYSYMBOL_simple_window_func = 1547,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1548, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1549,     /* percentile_function  */
  YYSYMBOL_1550_176 = 1550,                /* $@176  */
  YYSYMBOL_inverse_distribution_function_def = 1551, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1552, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1553,             /* window_name  */
  YYSYMBOL_variable = 1554,                /* variable  */
  YYSYMBOL_1555_177 = 1555,                /* $@177  */
  YYSYMBOL_variable_aux = 1556,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1557,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1558,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1559,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1560,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1561,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1562,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1563,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1564,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1565,             /* in_sum_expr  */
  YYSYMBOL_1566_178 = 1566,                /* $@178  */
  YYSYMBOL_cast_type = 1567,               /* cast_type  */
  YYSYMBOL_1568_179 = 1568,                /* $@179  */
  YYSYMBOL_1569_180 = 1569,                /* $@180  */
  YYSYMBOL_1570_181 = 1570,                /* $@181  */
  YYSYMBOL_cast_type_numeric = 1571,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1572,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1573,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1574,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1575,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1576,              /* ident_list  */
  YYSYMBOL_when_list = 1577,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1578,      /* when_list_opt_else  */
  YYSYMBOL_table_ref = 1579,               /* table_ref  */
  YYSYMBOL_join_table_list = 1580,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1581,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1582,      /* derived_table_list  */
  YYSYMBOL_join_table = 1583,              /* join_table  */
  YYSYMBOL_1584_182 = 1584,                /* $@182  */
  YYSYMBOL_1585_183 = 1585,                /* $@183  */
  YYSYMBOL_1586_184 = 1586,                /* $@184  */
  YYSYMBOL_1587_185 = 1587,                /* $@185  */
  YYSYMBOL_1588_186 = 1588,                /* $@186  */
  YYSYMBOL_1589_187 = 1589,                /* $@187  */
  YYSYMBOL_inner_join = 1590,              /* inner_join  */
  YYSYMBOL_normal_join = 1591,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1592,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1593,           /* use_partition  */
  YYSYMBOL_table_factor = 1594,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1595, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1596, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1597, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1598, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1599,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1600,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1601,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1602,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1603,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1604,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1605,   /* index_hint_definition  */
  YYSYMBOL_1606_188 = 1606,                /* $@188  */
  YYSYMBOL_1607_189 = 1607,                /* $@189  */
  YYSYMBOL_index_hints_list = 1608,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1609,    /* opt_index_hints_list  */
  YYSYMBOL_1610_190 = 1610,                /* $@190  */
  YYSYMBOL_opt_key_definition = 1611,      /* opt_key_definition  */
  YYSYMBOL_1612_191 = 1612,                /* $@191  */
  YYSYMBOL_opt_key_usage_list = 1613,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1614,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1615,          /* key_usage_list  */
  YYSYMBOL_using_list = 1616,              /* using_list  */
  YYSYMBOL_interval = 1617,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1618,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1619,          /* date_time_type  */
  YYSYMBOL_table_alias = 1620,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1621,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1622,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1623,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1624,        /* opt_where_clause  */
  YYSYMBOL_1625_192 = 1625,                /* $@192  */
  YYSYMBOL_opt_having_clause = 1626,       /* opt_having_clause  */
  YYSYMBOL_1627_193 = 1627,                /* $@193  */
  YYSYMBOL_opt_group_clause = 1628,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1629,              /* group_list  */
  YYSYMBOL_olap_opt = 1630,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1631,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1632,         /* window_def_list  */
  YYSYMBOL_window_def = 1633,              /* window_def  */
  YYSYMBOL_window_spec = 1634,             /* window_spec  */
  YYSYMBOL_1635_194 = 1635,                /* $@194  */
  YYSYMBOL_opt_window_ref = 1636,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1637, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1638, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1639, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1640,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1641,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1642,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1643,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1644, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1645,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1646,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1647,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1648,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1649,            /* order_clause  */
  YYSYMBOL_1650_195 = 1650,                /* $@195  */
  YYSYMBOL_order_list = 1651,              /* order_list  */
  YYSYMBOL_order_dir = 1652,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1653,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1654,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1655, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1656,           /* limit_options  */
  YYSYMBOL_limit_option = 1657,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1658,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1659,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1660,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1661,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1662,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1663, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1664,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1665,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1666,                /* opt_plus  */
  YYSYMBOL_int_num = 1667,                 /* int_num  */
  YYSYMBOL_ulong_num = 1668,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1669,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1670,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1671,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1672,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1673,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1674,                 /* dec_num  */
  YYSYMBOL_choice = 1675,                  /* choice  */
  YYSYMBOL_bool = 1676,                    /* bool  */
  YYSYMBOL_procedure_clause = 1677,        /* procedure_clause  */
  YYSYMBOL_1678_196 = 1678,                /* $@196  */
  YYSYMBOL_procedure_list = 1679,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1680,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1681,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1682,    /* select_var_list_init  */
  YYSYMBOL_1683_197 = 1683,                /* $@197  */
  YYSYMBOL_select_var_list = 1684,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1685,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1686,           /* select_outvar  */
  YYSYMBOL_into = 1687,                    /* into  */
  YYSYMBOL_into_destination = 1688,        /* into_destination  */
  YYSYMBOL_1689_198 = 1689,                /* $@198  */
  YYSYMBOL_1690_199 = 1690,                /* $@199  */
  YYSYMBOL_do = 1691,                      /* do  */
  YYSYMBOL_1692_200 = 1692,                /* $@200  */
  YYSYMBOL_drop = 1693,                    /* drop  */
  YYSYMBOL_1694_201 = 1694,                /* $@201  */
  YYSYMBOL_1695_202 = 1695,                /* $@202  */
  YYSYMBOL_1696_203 = 1696,                /* $@203  */
  YYSYMBOL_1697_204 = 1697,                /* $@204  */
  YYSYMBOL_table_list = 1698,              /* table_list  */
  YYSYMBOL_table_name = 1699,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1700, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1701,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1702,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1703, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1704,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1705,           /* opt_temporary  */
  YYSYMBOL_insert = 1706,                  /* insert  */
  YYSYMBOL_1707_205 = 1707,                /* $@205  */
  YYSYMBOL_1708_206 = 1708,                /* $@206  */
  YYSYMBOL_replace = 1709,                 /* replace  */
  YYSYMBOL_1710_207 = 1710,                /* $@207  */
  YYSYMBOL_1711_208 = 1711,                /* $@208  */
  YYSYMBOL_insert_lock_option = 1712,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1713,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1714,                 /* insert2  */
  YYSYMBOL_insert_table = 1715,            /* insert_table  */
  YYSYMBOL_1716_209 = 1716,                /* $@209  */
  YYSYMBOL_insert_field_spec = 1717,       /* insert_field_spec  */
  YYSYMBOL_1718_210 = 1718,                /* $@210  */
  YYSYMBOL_insert_field_list = 1719,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1720,              /* opt_fields  */
  YYSYMBOL_fields = 1721,                  /* fields  */
  YYSYMBOL_insert_values = 1722,           /* insert_values  */
  YYSYMBOL_values_list = 1723,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1724,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1725,          /* ident_eq_value  */
  YYSYMBOL_equal = 1726,                   /* equal  */
  YYSYMBOL_opt_equal = 1727,               /* opt_equal  */
  YYSYMBOL_opt_with = 1728,                /* opt_with  */
  YYSYMBOL_opt_by = 1729,                  /* opt_by  */
  YYSYMBOL_no_braces = 1730,               /* no_braces  */
  YYSYMBOL_1731_211 = 1731,                /* $@211  */
  YYSYMBOL_no_braces_with_names = 1732,    /* no_braces_with_names  */
  YYSYMBOL_1733_212 = 1733,                /* $@212  */
  YYSYMBOL_opt_values = 1734,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1735,   /* opt_values_with_names  */
  YYSYMBOL_values = 1736,                  /* values  */
  YYSYMBOL_values_with_names = 1737,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1738,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1739, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1740,       /* opt_insert_update  */
  YYSYMBOL_1741_213 = 1741,                /* $@213  */
  YYSYMBOL_1742_214 = 1742,                /* $@214  */
  YYSYMBOL_update_table_list = 1743,       /* update_table_list  */
  YYSYMBOL_update = 1744,                  /* update  */
  YYSYMBOL_1745_215 = 1745,                /* $@215  */
  YYSYMBOL_1746_216 = 1746,                /* $@216  */
  YYSYMBOL_update_list = 1747,             /* update_list  */
  YYSYMBOL_update_elem = 1748,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1749,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1750,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1751,        /* opt_low_priority  */
  YYSYMBOL_delete = 1752,                  /* delete  */
  YYSYMBOL_1753_217 = 1753,                /* $@217  */
  YYSYMBOL_opt_delete_system_time = 1754,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1755,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1756,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1757, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1758,            /* single_multi  */
  YYSYMBOL_1759_218 = 1759,                /* $@218  */
  YYSYMBOL_1760_219 = 1760,                /* $@219  */
  YYSYMBOL_opt_select_expressions = 1761,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1762,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1763,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1764,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1765,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1766,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1767,                /* truncate  */
  YYSYMBOL_1768_220 = 1768,                /* $@220  */
  YYSYMBOL_1769_221 = 1769,                /* $@221  */
  YYSYMBOL_opt_truncate_table_storage_clause = 1770, /* opt_truncate_table_storage_clause  */
  YYSYMBOL_opt_table_sym = 1771,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1772,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1773,            /* profile_defs  */
  YYSYMBOL_profile_def = 1774,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1775,        /* opt_profile_args  */
  YYSYMBOL_show = 1776,                    /* show  */
  YYSYMBOL_1777_222 = 1777,                /* $@222  */
  YYSYMBOL_show_param = 1778,              /* show_param  */
  YYSYMBOL_1779_223 = 1779,                /* $@223  */
  YYSYMBOL_1780_224 = 1780,                /* $@224  */
  YYSYMBOL_show_engine_param = 1781,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1782,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1783,             /* opt_storage  */
  YYSYMBOL_opt_db = 1784,                  /* opt_db  */
  YYSYMBOL_opt_full = 1785,                /* opt_full  */
  YYSYMBOL_from_or_in = 1786,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1787,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1788,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1789,          /* wild_and_where  */
  YYSYMBOL_describe = 1790,                /* describe  */
  YYSYMBOL_1791_225 = 1791,                /* $@225  */
  YYSYMBOL_1792_226 = 1792,                /* $@226  */
  YYSYMBOL_explainable_command = 1793,     /* explainable_command  */
  YYSYMBOL_describe_command = 1794,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1795,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1796,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1797,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1798,     /* opt_describe_column  */
  YYSYMBOL_flush = 1799,                   /* flush  */
  YYSYMBOL_1800_227 = 1800,                /* $@227  */
  YYSYMBOL_flush_options = 1801,           /* flush_options  */
  YYSYMBOL_1802_228 = 1802,                /* $@228  */
  YYSYMBOL_opt_flush_lock = 1803,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1804,              /* flush_lock  */
  YYSYMBOL_1805_229 = 1805,                /* $@229  */
  YYSYMBOL_flush_options_list = 1806,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1807,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1808,          /* opt_table_list  */
  YYSYMBOL_backup = 1809,                  /* backup  */
  YYSYMBOL_backup_statements = 1810,       /* backup_statements  */
  YYSYMBOL_1811_230 = 1811,                /* $@230  */
  YYSYMBOL_opt_delete_gtid_domain = 1812,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1813,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1814,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1815, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1816,                   /* reset  */
  YYSYMBOL_1817_231 = 1817,                /* $@231  */
  YYSYMBOL_reset_options = 1818,           /* reset_options  */
  YYSYMBOL_reset_option = 1819,            /* reset_option  */
  YYSYMBOL_1820_232 = 1820,                /* $@232  */
  YYSYMBOL_1821_233 = 1821,                /* $@233  */
  YYSYMBOL_slave_reset_options = 1822,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1823,    /* master_reset_options  */
  YYSYMBOL_purge = 1824,                   /* purge  */
  YYSYMBOL_1825_234 = 1825,                /* $@234  */
  YYSYMBOL_kill = 1826,                    /* kill  */
  YYSYMBOL_1827_235 = 1827,                /* $@235  */
  YYSYMBOL_kill_type = 1828,               /* kill_type  */
  YYSYMBOL_kill_option = 1829,             /* kill_option  */
  YYSYMBOL_opt_connection = 1830,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1831,               /* kill_expr  */
  YYSYMBOL_shutdown = 1832,                /* shutdown  */
  YYSYMBOL_1833_236 = 1833,                /* $@236  */
  YYSYMBOL_shutdown_option = 1834,         /* shutdown_option  */
  YYSYMBOL_use = 1835,                     /* use  */
  YYSYMBOL_load = 1836,                    /* load  */
  YYSYMBOL_1837_237 = 1837,                /* $@237  */
  YYSYMBOL_1838_238 = 1838,                /* $@238  */
  YYSYMBOL_1839_239 = 1839,                /* $@239  */
  YYSYMBOL_1840_240 = 1840,                /* $@240  */
  YYSYMBOL_data_or_xml = 1841,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1842,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1843,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1844,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1845,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1846,         /* field_term_list  */
  YYSYMBOL_field_term = 1847,              /* field_term  */
  YYSYMBOL_opt_line_term = 1848,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1849,          /* line_term_list  */
  YYSYMBOL_line_term = 1850,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1851, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1852,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1853,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1854,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1855,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1856,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1857,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1858,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1859,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1860,            /* text_literal  */
  YYSYMBOL_text_string = 1861,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1862,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1863,            /* param_marker  */
  YYSYMBOL_signed_literal = 1864,          /* signed_literal  */
  YYSYMBOL_literal = 1865,                 /* literal  */
  YYSYMBOL_NUM_literal = 1866,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1867,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1868,             /* with_clause  */
  YYSYMBOL_1869_241 = 1869,                /* $@241  */
  YYSYMBOL_opt_recursive = 1870,           /* opt_recursive  */
  YYSYMBOL_with_list = 1871,               /* with_list  */
  YYSYMBOL_with_list_element = 1872,       /* with_list_element  */
  YYSYMBOL_1873_242 = 1873,                /* $@242  */
  YYSYMBOL_opt_with_column_list = 1874,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1875,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1876,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1877,            /* insert_ident  */
  YYSYMBOL_table_wild = 1878,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1879, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1880,             /* order_ident  */
  YYSYMBOL_simple_ident = 1881,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1882,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1883,             /* field_ident  */
  YYSYMBOL_table_ident = 1884,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1885,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1886,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1887,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1888,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1889,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1890,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1891,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1892,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1893,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1894,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1895,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1896,                   /* ident  */
  YYSYMBOL_ident_directly_assignable = 1897, /* ident_directly_assignable  */
  YYSYMBOL_label_ident = 1898,             /* label_ident  */
  YYSYMBOL_labels_declaration_oracle = 1899, /* labels_declaration_oracle  */
  YYSYMBOL_label_declaration_oracle = 1900, /* label_declaration_oracle  */
  YYSYMBOL_ident_or_text = 1901,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1902,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1903,            /* user_or_role  */
  YYSYMBOL_user = 1904,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1905,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1906,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1907,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1908,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1909,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1910,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_directly_assignable = 1911, /* keyword_directly_assignable  */
  YYSYMBOL_keyword_sp_var_not_label = 1912, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1913,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1914,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1915, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1916, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1917,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1918,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1919, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1920,                     /* set  */
  YYSYMBOL_1921_243 = 1921,                /* $@243  */
  YYSYMBOL_1922_244 = 1922,                /* $@244  */
  YYSYMBOL_1923_245 = 1923,                /* $@245  */
  YYSYMBOL_set_assign = 1924,              /* set_assign  */
  YYSYMBOL_1925_246 = 1925,                /* $@246  */
  YYSYMBOL_1926_247 = 1926,                /* $@247  */
  YYSYMBOL_1927_248 = 1927,                /* $@248  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1928, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1929, /* start_option_value_list  */
  YYSYMBOL_1930_249 = 1930,                /* $@249  */
  YYSYMBOL_1931_250 = 1931,                /* $@250  */
  YYSYMBOL_1932_251 = 1932,                /* $@251  */
  YYSYMBOL_start_option_value_list_following_option_type = 1933, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1934_252 = 1934,                /* $@252  */
  YYSYMBOL_option_value_list_continued = 1935, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1936,       /* option_value_list  */
  YYSYMBOL_1937_253 = 1937,                /* $@253  */
  YYSYMBOL_1938_254 = 1938,                /* $@254  */
  YYSYMBOL_option_value = 1939,            /* option_value  */
  YYSYMBOL_1940_255 = 1940,                /* $@255  */
  YYSYMBOL_option_type = 1941,             /* option_type  */
  YYSYMBOL_opt_var_type = 1942,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1943,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1944, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1945, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1946, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1947, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1948,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1949, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1950,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1951,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1952,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1953,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1954,                    /* lock  */
  YYSYMBOL_1955_256 = 1955,                /* $@256  */
  YYSYMBOL_opt_lock_wait_timeout = 1956,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1957,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1958,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1959,              /* table_lock  */
  YYSYMBOL_lock_option = 1960,             /* lock_option  */
  YYSYMBOL_unlock = 1961,                  /* unlock  */
  YYSYMBOL_1962_257 = 1962,                /* $@257  */
  YYSYMBOL_handler = 1963,                 /* handler  */
  YYSYMBOL_1964_258 = 1964,                /* $@258  */
  YYSYMBOL_handler_tail = 1965,            /* handler_tail  */
  YYSYMBOL_1966_259 = 1966,                /* $@259  */
  YYSYMBOL_handler_read_or_scan = 1967,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1968,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1969,   /* handler_rkey_function  */
  YYSYMBOL_1970_260 = 1970,                /* $@260  */
  YYSYMBOL_handler_rkey_mode = 1971,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1972,                  /* revoke  */
  YYSYMBOL_revoke_command = 1973,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1974,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1975,                   /* grant  */
  YYSYMBOL_grant_command = 1976,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1977,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1978,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1979,               /* role_list  */
  YYSYMBOL_current_role = 1980,            /* current_role  */
  YYSYMBOL_grant_role = 1981,              /* grant_role  */
  YYSYMBOL_opt_table = 1982,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1983,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1984,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1985,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1986,        /* object_privilege  */
  YYSYMBOL_1987_261 = 1987,                /* $@261  */
  YYSYMBOL_1988_262 = 1988,                /* $@262  */
  YYSYMBOL_1989_263 = 1989,                /* $@263  */
  YYSYMBOL_1990_264 = 1990,                /* $@264  */
  YYSYMBOL_opt_and = 1991,                 /* opt_and  */
  YYSYMBOL_require_list = 1992,            /* require_list  */
  YYSYMBOL_require_list_element = 1993,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1994,             /* grant_ident  */
  YYSYMBOL_user_list = 1995,               /* user_list  */
  YYSYMBOL_grant_list = 1996,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 1997,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 1998,             /* via_or_with  */
  YYSYMBOL_using_or_as = 1999,             /* using_or_as  */
  YYSYMBOL_grant_user = 2000,              /* grant_user  */
  YYSYMBOL_auth_expression = 2001,         /* auth_expression  */
  YYSYMBOL_auth_token = 2002,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 2003,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 2004,         /* opt_column_list  */
  YYSYMBOL_column_list = 2005,             /* column_list  */
  YYSYMBOL_column_list_id = 2006,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 2007,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 2008,         /* resource_option  */
  YYSYMBOL_resource_option_list = 2009,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 2010,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 2011,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 2012,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 2013,       /* grant_option_list  */
  YYSYMBOL_grant_option = 2014,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 2015,      /* begin_stmt_mariadb  */
  YYSYMBOL_2016_265 = 2016,                /* $@265  */
  YYSYMBOL_compound_statement = 2017,      /* compound_statement  */
  YYSYMBOL_opt_not = 2018,                 /* opt_not  */
  YYSYMBOL_opt_work = 2019,                /* opt_work  */
  YYSYMBOL_opt_chain = 2020,               /* opt_chain  */
  YYSYMBOL_opt_release = 2021,             /* opt_release  */
  YYSYMBOL_commit = 2022,                  /* commit  */
  YYSYMBOL_rollback = 2023,                /* rollback  */
  YYSYMBOL_savepoint = 2024,               /* savepoint  */
  YYSYMBOL_release = 2025,                 /* release  */
  YYSYMBOL_unit_type_decl = 2026,          /* unit_type_decl  */
  YYSYMBOL_union_option = 2027,            /* union_option  */
  YYSYMBOL_query_expression_option = 2028, /* query_expression_option  */
  YYSYMBOL_definer_opt = 2029,             /* definer_opt  */
  YYSYMBOL_no_definer = 2030,              /* no_definer  */
  YYSYMBOL_definer = 2031,                 /* definer  */
  YYSYMBOL_view_algorithm = 2032,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 2033,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 2034,               /* view_suid  */
  YYSYMBOL_view_list_opt = 2035,           /* view_list_opt  */
  YYSYMBOL_view_list = 2036,               /* view_list  */
  YYSYMBOL_view_select = 2037,             /* view_select  */
  YYSYMBOL_2038_266 = 2038,                /* $@266  */
  YYSYMBOL_view_check_option = 2039,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 2040,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 2041, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 2042,            /* trigger_tail  */
  YYSYMBOL_2043_267 = 2043,                /* $@267  */
  YYSYMBOL_2044_268 = 2044,                /* $@268  */
  YYSYMBOL_2045_269 = 2045,                /* $@269  */
  YYSYMBOL_2046_270 = 2046,                /* $@270  */
  YYSYMBOL_2047_271 = 2047,                /* $@271  */
  YYSYMBOL_sf_return_type = 2048,          /* sf_return_type  */
  YYSYMBOL_2049_272 = 2049,                /* $@272  */
  YYSYMBOL_sf_c_chistics_and_body_standalone = 2050, /* sf_c_chistics_and_body_standalone  */
  YYSYMBOL_2051_273 = 2051,                /* $@273  */
  YYSYMBOL_sp_tail_standalone = 2052,      /* sp_tail_standalone  */
  YYSYMBOL_2053_274 = 2053,                /* $@274  */
  YYSYMBOL_2054_275 = 2054,                /* $@275  */
  YYSYMBOL_opt_package_routine_end_name = 2055, /* opt_package_routine_end_name  */
  YYSYMBOL_sp_tail_is = 2056,              /* sp_tail_is  */
  YYSYMBOL_xa = 2057,                      /* xa  */
  YYSYMBOL_opt_format_xid = 2058,          /* opt_format_xid  */
  YYSYMBOL_xid = 2059,                     /* xid  */
  YYSYMBOL_begin_or_start = 2060,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 2061,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 2062,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 2063,             /* opt_suspend  */
  YYSYMBOL_2064_276 = 2064,                /* $@276  */
  YYSYMBOL_opt_migrate = 2065,             /* opt_migrate  */
  YYSYMBOL_install = 2066,                 /* install  */
  YYSYMBOL_uninstall = 2067,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 2068           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 304 "/home/buildbot/git/sql/sql_yacc_ora.yy"

bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  751
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   94064

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  779
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1290
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3550
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6129

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1012


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   773,     2,     2,     2,   762,   757,     2,
     769,   770,   760,   759,   772,   758,   777,   761,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   776,
     755,   753,   754,     2,   778,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   763,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   774,   756,   775,   764,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   765,   766,
     767,   768,   771
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1755,  1755,  1765,  1764,  1789,  1796,  1798,  1802,  1803,
    1804,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1872,  1879,  1880,  1885,  1884,  1895,  1901,  1903,  1900,
    1912,  1914,  1913,  1923,  1928,  1940,  1939,  1956,  1955,  1964,
    1965,  1969,  1973,  1977,  1981,  1985,  1989,  1999,  2004,  2008,
    2012,  2016,  2020,  2024,  2029,  2033,  2038,  2066,  2070,  2074,
    2079,  2082,  2084,  2085,  2089,  2095,  2097,  2098,  2102,  2108,
    2110,  2111,  2115,  2122,  2126,  2141,  2145,  2151,  2157,  2163,
    2173,  2177,  2181,  2195,  2207,  2194,  2230,  2229,  2285,  2292,
    2284,  2304,  2310,  2303,  2322,  2328,  2321,  2340,  2339,  2354,
    2352,  2368,  2366,  2380,  2379,  2390,  2389,  2399,  2398,  2410,
    2408,  2423,  2421,  2437,  2435,  2450,  2448,  2462,  2469,  2476,
    2483,  2487,  2491,  2491,  2498,  2494,  2518,  2530,  2535,  2514,
    2548,  2554,  2562,  2563,  2564,  2570,  2571,  2577,  2578,  2584,
    2595,  2594,  2622,  2621,  2648,  2657,  2666,  2672,  2671,  2690,
    2689,  2708,  2711,  2713,  2717,  2718,  2722,  2729,  2740,  2741,
    2745,  2746,  2750,  2755,  2761,  2767,  2775,  2781,  2787,  2795,
    2803,  2811,  2819,  2827,  2835,  2847,  2863,  2863,  2867,  2866,
    2878,  2879,  2883,  2888,  2893,  2898,  2903,  2908,  2913,  2921,
    2920,  2953,  2952,  2959,  2966,  2967,  2973,  2979,  2989,  2995,
    3001,  3003,  3010,  3011,  3015,  3025,  3026,  3034,  3034,  3076,
    3088,  3089,  3093,  3098,  3106,  3107,  3111,  3112,  3116,  3117,
    3122,  3124,  3126,  3128,  3130,  3132,  3134,  3139,  3141,  3146,
    3147,  3150,  3152,  3156,  3156,  3162,  3163,  3167,  3168,  3173,
    3172,  3183,  3182,  3193,  3192,  3205,  3207,  3210,  3212,  3216,
    3220,  3229,  3234,  3234,  3244,  3245,  3249,  3257,  3262,  3267,
    3272,  3277,  3282,  3290,  3292,  3296,  3297,  3301,  3307,  3313,
    3319,  3325,  3331,  3340,  3341,  3342,  3343,  3344,  3349,  3348,
    3361,  3368,  3369,  3373,  3374,  3378,  3379,  3383,  3384,  3388,
    3388,  3400,  3403,  3408,  3407,  3416,  3420,  3421,  3428,  3429,
    3436,  3437,  3441,  3447,  3453,  3462,  3470,  3474,  3479,  3487,
    3491,  3498,  3508,  3516,  3524,  3535,  3536,  3543,  3554,  3553,
    3572,  3571,  3585,  3587,  3592,  3602,  3601,  3620,  3621,  3622,
    3623,  3628,  3630,  3635,  3650,  3658,  3662,  3682,  3683,  3687,
    3691,  3697,  3703,  3709,  3715,  3725,  3730,  3738,  3746,  3761,
    3767,  3768,  3774,  3777,  3781,  3789,  3806,  3808,  3826,  3832,
    3834,  3836,  3838,  3840,  3842,  3844,  3846,  3848,  3850,  3852,
    3854,  3859,  3867,  3883,  3884,  3889,  3895,  3904,  3911,  3920,
    3929,  3934,  3943,  3945,  3947,  3956,  3961,  3968,  3977,  3986,
    3988,  3990,  3992,  3994,  3996,  3998,  4000,  4002,  4004,  4006,
    4008,  4010,  4015,  4016,  4024,  4036,  4051,  4052,  4053,  4057,
    4058,  4059,  4060,  4061,  4062,  4066,  4067,  4068,  4069,  4070,
    4071,  4072,  4073,  4074,  4075,  4076,  4077,  4078,  4082,  4083,
    4084,  4085,  4090,  4089,  4100,  4102,  4101,  4113,  4112,  4123,
    4122,  4135,  4135,  4157,  4158,  4163,  4162,  4180,  4191,  4191,
    4204,  4209,  4214,  4220,  4229,  4234,  4239,  4245,  4255,  4263,
    4271,  4280,  4286,  4296,  4295,  4317,  4316,  4337,  4343,  4351,
    4352,  4356,  4364,  4369,  4374,  4382,  4383,  4391,  4409,  4424,
    4442,  4448,  4465,  4442,  4484,  4486,  4487,  4492,  4491,  4561,
    4567,  4561,  4577,  4582,  4583,  4587,  4588,  4593,  4599,  4592,
    4620,  4626,  4619,  4645,  4655,  4659,  4660,  4664,  4675,  4673,
    4689,  4693,  4687,  4708,  4710,  4715,  4714,  4729,  4735,  4728,
    4750,  4754,  4758,  4764,  4754,  4775,  4773,  4788,  4789,  4793,
    4794,  4799,  4798,  4814,  4815,  4820,  4819,  4833,  4838,  4845,
    4854,  4869,  4868,  4888,  4887,  4912,  4921,  4920,  4928,  4927,
    4938,  4943,  4952,  4937,  4962,  4961,  4972,  4971,  4981,  4980,
    4993,  5000,  4992,  5017,  5016,  5028,  5030,  5035,  5037,  5039,
    5056,  5061,  5067,  5074,  5075,  5083,  5089,  5098,  5104,  5110,
    5111,  5115,  5115,  5120,  5121,  5122,  5126,  5127,  5128,  5132,
    5136,  5137,  5138,  5142,  5143,  5144,  5145,  5146,  5147,  5148,
    5149,  5153,  5157,  5158,  5159,  5163,  5164,  5165,  5166,  5167,
    5171,  5175,  5176,  5177,  5181,  5182,  5183,  5184,  5185,  5186,
    5187,  5191,  5195,  5196,  5197,  5201,  5202,  5203,  5208,  5216,
    5224,  5232,  5245,  5258,  5263,  5268,  5276,  5284,  5292,  5300,
    5308,  5316,  5324,  5334,  5344,  5354,  5356,  5360,  5365,  5375,
    5376,  5389,  5388,  5391,  5392,  5406,  5407,  5411,  5412,  5421,
    5426,  5437,  5474,  5475,  5480,  5479,  5495,  5510,  5509,  5532,
    5531,  5537,  5545,  5544,  5547,  5549,  5552,  5551,  5560,  5563,
    5562,  5571,  5572,  5578,  5579,  5596,  5597,  5601,  5602,  5606,
    5620,  5630,  5641,  5650,  5651,  5664,  5666,  5665,  5670,  5668,
    5679,  5680,  5684,  5698,  5710,  5711,  5724,  5733,  5755,  5756,
    5761,  5760,  5784,  5796,  5812,  5811,  5826,  5825,  5839,  5844,
    5849,  5869,  5887,  5891,  5918,  5930,  5931,  5936,  5945,  5935,
    5970,  5971,  5975,  5986,  6005,  6018,  6044,  6045,  6050,  6049,
    6086,  6095,  6096,  6100,  6101,  6105,  6107,  6113,  6119,  6121,
    6123,  6125,  6127,  6129,  6134,  6135,  6135,  6142,  6158,  6161,
    6178,  6179,  6183,  6184,  6188,  6189,  6193,  6194,  6199,  6202,
    6210,  6213,  6220,  6224,  6230,  6232,  6236,  6237,  6241,  6242,
    6243,  6247,  6262,  6267,  6272,  6277,  6282,  6287,  6292,  6307,
    6313,  6328,  6333,  6348,  6354,  6372,  6377,  6382,  6387,  6392,
    6397,  6403,  6402,  6428,  6429,  6430,  6435,  6440,  6445,  6447,
    6449,  6451,  6457,  6462,  6467,  6476,  6485,  6491,  6497,  6502,
    6505,  6507,  6511,  6530,  6538,  6553,  6563,  6574,  6575,  6576,
    6577,  6578,  6579,  6580,  6584,  6585,  6586,  6590,  6591,  6592,
    6593,  6598,  6605,  6612,  6613,  6617,  6618,  6619,  6620,  6621,
    6625,  6627,  6633,  6632,  6640,  6639,  6647,  6646,  6654,  6653,
    6663,  6660,  6671,  6669,  6678,  6677,  6716,  6724,  6732,  6740,
    6741,  6745,  6755,  6756,  6760,  6761,  6765,  6770,  6769,  6807,
    6807,  6810,  6809,  6820,  6821,  6825,  6826,  6830,  6831,  6835,
    6836,  6840,  6841,  6842,  6843,  6845,  6844,  6850,  6855,  6863,
    6864,  6869,  6872,  6876,  6880,  6887,  6888,  6892,  6893,  6897,
    6903,  6909,  6910,  6918,  6917,  6939,  6940,  6950,  6958,  6970,
    6970,  6973,  6974,  6981,  6989,  6993,  7001,  7002,  7003,  7004,
    7005,  7010,  7011,  7012,  7013,  7014,  7019,  7020,  7021,  7037,
    7041,  7045,  7049,  7051,  7058,  7060,  7065,  7067,  7068,  7069,
    7073,  7077,  7082,  7087,  7091,  7095,  7100,  7105,  7114,  7118,
    7123,  7128,  7132,  7136,  7141,  7146,  7155,  7173,  7174,  7181,
    7188,  7196,  7201,  7206,  7211,  7216,  7227,  7232,  7237,  7242,
    7244,  7246,  7248,  7250,  7252,  7254,  7256,  7264,  7266,  7271,
    7272,  7273,  7274,  7275,  7276,  7277,  7278,  7282,  7286,  7287,
    7291,  7292,  7296,  7297,  7298,  7299,  7300,  7304,  7305,  7306,
    7307,  7308,  7312,  7318,  7319,  7324,  7326,  7333,  7334,  7335,
    7339,  7343,  7344,  7345,  7346,  7347,  7348,  7352,  7353,  7354,
    7355,  7359,  7360,  7364,  7365,  7386,  7387,  7391,  7392,  7396,
    7397,  7402,  7403,  7407,  7408,  7409,  7416,  7417,  7423,  7430,
    7434,  7435,  7439,  7440,  7444,  7452,  7460,  7469,  7473,  7479,
    7483,  7484,  7493,  7502,  7508,  7514,  7527,  7533,  7543,  7551,
    7552,  7556,  7561,  7565,  7566,  7570,  7571,  7575,  7582,  7586,
    7587,  7591,  7599,  7600,  7604,  7605,  7609,  7610,  7614,  7615,
    7616,  7623,  7627,  7628,  7632,  7633,  7634,  7635,  7636,  7648,
    7652,  7653,  7658,  7657,  7670,  7671,  7675,  7678,  7679,  7680,
    7681,  7685,  7693,  7700,  7701,  7705,  7715,  7716,  7720,  7721,
    7724,  7726,  7730,  7742,  7743,  7747,  7754,  7767,  7768,  7770,
    7772,  7778,  7783,  7789,  7795,  7802,  7812,  7813,  7814,  7815,
    7816,  7820,  7821,  7825,  7826,  7830,  7831,  7835,  7836,  7837,
    7841,  7842,  7846,  7850,  7862,  7863,  7867,  7868,  7872,  7873,
    7877,  7878,  7882,  7883,  7887,  7888,  7892,  7893,  7898,  7899,
    7900,  7904,  7906,  7911,  7916,  7918,  7926,  7934,  7940,  7949,
    7950,  7954,  7958,  7959,  7969,  7970,  7971,  7975,  7979,  7986,
    7992,  8004,  8005,  8009,  8011,  8021,  8037,  8020,  8059,  8058,
    8075,  8084,  8083,  8104,  8103,  8124,  8123,  8142,  8136,  8155,
    8154,  8193,  8198,  8203,  8208,  8214,  8213,  8220,  8227,  8239,
    8226,  8261,  8265,  8273,  8276,  8280,  8284,  8292,  8294,  8295,
    8296,  8297,  8301,  8302,  8303,  8304,  8308,  8309,  8321,  8322,
    8326,  8327,  8330,  8332,  8340,  8348,  8350,  8352,  8353,  8361,
    8362,  8368,  8377,  8375,  8388,  8401,  8400,  8413,  8411,  8424,
    8431,  8441,  8442,  8451,  8458,  8462,  8468,  8466,  8483,  8485,
    8490,  8498,  8497,  8511,  8515,  8514,  8526,  8527,  8531,  8544,
    8545,  8549,  8553,  8560,  8565,  8569,  8576,  8583,  8587,  8592,
    8600,  8608,  8618,  8629,  8639,  8650,  8660,  8666,  8672,  8679,
    8685,  8699,  8713,  8718,  8722,  8727,  8728,  8729,  8734,  8739,
    8743,  8753,  8755,  8756,  8757,  8758,  8762,  8767,  8775,  8780,
    8788,  8789,  8793,  8794,  8798,  8798,  8801,  8803,  8807,  8808,
    8812,  8813,  8821,  8822,  8823,  8827,  8828,  8833,  8842,  8843,
    8844,  8845,  8850,  8849,  8859,  8858,  8866,  8873,  8883,  8900,
    8903,  8910,  8914,  8921,  8925,  8929,  8936,  8936,  8942,  8943,
    8947,  8948,  8949,  8953,  8954,  8963,  8970,  8971,  8976,  8975,
    8987,  8988,  8989,  8993,  8995,  8994,  9001,  9000,  9021,  9022,
    9026,  9027,  9031,  9032,  9033,  9037,  9038,  9043,  9042,  9063,
    9064,  9068,  9073,  9074,  9081,  9083,  9088,  9090,  9089,  9102,
    9104,  9103,  9117,  9118,  9123,  9132,  9133,  9134,  9138,  9145,
    9155,  9163,  9172,  9174,  9173,  9179,  9178,  9201,  9202,  9206,
    9207,  9211,  9212,  9213,  9214,  9215,  9216,  9220,  9221,  9226,
    9225,  9246,  9247,  9248,  9253,  9252,  9262,  9269,  9275,  9284,
    9285,  9289,  9305,  9304,  9317,  9318,  9322,  9323,  9327,  9338,
    9349,  9350,  9355,  9354,  9369,  9370,  9374,  9375,  9379,  9390,
    9402,  9401,  9409,  9409,  9418,  9419,  9424,  9425,  9434,  9433,
    9448,  9447,  9467,  9466,  9483,  9481,  9503,  9504,  9509,  9508,
    9522,  9532,  9521,  9542,  9554,  9618,  9623,  9638,  9639,  9654,
    9653,  9669,  9668,  9681,  9683,  9698,  9706,  9704,  9720,  9738,
    9740,  9750,  9754,  9795,  9804,  9814,  9815,  9819,  9823,  9829,
    9836,  9838,  9847,  9851,  9855,  9862,  9871,  9875,  9882,  9899,
    9902,  9910,  9913,  9920,  9924,  9928,  9932,  9939,  9940,  9944,
    9945,  9954,  9967,  9973,  9983,  9986,  9994,  9997, 10002, 10010,
   10011, 10012, 10026, 10031, 10053, 10059, 10065, 10071, 10080, 10081,
   10082, 10083, 10084, 10088, 10089, 10090, 10094, 10095, 10096, 10100,
   10101, 10106, 10157, 10164, 10207, 10213, 10217, 10223, 10229, 10235,
   10241, 10247, 10253, 10259, 10265, 10271, 10277, 10283, 10287, 10293,
   10302, 10308, 10316, 10322, 10331, 10337, 10345, 10355, 10361, 10368,
   10375, 10383, 10389, 10398, 10402, 10408, 10414, 10420, 10426, 10433,
   10439, 10445, 10451, 10457, 10464, 10470, 10476, 10482, 10488, 10494,
   10500, 10506, 10512, 10516, 10517, 10521, 10522, 10526, 10527, 10531,
   10532, 10536, 10537, 10538, 10539, 10540, 10541, 10545, 10546, 10551,
   10555, 10559, 10560, 10561, 10565, 10566, 10567, 10568, 10569, 10570,
   10574, 10575, 10576, 10581, 10580, 10586, 10594, 10617, 10624, 10633,
   10634, 10635, 10636, 10640, 10649, 10650, 10651, 10652, 10653, 10654,
   10655, 10656, 10688, 10689, 10690, 10691, 10692, 10693, 10694, 10695,
   10696, 10704, 10712, 10713, 10720, 10726, 10731, 10741, 10746, 10751,
   10757, 10762, 10768, 10779, 10786, 10791, 10796, 10801, 10806, 10811,
   10816, 10824, 10825, 10826, 10827, 10835, 10836, 10844, 10845, 10851,
   10855, 10861, 10867, 10876, 10877, 10886, 10893, 10907, 10913, 10919,
   10928, 10937, 10943, 10949, 10955, 10961, 10976, 10987, 10993, 10999,
   11005, 11011, 11017, 11025, 11032, 11036, 11042, 11050, 11059, 11063,
   11067, 11071, 11091, 11098, 11104, 11111, 11118, 11124, 11130, 11136,
   11142, 11148, 11154, 11161, 11167, 11174, 11180, 11186, 11204, 11210,
   11216, 11221, 11228, 11235, 11243, 11250, 11257, 11264, 11271, 11288,
   11294, 11300, 11306, 11312, 11319, 11325, 11331, 11340, 11351, 11358,
   11364, 11370, 11377, 11385, 11391, 11397, 11403, 11409, 11417, 11423,
   11429, 11435, 11441, 11449, 11461, 11468, 11483, 11489, 11496, 11503,
   11510, 11517, 11524, 11528, 11535, 11553, 11552, 11620, 11625, 11633,
   11635, 11640, 11641, 11645, 11646, 11650, 11651, 11655, 11662, 11670,
   11697, 11703, 11709, 11715, 11721, 11727, 11736, 11743, 11745, 11742,
   11752, 11763, 11769, 11775, 11781, 11787, 11793, 11799, 11805, 11811,
   11818, 11817, 11842, 11851, 11869, 11871, 11873, 11888, 11895, 11902,
   11909, 11916, 11923, 11930, 11937, 11944, 11951, 11962, 11969, 11980,
   11991, 12011, 12010, 12016, 12033, 12039, 12048, 12057, 12067, 12066,
   12078, 12088, 12096, 12101, 12109, 12110, 12115, 12120, 12123, 12125,
   12129, 12134, 12142, 12143, 12147, 12151, 12158, 12165, 12172, 12185,
   12184, 12201, 12204, 12203, 12208, 12207, 12212, 12211, 12215, 12220,
   12221, 12225, 12226, 12227, 12228, 12229, 12230, 12231, 12232, 12236,
   12237, 12238, 12239, 12246, 12247, 12251, 12256, 12264, 12265, 12269,
   12276, 12284, 12293, 12303, 12304, 12315, 12316, 12328, 12339, 12340,
   12346, 12351, 12365, 12373, 12371, 12391, 12389, 12402, 12414, 12412,
   12432, 12431, 12443, 12456, 12454, 12475, 12474, 12487, 12501, 12502,
   12503, 12507, 12508, 12516, 12517, 12521, 12530, 12531, 12532, 12537,
   12541, 12542, 12546, 12547, 12551, 12552, 12560, 12568, 12576, 12577,
   12590, 12608, 12618, 12619, 12624, 12627, 12628, 12629, 12633, 12634,
   12639, 12638, 12644, 12643, 12651, 12652, 12655, 12657, 12657, 12661,
   12661, 12666, 12667, 12671, 12673, 12678, 12679, 12683, 12694, 12708,
   12709, 12710, 12711, 12712, 12713, 12714, 12715, 12716, 12717, 12718,
   12719, 12723, 12724, 12725, 12726, 12727, 12728, 12729, 12730, 12731,
   12735, 12736, 12737, 12738, 12741, 12743, 12744, 12748, 12749, 12753,
   12761, 12763, 12767, 12769, 12768, 12782, 12785, 12784, 12802, 12804,
   12808, 12813, 12821, 12822, 12839, 12862, 12863, 12869, 12870, 12874,
   12887, 12886, 12895, 12896, 12905, 12906, 12910, 12911, 12915, 12916,
   12930, 12931, 12935, 12945, 12954, 12961, 12968, 12978, 12979, 12986,
   12996, 12997, 12999, 13001, 13003, 13005, 13014, 13018, 13019, 13023,
   13037, 13038, 13044, 13043, 13054, 13060, 13069, 13070, 13071, 13076,
   13077, 13082, 13089, 13095, 13105, 13114, 13120, 13126, 13135, 13140,
   13145, 13149, 13155, 13161, 13170, 13179, 13183, 13190, 13191, 13195,
   13200, 13205, 13217, 13221, 13225, 13229, 13234, 13237, 13241, 13255,
   13263, 13276, 13278, 13282, 13283, 13287, 13288, 13289, 13290, 13291,
   13292, 13296, 13297, 13298, 13299, 13300, 13304, 13305, 13306, 13307,
   13311, 13312, 13313, 13314, 13315, 13319, 13320, 13321, 13322, 13323,
   13327, 13332, 13333, 13337, 13338, 13342, 13343, 13344, 13349, 13348,
   13380, 13381, 13385, 13386, 13390, 13400, 13400, 13412, 13413, 13416,
   13436, 13440, 13445, 13453, 13459, 13470, 13458, 13472, 13487, 13499,
   13498, 13521, 13520, 13530, 13529, 13552, 13558, 13566, 13574, 13588,
   13603, 13611, 13615, 13620, 13619, 13628, 13633, 13639, 13644, 13649,
   13656, 13654, 13668, 13669, 13673, 13685, 13698, 13699, 13703, 13717,
   13721, 13730, 13733, 13740, 13741, 13749, 13760, 13748, 13775, 13785,
   13774, 13800, 13808, 13809, 13816, 13820, 13821, 13830, 13831, 13835,
   13835, 13848, 13849, 13851, 13850, 13863, 13869, 13871, 13875, 13877,
   13883, 13887, 13888, 13892, 13893, 13897, 13907, 13908, 13912, 13913,
   13917, 13918, 13922, 13923, 13928, 13927, 13943, 13942, 13957, 13958,
   13962, 13963, 13967, 13972, 13980, 13988, 13999, 14000, 14009, 14010,
   14018, 14020, 14022, 14020, 14032, 14046, 14053, 14063, 14052, 14092,
   14093, 14097, 14104, 14112, 14113, 14117, 14127, 14128, 14135, 14134,
   14155, 14158, 14165, 14166, 14176, 14191, 14199, 14212, 14211, 14226,
   14225, 14241, 14243, 14247, 14248, 14252, 14267, 14285, 14286, 14290,
   14291, 14295, 14296, 14297, 14302, 14313, 14301, 14323, 14325, 14326,
   14329, 14331, 14334, 14336, 14339, 14340, 14343, 14347, 14351, 14355,
   14359, 14363, 14367, 14371, 14375, 14383, 14386, 14396, 14395, 14414,
   14421, 14429, 14437, 14445, 14453, 14461, 14468, 14475, 14481, 14483,
   14485, 14494, 14498, 14503, 14502, 14509, 14508, 14514, 14523, 14530,
   14535, 14540, 14545, 14550, 14555, 14557, 14559, 14561, 14568, 14576,
   14578, 14586, 14593, 14600, 14608, 14614, 14619, 14627, 14635, 14643,
   14647, 14652, 14659, 14664, 14671, 14678, 14684, 14690, 14696, 14704,
   14709, 14716, 14723, 14730, 14737, 14742, 14747, 14752, 14757, 14764,
   14786, 14788, 14790, 14795, 14796, 14799, 14801, 14805, 14806, 14810,
   14811, 14815, 14816, 14820, 14821, 14825, 14826, 14830, 14831, 14839,
   14851, 14850, 14869, 14868, 14878, 14879, 14880, 14881, 14882, 14883,
   14887, 14888, 14892, 14899, 14900, 14902, 14903, 14907, 14908, 14921,
   14922, 14923, 14938, 14937, 14949, 14948, 14960, 14965, 14966, 14981,
   14984, 14983, 14996, 14997, 15002, 15004, 15006, 15008, 15010, 15012,
   15020, 15022, 15024, 15026, 15031, 15033, 15041, 15043, 15045, 15047,
   15049, 15066, 15067, 15071, 15075, 15088, 15087, 15100, 15108, 15109,
   15112, 15114, 15115, 15119, 15135, 15136, 15141, 15140, 15150, 15151,
   15155, 15155, 15159, 15158, 15164, 15168, 15169, 15173, 15174, 15181,
   15186, 15185, 15200, 15199, 15214, 15215, 15216, 15220, 15221, 15222,
   15231, 15232, 15236, 15240, 15248, 15248, 15253, 15254, 15262, 15274,
   15288, 15299, 15312, 15273, 15325, 15326, 15330, 15331, 15335, 15336,
   15344, 15348, 15349, 15350, 15353, 15355, 15359, 15360, 15364, 15369,
   15376, 15381, 15388, 15390, 15394, 15395, 15399, 15404, 15412, 15413,
   15417, 15419, 15427, 15428, 15432, 15433, 15434, 15438, 15440, 15445,
   15446, 15455, 15456, 15460, 15461, 15465, 15478, 15483, 15488, 15493,
   15501, 15509, 15514, 15522, 15530, 15545, 15552, 15558, 15568, 15569,
   15577, 15578, 15579, 15580, 15594, 15600, 15606, 15612, 15618, 15624,
   15643, 15653, 15663, 15669, 15676, 15686, 15693, 15700, 15711, 15710,
   15735, 15736, 15741, 15742, 15749, 15747, 15774, 15775, 15781, 15786,
   15795, 15813, 15814, 15818, 15823, 15831, 15836, 15844, 15849, 15854,
   15859, 15865, 15870, 15878, 15883, 15888, 15893, 15899, 15907, 15908,
   15919, 15927, 15931, 15937, 15943, 15953, 15959, 15968, 15978, 15979,
   15983, 15984, 15985, 15989, 15997, 16005, 16013, 16021, 16022, 16030,
   16031, 16039, 16040, 16045, 16054, 16055, 16063, 16064, 16073, 16074,
   16082, 16083, 16087, 16096, 16097, 16098, 16102, 16113, 16142, 16151,
   16151, 16153, 16163, 16164, 16165, 16166, 16167, 16168, 16169, 16170,
   16171, 16176, 16177, 16178, 16179, 16180, 16181, 16182, 16183, 16184,
   16185, 16193, 16194, 16195, 16196, 16197, 16198, 16202, 16203, 16204,
   16205, 16206, 16207, 16208, 16209, 16210, 16214, 16215, 16216, 16217,
   16218, 16219, 16220, 16224, 16225, 16226, 16227, 16228, 16229, 16230,
   16231, 16232, 16236, 16237, 16238, 16239, 16240, 16241, 16242, 16255,
   16256, 16257, 16258, 16259, 16260, 16261, 16262, 16263, 16264, 16265,
   16266, 16267, 16268, 16269, 16270, 16271, 16272, 16273, 16274, 16275,
   16276, 16277, 16278, 16279, 16280, 16281, 16282, 16283, 16284, 16285,
   16286, 16287, 16288, 16289, 16290, 16291, 16292, 16293, 16294, 16295,
   16296, 16297, 16298, 16299, 16300, 16301, 16302, 16303, 16304, 16305,
   16306, 16307, 16308, 16309, 16350, 16351, 16352, 16353, 16354, 16355,
   16366, 16367, 16368, 16369, 16370, 16371, 16372, 16373, 16374, 16375,
   16379, 16380, 16381, 16388, 16389, 16390, 16394, 16395, 16396, 16405,
   16406, 16407, 16408, 16409, 16410, 16411, 16412, 16413, 16414, 16415,
   16416, 16417, 16418, 16419, 16420, 16421, 16422, 16423, 16424, 16425,
   16426, 16427, 16428, 16429, 16430, 16431, 16432, 16433, 16434, 16435,
   16436, 16437, 16438, 16446, 16447, 16448, 16449, 16450, 16451, 16452,
   16453, 16454, 16455, 16456, 16457, 16458, 16459, 16460, 16461, 16462,
   16463, 16464, 16465, 16466, 16467, 16468, 16469, 16470, 16471, 16472,
   16473, 16474, 16475, 16476, 16477, 16478, 16479, 16480, 16481, 16482,
   16483, 16484, 16485, 16486, 16487, 16488, 16489, 16490, 16491, 16492,
   16497, 16498, 16499, 16500, 16501, 16502, 16503, 16504, 16505, 16506,
   16507, 16508, 16509, 16510, 16511, 16512, 16513, 16514, 16515, 16516,
   16517, 16518, 16519, 16520, 16521, 16522, 16523, 16524, 16525, 16526,
   16527, 16528, 16529, 16530, 16531, 16532, 16533, 16534, 16535, 16536,
   16537, 16538, 16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546,
   16547, 16548, 16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556,
   16557, 16558, 16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566,
   16567, 16568, 16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576,
   16577, 16578, 16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586,
   16587, 16588, 16589, 16590, 16591, 16592, 16593, 16594, 16595, 16596,
   16597, 16598, 16599, 16600, 16601, 16602, 16603, 16604, 16605, 16606,
   16607, 16608, 16609, 16610, 16611, 16612, 16613, 16614, 16615, 16616,
   16617, 16618, 16619, 16620, 16621, 16622, 16623, 16624, 16625, 16626,
   16627, 16628, 16629, 16630, 16631, 16632, 16633, 16634, 16635, 16636,
   16637, 16638, 16639, 16640, 16641, 16642, 16643, 16644, 16645, 16646,
   16647, 16648, 16649, 16650, 16651, 16652, 16653, 16654, 16655, 16656,
   16657, 16658, 16659, 16660, 16661, 16662, 16663, 16664, 16665, 16666,
   16667, 16668, 16669, 16670, 16671, 16672, 16673, 16674, 16675, 16676,
   16677, 16678, 16679, 16680, 16681, 16682, 16683, 16684, 16685, 16686,
   16687, 16688, 16689, 16690, 16691, 16692, 16693, 16694, 16695, 16696,
   16697, 16698, 16699, 16700, 16701, 16702, 16703, 16704, 16705, 16706,
   16707, 16708, 16709, 16710, 16711, 16712, 16713, 16714, 16715, 16716,
   16717, 16718, 16719, 16720, 16721, 16722, 16723, 16724, 16725, 16726,
   16727, 16728, 16729, 16730, 16731, 16732, 16733, 16734, 16735, 16736,
   16737, 16738, 16739, 16740, 16741, 16742, 16743, 16744, 16745, 16746,
   16747, 16748, 16749, 16750, 16751, 16752, 16753, 16754, 16755, 16756,
   16757, 16758, 16759, 16760, 16761, 16762, 16763, 16775, 16774, 16791,
   16797, 16790, 16813, 16812, 16827, 16826, 16843, 16842, 16870, 16871,
   16877, 16876, 16883, 16882, 16892, 16891, 16902, 16901, 16907, 16915,
   16917, 16922, 16922, 16932, 16931, 16946, 16945, 16950, 16954, 16955,
   16956, 16960, 16961, 16962, 16963, 16967, 16968, 16969, 16970, 16975,
   16980, 16985, 16994, 16999, 17004, 17009, 17014, 17019, 17024, 17029,
   17043, 17054, 17073, 17091, 17103, 17111, 17116, 17132, 17133, 17134,
   17135, 17139, 17158, 17176, 17177, 17181, 17182, 17183, 17184, 17188,
   17202, 17206, 17211, 17216, 17227, 17228, 17229, 17235, 17241, 17253,
   17252, 17266, 17267, 17273, 17282, 17283, 17287, 17288, 17292, 17311,
   17312, 17313, 17318, 17319, 17324, 17323, 17341, 17340, 17352, 17361,
   17371, 17370, 17411, 17412, 17416, 17417, 17421, 17422, 17423, 17424,
   17426, 17425, 17438, 17439, 17440, 17441, 17442, 17448, 17453, 17459,
   17465, 17471, 17478, 17485, 17489, 17496, 17505, 17507, 17512, 17517,
   17524, 17531, 17538, 17545, 17552, 17559, 17571, 17572, 17576, 17577,
   17581, 17586, 17594, 17604, 17623, 17626, 17628, 17632, 17633, 17640,
   17642, 17646, 17647, 17652, 17651, 17655, 17654, 17658, 17657, 17661,
   17660, 17663, 17664, 17665, 17666, 17667, 17668, 17669, 17670, 17671,
   17672, 17673, 17674, 17675, 17676, 17677, 17678, 17679, 17680, 17681,
   17682, 17683, 17684, 17685, 17686, 17687, 17688, 17689, 17693, 17694,
   17698, 17699, 17703, 17710, 17717, 17727, 17737, 17746, 17755, 17768,
   17773, 17781, 17786, 17794, 17799, 17806, 17806, 17807, 17807, 17810,
   17816, 17822, 17827, 17834, 17840, 17847, 17856, 17860, 17866, 17876,
   17880, 17884, 17885, 17889, 17917, 17919, 17923, 17927, 17931, 17938,
   17943, 17948, 17953, 17958, 17966, 17967, 17971, 17972, 17977, 17978,
   17982, 17983, 17987, 17988, 17992, 17993, 17998, 17997, 18007, 18016,
   18017, 18021, 18022, 18027, 18028, 18029, 18034, 18035, 18036, 18040,
   18052, 18061, 18067, 18076, 18085, 18098, 18100, 18102, 18110, 18111,
   18112, 18116, 18117, 18123, 18124, 18125, 18126, 18127, 18128, 18129,
   18139, 18140, 18145, 18158, 18172, 18173, 18174, 18178, 18179, 18183,
   18184, 18189, 18190, 18194, 18200, 18209, 18209, 18223, 18224, 18225,
   18226, 18236, 18238, 18244, 18250, 18260, 18269, 18275, 18280, 18284,
   18258, 18332, 18332, 18348, 18347, 18363, 18371, 18362, 18386, 18387,
   18391, 18392, 18398, 18402, 18406, 18410, 18414, 18418, 18426, 18427,
   18443, 18450, 18457, 18467, 18468, 18469, 18473, 18474, 18475, 18479,
   18480, 18485, 18487, 18486, 18492, 18493, 18497, 18502, 18509, 18514,
   18523
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM",
  "DES_KEY_FILE", "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM",
  "DISCARD", "DISK_SYM", "DO_SYM", "DUMPFILE", "DUPLICATE_SYM",
  "DYNAMIC_SYM", "ENABLE_SYM", "END", "ENDS_SYM", "ENGINES_SYM",
  "ENGINE_SYM", "ENUM", "ERROR_SYM", "ERRORS", "ESCAPE_SYM", "EVENTS_SYM",
  "EVENT_SYM", "EVERY_SYM", "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM",
  "EXECUTE_SYM", "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM",
  "EXIT_ORACLE_SYM", "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM",
  "EXTENDED_SYM", "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM",
  "FIRST_SYM", "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM",
  "FORCE_SYM", "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM",
  "GENERAL", "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM",
  "GET_FORMAT", "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM",
  "HARD_SYM", "HASH_SYM", "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM",
  "HOST_SYM", "HOSTS_SYM", "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM",
  "IGNORE_SERVER_IDS_SYM", "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM",
  "INDEXES", "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM",
  "INVOKER_SYM", "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM",
  "ISSUER_SYM", "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE",
  "LANGUAGE_SYM", "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES",
  "LESS_SYM", "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM",
  "LOCKS_SYM", "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "$accept", "query",
  "$@1", "opt_end_of_input", "verb_clause", "statement", "deallocate",
  "deallocate_or_drop", "prepare", "$@2", "execute", "$@3", "$@4",
  "execute_using", "$@5", "execute_params", "help", "$@6", "change", "$@7",
  "master_defs", "master_def", "ignore_server_id_list", "ignore_server_id",
  "do_domain_id_list", "do_domain_id", "ignore_domain_id_list",
  "ignore_domain_id", "master_file_def", "optional_connection_name",
  "connection_name", "create", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "$@19", "$@20", "$@21",
  "$@22", "$@23", "$@24", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "$@31", "package_implementation_executable_section",
  "package_implementation_declare_section",
  "package_implementation_declare_section_list1",
  "package_implementation_declare_section_list2", "package_routine_lex",
  "package_specification_function", "$@32",
  "package_specification_procedure", "$@33",
  "package_implementation_routine_definition",
  "package_implementation_function_body", "$@34",
  "package_implementation_procedure_body", "$@35",
  "package_implementation_item_declaration",
  "opt_package_specification_element_list",
  "package_specification_element_list", "package_specification_element",
  "opt_sequence", "sequence_defs", "sequence_def", "force_lookahead",
  "server_def", "$@36", "server_options_list", "server_option",
  "event_tail", "$@37", "ev_schedule_time", "$@38", "opt_ev_status",
  "ev_starts", "ev_ends", "opt_ev_on_completion", "ev_on_completion",
  "opt_ev_comment", "ev_sql_stmt", "$@39", "clear_privileges",
  "opt_aggregate", "sp_name", "opt_sp_name", "sp_a_chistics",
  "sp_c_chistics", "sp_chistic", "create_package_chistic",
  "create_package_chistics", "opt_create_package_chistics",
  "opt_create_package_chistics_init", "$@40", "sp_c_chistic", "sp_suid",
  "call", "$@41", "$@42", "$@43", "opt_sp_cparam_list", "opt_sp_cparams",
  "sp_cparams", "sp_fdparam_list", "$@44", "sp_fdparams", "sp_param_name",
  "sp_param_name_and_type", "sp_pdparam_list", "sp_pdparams", "sp_pdparam",
  "sp_opt_inout", "sp_parenthesized_pdparam_list", "$@45", "sp_no_param",
  "opt_sp_parenthesized_fdparam_list", "opt_sp_parenthesized_pdparam_list",
  "sp_proc_stmts", "sp_proc_stmts1", "sp_proc_stmts1_implicit_block",
  "$@46", "opt_sp_decl_body_list", "sp_decl_body_list", "$@47",
  "sp_decl_non_handler_list", "sp_decl_handler_list",
  "opt_sp_decl_handler_list", "optionally_qualified_column_ident",
  "row_field_name", "row_field_definition", "row_field_definition_list",
  "row_type_body", "sp_decl_idents_init_vars", "sp_decl_vars",
  "sp_decl_non_handler", "$@48", "sp_decl_handler", "$@49",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@50", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt", "sp_labelable_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@51", "sp_statement",
  "$@52", "$@53", "$@54", "sp_proc_stmt_statement", "$@55",
  "RETURN_ALLMODES_SYM", "sp_proc_stmt_return", "$@56", "reset_lex_expr",
  "$@57", "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "remember_lex", "assignment_source_lex", "assignment_source_expr",
  "$@58", "for_loop_bound_expr", "$@59", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@60", "$@61", "$@62", "sp_elseifs",
  "case_stmt_specification", "$@63", "case_stmt_body", "$@64", "$@65",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@66", "$@67", "searched_when_clause", "$@68",
  "$@69", "else_clause_opt", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@70", "$@71", "$@72", "opt_not_atomic",
  "sp_unlabeled_block", "$@73", "$@74", "$@75", "sp_instr_addr", "sp_body",
  "$@76", "$@77", "$@78", "sp_block_statements_and_exceptions", "$@79",
  "opt_exception_clause", "exception_handlers", "exception_handler",
  "$@80", "opt_sp_for_loop_direction", "sp_for_loop_index_and_bounds",
  "$@81", "sp_for_loop_bounds", "loop_body", "while_body", "$@82",
  "repeat_body", "$@83", "pop_sp_loop_label", "sp_labeled_control", "$@84",
  "$@85", "$@86", "$@87", "$@88", "$@89", "sp_unlabeled_control", "$@90",
  "$@91", "$@92", "$@93", "$@94", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@95", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@96", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@97", "have_partitioning",
  "partition_entry", "$@98", "partition", "$@99", "part_type_def", "$@100",
  "$@101", "$@102", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@103",
  "$@104", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@105", "part_name", "opt_part_values", "$@106", "$@107",
  "part_func_max", "part_values_in", "part_value_list", "part_value_item",
  "$@108", "$@109", "part_value_item_list", "part_value_expr_item",
  "opt_sub_partition", "sub_part_list", "sub_part_definition", "$@110",
  "sub_name", "opt_part_options", "opt_part_option_list",
  "opt_part_option", "opt_versioning_rotation", "$@111",
  "opt_versioning_interval_start", "opt_as", "opt_create_database_options",
  "create_database_options", "create_database_option",
  "opt_if_not_exists_table_element", "opt_if_not_exists",
  "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@112", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@113", "$@114", "$@115", "$@116", "$@117",
  "$@118", "$@119", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@120", "field_type_or_serial", "$@121",
  "$@122", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@123",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@124",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "sp_param_field_type", "field_type_numeric",
  "opt_binary_and_compression", "field_type_string",
  "sp_param_field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1",
  "opt_field_length_default_sp_param_varchar",
  "opt_field_length_default_sp_param_char", "opt_precision",
  "attribute_list", "attribute", "opt_compression_method",
  "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "sp_param_type", "charset",
  "charset_name", "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@125", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@126", "$@127", "$@128", "$@129", "$@130", "$@131", "$@132",
  "$@133", "$@134", "$@135", "$@136", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@137", "$@138", "$@139",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@140", "add_part_extra", "reorg_partition_rule", "$@141",
  "reorg_parts_rule", "$@142", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@143", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@144", "$@145",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@146", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@147", "opt_checksum_type", "repair_table_or_view", "$@148", "repair",
  "$@149", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@150", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@151",
  "persistent_index_stat_spec", "$@152", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@153", "check", "$@154", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@155", "opt_no_write_to_binlog", "rename", "$@156", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@157",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@158",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@159", "cache_keys_spec",
  "$@160", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@161", "$@162", "select_into", "$@163", "$@164", "simple_table",
  "table_value_constructor", "$@165", "query_specification_start", "$@166",
  "$@167", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@168", "$@169",
  "query_expression_body_ext_parens", "query_expression_body", "$@170",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end",
  "remember_end_opt", "select_alias", "opt_default_time_precision",
  "opt_time_precision", "optional_braces", "expr", "boolean_test",
  "predicate", "bit_expr", "or", "and", "not", "not2", "comp_op",
  "all_or_any", "opt_dyncol_type", "dyncol_type", "numeric_dyncol_type",
  "temporal_dyncol_type", "string_dyncol_type", "$@171",
  "dyncall_create_element", "dyncall_create_list", "plsql_cursor_attr",
  "explicit_cursor_attr", "trim_operands",
  "column_default_non_parenthesized_expr", "primary_expr",
  "string_factor_expr", "simple_expr", "mysql_concatenation_expr",
  "function_call_keyword_timestamp", "function_call_keyword",
  "substring_operands", "function_call_nonkeyword",
  "function_call_conflict", "geometry_function", "function_call_generic",
  "@172", "fulltext_options", "opt_natural_language_mode",
  "opt_query_expansion", "opt_udf_expr_list", "udf_expr_list", "udf_expr",
  "sum_expr", "$@173", "$@174", "$@175", "window_func_expr", "window_func",
  "simple_window_func", "inverse_distribution_function",
  "percentile_function", "$@176", "inverse_distribution_function_def",
  "order_by_single_element_list", "window_name", "variable", "$@177",
  "variable_aux", "opt_distinct", "opt_gconcat_separator",
  "opt_gorder_clause", "gorder_list", "opt_glimit_clause",
  "glimit_clause_init", "glimit_clause", "glimit_options", "in_sum_expr",
  "$@178", "cast_type", "$@179", "$@180", "$@181", "cast_type_numeric",
  "cast_type_temporal", "opt_expr_list", "expr_list", "ident_list_arg",
  "ident_list", "when_list", "when_list_opt_else", "table_ref",
  "join_table_list", "esc_table_ref", "derived_table_list", "join_table",
  "$@182", "$@183", "$@184", "$@185", "$@186", "$@187", "inner_join",
  "normal_join", "opt_use_partition", "use_partition", "table_factor",
  "table_primary_ident_opt_parens", "table_primary_derived_opt_parens",
  "table_reference_list_parens", "nested_table_reference_list",
  "join_table_parens", "table_primary_ident", "table_primary_derived",
  "opt_outer", "index_hint_clause", "index_hint_type",
  "index_hint_definition", "$@188", "$@189", "index_hints_list",
  "opt_index_hints_list", "$@190", "opt_key_definition", "$@191",
  "opt_key_usage_list", "key_usage_element", "key_usage_list",
  "using_list", "interval", "interval_time_stamp", "date_time_type",
  "table_alias", "opt_table_alias_clause", "table_alias_clause", "opt_all",
  "opt_where_clause", "$@192", "opt_having_clause", "$@193",
  "opt_group_clause", "group_list", "olap_opt", "opt_window_clause",
  "window_def_list", "window_def", "window_spec", "$@194",
  "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@195", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@196", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@197",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@198", "$@199", "do", "$@200", "drop", "$@201",
  "$@202", "$@203", "$@204", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@205", "$@206", "replace", "$@207", "$@208",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@209", "insert_field_spec", "$@210", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@211", "no_braces_with_names", "$@212", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@213", "$@214",
  "update_table_list", "update", "$@215", "$@216", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@217", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@218", "$@219", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@220", "$@221",
  "opt_truncate_table_storage_clause", "opt_table_sym", "opt_profile_defs",
  "profile_defs", "profile_def", "opt_profile_args", "show", "$@222",
  "show_param", "$@223", "$@224", "show_engine_param", "master_or_binary",
  "opt_storage", "opt_db", "opt_full", "from_or_in", "binlog_in",
  "binlog_from", "wild_and_where", "describe", "$@225", "$@226",
  "explainable_command", "describe_command", "analyze_stmt_command",
  "opt_extended_describe", "opt_format_json", "opt_describe_column",
  "flush", "$@227", "flush_options", "$@228", "opt_flush_lock",
  "flush_lock", "$@229", "flush_options_list", "flush_option",
  "opt_table_list", "backup", "backup_statements", "$@230",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@231", "reset_options",
  "reset_option", "$@232", "$@233", "slave_reset_options",
  "master_reset_options", "purge", "$@234", "kill", "$@235", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@236",
  "shutdown_option", "use", "load", "$@237", "$@238", "$@239", "$@240",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@241",
  "opt_recursive", "with_list", "with_list_element", "$@242",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "ident_directly_assignable", "label_ident",
  "labels_declaration_oracle", "label_declaration_oracle", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case",
  "keyword_directly_assignable", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@243", "$@244", "$@245",
  "set_assign", "$@246", "$@247", "$@248",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@249", "$@250", "$@251",
  "start_option_value_list_following_option_type", "$@252",
  "option_value_list_continued", "option_value_list", "$@253", "$@254",
  "option_value", "$@255", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@256",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@257", "handler", "$@258",
  "handler_tail", "$@259", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@260", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@261", "$@262", "$@263",
  "$@264", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@265", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@266", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@267", "$@268", "$@269", "$@270", "$@271",
  "sf_return_type", "$@272", "sf_c_chistics_and_body_standalone", "$@273",
  "sp_tail_standalone", "$@274", "$@275", "opt_package_routine_end_name",
  "sp_tail_is", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@276",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5364)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3488)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   16263,  4274,   200, 86721, -5364,    52, -5364,   941, -5364, -5364,
   -5364, -5364,  4338, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,   332,   139, -5364,  1035, -5364, -5364,   365, 82241,  1020,
     738, -5364, 83521, -5364, -5364,  1010, -5364, 83521, -5364, -5364,
   86721, -5364, -5364,  1519, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364,   535, -5364,  2953,   413, -5364, -5364, -5364,
   -5364, -5364, -5364,  1809, -5364, -5364, -5364, -5364, -5364,   139,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, 86721, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  1246, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364,  1414, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, 87361,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  2183, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364,  2266, -5364, -5364, -5364, -5364, -5364,   555, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364,  1738, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, 86721, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364,  1035, -5364, -5364,  1856, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  1246, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, 86721, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,   229, -5364, -5364,   257,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  1908, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  3743, -5364, -5364,   534,  2225,
    2245, -5364, -5364,  1780, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    4459, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  2572, -5364,
   -5364, -5364, -5364,  2879,  2052, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, 71341, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,   534, -5364, -5364,   100, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, 86721, 86721,  1667,  1747, 86721,  2423,  2424, 82881,
   86721,  2424, -5364,    73, -5364, -5364,  2189, -5364,  1861, -5364,
     139,  2382, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    1849, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    2414,  2461,  1065,  2484,  2639, 86721, 50761,  1290,  2424, -5364,
     533,  2424,  2424,  2424,  2424,  2645,  2424,  2424, 86721, -5364,
    2424,  2424,   705, 91201, 38131, -5364,  1029,  1435,  2696, -5364,
   -5364, -5364, -5364, -5364, -5364,  6953,   139, 24370,  2817, -5364,
   -5364,  2329,  4208,  2144, -5364,  2642, -5364, -5364, 86721, -5364,
   -5364,  6953, -5364,  2642, 38875,  3393, -5364, 36674,  7094,  2642,
     139,  2737, -5364,  2169, 24370, -5364, -5364,  1126, -5364, -5364,
   86721, -5364,  1246, -5364, -5364, -5364,  2630, -5364, 82881, -5364,
   -5364, -5364,  2190, -5364,  3024, 24370,   378,  2731, -5364, -5364,
    2631, 71981, 82881,  2928,  2461,  2954, -5364,  2099,   496, -5364,
    2334,  2394,  2461,   358,  2428,  2461,  2832,  2424,  2424, -5364,
   -5364,  2179,  2179,  2179,  2632,  2179, -5364,  2179,  3006,  2360,
     155, -5364, -5364,  2363, 86721,  2928, -5364, -5364, -5364,  2928,
    2928,  2456,  3029,  3049,  3058,   163,  2479,  1998,  1998,  2189,
   52837,  1642,  2885, -5364,  3006,  2967,  1148, -5364, -5364,  1924,
    2967,   534,  2967, -5364,   223,  1861,  2401, 86721, -5364, -5364,
   -5364,  2399, -5364, -5364, -5364, 86721, -5364,  2487, -5364,  2446,
    2016, 51466, -5364, 86721,  3125, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364,  1368, -5364, -5364,  2978,   250,  2602,  2829,
    2525, -5364,  3031, 82881, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, 86721,  2518, -5364,  3225, 24370,  2414, -5364,  3023,
   -5364, -5364, -5364, -5364, 71981, -5364, 86721, -5364,  3306, -5364,
   -5364, 91201, -5364, -5364,   436, -5364, -5364, 54234,  1466, 43749,
   -5364,  2544,  2561,  2892, -5364,  2616,  1354,  1400, -5364,  1438,
   -5364, -5364,  1459,  1502,  1640, -5364, -5364,  3297, -5364, -5364,
   75201,   657, 86721,  3284,  2424, 86721, 86721, 86721, 86721, 86721,
   86721, -5364, 82881,  2762, -5364, -5364,  2424,  2424, -5364, -5364,
    2870,  2838,  2392,  2742,  3036, -5364,  2932, -5364, -5364,  2836,
   -5364, -5364,   196, -5364, -5364, -5364,   113,   301,   307,   323,
    3357,   337,  1045,   430,   493, -5364, -5364, -5364,  3275,  3373,
    2786, -5364,  3146, 24370, -5364, -5364, -5364,  3465, -5364, -5364,
     872,  3237,   339, 71981, 91841, 74551, 92769, 92769, 92769, -5364,
   -5364,   145, 92769, 86721, 92305, 86721,  6638,  2813, -5364, -5364,
   -5364, 17749, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   86721, -5364, -5364, -5364,   399, -5364, -5364, -5364, -5364, -5364,
    8682, -5364, -5364, 29522, -5364,  2825,  2840,  2856, 19954,  2862,
    2865,  2871,  2875,  2878,  2742,  2742,  2742,  2888,  2897,  2906,
    2910, -5364,  2914,  2936,  2944,  2949, -5364,  2958, -5364,  2961,
    2962,  2968, -5364, -5364,    74,   184,  2975,  2976, 25106,  2995,
   -5364, 66221,  3003,  3013,  3017,  3021, -5364, -5364, 24370,  2888,
    3027, -5364, -5364,  3028, -5364,  3035,  3050,  3053,  3064,  3085,
    3086,  3092,  3096,  3417,  3099,  3109,  3127,  2888, -5364, -5364,
   -5364,  2319,  2742,  2888,  2888,  3134,  3145,  3147,  3156,  3164,
    3165,  3167,  3169,  3170,  3171,  3172, 84161,  3173,  3174,  3179,
    3182,  3183,  3186,  3191,   143,  3192,  3196,  3200,  3209,  3211,
    3219,  3220,  3224,  3232,  3240,  3243,  3245,  3260,  3265,  2920,
    3266,  3269,  3271,  3273,  3282,  2973,  3300,  3301,  3302,  3303,
    3304,  3307,  3309,   375,  3312,  3320,   411,  3321,  3325,  3329,
    3334,  3335,  3336,  3339,  3342, 30258, 30994, 29522, 18482, -5364,
   86721, 88001, -5364, -5364, -5364,  4087,  2290,  1783,  3680, 29522,
   -5364, -5364, -5364,  3688, -5364,  3599, -5364, -5364, -5364, -5364,
   -5364,  3567,  3602, -5364,  3614, -5364, -5364,  3627,  3087, -5364,
    3582, -5364, -5364, -5364, -5364, -5364,  3141,  3345,  3676,  3789,
   -5364, -5364,  1256, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  3222,  3280, -5364,  3582, -5364,
   -5364, 52166, 71981,  4688, -5364, -5364,  2870,  3443,  3864, -5364,
    3958, -5364,  3888, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  3393, -5364, -5364, 57681,  3878,
     723,   478,  3344,   514,   826, 43015,   263, 79681,   900,  1172,
    3349, 62381, 46663,  3351,   353,  3353, -5364,  3356,  3358,  3369,
    3375,  3377,  3379,  3383, -5364, -5364, -5364,  3455,  3381,  3130,
    1553, -5364, -5364,   245,    24,  3439, -5364,  3737, -5364,  1553,
   -5364, 39541,  4026,  2498, -5364,   117, -5364,  4075, -5364, -5364,
    3490,  3475,  3507, -5364,  1082, -5364,  2461, -5364,   146, -5364,
    4026,  1553,  2498, -5364,  3675,  3758,  1009,  4084, -5364,  2130,
   -5364, -5364, -5364,  3465, -5364,  3414, -5364, -5364,  3453, 86721,
   -5364,  4066, -5364, 71981, -5364, -5364, -5364, -5364,  3421, 71981,
   71981, 86721,  1403,   180,  4087,  3423, 24370, -5364, -5364,  5455,
   40251,  3620,   330,   -43, -5364, -5364,  2953, 86721, -5364, -5364,
    1195, -5364,  3851, -5364,  3437, -5364, 88641,   180,  4117, -5364,
   -5364, -5364,   -63,  3843, -5364,  3457, -5364, -5364, -5364, -5364,
   71981, 86721,  2461, -5364, -5364, -5364, -5364,  3460, -5364, -5364,
    3656,  3544, -5364,  3487, -5364, -5364,   438, -5364, -5364,  4161,
   -5364, 86721, -5364, -5364,  2928, -5364,  2928, -5364, -5364,  2928,
    2928,  2344,  2928, -5364, -5364,  3502, -5364,  3791,  3792,  3031,
   -5364, 65581, 86721,  4150, -5364,  2352, -5364, -5364,  3477, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4054,  3988,  3988,
   -5364, 63021, -5364, -5364,  4157,  2885,  3975, 80321,  4135,  4235,
   -5364,  4026, -5364, -5364, -5364,  1873, 86721, -5364,  1873,  1873,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
     534, -5364, -5364,  2382, 48700, 86721,  2967,  1148, 14748,  4024,
    4202,  3868, -5364, 86721, -5364, -5364, -5364,  2742,  3489, -5364,
   -5364, -5364, -5364, -5364,  4260, -5364, -5364, 71981,  3693,  3877,
    3877,  3877,  4271, -5364, -5364, -5364, 51466, 71981, -5364, -5364,
   -5364,   250, -5364,   914, 86721, 71981,  3542, -5364, 71981,  3500,
   24370, -5364, 24370, -5364,  3862,  4087, -5364, -5364, 71981,  2139,
   -5364, -5364, -5364,  4260,  3877, -5364,  3942,  1466,  3516,  3519,
   -5364,  3527,  3527,     6, -5364,  3528,  4095,  3528, -5364,  3921,
    2644,  2828,  3921, -5364,  2644,  3528, -5364,  3533, -5364,  3921,
   -5364,  2644,  3527, -5364,  3527, -5364, -5364,  2644,  3527, -5364,
    3534,  3528, -5364, -5364,  3921, -5364, -5364, -5364, -5364,  1317,
    2689,  3528, -5364, -5364, -5364,  3527,  3535,  3527,  3527,  3527,
    3527, -5364,  3527,  4114,  3540,  1883, -5364, -5364, -5364, -5364,
   -5364, -5364,  3528,   437,  3527,  3527,  3527,  3527,  3553, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,  4225, 86721,  4233, -5364,
   71981,  4315, 71981,  4238,  2885, -5364,  3561, -5364,  3557, -5364,
   -5364,  4251, 86721, 86721, -5364, -5364, -5364, -5364,  3559,  2762,
   53536, -5364,  1363,  3918, 52166, 71981, -5364, -5364,  4188,  4215,
   -5364, -5364, -5364, -5364, -5364,  3646, -5364, -5364,  3575, -5364,
   -5364, -5364,  3578, -5364,  3578,  3578, -5364, -5364,  3578, 52166,
   -5364, -5364, 51466,  2101,  5011,  4239,  3592, -5364,  4066, -5364,
   25842, -5364, 26578, -5364, -5364, -5364,  3853,   360,  1371, -5364,
   -5364, -5364, -5364, -5364,  4061, -5364, -5364, -5364, -5364, -5364,
   86721,  3805,  4265,  4244, -5364, -5364, -5364,  4122, -5364, -5364,
    4076,  3605,  4227,  3600, -5364, -5364, -5364,   222, 24370,  3607,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, 71981,
    3612, 29522, 29522, -5364,  4376,  4376,  4376, 24370,  3745,  1350,
    3969, 24370, 24370, 24370,  1990,  3616, -5364, -5364, -5364,   344,
   -5364,  3618, 24370, 24370, 67501,  3626,  1222,  3488, 24370,  4329,
   24370, 24370, 24370, 24370, 18482,  5643, 24370, -5364, -5364, 88001,
   67501,  4074,  3630, -5364,  3631, -5364,  2503, 24370,  2575, 24370,
   -5364, -5364, 24370, 24370,  3633, 24370, 24370, 31730,  3634, 24370,
   24370,  3637,  3769,  4376,  4376,  2634, -5364, -5364, -5364, -5364,
   -5364, -5364,  4376,  4376, 24370, 24370, 19218, 24370, 24370,  2812,
   24370, 24370, 24370, -5364,  3635, 24370, 24370, 24370, 24370, 24370,
   24370, 24370, -5364, 24370, 24370, 24370, 24370,  2073, 24370, 24370,
   71981, 24370, 24370, 24370, 24370, 24370, 24370, 24370,  4320, 71981,
   24370, 24370, 24370, 24370,  4321, 24370, 24370, 24370,  3654, 24370,
   71981, 24370, -5364, 24370,  4156,  4156, -5364, 24370, 19218, 24370,
    3655, 68141, 24370, 24370, 24370, 24370, 25106, -5364, 25106, -5364,
   -5364,  3659,  1440,   390,   534, 24370,  3644, 63661, -5364, -5364,
   -5364, -5364, 24370, 24370, 24370, 31730, -5364,  1586, -5364, -5364,
   -5364, -5364, -5364, 15510, 31730,  3657, 31730, 31730,  4293,  2473,
   31730, 31730, 31730, 31730, 31730, 31730, 31730, 32466, 33202, 31730,
   31730, 31730, 31730, -5364, 82881, 29522, 73261,  3681,  4344, -5364,
   88001, -5364,  2340,  1320, -5364,  2461,  4208, 34665, -5364,  3679,
   -5364,  4184,  3683, -5364,  1664, -5364,  3686,  4366, 52166, 51466,
    2173,  3702, -5364,  3687,   907,  3691, -5364, -5364, 53536, 86721,
   -5364, -5364, -5364, -5364, -5364,  4431, 24370, -5364, 52166, -5364,
    1691, 14748, -5364,  1213,  1723,   353, -5364, -5364, -5364, -5364,
   -5364, 14748, 86721, 58365,  3694,  3788,  3708,  2928, 49348, 86721,
   71981, 86721, 86721, 86721, 71981, 52166, 71981, -5364, -5364, -5364,
     845,  1553, 86721,  1553,  2498,  4345, -5364,  1544,  1544, -5364,
   -5364, -5364, -5364, -5364, -5364,  1553, 86721, 86721,  1553, 51466,
   -5364,  2498,  2432, -5364,  3991,  3782, -5364, -5364, -5364,  4036,
   -5364, -5364,  4387,  3709, -5364,  4058, -5364, -5364,  3804, -5364,
   -5364, 71981, -5364, -5364,  2498, -5364,  2498,  2498, 24370,  1553,
    1553,  1553, 66861,  3715,  3719, -5364,  3718, -5364,  3722, -5364,
   -5364, -5364, -5364, 71981, -5364, -5364,  4077,  3717,  4377,  3732,
   -5364, -5364,  4305,  1377,  4269, -5364,  4158, -5364,  4292, -5364,
   24370,  4087, 20690,  4012, -5364, -5364,  4013,  4015,  4016, -5364,
   -5364, -5364, -5364,  4172,  4027, -5364,  2461,  4029, -5364, -5364,
    3752, -5364, -5364, -5364, 34665, 82881, -5364,  3754, -5364,  3780,
   -5364,   234, -5364, -5364,  4451,  3869, 24370, -5364, -5364, 71981,
    4267, -5364,  2461,  2099, 86721, -5364, -5364,  4533, -5364,  2296,
   -5364, -5364, -5364,  3883,   358, -5364, -5364,  1664, -5364, -5364,
    2179,  3954, -5364, -5364, -5364, 82881, -5364, -5364, -5364, -5364,
   -5364, -5364, 53536, 51466, 82881, -5364,  2928,  2928, -5364, 71981,
    2928, 86721, -5364, -5364, -5364,  2928,  2928,  2928,  3808,  1905,
    3778,  3783,  3784,  3787,  2335,  3793, 68781,  2791,   226,  4424,
    4433, -5364,  4371,  3707,  4371, -5364, -5364, 68781, 66861,  3795,
    4150, -5364, -5364, -5364, -5364, 82881,  3790, -5364, -5364,  3798,
   -5364, 24370,  4543,  4474,  4157,  1724, -5364, -5364,  4151, -5364,
   84161,  4351,  1263, -5364,  3807,  3932, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, 29522,  2914, -5364,  4087, -5364, -5364, -5364,   278,
   -5364, -5364, -5364,  1561,  4182,  2043, -5364, -5364, 82881,  2043,
    1614,  2056, -5364,  3821,  2461,  1771, -5364,  1771, -5364,  4124,
   -5364,  4125,   236, -5364,  1664, -5364, -5364, -5364, -5364, -5364,
   71981,  3826, -5364,  4017, 86721,  2518,  3832,  3833,  4087,  4087,
   -5364,  6953,  4575,  4311,  5503,   198,  3892, -5364, -5364, -5364,
   -5364, -5364, 71981, -5364, -5364,  2529,  2989,  4336,  3852, -5364,
    1466, -5364, -5364, -5364,  2570, -5364, -5364, -5364,  3921,   353,
    3921, -5364, -5364,  2710,  1058, -5364, -5364, -5364,  1058, -5364,
     357, 56997, -5364, -5364, -5364, -5364,   327, 48046,  1364, -5364,
    4241,  3878,  3921, -5364,  4332,  2644, -5364, -5364,  1058,  2179,
   -5364, -5364,  3921, -5364, -5364, -5364,  2179,  1058, -5364,  4347,
   -5364, -5364, -5364,  1058,  3921, 91201,  1883,  2644, -5364, -5364,
    2644,  1058,   407, 86721, 24370, 24370, -5364,  4412, -5364,   327,
    4621,  2644,  3921,  1058,  4462, -5364,  1058, -5364, -5364,   288,
    4054,  3949, -5364,  3870, -5364, -5364,   819,  4443, -5364, -5364,
    4460, 86721,  4551, 75841, -5364, -5364,  4468, -5364, 86721,  1363,
    3879, -5364, -5364, -5364, -5364, -5364,   353, -5364,  3882,   195,
   71981, 71981,  6953,  4021, -5364, -5364, -5364, 86721, -5364, -5364,
   -5364, -5364,  4388,   239, 35313, 69421, -5364, 69421, 69421, -5364,
   -5364, -5364, -5364, -5364,  1045, -5364, -5364, -5364, -5364, -5364,
   -5364, 24370, 50048,  4087, -5364, -5364, 71981, -5364,  4545, -5364,
   -5364, 89921,   152, -5364, -5364,   201, 71981, -5364, -5364, 24370,
   -5364,  4541,  4025, 86721, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, 86721,  2518,  4087, 86721, 50761, -5364, 91201,  6953,
    6953, 24370,  1594, 24370, -5364,  3897, -5364,  3898,  3900,  3729,
    4256, 24370, 24370, -5364,  3396,   805,   264, -5364,  3907,  3919,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  3914, -5364,
   -5364, -5364,   397,   523,  3915, -5364, -5364, -5364,  3916,   534,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    4592, -5364,   171, -5364, -5364,   286,   302,   536,   541,   563,
    3929,   570,  3635,  2395,  3923, 67501, 88001,  4376,  3927,   252,
    4376,  3936,   598,   311,   602, -5364,   584,  1305,  2929, -5364,
     606,   620, -5364, -5364,  3937,  3939,  4376,  3941,  3945,  3946,
     624,   321,  3950, 21426, 22162, 22898,  3799,  3953,   702,  1731,
    4376,  3959,  1933,  2413,  1936, 88001,   734,  1939,  1066, -5364,
    2419,  1133,  1265,  1275,  1284,  1942,  1948,  1291,  2420, -5364,
   -5364, -5364, -5364,  3947,  1952,  1961,  3956,  3961,  2429,  1970,
    1973,  1984,  2452,  2460,  2505, 71981,  3964,  1992,  2008,  1302,
    2524, 71981,  2018,  2060,  1313, -5364,  2070,  3966,  1330,   324,
    3971,  3972,  2083,  3965,  1367, -5364, 88001, 86721,  3976,  3968,
     433,   420,  1378,  2176,  5643,  5643, -5364, 24370,  3979,   231,
   88001,  1723, -5364,  4498,  3149,  1965, -5364,  1783, -5364, -5364,
   -5364, -5364,   246, -5364,  3981,  1783,  3983,  2164, 18482, -5364,
    1814,  2953, 31730, 31730,  3984, 31730, 31730,  3992,  3992,   519,
    2435,  2435,  3422,  3299, 25106,   519, 25106,   519,  3992,  3992,
    3992, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4560,
    3989,  2253,  3987, -5364, -5364, -5364, -5364, -5364, -5364,   821,
    4394, -5364,  4186,   279, 24370, -5364,  4018,  4501,  4504,  4505,
   -5364, -5364, -5364, -5364, 52166, 52166, 71981,  4502, 24370,  4675,
   53536,  4681, -5364,  4008, 35961, 69421, 69421, 69421, -5364,  4023,
   -5364, 24370, 86721, 86721, 14748, 57681,  4691,  4694,   353, 56997,
   -5364,  4087,   353, -5364,  4019,  4028, -5364, -5364,  1514,  4296,
   -5364,  4033,  4034, -5364,  4032,  4035,  4037, 61101, 24370, -5364,
     353,  1213, -5364, -5364, -5364, -5364, -5364,  4040, 86721, 86721,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  2461,
   24370, 86721,  1553, -5364, -5364, -5364,  1553,  2461,  4698, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  1553,
   -5364, -5364, -5364, -5364, -5364,  4192,  4026,  1082,  4345, -5364,
    2498, 71981,  1553,  1553,  4087, -5364, -5364, -5364, -5364,  4574,
    4054, 20690,  4043,  4044, -5364, -5364,  6953, 86721, 86721, -5364,
   -5364,  1408, -5364,  4054,  8135, -5364, 82881, 59049, 71981, -5364,
   -5364, -5364,  2802, -5364, -5364, -5364, -5364, -5364, -5364,  4087,
    2731,  2914, -5364,  4046,  4087, -5364, -5364,  4757, -5364, -5364,
   -5364, -5364,  2461, -5364, -5364,  5800, -5364, 71981, -5364, 64941,
   -5364, 64941,  2286, -5364, 89281, -5364,  2461,  4087, 71981,  1634,
     201, -5364,  4815, -5364, -5364,  4163, -5364, -5364, -5364,  4053,
   -5364,  4103, -5364, -5364, -5364,  4056, -5364,  4736, -5364,  2110,
     367,   236, -5364, 86721, 86721, 86721, 71981, -5364, 86721, -5364,
   86721,  2928, -5364, -5364,  2928, 71981, 86721, 86721,  2928, 68781,
   -5364, -5364, -5364, -5364, -5364, 68781, -5364,  1385, -5364,  4262,
    2247,  2247, -5364, -5364, -5364, -5364, -5364,  4703,  4371,  4371,
   68781,  4706,  4752, -5364, 86721,  6143,   447, -5364, 63021, 86721,
    4087, 24370, -5364,  4102,  4474, -5364,   201, -5364, 81601, -5364,
    4415, 81601, 81601, 88001,  4307, 24370,  4078, 14748, -5364,   353,
     353,  4300,  4599,  4600,  4203,  2461,  4602,  4606,  4608, -5364,
   -5364, -5364,  2461,  2461, -5364, -5364,   353, -5364,  3100, -5364,
   -5364, -5364, -5364,  3651,  2321, -5364,   353,   353, -5364,  2617,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  1693, -5364,   217,
    1768, 51466,  4561, -5364,  4682,  4094, -5364, 71981,  4773, -5364,
   -5364, -5364, -5364, 24370,  4604,  6515, -5364, -5364,  4311, -5364,
    4118,  4120,  4121,  4128,  4129,  4131,  4132,  4137,  4138,  4142,
    4143,  4145,  4147,  4149,  4154,  4162,  4165,  4167,  4168,  4169,
    4170,  4173,  4176,  4181,  4105, -5364, -5364,  4153, -5364, -5364,
   -5364, -5364,   353,   353,   353,   353, -5364,  3549, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,  4389,  3226, 86721,  4771,
    4487,  4155,  4166,  4171,  4174, -5364, -5364, 86721, -5364,  2536,
    4632,  4658, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,   353, -5364, -5364, -5364, -5364,
    2540, -5364, -5364,  2547, -5364, -5364, -5364, -5364,  7060, -5364,
    2559, -5364, -5364, -5364, -5364, -5364,  1883,  1883,  4178,  4087,
    4087,  4187, -5364, -5364, -5364, -5364,  4621, -5364,  4175, -5364,
   73901, -5364, -5364, -5364, -5364,  2626, -5364, -5364,  2247, 86721,
    4662, 75841, -5364,  4374,  4809, -5364, -5364, 66861, -5364,  4179,
   71981, -5364, -5364, 53536, -5364, 82881, 52166, -5364, -5364, -5364,
    4185,  1594,  7860, -5364,  4189, -5364,  2560, -5364, 51466,  4638,
   -5364, 69421,  4190, -5364,  4191,  4692,  4696,  4699,  4701, -5364,
    1408,  4087, -5364, -5364,  4200, -5364, -5364,  4305,  3988, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  4216,  4467,  4593, -5364, -5364, -5364,  4087, -5364, -5364,
   -5364,  4852, -5364, -5364, -5364,  2566,   238, -5364, -5364, -5364,
    4569, -5364, 92769, 92769, 92769, -5364,  1548, -5364, 24370, -5364,
   -5364, 24370, -5364,  4087,  3834,  3493, 48046, -5364, 48046,  3493,
   24370, -5364,  4206, -5364,  4855,  4865, -5364, -5364, -5364, 24370,
   -5364, 24370, -5364, 24370, -5364, 24370, 24370, 24370, 24370, 24370,
   24370, -5364, 31730, -5364,  4211,  4219, -5364, -5364,  4220, -5364,
   24370, -5364, 24370, -5364, -5364, 24370, 24370, 24370, -5364, -5364,
    4221, -5364, -5364, -5364, 24370, 24370, 24370, -5364, 24370,  4333,
   24370,  4354, 24370,  4401, 24370, -5364, 27314, -5364,  4229, -5364,
   -5364, -5364, -5364, -5364, 24370, -5364, 24370, -5364, 24370, 24370,
   24370, 24370, 24370, -5364, -5364, 24370, -5364, 24370, -5364,  4804,
   24370, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, 24370, -5364, -5364, -5364, -5364, 24370, -5364,
     528, 28050, -5364, 24370, 24370, 24370, -5364, -5364, 24370,  4230,
    4232, -5364, 86721, -5364, 24370,  2957,  3483,   201,  4240, 24370,
   -5364,  4253,  4255,  3423, -5364, -5364, -5364, 90561, 24370, -5364,
   -5364, -5364, -5364,  1222, 31730,   442, 31730,  2953,  3133, 18482,
   -5364,  1890,  2953,  5643,  5643, 86721,  4971,  4245, -5364, 24370,
   88001, 24370,  4246,  4248, -5364,  4254, 31730, -5364, -5364,  4258,
   -5364,   446,  3483,  4334,  4705, -5364,  4087, 34665,  4754, -5364,
   -5364, 71981,  3217,  4453, -5364, 52166, 51466, 69421,  4937,  4940,
    4944,  4946, -5364,  4087, -5364,  4270,   353,   353, -5364, -5364,
   17006, 52166, 14748, -5364, -5364,  4781,  4783, -5364, -5364,  1179,
    4568,  4840, -5364, -5364, -5364,  4276, -5364, -5364, -5364, -5364,
     913, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4087,
   14748, -5364,  3694,  4282, 37387,   861, -5364, -5364, -5364,  4087,
   -5364, -5364, -5364, -5364,  4298, -5364, -5364, -5364,  4878, -5364,
   -5364,  4698,  2885,  2498, -5364, -5364, 68141,  3078, -5364, -5364,
   -5364, 20690,  8256, -5364,  2579, -5364,  5048, 68141,  4761, -5364,
   -5364, -5364, -5364,   916, -5364, -5364,  4286,  4753, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4297, -5364,
   14748, -5364, 20690,  4314, -5364, -5364, -5364,  4185,   396,  4316,
    4299, -5364, -5364, -5364, -5364, -5364, -5364,   456,   558,  3638,
    2885, -5364, -5364,   131, -5364, -5364, -5364, -5364, -5364,  1245,
   -5364, -5364, -5364, -5364,  2296,  2146, -5364,   235,   201,  4534,
   -5364, -5364,  2110,  4749, -5364,  4561,  4981,    83,  4895,  4896,
   -5364,  3651, -5364,  2292,  2014, -5364, -5364, -5364, 86721, -5364,
      61,  -134,   318, 71981,  2352,  2352, -5364,  2247,   464, -5364,
   31730,  5067, -5364,  4808, 68781,  4951,  4952, -5364, 68781, -5364,
   -5364,  2585, -5364, -5364, 47391, -5364, -5364, -5364,  4087,  1043,
    2477, 24370, 86721, -5364,  4102, -5364, -5364, -5364, 81601, -5364,
   -5364, -5364,  1724,  4309,  2477,  4313, -5364, 56997, 47391, -5364,
    4689,  4690,  2126, -5364, -5364, -5364, -5364, -5364, -5364,  3710,
    2056, -5364,   353,   353, -5364,   256,   353, -5364, -5364,   576,
   -5364, -5364,  2258,   422,  3651, -5364,  2461,  2461,  2461,  2461,
     201,  2461,  2461,  2600, -5364,  3710,  3710,  1771, -5364,  1162,
   -5364, -5364, -5364, -5364,   179, -5364, -5364, 82881, -5364,  4822,
    4823, -5364,  4826, -5364, -5364,   299, -5364,  2721,   154,  6525,
     942, -5364,  4873, 86721,  5082,  4094, -5364,   385,  2518,  4087,
   -5364, 24370, -5364,  4325,  4328,   201,  4330,   201,   201,  2461,
    2461,  4298,  2461,   201,  2461,  2461,  2461,  2461,  2461,  2461,
    2461,   201,  2461,  1581,  2777,  2461,   201,  5503, -5364,  2461,
    3483,  3710,  3710,  2989, -5364,  4998,   353, -5364,  3341, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  2612, 44483,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4924,
   -5364, -5364, -5364,   327,  2179,   327, -5364, -5364, 91201, -5364,
   -5364, 86721,  4925, -5364, -5364, -5364, -5364,  4272, -5364, -5364,
   -5364,  4654, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    4331, 66861,   959, -5364, 80961,  4881,  2885,  4346, -5364,  1664,
   -5364, -5364, -5364, -5364,  1366,  4963, -5364, -5364,  5043, -5364,
   86721,   425,  4542,  4847,  4359, 76481, 51466, 51466, 51466, 51466,
   -5364,  4945, 71981, -5364,  5006, -5364, -5364, -5364, -5364, -5364,
   24370, -5364, -5364, 86721,  2518,  4787, 92769,  4977, -5364, -5364,
   -5364, -5364, -5364, 24370,  4087,  4087, 24370,  3527,  3527,  3528,
    3553, -5364,  5074, -5364,  5010,  3527,  3527, -5364,  3527,  5012,
    3527,  3527,  4365, -5364, -5364,  4367,  4370,  4373,  3423, -5364,
   24370, 24370,  2212,   209,  2224,  2248,  1575,  1811,   455, -5364,
    2262,  3382, 88001, -5364, -5364,  2282,  2289,  2298,  2309,  2322,
   -5364,  1824,  4006,  1827,  4087, 24370,  4087, 24370,  4087, 24370,
    4087, 25106,  2336, -5364,  2615,  3948, -5364,  2625,  3963,  2383,
     458,   475,  2476,  2501,  2508,  2628, -5364,  2672,  4964,  2658,
   25106,  2539,  2621,  1837,  1903,  2638, 88001, 86721,  4368,  2698,
    4375,  4375,   218, -5364,  4378, -5364, -5364, -5364,  4379, -5364,
    2704, 24370, 24370,  4382,  4087,  4383,  1783, -5364, 24370,  2953,
   31730,   518, 31730, -5364, -5364,  4560, -5364, 24370, -5364,  4962,
    4384,  3423,  4386,  4087, -5364, -5364, 86721,  4390,  3680, -5364,
    4298, -5364,  5034, -5364,  5135,  4393,  4411,  4396,  4258, -5364,
   52166, -5364,  4948,  5071,  3882, -5364,  5075, 51466, 51466, 51466,
   51466, -5364, 42287, -5364, 77121, 14748, 14748, -5364, -5364, -5364,
    4399,  4402,   729,  4960, -5364, -5364, -5364, -5364, 86721, 86721,
   14748, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  2826,
   -5364,  4026, -5364, -5364, -5364,  1553,  4403, -5364,   353,   259,
   -5364, 20690,  4406,  4407, -5364,  5022, -5364, 86721,  4409,  4410,
    4414, -5364, -5364, -5364,  4404,   534, 68141, -5364, -5364,  4887,
   -5364,  4420, 84801, -5364, -5364,  4421, -5364,  4973, -5364, -5364,
    4739, 64941, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364,  4026,  4647, -5364, -5364, -5364,  4440, -5364,
    4423,  4515,  4516, -5364, -5364, -5364, 51466,   154,  4802,  1587,
    1587,  5021, 71981, 71981,  7194,  7544,  3651,  2292, -5364, -5364,
   -5364,  2461, -5364,  2014, -5364, -5364,  4435, 86721, -5364,  4094,
   -5364, -5364,   501, -5364, -5364, -5364, -5364, -5364,  3680,  2247,
    2247,  4480,  4921, 68781, 68781,  4737,  4922, 24370,  4438, -5364,
   86721, -5364,  1183, -5364,  4844, -5364, -5364, 24370, -5364, -5364,
   -5364, -5364,  4087,  5201,  4441, -5364, -5364, -5364, -5364, 24370,
   -5364, 24370,  4444,  4445, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
     528,   528, -5364, -5364,   528,   528, -5364, -5364, -5364, -5364,
     528,   528, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  2321, -5364, -5364, -5364,  1693, -5364, -5364,  4953,   434,
   -5364,  5030, -5364, -5364, -5364, -5364,  1343,   201,   201,   201,
    2777,  2447, -5364,  2721,  2116,  4784, -5364,  4563,  4848,  5025,
    4848,  5027,  4954,  3469,  4819,   353,  5033,  5204,   353, -5364,
     213,   353,   353,   353,   353,  4500,   353,   353,   353,   353,
    5037,   353,   353,  4830,   353,  5110,  4544,  5112,   353,  5046,
   -5364,  4547,   353,   353,   353,   353,  4848,   353,   353,  5049,
    4663,  5051,  5052,   353,   353,   120, 86721,   353,   353,  5053,
   -5364, -5364,  7544, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
     435, 70061, -5364, -5364, -5364, -5364,   353,  2953,  1037,  4983,
    2084, -5364,  2662, -5364,  5244, -5364,   208, -5364, -5364, -5364,
    4087,   424,   470, -5364,   479, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, 86721,  3710,  3226, -5364, -5364, 86721,  3527,
    3527,  3527,  3535,  3527,    95, -5364, -5364, -5364, -5364, -5364,
   -5364,   437,  3527,  3527,  3527, -5364, -5364, -5364,  4488, -5364,
   -5364, -5364, -5364, -5364, -5364, 73901, -5364, -5364, 75841,  2885,
   -5364, 86721,  4829,  5031,  3702, -5364, -5364, -5364, -5364, -5364,
    4489, 24370, -5364, -5364,  5162, -5364, -5364, 51466, -5364, -5364,
     236,   236,   236,   236,  3370,  4850, -5364, -5364, -5364,  5006,
    4772, -5364,  1127,  4087, -5364, -5364, -5364, -5364, -5364,  6953,
     455,  4087, -5364, -5364, -5364, -5364,  3527, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4496,  5643,
    5643, -5364,  5241,  5035, -5364, -5364, 24370, 24370, -5364, 24370,
   -5364,  2093,  4499,  4969, -5364, -5364, -5364, -5364, -5364, -5364,
   24370, 24370, 24370,  4087,  4087,  4087,  5643, -5364, -5364,  2886,
   -5364, -5364,  3493, -5364, -5364, 24370, -5364, 24370, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,   292,  5643, -5364, -5364,
   24370, 24370, -5364, -5364, -5364, 86721, -5364,  3483,  4508,  4778,
   -5364, -5364, -5364,  3483,  4639, -5364, -5364,  3483,   201, -5364,
   -5364, -5364, 86721, -5364,  2700,  1783, -5364, 24370,  2953,  5094,
    4509,  5254,  4512, -5364, 24370, 42287, -5364,  4517,  4514, -5364,
   -5364, -5364, -5364, 24370,  5146,  5093, -5364,  3483, 86721, -5364,
   -5364, -5364, 51466, 51466,  4008,  4008,  4008,  4008, 85441, -5364,
   -5364, -5364, -5364,  2284, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,   353,   353, -5364, 37387, 57681, -5364, -5364, -5364, -5364,
   -5364, -5364,  4026, -5364, 68141,  2885, 23634, -5364, -5364, -5364,
   20690, -5364, -5364,  1222, -5364, 68141, 77761,  4520,  4519, -5364,
     353, -5364,  4887, -5364, 40917, -5364,  4525, -5364,  4524, -5364,
    2357,  4861,  5152, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4536, -5364,
   -5364,  2461,  2459, -5364, -5364, -5364, -5364,  4564, -5364, -5364,
   -5364, -5364, -5364, 71981, -5364, -5364, 41626,  5171, 71981, -5364,
   -5364,  5118, -5364,  6307, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364,   432,  5136,  5304, -5364,  4548, -5364,
   -5364, -5364, -5364,  4650, -5364,  4548,  4094, -5364, -5364, -5364,
    5036, -5364, -5364, -5364,  5039,  4087, 86721, -5364, -5364, -5364,
    1621,  2276,  5181,  2477,  4556, 86721,  2477,  4087, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,   188, -5364, 82881, -5364, -5364, -5364, -5364, -5364,  5150,
    5153, -5364, -5364, -5364, -5364,  4745,  1046, 70701,  2928, -5364,
    2845,  4603, -5364, -5364, -5364,  2005, -5364,  2928,  2802,  2802,
    5219,  3284,  1035,  3284, 40917,   447,   428,  5202,  2424,  2846,
    4605,  5132,  3284,  3284,   353, 59733,  1035, 68141,   173, -5364,
   -5364, -5364, -5364, 71981,   192,   267,   287, -5364, -5364, 60417,
    4298,   201,   201,  1035,  2461,  2461,   353,   201, -5364, -5364,
   -5364, 82881, 86721, -5364,  2131,   201,  4298,  4298,  3284,   309,
    2461,  1035, -5364,  1035,  1035,  2433,   173, -5364, -5364, -5364,
     201,   173, 40917, -5364,  9695, -5364, -5364, -5364, 41626, 86721,
    1003,  5122, -5364,  4571, 54927, -5364,  4755, 24370, 24370,  5169,
   86721,  5172, -5364,  4980, -5364, 86721, -5364,  1222, -5364, -5364,
   -5364,  4880,  5090,  2703, -5364, -5364,  2706, -5364, -5364,  2714,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364,   327,  5127, 86721,   327,  4621,   327,  4621,  1222,
   -5364, -5364,  4179, -5364,  5263, -5364,  4931,  4023, -5364,  4087,
   -5364,  4785,   236,  5061,  5061,  5061,  5061, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  5239,  2518,  4947,  8418,   327,
   -5364,   327,   327, -5364,  4595,  4596, 24370,  2179,  5231,  2711,
    1927,  2718,  4885,  4836, -5364,  4769, -5364,  2723,  4087,  4087,
    2024,  3528, -5364, -5364, -5364, -5364,  5252,  3527, -5364,  5345,
   -5364,  3527, -5364, -5364, -5364, -5364, -5364, -5364,  4609,  2726,
    2739, -5364, -5364, -5364,  2722,  2160,  2743,  2747, -5364, -5364,
   -5364,  4610, -5364, -5364,   310, -5364,  4611, -5364, -5364,  2752,
    5355,  2350, 24370, -5364,  4612, -5364, -5364, 86721,  5643,  1177,
   -5364,  2756, -5364, -5364,  4615,  4008,  4008, -5364, -5364, 78401,
   14748, 14748, -5364, -5364, -5364, -5364,  4460,  2914, -5364, -5364,
   -5364, -5364,  4618, -5364, -5364,  4613, -5364, 68141, 20690, 73901,
   -5364, -5364,  4619,  4622, -5364, -5364, -5364, 84801, -5364,  2797,
   -5364, -5364,  5381, 20690, -5364, -5364, 82881, -5364,  4624,  4626,
   72621,  3250,  2803, -5364, -5364, -5364, -5364, -5364, 71981, -5364,
     463, -5364,  7758, -5364,  7544, -5364,  1225, 86721,  4263, -5364,
   -5364,  1226,  4751, -5364, -5364,  8181,  4628, 86721,  2461, -5364,
    4630,  5390, 24370,  4633, 24370,  4635,  2820, -5364,  2802, -5364,
    2802, -5364,  1621,  5380,  5383,  5328,  5387,  2276, -5364,  2732,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4646, -5364, -5364,
   -5364, -5364,  4982, -5364,  5245, -5364,  5097,  2953, -5364, -5364,
    1035,  4652,  2953,  5331, -5364,  4656,  5297,  5298,  2802, -5364,
    2928, 72621, -5364,  2928,  2928, -5364, 72621, 40917, 72621, -5364,
   47391, 72621,  3284, 86721, -5364,  5336, -5364,  5300, 72621, 72621,
    2461, -5364, -5364, 40917,  4659, -5364,  2477, -5364, -5364, -5364,
    2817, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4664, -5364,
   -5364, -5364, -5364, -5364,  3483, -5364, -5364,  2461, -5364, -5364,
    5133, -5364, -5364, -5364, -5364, -5364, -5364, -5364, 72621, -5364,
   -5364, -5364, 40917, -5364, 40917, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  4436,  3095, -5364,
    4665,  4666, -5364, 86721, -5364, -5364, 71981, -5364, 45217, 86721,
   -5364, -5364, -5364, -5364, -5364,  4087,  5643,  5056, -5364, -5364,
    4779,  2461,  5029, -5364,  5143, -5364, 86721,   215, -5364, -5364,
     201, -5364,   201, -5364,   201, -5364, -5364,   105, -5364, -5364,
   -5364, -5364, -5364,   534, 31730, -5364, -5364,  5061,  2891, -5364,
   -5364, -5364, -5364, -5364, -5364,  5313,  5182, -5364, 92769,  5293,
   -5364, -5364, -5364, -5364, -5364,  4674,  2477, -5364, -5364,  4677,
   81601, -5364, -5364, 24370, -5364,  4910, -5364,  5015, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,   327, -5364, -5364, -5364, -5364,
    4298, -5364, -5364, -5364,  4680, -5364,   201, -5364, 24370, -5364,
   -5364,  4684,  4400,  2477, -5364, -5364,  4775,  4705,  4686, 86721,
   -5364,  5093, -5364, -5364, -5364, -5364,  4809, -5364, 79041, -5364,
   -5364,    99, -5364, 86721, -5364, -5364,  4298,  5050, -5364,  2881,
    4882,  4697, 86721, 86721, 86721, -5364, -5364, 41626,  4693, -5364,
    5449, -5364,  5118, 93316, -5364, -5364,  5045,  1225, -5364,  1835,
    4695,  4702, -5364, -5364, -5364,  5400,  2292, -5364, -5364, -5364,
    5289,  1037, -5364,  4263, 86721, -5364,  5247,  4704, -5364, 86721,
    5251, -5364,  4087, 86721,  4087, 86721, -5364,  5378,  5378, -5364,
    2179,  2179,  5452,  2179, -5364,  5454,  5456,  2732, -5364,  5216,
    1046,  5083,  2116,  5401, -5364, 86721,  5402, -5364, 24370,  2928,
   -5364, -5364, 72621,  5200,  1902, 72621, 72621,   417, -5364, 72621,
    2529,  4431, -5364, 72621,  4622, 86721, -5364, -5364,  1366, -5364,
   -5364, 68141, -5364, -5364, 71981, -5364, -5364,  5224,  1003, -5364,
   86721, -5364, -5364, -5364,  4719, -5364,  4712,  5458, -5364, -5364,
    4716, -5364, -5364, -5364, -5364, -5364,  1277, -5364,  2884, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,   459, 86721,  3458,
   -5364,  4919, -5364,  2891, -5364,  5218, 71981, -5364, -5364, 24370,
   -5364, -5364, -5364,  1340,  2759, -5364, -5364, -5364,  4727, -5364,
    4730,  4309, -5364,  5145,  4860,  4501,  4504,  4505,  4908,  5077,
   -5364,  4914, -5364,   201, -5364,  4740, 31730, -5364,  1550, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,  5157, -5364,  4744, 86721,
    2912,  2477,  4746,  2923,  4747, -5364, -5364, -5364,   916,   463,
   -5364, -5364, -5364, 93316,  1255, -5364, -5364, -5364,  4738,  4741,
   -5364,  4742, -5364, -5364, -5364, -5364,  5329, -5364, 45951, -5364,
   86721, -5364, -5364, -5364,  5169,  2292, -5364, -5364, -5364, -5364,
   -5364, -5364,  2924,  2934,  2596, -5364, -5364, -5364, -5364,  2179,
   -5364,  2179,  2179, -5364,  4750, -5364, -5364, -5364, 72621,  1528,
    4756, -5364,  2763, 72621,  5200,  2071,  1587, -5364,  1587, -5364,
   -5364,  5460,  5461,  1003, -5364, -5364, -5364, -5364, -5364,  1035,
   -5364,  4762, 71981, -5364, -5364,  4622,  1245, 86721,  5369,  3920,
    7060, -5364, -5364,  4197, 86721,  4849, -5364,  6953,  4950,  5491,
    5498, -5364, 86721, 86081, -5364, -5364,  5337, 31730, -5364, -5364,
   -5364,  4054, 92769,  2477, 81601, 81601, -5364, -5364, -5364,  1482,
   -5364,  5525,  1535, -5364, -5364,   802, -5364, -5364, -5364, 86721,
    4767,  4853, -5364, -5364,  4839, -5364, -5364,  2482, -5364, -5364,
    2321,  2947,  1664, 86721, -5364,  5365,  1664, 86721,  5246, -5364,
     162,   164,  2234,  1255, -5364, -5364, -5364, -5364, 86721, -5364,
   86721, 86721, -5364,  3535,   240, -5364, -5364, 86721, 50761, -5364,
    2084, -5364, -5364, -5364, -5364, -5364, -5364,  5517, -5364,  5523,
    4782,  4786, -5364, -5364, -5364, -5364,  5458,  3483,  5093, -5364,
   86721, -5364, -5364, -5364,  1587, -5364,  4788, -5364,  4789,  4791,
   -5364, 33938, -5364, -5364, -5364, -5364,  5427, -5364,  2951, -5364,
    1798,  5373, -5364,  5424, -5364,  2461, -5364,  4863, -5364,  3920,
   -5364, -5364, -5364,  4832,  5431,  5386,   353, -5364, 82881, 33938,
   -5364,  5286, -5364,  5242,  5507, -5364,  5559,  4144, -5364, -5364,
   -5364, 24370,  5154,  5481, -5364,  4997,  4999, -5364, -5364,  2964,
   -5364, -5364,  4862,  3680, 68141, -5364, -5364, -5364, -5364, -5364,
   -5364,  5145, -5364, -5364,  4936,  1109, -5364,  2999, -5364, -5364,
   -5364,  3483, -5364,  4810, -5364,  5173,   353,   353,  5174,   353,
     353,   353,   353,  4813,  2482, -5364,  5159,  3005,  1664,  1791,
    2477,  4814,  1537,  4811, -5364, -5364,  4812, -5364,  4816, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,  5356, 86721, -5364,
   -5364, 71981,  4980,  5481, 86721, 86721, -5364, -5364, 84801, 84801,
   -5364, -5364,  3030,  4817,  4820,  4821, -5364, 86721,  4824, 86721,
   86721,  2777,  2777, 18482, -5364, -5364, -5364, -5364, -5364, -5364,
    3345, -5364,  4825, -5364, 86721, -5364, -5364, -5364,  1236, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, 55620, -5364, -5364,
    5412, -5364,  4867,   -32,   353, -5364,  3496,  4087, 24370, -5364,
   -5364, -5364, -5364, -5364, -5364, 86081, -5364,  4828, -5364,   353,
     447, -5364, -5364, -5364, -5364, -5364, 86721, -5364,  4827, -5364,
   -5364,   123,   353,  2461,  2461,   353,  4395,  4395,  3483, 82881,
    4909, -5364, -5364,   353, -5364,  2427,  5018,  2461,   353,  1159,
    1791, -5364, -5364,   353, -5364, -5364,  1159,  1537, -5364, -5364,
   86721, -5364, -5364, -5364, -5364,  5185, -5364,  4435,  4833, -5364,
     242,  5264,  5510,  5194, -5364, -5364, -5364,  4837,  3042, -5364,
   -5364, 86721, 86721,  4841,  3059, 86721,  3062,  3068, -5364, -5364,
    4842,  5093, -5364,  1666,  1666, -5364, -5364, -5364, -5364,  4845,
   -5364,  1012, -5364, -5364,  3496,  4087, -5364, 68141, 20690, -5364,
    4853, -5364, -5364,  3076, -5364, 28786, -5364, -5364, -5364,  2461,
   -5364, -5364,  2461, -5364, -5364, -5364, -5364, -5364,  3104, -5364,
   82881,  1587,  1587,  1159,  2427, -5364, -5364, -5364,  3264, -5364,
     201, -5364,  5463,  5287, -5364, 56313, -5364, -5364,  4854, -5364,
   -5364, -5364, 86721, -5364,  4548, -5364,  5389,   460, 86721, -5364,
   -5364, -5364, -5364, -5364,  3112,  3113, 86721,  2427,  3119,  1791,
    1537, -5364,  3129, -5364, -5364,  2369,  5302,  5437,  5438,   409,
   -5364,  3506,  3506,  2156, -5364, -5364,  5394, -5364, -5364,  4827,
   -5364,  4856, -5364,  3680, -5364, -5364, 82881, -5364,  4909, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, 86721, 86721, -5364,  4263,  4857, -5364, -5364,
   -5364,  5429, -5364, -5364, -5364,  5122,  2427,  3139, -5364,  2427,
   -5364, -5364, -5364, -5364, -5364, -5364,  5349,  5568, -5364,  4864,
   -5364,  3506, -5364, -5364, -5364, -5364, -5364,  1710,  5163,  4844,
   -5364, 28786,  4866,  2482, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  4926,  5223,  5560, -5364, -5364,  2427, -5364,  1666,  1666,
   -5364, -5364, -5364,  1710, -5364,  5616,  5181, -5364, -5364, -5364,
    4263, -5364, -5364,  5003, -5364, -5364, -5364, -5364,  2179,  5531,
   -5364, -5364,  5469,  4886,  1779,  2127, 61741,  5413, -5364, -5364,
   82881, -5364, -5364, -5364, -5364, -5364, 82881,  3140, -5364, -5364,
   68141, -5364, -5364,  6953, -5364, -5364, 64301,  4877, -5364,   353,
    5481, -5364, 68141, -5364, -5364, -5364, 20690, -5364, -5364
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1245,  2477,     0,   537,     0,  1465,   822,   567,  2328,
    2470,  2471,  2253,     2,   610,   259,  2678,  2679,   482,  2255,
    2542,     0,     0,   606,  1481,   963,   717,     0,   402,     0,
       0,   613,   400,   259,  1530,  3197,  2377,     0,  3294,  2316,
       0,  1528,   608,  2640,  3550,  2902,  2948,  2949,  2977,  2796,
    3072,  3094,  3120,  2258,  2884,  2883,  2886,  2885,  2887,  2888,
    2889,  2890,  2891,  2892,  2769,  2893,  2894,  2895,  2897,  2896,
    2898,  2899,  2900,  2770,  3446,   563,  2771,  2849,  2901,  2851,
    2850,  2903,  2772,  2773,  2904,  2905,  2906,  2907,  2775,  2774,
    2908,  2910,  2909,  2852,  2853,  2911,  2912,  2913,     0,  2915,
    2776,  2777,  2778,  2779,  2780,  2914,  2781,  2916,  3451,  2917,
    2918,  2782,  2919,  2920,  2921,  2922,  2924,  2923,  2925,  2926,
    2928,  2929,  2930,  2927,  2931,  2932,  2934,  2933,  2855,  2935,
    2854,  2936,  2783,  2937,  2938,  2939,  2940,  2941,  2942,  2943,
    2944,  2219,  2945,  2946,  2947,  2969,  2950,  2952,  2951,  2856,
    2953,  2954,  2955,  2957,  2956,  2958,  2960,  2784,  2785,  2786,
    2959,  2961,  2962,  2963,  2964,  2965,  2967,  2966,  2971,  2972,
    2857,  1481,  2788,  2789,  2968,  2970,  2767,  2973,  2974,  2858,
    2859,  2975,  2790,  2846,  2976,  3296,  2979,  2978,    85,  2980,
    2792,  2981,  2982,  2983,  2984,  2985,  2987,  2989,  2986,  2990,
    2991,  2997,  2793,  2988,  2992,  2993,  2994,  2995,  2996,  2998,
    2860,  2999,  3001,  3000,  3002,  3003,  3004,  3005,  2861,  3006,
    2847,  3007,  3008,  3009,  3022,  3023,  3013,  3014,  3016,  3017,
    3020,  3015,  3021,  3026,  3025,  3027,  3028,  3029,  3030,  3031,
    3024,  3011,  3018,  3019,  3012,  3032,  3033,  3010,  3034,  3036,
    3035,  3037,  2862,  3038,  3039,  3040,  3041,  3042,  3043,  3044,
    3045,  3047,  3046,  3048,  2863,  2864,  2865,  3049,  3050,  3051,
    2840,  3052,  2866,  2867,  3055,  3056,  3053,  3054,  3057,  3058,
    3063,  3064,  3065,  3060,  3059,  3061,  3062,  2868,  2869,  2870,
    3066,  3067,  3068,  3069,  3071,  3070,  2795,  2794,  2797,  3073,
    3074,  2798,  3075,  3077,  3076,  2842,  2799,  3078,  3079,  3081,
    3080,  2871,  2872,  2800,  2801,  2802,  3082,  3083,  3084,  3085,
    3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  2873,  2874,
    3095,  3096,  3097,  3099,  3098,  3100,  3101,  3102,  3103,  3104,
    3105,  3106,  2803,  3107,  1481,  3108,  3109,  2804,  3111,  3110,
    2805,  3112,  3113,  3114,  3115,  3116,  2841,  3451,  3117,  3118,
    3119,  2875,  3121,  3122,  3123,     0,  3124,  3125,  3126,  2806,
    3127,  3128,  2876,  2848,  2807,  3129,  3131,  2554,  2808,  3130,
    2810,  2811,  3132,  3133,  3134,  2809,  3135,  2812,  3136,  3137,
    3139,  3138,  3140,  3141,  3142,  3143,  2813,  3144,  3145,  2814,
    3146,  2815,  3147,  3148,  3149,  3150,  3152,  3151,  3153,  3154,
    3155,  3156,  3157,  3158,  3160,  3162,  3161,  3159,  3163,  3164,
    2877,  3165,  2816,  2878,  3170,  3171,  2879,  3166,  3167,  3168,
    3169,  2354,  3172,  3173,  3174,  2819,  3175,  3176,  3178,  3177,
    2817,  2818,  3179,  3180,  2823,  3181,  3182,  3187,  2880,  2881,
    3183,  3184,  3196,  3185,  3186,  3189,  3188,  3190,  3191,  2768,
    2820,  3192,  3193,  2821,  3194,  2822,  3195,  2882,     0,     0,
       3,     8,    22,     0,    44,    27,    32,    17,    21,    16,
      46,    60,    52,    29,  3448,   478,   479,   480,   481,    42,
    3482,    41,    11,    63,    64,    19,    49,    12,    15,    18,
      40,    48,    36,    43,    56,    57,  1551,  1527,  1555,  1526,
    1522,  1518,  1537,  1538,  1539,  1545,    25,    26,    33,    50,
      68,    23,    65,    61,    24,  2477,    13,    28,    14,    51,
      45,    37,    62,    69,    38,     0,  2683,  2696,     0,  2697,
    2765,  2763,  2766,  2762,  2764,    58,    59,    39,    67,    31,
      53,    30,     9,    10,    20,    54,    55,    47,    70,    34,
      66,    35,  1290,     0,     0,     0,     0,     0,  2251,     0,
       0,  2251,  1374,  1595,  3480,  3481,  3482,  1482,     0,  1483,
       0,     0,  2844,  2770,  2843,  2771,  2773,  2827,  2774,  2830,
    2831,  2824,  2783,  2832,  2845,  2786,  2787,  2828,  2729,  2790,
    2833,  2791,  2793,  2825,  2826,  2834,  2829,  2802,  2835,  2804,
    2836,  2837,  2838,  2813,  2814,  2839,  2818,  2730,  2822,  2694,
     289,  2695,  2726,  2724,  2728,  2722,  2723,  2727,  2721,  2725,
     539,   130,     0,     0,     0,     0,   341,  2349,  2251,  2223,
    2251,  2251,  2251,  2251,  2251,     0,  2251,  2251,     0,  2254,
    2251,  2251,     0,     0,     0,   530,  2261,  2544,     0,  2564,
    2565,  2559,  3284,  3285,  3279,   491,     0,     0,     0,  2444,
    2443,     0,     0,   387,   399,   402,   395,   398,     0,   259,
    1484,   491,   401,   402,     0,  1560,  3199,     0,  2449,   402,
       0,  2326,  2558,     0,     0,  2641,  2638,  2326,  2515,  2517,
       0,  2513,  3451,  1668,  1667,   565,     0,  2684,     0,  1460,
    1492,  1418,     0,  3452,  3453,     0,    77,    80,  2482,   424,
       0,     0,     0,   820,     0,     0,  1426,     0,  3453,  3463,
    2556,     0,   130,  1399,     0,   130,  2360,  2251,  2251,  3533,
    3534,     0,     0,     0,  3528,     0,  3535,     0,  1555,     0,
    1541,     1,     5,     0,     0,   820,  1202,  1203,  1201,   820,
     820,     0,     0,     0,     0,     0,  3487,  3480,  3481,  3482,
       0,  2205,  2072,  1556,  1555,  2152,  2156,  3467,  3466,  3468,
       0,     0,  2152,  1546,  2964,  2789,  3077,     0,  2462,  2476,
    2460,  2672,  1524,  1520,  3202,     0,  1248,  1291,  1251,   263,
       0,     0,  1253,     0,     0,  1268,  2705,  2704,  2703,  1265,
    1264,  1263,  1261,     0,   681,   259,     0,  1376,     0,     0,
       0,  3488,  3487,     0,  1437,  2464,  2465,  2466,  2467,  2468,
    2469,  2472,     0,   295,   550,   553,     0,   542,   545,     0,
     131,   132,  1463,  1466,     0,   823,     0,   171,     0,   378,
     380,     0,   377,   379,  2752,   568,   342,   343,   345,     0,
     365,     0,     0,     0,   454,   360,   452,     0,   453,  2749,
    2746,  2751,  2747,  2750,  2748,  2353,  2352,     0,  2351,  2329,
       0,  2349,     0,  2249,  2251,     0,     0,     0,     0,     0,
       0,   259,     0,  2445,   259,  2233,  2251,  2251,   611,   585,
    3349,  3364,  3365,  1609,  3361,  3366,     0,  3363,  3355,     0,
    3359,  3353,     0,  3385,  3357,  3362,  2956,  2786,  2971,  3086,
    3090,  3106,  3109,  2838,  3153,  3343,  3328,  3344,     0,     0,
    3347,  3351,     0,     0,  2262,  2263,  2264,  1372,  2545,  2546,
    2550,     0,  2568,     0,   504,     0,     0,     0,     0,   477,
     493,   494,     0,     0,   500,     0,   491,     0,   463,   475,
     465,     0,   495,   474,   467,   466,   468,   469,   470,   471,
       0,   472,   473,   476,     0,   459,   460,   607,   461,   462,
     491,  2700,  1479,     0,  2628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1609,  1609,  1609,  1606,     0,     0,
       0,  2633,     0,     0,     0,     0,  2624,     0,  2634,     0,
       0,     0,  2626,  2627,  2680,  2681,     0,     0,     0,     0,
    2631,     0,     0,     0,     0,     0,  2607,  1670,     0,  1606,
       0,  2623,  2630,     0,  2615,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1606,  2606,  2625,
    2632,     0,  1609,  1606,  1606,     0,     0,     0,     0,     0,
    2885,  2769,  2900,  2827,  2911,  2913,     0,  2776,  2777,  2778,
    2779,  2780,  2824,  2935,  2854,  2936,  2789,  2858,  2975,  2982,
    3000,  3002,  2861,  3041,  3043,  3048,  2863,  2864,  2865,  3053,
    3054,  3068,  2842,  2871,  2872,  3084,  3091,  3116,  2875,  3121,
    3126,  3129,  3149,  2878,  3170,  3171,  2879,  3169,  2839,  3181,
    3187,  3190,  3191,  2820,  2882,     0,     0,     0,     0,  1669,
       0,     0,  1908,  1553,  1744,   964,  1615,  1627,  1643,     0,
    1742,  1741,  1745,  1747,  1753,  1662,  1774,  1713,  1714,  1716,
    1835,  1715,  1720,  1721,     0,  1884,  1722,     0,     0,  1719,
    2620,  1718,  1717,  2621,  2622,  1712,  2658,  2694,     0,  2682,
     719,   718,     0,   414,   409,   417,   411,   413,   412,   418,
     419,   420,   415,   410,   416,   403,     0,   388,     0,   396,
    3464,     0,     0,   491,   614,   421,  3349,  2886,  3090,  3317,
       0,  3327,     0,  3479,  3473,  3476,  3475,  3471,  3474,  3472,
    3477,  1581,  3478,  1580,  1531,  1561,  1578,  1579,     0,     0,
       0,  1120,  2760,  3228,  3229,  2840,  2842,  2841,  3230,  3166,
    2761,     0,     0,  2689,     0,     0,  2690,  2757,  2755,  2759,
    2754,  2758,  2753,  2756,  3198,  3214,  3210,     0,     0,     0,
    2457,  1198,  1197,     0,     0,     0,  2399,     0,  1120,  2457,
    2400,     0,  2129,  2447,  2450,     0,  3232,  2413,  1199,  3233,
    2443,     0,  2385,  2401,  2362,  2406,   130,  3234,     0,  2446,
    2129,  2457,     0,  2378,     0,     0,     0,     0,  1594,     0,
     397,  3295,  2327,  1372,  2296,  1529,  2282,   609,     0,     0,
    2266,  2269,  2265,     0,  2514,  3447,   570,   564,     0,     0,
       0,     0,     0,  3456,  1955,  2220,     0,    81,    76,     0,
       0,     0,     0,  2677,  3297,    86,     0,     0,  3547,    74,
       0,  2532,     0,  2530,  2527,  2529,     0,  3456,     0,  2555,
    1406,  1406,     0,     0,  1398,  1400,  1401,  1406,  1406,  2361,
       0,     0,     0,  2614,  2612,  2613,  2685,  3530,  2611,  2610,
    3539,  3541,  3524,     0,  3527,  3526,  3536,  1544,  1543,     6,
      71,     0,   259,   259,   820,   173,   820,   141,   144,   820,
     820,   820,   820,   153,   157,     0,   261,     0,     0,  3487,
    1559,     0,     0,  1571,  1557,  1968,  1558,  1970,  1967,  1966,
    1965,  1996,  1997,  1999,  1998,  2000,  2002,  1993,     0,     0,
    2218,     0,  2213,  2073,  2078,  2072,     0,     0,     0,     0,
    2151,  2129,  2160,  2153,  1523,  2149,     0,  1519,  1584,  1584,
    3470,  3469,  3465,  2154,  1542,  1550,  1548,  1549,  2155,  1540,
       0,  2474,  2674,     0,  2479,     0,  2152,  2156,     0,     0,
    1136,     0,   266,     0,  3485,  3486,  3484,  1609,  2706,  2709,
    3483,  2710,   266,  1262,     0,   682,  2252,     0,     0,     0,
       0,     0,     0,   684,   683,   620,     0,     0,  1380,  1381,
    1375,  1377,  1379,     0,     0,     0,     0,  2478,     0,   291,
     297,   290,     0,   339,     0,   540,   546,    87,     0,  1467,
    2242,  2244,   170,     0,     0,   368,     0,   350,     0,     0,
    1061,  1083,  1081,  1102,  1047,  1067,  1063,  1067,  1057,  1102,
     996,   996,  1102,  1060,   996,  1067,  1062,     0,  1059,  1102,
    1058,   996,     0,  1051,  1083,   990,   991,   996,  1081,  1017,
       0,  1067,  1040,  1039,  1102,  1043,  1044,  1042,  1046,     0,
    1048,  1067,  1053,  1041,  1045,     0,     0,  1081,  1081,  1081,
       0,  2752,  1081,     0,   352,   456,   973,   976,   978,   977,
     979,   980,  1067,  1083,  1083,     0,     0,  1081,  1089,   452,
    2749,  2747,  2750,  2748,   346,   348,     0,     0,     0,   367,
       0,  2330,     0,  1569,  2072,  2332,  2337,  2343,  2347,  2350,
    2225,     0,     0,     0,  2226,  2230,  2236,  2235,  2229,  2445,
       0,  2239,   695,     0,     0,     0,  2240,  2221,     0,     0,
    3350,  3348,  3382,  3381,  3386,     0,  3383,  3379,     0,  3342,
    3387,  3372,  3419,  3376,  3419,  3419,  3373,  3380,  3419,     0,
    3378,  3377,     0,  3345,     0,     0,     0,  1373,  2269,  2551,
       0,  2543,     0,  1502,  2570,  2569,  2566,  2064,  3281,  3286,
     498,  2736,  2735,  2698,   505,  2699,  2732,  2734,  2731,  2733,
       0,     0,  3053,     0,   510,   509,   508,     0,   527,   498,
     501,   519,     0,     0,   337,   484,   492,   485,     0,   525,
     528,   560,   558,   600,   596,   604,   598,   464,  2701,     0,
       0,     0,     0,  1748,  2070,  2070,  2070,     0,     0,  1963,
       0,     0,     0,     0,  2070,     0,  1784,  1759,  1760,     0,
    1785,     0,     0,     0,     0,     0,     0,     0,     0,  1914,
       0,     0,     0,     0,     0,     0,     0,  2680,  2681,     0,
       0,     0,  1957,  1959,  2658,  2682,  2070,     0,  2070,     0,
    1614,  1792,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2070,  2070,  2070,  1797,  2608,  2629,  1801,
    1803,  1802,  2070,  2070,     0,     0,     0,     0,     0,  2070,
       0,     0,     0,  2617,  2616,     0,     0,     0,     0,     0,
       0,     0,  2635,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,  2636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1750,     0,  1749,
    1751,     0,  1553,   965,     0,     0,     0,     0,  1666,  1665,
    1664,  1663,     0,     0,     0,     0,  1672,     0,  1674,  1676,
    1671,  1673,  1675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1752,     0,     0,     0,     0,     0,  2609,
       0,  1845,     0,   731,  2540,     0,     0,     0,   386,  1486,
    2711,     0,  1485,  1489,  3281,   593,  3348,     0,     0,     0,
    3345,  1595,  1577,     0,     0,  3200,  3208,  1119,     0,     0,
    1122,  1124,  2287,  2286,  1123,  1132,     0,  1121,     0,  3269,
       0,     0,  3254,     0,  3235,     0,  1128,  1130,  1129,  3249,
    1127,     0,     0,     0,  3219,     0,     0,   820,     0,     0,
       0,     0,     0,     0,     0,  2428,     0,  1594,  1594,  2379,
       0,  2457,     0,  2457,  2447,  2453,  2412,     0,     0,   876,
    2134,  2130,  2405,  2451,  2452,  2457,     0,     0,  2457,     0,
    2419,  2447,  2457,  2374,     0,     0,  2366,  2371,  2367,     0,
    2373,  2372,  2375,  2363,  2364,     0,  2392,  2421,     0,  2404,
    2411,     0,  2391,  2398,     0,  2409,  2447,  2447,     0,  2457,
    2457,  2457,     0,  1595,     0,   591,  2639,  2642,  2646,  2650,
    2269,  2259,  2268,     0,  2516,   335,     0,     0,     0,  1494,
    1496,  1495,  1512,  1420,     0,  3455,     0,  3457,     0,  3459,
       0,    78,     0,     0,  2509,  2507,     0,     0,     0,  2501,
    2503,  2506,  2502,     0,     0,  2508,   130,     0,  2504,  2483,
    2486,  2493,  1594,  2484,     0,     0,   422,   425,   427,     0,
     430,  2064,  3300,  3299,     0,     0,     0,  1424,  1427,     0,
    2537,  2534,   130,     0,  2837,  3462,  3460,     0,  1394,  1410,
    1392,  1404,  1405,     0,     0,  1397,  1396,  3281,  3548,  3549,
       0,     0,  3525,  3542,  3523,     0,  3537,  3538,  3522,     7,
       4,   147,     0,     0,     0,   138,   820,   820,   133,     0,
     820,     0,   155,  1595,  1595,   820,   820,   820,     0,     0,
    1966,  1996,  1997,  1999,     0,  1998,     0,     0,  2064,     0,
       0,  1988,  2012,     0,  2012,  1990,  1991,     0,     0,     0,
    1571,  1994,  2686,  2214,  2217,     0,  2206,  2208,  2209,  2703,
    2211,     0,     0,  2075,  2078,  1586,  2142,  2143,     0,  2141,
       0,  2131,  2135,  2140,  2138,     0,  2122,  2159,  2150,  2198,
    1585,  2157,  2158,  1547,  2463,  2461,  2480,  2481,  2673,  1525,
    1521,  3277,  3278,  3275,  3276,  3274,  3203,  3204,  1137,  1136,
     814,   817,   816,     0,     0,  1252,   262,  2708,     0,  1254,
       0,  2445,  1269,     0,     0,  2445,   631,  2445,   685,  2709,
    3412,     0,  3424,  3401,  3281,  1378,  3489,  3490,  1259,  1257,
       0,  1438,  1439,  1442,     0,   295,     0,   298,   300,   551,
     554,   491,     0,     0,     0,  1477,     0,  1475,  1474,  1472,
    1473,  1471,     0,  1462,  1468,  1469,  2445,   623,   372,   570,
     351,   344,   347,   349,     0,  1084,  1002,  1082,  1102,  1100,
    1102,  1024,  1103,     0,  1071,  1069,  1068,  1064,  1071,  1027,
    1146,     0,  1139,  1144,  1140,  1033,  1142,     0,  1150,  1149,
     997,  1047,  1102,  1035,     0,   996,  1026,  1032,  1071,     0,
    1021,  1030,  1102,   989,  1034,  1020,     0,  1071,  1036,  1049,
    1052,  1054,  1056,  1071,  1102,     0,   456,   996,  1019,  1018,
     996,  1071,     0,     0,     0,     0,   361,  1065,  1050,  1142,
    1150,   996,  1102,  1071,     0,  1090,  1071,   370,   455,  2161,
    1993,     0,  2333,  2339,  2246,  2248,  2672,     0,  1570,  2335,
    2120,     0,     0,     0,  2345,  2250,     0,  2227,     0,   695,
    2232,  3340,   698,   697,  2237,   696,  2288,  3399,  2231,  1382,
       0,     0,   491,   583,   586,  3375,  1610,     0,  3356,  3360,
    3354,  3358,     0,  3338,     0,     0,  3346,     0,     0,  3384,
    3367,  3371,  3370,  3368,     0,  3369,  3374,  3352,   483,   531,
    2256,  2983,  3181,  2552,  2548,  2547,     0,  2567,     0,  2065,
    2066,     0,     0,  2068,  3283,  2161,     0,  3280,   506,     0,
     498,     0,     0,     0,   522,  2702,   502,   498,   512,   521,
     590,   338,     0,   295,   496,     0,   341,   570,     0,   491,
     491,     0,  3281,     0,  2071,     0,  1929,     0,     0,     0,
       0,     0,     0,  1728,     0,     0,     0,  1867,     0,  1929,
    1891,  2191,  2192,  2172,  2173,  2171,  2174,  1607,     0,  2175,
    2190,  1813,     0,     0,     0,  1889,  1552,  1535,     0,     0,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2053,  2058,  2054,  2055,  2056,  2057,  2052,  2059,
       0,  2039,     0,  1915,  1880,     0,     0,     0,     0,   965,
       0,     0,     0,     0,     0,     0,     0,  2070,     0,     0,
    2070,     0,     0,     0,     0,  1890,     0,     0,     0,  1888,
       0,     0,  1887,  1772,     0,     0,  2070,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1704,     0,     0,     0,
    2070,     0,     0,     0,     0,     0,     0,     0,     0,  1697,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2062,
    2060,  2063,  2061,     0,     0,  1955,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1776,     0,     0,     0,  2663,
       0,  1168,     0,     0,     0,     0,  1743,     0,     0,     0,
       0,  3235,  1909,  1911,  1612,  1611,  1613,  1624,  1618,  1622,
    1616,  1620,     0,  1677,  2892,  1625,     0,     0,     0,  1628,
    1637,  1641,     0,     0,     0,     0,     0,  1659,  1660,  1648,
    1646,  1647,  1644,  1645,     0,  1650,     0,  1649,  1656,  1657,
    1658,  1661,  1746,  1131,  1754,  2090,  1882,  1883,  1907,  2094,
       0,  2659,  1595,  1700,  1699,  1701,  1702,  1703,   732,     0,
     726,   729,   743,     0,     0,  2539,     0,  2854,  2878,  2879,
     404,   407,   406,   408,     0,     0,     0,     0,     0,     0,
       0,     0,  3403,  3325,     0,     0,     0,     0,  1591,  1532,
    1590,     0,     0,     0,     0,     0,     0,  3252,     0,     0,
    3251,  3250,     0,  3271,     0,     0,  3256,  3255,     0,     0,
    3213,  3257,  3258,  3261,     0,     0,     0,     0,     0,  3242,
       0,  3166,  3215,  3216,  3221,  3211,  2420,     0,     0,     0,
    2425,  2423,  2416,  2427,  2437,  2424,  2418,  2429,  2417,     0,
       0,     0,  2457,  2432,  2434,  2430,  2457,     0,  2455,  2442,
    2441,  2440,  2389,  2388,  2382,  2448,  2435,  2431,   259,  2457,
    2387,  2386,  2368,  2369,  2370,     0,  2129,     0,  2453,  2422,
    2447,     0,  2457,  2457,  2438,  2439,  2408,  2410,  2315,     0,
    1993,     0,     0,  2301,  2294,  2281,   491,     0,     0,  2644,
    2267,     0,  2270,  1993,   491,   566,     0,     0,     0,   716,
    1512,  1498,  1514,  1422,  1421,  1419,  3206,  3454,  3458,  1956,
      80,  2309,  2307,    82,  2306,  2308,    83,  2518,  2495,  2494,
    2496,  2500,   130,  2505,  2497,     0,  2510,  2511,   435,     0,
     431,     0,     0,  3298,     0,   821,     0,    75,     0,  1428,
    2161,  2533,  2535,  2528,  3461,     0,  1395,  1412,  1411,  1407,
    1408,  1413,  1403,  1402,  2355,  3531,  3540,  3544,  3529,   812,
    3336,  3424,   228,     0,     0,     0,     0,   136,     0,   283,
       0,   820,   154,   158,   820,     0,     0,     0,   820,     0,
    2009,  2001,  2003,  2004,  2005,     0,  2008,     0,  1574,     0,
    1562,  1562,  1572,  2011,  1992,  1989,  2013,     0,  2012,  2012,
       0,     0,  1972,  1971,     0,  2064,  1125,  2210,     0,     0,
    2074,     0,  2076,  2085,  2075,  1588,  2161,  1582,     0,  2616,
       0,     0,     0,     0,     0,     0,     0,     0,   815,  2288,
    2288,     0,     0,     0,     0,     0,     0,     0,     0,   267,
     276,  2707,     0,     0,   629,   630,  2288,   628,   671,   672,
     675,   676,   677,     0,     0,   678,  2288,  2288,   625,   651,
     652,   655,   656,   657,   658,   659,   621,     0,   626,     0,
       0,     0,  3436,  1246,  1282,  3491,  1255,     0,     0,  1441,
     293,   292,   296,     0,     0,   491,   538,   547,   541,   543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    88,    89,   110,     0,  1464,  1476,
    2243,  1470,  2288,  2288,  2288,  2288,   627,   660,   661,   664,
     665,   666,   667,   670,   668,   669,     0,  2445,     0,     0,
       0,     0,     0,     0,     0,  1022,  1104,     0,  1023,     0,
    1073,  1074,  1072,   992,   988,  1147,  1135,  1134,  1141,   999,
    1143,  1138,  1151,  1148,  1145,  1100,   998,  1028,  1029,   994,
       0,  1243,  1006,     0,   995,  1055,   993,  1007,     0,   357,
       0,   355,   364,  1031,  1004,  1016,   456,   456,   353,   457,
     458,     0,  1025,  1000,  1001,  1003,  1150,   986,     0,   987,
    2161,  2166,  2162,   366,   385,     0,   384,  2334,  1562,     0,
       0,     0,  2675,     0,  2145,  2121,  2344,     0,  2348,  2347,
       0,  2228,  2238,     0,  2289,     0,     0,  1384,  1383,  2234,
    2241,  3281,   491,   584,   512,  3423,     0,  3422,     0,     0,
    3335,     0,  3395,  3398,  2672,     0,     0,     0,     0,   339,
       0,  2549,  2553,  1503,  1505,  1506,  1504,  1512,     0,  2720,
    2687,  2069,  2688,  2717,  2715,  2719,  2713,  2714,  2718,  2712,
    2716,     0,  3289,  3290,  3288,  3282,  3287,   499,   507,   523,
     526,     0,   503,   513,   517,     0,   487,   486,   529,   561,
       0,   601,   555,   555,   555,  1480,     0,  1862,     0,  1863,
    1864,     0,  1729,  1964,     0,     0,     0,  1757,     0,     0,
       0,  1866,     0,  1608,     0,     0,  1732,  1724,  1536,     0,
    1893,     0,  1898,     0,  1896,     0,     0,     0,     0,     0,
       0,  1958,     0,  1960,  2659,     0,  1872,  1903,     0,  1870,
       0,  1892,     0,  1904,  1905,     0,     0,     0,  1876,  1874,
       0,  1878,  1875,  1877,     0,     0,     0,  1796,     0,     0,
       0,     0,     0,     0,     0,  1775,     0,  1809,     0,  1860,
    1810,  1811,  1812,  2662,     0,  1806,     0,  1807,     0,     0,
       0,     0,     0,  1761,  1762,     0,  1837,     0,  1763,  1817,
       0,  1737,  1838,  1819,  1768,  1769,  1839,  1840,  1841,  1734,
    1735,  1821,  1822,     0,  1843,  1736,  1823,  1826,     0,  1771,
    2161,     0,  1755,     0,     0,     0,  1773,  1800,     0,     0,
       0,  1733,     0,  1829,     0,     0,     0,  2161,     0,     0,
    1777,     0,     0,   966,  1554,  1725,  2660,     0,     0,  1619,
    1623,  1617,  1621,     0,     0,     0,     0,  1636,     0,     0,
    1629,  1639,  1642,     0,     0,  2092,     0,     0,  1901,  1953,
       0,     0,     0,  1856,  1857,     0,     0,   725,   724,     0,
     728,   804,     0,   745,   733,   722,  2541,     0,     0,  1487,
    1490,     0,     0,     0,  3326,     0,     0,     0,     0,     0,
       0,     0,  1595,  1596,  1596,  2658,     0,     0,  3239,  3209,
       0,     0,     0,  1133,  3270,     0,     0,  3263,  3264,     0,
       0,     0,  3236,  3237,  3238,     0,  2744,  2745,  2691,  2693,
       0,  2692,  2742,  2740,  2743,  2738,  2739,  2737,  2741,  3245,
       0,  3218,  3219,  3220,     0,     0,  2415,  2426,  2458,  2459,
    2436,  2433,  2383,  2454,  2161,  2393,  2414,  2384,     0,  2407,
    2365,  2455,  2072,  2447,  2380,  2381,     0,  1571,  1596,  2297,
    1595,  2298,   491,  2643,     0,  2648,     0,  2276,     0,  2273,
    2280,   709,  2260,     0,  2271,  2245,     0,   577,  1461,  1501,
    1493,  1500,  1497,  1512,  1510,  1499,  1194,  1193,     0,  1513,
       0,    79,     0,     0,  2498,  2499,  2492,  2512,  2487,     0,
     426,   436,   428,   432,   433,   434,   429,  2972,  3053,     0,
    2072,  3302,  3546,  1435,  1433,  1432,  1434,  1423,  1429,  1430,
    2538,  2536,  2531,  2557,  1410,     0,  1393,  2357,  2161,     0,
    3543,   148,   813,     0,   169,  3436,     0,  1218,     0,     0,
     134,   208,   283,     0,   281,  3515,   156,  3505,     0,   149,
       0,   263,     0,     0,  2006,  2007,  1969,  1562,  1564,  1563,
       0,     0,  1566,     0,     0,     0,     0,  1977,     0,  1973,
    1975,     0,  2037,  2029,     0,  2215,  2207,  2212,  2657,  2082,
    2126,     0,     0,  1533,  2085,  1587,  2144,  2133,     0,  2137,
    2136,  2139,  1586,  2123,  2126,  1595,  3205,     0,     0,  1250,
       0,     0,     0,   270,   273,   271,   272,   680,   679,     0,
    2445,   673,  2288,  2288,   222,  2288,  2288,   221,   223,     0,
     217,   214,   224,  2288,  1270,   210,     0,     0,     0,     0,
    2161,     0,     0,     0,   230,     0,     0,  2445,   653,   632,
     633,   636,   637,   638,     0,  3406,  3405,     0,  3426,     0,
       0,  3428,     0,  3427,  3425,  3391,  3402,     0,  1277,  1136,
       0,  1284,  1286,     0,     0,  3491,  1440,     0,   295,   299,
     339,     0,   544,     0,     0,  2161,     0,  2161,  2161,     0,
       0,  2161,     0,  2161,     0,     0,     0,     0,     0,     0,
       0,  2161,     0,     0,     0,     0,  2161,     0,  1478,     0,
       0,     0,     0,  2445,   662,     0,  2288,   622,   639,   640,
     643,   644,   645,   646,   647,   650,   648,   649,     0,     0,
     305,   306,   374,   569,  1079,  1077,  1080,  1078,  1101,     0,
    1075,  1076,  1105,  1142,     0,  1142,   356,   359,     0,   363,
     362,     0,     0,  1005,   394,   393,   391,   491,   381,   389,
     383,     0,   390,  2169,  2170,  2167,  2165,  2168,  2331,  2247,
    2347,     0,  2673,  1594,     0,  2341,  2072,     0,  2346,  3281,
    3341,   694,   875,  3400,  1382,     0,   374,   515,   588,  3420,
       0,  3440,     0,     0,     0,     0,     0,     0,     0,     0,
     532,  2310,     0,  1512,  1516,  2560,  3292,  3293,  3291,   524,
       0,   520,   512,     0,   295,     0,   555,     0,   595,   597,
     556,   605,   599,     0,  1930,  1961,     0,  1081,  1081,  1067,
    1089,  1947,     0,  1941,  1944,     0,  1081,  1949,  1081,  1942,
    1081,     0,     0,  1939,  1940,     0,     0,     0,  1868,  1865,
       0,     0,     0,  1918,     0,     0,     0,     0,     0,  1653,
       0,  1851,     0,  1873,  1871,     0,     0,     0,     0,     0,
    1879,     0,  1781,  1779,  1710,     0,  1708,     0,  1709,     0,
    1711,     0,     0,  1861,     0,  1679,  1698,     0,     0,     0,
       0,     0,     0,  1956,     0,     0,  2177,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2664,     0,
       0,     0,  1157,  1163,  1166,  1167,  1169,  1161,     0,  1831,
       0,     0,     0,  1912,  1910,     0,  1634,  1630,     0,  1638,
       0,     0,     0,  1652,  1651,  2094,  2093,     0,  1900,     0,
       0,  1954,  2661,  1596,  1846,  1595,   735,     0,   753,   727,
    2161,   730,     0,   744,     0,   756,     0,     0,     0,   405,
       0,  1491,     0,     0,  3324,  3404,     0,     0,     0,     0,
       0,  1589,  1598,  1592,     0,     0,     0,  3201,  3253,  3244,
       0,     0,     0,     0,  3268,  3262,  3259,  3260,     0,     0,
       0,  3243,  3217,  3223,  3222,  3225,  3227,  2403,  2402,     0,
    2456,  2129,  2376,  2395,  2397,  2457,  2317,  2320,     0,  2064,
    2305,     0,     0,  2299,  2303,     0,  2647,     0,     0,     0,
    2277,  2279,  2652,  2651,  2663,     0,     0,  2272,   336,     0,
     576,     0,  2031,  3207,    84,     0,  2490,     0,  2485,  2488,
       0,     0,  3313,  3314,  3306,  3309,  3307,  3308,  3312,  3315,
    3316,  3303,  3310,  2129,     0,  1425,  1431,  1409,     0,  1416,
    1414,     0,     0,  2356,  3532,  3545,     0,  1277,     0,     0,
       0,     0,     0,     0,   824,   824,   209,     0,  3521,  3520,
    1595,     0,   279,   282,   284,   278,   330,     0,   239,  3491,
     163,   165,     0,   159,   161,   151,  1573,  1565,  1567,  1562,
    1562,     0,  1965,     0,     0,     0,  1965,     0,     0,   716,
       0,  2010,  2026,  1126,  2574,  2083,  2084,     0,  2079,  2127,
    2128,  2081,  2077,     0,  2086,  2088,  1534,  2132,  1583,     0,
    2125,     0,     0,  2201,  2203,   874,   873,   275,   274,   287,
     288,  2187,  2188,  2185,  2186,   686,   699,  2189,   700,   674,
    2161,  2161,  2293,  2292,  2161,  2161,   216,   213,  2291,  2290,
    2161,  2161,   211,   234,   233,   235,   236,   238,   237,   232,
    1266,     0,   687,   688,   654,     0,   634,  3409,     0,  3416,
    3411,  3414,  3394,  3393,  3392,  3389,     0,  2161,  2161,  2161,
       0,  2161,  3435,  3437,     0,     0,  1267,  1370,  1370,     0,
    1370,     0,     0,  1370,     0,  2288,     0,     0,  2288,   716,
    1388,  2288,  2288,  2288,  2288,     0,  2288,  2288,  2288,  2288,
       0,  2288,  2288,     0,  2288,     0,     0,     0,  2288,     0,
    1353,     0,  2288,  2288,  2288,  2288,  1370,  2288,  2288,     0,
       0,     0,     0,  2288,  2288,     0,     0,  2288,  2288,     0,
    1298,  1352,   826,   869,   853,   854,  1247,  1297,  1299,  1311,
     712,     0,  1329,  1355,  1356,  1354,     0,  3449,     0,     0,
     244,  3493,     0,  3495,     0,  1444,     0,  1443,   294,   552,
     548,  2161,  2161,   103,  2161,    95,    96,    91,   123,   124,
      93,    94,    99,    98,   100,   101,   104,   105,   102,    97,
      92,   127,   129,   128,   106,   125,   126,    90,   693,   692,
     691,   690,   663,     0,     0,  2445,   641,   373,     0,  1087,
    1085,  1085,     0,  1085,     0,  1118,   981,   983,   982,   984,
     985,  1087,  1087,  1085,  1085,   307,   375,   369,     0,  1038,
    1244,  1037,   358,   354,  1066,  2161,   371,   392,     0,  2072,
    2676,     0,     0,  2146,  1595,  2336,  2338,  2224,  2222,   612,
       0,     0,   512,  3421,     0,  3334,  3339,     0,  3397,  3396,
    3424,  3424,  3424,  3424,   534,     0,  2257,  1507,  1512,  1516,
       0,  1508,  2571,   514,   518,   489,   488,   570,   559,   491,
       0,  1962,  1931,  1932,  1946,  1948,     0,  1945,  1934,  1951,
    1938,  1943,  1950,  1936,  1727,  1758,  1731,  1730,     0,     0,
       0,  1790,     0,  1916,  1899,  1897,     0,     0,  1765,     0,
    1767,     0,     0,  1853,  2661,  1820,  1895,  1793,  1824,  1770,
       0,     0,     0,  1707,  1705,  1706,     0,  1782,  1804,     0,
    1696,  1805,     0,  1836,  1788,     0,  1815,     0,  1791,  1818,
    1842,  1723,  2179,  2178,  2176,  1738,  2161,     0,  1794,  1756,
       0,     0,  1828,  2665,  2666,     0,  1830,     0,     0,  1168,
    1154,  1155,  1156,     0,  1158,  1160,  1162,     0,  2161,  1844,
    1655,  1654,     0,  1626,     0,  1635,  1632,     0,  1640,  2096,
    2095,     0,     0,  1847,  1953,  1598,  1858,     0,   736,   737,
     739,   741,   807,     0,   731,     0,   720,     0,   735,   723,
    1488,   594,     0,     0,  3321,  3320,  3319,  3318,     0,  1593,
    1602,  1601,  2655,  2659,  3241,  3240,  3273,  3272,  3266,  3265,
    3267,     0,     0,  3246,     0,     0,  2183,  2184,  2182,  2180,
    2181,  2394,  2129,  2390,     0,  2072,     0,  2029,  1596,  2295,
       0,   592,  2649,     0,  2275,     0,     0,     0,  2274,  2284,
       0,   581,   578,   579,     0,  2034,     0,  2035,  2032,  2033,
    2161,     0,     0,   444,   439,   447,   441,   443,   442,   448,
     449,   450,   451,   445,   440,   446,   438,   437,     0,  3301,
    1436,     0,     0,  2358,  2359,  3337,   168,     0,  1234,  1236,
    1235,  1219,  1220,     0,   142,   145,   924,     0,     0,   135,
     704,   712,   825,   828,   701,   137,  1595,   174,   277,   280,
     328,   334,   333,   268,     0,     0,     0,  3511,   302,   889,
     890,   888,   887,     0,  3511,   302,  3491,  1576,  1575,  1978,
       0,  1982,  1987,  1983,     0,  1974,     0,  1995,  2038,  2030,
       0,     0,  2582,  2126,     0,     0,  2126,  1596,  2199,  1595,
     215,   220,   219,   212,   225,   218,   231,   635,  3410,  3408,
    3407,     0,  3415,     0,  3390,  3431,  3429,  3430,  3433,     0,
       0,  3432,  3434,  1271,  1272,  1278,  1273,  1241,   820,  1371,
     818,     0,  1333,  1337,  1334,     0,   925,   820,  1195,  1195,
     818,  2249,  1481,  2249,     0,     0,  2249,     0,  2251,  2249,
       0,     0,  2249,  2249,  2288,     0,  1481,     0,  2161,   714,
    1391,  1389,  1390,     0,  2161,  2161,  2161,   851,   872,     0,
    2161,  2161,  2161,  1481,     0,     0,  2288,  2161,  1346,  1293,
    1347,     0,     0,  1294,     0,  2161,  2161,  2161,  2249,  2161,
       0,  1481,  1313,  1481,  1481,     0,  2161,   859,   860,   858,
    2161,  2161,     0,   827,  1136,  1295,   713,  1296,   924,     0,
    1385,   900,   927,  2668,     0,  3450,     0,     0,     0,  1283,
       0,   247,   245,   255,  3492,     0,  1258,     0,  3495,  1446,
    1447,     0,     0,     0,   116,   118,     0,   120,   122,     0,
     112,   114,   624,   689,   642,   304,  1088,  1010,  1086,  1014,
    1015,   312,  1142,     0,     0,  1142,  1150,  1142,  1150,     0,
    1070,   382,  2347,  2340,     0,  2147,     0,  2342,   589,   516,
     587,     0,  3424,  3438,  3438,  3438,  3438,   339,   530,   533,
    2311,  1509,  1517,  2573,  2572,     0,   295,     0,   491,  1142,
    1952,  1142,  1142,  1869,     0,     0,     0,     0,  1922,     0,
       0,     0,     0,     0,  1726,     0,  1849,     0,  1780,  1778,
       0,  1067,  1686,  1688,  1684,  1687,     0,  1081,  1690,     0,
    1048,  1081,  1693,  1695,  1680,  1681,  1682,  1683,     0,     0,
       0,  2197,  2196,  2195,     0,     0,     0,     0,  2667,  1152,
    1833,     0,  1165,  1159,  1157,  1164,     0,  1913,  1631,     0,
       0,  2098,     0,  1902,     0,  1859,   740,     0,     0,     0,
     760,     0,   758,   734,     0,  3323,  3322,  1600,  1599,     0,
       0,     0,  3224,  3226,  2396,  2319,  2120,  2321,  2322,  2314,
    2304,  2302,     0,  2278,  2653,  2664,   710,     0,     0,  2161,
     580,  1314,     0,  1315,  1326,  1328,  1515,     0,  2523,     0,
    2521,  2491,  2524,     0,  1415,  1417,     0,   139,     0,     0,
    1241,  2799,     0,   893,   895,   896,   897,   898,     0,   705,
    2571,   711,  1136,   829,   824,   176,   202,   313,  3516,   615,
     616,     0,     0,  3495,   268,     0,     0,     0,     0,   268,
       0,     0,     0,     0,     0,     0,     0,  2019,     0,  2018,
       0,  2024,  2028,     0,     0,     0,     0,  2575,  2577,     0,
    2216,  2080,  2089,  2087,  2124,  2204,  2202,     0,  3417,  3413,
    2164,  2163,     0,  1275,     0,  1274,  1279,     0,   926,  1242,
    1481,     0,     0,     0,  1357,     0,     0,     0,  1195,   916,
     820,  1241,  1196,   820,   820,  1331,     0,     0,     0,  1305,
       0,     0,  2249,     0,  1359,     0,  1358,     0,     0,     0,
       0,  1368,  1369,     0,  2116,  2118,  2126,  2194,  2193,   848,
       0,  1350,   841,   840,   843,   842,   845,   844,     0,  1366,
    1367,   837,   834,   846,     0,   836,   861,     0,   849,   831,
       0,   885,   886,   884,   855,   862,   832,   833,     0,   839,
     838,   835,     0,  1321,     0,   877,   882,   880,   879,   878,
     883,   881,   850,   868,   847,   863,  1310,  1370,  1370,  1330,
       0,   891,  2671,     0,  1387,  1332,     0,   901,     0,     0,
     867,   866,   864,   865,   254,   243,     0,     0,  1285,  1287,
       0,     0,  1288,  3494,  3497,  1256,  1452,     0,   339,   108,
    2161,   109,  2161,   107,  2161,  1012,   310,     0,  1008,  1009,
    1011,  1013,   376,     0,     0,  2148,  3441,  3438,     0,  3332,
    3331,  3330,  3329,   536,   535,     0,     0,   490,   555,     0,
    1933,  1935,  1937,  1786,  1787,  1919,  2126,  1917,  1924,     0,
       0,  1923,  1814,     0,  1766,     0,  1850,     0,  1825,  1783,
    1689,  1685,  1692,  1049,  1691,  1142,  1808,  1789,  1816,  1739,
    2161,  1795,  1798,  1799,     0,  1832,  2161,  1633,     0,  2101,
    2100,     0,     0,  2126,  1848,   738,   808,   733,     0,     0,
     757,     0,   721,  2656,  3248,  3247,  2145,  2645,     0,  2283,
    2285,     0,  1511,     0,  2036,  2519,  2161,     0,  2489,     0,
       0,     0,     0,     0,     0,   899,   892,   924,     0,   703,
     810,   830,   712,     0,   511,   511,     0,   203,   204,   323,
       0,   314,   316,   285,   269,     0,     0,   619,   617,   618,
       0,     0,   150,  3513,   264,  3512,     0,   303,   167,   264,
       0,  3495,  1979,     0,  1984,     0,  1976,  2014,  2014,  2025,
       0,     0,     0,     0,  2576,     0,     0,  2583,  2585,     0,
    1273,     0,     0,     0,  1316,     0,     0,  1335,     0,   820,
    1191,  1192,  1241,  1216,  2668,  1241,  1241,     0,  1304,     0,
    1467,  1132,  1342,     0,  1300,     0,  1344,  1345,  1382,   857,
    1302,     0,  2119,   715,  2511,  1309,   856,     0,  1385,  1301,
    1323,  1307,  1336,  1386,  1173,   931,     0,   919,   929,   974,
    2670,   241,   246,   256,   257,  1260,     0,  3496,     0,  1453,
    1449,  1450,  1445,   549,   117,   121,   113,     0,     0,     0,
    3333,     0,  3445,  3439,  3443,     0,     0,   562,   602,     0,
    1921,  1881,  1925,  1926,     0,  1852,  1854,  1694,     0,  1153,
       0,  2097,  2091,     0,     0,     0,     0,     0,     0,  2110,
    2102,     0,  1906,  2161,   806,     0,     0,   746,   763,   762,
     759,  2318,  2654,   339,  1327,  2522,     0,  3311,     0,     0,
       0,  2126,  1239,     0,     0,   894,   706,   811,     0,  2571,
     511,   511,   177,   182,   183,   187,   185,   196,     0,     0,
     189,     0,   189,  1597,   205,   326,   324,   325,     0,   329,
       0,   286,   571,  1595,   252,     0,   265,   164,  3511,   160,
    3511,   152,     0,     0,     0,  2022,  2020,  2580,  2581,     0,
    2578,     0,     0,  2584,     0,  1280,  1276,  1281,     0,  1318,
       0,   819,     0,  1241,  1216,  2668,     0,   902,     0,   906,
     908,     0,     0,  1385,  1306,  1351,  1343,  1360,  1341,  1481,
    2117,     0,     0,  1340,  1322,  1324,  1428,     0,  1177,   933,
       0,   928,   920,   941,     0,   248,  1289,   491,     0,     0,
       0,  1448,     0,  1455,   311,   308,     0,     0,  3444,  3442,
    2312,  1993,   555,  2126,     0,     0,  1764,  1740,  1834,     0,
    2107,     0,     0,  2105,  2104,     0,  2099,  2106,   809,     0,
       0,   754,   770,   766,     0,   768,   769,   791,   582,  2525,
       0,     0,  3281,     0,  1238,     0,  3281,     0,   870,   702,
       0,     0,     0,   184,   186,   188,   201,   207,     0,   206,
       0,   264,   327,     0,     0,   317,   315,   264,   341,  3506,
     244,   253,   571,   268,   268,  1981,  1986,     0,  2015,     0,
       0,     0,  2579,  2587,  2586,  3418,     0,     0,     0,  1317,
       0,   921,   914,   910,     0,  1217,     0,   904,     0,     0,
    1349,     0,  1339,  1303,   852,   716,     0,  1308,     0,  1176,
       0,  1181,  1171,   959,  1116,     0,   962,     0,   932,   934,
    1109,  1110,   936,     0,     0,     0,     0,   975,     0,     0,
    1093,     0,  1096,     0,     0,   930,     0,   942,  1092,  1099,
    2669,     0,   250,   226,  3498,     0,     0,  1454,  1459,     0,
    1456,  1458,     0,  1568,     0,  2561,   603,  1920,  1928,  1927,
    2108,     0,  2109,  2112,     0,     0,  2113,     0,   750,   752,
     742,     0,   747,     0,   764,     0,  2288,  2288,     0,  2288,
    2288,  2288,  2288,   784,   792,   794,     0,     0,  3281,  1206,
    2126,     0,  1208,     0,   708,   871,     0,   511,     0,   511,
     570,   180,   178,   192,   190,   175,   322,     0,     0,  3517,
     572,     0,   255,   226,   264,   264,  2017,  2016,  2031,     0,
    1338,  1320,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,     0,   971,   972,  1348,   968,   969,   970,
       0,  1312,     0,  1174,     0,  1178,  1179,  1180,     0,  1172,
     960,   961,  1117,   935,  1115,  1108,  1107,     0,  1098,  1094,
       0,   950,     0,     0,  1100,  1091,   943,   249,     0,   242,
     227,   258,  3499,  3500,  1451,     0,   309,  2313,  2324,     0,
    1125,  2103,  2111,  2115,  2114,   748,     0,   755,   777,   767,
     773,     0,  2288,     0,     0,  2288,     0,     0,     0,     0,
       0,   761,   793,  2288,   229,  1204,     0,     0,  2288,  1361,
    1207,  1232,  1214,     0,  1237,  1240,  1361,  1209,  1231,  1212,
       0,   195,   199,   194,   197,     0,  1597,   330,   330,   320,
       0,     0,     0,     0,  3514,   166,   162,     0,     0,  1319,
     917,     0,     0,     0,     0,     0,     0,     0,  2619,  2618,
       0,     0,  1175,     0,     0,  1114,  1113,  1111,  1112,  1603,
    1097,     0,   945,  1106,   944,   251,  1457,     0,     0,  2562,
     754,   751,   777,     0,   775,     0,   771,   765,   772,     0,
     803,   797,     0,   799,   800,   798,   795,   788,     0,   786,
       0,     0,     0,  1361,  1205,  1230,  1229,  1210,     0,  1224,
    2161,   143,  1363,  1362,  1215,     0,   146,  1213,     0,   571,
     571,   181,   264,   268,   302,   331,     0,     0,     0,   570,
    1595,   257,  2023,  2021,     0,     0,     0,  1204,     0,  1206,
    1208,   967,     0,  1187,  1186,     0,     0,  1183,  1182,     0,
    1095,   937,   937,   951,  2323,  2325,  2588,   749,   774,     0,
     782,   778,   780,   783,   802,   801,     0,   785,     0,   796,
    1221,  1222,   140,  1211,  1233,  1223,  1365,  1364,  1228,  1227,
    1225,  1226,   918,  3518,  3518,   179,   193,     0,  3511,   321,
     318,     0,   573,  3507,   240,     0,  1204,     0,   903,  1204,
     907,   909,  1325,  1190,  1188,  1189,     0,     0,  1604,     0,
     948,   938,   940,   947,   953,   954,   952,   955,     0,  2574,
     776,     0,     0,   791,   790,   787,  3519,   200,   198,   332,
     268,     0,     0,     0,   915,   911,  1204,   905,     0,     0,
    1605,   939,   946,   956,   958,     0,  2582,   781,   779,   789,
     191,   319,   574,     0,   913,  1185,  1184,   957,     0,  2590,
    3508,  2589,     0,  2594,  3503,     0,     0,  2601,  3501,  3502,
       0,  3509,  2592,  2593,  2591,  2596,     0,     0,  2598,  2599,
       0,  2563,  3504,   491,  2600,  2595,     0,  2602,  2604,     0,
     226,  2597,     0,  1595,  3510,  2603,     0,  1596,  2605
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5364, -5364, -5364, -5364,  2241,  4700, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364,  2837, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  1951, -5364,   498, -5364,   500, -5364,   502, -3373,  -615,
    4397, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,   210,
     204,   216, -5364,   220, -5364, -3783, -5364, -5364, -5364, -5364,
     221, -5364, -5364, -3710, -5364,  2120, -3274, -5363, -5364, -5364,
      93,  1504, -5364, -5364,   388, -5364,    66, -5364, -5364, -5364,
   -4548,   -72,  -279, -5364,    22,  4915,  -324, -4566,  4234, -4500,
     868,  1601, -5364, -5364,  2135, -5364, -5364, -3227, -5364, -5364,
   -5364, -5364, -2191, -5364, -5364, -4498, -5364,   691, -4211,  1373,
   -5364, -5364,   219, -5364, -5364, -5364,  -176, -5364,  -174, -5364,
    -648, -3081, -5364, -2380, -5364, -5364, -5364,  4198, -5364, -5364,
   -5364,  1946, -5364, -4183, -5364, -4795,  4846, -5364,  -728, -5364,
   -5364, -5364,  1915, -5364, -5364,   753,  1359,  3376,  2996, -5364,
   -5364, -5364, -5364,  1304, -5364,  2288, -5364, -1922,  3820, -5364,
   -5364, -5364, -5364, -5364,  2867, -2684, -5364, -5364, -5364,  1668,
   -5364,  -854, -5364, -2106,  -931,  4731, -5364,    27, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -1403, -5364,
   -5364, -5364, -5364, -5364, -5364, -3852, -3002,  1898, -5364,  1351,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,   874, -5364,
   -5364, -5364, -5364,    32, -5364, -5364, -5364, -5364, -5364, -5364,
    2717, -5364, -5364,  4879, -5364, -5364, -5364, -3690, -5364, -5364,
   -5364, -5364, -5364, -5364,    37, -5364, -5364, -5364, -5364, -4221,
   -5364, -5364, -5364, -2226, -5364, -5364, -5364,  1155, -5364, -5364,
    3292, -5364, -5364,  3293,  3290, -5364,  3294, -5364, -3129, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,    40, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  4237, -5364, -5364, -5364, -3136, -5364, -5364, -3451,  3518,
   -5364, -2725, -5364, -5364, -2778, -5364, -5364, -2709,  1527, -5364,
   -5364,  1355,  1158, -5364, -1791, -2825, -2814, -5364, -5364, -5364,
   -2913, -2907,  -849,  3374, -1529, -2805, -5364, -5364, -5364,   277,
     283,   461,  1467,  2065, -5364, -3993, -5364, -5364,   655, -5364,
   -5364, -5364, -5364, -5364,  1232,   503,  1229, -5364,   822,  3071,
   -3027, -5364, -5364, -5364, -5364, -5364, -5364,   -88,   317,  -165,
   -5364, -4415,   506, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -3381, -5364, -5364, -5364,  -303, -5364, -5364,  -245, -5364,
   -5364,  -299, -5364,    31, -5364, -5364, -5364, -5364, -5364,  2887,
   -2058,  1057,  -701, -5364, -3901,  1506, -4217, -3510, -5364, -5364,
     172, -1342, -1339,  -171, -5364, -5364, -5364, -5364, -5364, -5364,
     995,   497,  1505, -4036, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -4027, -4026,   722, -5364, -4947, -5364, -5364, -5364, -3641,
   -5364, -5364, -5364, -5364, -5364, -5364,  -213, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -3139, -5364, -5364,    -3,   -31, -5364,
     102,  2692, -5364, -4743, -5364, -3588, -1086, -5364, -5364, -3584,
   -3582, -3576, -5364, -1491, -3585, -1489, -3573, -5364, -5364, -5364,
   -1462, -1492,  1192, -1247, -1487,  1559, -1007,  -916,  1947,   -25,
   -3998, -3028, -1262, -1174, -5364, -5364, -3145, -3146, -5364, -4669,
    -681, -2108, -3460,   -38, -5364, -5364, -1855,   444, -2541, -5364,
    3513,  3508, -2262, -1087, -2248,  1877, -5364, -5364,  1315, -5364,
   -1808,  1314, -5364, -5364, -5364,  1321, -5364,  -233, -5364, -5364,
   -5364, -5364, -3592, -5364, -2731, -4245, -5364, -5364,  5305,  5306,
   -3212,  -175,  -172, -5364, -5364, -5364,   295, -5364, -5364, -2855,
    -133,   -57,   -48, -3967, -3356,   227, -2465,  3515, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
     481,   489,  1745, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  1555, -3018, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -3881, -4392, -5364, -5364,  1049, -3060, -3601, -3599, -3988,  4535,
   -5364, -5364, -5364, -5364,  4348, -3665, -3263, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364,  3738,  1744, -5364, -5364,  2287, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,   290,  2295,
   -5364, -5364, -5364, -5364, -5364,  2841, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364,    10, -5364, -5364, -5364, -5364, -5364,
     490,  3587, -5364, -5364, -5364, -5364,   -21, -5364, -5364, -5364,
   -5364,  3148, -5364, -5364, -5364, -5364,  3025, -5364, -5364, -5364,
   -5364, -5364, -5364,  2034, -5364,  2670, -5364, -2705, -5364, -5364,
    1460,  -573, -5364, -5364,  -384, -5364, -5364, -5364, -5364, -5364,
      17, -5364, -5364, -5364,  5303, -1685,    21,  -466, -5364, -5364,
      14, -5364, -5364,  4413,  -501,  2488,  -758,  5066, -5364, -5364,
   -5364, -5364, -2752,  2375, -5364,  4461, -5364, -5364,  4641,  1590,
    4428,  2246,  1497,  2451, -1841,  -564, -3353,   -12,  1360, -5364,
    2108,   552,  9069, -5364, -1477, -1676, -5364, -5364,   -39, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  2568,  2574,
   -5364, -5364,  4041, -2747, -5364, -5364,  -816, -5364, -2735, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364,  1917, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364,  3990, -1765, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -1350, -5364, -3086, -5364,
   -5364, -5364, -5364, -5364,  1369,  -625, -5364,  4134, -5364,  4180,
   -1288, -1890,  3730, -5364,  4486, -5364, -5364, -5364, -5364, -5364,
   -5364,  3736, -5364, -2288, -5364, -2732,  4490,  4491,  4492, -5364,
    4503, -5364, -5364, -1906,   562, -5364,   865, -5364, -5364, -5364,
   -5364, -5364,  1332, -5364,   122,   924,   124, -4395, -1611,  1608,
   -5364, -5364, -1959,  3757,  4183, -1357, -5364,  2965, -5364,  3728,
    1949, -5364,  2294, -5364,  1238,  1242, -5364, -5364,  1962, -5364,
   -5364, -5364, -5364,   666,   199, -5364, -5364, -5364,   548,   965,
   -2277, -5364,   674, -3522,  4494,  -179, -1240, -5364, -1389,  2305,
     660,  5129,  -472, -5364, -5364,  4475, -5364, -2109, -5364, -1628,
   -1674,  -408, -3329, -4620, -3447, -5364, -1757, -5364, -5364, -5364,
   -5364, -5364,  1254, -5364, -5364, -5364,  2998, -5364,  5406, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  -740,
   -1197, -5364, -5364,  2798, -1135,  -555,  5428,  -372, -5364, -5364,
    -368, -5364, -5364, -5364, -5364,  4281,  3910, -5364,  2761, -5364,
   -5364, -5364, -5364,  2440, -5364, -5364,   977, -1106,  2269,  2293,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364,   962, -5364,  1381,
   -2006, -5364, -5364, -5364, -5364,  -363, -5364, -5364, -5364,  1384,
   -5364,    23,  5232,  -362, -5364, -5364, -5364,  5055, -5364, -5364,
   -5364, -5364, -5364, -5364,  3590, -1560,  5058, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  3155, -5364, -5364, -5364, -5364,
   -5364, -5364,  3978,  5249,  -684, -1794, -5364, -1052,  3162,  2472,
   -1120, -5364, -5364, -5364,  4511,  5253, -5364, -5364,  5420, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,  3114,   594,
   -5364, -5364, -5364, -5364, -5364,   694, -5364, -5364, -5364, -5364,
    3880, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364,  4310, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364,  1569,   -95, -5364,   939,  -119,
   -5364,   641, -5364, -5364, -5364, -5364, -5364,  -157, -5364, -5364,
    -162, -5364, -1405,  4911, -1397, -5364, -1849, -3605, -5364,     1,
   -5364, -5364, -5364,  3168, -5364, -5364, -5364, -5364,  1406, -5364,
   -5364, -2869,  -913, -1797, -4006,  2257, -5364, -5364, -5364,  -529,
       0,   308,  1677, -1286, -5364, -5364,  2624,  3401,    43,  2664,
   -5364,  4984,    51,  -340,  -751, -1129, -5364,  7824, -5364, -5364,
   -5364, -5364, -5364,    39,  -552,  -508,   138,  -674,    77,   176,
      11, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364,  2526, -5364, -5364, -5364,
    1432, -5364,  5285, -5364,  3364, -1877,  5291,  3248,  2562,  2564,
   -5364, -5364, -5364, -5364, -1785, -5364, -5364, -1879,   128, -5364,
    3574, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364,
    3884,  -587,  -590,  4088,  5307,  4801, -5364,  4355, -5364, -5364,
   -5364, -5364, -5364,  1804, -5364, -2171,  2597, -1583, -2397, -5364,
   -5364,  3012,  1322, -5364, -5364,  1510, -5364,  2204, -2714, -3149,
   -5364,  2454, -2896, -5364, -5364,   603, -5364, -5364, -5364,  1730,
     710,  5272,  4676, -5364, -5364, -5364, -5364,  5487, -5364, -5364,
    1430,  5516,  5522,  5535,  -345, -5364, -3511, -5364, -4166, -5364,
   -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -4507,
   -5364, -4714, -5364, -5364, -5364, -5364,     7, -3956, -5364, -5364,
    2619, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364, -5364
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   469,   753,  2100,   470,   471,   472,   473,   474,  2066,
     475,  1306,  2820,  1308,  2032,  2823,   476,   722,   477,  2234,
    3024,  3025,  4799,  4800,  4793,  4794,  4796,  4797,  3026,   839,
     840,   478,  2876,  4074,  3551,  2873,  5261,  2106,  4968,  2107,
    4969,  2869,  4089,  4636,  2113,  2880,  2114,  4634,  4635,  4627,
    4628,   761,  4986,  5273,  5592,  5866,  5742,  5452,  5453,  5454,
    5598,  5461,  5868,  5459,  5867,  5455,  5738,  5950,  5736,  5949,
    5456,  5276,  5277,  5457,  4075,  3634,  3635,  5811,  1365,  3546,
    3643,  3644,  2883,  4625,  4779,  5535,  4783,  5682,  5809,  5610,
    3671,  5152,  5536,  5537,   654,  1377,  5476,  5477,  2195,  5293,
    5283,  4082,  4083,  4084,  3553,  3554,  5284,  2950,   479,   833,
    2225,  3678,  1481,  2226,  2227,  4996,  4997,  3728,  3729,  3730,
    5280,  5281,  5282,  5468,  4621,  4987,  4622,  5956,  4623,  2804,
     956,  2230,  2231,   855,   856,  1497,   857,   858,  2251,  1553,
    3088,  3089,  3090,  2306,   859,   860,   861,  2248,   862,  3110,
    3049,  4336,  4337,  4819,   863,  3757,  3758,  3759,  3114,  1178,
    3760,   480,   481,   675,   683,   676,  1175,  2680,  1176,   482,
     483,   720,  2056,  2057,  2058,  2059,  3516,  2839,  3510,  3511,
    4586,   864,   865,  2316,   957,   958,   484,   959,   655,  1676,
    2423,  3814,  4846,   960,   961,   962,   963,  1678,  2408,  2409,
     964,   965,   966,   967,   968,  5460,  3193,  3194,  3810,  3788,
    4361,  3195,  2419,   969,   970,   971,   972,  1679,   932,   933,
    3159,  4374,  4839,   973,   630,   835,   836,  2233,  2998,   837,
    2999,  3681,  4792,   838,  1482,  2994,  1484,  3818,   974,   975,
    2427,  2426,  3815,   705,   976,  1296,   636,  1496,  2015,  5607,
    5608,  5871,  6062,  2016,  3487,  4030,  4562,  4563,  4949,  3144,
     898,  1609,  2364,   977,  1287,  2796,  1184,  2688,  3819,   978,
    2429,  2431,  2428,  3817,  5552,  2430,   979,   665,   694,   653,
    1608,   681,  4991,  5290,   810,   811,   847,  3047,   812,  1492,
    1453,  2201,  2976,  2977,  3649,  3650,  3717,  3718,  3719,  2968,
    2969,  2970,  3036,  3037,  3038,  2957,  2958,  2959,  2205,  2954,
    2955,   813,  1454,  1465,  2971,  2972,  2973,  3723,  3040,  3041,
    3042,  3043,  2974,  2354,  2975,  4145,  4609,  4984,  4610,  5269,
    3480,  4980,  4981,  4766,  5080,  3494,   489,   668,  1161,  1883,
    2672,  3958,  3379,  3381,  2673,  3957,  4497,  4498,  4499,  3377,
    3378,  5427,  3383,  3955,  5571,  5910,  5707,  5708,  3947,  5712,
    4506,  4921,  4922,  5239,  5428,  5577,  5831,  5713,  5917,  5829,
    5913,  5830,  5915,  6052,  5991,  5992,  5841,  5928,  5929,  5996,
    6053,  5723,  5724,  5725,  3951,  3952,  5424,  5448,  3541,  2189,
    2190,  5043,  1317,   490,  4611,  4251,  4612,  4613,  5088,  5734,
    4253,  4254,  4255,  3781,  1958,  5122,  5104,  4633,  5130,  4614,
    4972,  4973,  4974,  4975,  5636,  5768,  5638,  5639,  5765,  5883,
    5764,  4976,  4977,  5265,  5531,  5049,  4711,  4695,  4696,  4771,
    5138,  5367,  5533,  5529,  5658,  5659,  6040,  6041,  5675,  5983,
    5676,  6047,  6072,  6073,  5660,   491,   667,  1831,  5774,  5775,
    5776,  1555,  5368,  1556,  4325,  1557,  2275,  1558,  4327,  1559,
    1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,  1568,  3102,
    2264,  2265,  3063,  2257,  2258,  2256,  4809,  4807,  2326,  5677,
    5678,  3056,  2261,  2262,  3076,  5806,  5661,  5679,  5663,  4335,
    2277,  1914,  1915,  3585,  1928,  1929,  3067,  2710,  3068,  2193,
    2278,  2279,  3069,  3070,  3074,  4468,  5224,  4474,  4475,  4476,
    3912,  3913,  3914,  3915,  3916,  3338,  5664,  5137,  5528,  5648,
    5651,  5789,  5977,  5050,  4697,  5053,  1272,   762,  4698,  4699,
    5933,  5849,  5856,  5934,  5857,  5850,  5507,  4071,  5935,  5936,
    5937,  5859,  5852,  4601,  5440,  5441,  5038,  3080,   492,   572,
    3669,  1440,  1442,  1452,  3675,  2985,  2984,  1458,  1457,  2963,
    4685,  5036,  4196,  3672,  4270,  5375,   796,  4256,  5519,  5340,
    5526,  4257,  4952,  4258,  5499,  5629,  4259,  5360,  5524,  5646,
    4953,  4954,  4260,  4261,  4262,  5941,  5942,  5943,  4700,  1638,
     816,   817,  1470,  1471,  1472,  3139,  5135,  4723,   493,  2861,
    2856,   494,  1334,  1335,  1336,  2078,  2079,  2859,  2860,  3536,
    4060,   495,  1300,  2815,  2068,  2848,   496,  1320,  3527,  3528,
    3529,  4055,   497,  1478,  2221,  2222,  2989,  4277,  4791,  5156,
    5382,  5543,  5378,  5689,  5690,   498,   843,  1488,   499,   632,
    2243,  2244,  2245,  3028,   500,  1689,   580,   501,  1182,  1889,
    1892,  1893,   502,  1299,  2018,  2019,  2020,  2021,  3490,   503,
    2396,  3163,  3164,  3165,  3166,  2810,  4031,  2811,  2812,  3499,
    4381,   504,   776,  1437,   505,   775,  1436,   506,   507,   693,
     748,   685,  1901,   509,   510,  3481,  2467,   512,   782,   780,
    1123,   514,  1430,  1426,   515,  2468,  1124,   772,   773,  1384,
    1204,  3570,  3571,  2338,  2339,  2915,  2902,  1205,  1206,  1410,
    2171,  2927,  2699,  2700,  1999,  2701,  3972,  5601,  4519,  5980,
    1710,  1619,  1304,  1126,  1127,  1128,  1843,  1844,  1859,  1129,
    1853,  2626,  4440,  4884,  4885,  4886,  4887,  5215,  2549,  2550,
    2667,  1130,  2537,  1131,  1132,  1133,  1134,  1135,  1136,  1137,
    2532,  1138,  1139,  1140,  1141,  2662,  4422,  4423,  4866,  3372,
    3373,  3374,  1142,  3220,  4408,  3231,  1143,  1144,  1145,  1146,
    1147,  3939,  1148,  4492,  4123,  1149,  1837,  2612,  2494,  4858,
    4413,  5195,  5199,  5200,  5201,  5402,  2435,  3208,  3842,  4849,
    4851,  4852,  3843,  3844,  3940,  3343,  1731,  1732,  1699,  1700,
    1385,  1386,  1387,  1388,  1389,  4107,  4108,  5002,  4640,  5004,
    4644,  2136,  2137,  2140,  2141,  1390,  1391,  1392,  1393,  2124,
    1394,  1395,  1396,  2907,  5485,  5010,  5011,  5621,  5620,  5012,
    4649,  4650,  4111,  4112,  4566,  4567,  4568,  3581,  2490,  2491,
    2563,  2401,  2402,  2403,  2436,  1404,  2151,  2923,  3591,  2153,
    3589,  4118,  3593,  4124,  4125,  2657,  3365,  3935,  3367,  4911,
    5231,  5232,  5419,  5560,  5561,  5566,  4265,  5074,  5075,  3124,
    1411,  2935,  3603,  4121,  1960,  1961,  1962,  2161,  3596,  3597,
    3775,  1413,  1414,  1424,  1429,  1417,  1415,  3115,  4681,  3116,
    3917,  3899,  4958,  4146,  2459,  2460,  5079,  4894,  1418,  2936,
    4132,  4133,  4134,  1400,  1401,  2146,  2147,  2148,  1419,  1402,
    2916,  4114,   516,   715,   517,  2361,   883,  1605,  2360,  3507,
    1490,  2802,  2333,  2334,  1592,   805,   652,   518,   656,  3160,
     519,   697,  2801,   937,  1291,  2011,  2012,  2013,  3482,  4026,
    3483,  4019,  4020,  3484,  1285,  4558,  4559,  3134,  4159,  4160,
    4154,  2795,  3471,  1286,  2003,  4012,  2792,  4013,  2793,  2825,
    4014,  4376,  5185,  5694,  2789,   520,   691,  4545,  4006,  4007,
    5817,  5818,  1283,   521,   637,  2332,   879,  1581,  1584,  1585,
    2342,  3120,  4355,  1586,  1587,  3122,   880,   881,   522,   736,
    3537,  4063,  1340,  1982,  1983,  1984,  2776,   523,   688,  1273,
    4001,  4542,  2762,   671,  1603,  1965,  1276,  1966,  2758,  3455,
    1949,   524,  1434,  1433,   831,   525,   526,   788,   581,  2175,
     527,  1309,  2049,  2837,  4038,  4039,  4571,  2050,  2051,  3508,
     528,   701,  1293,  3504,  4959,  4960,  5258,   529,   727,  1324,
    1325,  2072,  2070,  3532,  2851,   530,  2674,   531,   657,   940,
    1641,  1642,  2394,   532,   730,  1329,   533,   534,   942,  4382,
    5820,  5986,   661,  2398,  1646,  5270,  4652,  5017,  5018,  5020,
    5317,  5318,  6049,  6093,  6104,  6097,  6107,  6108,  6111,  6117,
    6118,  1150,  1347,  1348,  1151,  5779,  1152,  1153,  1154,  2469,
    1289,   696,  2006,  2007,  3476,  2799,  3474,  2008,  4021,  4022,
    3404,  3590,  1155,  4008,  5039,  1491,  2335,  1312,   536,  1156,
     619,   807,  1349,  2143,  3171,  1224,  3430,  1158,   867,  3820,
     980,   981,  1448,  1890,  2210,  2211,  3172,   621,  1655,  3431,
     868,  1226,   539,   622,   623,   624,   625,   626,   627,   628,
     629,   545,   687,  1208,  2706,   546,  1438,  2937,  3500,  1905,
    1234,  1934,  1923,  1933,  2732,  3442,  2735,  3443,  3444,  4534,
    3994,  4535,  3995,  1279,  2727,  1906,  3996,  2720,  2721,  2722,
    2723,  3985,  1920,  2716,  2186,   547,   943,  2407,   664,  1648,
    1649,  3184,   548,   690,   549,   721,  1314,  2844,  3520,  3521,
    4051,  4588,  4052,   550,  1189,  1190,   551,   926,  3544,  3150,
    2350,  1451,  2351,  2378,   929,  1611,   930,   931,  1625,  1622,
    1628,  1624,  4186,  3664,  3665,  3155,  2358,  2212,  2693,  3657,
    4671,  2213,  4180,  4181,  4672,  2368,  3146,  3147,  2982,  5392,
    4193,  3668,  5179,  4365,  5393,  5394,   552,   702,   553,  5285,
     714,  1303,  2029,   554,   555,   556,   557,   781,  1422,  1207,
     573,   574,   575,   576,   820,   821,  3674,  4272,  4786,  4787,
    5377,  6100,  6101,  2882,  4087,  5751,  6063,  6094,  6113,  4994,
    4995,  5294,  5475,  3556,  4086,  5286,  6057,  4080,   558,  1354,
    1350,   747,  2098,  2092,  2094,  2867,  3540,   559,   560,   561
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     537,   535,   749,   666,  1275,  1554,  1222,  1271,   825,   819,
    2163,   544,  1383,  1230,   513,  2687,   815,   508,  2162,  2652,
    2284,   511,  2285,  3050,  2598,  1673,  2826,   485,  2344,  2176,
    1989,  2466,   486,  1183,  2991,  2458,   706,   487,  2682,   540,
     488,  2295,  3117,   538,  1602,  2268,  3199,  3742,  2154,  2373,
    1450,  3973,  1891,  2288,  1361,   684,  2733,  3103,  1362,  1363,
    2307,  2308,  2309,  3125,   928,  2311,  3604,   927,  4263,  2297,
    4264,  2518,  3104,  2355,  3821,  3822,  2325,   542,  3800,  2303,
    2323,  3498,  4130,   882,   870,   885,   886,   887,   888,   889,
    1305,   891,   892,  2119,  1191,   894,   895,   927,  2191,  4304,
    2317,  2192,  2843,  4602,  1489,  3495,  2749,  2750,  1733,  1916,
    1919,  1921,  2788,  2144,  2500,  4010,  4647,  1331,  1931,  4358,
    1338,  4616,  2681,  4988,  4113,  4000,  4388,  4999,   871,  1956,
    1499,  2938,  2838,  3847,  3724,  1228,  2717,  5000,   541,  4811,
    3725,  4326,  3787,  2087,  4332,  4328,  2729,  4329,  4136,  3573,
     718,  1990,  3652,  4330,  5141,  3509,  4334,  3545,   680,  4252,
    2756,  4692,  4059,  3653,  4274,  3572,  3572,  1693,  3413,  3071,
    4693,  4694,  4147,  4078,  4615,  4078,   543,  2769,  3577,  1229,
    1838,  1839,  1341,  1342,  2637,  2638,  2639,  2640,  2641,  2642,
    2643,  2645,  2647,  2648,  2649,  2650,  2651,   826,  4147,  4147,
    3092,  3200,  2782,  2783,  3156,  2682,  3157,  3158,  2864,   827,
    4701,  2836,  4703,   828,  4789,  4713,  4719,   711,   829,   830,
    1991,  5380,  3721,  3137,  4720,  -497,  4054,  2340,  2911,  1431,
    4470,  5148,  3197,  3722,  5077,   731,  -497,  2399,   777,   798,
    1838,  1839,   802,  3654,  3648,  2399,  1626,  2269,  4748,  3621,
    2286,  5006,  1673,  5082,  2255,  4772,  2260,  2290,  2266,  3714,
    2266,  1838,  1839,   734,  4147,  4147,  2416,  4316,  2266,  1950,
    2399, -2678,  2298,  1838,  1839,  2292,   778,  2255,  3111,  5916,
    1427,  2223,  4152,  4471,  2266,  5299, -2473,  4090,  4079,  2681,
    4079,  3027,  4813, -3384,  2266,  1838,  1839,  3111,  2304,  1827,
    1829,  1830,  5387,  2310,  3181,   870,  3111,   870,  4061,  4185,
    1428,  1838,  1839,  1873, -2067,  2266,  2255,  2255,  2321,  2322,
    1838,  1839,  4470,   726,   818, -2067,  5295,  4085,  5084,  1593,
    1838,  1839,  3349,  1838,  1839,  2983,  2276,  2276,   794,  2188,
    2276,  1606,  1607, -2473,  2270,  2437,  2438,  2276,  5086,   871,
    5100,   871,  3949,  2276,  2448,  1840,  1918,  1841, -1249,  1209,
    4162,  2271,  4289,  3182,  1468,  5433,  3768,  4069,  2617, -1249,
    5109,  2399,  3111, -2067,   577,  4471,  2625,  2627,  4891,  2630,
    2631, -2679,   669,  3572,   709,  2259,  2508,  1952,  2511,  1209,
    5874,  4275,  3111,  3111,  4412,  5369,  4983,  3111,  2027,  1838,
    1839,  2451,   662,  2524,  2525,  2527,  1838,  1839,  1782,  3384,
    2960,   707,  2528,  2529,  3111,  1840,  3265,  1841,  3138,  2541,
    5532,  1375,  3350,  2280,  2280,  2283,  1369,  2280,  2287,  1838,
    1839,  3335,   779,  2452,  2280,  2291,  1840,  5747,  1841,  5957,
    2280,  2294,  1838,  1839,  4177,  4669,  4989,   658,  1840,  2453,
    1841,  1838,  1839,   707,  5054,  3039, -2473,  2980, -2987,  1681,
     794,  1449,  3804, -1481,  1838,  1839,  2451,  1838,  1839, -2987,
    1840, -2768,  1841,  4194,  1842,  2357,  2187,  1476,  5458,  1209,
    1967, -3367,   750,  4721,  1838,  1839,  1840, -3371,  1841,  4036,
    5511,  1644,  1734,  2454,  1912,  1840, -2067,  1841,  2452,  4092,
    2372,  1912,  3467, -3370, -2473,  1840,  1302,  1841,  1840,  2081,
    1841, -2473, -2067,  4176,  2453,  3485,  3655, -3368,  4192,  3351,
    2871,  2455, -2473,  3398,  3399,  3400,  3401,  1838,  1839,  3111,
    4757, -2672,  1838,  1839,  1842,   673, -3304,  1774,  3149, -2473,
    1591,  2062, -2067,  -707,  4093,  1838,  1839, -3304,  3218,   513,
    1838,  1839,   508,  3205,  -707,  1842,   793,   884,  2454,  4629,
    2023,  1594,  1595,  1596,  1597,  4892,  2096,  1842,  -805,  1332,
     631, -2067,  1838,  1839,  1840,  3111,  1841,  4843,  4626,  1838,
    1839,  1840,   535,  1841,  3111,  4678,  2455,  3950,  1860,  1842,
    4495,  1912,  1836,  1838,  1839,   513,  1412, -3304,   508,  4279,
    4772,  1412,   511,  1412,  1840,  1842,  1841,  1838,  1839,  5901,
   -3369,  1838,  1839,  1986,  1842,  1838,  1839,  1840,  2456,  1841,
     809,  4502,  5155,  1383,  1842,  4630,  1840,  1842,  1841,  1838,
    1839,  4209,  -923,  1838,  1839, -2791,   866,  3096, -3305,  1840,
    1812,  1841,  1840,  1443,  1841,   804, -2791,   874,   578, -3305,
    4758,  1985,   749,   537,  5512, -3388,  2272,  1333,  5458,  1840,
    1912,  1841, -2987,  2104,   544,  2105,  3543,  1157,  2108,  2109,
    2111,  2112,  2962, -3374,  2273,   869,  1816,  3896,   707,  5760,
    1248,   698,  2082,  2456,  1861,  2865,  2272,  1223,  1278,  5544,
    6019,  2063,   540,  1842,  1157,  4037,   899,   579,  1233, -3305,
    1842,  1181,  1840,  1953,  1841,   925, -2067,  1840,   824,  1841,
    1248,  1838,  1839,   873,  4631,  1157, -2827,  3045,  4670,  1645,
    1840,  4158,  1841,  1842,  4364,  1840,  1227,  1841,   659,  4097,
     542,  2318,  4156,  5479,  1435,   925,  1842,  5773,  4195,  1682,
    2028,  3385,  4252,  1838,  1839,  1842, -2768,  1840,  2235,  1841,
    2349,  4276, -2846, -3304,  1840,  4990,  1841,  6124,  1842,  1298,
     844,  1842,  4772,  4178,  1231,  5271,  1326,    34,  1840,  2691,
    1841,   875,  5027,  1315,   872,  2254,  5279,  3185,  1842,  4844,
     897,  2060,  1840, -3388,  1841,  3468,  1840,  5667,  1841,  2712,
    1840,   541,  1841, -2791,   982,  1425,  1968,  4070,  2704,  5605,
    1248,  2464,  4162,  5331,  1840,  3724,  1841, -3487,  1840,   876,
    1841,  3725,   543,  1370,   699,  4096,  2747,  1733,  1281,  2728,
    2355,  1842,    41,  1469,  3652,  1987,  1842,  5292,  3409,   543,
    4091,  2753,  3572,  2755,   663,  3653,  1157,  1466,  2897,  1842,
    4172,  4173,  4102, -2678,  1842,  2764,  4106,  2191,  2767,  2912,
    2192,   537,  2770,  4472,  4883, -3305,  4085,   866,  3753,  1569,
     825,  5434,   544,  1232,  4804,  2359,  1842,  4147,   874,  4062,
    1573,  4345,  4814,  1842,  1477,  1827,  1829,   795,  2164,  2785,
    2786,  2787,  5388,   670,  3081, -3384,  1840,  1842,  1841,   732,
     540,  3081,  5912,  3721,  1495, -1481,   869,  3183,  1570,  5754,
    5755,  1842,  5703,  2242,  3722,  1842,  4310,  4311,  5482,  1842,
    5483,  4149,  1783,  1600,  3336,   749,  1604,   735,  1840,  3408,
    1841,  -497,  4174,  1842,  1951,  1358,  5611,  1842,   542,  1427,
    1627,  4509,  3112,  1157,   873,  4312,  1572,   733,  5597,   841,
    5599,  3230,  2781,  1601,  1653,  4472,  1653,  1653,  1653,  2432,
    3656,  3112,  1653, -2679,  1653,  1659,  3583,  1659,  1659,  1659,
    3112,   537,   535,  1659,  2179,  1659,  4722,  2242,   662,  3352,
    2242,  5613,   544,  5614,  2683,   513,  4473,  4790,   508,  2400,
    3793,  2030,   511,  1157,  5381, -3388,  3462,  2400,  1157,   541,
    3749,  3750, -2473,  3341,  3342,   872,  3055,  1571,  3058,  2422,
     540,   662,  3575,  3576,  1677,  1842,  3345,  3188,  2981,  1913,
   -2067,  2981,  2400,   927,  3192,  3813,  1913,  5748,  1157,  5958,
    3077,  1657,  3247,  1657,  1657,  1657,  3112,   543,  1157,  1657,
    3082,  1657,  1318,   543,  2118,  5745,  3219,  1842,   542,  4667,
     841,  5749,  3087,   841,  4682,  3030,  3112,  3112,  2274,   826,
    5337,  3112,  5339,  3478, -1249,  5342,  3232,  4240,  3233,  2654,
    3106,   827,  5347,  5348, -2847,   828,  4135,   728,  3112,  2097,
     829,   830,  3234, -3367,  3235,  1838,  1839,  2445,  2274, -3371,
     660,  3251,  1656,  5272,  1656,  1656,  1656,  4094,  1973,  3216,
    1656,  4692,  1656,  3266,  3322, -3370,  3323,  2629,  4379,   541,
    4693,  4694,  4772, -2347,  4528, -2067,  1913,  5033,  3845, -3368,
    3846,  2276,  4157,  2400,  2457,  1157,  1157,  1157,  1157,  1834,
    1658,  3097,  1658,  1658,  1658,  5001,  2209,   633,  1658,  1157,
    1658,  5021,  1832,  2276,  5024,  5481,  2276,   543, -2848,  3133,
    4713,  2683,  1838,  1839,  1813,  1912,  2543,  2276,  2692,    34,
    2218,  1912,  3606,  3057, -2987,  3357,  3358,  3245,  3361,  3362,
    3248,  2558,  2607,  4263,  2566,  4264,  2568,  2960,  5034,  3224,
    2572,  2573,  2574,  5545,  6020,  1913,  3260,  5896,  2580,  6038,
    1817,   934,  5344,  3112,  4632,  1734,  3651,  3375,  5875,  5876,
    3278,   708,  3337,  5704,  -115,  4940,  -115,  2981,  2280,  3078,
    2502,  1734, -3369,  3333,    41,  3334,  2254,  4764,  2751,   577,
     700,  3898,  3927,  5762,  3928,    43,  5923,  5924,  2768,  4965,
    2280,  3093,  3530,  2280,  3094,  4418,  3966,  4419,  4444,  3112,
    4445, -2827, -3304,  1813,  2280,  3105,  2738,  3776,  3112,  -707,
    -119,  4843,  -119, -2347,  1383,  4446,  3039,  4447,  4653,  -111,
    1840,  -111,  1841,  1639,  4252, -2827,  3720,  1412,   749,  5279,
    4656,  4772,  3784,  3162,   878, -3374,  1917, -2846,  1922,  2347,
    1884,   771,  1925,  1930,  1838,  1839,  5278,  2064,  1282,  1869,
    1870,  1871,  1872,  3997,  1838,  1839,  3897,  3112,  4486,  5287,
    4487, -2846,  2209,  1838,  1839,  3225,  5823, -2027,  3595,  5893,
    1838,  1839,  1959,   468,  5025,  4205,  1157,  5237,  3236,  2052,
    5538,  1838,  1839,  3237,  1838,  1839,  2216,  1840,  2707,  1841,
    4267,   927,  1838,  1839, -2791,  6009,  5133,  4147,   662,  2849,
    5472, -2791, -2791,  4772, -3305,  3238,   682,  5516,  3060,  1838,
    1839,   689,  3240,  4115,  4116,  3999,  5288,  4637,  4638,  2299,
    3652,  2661,  2961,  1416,  3253,   896,  4888,  3509,  1734,  1908,
    3787,  3653,  5705,  3061,  3572,  3572,  1693,  4777,  1383,  1842,
    3250,  4641,  4642,  1459,  3252,  1994,  1838,  1839,  3256,  1383,
    1383,  3072,  1834, -3212,  2102,  2103,  6015,  1838,  1839, -2696,
    3982,  5753,  3257,  2217,  3137,  1832,  3264,  3044,  2271,  1460,
     663,  5091,  3724,  1630,   875,  2874,  2875,  4326,  3725,  2878,
    4332,  4328,  1295,  4329,  2885,  2886,  2887,  5106,  5107,  4330,
    5746,  5824,  4334,  5462,  2718,  1974,  2441,  2129,  5981,  2962,
    5274,  2833,   935,   663,   535,  1578,  1842,  2053,  1157,  2791,
     634,  1461,   876,  4844,  1425,  5134,  4529,   513,  2069,  1840,
     508,  1841,  2150,  6016,   511,    34,  6017,  2852,   662,  1840,
    5450,  1841,  2668,  4778,   679,  3959, -2027,  5358,  1840,  1975,
    1841,  1976,  4712, -2765,  3276,  1840,  5972,  1841,  1640,  5525,
    1157,  4339,  1157,  4341,  2938,  4216,  1840,  4278,  1841,  1840,
    3721,  1841,  5626,   936, -2763,  2966,  4034,  1840,  5397,  1841,
    1909,  3722,  2130,   849,   850,  5706,  3284,  5289,  3045,  4803,
      41,  6060,  2940,  2131,  1840,   927,  1841,  5894,  3727,  5612,
    2132,    43,  1499,   777,  2752,  1734,  1885,  2191,  2669,  1290,
    2192,  2163,   579, -1541,  2163,  2163,  3459, -2766,  2682,  5635,
    1462,  5637,  3599,  3600,  3477,  3478,  1706,  1707,  1708,  2881,
    2884,  1840,  2133,  1841,  5352,  3388,  3389,  1838,  1839,  1449,
    6080,   778,  1840,  1977,  1841,  3791,  3861,  5464,  1842,  3778,
    4514,  4515,  4516,  4517,   841,  3217,   841,  2030,  1842, -2847,
    1463, -1541,  3999,  2995,  1838,  1839, -1541,  1842,  4268,  3138,
    3376, -2347,  3243,  1209,  1842,  2939,  3121,  5035,  3998,  5462,
    5341,  3564,  3412, -2847,  1759,  1842,  3414,  3565,  1842,  2300,
    1995,  5572,  1978,  2134,  2740,  2741,  1842,  2743,  2744,  2745,
    3140,  3141,  2681,  4386,  3440, -1541,  5539,  3979,  2754,  1449,
   -2027,  2929,  3451,  1842,  5737,  5739,  3452,   635,  2956,  5238,
    1157,    34,  1157,  2766,  2135,  3479,  2442,    16,    17,  3457,
    2089,   925,  5781, -2848, -3212,  3991,  4833,  4834,  4835,  4836,
    1913,  1979,  3464,  3465, -2696,   678,  1913,  5766,  2466,  4005,
    1842,  5595,  2618,  3804,  5400, -2764,  5275, -2848,  1157,  5805,
    4023,  1842,  3524,  5518,  2703,   468,  5059,  2967,   686,  5982,
    3989,  1157,  1157,  1947,  5973,  2719,    41,  1157,  5513,  3659,
    3948,  1157,  1157,  1157,  1996,  1631,  5451,    43,  3953,  3918,
    1579,  5422,  1157,  1157,  3142,  4033,  3062,   779,  1157,  1997,
    1157,  1157,  1157,  1157,  1157,  1834,  1157,  3177,  6013,  6014,
     513, -2347,  1840,   695,  1841,  5007,  3777,  1157,  1832,  1157,
    1838,  1839,  1157,  1157,  5126,  1157,  1157,  1157, -2765,  1157,
    1157,  1980,  3933,  3934,  2025,   877,  5183,   703,   704,  1840,
     663,  1841,  2619,  2209,  1157,  1157,  1157,  1157,  1157, -2763,
    1157,  1157,  1157,  1981,  5540,  1157,  1157,  1157,  1157,  1157,
    1157,  1157,  1183,  1157,  1157,  1157,  1157,  2879,  1157,  1157,
    2223,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1854,   842,
    1157,  1157,  1157,  1157,  3983,  1157,  1157,  1157,  2622,  1157,
    5595,  1157, -2766,  1157,  2813,  4117,  2670,  1157,  1157,  1157,
    1838,  1839,  1157,  1157,  1157,  1157,  1157,  3660,  1157,  2960,
    3984,  1398,  2931,  1838,  1839,  1157,  1838,  1839,  3286,  5573,
    5574,  3999,  1157,  1157,  1157,  1157,  1838,  1839,   513,  3174,
    1948,  1842,  3525,  1157,  1157,  2608,  1157,  1157,  3651,  2620,
    1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,
    1157,  1157,  1157,  3486,   870,  1157,  3360,  3926,  1842,  3929,
    4326,  4349,  3805,  4332,  4328,  5862,  4329,  5864,  2613,  5974,
     663,  5408,  4330,  3175,  4098,  4334,   938,   878,   852,   853,
    4357,    16,    17,  5975,  5008,  3289,  5805,  5443,  1855,  5554,
    4064,  5847,  1838,  1839,  1248,  1840,  1157,  1841,   871,  5584,
     766,  1157,  3039,  1856,   710,  2653,  2352,  3720,  5700,  2067,
    1420,  1157,  4351,  4598,  4175,  2404,  1838,  1839,  5180,  5181,
    5182,  5575,  1838,  1839,  2314,  1838,  1839,  2129,  1838,  1839,
   -2764,  1838,  1839,  5465,   703,   704,  2713,  1838,  1839,   925,
    5466,  1838,  1839,  2026,  6000,  6001,  1406,  5052,  5052,  3057,
    1838,  1839,  3526,  4301,  1838,  1839,  1734,  3244,  1464,  1838,
    1839,  5702,  1838,  1839,  2814,   703,   704,  5196,  5653,   713,
     848,   468,  1421,  1838,  1839,  1840,  2434,  1841,  1157,  2197,
    1857,  1838,  1839,   893,  1493,  4548,   822,  3783,  1840,   -72,
    1841,  1840,  4167,  1841,  2671,  5576,  3283,  1838,  1839,  1408,
    3658,  1840,  2130,  1841,  5848,  5467,  2966,  1838,  1839,  3662,
    1157,  5697,  1157,  2131,  1842,  2932,  4309,  3290,  5045,  5338,
    2132,  3898,  3898,  5233,  2759,  3898,  3898,  3291,  1599,  4599,
    4547,  3898,  3898,  3436,  1399,  5350,  3292,  4283,  2447,  4285,
    4286,   703,   704,  3295,  1673,  4291,  1157,  3329,  5009,  1838,
    1839,  3524,  2133,  4299,  3313,  3254,  5564,  5383,  4306,  1838,
    1839,  3346,  4680,  5581,  5655,  3318,  3417,  1840,  2760,  1841,
    5846,  2962,  1838,  1839,  5359,  5523,  5361,  5046,  3371,  2353,
    3394,   939,  3321,   927,  2966,  4004,  2840,  2405,  3523,  2961,
    5627,  1840,  5555,  1841,  1842,  4925,  4926,  1840,  5177,  1841,
    1840,  2315,  1841,  1840,  3659,  1841,  1840,  1842,  1841,  5567,
    1842,  1383,  1840,  2134,  1841,   777,  1840,  1383,  1841,  3328,
    1842,  4302, -1136,  2406, -1136,  1840,  2868,  1841,  3472,  2242,
    3339,  1157,  1383,   925,  1840,  2872,  1841,  1840,  2404,  1841,
    3566,  4847,   749,  4053,  2135,  5847,  5888,  5889,  1840,  2956,
    1841,  2188,  3405,   778,  3354,  3433,  1840,   468,  1841,  1854,
    3557,  2724,  1157,  3558,  3045,  1838,  1839,  3563,  3044,  3727,
    4524,  4525,  1840,  2675,  1841,  5656,  2917,  1343,  3726,  1379,
    2191,  2163,  1840,  2192,  1841,  4533,  1842,  2942,  5854,  5047,
    1358,  1673,  4350,  4370,  4371,  4372,  4373,  3505,  2967,  3434,
    2725,  1838,  1839,  2761,  6098,   751,  5976,  2952,  2404,  4560,
    1842,  4600,  2236,  1838,  1839,  3584,  1842,  3356,  4331,  1842,
    4333,  3525,  1842,  4303,  1840,  1842,  1841,  2956,  5785,  2951,
    5642,  1842,  3660,  2943,  1840,  1842,  1841,  1838,  1839,  3418,
    4862,  2714,  4683, -2787,  1842,  2944,  2357,  1840,  1842,  1841,
    6102,  1838,  1839,  1842, -2787,  2715,  1842,  5307,  5848,  5308,
    2771,  5390,  3978,  5048,  1344,  1345,  4101,  1842,  2925,  1855,
    4105,  1838,  1839,  2374,  2944,  1842,  2967,  5628,  1838,  1839,
    3975,  3976,  5978,  4078,  1856,   537,  2375,  1838,  1839,  2621,
    2060,  1842,  2060,  3932,  1157,  1157,   544,  5052,  1838,  1839,
    3823,  1842,  2653,  1376,  3990,   752,  3661,   723,  1917,   779,
    2405,  1838,  1839,  2953,  2352,   703,   704,  1343,  2325,  4340,
    4392,  4393,  6007,  6006,   540,  1838,  1839,  4416,  3091,  4399,
    4147,  4400,  5578,  4402,   841,  5013,  6103,   577,  5014,  3604,
    1840,  3526,  1841,  1842,  2376,  2694,  2242,  4394,  2110,  1383,
    3636,  1845,  6099,  1842, -2526,   754,  2726,  2163,  2695,  5786,
     841,  1857,   542,  5662,  3651,  4353,  1842,  1846,  4081,  4147,
    4147,  1157,  1838,  1839,  2129,  4684,  1840,  4712,  1841,  2164,
    2405,  3170,  2164,  2164,  3601,   724,  2242, -2288,  1840,  1157,
    1841,  5884,  3180,  5886,  5887,  3447,  1847,  2945,  4079,  4356,
     800, -2787,  1848,  5696,  1344,  1345,   866,  3450,   537,  2946,
    6033,  1157,  1840,  1157,  1841, -2288,  2376,   874,  4863,   544,
    3173,  1157,  1157,   541,  1346,     9,  1840,  5914,  1841,  -260,
    5918,  1858,  1269,  4485,  3662,  4488,  1316,  5787,  5015,  1849,
    2926,  3999, -2526, -1136, -2475,   869,  1840,   540,  1841,  2130,
    2559,   899,  2560,  1840,  2683,  1841,  6085,  6086,  3178,  1842,
    2131,   543,  1840,   513,  1841,  1838,  1839,  2132,  2633,  4119,
    3228,  2237,  4781,  1840,  5115,  1841,  1912,   737,  4147,  4782,
     801,  3277,    19,   873,  1860,   542,  1840,  2353,  1841,  2434,
    1838,  1839,  2965,  5793,  3663,  1842, -2526,  1838,  1839,  2133,
    1840, -2475,  1841,   803,  3720,  5964,  5965,  1842,  4139,  5968,
    5553,  2947,  2956,  1157,  1157,  1157,   804,    16,    17,  3176,
    5016,  1673,  4120,  3780,  4941,  6034,   927,  1444,  1838,  1839,
    5165,  1842,  2377,  5168,  3552,  5170,  3555,  4158,  5229,  4675,
    4676,  4677,  3560,  3562,   872,  1842,   541,  1840,  5169,  1841,
    5171,  2507,  1947,  5101,  5740,   738,  2238,  3179,  2239,  5230,
    2134,  2434,  2266,  4417,  1757,  1842,  5333,  5190,  4398,  5191,
    5192,   565,  1842,  1963,  4403,  3848,  4430,  5715,  2634,  4432,
    1861,  1842,   543,  2948,   543,  4140,  3853,  1157,  6050,  4460,
    6027,  2135,  1842,  2635,   823,    34,  5508,  1321,  1862,  2352,
    5102,  3999,  2236,  1964,  2696,  1842,   832,  3051,  1157,  1834,
    1838,  1839,  1157,  1157, -2475,  1157,  1157,  3999,  3999,  1842,
    2434,  2209,  1832,  2510,  1157,  3965,  1157,  1838,  1839,  4058,
    5741,  3007,  3008,  4795,  4798,  5187,  4801,   719,  4933,  3125,
    1840,  2270,  1841,    39,  3887,  4902,  3020,   770,  2240,  4904,
      41,  1371,  -423,  3436,  1157,  4461,  1209,  2889,  2271,  5139,
     579,    43, -2475,  3763,  1372,  1840,  1842,  1841,  1157, -2475,
    2636,  5103,  1840,  3895,  1841,   771,  5617,   707,    53,  5203,
   -2475,  1157,  2526,  3280,  1157,  1322,  3282,  1838,  1839,  3285,
     834,  5931,  3293,  1838,  1839,  3764,  1445, -2475,  3294,  3052,
    1838,  1839,  3298,  1840,  5618,  1841,   707,  3428,  1157,  1948,
     818,  3299,  1838,  1839,  1446,  1838,  1839,  1269,  3438,   846,
    3303,   925,  6044,  3304,  3941,   890,  2241,  3053,  1838,  1839,
    1157,  1373,  1838,  1839,  3305,  6028,  1838,  1839,  4023,  1323,
    2653,  4541,  3311,  1222,  3022,  3023,  3432,  3051,  1838,  1839,
    1230,  2961,  1838,  1839,  6128,  3765,  5903,  2561,  3312,  1842,
    2562,  5619,   790,  3239,  4832,  5634,  3727,  3637,  3316,  2663,
    3456,  1157,  2353,  4899,  5209,  3433,  5946,  2898,  4854,  4855,
     845,  5847,  2899,  3766,  1842,  1840,  2900,  1841,  2209,  2000,
    5116,  1842,  5117,  4589,  6065,   513,  1383,  6067,  2434,   941,
    1383,  4452,  1840,  2664,  1841,  4870,  4346,  1879,  4893,  1162,
    3317,  4510,  1858,  4923,  1001,  2052,  6042,  6042,  6045,  3434,
    3319,  3942,  1842,  1160,  3054,  2270,  4895,  5118,  5139,  4453,
    4906,  3513,  3514,  3326,  6084,  1888,  5716,  3488,  1734,  3052,
    2281,  2001,  2271,  5717,  3044,  3435,  1008,  5504,  4942,  3726,
    5509,  5510,  1177,  6002,  5851,  4324,  5119,  5858,  5718,   672,
    2540,  2237,  1840,  4536,  1841,  4543,  2901,  3059,  1840,  1282,
    1841,  6046,  1228,   749,  5778,  1840,  6071,  1841,  3638,  2665,
    3767, -2445,  4546,  3437,  1374,  3639,  4011,  1840,  6074,  1841,
    1840,  2242,  1841,  3640,  5848,  4537,  2857,  3496,  1504,  3239,
    5076,  1157,  5778,  1840,  1842,  1841,  1020,  1840,  3515,  1841,
    5221,  1840,  3497,  1841,  6087,  1157,  1229,  1157,  1284,  5041,
    5064,  1842,  5250,  1840,  4871,  1841,  3340,  1840,  4882,  1841,
    2966,  3568, -2787,  5407,  1032,  3569,  4872,  5042,  1591, -2787,
   -2787,  1297,   777,  1179,  3007,  3008,  2238,  1301,  2239,  2150,
    2858,  1185, -1541,  2272,  3910,  4538,  4873,  1280,  1311,  3020,
    2666,  2301,  4411,  2302,  3054,  5315,  3641,  2206,  2207,  3911,
    5391,  2273,  4823,  1157,  4414,  5851,  5316,  1248,  1860,  5123,
     778,  1842,  5858,  4539,  5125,  2168,  5719,  1842,  2170,  2170,
    4874,  1913,  5120,  1383,  1842,  1307, -2288, -2288,  4415,  5720,
   -1541,  2247,  3369,  2259,   674, -1541,  1842,  1397,   674,  1842,
    3370,  1613,  4420,   674,  1302,  3429, -2445,  1310,  5632,  5721,
    1316,  4131,  1842,  1850,  1851,  1852,  1842,  3642,  5121,  1319,
    1842,  1050,  4425,  3369,  3255,  1330,  1449,  3448,  2240,  4426,
    1406,  4929,  1842,  2949, -1541,  3453,  1842,  2949,  4427,  2164,
    1328,  3761,  4806,  4808,  4808,  2080,  4808,  3022,  3023,  4428,
    1353,  2085,  2086,  2293,  4806,  4806,  4808,  4808,  1614,  1337,
    5078,  1615,  4429,  2956,  1861,  1339,  5083,  5085,  5087,  4875,
    4540,   770,  5154,  5092,  5093,  2894,  4437,  2895,  1407,  5098,
    1364,  3999,  1862,  1408,  5851,  5858,  3112,  5105,  1616,  2282,
    1523,  5110,  2319,  2320,   703,   704,  1617, -2520,  5078, -2520,
    1357,  4706,  5124,  5078,  2369,  2370,  2241,  1741,  2371,  1359,
     841,  5932,  2967,  3930,  1366,  5244,  5245,  3999,  1854,  4850,
    4560,   468,  1409,  4443,  3522,  1756,   779,  2272,  1838,  1839,
    4774,  1760,  1761,  1269,  1367,  3241,  4876,  2505,  1863,  1864,
   -2475,  2337,  2127,  1368,   513,  2273,  1435,   870,  5722,  1937,
    2352,  1248,  1403,  3281,   925,  2030,  3782,  4707,  4936,  3287,
    3296,  3288,  2030,  1867,  1868,  1869,  1870,  1871,  1872,  3302,
    1647,  2030,  1653,  1653,  1653,  4679,  3112,  2259,  1157,  1456,
    3496,  1157,  1441,  1659,  1659,  1659,  2692,  2692,  2692,  2692,
    1157,   871,  3306,  1443,  2030,  3497,  1838,  1839,  5750,  1157,
    3307,  1157,  2030,  1157,  4088,  1157,  1157,  1157,  1157,  1157,
    1157,  1467,  1157,  4187,  4188,  2164,  4448,  4189,  4190,  4191,
    1157,  1473,  1157,  3613,  1474,  1157,  1157,  1157,  1855,  1475,
    3617,  3618,  4350,  5695,  1157,  1157,  1157,  1917,  1157,  1917,
    1157,  4449,  1157,  1856,  1157,  3308,  1157,  2030,  4450,  1657,
    1657,  1657,   818,  4877,  1157,  4878,  1157,  1480,  1157,  1157,
    1157,  1157,  1157,  1487,  3314,  1157,  2030,  1157,  1269,  -922,
    1157,  1483,  4934,  4484,   703,   704,  3736,  5236,  3739,  4458,
    3743,  1494,  3744,  1157,  4810,  4595,  4812,  3745,  1157,  3744,
    1574,  1157,  1938,  1157,  1157,  1157,  4817,  4818,  1157,  3747,
    3789,  3748,  3790,  4424,  1157,  1939,  3811,  1575,  3812,  1157,
    1656,  1656,  1656,  5264,  5041,  1383,  1383,  3428,  1157,  4016,
    1857,  4017,  1576,  2353,  1157,  4109,  1157,  4110,  3438,  1157,
    1834,  1351,  1352,  3032,  1355,  2274,  1356,   513,  1860,  1157,
    4170,  1157,  4171,  1832,    16,    17,  1157,  4463,  1658,  1658,
    1658,  3371,  4317,  5421,  4318,  4438,  3432,  3288,  1577,  3647,
    5212,  4459,  1580,  1940,  5214,  4441,  1591,  2030,  4451,  1193,
    2030,  1840,  1941,  1841,   620,  1838,  1839,  3215,  4462,  5210,
     537,   535,  1157,  4187,  4188,  4815,  4816,  4189,  4190,  4191,
    5355,   544,  2590,  2591,   513,  4930,  4931,   508,  4455,   677,
    4456,   511,  4784,   677,  4785,  4879,  4880,   485,   677,  1894,
    1157,   692,   486,  1269,  1223,  4523,  4837,   487,  4838,   540,
     488,  1860,  5197,   538,  4948,  1233,  2209,  2209,  2209,  2209,
    3064,  1194,  1838,  1839,  1861,  2956,  3726,  4689,  4466,  1610,
    4908,  1157,  2030,  5159,  4479,  5160,  5161,  1612,  5162,  4025,
    3079,  5202,  1862,  1227,  5163,  3435,  5164,   542,  5204,  3084,
    2030,  1860,  5219,  5208,  5220,  3086,  5217,   513,  5389,   712,
    1157,  1620,  1157,  3095,  4331,  4706,  4333,  4421,  1621,  5218,
    3827,  1618,  2060,  5222,  5865,  3107,  4617,  5223,  3109, -2445,
    1842,  1231,  5227,  3437,  2030,  3828,  5240,  1860,  5241,  5556,
    5668,  1623,  4795,  5631,  4798,  5371,  4801,  1629,  1863,  1864,
    2451,  2470,  2471,  2472,  2473,  1632,  3033,  1861,   541,  2274,
    2014,  3829,  2352,  1633,  5076,  1942,  2022,  5669,  1634,  2966,
     717,  4707,  1635,  3830,  5562,  1862,  5056,  5255,  5058,  5256,
    1157,  5061,  2452,  5266,  5065,  5267,  2956,  5068,  5069,  1637,
    1840,  1943,  1841,  3831,  3496,  1643,   543,  1861,  2453,  1674,
    5306,  1157,  4110,  4881,  1694,  2474,  2475,  2476,  5410,  3497,
    3032,  1838,  1839,  3034,  2005,  1862,    16,    17,  1654,  1695,
    1664,  1665,  1666,  5108,  1752,  3832,  1667,  3833,  1670,  4148,
    1232,  1863,  1864,  1861,  2266,  1696, -1170,  1449,  1449,  1449,
    1449,  1701,  2454,  3962,  1702,  1917, -1170,  1840,  1397,  1841,
    1703,  1862,  1195,  1196,  1704,  4148,  4148,  1705,  1798,  2477,
    2478,  5437,  1197,  4550,  5541,  3429,  5542,  1709,  2653,  1917,
    2455,  1863,  1864,  2352,  3716,  4708,  1711,   703,   704,  4266,
    1269,  1198,  5670,  -922,  2966,  1712,  5671,   703,   704,  1713,
    4709,  1157,  5582,  1714,  5583,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  5586,  5615,  5583,  4110,  1863,  1864,  1842,
    5652,  1804,  2956,  5729,  5616,  1715,  4110,  5732,  4179,  3035,
    5652,  4148,  4148,  1716,  2202,  3032,   725,  5728,  1717,  5583,
    2479,  5783,  1874,  5784,  2214,  2353,  1449,  1718,  5547,  1569,
    1719,  1720,  2219,  6022,  5814,  4042,  5815,  1721,  1838,  1839,
    1573,  4848,  4660,  4661,  1722,  1723,  4662,  4663,   537,  1860,
    3948,  2967,  4664,  4665,  1838,  1839,  1842,  2456, -1886,   544,
   -2445,  2692,  2692,  4624,  1726,  1875,   729,  2451,  1570,  5825,
    4043,  5826,  1736,  3834,  5653,  5844,  1840,  4171,  1841,  3716,
    1944,  1269,  1737,  3033,  5653,  3835,  1738,   540,  4710,  2352,
    1739,  3091,  2480, -1885,  4861,  5568,  1742,  1743,  5654,  2452,
    5879,  1858,  5241,  2163,  1744,  1876,  1572,  3622,  1838,  1839,
    1157,  5403,  5963,  5798,  4957,  4141,  1653,  2956,  1877,  1745,
      16,    17,  1746,  1157,  2130,   542,  1157,  1659,  1878,  5967,
    5672,  5583,  5969,  1747,  5583,  2131,  2353,  2330,  5970,  2330,
    5583,  4689,  2908,  1838,  1839,  1861,  5988,  1346,  5989,  5845,
    1157,  1157,  5562,  1222,  1748,  1749,  1945,  1199,  2389,  4142,
    1230,  1750,  4909,  1862,  1946,  1751,  2967,  1571,  1753,  3941,
    5655,  5693,  3620,  1882,  5997,  1157,  5998,  1157,  1754,  1157,
    5655,  1157,  6025,  6026,  5583,  5583,   541,  4143,  2481,  6029,
    3836,  5583,  3837,  1657,  3274,  1842,  1755,  5819,  3033,  6032,
    1157,  5241,  5985,  1762,  2352,  5487,  5488,  1269,  5490,  6066,
    6115,  5583,  6116,  1840,  1763,  1841,  1764,  1673,  1880,  1863,
    1864,  1157,  1157,  3032,   543,  1765,   791,  5343,  1157,  1840,
    1157,  1841,  1157,  1766,  1767,  2909,  1768,  1157,  1769,  1770,
    1771,  1772,  1775,  1776,  4163,  4164,  4165,  4166,  1777,  4168,
    4169,  1778,  1779,  5761,  1656,  1780,  2482,  1838,  1839,  4439,
    1781,  1784,  2353,   797,   799,  1785,  2135,   799, -2445,  1786,
     808,   814,  1838,  1839,  4442,  1157,  1157,  4331,  1787,  4333,
    1788,  5656,  1228,  1840,  4144,  1841, -2695,  5040,  1789,  1790,
    1157,  5656,  1658,  1791,  1886,  3211,  5051,  4287,  4288,  3623,
    4290,  1792,  4292,  4293,  4294,  4295,  4296,  4297,  4298,  1793,
    4300,  1157,  1794,  4305,  1795,  1838,  1839,  4308,  1840,  1897,
    1841,  2483,  1269,  2484,  5060,  2956,  1229,  2209,  2485,  1796,
      16,    17,  1842,  1887,  1797,  1799,   814,  5827,  1800,   513,
    1801,  1697,  1802,  3838,  1898,  3624,  4557,  2567,  1842,   814,
   -1170,  1803,  4985,  1899,  4709,   808,  2576,  1867,  1868,  1869,
    1870,  1871,  1872,  1200,  1201,  1202,  1203,  2587,  1900,  1805,
    1806,  1807,  1808,  1809,  4266,  4266,  1810,  2353,  1811,  1180,
    4044,  1814,   739,   740,  5622,   808,  5623,  5624,  1225,  1815,
    1818,   703,   704,  2486,  1819,  4131,  1838,  1839,  1820,  4431,
    3826,  1294,  1842,  1821,  1822,  1823,  3033,  1157,  1824,   808,
    5819,  1825,  2352,  4315,  1881,  1907,  1935,  1157,  1954,   741,
    6127, -2729,  1313,   808,  5652,  3625, -2730,  4045, -2694,  1157,
    1932,  1157,  1840, -2726,  1841, -2724,  2487,  1842,  1865,  1866,
    1867,  1868,  1869,  1870,  1871,  1872, -2728,  1840,  5674,  1841,
    1936,  3839, -2723,  5063, -2727,  1360, -2721,  2163,  2163,   742,
   -2725,  1955,  4710,  3034,  5925,  5698,  5699,  1407,  1969,  1970,
    1971,   791,  1449,  1449,  1972,  1992,  1993,  1998,  5668,  1866,
    1867,  1868,  1869,  1870,  1871,  1872,  2004,  3626,  1432,  2010,
    1840,  4046,  1841,  2017,  2061,  2030,  1439,  2742,  5653,  2071,
    3840,  2746,   808,  2748,  1455,  5669,  3627,  3628,  -949,  2073,
    2077,  3629,  3630,  3631,  1865,  1866,  1867,  1868,  1869,  1870,
    1871,  1872,  5654,  3841,   808,  2083,  2488,  2091,  4775,  2084,
    1269,  5668,  2090,  1479,  2093,  4047,  2115,  2489,  5657,  5993,
    2095,  2099,  2116,  2117,  2127,   791,  5172,  1455,  2780,  2138,
    2139,  1842,  4266,  2142,    16,    17,  2155,  2152,  5669,  2790,
    2165,  2166,  2187,  2188,  2194,  2200,  1842,  2198,  2203,  3035,
    2803,  1840,  2204,  1841, -1170,  2208,  2220,  2224,  2232,  3632,
    4520,  1588,  2249,  1590,  5366,  2353,   799,   799,   799,   799,
    1598,  1455,  2252,   808,  5655,  2253,  2254,  2263,  2267,  6109,
    2259,     4,  2289,  2296,  2305,  6039,  3761,    16,    17,  1842,
     944,  2312,  6005,  6119,  4148,   703,   704,  2313,  2327,  6109,
    5670,  3713,  2324,   562,  5671,  6119,  2329, -1170,  3633,  2331,
   -3449,  2337,     8,  2341,  2343,  2345,  2348,  2356,   743,  2362,
    2363,  2365,  1838,  1839,   791,  2366,  1663,  2367,  5652,  5332,
    2397,  2388,  5335,  5336,  1668,   744,  1671,  2410,  2412,   945,
    2413,  1157,  2415,  1838,  1839,    14,  2877,  2414,   703,   704,
     946,  1680,  2417,  5670,  2418,  5993,  2421,  5671,  2420,  2425,
     745,  2433,  2434,  1397,    18,  2443,  2450,   638,  2461,  4618,
    1842,  4048,  4049,  4050,  1397,  1397,  2465,  2493,  2504,   947,
    3942,  5652,  2505,  2515,  2519,  5656,   948,  2522,  2506,  2523,
    1838,  1839,  2545,  2575,  2581,  5413,  1157,  1157,   984,  1157,
     746,  2610,  5653,    23,  2585,  2595,  2628,  2942,  3875,  2606,
    1157,  1157,  1157,  2632,   703,   704,  1865,  1866,  1867,  1868,
    1869,  1870,  1871,  1872,  2660,  1157,  5654,  1157,   949,  3877,
    2659,  2684,  2451,   639,  2685,  2686,  5149,  1001,  2689,  2690,
    1157,  1157,  2698,  2705,  2702,  2709,  2734,  2736,  2737,  -924,
    2757,  2772,  4687,  2943,  2773,  5653,  2774,  2986,  5672,   563,
    2775,  2777,  2778,  2779,  2452, -2300,  1006,  1157,  2794,  1008,
    2797,  2798,    31,  2805,  1157,  2806,  3879,   950,   951,  5654,
    4141,  2809,  2807,  1157,  2808,  1012,  1013,  2816,   755,  2817,
    2818,   952,  2827,  2828,  2944,  2829,  2830,  1840,  5655,  1841,
    2831,  1835,  2129,  5804,  2835, -3482,  2841,  2832,  -924,  2834,
     640,  5672,   756,  2842,  1223,  2845,  2846,  2850,  1840,  2855,
    1841,  2866,  2888,   641,  4142,  1233,  1157,  2862,  2890,  1020,
    1157,  3496,  2904,  2891,  2892,   756,  2481,  2893,  1163,  2906,
    5797,  2905,  2918,  2896,  2914,  1164,  3497,   513,  1026,  2921,
      42,  5655,  4143,  1227, -1200,  2919,  1031,  1032,  2922,  2928,
    2930,  1165,   808,   791,  2933,  1840,   870,  1841,  2934,  2941,
    2964,  1166,  1167,  1168, -2711,  2979,  -924,  2130,  2987,  4687,
     564,  1169,  2992,  2988,  2996,  2993,  5683,  2997,  2131,  1904,
     642,  1231,    75,  4266,  5604,  2132,   808,  3029,   808,  3046,
    3075,  3048,   808,   808,  2482,  3135,  2318,  3101,  5503,  5656,
     871,  3153,  3153,   953,  3153,  3153,  1842,  2945,  3072,  3108,
    -924,  3085,  3119,  3118,  3123,  1409,  3127,  2133,  3130,  2946,
    5673,  3133,   808,  3167,  3136,  -924,  3143,  1842,  3148,   756,
    4639,  3168,  5657,  1647,  3189,  1048,  3190,  3207,  3209,  4144,
    3210,  2164,  3212,  1049,  1050,  1051,   565,  3221,  3496,  3222,
     757,  5057,  5656,  6091,  3223,  3226,  3227,  3229,  3239,  2483,
    2009,  2484,  3242,  3497,   791,  5073,  2485,  3246,  3057, -3482,
     791,   791,  2024,   757,  1842,   954,  3249,  3258,  2134,  3259,
    1232,  3261,  5094,  5908,  -924,  3262,  3263,     4,  2065,  3297,
    3267,   870, -2253,  3275,  4179,   566,   944,  2075,  3300,  3279,
    5112,  3301,  5113,  5114,  3310,  3327,  3348,   758,  3320,  2135,
    1170,   791,  2088,  3324,  3325,  3332,  3331,  5945,     8,  3344,
   -1678,  2947,  3353,  3359,  1171,  1872,  3366, -1855,  3368,  4688,
    3375,  2486,  2101,   643,  4266,   871,  1782,  -924,  3382,  1812,
    1816,  3387,  3391,   567,  3393,   945,  3395,  1157,  1157,  2129,
    3396,    14,   791,  2126,  3410,   564,   946,  3411,  3415,   644,
    3419,  5414,  5099,  3454,  2129,  3402,  5674,  3416,  3458,  5415,
      18,   513,  2149,  4520,  2487,  3420,  3421,   757,  4689,  3422,
    3445,  3466,  3423,  3469,  3424,   947,  3470,  2169,  3502,  3503,
    5173,  3531,   948,  2948,  3533,  3534,  4927,  3535,  3538,  3539,
    3567,  3574,  3309,   513,  3578,  2177,  2178,   645,  3315,    23,
     511,  -924,  3592,  3598,  2196,  3602,   955,  3605,  3609,  5674,
    3610,  3611,  3612,  3614,  2130,  1172,  1157,  3615,   791,  3616,
    3667,   565,  3670,  3673,   949,  2131,  3677,   808,   791,  2130,
    3680,  3683,  2132,  3684,  3685,   799,   791,  3707,  3708,   791,
    2131,  3686,  3687,  5777,  3688,  3689,  5657,  2132,  3715,   791,
    3690,  3691,  1173,  5726,  2488,  3692,  3693,  3732,  3694,  4964,
    3695,   870,  3696,  3733,  2133,  2489,  1174,  3697,    31,  5609,
    3761,  5777,  1157,   950,   951,  3698,   870,  4643,  3699,  2133,
    3700,  3701,  3702,  3703,   568,  3734,  3704,   952,   569,  3705,
    1157,  1157,  3579,   -73,  3706,  4689,  3735,  3740,  3741,  5657,
    3752,  3736,  3773,  1894,  3737,   871,  3771,  3739,  1157,  4775,
    3774,  3153,  3153,  3153,  3153,  3751,  3777,  2242,  3786,  3792,
     871,  3806,  3796,  1157,  3807,  2134,  3797,  3794,  3795,  3798,
     570,  3799,  3802,  3808,   646,  3809,  3849,  3850,  2328,  5028,
    2134,   791,  4266,  2336,  4266,  3816,    42,  3851,  3862,  3863,
    3864,  3870,   647,  2346,   799, -1894,  2135,  3937,  5323,  3883,
     571,   808,  1157,  5326,  1157,   808,   791,  3906, -3482,  3907,
    3919,  2135,  3921,  6123,  3922,  3938,  3944,  5260,   901,  5324,
    3945,  4690,  3954,  3946,  3960,  2164,  2164,  3376,    75,  3963,
     808,  3956,  3967,   808,   648,  3968,  3580,   649,  3463,  3969,
    5726,  3970,  5095,  5096,  4345,  5777,  3980,  3974,  3981,   953,
    2719,  2718,   902,  3988,  3993,  4002,   870,  3112,  5111,  4018,
      43,  2411,  4028,  4029,   650,  3493,  4032,  4035,  4065,  4040,
    4066,  4041,   651,  4068,   904,  4072,  4073,  4099,  4100,  4103,
    4104,  4129,  5142, -2200,   905,  4137,  4138,  4182,  4183,  4573,
     791,  4184,  4269,  4273,  4281,   759,  4574,  4282,  4313,  4284,
     871,  4338,  4344,  4347,  5416,  4354,  3128,  5417,  4348, -2253,
     906,  1917,  4575,  -172,  4359,  4362,  5418,  4367,  4366,  4368,
    4380,   954,  4576,  4577,  4578,  4375,   907,  4387,  4389,  4691,
    4396,   908,  4579,  3550,  4397,  4404,  4401,  4405,  1569,  3584,
    4406,  4454,  3559,  4407,  4467,  4465,  1397,  4491,  4690,  1573,
    4477,  4478,  1397,  4483,  4493,  4494,  4503,   909,   649,  4482,
    4501,  4504,  4505,   984,  4507,  4508,  4512,  1397,  4511,  4526,
    4513,  4530,  4527,  4551,  1157,  4544,  4549,  1570,  4553,  4550,
    4554,  4556,  6120,  4561,  4572,   760,  4555,   513,  1653,  4564,
    4570,   791,  4590,  4591,   793,  4592,  4593,  4594,  4597,  1659,
     791,  4603,  1001,  1157,  4620, -1980, -1985,  4646,  3607,  3608,
    4651,   791,  4654,  4655,  4658,  1572,  4673,  4659,  4668,  4686,
    4689,  4702,  2599,  4704,  4705,  3619,  4714,   910,  1157,  4716,
    4717,  1006,  4728,  4733,  1008,  3645,  3646,  4736,   808,  4738,
    4739,  4740,  4742,  4743,   911,  4751,  4752,  4753,  4754,  4762,
    1012,  1013,   912,  4780,  4775,  4788,  4691,  4825,  4820,  4828,
    4826,  4831,   955,  4840,  4842,  1657,  4853,  4856,  4865,  4864,
    4857,  4580,  3336,  1569,  4472,   808,  1571,  2658,  4900,  4910,
    4912,  4117,  4913,   913,  1573,  4581,  4917,  4916,  2668,  4920,
    4946,  4947,   914,   915,  1020,  4956,  4957,  4961,  4962,   808,
     808,  3709,  3710,  3711,  3712,  4963,  5298,   749,  4966,   808,
    2708,  4978,  1570,  1026,  4209,  4993,  4992,  4998,  -301,   808,
    5003,  1031,  1032,  5005,  5019,  2655,  1656,  5030,  1157,  5032,
    5031,  5042,  5062,  2730,  1904,  5044,  5067,  5066,  5136,   799,
     799,   791,   799,   799,   799,   791,   808,   791,  5139,  5147,
    1572,  5144,  5150,   799,  5151,  5157,  5158,  5166,  5174,  5175,
    5178,  5176,  5186,  5188,  1658,  5193,  5194,  2765,   799,  5726,
     808,  4582,  5198,  5205,  5206,  5207,  5211,  5213,  5349,  5216,
    5225,  5228,  5234,  5226,  1397,  5242,  4583,  3779,  5247,  5252,
    5248,  5257,   791,  5262,  5253,  5263,  6023,  5291,  5296,  1157,
    5300,  5301,  5303,   791,  5305,  5356,  5310,  5312,  3153,  5311,
    1048,  1571,  1895,  5313,   791,  5319,  5322,  5320,  1049,  1050,
    1051,  5325,  5321,  4584,  5264,  5328,  1157,  5329,  5330,  5345,
    5346,  5351,  5357,  5354,  4267,  5362,  2379,  4585,  5267,  5372,
    5374,  2380,  5376,  5395,  5398,  5396,  5399,  5401,  5405,  5406,
    5409,  5423,  2381,  1569,  5412,  5426,   808,  5438,  5436,  5373,
    5447,  5463,   513,  5446,  1573,  5469,  5439,  5471,  1569,  5473,
     791,  5484,  2033,  5478,  5470,  2854,  4318,  5480,  5489,  1573,
    5491,  5494,  5492,  5496,  5506,  5498,  5501,  5522,  5527,  5530,
    5665,  5045,  1570,  5534,  5665,  5548,   808,  5557,  5643,  5550,
    5558,  5563,  5564,   808,   808,   808,  5565,  1570,  5567,  5569,
     791,  5579,   799,  5580,  5596,  5585,  5587,  5597,  5599,  5602,
    5625,  5640,  5641,  5650,  5685,  5681,  5684,   791,  5630,  5666,
    1572,  5686,  5644,  5666,  5692,  5701,  5414,  5710,   791,   791,
    5711,  5714,  5731,  5756,  5415,  1572,   808,  1157,  4215,  5757,
    5782,  5758,  1653,  5788,  5790,  5759,  5792,  5767,  5769,  6126,
    5770,  5795,  5796,  1659,  5794,    16,    17,  5800,  5802,  5801,
    5803,  5808,  5810,  5812,  3000,  5813,  5816,  5822,  5843,  5828,
    5832,  5835,  5840,  5860,  5855,  5899,  5869,  5880,  5861,  5881,
    5882,  1571,  5863,  5885,  5891,  5900,  5912,  5927,  5938,   808,
    5907,  5951,  5954,  5960,  5959,  5961,  1571,  5962,   866,  4205,
    5966,  2382,  5971,  4216,  5979,  6018,  3001,  6036,  6037,   874,
    5665,   791,  6035,  6048,  6012,  2990,  6061,  6059,  6051,  1657,
    6068,  6069,  2383,  6075,  6070,  6083,  6078,  2384,  5665,  6082,
    6081,  5780,  6088,   791,  6090,  6092,  6095,   869,  3961,  6122,
    6110,  3977,  1838,  1839,  3153,  6096,  3002,  3501,  4307,  5666,
    5384,  1675,  5386,  5593,  5385,  1988,  5600,  5591,  2385,  5780,
    5590,  4076,   808,  5727,  5594,  4666,  5752,  5666,   808,  5474,
    5873,  1157,  6024,  1378,  4619,   873,  2199,  4077,  5297,  5606,
    1656,  4805,  5955,  5953,  4342,  2250,  2470,  2471,  2472,  2473,
    2386,  4360,  5251,  1498,  4821,  3113,  2676,  2034,  3512,  4587,
    4384,  1687,  5184,  4830,  3098,  3682,  1486,  4950,   662,  2653,
    3201,  3204,  3202,  3132,  3203,  2978,  5589,  4765,  1658,  5853,
    2246,  5588,  5853,  5449,  4250,  5353,  4919,  4924,  5911,  5235,
    5425,  3380,  1588,  5570,  3129,  5987,   872,  5430,  6077,  3131,
    2474,  2475,  2476,  6055,  6079,  5842,  3542,  5055,  4763,  5999,
    5735,   791,   791,  5131,  5445,  5327,  4770,  5665,  3145,  6043,
    5890,  5799,  5902,  1157,  1834,  3154,  3154,  4395,  3154,  3154,
    3746,  5904,  5909,  3065,   543,  5515,  3073,  1832,  4469,  4903,
    4901,  4905,  6064,   808,  6030,   763,   764,   791,  6031,  5633,
    5947,  6003,  5944,  5497,  2477,  2478,  5666,   791,  1157,  5495,
    5730,  3083,  4596,  5129,  3191,  4767,  5647,  2033,  2002,  2215,
    4095,  4057,  2863,  3196,  4056,  5906,  3198,  1840,  3676,  1841,
    5514,  1397,  3031,  3492,  3390,  1397,  4377,  3803,   792,  4841,
    1405,  3925,  4009,  2173,  2128,  5853,  1902,  2172,  4128,  5416,
    5853,  4827,  5417,  3971,  5952,  4915,  3886,  5853,  3884,  2593,
    2035,  5559,  4496,  4914,  2503,  5665,  2656,  2120,  2913,  2910,
    5486,  2121,  2122,  2123,  2036,  2479,  2037,  5309,  2440,  4939,
    5877,  5254,  2924,  5878,  2125,  2903,  4490,  2449,  4126,  3594,
    5926,  4150,  4151,  5023,  4153,  4155,  5022,  4489,  5420,  5520,
    5821,  5246,  5411,  4127,  5666,  2167,  5431,  2038,  1157,  1423,
      16,    17,  2180,  5026,   774,  1157,  3586,  3769,   765,  2390,
    2800,  3801,  2039,  4027,  5249,  5259,  4161,  4938,  4935,  1292,
    5984,  3126,  3460,  4003,  5853,  1583,  2763,  1274,  6004,  1589,
    3461,  1277,  5665,  5665,  2174,   789,  1842,  2480,  5521,  3506,
    5435,  4845,  2395,  2853,  6076,  2040,  5314,  6089,  5493,  6121,
    6125,  4943,  1758,  5791,  1688,  3473,  4932,  5853,  3992,  5853,
    5853,  3923,  1235,  2041,  3003,  3347,   791,  4775,  1236,  3441,
    3186,  3782,   791,  3987,  3986,  4314,  2870,  1896,  2697,  2387,
    4674,  1192,  3964,  3666,  4363,  5029,  5549,  4776,  3330,  4067,
    1327,   783,  5665,  2076,  3004,  3005,   767,  3006,  3007,  3008,
    3009,  3010,   768,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
    3018,  6058,  3019,  3020,  3021,   769,  5853,     0,  1397,  5853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4775,     0,  2481,     0,     0,     0,  6054,     0,     0,
       0,  1157,  2034,     0,  2042,     0,     0,     0,     0,  4378,
       0,  2043,     0,     0,     0,     0,  5853,     0,     0,     0,
       0,  2044,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2045,   808,   808,   791,     0,     0,
       0,   808,     0,     0,     0,  3154,  3154,  3154,  3154,     0,
       0,     0,     0,  3406,  3407,  5897,  1904,     0,     0,     0,
     808,  2482,     0,     0,     0,  2046,     0,     0,  2047,     0,
       0,  3022,  3023,     0,     0,     0,  1157,     0,     0,     0,
       0,     0,     0,     0,  2048,     0,     0,     0,     0,  3446,
     799,  5920,  5921,     0,     0,     0,     0,     0,     0,     0,
     663,  6112,   799,     0,  2399,  5939,     0,  6114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2483,     0,  2484,     0,
       0,     0,   791,  2485,     0, -2067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2009,  3475,
       0,     0,     0,     0,     0,  2035,     0,   808,  3491,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2036,
       0,  2037,     0, -2067,     0,     0, -2067,  5994,     0,     0,
    5995,     0,     0,     0, -2067,     0, -2067,     0,   791,     0,
       0,     0,     0, -2067,     0,  3519,     0, -2067,  2486,   791,
       0,     0,  2038,  6010,     0,     0,     0, -2067,     0,     0,
   -2067,     0,     0,     0, -2067,     0, -2067,  2039,     0,     0,
       0, -2067,     0,     0,  3547,  3548,  3549,   791, -2067,   799,
       0,   799,     0,     0, -2067,     0,   791,  3561,   799, -2067,
     791,  2487,     0,     0,     0,     0,   791,     0,     0,     0,
    2040,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2067,   791,     0,     0,     0,  3582,     0,     0,  2041,  2149,
    3587,     0,     0, -2067,     0,     0,     0,     0, -2067,  4604,
    4605,     0,     0,     0,     0,     0,     0,     0,     0, -1136,
       0, -1136,     0,     0,     0,     0,     0,     0, -2067,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,  1397,     0,     0,     0,     0,     0,     0,  2188,     0,
       0, -2067,     0,     0,     0,     0,     0,     0,     0,     0,
   -2067,  2488,   808,     0,     0,     0,     0,     0,   791,     0,
       0,     0,  2489,     0,     0,     0,     0,     0,     0,  2042,
       0,     0, -2067,     0,     0,     0,  2043,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2044,    16,    17,     0,
   -2067,     0,  4204,     0,     0,     0, -2067, -2067,     0,  2045,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2067,     0, -2067,     0,     0, -2067,     0,     0,     0,  3731,
       0,     0,     0,     0,     0,     0,     0,     0,  3738,     0,
    2046,     0,     0,  2047,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4715,     0,     0,  4718,     0,  2048,
    4724,  4725,  4726,  4727,     0,  4729,  4730,  4731,  4732,     0,
    4734,  4735,     0,  4737,     0,     0,     0,  4741,     0,     0,
    4208,  4744,  4745,  4746,  4747,     0,  4749,  4750,     0,     0,
       0,  3762,  4755,  4756,     0,     0,  4760,  4761,     0,     0,
    3770,     0,  3772,     0,     0,     0,     0,     0,   791,     0,
    4197,   791,  4198,  4199,   808,     0,   808,   808,     0,     0,
       0,     0,     0,     0,     4,     0,     0,     0,     0,   808,
       0,     0,  3154,   944,     0,     0,  4200,     0,  4201,     0,
       0,  4211,  4212,  4213,  4202,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     8,     0,     0,     0,     0,
       0,     0,     0,     0,  4214,     0,  2188,     0,     0,     0,
   -2067,  -340,     0,  -340,     0,     0,     0,     0,  4203,     0,
       0,     0,   945,     0,     0, -1292,     0,     0,    14,  4215,
       0,     0,     0,   946,     0,     0, -1292,   808,     0,   808,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
    4204,  4217,   947,  4218,     0,     0,     0,     0,     0,   948,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1136,     0,  4219,     0,     0,     0,    23,     4,     0,     0,
       0,  4205,     0,     0,     0,     0,   944,     0,     0,     0,
       0,  4221,     0,     0,     0,     0,     0,     0,  4222,     0,
       0,   949,     0,     0,     0,     0,     0,     0,     8,     0,
       0,     0,     0,  4223,     0,     0,  4206,     0,     0,     0,
    4207,  4224,     0,     0,     0,     0,     0,     0,  4208,     0,
       0,  4209,     0,     0,     0,   945,  4228,     0,     0,     0,
       0,    14,     0,  3908,     0,    31,   946,     0,     0,     0,
     950,   951,     0,     0,  4210,     0,     0,     0,     0,     0,
      18,     0,     0,     0,   952,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   947,  3936,     0,     0,     0,
       0,     0,   948,     0,     0,     0,     0,     0,     0,  4211,
    4212,  4213,     0,     0,  4232,     0,     0,     0,     0,    23,
       0,     0,   791,     0,  4233,     0,   808,   808,  3154,     0,
       0,     0,  4214,     0,     0,     0,     0,     0,     0,     0,
       0,  -340,   808,    42,   949,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4215,     0,     0,
       0,  4234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4235,  1225,     0,     0,     0,     0,
       0,  4216,     0,     0,     0,    75,     0,     0,    31,  4217,
    4967,  4218,     0,   950,   951,  4979,     0,  2599,     0,     0,
       0,     0,     0,     0,     0,     0,   953,   952,  4024,     0,
    4219,     0,     0, -2067,     0,  4237,     0,  4220,     0,     0,
       0,  4238,     0,     0,     0,     0,  2400,     0,     0,  4221,
       0,     0,     0,     0,     0,     0,  4222,     0,     0,     0,
       0,     0,     0, -2067,     0, -2067,     0,     0, -2067, -2067,
       0,  4223,     0,     0,     0,     0,     0,     0,     0,  4224,
       0,  -340,     0,  4225,  4226,     0,    42,     0,     0,     0,
    4227,     0,     0,     0,  4228,     0,     0,     0,   954,     0,
    4243,     0,  4229,     0,     0,     0,     0,  4244,     0,   799,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,  4230,     0,     0,   791,     0,     0,    75,   791,
    5081,     0,     4,  5070,     0,   808,     0,     0,  4245,     0,
       0,   944,     0,  2658,     0,     0,     0,     0,  4231,   953,
       0,     0,  4232,  4246,  4247,  5097,     0,     0,   808,   808,
       0,     0,  4233,     8,     0,     0,  4248,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     945,     0,     0,     0,     0,     0,    14,     0,     0,  4234,
       0,   946,     0,     0,  1672,     0,     0,     0,   808,     0,
       0,     0,  4235,     0,  4236,    18,     0,     0,     0,     0,
       0,   954,     0,     0,  4271,     0,  1500,  1501,     0,  4982,
     947,     0,  1502,  1503,     0,     0,     0,   948,     0,   955,
       0,     0,  1504,     0,     0,     0,     0,     0,     0,     0,
    1237,     0,     0,  4237,    23,     0,     0,     0,     0,  4238,
       0,   669,     0,     0,     0,     0,     0,     0,  1505,     0,
       0,     0,     0,     0,     0,     0,  1209,     0,     0,   949,
    1506,     0,     0,     0,  1238,  1239,  4239,     0,     0,     0,
       0,     0,     0,     0,  1240,     0,     0,  4240,  4241,  4242,
    1507,     0,  4343,     0,     0,     0,     0,     0,     0,    10,
      11,     0,     0,     0,     0,     0,     0,     0,  4243,     0,
       0,     0,   791,    31,     0,  4244,     0,     0,   950,   951,
       0,     0,     0,     0,  1508,     0,     0,     0,     0,     0,
       0,  3145,   952,     0,     0,     0,  2178,   808,   808,   808,
     808,     0,     0,   791,    16,    17,  4245,  1509,  1510,  1241,
    1511,     0,   955,     0,  4385,     0,     0,     0,  1512,  1513,
    1514,  4246,  4247,  1242,     0,     0, -1136,     0, -1136,     0,
       0,     0,     0,     0,  4248,  5268,     0,  4249,  1515,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,  2188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1516,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1243,     0,     0,     0,
       0,     0,     0,    75,     0,     0,     0,  1517,     0,  1244,
       0, -1292,     0,  1518,    16,    17,     0,     0,  4464,  4204,
       0,     0,     0,     0,   953,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1519,  1520,  1521,
    4606,     0,  4607,     0,  4608,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4500,     0,     0,
       0,  1522,  1523,     0,     0,     0,     0,  1245,     0,     0,
       0,   808,     0,     0,     0,     0,     0,     0,   808,   808,
     808,   808,     0,  4521,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,  4208,     0,  4531,
    4532,     0,     0,  5364,     0,     0,     0,     0,     0,     0,
       0,     0,  1524,     0,  1525,  1526,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4552,     0,
    1527,     0,     0,     0,     0,     0,  1246,  2599,     0,     0,
       0,     0,     0,  4569,     0,  1247,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1248,  4211,  4212,
    4213,     0,     0,     0,     0,     0,     0,  1528,  1249,  1529,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,  4214,     0,   791,   791,     0,     0,     0,     0,     0,
    1530,     0,  1250,     0,     0,     0,     0,     0,   799,     0,
       0,     0,     0,     0,     0,     0,  4215,     0,     0,     0,
       0,     0,     0,  1531,   791,   791,     0,     0,     0,     0,
       0,  4648, -2445,  1251,  1532,  1533,  1252,     0,  1253,     0,
       0,     0,     0,     0,     0,     0,     0,   955,  4217,     0,
    4218,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1254,  1255,  1534, -1136,     0,  4219,
       0,     0,  1256,  1257,     0,  1535,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4221,  1258,
       0,     0,     0,     0,     0,  4222, -1136,     0, -1136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4223,  1259,     0,     0,     0,     0,     0,     0,  4224,     0,
       0,  1536,  1537,  1538,     0,  2188,     0,     0,     0,  1539,
    1540,     0,  1260,  4228,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,  1542,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4759,     0,     0,
    1543,  1544,     0,  5551,    16,    17,     0,     0,     0,  4204,
       0,     0,  4773,     0,     0,     0,     0,     0,  1261,  1545,
       0,  4232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4233,  1262,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1263,     0,     0,  1264,  1265,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1266,     0,     0,  4802,     0,     0,     0,  4234,  3731,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4235,     0,     0,     0,     0,     0,  4208,     0,     0,
       0,     0,     0,     0,     0,     0,  3762,  1267,     0,  4822,
       0,     0,  4824,     0,  1268,     0,     0,     0,     0,     0,
       0,  1547,     0,     0,  1548,     0,     0,  1549,   808,     0,
       0,     0,  4237, -3231,     0,  1269,     0,     0,  4238,  5645,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1550,     0,     0,     0,     0,     0,     0,     0,  4211,  4212,
    4213,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2188,
       0,  4214,     0,     0,     0, -3231,     0,     0,     0,     0,
       0,  1270,     0,     0,     0,     0,     0,  4243,     0,     0,
       0,     0,     0,     0,  4244,     0,  4215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4898,     0,    16,    17,
       0,     0,     0,  4204,     0,  4245,     0,     0,  4217,     0,
    4218,     0,     0,  4907,     0,     0,     0,     0,     0,     4,
    4246,  4247,     0,     0,     0,     0,  4521, -1136,   944,  4219,
       0,     0,     0,  4248,     0,     0,     0,     0,     0,  4500,
       0,     0,     0,   808,   808,     0,     0,     0,  4221,  4928,
       8,     0,     0,     0,     0,  4222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1225,  1904,     0,     0,     0,
    4223,     0,     0,     0,     0,  2599,     0,   945,  4224,     0,
       0,  4208,     0,    14,     0,     0,  4024,  4945,   946,     0,
       0,     0,     0,  4228,     0,  4955,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5833,  5834,   947,  5836,  5837,
    5838,  5839,     0,     0,   948,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,  4773,  5872,   791,
       0,    23,  4211,  4212,  4213,     0,     0,     0,     0,     0,
       0,  4232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4233,     0,     0,     0,  4214,   949,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3582,     0,     0,
       0,     0,     0,     0,     0,     0,  2658,     0,     0,     0,
    4215,     0,     0,     0,     0,     0,     0,     0,  4234,     0,
       0,     0,     0,     0,   808,     0,     0,     0,     0,     0,
      31,  4235,     0,     0,     0,   950,   951,     0,  4773,     0,
       0,     0,  4217,     0,  4218,     0,     0,     0,     0,   952,
       0,  5919,     0,     0,  5922,  4955,     0,     0,     0,     0,
       0,     0,  5930,  4219,     0,     0,  5072,  5940,  2599,     0,
       0,     0,  4237,     0,   791,     0,     0,     0,  4238,     0,
    5090,     0,  4221,     0,     0,     0,     0,     0,     0,  4222,
       0,     0,   808,  4955,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4223,     0,     0,     0,    42,     0,
       0,     0,  4224,  4955,     4,     0,     0,     0,     0,  4773,
    5132,     0,     0,   944,     0,  5143,     0,  4228,     0,     0,
       0,   799,     0,     0,     0,     0,  5153,  4243,     0,     0,
       0,     0,     0,     0,  4244,     8,     0,  1500,  4319,     0,
      75,     0,     0,  1502,  1503,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,  5167,     0,     0,     0,     0,
       0,   953,   945,     0,     0,  4245,     0,     0,    14,     0,
       0,     0,     0,   946,     0,  4232,     0,     0,     0,  1505,
    4246,  4247,     0,     0,     0,  4233,     0,    18,     0,     0,
       0,  1506,     0,  4248,     0,     0,     0,     0,     0,     0,
       0,     0,   947,     0,     0,     0,     0,     0,     0,   948,
       0,  1507,     0,     0,     0,     0,  3785,     0,     0,     0,
       0,     0,  4234,     0,     0,     4,    23,     0,     0,     0,
       0,     0,     0,   954,   944,  4235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1508,     0,     0,     0,     0,
       0,   949,     0,     0,     0,     0,     8,     0,  4500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1509,  1510,
       0,  1511,     0,     0,     0,     0,  4237,     0,     0,  1512,
    1513,  1514,  4238,   945,     0,     0,     0,     0,  2599,    14,
    3762,     0,     0,     0,   946,    31,     0,     0,  4569,  1515,
     950,   951,     0,     0,     0,     0,     0,   808,    18,     0,
       0,  4773,     0,     0,   952,     0,     0,     0,     0,   791,
       0,     0,     0,   947,     0,     0,     0,     0,  3731,     0,
     948,     0,     0,     0,  1516,     0,     0,     0,  3731,     0,
       0,  4243,     0,     0,     0,     0,     0,    23,  4244,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1517,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,   949,    42,   955,     0,     0,     0,     0,  4245,
       0,     0,     0,     0,     0,  -575,     0,     4,  1519,  1520,
    1521,     0,  5334,     0,  4246,  4247,   944,  4773,  4955,  4773,
       0,   808,  4773,     0,  4955,     0,     0,  4248,     0,  4773,
    4773,     0,  4320,  1523,  4955,    75,    31,     0,     8,     0,
       0,   950,   951,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,   952,   953,     0,     0,     0,
       0,     0,     0,     0,     0,   945,     0,     0,     0,  4773,
       0,    14,     0,  4955,     0,  4955,   946,     0,  1159,     0,
       0,     0,     0,  1524,     0,  1525,  1526,     0,     0,     0,
      18,     0,     0,     0,  5363,     0,     0,   791,     0,  1159,
    5370,  1527,     0,     0,     0,   947,     0,     0,     0,     0,
       0,  -575,   948,     0,    42,     0,     0,  5379,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,    23,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
    1529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   949,     0,    75,     0,     0,     0,
       0,  1530,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   953,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1532,  1533,     0,    31,     0,
    5429,     0,     0,   950,   951,     0,     0,     0,     0,  4898,
       0,     0,     0,     0,  4955,     0,     0,   952,     0,     0,
    1159,     0,     0,  5442,  5442,  5444,     0,  1534,  4773,     0,
       0,     0,  4015,     0,     0,     0,  1535,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,   799,     0,     0,     0,     0,
     799,     0,     0,     0,  3582,     0,  3582,     0,     0,   955,
       0,     4,     0,     0,     0,     0,    42,     0,     0,     0,
     944,     0,  1536,  1537,  1538,     0,  5500,     0,     0,     0,
    1539,  1540,     0,  5505,     0,     0,  4773,  4773,     0,     0,
    4773,     0,  -557,     0,  4773,     0,  5517,  1541,  1542,     0,
       0,     0,  2599,     0,     0,   791,     0,  1159,    75,     0,
       0,  4955,     0,     0,     0,     0,     0,     0,     0,   945,
       0,  1543,  1544,     0,     0,  1683,     0,     0,     0,   953,
     946,     0,     0,     0,     0,     0,     0,     0,     0,  5546,
    4321,     0,     0,     0,    18,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,   947,
       0,     0,  1159,     0,     0,     0,   948,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     955,     0,     0,  1684,  5189,     0,     0,     0,     0,     0,
    5442,     0,  1159,     0,     0,  1735,     0,     0,     0,     0,
       0,   954,  1159,     0,     0,     0,     0,     0,   949,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3731,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1547,     0,     0,  1548,     0,     0,  1549,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,  4773,
       0,     0,  1685,     0,  4773,     0,     0,   950,   951,     0,
       0,  4323,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   952,     0,   791,     0,     0,     0,     0,  5649,     0,
    1552,     0,     0,     0,     0,  5680,     0,     0,     0,  1159,
    1159,  1159,  1159,  5687,  5691,  1735,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5709,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1686,     0,     0,     0,  5442,     0,     0,     0,  5733,     0,
       0,     0,   955,     0,     0,     0,     0,     0,     0,  5743,
       0,  5744,   799,     0,     0,     0,     0,     0,   799,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -557,     0,     0,     0,     0,     0,     0,     0,
       0,  5763,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   953,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2599,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,  1735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5870,
       0,     0,   791,     0,     0,   799,   799,     0,     0,  4569,
    4569,     0,     0,     0,     0,     0,     0,     0,  5442,     0,
    5442,  5442,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5892,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5691,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5709,     0,     0,
       0,  1735,     0,     0,     0,     0,     0,     0,     0,     0,
     808,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,     0,     0,     0,
       0,  5948,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5442,  5442,     0,     0,  5442,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,  2599,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6011,     0,     0,     0,
       0,     0,     0,   799,     0,     0,     0,     0,     0,  6021,
       0,     0,     0,     0,     0,     0,     0,  5442,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6056,  6056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2599,     0,     0,
       0,   808,  1159,     0,     0,     0,     0,   808,     0,     0,
       0,  2599,     0,     0,     0,  1159,  1159,  2599,     0,     0,
       0,  1159,     0,  2599,     0,  1159,  1159,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,  1159,  1735,     0,
       0,     0,  1159,     0,  1159,  1159,  1159,  1159,  1159,     0,
    1159,     0,     0,  1735,  1735,     0,     0,     0,     0,     0,
       0,  1159,     0,  1159,     0,     0,  1159,  1159,     0,  1159,
    1159,  1159,     0,  1159,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,  1159,
    1159,  1159,  1159,     0,  1159,  1159,  1159,     0,     0,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,     0,  1159,  1159,  1159,
    1159,     0,  1159,  1159,     0,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,     0,     0,  1159,  1159,  1159,  1159,     0,  1159,
    1159,  1159,     0,  1159,     0,  1159,     0,  1159,     0,     0,
       0,  1159,  1159,  1159,     0,     0,  1159,  1159,  1159,  1159,
    1159,     0,  1159,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,  1159,  1159,  1159,  1159,
       0,     0,     0,     0,     0,     0,     0,  1159,  1159,     0,
    1159,  1159,     0,     0,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,     0,     0,  1159,
    5127,     0,  4198,     0,  1735,     0,     0,     0,     0,     0,
       0,  1735,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4200,     0,     0,     0,
       0,     0,     0,     0,  4202,     0,  1125,     0,     0,     0,
    1159,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,  2188,     0,     0,     0,
       0,     0,     0,  1288,     0,     0,     0,     0,  5128,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
    4204,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1735,     0,
    4207,     0,     0,     0,     0,     0,     0,     0,  4208,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1485,     0,     0,     0,     0,
       0,     0,     0,     0,  4210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4211,
    4212,  4213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4214,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4215,     0,     0,
       0,     0,  1636,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4216,     0,     0,     0,     0,     0,     0,     0,  4217,
       0,  4218,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4219,     0,     0,     0,     0,     0,     0,  1698,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4221,
       0,     0,     0,     0,     0,     0,  4222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1725,     0,     0,
       0,  4223,     0,     0,     0,     0,     0,  1740,     0,  4224,
       0,     0,     0,  4225,     0,     0,     0,     0,     0,     0,
    4227,     0,     0,     0,  4228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,  1159,
       0,     0,  4230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4233,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,  4234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4235,  1159,  4236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,  1159,  1159,     0,     0,     0,
       0,     0,     0,  4237,     0,     0,     0,     0,     0,  4238,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1735,
    1735,     0,     0,     0,     0,     0,     0,     0,  4243,     0,
       0,     0,     0,     0,     0,  4244,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,  1159,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1735,
       0,     0,     0,     0,     0,  2031,  4245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4246,  4247,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,  1735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,  1159,  1159,     0,  1159,
    1159,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,  2185,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2228,
       0,  2229,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1735,     0,  1735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2393,
       0,  2393,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,  2424,     0,     0,
       0,     0,  1735,     0,     0,  1735,  1735,  1735,     0,  1159,
       0,  1159,     0,     0,     0,     0,  2439,     0,     0,     0,
    2444,     0,  2446,     0,     0,     0,     0,     0,     0,     0,
       0,  2462,  2463,     0,     0,     0,     0,  2492,     0,  2495,
    2496,  2497,  2498,  2499,     0,  2501,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2509,     0,  2512,     0,
       0,  2513,  2514,     0,  2516,  2517,     0,  1159,  2520,  2521,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2530,  2531,  2536,  2538,  2539,     0,  2542,
       0,  2544,     0,     0,  2546,  2547,  2548,  2551,  2552,  2553,
    2554,     0,  2555,  2556,  2557,     0,     0,  2564,  2565,     0,
       0,  2569,  2570,  2571,     0,     0,     0,     0,     0,  2577,
    2578,  2579,     0,     0,  2582,  2583,  2584,     0,  2586,     0,
    2588,     0,  2589,     0,     0,     0,  2592,  2536,  2594,     0,
       0,  2600,  2601,  2602,  2603,  2604,     0,  2605,     0,     0,
       0,     0,     0,     0,  2609,     0,     0,     0,     0,     0,
       0,  2614,  2615,  2616,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2711,     0,     0,     0,     0,
    2185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,  1159,     0,  1159,     0,  1159,
    1159,  1159,  1159,  1159,  1159,     0,  1159,  2784,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,     0,  1159,
    1159,  1159,     0,     0,     0,     0,     0,     0,  1159,  1159,
    1159,     0,  1159,     0,  1159,     0,  1159,     0,  1159,  2819,
    1159,  2824,     0,     0,     0,     0,     0,     0,  1159,     0,
    1159,     0,  1159,  1159,  1159,  1159,  1159,     0,     0,  1159,
       0,  1159,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2847,     0,  1159,     0,     0,
       0,     0,  1159,     0,     0,  1159,     0,  1159,  1159,  1159,
       0,     0,  1159,     0,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,  1159,     0,
    1159,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,  1735,  1159,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1735,     0,     0,     0,     0,     0,     0,     0,     0,
    2920,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3099,  3100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,  1735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3187,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1288,     0,  3206,     0,     0,  1159,     0,     0,     0,     0,
    3213,  3214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1735,     0,
       0,     0,  3269,  3271,  3273,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1735,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3355,     0,  1159,
       0,  1159,     0,  1159,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,  3363,     0,  3364,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3386,     0,  1159,  1159,     0,     0,     0,
       0,     0,  1159,     0,  1159,     0,  1159,  3392,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
    3403,     0,     0,  2185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3439,  1735,  1159,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,  3449,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2824,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3588,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3588,     0,  2185,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,  1159,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,  1159,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
       0,  1159,     0,     0,     0,     0,     0,  3824,     0,     0,
    3825,     0,     0,     0,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3852,     0,
       0,     0,  3854,     0,  3855,  3856,  3857,  3858,  3859,  3860,
       0,  1159,     0,     0,     0,     0,     0,     0,  1159,  3865,
       0,  3866,     0,     0,  3867,  3868,  3869,  1159,     0,     0,
       0,     0,     0,  3871,  3872,  3873,     0,  3874,     0,  3876,
       0,  3878,     0,  3880,     0,  3882,     0,     0,     0,     0,
       0,     0,     0,  2548,     0,  3885,     0,  2548,     0,  3888,
    3889,  3890,     0,     0,  3891,     0,  3892,     0,     0,  3893,
    1159,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,  3894,     0,     0,     0,     0,     0,     0,     0,
    3901,     0,  3902,  3903,  3904,     0,     0,  3905,     0,     0,
       0,     0,     0,  3909,     0,     0,     0,     0,  3920,     0,
       0,     0,     0,     0,     0,     0,     0,  3924,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3931,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3943,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2185,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2185,
       0,  2824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4122,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4280,     0,     0,  1735,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4383,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4390,     0,     0,  4391,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4409,
    4410,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4433,     0,  4434,     0,  4435,     0,
    4436,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4457,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4480,  4481,     0,     0,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,  3588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2185,  2185,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,  2185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4645,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3588,     0,
    4657,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,  1735,  1735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4859,  4860,     0,     0,     0,
       0,     0,     0,  1735,     0,     0,     0,     0,     0,  4867,
    4868,  4869,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,  4889,     0,  4890,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4896,
    4897,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4918,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2824,     0,     0,     0,  2824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5145,  5146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3588,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3588,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2185,
    2185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5302,     0,  5304,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5502,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3588,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5807,     0,     0,     0,  2181,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2182,   984,   985,   986,   987,
       0,     0,     0,     0,     0,     0,     0,   988,   989,     0,
     990,     0,     0,     0,     0,     0,     0,   991,   992,     0,
       0,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  2183,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,  5905,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,  2184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,  2824,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,  2824,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,  1115,  1116,     0,     0,
       0,     0,  1117,     0,     0,     0,  2623,  1118,     0,     0,
       0,  1119,  1120,     0,     0,  1121,  1122,   983,   984,   985,
     986,   987,     0,     0,     0,     0,     0,     0,     0,   988,
     989,     0,   990,     0,     0,     0,     0,     0,     0,   991,
     992,     0,     0,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,     0,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,  2624,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,  1115,  1116,
       1,     2,     0,     0,  1117,     0,     0,     0,     0,  1118,
       0,     0,     0,  1119,  1120,     0,     0,  1121,  1122,     0,
       3,     0,     4,     0,     5,     0,     6,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     8,     0,     0,     9,     0,    10,    11,
       0,     0,     0,     0,     0,     0,    12,     0,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    14,     0,     0,     0,
       0,     0,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,    18,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,    22,
       0,     0,     0,     0,    23,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,    30,    31,     0,    32,     0,     0,     0,     0,
      33,     0,     0,     0,     0,     0,    34,     0,     0,     0,
      35,     0,     0,     0,    36,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,    39,     0,    40,     0,     0,     0,
       0,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,    43,     0,     0,     0,     0,     0,     0,    44,
      45,    46,    47,     0,    48,    49,    50,    51,    52,    53,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     0,    88,    89,    90,
      91,    92,    93,    94,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,     0,   172,
       0,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,     1,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   468,     3,     0,     4,     0,     5,     0,     6,
       0,     0,     0,     0,     0,     0,     0,     7,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     8,     0,     0,     9,
       0,    10,    11,     0,     0,     0,     0,     0,     0,    12,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    14,
       0,     0,     0,     0,     0,    15,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,    18,     0,
       0,     0,     0,     0,     0,     0,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      21,     0,    22,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    29,    30,    31,     0,    32,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,    34,
       0,     0,     0,    35,     0,     0,     0,    36,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    38,     0,    39,     0,    40,
       0,     0,     0,     0,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,    43,     0,     0,     0,     0,
       0,     0,    44,    45,    46,    47,     0,    48,    49,    50,
      51,    52,    53,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     0,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,     0,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,     0,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,     0,   172,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,     0,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,     1,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   468,     3,     0,     0,     0,
       5,     0,     6,     0,     0,     0,     0,     0,     0,     0,
       7,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     9,     0,    10,    11,     0,     0,     0,     0,
       0,     0,    12,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    30,     0,
       0,    32,     0,     0,     0,     0,    33,     0,     0,     0,
       0,     0,    34,     0,     0,     0,    35,     0,     0,     0,
      36,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    38,     0,
      39,     0,    40,     0,     0,     0,     0,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,    44,    45,    46,    47,     0,
      48,    49,    50,    51,    52,    53,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,     0,     0,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     0,    88,    89,    90,    91,    92,    93,    94,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,     0,   172,     0,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   983,
     984,   985,   986,   987,     0,     0,     0,     0,     0,     0,
       0,   988,   989,     0,   990,     0,     0,     0,   468,     0,
       0,   991,   992,     0,     0,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
      41,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,  2533,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2534,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,  2535,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
    1697,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  2821,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,  2822,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,  1028,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,  3268,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,  1028,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,  3270,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,  3272,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  4937,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,  2822,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,  1028,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,  1028,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1724,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,  2391,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  2392,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  2392,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  3881,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  3900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,  1028,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,  5990,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,     0,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,     0,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1691,  1692,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1826,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
       0,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1691,  1692,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  1828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,     0,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1691,  1692,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,     0,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,     0,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  2646,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,     0,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,     0,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1690,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,     0,
       0,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,   984,   464,   618,   466,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,  5771,  5772,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5773,     0,     0,
       0,     0,  1120,     0,     0,  1121,  1122,     0,     0,     0,
       0,     0,  1001,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,  1008,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1012,  1013,     0,     0,     0,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1020,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,  1031,  1032,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1048,     0,     0,     0,     0,     0,     0,     0,  1049,  1050,
    1051,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    1729,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,  2677,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,  3151,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  2678,
     424,   425,  2679,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1121,  1122,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   582,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,   584,   585,    77,    78,    79,    80,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,    93,    94,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,   594,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   596,   597,   172,
       0,   173,   174,   175,   598,   177,   178,   179,   180,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   603,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,   361,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,  3397,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   617,   460,   461,   462,   463,     0,   464,
     618,   466,   467,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,  3152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1209,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1210,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1211,    88,   588,
      90,    91,    92,    93,    94,   589,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     591,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,   173,   174,   175,  1212,   177,   178,   179,   180,
     181,   599,  1213,   184,   600,   186,   187,   601,     0,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,   213,   214,   215,   216,   217,   218,
     219,  1214,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,  1215,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1216,   306,
     307,   308,   309,   310,   311,   312,   313,   606,   314,   607,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,   355,
    1217,   610,   358,   359,   360,   361,   362,   363,   364,   611,
     366,   367,   368,   369,   370,   371,   372,  1218,   374,   375,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,  1219,   428,   429,   430,   615,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,  1220,   460,   461,   462,   463,  1209,
     464,   618,   466,   467,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1210,     0,
       0,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
    1211,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,  1212,   177,
     178,   179,   180,   181,   599,  1213,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,  1214,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,  1215,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,  1216,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,  1217,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
    1218,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1220,   460,   461,
     462,   463,     0,   464,   618,   466,   467,   900,   901,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1221,     0,     0,     0,     0,
       0,     0,   902,     0,     0,     0,     0,   903,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   904,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     906,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,   907,     0,     0,     0,
       0,   908,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,   909,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   911,     0,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,   914,   915,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   916,   155,   156,   157,
     158,   917,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   918,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   919,   321,   322,   323,   920,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   921,   342,   343,   608,   345,   922,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   923,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     924,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1186,   901,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   902,     0,     0,     0,
       0,   903,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   905,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   906,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
     907,     0,     0,     0,     0,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   911,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,   914,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,  1187,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     916,   155,   156,   157,   158,   917,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   918,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   919,   321,   322,   323,  1188,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   921,   342,   343,   608,
     345,   922,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   923,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,  1957,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   924,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  2054,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,  4951,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,  2055,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  4970,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   756,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,  3496,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3497,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     757,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,    93,    94,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,   173,   174,   175,   598,   177,   178,
     179,   180,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,  4971,   307,   308,   309,   310,   311,   312,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,   361,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,  4518,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   617,   460,   461,   462,
     463,     0,   464,   618,   466,   467,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,  4769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  1910,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1911,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1500,  1501,     0,  1913,     0,
       0,  1502,  1503,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1506,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1507,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1508,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1509,  1510,     0,  1511,
       0,     0,     0,     0,     0,     0,     0,  1512,  1513,  1514,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1515,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1516,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1517,     0,     0,     0,
       0,     0,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1519,  1520,  1521,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,     0,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,     0,
     585,  1524,    78,  1525,  1526,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,     0,  1527,
     589,    95,    96,    97,     0,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,  1528,   129,  1529,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,     0,   146,   147,   148,  1530,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   595,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,  1531,   596,   597,   172,     0,   173,   174,   175,
       0,   177,   178,  1532,  1533,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,  1534,   211,   603,   212,   213,
     214,   215,   216,   217,  1535,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
    1536,  1537,  1538,   267,   268,   269,   270,   271,  1539,  1540,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,     0,  1541,  1542,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1543,
    1544,   313,   606,   314,   607,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,     0,  1545,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   608,   345,   346,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
    1546,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,   612,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
    1547,   421,   422,  1548,   424,   425,  1549,   427,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,     0,  1550,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1551,
     460,   461,   462,   463,     0,   464,   618,   466,  1552,  1500,
    4319,     0,     0,     0,     0,  1502,  1503,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1506,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1507,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1508,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1509,  1510,     0,  1511,     0,     0,     0,     0,     0,     0,
       0,  1512,  1513,  1514,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1515,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1516,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1517,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1519,  1520,  1521,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4320,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,     0,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,     0,   585,  1524,    78,  1525,  1526,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,     0,  1527,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
    1528,   129,  1529,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,     0,
     146,   147,   148,  1530,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,  1531,   596,   597,   172,
       0,   173,   174,   175,     0,   177,   178,  1532,  1533,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,  1534,
     211,   603,   212,   213,   214,   215,   216,   217,  1535,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,  1536,  1537,  1538,   267,   268,   269,
     270,   271,  1539,  1540,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,     0,  1541,
    1542,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,  1543,  1544,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,     0,  4321,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,  4322,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,  1547,   421,   422,  1548,   424,   425,
    1549,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,     0,  4323,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1551,   460,   461,   462,   463,     0,   464,
     618,   466,  1552,  1500,  1501,     0,     0,     0,     0,  1502,
    1503,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1506,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1507,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1508,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1509,  1510,     0,  1511,     0,     0,
       0,     0,     0,     0,     0,  1512,  1513,  1514,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1515,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1517,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1519,  1520,  1521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,     0,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,     0,   585,  1524,
      78,  1525,  1526,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,     0,  1527,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,  1528,   129,  1529,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,     0,   146,   147,   148,  1530,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
    1531,   596,   597,   172,     0,   173,   174,   175,     0,   177,
     178,  1532,  1533,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,  1534,   211,   603,   212,   213,   214,   215,
     216,   217,  1535,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,  1536,  1537,
    1538,   267,   268,   269,   270,   271,  1539,  1540,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,     0,  1541,  1542,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,  1543,  1544,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,     0,  1545,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,     0,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,  5365,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,  1547,   421,
     422,  1548,   424,   425,  1549,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,     0,  1550,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1551,   460,   461,
     462,   463,     0,   464,   618,   466,  1552,  1500,  4319,     0,
       0,     0,     0,  1502,  1503,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1506,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1507,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1508,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1509,  1510,
       0,  1511,     0,     0,     0,     0,     0,     0,     0,  1512,
    1513,  1514,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1515,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1516,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1517,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1519,  1520,
    1521,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4320,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,     0,   585,  1524,    78,  1525,  1526,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
       0,  1527,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,  1528,   129,
    1529,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,     0,   146,   147,
     148,  1530,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,  1531,   596,   597,   172,     0,   173,
     174,   175,     0,   177,   178,  1532,  1533,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,  1534,   211,   603,
     212,   213,   214,   215,   216,   217,  1535,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,  1536,  1537,  1538,   267,   268,   269,   270,   271,
    1539,  1540,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,     0,  1541,  1542,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,  1543,  1544,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,     0,
    4321,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,  5603,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,  1547,   421,   422,  1548,   424,   425,  1549,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
    1926,  4323,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1551,   460,   461,   462,   463,     0,   464,   618,   466,
    1552,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1927,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   707,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   582,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,   584,   585,    77,    78,    79,    80,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,    93,    94,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,   594,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   596,   597,   172,
       0,   173,   174,   175,   598,   177,   178,   179,   180,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   603,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,   361,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   617,   460,   461,   462,   463,  1910,   464,
     618,   466,   467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1911,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,  1910,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,    93,    94,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,   173,   174,   175,   598,   177,   178,
     179,   180,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,   361,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,  1343,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   617,   460,   461,   462,
     463,     0,   464,   618,   466,   467,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,  1345,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1346,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,  2739,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,     0,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,   587,    88,   588,    90,    91,    92,    93,    94,   589,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   591,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,   173,   174,   175,   598,
     177,   178,   179,   180,   181,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   606,   314,   607,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   610,   358,   359,   360,   361,
     362,   363,   364,   611,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     615,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   617,   460,
     461,   462,   463,  1447,   464,   618,   466,   467,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   707,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,   587,    88,   588,    90,    91,    92,    93,    94,   589,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   591,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,   173,   174,   175,   598,
     177,   178,   179,   180,   181,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   606,   314,   607,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   610,   358,   359,   360,   361,
     362,   363,   364,   611,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     615,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   617,   460,
     461,   462,   463,     0,   464,   618,   466,   467,   849,   850,
       0,     0,     0,     0,     0,     0,     0,     0,   851,     0,
       0,     0,     0,     0,     0,     0,     0,  1820,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,     0,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,     0,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,   852,   853,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   854,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1447,   903,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,    93,    94,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,   173,   174,   175,   598,   177,   178,
     179,   180,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,   361,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   617,   460,   461,   462,
     463,  1447,   464,   618,   466,   467,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,    93,    94,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,   173,   174,   175,   598,   177,   178,
     179,   180,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,   361,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   617,   460,   461,   462,
     463,  1380,   464,   618,   466,   467,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,   903,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1381,     0,     0,     0,
       0,  1382,     0,     0,   787,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,    93,    94,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,   173,   174,   175,   598,   177,   178,
     179,   180,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,   361,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   617,   460,   461,   462,
     463,   851,   464,   618,   466,   467,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,     0,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   583,     0,     0,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,   587,    88,   588,
      90,    91,    92,    93,    94,   589,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     591,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
       0,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   606,   314,   607,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   610,   358,   359,   360,   361,   362,   363,   364,   611,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   615,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   854,   460,   461,   462,   463,     0,
     464,   618,   466,   467,  2451,     0,     0,     0,  5140,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2452,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4141,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4143,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,  4144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,     0,   464,   618,   466,   467,  2451,     0,     0,
       0,  5895,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2452,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4141,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,  4144,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,     0,   464,   618,   466,   467,
    2451,     0,     0,     0,  6008,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2452,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4141,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4143,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   707,     0,
       0,     0,     0,     0,     0,     0,     0,  4144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   582,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,   584,   585,    77,    78,    79,    80,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,    93,    94,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,   594,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   596,   597,   172,
       0,   173,   174,   175,   598,   177,   178,   179,   180,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   603,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,   361,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   617,   460,   461,   462,   463,  3066,   464,
     618,   466,   467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  1903,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1903,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,  2731,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    3489,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   582,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,   584,
     585,    77,    78,    79,    80,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,    93,    94,
     589,    95,    96,    97,     0,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,   594,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   595,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   596,   597,   172,     0,   173,   174,   175,
     598,   177,   178,   179,   180,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   603,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   606,   314,   607,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   608,   345,   346,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
     361,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   612,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   617,
     460,   461,   462,   463,  5071,   464,   618,   466,   467,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   582,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,   584,   585,    77,    78,    79,    80,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,    93,    94,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,   594,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   596,   597,   172,
       0,   173,   174,   175,   598,   177,   178,   179,   180,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   603,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,   361,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   617,   460,   461,   462,   463,  5089,   464,
     618,   466,   467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  3425,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,  3426,   177,   178,   179,   180,   181,   599,     0,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  3427,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2596,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6105,     0,     0,     0,     0,     0,     0,  2597,  6106,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1924,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2145,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2611,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2596,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2597,  6106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2055,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1381,     0,     0,     0,     0,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  1729,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1730,     0,     0,     0,     0,     0,     0,     0,  1121,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1381,     0,     0,     0,     0,  1382,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  1729,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1121,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2596,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2597,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1381,     0,     0,     0,     0,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,  5037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4768,     0,     0,     0,     0,     0,     0,     0,  4769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   784,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   785,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   786,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  3111,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2655,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   703,   704,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3754,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3755,   673,  3756,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1660,   464,   618,   466,
     467,  1661,     0,     0,     0,     0,     0,     0,     0,     0,
    3112,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,  1662,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1582,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,  3128,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,  4369,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,  4522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,  4944,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,  5243,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,  5432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1912,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,  1913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2156,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2158,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2160,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2156,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4352,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2160,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2156,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,  2160,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   673,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   673,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4565,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5688,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   716,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  1727,  1728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,  2074,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,  3517,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,  3518,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,  3169,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,  3426,   177,   178,   179,   180,   181,   599,     0,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  3427,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,     0,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,     0,    88,   588,    90,    91,    92,
      93,    94,     0,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,     0,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,     0,   142,   143,   144,   145,     0,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,     0,   172,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   599,   183,
     184,     0,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,     0,   358,
     359,   360,   361,   362,   363,   364,     0,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,     0,   464,   618,   466,
     467,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1650,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,     0,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
       0,    65,    66,    67,    68,    69,    70,    71,    72,     0,
       0,     0,     0,    77,    78,    79,    80,    81,     0,     0,
      84,    85,    86,    87,     0,     0,     0,    90,    91,    92,
      93,    94,     0,    95,    96,    97,     0,    99,     0,     0,
       0,     0,     0,     0,   105,     0,   107,     0,   109,   110,
    1651,   112,   113,   114,   115,   116,   117,     0,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,     0,   133,     0,   134,   135,   136,   137,   138,
     139,   140,     0,   142,   143,   144,   145,     0,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,     0,
       0,     0,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
     174,   175,  1652,   177,   178,   179,   180,   181,     0,   183,
     184,     0,   186,   187,     0,     0,   189,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,     0,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    16,    17,     0,     0,   299,
     300,     0,   302,   303,   304,   305,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,     0,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,     0,   343,     0,   345,   346,     0,   348,
     349,     0,   351,   352,   353,   354,   355,   356,     0,   358,
     359,   360,   361,   362,   363,   364,     0,   366,   367,   368,
       0,   370,   371,   372,   373,     0,   375,   376,     0,     0,
     379,     0,     0,   382,   383,   384,     0,   386,     0,   388,
     389,   390,   391,     0,   392,   393,   394,   395,     0,   397,
     398,     0,   400,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,     0,   423,   424,   425,   426,   427,
     428,   429,   430,     0,   432,   433,   434,     0,   436,   437,
     438,   439,     0,     0,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,     0,   461,   462,     0,     0,   464,     0,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1669,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,     0,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,     0,    65,    66,    67,    68,    69,
      70,    71,    72,     0,     0,     0,     0,    77,    78,    79,
      80,    81,     0,     0,    84,    85,    86,    87,     0,     0,
       0,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,    99,     0,     0,     0,     0,     0,     0,   105,     0,
     107,     0,   109,   110,  1651,   112,   113,   114,   115,   116,
     117,     0,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,     0,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,   142,   143,   144,
     145,     0,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,     0,     0,     0,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,   174,   175,  1652,   177,   178,   179,
     180,   181,     0,   183,   184,     0,   186,   187,     0,     0,
     189,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    16,
      17,     0,     0,   299,   300,     0,   302,   303,   304,   305,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
       0,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,     0,   343,     0,
     345,   346,     0,   348,   349,     0,   351,   352,   353,   354,
     355,   356,     0,   358,   359,   360,   361,   362,   363,   364,
       0,   366,   367,   368,     0,   370,   371,   372,   373,     0,
     375,   376,     0,     0,   379,     0,     0,   382,   383,   384,
       0,   386,     0,   388,   389,   390,   391,     0,   392,   393,
     394,   395,     0,   397,   398,     0,   400,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   423,
     424,   425,   426,   427,   428,   429,   430,     0,   432,   433,
     434,     0,   436,   437,   438,   439,     0,     0,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,     0,   461,   462,     0,
       0,   464,     0,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,     0,
      48,     0,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,     0,    65,
      66,    67,    68,    69,    70,    71,    72,     0,     0,     0,
       0,    77,    78,    79,    80,    81,     0,     0,    84,    85,
      86,    87,     0,     0,     0,    90,    91,    92,    93,    94,
       0,    95,    96,    97,     0,    99,     0,     0,     0,     0,
       0,     0,   105,     0,   107,     0,   109,   110,  1651,   112,
     113,   114,   115,   116,   117,     0,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
       0,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,   142,   143,   144,   145,     0,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,     0,     0,     0,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,   174,   175,
    1652,   177,   178,   179,   180,   181,     0,   183,   184,     0,
     186,   187,     0,     0,   189,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,     0,     0,     0,     0,   299,   300,     0,
     302,   303,   304,   305,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,     0,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,     0,   343,     0,   345,   346,     0,   348,   349,     0,
     351,   352,   353,   354,   355,   356,     0,   358,   359,   360,
     361,   362,   363,   364,     0,   366,   367,   368,     0,   370,
     371,   372,   373,     0,   375,   376,    16,    17,   379,     0,
       0,   382,   383,   384,     0,   386,     0,   388,   389,   390,
     391,     0,   392,   393,   394,   395,     0,   397,   398,     0,
     400,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,     0,   423,   424,   425,   426,   427,   428,   429,
     430,     0,   432,   433,   434,     0,   436,   437,   438,   439,
       0,     0,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
       0,   461,   462,     0,     0,   464,     0,   466,   467,     0,
       0,  5450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,     0,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   583,     0,     0,   585,     0,    78,
       0,     0,    81,    82,   586,    84,    85,    86,    87,   587,
      88,   588,    90,    91,    92,     0,     0,   589,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   591,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,     0,   129,     0,   131,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,     0,   146,   147,   148,     0,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,     0,
     596,   597,   172,     0,   173,   174,   175,  5451,   177,   178,
       0,     0,   181,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,     0,   211,   603,   212,   213,   214,   215,   216,
     217,     0,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,     0,     0,
     267,   268,   269,   270,   271,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,     0,     0,     0,   290,   291,   292,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,     0,   313,   606,
     314,   607,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,     0,     0,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   610,   358,   359,   360,     0,   362,   363,
     364,   611,   366,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   421,   422,
       0,   424,   425,     0,   427,   428,   429,   430,   615,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,   445,   446,   447,     0,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,  1551,   460,   461,   462,
     463,     0,   464,   618,   466
};

static const yytype_int16 yycheck[] =
{
       0,     0,   468,    24,   688,   859,   687,   688,   581,   573,
    1407,     0,   770,   687,     0,  1894,   571,     0,  1407,  1874,
    1511,     0,  1511,  2249,  1821,   956,  2032,     0,  1588,  1434,
    1270,  1716,     0,   681,  2225,  1709,    75,     0,  1887,     0,
       0,  1528,  2330,     0,   893,  1507,  2426,  3075,  1405,  1632,
     801,  3404,  1181,  1515,   755,    33,  1933,  2319,   759,   760,
    1547,  1548,  1549,  2340,   654,  1552,  2935,   654,  3669,  1531,
    3669,  1747,  2320,  1602,  3203,  3204,  1568,     0,  3159,  1541,
    1567,  2812,  3604,   638,   636,   640,   641,   642,   643,   644,
     715,   646,   647,  1381,   684,   650,   651,   684,  1440,  3704,
    1562,  1440,  2061,  4070,   844,  2810,  1947,  1948,  1021,  1215,
    1216,  1217,  2002,  1399,  1725,  3468,  4109,   732,  1224,  3784,
     735,  4077,  1887,  4623,  3584,  3454,  3816,  4634,   636,  1249,
     858,  2189,  2054,  3219,  3047,   687,  1921,  4635,     0,  4322,
    3047,  3729,  3144,  1340,  3729,  3729,  1931,  3729,  3608,  2901,
     171,  1271,  2977,  3729,  4774,  2839,  3729,  2871,    30,  3669,
    1954,  4197,  3535,  2977,  3675,  2900,  2901,   983,  2709,  2277,
    4197,  4197,  3619,    11,  4075,    11,     0,  1971,  2910,   687,
       9,    10,   737,   738,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,   581,  3645,  3646,
    2306,  2427,  1996,  1997,  2375,  2054,  2377,  2378,  2087,   581,
    4198,  2052,  4200,   581,     6,  4203,  4209,    89,   581,   581,
    1272,     6,  3047,    28,    11,    80,    95,  1584,  2134,     6,
      12,  4779,  2423,  3047,    61,     6,    91,    11,    83,   563,
       9,    10,   566,    26,  2969,    11,    50,  1509,  4236,  2958,
    1512,  4646,  1183,    61,  1501,  4261,  1503,  1519,  1505,  3037,
    1507,     9,    10,     6,  3711,  3712,  1669,  3718,  1515,    24,
      11,   197,  1534,     9,    10,  1522,   121,  1524,   105,   156,
     781,  1478,    26,    65,  1531,  4999,    63,   226,   126,  2054,
     126,    93,   197,   180,  1541,     9,    10,   105,  1545,  1115,
    1116,  1117,   197,  1550,   152,   857,   105,   859,    73,    10,
     782,     9,    10,  1129,    80,  1562,  1563,  1564,  1565,  1566,
       9,    10,    12,   344,   251,    91,  4995,  3554,    61,   884,
       9,    10,    86,     9,    10,  2214,  1510,  1511,   238,    61,
    1514,   896,   897,   120,    17,  1695,  1696,  1521,    61,   857,
    4742,   859,  3379,  1527,  1704,   184,    93,   186,    80,    32,
    3634,    34,  3691,   211,   114,   266,  3118,   284,  1845,    91,
      61,    11,   105,   114,   174,    65,  1853,  1854,    86,  1856,
    1857,   197,    17,  3118,    76,   379,  1736,   363,  1738,    32,
    5753,     6,   105,   105,   185,  5138,  4613,   105,   218,     9,
      10,    57,   263,  1753,  1754,  1755,     9,    10,   265,   130,
    2201,   265,  1762,  1763,   105,   184,    95,   186,   223,  1769,
    5367,   766,   176,  1510,  1511,  1511,   263,  1514,  1514,     9,
      10,    11,   277,    89,  1521,  1521,   184,   197,   186,   197,
    1527,  1527,     9,    10,   265,    11,    14,   115,   184,   105,
     186,     9,    10,   265,  4699,  2246,   233,   221,    80,    60,
     238,   801,  3167,   263,     9,    10,    57,     9,    10,    91,
     184,    35,   186,   319,   303,  1604,   238,   822,  5273,    32,
     363,   180,   468,   270,     9,    10,   184,   180,   186,    93,
      73,   152,  1021,   149,   238,   184,   237,   186,    89,   633,
    1629,   238,  2790,   180,   281,   184,    10,   186,   184,   572,
     186,   288,   152,  3649,   105,  2803,   299,   180,  3667,   273,
    2103,   177,   299,  2694,  2695,  2696,  2697,     9,    10,   105,
     410,   574,     9,    10,   303,   247,    80,  1066,   299,   316,
     112,   211,   283,    80,   226,     9,    10,    91,   284,   535,
       9,    10,   535,  2432,    91,   303,   535,    24,   149,    58,
    1300,   885,   886,   887,   888,   273,   128,   303,   122,   211,
     518,   211,     9,    10,   184,   105,   186,   114,  4089,     9,
      10,   184,   581,   186,   105,  4190,   177,   141,    69,   303,
    3943,   238,  1121,     9,    10,   581,   775,   141,   581,  3680,
    4606,   780,   581,   782,   184,   303,   186,     9,    10,   641,
     180,     9,    10,   467,   303,     9,    10,   184,   274,   186,
     569,  3950,  4788,  1381,   303,   124,   184,   303,   186,     9,
      10,   196,   204,     9,    10,    80,   636,   230,    80,   184,
     265,   186,   184,   777,   186,   112,    91,   636,   448,    91,
     530,  1266,  1118,   653,   237,   356,   329,   299,  5453,   184,
     238,   186,   284,  1364,   653,  1366,   299,   667,  1369,  1370,
    1371,  1372,  2201,   180,   347,   636,   265,   149,   265,  5626,
     353,   146,   745,   274,   165,  2090,   329,   687,   688,   230,
     230,   361,   653,   303,   694,   299,   653,   497,   687,   141,
     303,   679,   184,   679,   186,   654,   447,   184,   580,   186,
     353,     9,    10,   636,   213,   715,   238,  2246,   284,   380,
     184,   299,   186,   303,   299,   184,   687,   186,   396,   265,
     653,   294,   156,  5299,   777,   684,   303,   769,   584,   340,
     560,   462,  4252,     9,    10,   303,   310,   184,  1488,   186,
    1599,   366,   238,   297,   184,   323,   186,  6120,   303,   708,
     632,   303,  4768,   584,   687,  4982,   270,   233,   184,  1898,
     186,   114,   584,   722,   636,   769,  4987,  2405,   303,   316,
     652,  1310,   184,   484,   186,  2791,   184,  5530,   186,  1918,
     184,   653,   186,   238,   666,   781,   679,   714,  1904,  5468,
     353,  1714,  4076,  5048,   184,  3718,   186,   734,   184,   152,
     186,  3718,   636,   650,   279,  3567,  1945,  1730,   690,  1925,
    2349,   303,   288,   573,  3649,   679,   303,  4993,  2705,   653,
     769,  1951,  3567,  1953,   695,  3649,   836,   815,  2126,   303,
    3645,  3646,  3574,   769,   303,  1965,  3578,  2189,  1968,  2137,
    2189,   851,  1972,   635,  4439,   297,  4083,   857,  3106,   859,
    1433,  5253,   851,   687,  4315,  1605,   303,  4314,   857,   634,
     859,   772,   777,   303,   823,  1691,  1692,   777,  1407,  1999,
    2000,  2001,   777,   518,  2289,   772,   184,   303,   186,   660,
     851,  2296,   769,  3718,   851,   695,   857,   745,   859,  5613,
    5614,   303,   100,   772,  3718,   303,  3711,  3712,  5303,   303,
    5305,  3620,   769,   891,   494,  1381,   894,   660,   184,  2704,
     186,   776,  3647,   303,   679,   770,  5474,   303,   851,  1430,
     734,  3958,   759,   933,   857,  3713,   859,   708,   776,   631,
     776,   770,  1994,   892,   944,   635,   946,   947,   948,  1689,
     733,   759,   952,   769,   954,   944,  2915,   946,   947,   948,
     759,   961,   961,   952,  1436,   954,   753,   772,   263,   723,
     772,  5478,   961,  5480,  1887,   961,   758,   769,   961,   753,
    3151,   772,   961,   983,   769,   686,  2780,   753,   988,   851,
    3096,  3097,   769,  2604,  2605,   857,  2258,   859,  2260,   777,
     961,   263,  2908,  2909,   961,   303,   775,  2410,   772,   753,
     776,   772,   753,  1600,  2417,   777,   753,   777,  1018,   777,
    2282,   944,   770,   946,   947,   948,   759,   851,  1028,   952,
    2292,   954,   724,   857,  1379,  5601,   772,   303,   961,  4175,
     732,  5607,  2304,   735,  4193,  2242,   759,   759,   721,  1433,
    5056,   759,  5058,   137,   776,  5061,   770,   622,   772,  1875,
    2322,  1433,  5068,  5069,   238,  1433,  3607,   357,   759,   631,
    1433,  1433,   770,   772,   772,     9,    10,  1702,   721,   772,
     748,   770,   944,  4984,   946,   947,   948,   769,     6,   284,
     952,  5127,   954,   772,   770,   772,   772,  1855,  3803,   961,
    5127,  5127,  5108,   284,   375,   745,   753,    61,  3216,   772,
    3218,  2285,   536,   753,   770,  1115,  1116,  1117,  1118,  1118,
     944,   714,   946,   947,   948,  4636,  1466,   186,   952,  1129,
     954,  4653,  1118,  2307,  4656,  5301,  2310,   961,   238,   772,
    5128,  2054,     9,    10,   769,   238,  1771,  2321,  1899,   233,
    1474,   238,  2937,  2259,   776,  2632,  2633,  2507,  2635,  2636,
    2510,  1786,   772,  4764,  1789,  4764,  1791,  2958,   122,   772,
    1795,  1796,  1797,   714,   714,   753,  2526,  5797,  1803,   770,
     769,   152,  5063,   759,   683,  1714,  2977,   366,  5754,  5755,
    2540,   778,   772,   391,   770,  4548,   772,   772,  2285,  2285,
    1729,  1730,   772,   770,   288,   772,   769,   772,   363,   174,
     675,  3320,   770,  5628,   772,   299,  5836,  5837,  1969,  4592,
    2307,  2307,  2850,  2310,  2310,   770,  3397,   772,   770,   759,
     772,   753,   776,   769,  2321,  2321,  1937,  3127,   759,   776,
     770,   114,   772,   284,  2002,   770,  3037,   772,  4117,   770,
     184,   772,   186,   381,  4764,   777,  3047,  1436,  1724,  5470,
    4129,  5267,  3141,  2392,   607,   772,  1215,   753,  1217,  1593,
      14,   123,  1221,  1222,     9,    10,  4986,  1316,   152,   760,
     761,   762,   763,   422,     9,    10,   758,   759,   770,    63,
     772,   777,  1632,     9,    10,   772,   187,   114,  2926,    63,
       9,    10,  1251,   769,  4657,   146,  1306,   130,   772,  1309,
      33,     9,    10,   772,     9,    10,   402,   184,  1908,   186,
     378,  1908,     9,    10,   769,  5945,   323,  4774,   263,  2069,
    5286,   776,   777,  5339,   776,   772,    32,  5343,   280,     9,
      10,    37,   772,   300,   301,  3454,   120,  4099,  4100,    32,
    4175,  1880,  2201,   205,   770,   650,  4442,  4041,  1887,   636,
    4362,  4175,   560,   305,  4099,  4100,  2182,   330,  2126,   303,
     772,  4103,  4104,     5,   772,   366,     9,    10,   772,  2137,
    2138,    17,  1381,   211,  1362,  1363,  5952,     9,    10,    35,
     211,  5612,   772,   479,    28,  1381,   772,  2246,    34,    31,
     695,  4730,  4315,   358,   114,  2106,  2107,  4995,  4315,  2110,
    4995,  4995,   702,  4995,  2115,  2116,  2117,  4746,  4747,  4995,
    5603,   312,  4995,  5275,   211,   343,    76,    42,   416,  2958,
     205,  2046,   403,   695,  1433,    35,   303,  1309,  1438,  2003,
     499,    73,   152,   316,  1430,   442,   717,  1433,  1320,   184,
    1433,   186,  1401,  5953,  1433,   233,  5954,  2072,   263,   184,
     205,   186,   142,   426,   726,  3387,   283,  5108,   184,   387,
     186,   389,  4203,    35,   772,   184,  5891,   186,   606,  5360,
    1480,  3743,  1482,  3745,  3542,   326,   184,  3678,   186,   184,
    4315,   186,  5498,   464,    35,   333,  3502,   184,  5188,   186,
     777,  4315,   117,    37,    38,   703,   772,   281,  3037,  4314,
     288,  6018,  2193,   128,   184,  2102,   186,   281,  3047,  5475,
     135,   299,  2250,    83,   679,  2054,   270,  2869,   208,   403,
    2869,  2928,   497,    93,  2931,  2932,  2776,    35,  3387,  5506,
     172,  5508,  2931,  2932,   136,   137,   994,   995,   996,  2113,
    2114,   184,   167,   186,  5076,  2684,  2685,     9,    10,  1899,
    6060,   121,   184,   481,   186,  3148,  3242,  5277,   303,  3129,
    3967,  3968,  3969,  3970,  1266,   770,  1268,   772,   303,   753,
     212,   141,  3691,  2231,     9,    10,   146,   303,   646,   223,
     769,   772,  2505,    32,   303,    34,   777,   551,   737,  5451,
    5060,  2889,  2708,   777,  1052,   303,  2712,  2895,   303,   292,
     601,    61,   530,   228,  1938,  1939,   303,  1941,  1942,  1943,
    2360,  2361,  3387,  3814,  2730,   185,   349,  3412,  1952,  1969,
     447,  2160,  2752,   303,  5590,  5591,  2756,   696,   476,   462,
    1640,   233,  1642,  1967,   259,   237,   296,   110,   111,  2769,
    1342,  1600,  5645,   753,   482,  3440,  4370,  4371,  4372,  4373,
     753,   579,  2782,  2783,   310,   645,   753,  5634,  3353,  3463,
     303,  5454,    86,  4378,  5196,    35,   451,   777,  1678,  5677,
    3477,   303,   437,  5348,   777,   769,  4704,   525,   678,   677,
     777,  1691,  1692,   140,    28,   482,   288,  1697,  5339,   356,
    3376,  1701,  1702,  1703,   695,   660,   451,   299,  3382,  3337,
     310,  5233,  1712,  1713,  2362,  3500,   658,   277,  1718,   710,
    1720,  1721,  1722,  1723,  1724,  1724,  1726,  2401,  5949,  5950,
    1716,   772,   184,   214,   186,   114,   777,  1737,  1724,  1739,
       9,    10,  1742,  1743,  4762,  1745,  1746,  1747,   310,  1749,
    1750,   669,  3363,  3364,   351,   465,  4837,   171,   172,   184,
     695,   186,   176,  2103,  1764,  1765,  1766,  1767,  1768,   310,
    1770,  1771,  1772,   691,   497,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  2430,  1783,  1784,  1785,  1786,  2111,  1788,  1789,
    2987,  1791,  1792,  1793,  1794,  1795,  1796,  1797,    15,   734,
    1800,  1801,  1802,  1803,   625,  1805,  1806,  1807,  1847,  1809,
    5593,  1811,   310,  1813,   437,   772,   496,  1817,  1818,  1819,
       9,    10,  1822,  1823,  1824,  1825,  1826,   484,  1828,  3620,
     651,   189,   569,     9,    10,  1835,     9,    10,   772,   289,
     290,  3950,  1842,  1843,  1844,  1845,     9,    10,  1834,  2401,
     297,   303,   607,  1853,  1854,  1834,  1856,  1857,  3649,   273,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  2804,  2426,  1875,  2634,  3354,   303,  3356,
    5468,  3771,  3168,  5468,  5468,  5737,  5468,  5739,  1837,   223,
     695,  5220,  5468,  2401,  3570,  5468,   461,   607,   432,   433,
    3779,   110,   111,   237,   283,   772,  5904,  5263,   125,   569,
    3538,   374,     9,    10,   353,   184,  1916,   186,  2426,  5441,
     490,  1921,  3713,   140,   115,  1874,   563,  3718,   446,   734,
       6,  1931,  3773,   346,   772,   564,     9,    10,  4834,  4835,
    4836,   391,     9,    10,    61,     9,    10,    42,     9,    10,
     310,     9,    10,   118,   171,   172,   265,     9,    10,  1908,
     125,     9,    10,   560,  5931,  5932,    93,  4698,  4699,  3075,
       9,    10,   727,   392,     9,    10,  2505,  2506,   610,     9,
      10,   446,     9,    10,   607,   171,   172,  4856,   278,   743,
     635,   769,    68,     9,    10,   184,     6,   186,  1998,  1447,
     217,     9,    10,   648,   846,  4011,   576,  3136,   184,   595,
     186,   184,  3640,   186,   694,   465,  2545,     9,    10,   146,
     252,   184,   117,   186,   487,   190,   333,     9,    10,   686,
    2030,  5553,  2032,   128,   303,   772,  3710,   772,    33,  5057,
     135,  4150,  4151,  4912,   500,  4154,  4155,   772,   890,   462,
    4009,  4160,  4161,  2727,   412,  5073,   772,  3685,    68,  3687,
    3688,   171,   172,   772,  2995,  3693,  2066,  2596,   447,     9,
      10,   437,   167,  3701,   772,   770,   594,  5158,  3706,     9,
      10,  2610,  4191,  5439,   374,   772,   572,   184,   544,   186,
     299,  3620,     9,    10,  5112,  5358,  5114,    92,  2662,   736,
    2690,   666,   772,  2690,   333,  3462,  2055,   736,  2848,  2958,
     582,   184,   772,   186,   303,  4512,  4513,   184,  4832,   186,
     184,   238,   186,   184,   356,   186,   184,   303,   186,   594,
     303,  2889,   184,   228,   186,    83,   184,  2895,   186,   772,
     303,   560,    32,   772,    34,   184,  2095,   186,  2796,   772,
     772,  2151,  2910,  2102,   184,  2104,   186,   184,   564,   186,
     775,  4387,  2628,  3520,   259,   374,  5771,  5772,   184,   476,
     186,    61,  2701,   121,    10,  2727,   184,   769,   186,    15,
    2881,   458,  2182,  2884,  3713,     9,    10,  2888,  3037,  3718,
    3975,  3976,   184,  1885,   186,   485,  2145,    18,  3047,   769,
    3542,  3598,   184,  3542,   186,  3990,   303,   164,  5730,   204,
     770,  3142,  3772,  3796,  3797,  3798,  3799,  2832,   525,  2727,
     497,     9,    10,   679,   445,     0,   560,   613,   564,  4026,
     303,   644,    93,     9,    10,  2916,   303,   423,  3729,   303,
    3729,   607,   303,   662,   184,   303,   186,   476,   450,  2198,
    5513,   303,   484,   210,   184,   303,   186,     9,    10,   745,
     167,   570,   146,    80,   303,   251,  3395,   184,   303,   186,
     143,     9,    10,   303,    91,   584,   303,  5008,   487,  5010,
    1972,  5177,  3411,   278,   105,   106,  3574,   303,   564,   125,
    3578,     9,    10,   192,   251,   303,   525,   769,     9,    10,
    3406,  3407,  5894,    11,   140,  2305,   205,     9,    10,   723,
    2839,   303,  2841,   423,  2314,  2315,  2305,  5048,     9,    10,
     772,   303,  2271,   325,  3430,    80,   558,   589,  2277,   277,
     736,     9,    10,   719,   563,   171,   172,    18,  3830,  3744,
    3827,  3828,  5943,  5942,  2305,     9,    10,   772,  2305,  3836,
    5797,  3838,  5433,  3840,  2046,    79,   229,   174,    82,  5228,
     184,   727,   186,   303,   263,   192,   772,  3829,    24,  3127,
      49,    81,   593,   303,   518,   595,   653,  3774,   205,   581,
    2072,   217,  2305,  5529,  4175,  3774,   303,    97,   374,  5836,
    5837,  2391,     9,    10,    42,   279,   184,  5128,   186,  2928,
     736,  2401,  2931,  2932,  2933,   667,   772,   149,   184,  2409,
     186,  5767,  2401,  5769,  5770,  2739,   126,   374,   126,  3776,
     753,   238,   132,  5552,   105,   106,  2426,  2751,  2428,   386,
      61,  2431,   184,  2433,   186,   177,   263,  2426,   345,  2428,
    2401,  2441,  2442,  2305,   265,    63,   184,  5828,   186,   451,
    5831,   668,   681,  3930,   686,  3932,   112,   659,   182,   169,
     736,  4570,   606,   353,    63,  2426,   184,  2428,   186,   117,
     397,  2428,   399,   184,  3387,   186,  6068,  6069,  2401,   303,
     128,  2305,   184,  2469,   186,     9,    10,   135,    15,    12,
    2469,   352,   408,   184,    61,   186,   238,   589,  5945,   415,
     753,   770,   120,  2426,    69,  2428,   184,   736,   186,     6,
       9,    10,  2204,  5659,   746,   303,   660,     9,    10,   167,
     184,   120,   186,   100,  4315,  5881,  5882,   303,   402,  5885,
    5399,   488,   476,  2533,  2534,  2535,   112,   110,   111,  2401,
     264,  3472,    65,  3133,  4550,   176,  3133,   531,     9,    10,
    4812,   303,   451,  4815,  2878,  4817,  2880,   299,   208,  4187,
    4188,  4189,  2886,  2887,  2426,   303,  2428,   184,  4816,   186,
    4818,    68,   140,   442,   340,   667,   437,  2401,   439,   229,
     228,     6,  3829,   772,   265,   303,  5051,  4849,  3835,  4851,
    4852,   402,   303,    95,  3841,  3220,   772,   115,   125,   772,
     165,   303,  2426,   560,  2428,   479,  3231,  2607,  5989,   772,
    5966,   259,   303,   140,   753,   233,   714,   518,   183,   563,
     489,  4730,    93,   125,   451,   303,   777,    57,  2628,  2628,
       9,    10,  2632,  2633,   233,  2635,  2636,  4746,  4747,   303,
       6,  2981,  2628,    68,  2644,  3396,  2646,     9,    10,   503,
     416,   505,   506,  4281,  4282,  4846,  4284,   391,  4535,  4936,
     184,    17,   186,   281,  3289,  4473,   520,    95,   529,  4477,
     288,   192,   406,  3347,  2674,   772,    32,   772,    34,   777,
     497,   299,   281,    57,   205,   184,   303,   186,  2688,   288,
     217,   560,   184,  3318,   186,   123,   100,   265,   316,   772,
     299,  2701,    68,   770,  2704,   606,   770,     9,    10,   770,
     296,   284,   770,     9,    10,    89,   700,   316,   770,   149,
       9,    10,   770,   184,   128,   186,   265,  2727,  2728,   297,
     251,   770,     9,    10,   718,     9,    10,   681,  2727,   100,
     770,  2690,   586,   770,  3369,   100,   607,   177,     9,    10,
    2750,   272,     9,    10,   770,  5967,     9,    10,  4555,   660,
    2709,  4001,   770,  3444,   618,   619,  2727,    57,     9,    10,
    3444,  3620,     9,    10,  6127,   149,  5804,   704,   770,   303,
     707,   185,   525,   759,  4367,   714,  4315,   466,   770,   449,
    2768,  2791,   736,  4467,   770,  3347,  5856,     6,  4409,  4410,
     316,   374,    11,   177,   303,   184,    15,   186,  3148,   679,
     377,   303,   379,  4053,  6026,  2801,  3574,  6029,     6,   123,
    3578,   149,   184,   483,   186,  4436,  3757,  1150,  4456,   500,
     770,  3960,   668,  4507,    57,  2835,  5981,  5982,   682,  3347,
     770,  3370,   303,    26,   274,    17,  4457,   414,   777,   177,
    4478,   565,   566,   770,  6066,  1178,   374,  2806,  3387,   149,
      32,   731,    34,   381,  3713,  2727,    89,  5332,  4553,  3718,
    5335,  5336,   728,  5933,  5729,  3729,   443,  5732,   396,   237,
      68,   352,   184,    57,   186,  4005,    95,   177,   184,   152,
     186,   735,  3444,  3359,  5641,   184,  6041,   186,   577,   559,
     274,   419,  4008,  2727,   425,   584,  3470,   184,  6047,   186,
     184,   772,   186,   592,   487,    89,   620,   115,    32,   759,
    4717,  2921,  5669,   184,   303,   186,   149,   184,   642,   186,
     770,   184,   130,   186,  6073,  2935,  3444,  2937,   769,    94,
      94,   303,  4948,   184,    58,   186,   770,   184,  4439,   186,
     333,   704,   769,  5215,   177,   708,    70,   112,   112,   776,
     777,   331,    83,   675,   505,   506,   437,   777,   439,  2918,
     674,   683,    93,   329,    17,   149,    90,   689,   721,   520,
     640,   292,   770,   294,   274,   253,   665,  1460,  1461,    32,
      99,   347,  4349,  2993,   770,  5850,   264,   353,    69,  4756,
     121,   303,  5857,   177,  4761,  1415,   524,   303,  1418,  1419,
     124,   753,   579,  3771,   303,   284,   758,   759,   770,   537,
     141,  1494,   769,   379,    28,   146,   303,   770,    32,   303,
     777,   639,   770,    37,    10,  2727,   419,   406,  5503,   557,
     112,  3605,   303,   753,   754,   755,   303,   726,   615,    95,
     303,   274,   770,   769,   125,   661,  3396,  2749,   529,   770,
      93,   777,   303,  2195,   185,  2757,   303,  2199,   770,  3598,
     736,  3110,  4319,  4320,  4321,  1331,  4323,   618,   619,   770,
     448,  1337,  1338,  1524,  4331,  4332,  4333,  4334,   696,   661,
    4718,   699,   770,   476,   165,   263,  4724,  4725,  4726,   213,
     274,    95,  4787,  4731,  4732,   770,   770,   772,   141,  4737,
     654,  5220,   183,   146,  5969,  5970,   759,  4745,   726,   291,
     292,  4749,  1563,  1564,   171,   172,   734,   770,  4756,   772,
     770,    36,  4760,  4761,  1624,  1625,   607,  1029,  1628,   776,
    2832,   714,   525,    10,   115,  4930,  4931,  5256,    15,  4396,
    4947,   769,   185,   770,  2846,  1047,   277,   329,     9,    10,
    4266,  1053,  1054,   681,   115,   770,   280,   772,   239,   240,
     769,    93,    94,   115,  3160,   347,   777,  3729,   696,    49,
     563,   353,   297,   770,  3133,   772,  3135,    92,  4545,   770,
     770,   772,   772,   758,   759,   760,   761,   762,   763,   770,
     943,   772,  3202,  3203,  3204,   758,   759,   379,  3208,    84,
     115,  3211,   725,  3202,  3203,  3204,  3967,  3968,  3969,  3970,
    3220,  3729,   770,   777,   772,   130,     9,    10,  5608,  3229,
     770,  3231,   772,  3233,  3558,  3235,  3236,  3237,  3238,  3239,
    3240,   263,  3242,   522,   523,  3774,   770,   526,   527,   528,
    3250,   649,  3252,  2945,   425,  3255,  3256,  3257,   125,   734,
    2952,  2953,  4822,  5551,  3264,  3265,  3266,  3216,  3268,  3218,
    3270,   770,  3272,   140,  3274,   770,  3276,   772,   770,  3202,
    3203,  3204,   251,   397,  3284,   399,  3286,   769,  3288,  3289,
    3290,  3291,  3292,   270,   770,  3295,   772,  3297,   681,   204,
    3300,    76,  4542,  3928,   171,   172,   770,  4918,   772,   770,
     770,     5,   772,  3313,  4321,  4066,  4323,   770,  3318,   772,
     776,  3321,   192,  3323,  3324,  3325,  4333,  4334,  3328,   770,
     770,   772,   772,  3862,  3334,   205,   770,   776,   772,  3339,
    3202,  3203,  3204,    93,    94,  4103,  4104,  3347,  3348,   770,
     217,   772,   460,   736,  3354,   770,  3356,   772,  3347,  3359,
    3359,   742,   743,   374,   745,   721,   747,  3353,    69,  3369,
     770,  3371,   772,  3359,   110,   111,  3376,  3906,  3202,  3203,
    3204,  3945,   770,  5232,   772,   770,  3347,   772,   772,   772,
    4877,   770,    95,   263,  4881,   770,   112,   772,   770,     6,
     772,   184,   272,   186,     3,     9,    10,    11,   770,  4871,
    3410,  3410,  3412,   522,   523,  4331,  4332,   526,   527,   528,
    5094,  3410,  1814,  1815,  3410,  4531,  4532,  3410,   770,    28,
     772,  3410,   770,    32,   772,   549,   550,  3410,    37,  1182,
    3440,    40,  3410,   681,  3444,  3974,    76,  3410,    78,  3410,
    3410,    69,  4857,  3410,  4560,  3444,  3796,  3797,  3798,  3799,
    2268,    68,     9,    10,   165,   476,  4315,   372,   770,   599,
     770,  3471,   772,   770,   770,   772,   770,   639,   772,  3478,
    2288,   770,   183,  3444,   770,  3347,   772,  3410,   770,  2297,
     772,    69,   770,   770,   772,  2303,   770,  3483,  5174,    98,
    3500,   465,  3502,  2311,  4995,    36,  4995,   125,   576,   770,
      17,   769,  4041,   770,  5740,  2323,  4080,   770,  2326,   419,
     303,  3444,   770,  3347,   772,    32,   770,    69,   772,   770,
      34,   695,  5160,   770,  5162,  5146,  5164,   180,   239,   240,
      57,    53,    54,    55,    56,   270,   557,   165,  3410,   721,
    1293,    58,   563,   180,  5351,   425,  1299,    61,   772,   333,
     159,    92,   416,    70,  5413,   183,  4701,   770,  4703,   772,
    3570,  4706,    89,   770,  4709,   772,   476,  4712,  4713,   114,
     184,   451,   186,    90,   115,   348,  3410,   165,   105,   776,
     770,  3591,   772,   707,   769,   107,   108,   109,  5226,   130,
     374,     9,    10,   614,   151,   183,   110,   111,   944,   769,
     946,   947,   948,  4748,   197,   122,   952,   124,   954,  3619,
    3444,   239,   240,   165,  4871,   769,   130,  3967,  3968,  3969,
    3970,   769,   149,   416,   769,  3584,   130,   184,  1381,   186,
     769,   183,   249,   250,   769,  3645,  3646,   769,   728,   161,
     162,   770,   259,   772,   770,  3347,   772,   769,  3607,  3608,
     177,   239,   240,   563,   438,   196,   769,   171,   172,  3669,
     681,   278,   176,   204,   333,   769,   180,   171,   172,   769,
     585,  3681,   770,   769,   772,   756,   757,   758,   759,   760,
     761,   762,   763,   770,   770,   772,   772,   239,   240,   303,
     204,   728,   476,  5582,   770,   769,   772,  5586,  3657,   720,
     204,  3711,  3712,   769,  1457,   374,   315,   770,   769,   772,
     232,   770,    34,   772,  1467,   736,  4066,   769,   270,  3729,
     769,   769,  1475,  5959,   770,    97,   772,   769,     9,    10,
    3729,  4389,  4150,  4151,   769,   769,  4154,  4155,  3748,    69,
    5426,   525,  4160,  4161,     9,    10,   303,   274,   191,  3748,
     419,  4512,  4513,  4087,   769,   166,   365,    57,  3729,   770,
     132,   772,   769,   280,   278,   770,   184,   772,   186,   438,
     650,   681,   769,   557,   278,   292,   769,  3748,   693,   563,
     769,  3748,   304,   191,  4419,  5423,   769,   769,   302,    89,
     770,   668,   772,  5200,   769,   191,  3729,   156,     9,    10,
    3810,  5200,   770,  5668,   772,   105,  3816,   476,   191,   769,
     110,   111,   769,  3823,   117,  3748,  3826,  3816,   741,   770,
     334,   772,   770,   769,   772,   128,   736,  1580,   770,  1582,
     772,   372,   135,     9,    10,   165,   770,   265,   772,  5728,
    3850,  3851,  5701,  4534,   769,   769,   726,   464,   266,   149,
    4534,   769,  4487,   183,   734,   769,   525,  3729,   769,  4494,
     374,  5547,   772,   197,   770,  3875,   772,  3877,   769,  3879,
     374,  3881,   770,   770,   772,   772,  3748,   177,   400,   770,
     397,   772,   399,  3816,    95,   303,   769,  5694,   557,   770,
    3900,   772,  5908,   769,   563,  5310,  5311,   681,  5313,   770,
     770,   772,   772,   184,   769,   186,   769,  4848,   777,   239,
     240,  3921,  3922,   374,  3748,   769,   525,  5062,  3928,   184,
    3930,   186,  3932,   769,   769,   228,   769,  3937,   769,   769,
     769,   769,   769,   769,  3636,  3637,  3638,  3639,   769,  3641,
    3642,   769,   769,  5627,  3816,   769,   468,     9,    10,    11,
     769,   769,   736,   562,   563,   769,   259,   566,   419,   769,
     569,   570,     9,    10,    11,  3975,  3976,  5468,   769,  5468,
     769,   485,  4534,   184,   274,   186,   197,  4688,   769,   769,
    3990,   485,  3816,   769,   772,   266,  4697,  3689,  3690,   348,
    3692,   769,  3694,  3695,  3696,  3697,  3698,  3699,  3700,   769,
    3702,  4011,   769,  3705,   769,     9,    10,  3709,   184,   576,
     186,   533,   681,   535,  4705,   476,  4534,  4367,   540,   769,
     110,   111,   303,   753,   769,   769,   635,  5711,   769,  4025,
     769,   296,   769,   550,   180,   394,  4025,  1790,   303,   648,
     130,   769,  4616,    95,   585,   654,  1799,   758,   759,   760,
     761,   762,   763,   670,   671,   672,   673,  1810,   180,   769,
     769,   769,   769,   769,  4074,  4075,   769,   736,   769,   678,
     442,   769,   339,   340,  5489,   684,  5491,  5492,   687,   769,
     769,   171,   172,   605,   769,  4659,     9,    10,   769,    93,
     266,   700,   303,   769,   769,   769,   557,  4107,   769,   708,
    5907,   769,   563,   772,   769,   237,   661,  4117,   679,   376,
    6126,   777,   721,   722,   204,   474,   777,   489,   777,  4129,
     777,  4131,   184,   777,   186,   777,   648,   303,   756,   757,
     758,   759,   760,   761,   762,   763,   777,   184,   652,   186,
     769,   658,   777,  4708,   777,   754,   777,  5554,  5555,   416,
     777,   424,   693,   614,  5838,  5554,  5555,   141,    93,   679,
     695,   770,  4512,  4513,   667,   500,   418,    93,    34,   757,
     758,   759,   760,   761,   762,   763,   772,   536,   787,   123,
     184,   553,   186,   772,   574,   772,   795,  1940,   278,   348,
     707,  1944,   801,  1946,   803,    61,   555,   556,    11,   772,
      93,   560,   561,   562,   756,   757,   758,   759,   760,   761,
     762,   763,   302,   730,   823,   382,   738,   571,  4267,   772,
     681,    34,   772,   832,   690,   597,   734,   749,   742,  5915,
     753,    80,   451,   451,    94,   844,  4819,   846,  1991,   772,
     196,   303,  4252,   265,   110,   111,   281,   100,    61,  2002,
     125,    26,   238,    61,   396,     5,   303,   778,   575,   720,
    2013,   184,   395,   186,   130,     4,   734,   777,   416,   628,
    3972,   880,   340,   882,  5138,   736,   885,   886,   887,   888,
     889,   890,   776,   892,   374,   776,   769,   769,   203,  6096,
     379,    29,   769,   769,   769,  5979,  4345,   110,   111,   303,
      38,   197,  5940,  6110,  4314,   171,   172,   777,    93,  6116,
     176,   772,   769,    49,   180,  6122,    93,   130,   677,    14,
      67,    93,    60,   772,   777,    84,   777,   419,   595,   151,
     125,   695,     9,    10,   943,   770,   945,   769,   204,  5050,
     497,   112,  5053,  5054,   953,   612,   955,   296,   553,    87,
      95,  4361,   240,     9,    10,    93,  2109,   123,   171,   172,
      98,   970,   296,   176,   769,  6051,   776,   180,   151,   772,
     637,   769,     6,  2126,   112,   416,   770,    49,   770,  4081,
     303,   753,   754,   755,  2137,  2138,   770,    68,   324,   127,
    4929,   204,   772,   770,   770,   485,   134,   770,   777,   640,
       9,    10,   777,    93,    93,    15,  4416,  4417,    18,  4419,
     677,   777,   278,   151,   770,   770,   769,   164,    95,   770,
    4430,  4431,  4432,   140,   171,   172,   756,   757,   758,   759,
     760,   761,   762,   763,   100,  4445,   302,  4447,   176,    95,
     769,   772,    57,   115,   270,   772,  4780,    57,   772,    93,
    4460,  4461,   760,   772,   777,    34,   772,   679,   760,    33,
     125,   480,    36,   210,   692,   278,   440,  2220,   334,   205,
      93,   772,   424,   679,    89,   770,    86,  4487,   769,    89,
     772,   769,   220,   416,  4494,   778,    95,   225,   226,   302,
     105,   196,   125,  4503,   772,   105,   106,   238,    49,   351,
     218,   239,   500,   500,   251,   500,   500,   184,   374,   186,
     348,  1120,    42,   379,   772,   251,   772,   500,    92,   500,
     192,   334,    96,   753,  4534,    84,   667,   270,   184,     6,
     186,   587,   734,   205,   149,  4534,  4546,   664,   770,   149,
    4550,   115,   128,   770,   770,    96,   400,   770,   350,   188,
    5666,   128,   772,   770,   769,   357,   130,  4553,   168,    26,
     298,   374,   177,  4534,   115,   777,   176,   177,   104,   428,
     229,   373,  1181,  1182,   777,   184,  5138,   186,   656,   407,
     769,   383,   384,   385,   470,   470,    33,   117,   772,    36,
     326,   393,   770,   586,    29,   772,  5537,   296,   128,  1208,
     272,  4534,   340,  4613,  5468,   135,  1215,   725,  1217,   283,
     379,   769,  1221,  1222,   468,  2356,   294,   215,  5329,   485,
    5138,  2374,  2375,   361,  2377,  2378,   303,   374,    17,   177,
     204,   294,   772,   694,   201,   185,    95,   167,   180,   386,
     453,   772,  1251,  2396,   772,    92,   635,   303,   270,    96,
     180,   116,   742,  2406,   123,   265,   641,   770,   770,   274,
     770,  5200,   416,   273,   274,   275,   402,   770,   115,   760,
     244,  4702,   485,  6088,   770,   770,   770,    95,   759,   533,
    1289,   535,   769,   130,  1293,  4716,   540,   770,  5804,   425,
    1299,  1300,  1301,   244,   303,   433,   770,   770,   228,   770,
    4534,   770,  4733,  5819,   278,   770,   770,    29,  1317,   772,
     770,  5273,   263,   770,  4673,   451,    38,  1326,   772,   770,
    4751,   770,  4753,  4754,   770,   770,   238,   278,   772,   259,
     532,  1340,  1341,   772,   772,   777,   770,  5853,    60,   770,
     769,   488,   769,   769,   546,   763,   196,   770,   769,   196,
     366,   605,  1361,   425,  4764,  5273,   265,   204,   582,   265,
     265,   753,   270,   499,    99,    87,    95,  4777,  4778,    42,
     772,    93,  1381,  1382,    93,   326,    98,    93,   769,   451,
     494,   391,  4741,    95,    42,   772,   652,   769,   606,   399,
     112,  4787,  1401,  4495,   648,   772,   772,   244,   372,   777,
     770,   237,   777,   770,   777,   127,   772,  1416,   772,    62,
    4819,     6,   134,   560,   661,   772,  4518,   724,   772,    93,
     568,   128,  2575,  4819,   128,  1434,  1435,   499,  2581,   151,
    4819,   278,   740,   428,  1443,   538,   574,   769,   548,   652,
     251,   251,   649,   251,   117,   647,  4856,   251,  1457,   251,
     299,   402,   180,   769,   176,   128,    93,  1466,  1467,   117,
     266,   753,   135,   753,   753,  1474,  1475,   772,   725,  1478,
     128,   753,   753,  5641,   753,   753,   742,   135,   499,  1488,
     753,   753,   684,  5577,   738,   753,   753,   126,   753,  4591,
     753,  5453,   753,   416,   167,   749,   698,   753,   220,  5473,
    4949,  5669,  4912,   225,   226,   753,  5468,   180,   753,   167,
     753,   753,   753,   753,   650,   770,   753,   239,   654,   753,
    4930,  4931,   180,   595,   753,   372,   770,   305,   280,   742,
     753,   770,   568,  2686,   770,  5453,   284,   772,  4948,  4988,
     141,  2694,  2695,  2696,  2697,   777,   777,   772,   769,   321,
    5468,   745,   270,  4963,   497,   228,   270,   777,   777,   270,
     696,   270,   772,   380,   636,   123,   770,   122,  1577,  4671,
     228,  1580,  4982,  1582,  4984,   416,   298,   122,   777,   770,
     770,   770,   654,  1592,  1593,   191,   259,    26,  5037,   770,
     726,  1600,  5002,  5042,  5004,  1604,  1605,   777,   734,   777,
     770,   259,   759,  6119,   759,   770,   770,  4966,     7,  5040,
     772,   585,   688,   769,   270,  5554,  5555,   769,   340,   576,
    1629,   326,    95,  1632,   696,    95,   284,   699,  2781,    95,
    5724,    95,  4734,  4735,   772,  5803,   265,   777,   265,   361,
     482,   211,    41,   777,   772,   177,  5608,   759,  4750,    11,
     299,  1660,   776,   310,   726,  2808,   769,   753,   534,   753,
     321,   772,   734,    92,    63,   180,   180,    10,   270,   128,
     128,   772,  4774,   770,    73,   396,   396,   265,   265,   350,
    1689,   265,   219,    11,   769,   636,   357,   769,   100,   769,
    5608,   177,   177,   449,   704,   224,   760,   707,   777,   650,
      99,  5060,   373,   654,   151,    72,   716,   270,   576,   760,
     114,   433,   383,   384,   385,   180,   115,   340,   151,   693,
      56,   120,   393,  2876,   124,   770,   124,   770,  5138,  5820,
     770,   177,  2885,   770,   769,   777,  2889,   185,   585,  5138,
     772,   772,  2895,   770,   770,   769,   122,   146,   699,   777,
     770,    26,   769,    18,   753,   769,    95,  2910,   220,   770,
      95,   211,   770,   151,  5174,   772,   770,  5138,   769,   772,
     770,   777,  6113,   296,   211,   726,   772,  5173,  5188,   769,
     769,  1790,   545,   753,  5173,   772,   681,   681,   396,  5188,
    1799,   180,    57,  5203,   769,   284,   284,   769,  2939,  2940,
     366,  1810,    11,   772,   770,  5138,   186,   772,   265,   435,
     372,   196,  1821,   196,   270,  2956,   407,   216,  5228,   196,
      26,    86,   732,   196,    89,  2966,  2967,   407,  1837,   129,
     696,   129,   196,   696,   233,   196,   583,   196,   196,   196,
     105,   106,   241,   270,  5293,    11,   693,   428,   770,   770,
     229,    99,   574,   413,   492,  5188,   770,    26,   299,   770,
     235,   532,   494,  5273,   635,  1874,  5138,  1876,   770,   185,
      26,   772,   770,   272,  5273,   546,   772,   770,   142,   196,
     770,   772,   281,   282,   149,   770,   772,   436,   146,  1898,
    1899,  3032,  3033,  3034,  3035,   769,  4998,  5773,   744,  1908,
    1909,   140,  5273,   168,   196,    11,   180,   667,   770,  1918,
     284,   176,   177,   284,   143,   769,  5188,   177,  5328,   584,
     177,   112,   130,  1932,  1933,   732,   204,   732,   216,  1938,
    1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,   777,   180,
    5273,   596,   180,  1952,   374,   475,   266,   230,    95,   428,
     299,   576,   123,   416,  5188,   770,   770,  1966,  1967,  6053,
    1969,   632,   141,   488,   538,   606,   124,    32,  5070,   770,
     770,    26,   770,   772,  3127,   770,   647,  3130,   770,   770,
     777,    10,  1991,   769,   772,   769,  5960,   646,   770,  5399,
     770,    11,   769,  2002,   769,  5097,    26,    79,  3151,    26,
     265,  5273,   724,    26,  2013,   769,   319,   435,   273,   274,
     275,   769,   177,   684,    93,   769,  5426,   130,   130,    93,
     130,   772,   299,   769,   378,   770,   425,   698,   772,   660,
     411,   430,   299,   130,   151,   263,   772,   770,   538,   434,
     770,   676,   441,  5453,   770,   769,  2055,   575,   408,  5151,
      11,   416,  5448,   770,  5453,   770,   769,    67,  5468,   180,
    2069,    93,    17,   226,   772,  2074,   772,   226,    26,  5468,
      26,   265,    26,   400,   284,    84,    84,   263,   769,   777,
    5529,    33,  5453,   777,  5533,   576,  2095,   770,  5519,   281,
     770,   641,   594,  2102,  2103,  2104,   429,  5468,   594,   769,
    2109,   354,  2111,   769,   776,   769,   769,   776,   776,   190,
     770,    61,    61,   154,    33,   676,   576,  2126,   772,  5529,
    5453,    33,   770,  5533,   197,    10,   391,   770,  2137,  2138,
     687,   702,   177,    26,   399,  5468,  2145,  5547,   302,    26,
     123,   769,  5552,   180,   130,   769,   693,   769,   769,  6123,
     769,   130,   176,  5552,   732,   110,   111,   281,    61,   327,
      11,   417,    91,   576,    71,   576,   714,   641,   419,   769,
     407,   407,   769,   772,   770,   173,   230,   770,   776,   769,
     769,  5453,   776,   769,   769,   728,   769,   688,   580,  2198,
     772,   416,   769,    93,   340,   411,  5468,   770,  5608,   146,
     769,   600,   770,   326,   769,   226,   113,   180,   180,  5608,
    5659,  2220,   320,   229,   770,  2224,   197,   770,   772,  5552,
     281,    63,   621,   470,   770,    75,   770,   626,  5677,   416,
     714,  5641,    26,  2242,   641,   114,   177,  5608,  3391,   772,
     237,  3410,     9,    10,  3397,   769,   153,  2820,  3707,  5659,
    5160,   961,  5164,  5453,  5162,  1268,  5462,  5451,   657,  5669,
    5450,  3551,  2271,  5580,  5453,  4171,  5610,  5677,  2277,  5291,
    5752,  5681,  5961,   768,  4083,  5608,  1452,  3552,  4997,  5470,
    5552,  4318,  5868,  5867,  3748,  1497,    53,    54,    55,    56,
     689,  3786,  4949,   857,  4345,  2329,  1886,   252,  2841,  4041,
    3812,   980,  4838,  4362,  2313,  2998,   837,  4562,   263,  5668,
    2428,  2431,  2429,  2349,  2430,  2207,  5449,  4260,  5552,  5729,
    1493,  5448,  5732,  5272,  3669,  5080,  4504,  4508,  5826,  4917,
    5237,  2670,  2341,  5426,  2343,  5910,  5608,  5241,  6051,  2348,
     107,   108,   109,  5998,  6053,  5724,  2869,  4700,  4252,  5930,
    5588,  2360,  2361,  4768,  5267,  5043,  4261,  5806,  2367,  5982,
    5773,  5669,  5803,  5773,  5773,  2374,  2375,  3830,  2377,  2378,
    3088,  5806,  5820,  2270,  5608,  5341,  2278,  5773,  3911,  4474,
    4469,  4477,  6025,  2392,  5969,   490,   490,  2396,  5970,  5504,
    5857,  5934,  5850,  5322,   161,   162,  5806,  2406,  5808,  5320,
    5583,  2296,  4067,  4764,  2413,  4260,  5526,    17,  1283,  1471,
    3563,  3534,  2084,  2422,  3529,  5815,  2425,   184,  2987,   186,
    5340,  3574,  2245,  2808,  2686,  3578,  3802,  3167,   535,  4379,
     774,  3353,  3467,  1430,  1383,  5845,  1205,  1419,  3602,   704,
    5850,  4354,   707,  3402,  5866,  4495,  3288,  5857,  3284,  1818,
     405,   716,  3945,  4494,  1730,  5904,  1876,  1381,  2138,  2133,
    5308,  1381,  1381,  1381,   419,   232,   421,  5012,  1698,  4547,
    5758,  4957,  2154,  5759,  1381,  2128,  3937,  1704,  3594,  2924,
    5839,  3622,  3623,  4655,  3625,  3626,  4654,  3935,  5232,  5351,
    5701,  4936,  5228,  3598,  5904,  1411,  5246,   452,  5908,   780,
     110,   111,  1437,  4659,   508,  5915,  2918,  3119,   490,  1638,
    2010,  3160,   467,  3483,  4947,  4963,  3633,  4546,  4544,   697,
    5907,  2341,  2777,  3461,  5934,   880,  1958,   688,  5938,   881,
    2778,   688,  5981,  5982,  1433,   525,   303,   304,  5354,  2835,
    5256,  4382,  1642,  2073,  6049,   500,  5017,  6076,  5317,  6116,
    6122,  4555,  1051,  5655,   980,  2797,  4534,  5967,  3442,  5969,
    5970,  3347,   687,   518,   471,  2611,  2575,  6016,   687,  2731,
    2406,  5930,  2581,  3421,  3420,  3716,  2102,  1186,  1900,  1634,
    4186,   684,  3395,  2981,  3790,  4673,  5393,  4267,  2597,  3545,
     728,   514,  6041,  1327,   501,   502,   490,   504,   505,   506,
     507,   508,   490,   510,   511,   512,   513,   514,   515,   516,
     517,  6014,   519,   520,   521,   490,  6026,    -1,  3771,  6029,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6080,    -1,   400,    -1,    -1,    -1,  5996,    -1,    -1,
      -1,  6051,   252,    -1,   599,    -1,    -1,    -1,    -1,  3802,
      -1,   606,    -1,    -1,    -1,    -1,  6066,    -1,    -1,    -1,
      -1,   616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   629,  2684,  2685,  2686,    -1,    -1,
      -1,  2690,    -1,    -1,    -1,  2694,  2695,  2696,  2697,    -1,
      -1,    -1,    -1,  2702,  2703,  5797,  2705,    -1,    -1,    -1,
    2709,   468,    -1,    -1,    -1,   660,    -1,    -1,   663,    -1,
      -1,   618,   619,    -1,    -1,    -1,  6126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   679,    -1,    -1,    -1,    -1,  2738,
    2739,  5833,  5834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     695,  6100,  2751,    -1,    11,  5847,    -1,  6106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,   535,    -1,
      -1,    -1,  2781,   540,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2797,  2798,
      -1,    -1,    -1,    -1,    -1,   405,    -1,  2806,  2807,  2808,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
      -1,   421,    -1,    80,    -1,    -1,    83,  5919,    -1,    -1,
    5922,    -1,    -1,    -1,    91,    -1,    93,    -1,  2837,    -1,
      -1,    -1,    -1,   100,    -1,  2844,    -1,   104,   605,  2848,
      -1,    -1,   452,  5945,    -1,    -1,    -1,   114,    -1,    -1,
     117,    -1,    -1,    -1,   121,    -1,   123,   467,    -1,    -1,
      -1,   128,    -1,    -1,  2873,  2874,  2875,  2876,   135,  2878,
      -1,  2880,    -1,    -1,   141,    -1,  2885,  2886,  2887,   146,
    2889,   648,    -1,    -1,    -1,    -1,  2895,    -1,    -1,    -1,
     500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     167,  2910,    -1,    -1,    -1,  2914,    -1,    -1,   518,  2918,
    2919,    -1,    -1,   180,    -1,    -1,    -1,    -1,   185,  4072,
    4073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4103,  4104,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,   738,  2981,    -1,    -1,    -1,    -1,    -1,  2987,    -1,
      -1,    -1,   749,    -1,    -1,    -1,    -1,    -1,    -1,   599,
      -1,    -1,   259,    -1,    -1,    -1,   606,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   616,   110,   111,    -1,
     277,    -1,   115,    -1,    -1,    -1,   283,   284,    -1,   629,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,   299,    -1,    -1,   302,    -1,    -1,    -1,  3048,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3057,    -1,
     660,    -1,    -1,   663,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4205,    -1,    -1,  4208,    -1,   679,
    4211,  4212,  4213,  4214,    -1,  4216,  4217,  4218,  4219,    -1,
    4221,  4222,    -1,  4224,    -1,    -1,    -1,  4228,    -1,    -1,
     193,  4232,  4233,  4234,  4235,    -1,  4237,  4238,    -1,    -1,
      -1,  3110,  4243,  4244,    -1,    -1,  4247,  4248,    -1,    -1,
    3119,    -1,  3121,    -1,    -1,    -1,    -1,    -1,  3127,    -1,
       5,  3130,     7,     8,  3133,    -1,  3135,  3136,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,  3148,
      -1,    -1,  3151,    38,    -1,    -1,    31,    -1,    33,    -1,
      -1,   254,   255,   256,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,    -1,    61,    -1,    -1,    -1,
     447,    76,    -1,    78,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    87,    -1,    -1,    80,    -1,    -1,    93,   302,
      -1,    -1,    -1,    98,    -1,    -1,    91,  3216,    -1,  3218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,   334,   127,   336,    -1,    -1,    -1,    -1,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     353,    -1,   355,    -1,    -1,    -1,   151,    29,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,
      -1,   176,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,
      -1,    -1,    -1,   396,    -1,    -1,   181,    -1,    -1,    -1,
     185,   404,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,   196,    -1,    -1,    -1,    87,   419,    -1,    -1,    -1,
      -1,    93,    -1,  3332,    -1,   220,    98,    -1,    -1,    -1,
     225,   226,    -1,    -1,   219,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,  3365,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,   254,
     255,   256,    -1,    -1,   477,    -1,    -1,    -1,    -1,   151,
      -1,    -1,  3391,    -1,   487,    -1,  3395,  3396,  3397,    -1,
      -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,  3411,   298,   176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,
      -1,   524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   537,  3444,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   340,    -1,    -1,   220,   334,
    4603,   336,    -1,   225,   226,  4608,    -1,  3466,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   361,   239,  3477,    -1,
     355,    -1,    -1,   740,    -1,   578,    -1,   362,    -1,    -1,
      -1,   584,    -1,    -1,    -1,    -1,   753,    -1,    -1,   374,
      -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,   770,    -1,   772,    -1,    -1,   775,   776,
      -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   416,    -1,   408,   409,    -1,   298,    -1,    -1,    -1,
     415,    -1,    -1,    -1,   419,    -1,    -1,    -1,   433,    -1,
     643,    -1,   427,    -1,    -1,    -1,    -1,   650,    -1,  3558,
      -1,    -1,    -1,    -1,  3563,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   447,    -1,    -1,  3574,    -1,    -1,   340,  3578,
    4723,    -1,    29,  4714,    -1,  3584,    -1,    -1,   681,    -1,
      -1,    38,    -1,  3592,    -1,    -1,    -1,    -1,   473,   361,
      -1,    -1,   477,   696,   697,  4736,    -1,    -1,  3607,  3608,
      -1,    -1,   487,    60,    -1,    -1,   709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,   524,
      -1,    98,    -1,    -1,   416,    -1,    -1,    -1,  3657,    -1,
      -1,    -1,   537,    -1,   539,   112,    -1,    -1,    -1,    -1,
      -1,   433,    -1,    -1,  3673,    -1,    16,    17,    -1,   772,
     127,    -1,    22,    23,    -1,    -1,    -1,   134,    -1,   574,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       6,    -1,    -1,   578,   151,    -1,    -1,    -1,    -1,   584,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,   176,
      70,    -1,    -1,    -1,    40,    41,   611,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,   622,   623,   624,
      90,    -1,  3751,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,    -1,
      -1,    -1,  3771,   220,    -1,   650,    -1,    -1,   225,   226,
      -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,
      -1,  3790,   239,    -1,    -1,    -1,  3795,  3796,  3797,  3798,
    3799,    -1,    -1,  3802,   110,   111,   681,   147,   148,   115,
     150,    -1,   574,    -1,  3813,    -1,    -1,    -1,   158,   159,
     160,   696,   697,   129,    -1,    -1,    32,    -1,    34,    -1,
      -1,    -1,    -1,    -1,   709,  4978,    -1,   712,   178,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   298,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,    -1,
      -1,    -1,    -1,   340,    -1,    -1,    -1,   237,    -1,   205,
      -1,   776,    -1,   243,   110,   111,    -1,    -1,  3907,   115,
      -1,    -1,    -1,    -1,   361,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,   268,   269,
     136,    -1,   138,    -1,   140,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3946,    -1,    -1,
      -1,   291,   292,    -1,    -1,    -1,    -1,   263,    -1,    -1,
      -1,  3960,    -1,    -1,    -1,    -1,    -1,    -1,  3967,  3968,
    3969,  3970,    -1,  3972,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   433,   193,    -1,  3988,
    3989,    -1,    -1,  5136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   342,    -1,   344,   345,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4017,    -1,
     360,    -1,    -1,    -1,    -1,    -1,   332,  4026,    -1,    -1,
      -1,    -1,    -1,  4032,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,   254,   255,
     256,    -1,    -1,    -1,    -1,    -1,    -1,   397,   364,   399,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4066,    -1,    -1,
      -1,   277,    -1,  4072,  4073,    -1,    -1,    -1,    -1,    -1,
     420,    -1,   388,    -1,    -1,    -1,    -1,    -1,  4087,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,   443,  4103,  4104,    -1,    -1,    -1,    -1,
      -1,  4110,   418,   419,   454,   455,   422,    -1,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   574,   334,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   450,   451,   486,   353,    -1,   355,
      -1,    -1,   458,   459,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,   475,
      -1,    -1,    -1,    -1,    -1,   381,    32,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     396,   497,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      -1,   541,   542,   543,    -1,    61,    -1,    -1,    -1,   549,
     550,    -1,   518,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   566,   567,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4246,    -1,    -1,
     590,   591,    -1,  5396,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,  4261,    -1,    -1,    -1,    -1,    -1,   574,   609,
      -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,   588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   599,    -1,    -1,   602,   603,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   617,    -1,    -1,  4313,    -1,    -1,    -1,   524,  4318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   537,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4345,   653,    -1,  4348,
      -1,    -1,  4351,    -1,   660,    -1,    -1,    -1,    -1,    -1,
      -1,   701,    -1,    -1,   704,    -1,    -1,   707,  4367,    -1,
      -1,    -1,   578,   679,    -1,   681,    -1,    -1,   584,  5522,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,   277,    -1,    -1,    -1,   731,    -1,    -1,    -1,    -1,
      -1,   737,    -1,    -1,    -1,    -1,    -1,   643,    -1,    -1,
      -1,    -1,    -1,    -1,   650,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4465,    -1,   110,   111,
      -1,    -1,    -1,   115,    -1,   681,    -1,    -1,   334,    -1,
     336,    -1,    -1,  4482,    -1,    -1,    -1,    -1,    -1,    29,
     696,   697,    -1,    -1,    -1,    -1,  4495,   353,    38,   355,
      -1,    -1,    -1,   709,    -1,    -1,    -1,    -1,    -1,  4508,
      -1,    -1,    -1,  4512,  4513,    -1,    -1,    -1,   374,  4518,
      60,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4534,  4535,    -1,    -1,    -1,
     396,    -1,    -1,    -1,    -1,  4544,    -1,    87,   404,    -1,
      -1,   193,    -1,    93,    -1,    -1,  4555,  4556,    98,    -1,
      -1,    -1,    -1,   419,    -1,  4564,    -1,    -1,    -1,    -1,
      -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5716,  5717,   127,  5719,  5720,
    5721,  5722,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4603,    -1,    -1,  4606,  5751,  4608,
      -1,   151,   254,   255,   256,    -1,    -1,    -1,    -1,    -1,
      -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,    -1,    -1,    -1,   277,   176,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4646,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4655,    -1,    -1,    -1,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,    -1,
      -1,    -1,    -1,    -1,  4673,    -1,    -1,    -1,    -1,    -1,
     220,   537,    -1,    -1,    -1,   225,   226,    -1,  4687,    -1,
      -1,    -1,   334,    -1,   336,    -1,    -1,    -1,    -1,   239,
      -1,  5832,    -1,    -1,  5835,  4704,    -1,    -1,    -1,    -1,
      -1,    -1,  5843,   355,    -1,    -1,  4715,  5848,  4717,    -1,
      -1,    -1,   578,    -1,  4723,    -1,    -1,    -1,   584,    -1,
    4729,    -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,   381,
      -1,    -1,  4741,  4742,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   396,    -1,    -1,    -1,   298,    -1,
      -1,    -1,   404,  4762,    29,    -1,    -1,    -1,    -1,  4768,
    4769,    -1,    -1,    38,    -1,  4774,    -1,   419,    -1,    -1,
      -1,  4780,    -1,    -1,    -1,    -1,  4785,   643,    -1,    -1,
      -1,    -1,    -1,    -1,   650,    60,    -1,    16,    17,    -1,
     340,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,  4814,    -1,    -1,    -1,    -1,
      -1,   361,    87,    -1,    -1,   681,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    98,    -1,   477,    -1,    -1,    -1,    58,
     696,   697,    -1,    -1,    -1,   487,    -1,   112,    -1,    -1,
      -1,    70,    -1,   709,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,
      -1,    90,    -1,    -1,    -1,    -1,   416,    -1,    -1,    -1,
      -1,    -1,   524,    -1,    -1,    29,   151,    -1,    -1,    -1,
      -1,    -1,    -1,   433,    38,   537,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,    60,    -1,  4917,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,   148,
      -1,   150,    -1,    -1,    -1,    -1,   578,    -1,    -1,   158,
     159,   160,   584,    87,    -1,    -1,    -1,    -1,  4947,    93,
    4949,    -1,    -1,    -1,    98,   220,    -1,    -1,  4957,   178,
     225,   226,    -1,    -1,    -1,    -1,    -1,  4966,   112,    -1,
      -1,  4970,    -1,    -1,   239,    -1,    -1,    -1,    -1,  4978,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,  4987,    -1,
     134,    -1,    -1,    -1,   213,    -1,    -1,    -1,  4997,    -1,
      -1,   643,    -1,    -1,    -1,    -1,    -1,   151,   650,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   298,   574,    -1,    -1,    -1,    -1,   681,
      -1,    -1,    -1,    -1,    -1,   310,    -1,    29,   267,   268,
     269,    -1,  5051,    -1,   696,   697,    38,  5056,  5057,  5058,
      -1,  5060,  5061,    -1,  5063,    -1,    -1,   709,    -1,  5068,
    5069,    -1,   291,   292,  5073,   340,   220,    -1,    60,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   667,    -1,    -1,    -1,   239,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,  5108,
      -1,    93,    -1,  5112,    -1,  5114,    98,    -1,   694,    -1,
      -1,    -1,    -1,   342,    -1,   344,   345,    -1,    -1,    -1,
     112,    -1,    -1,    -1,  5133,    -1,    -1,  5136,    -1,   715,
    5139,   360,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,   416,   134,    -1,   298,    -1,    -1,  5156,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   397,    -1,
     399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,    -1,   340,    -1,    -1,    -1,
      -1,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   361,    -1,    -1,
      -1,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   454,   455,    -1,   220,    -1,
    5239,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,  5248,
      -1,    -1,    -1,    -1,  5253,    -1,    -1,   239,    -1,    -1,
     836,    -1,    -1,  5262,  5263,  5264,    -1,   486,  5267,    -1,
      -1,    -1,   416,    -1,    -1,    -1,   495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,
      -1,    -1,    -1,    -1,    -1,  5294,    -1,    -1,    -1,    -1,
    5299,    -1,    -1,    -1,  5303,    -1,  5305,    -1,    -1,   574,
      -1,    29,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      38,    -1,   541,   542,   543,    -1,  5325,    -1,    -1,    -1,
     549,   550,    -1,  5332,    -1,    -1,  5335,  5336,    -1,    -1,
    5339,    -1,    60,    -1,  5343,    -1,  5345,   566,   567,    -1,
      -1,    -1,  5351,    -1,    -1,  5354,    -1,   933,   340,    -1,
      -1,  5360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,   590,   591,    -1,    -1,    93,    -1,    -1,    -1,   361,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5388,
     609,    -1,    -1,    -1,   112,    -1,    -1,  5396,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   983,    -1,   127,
      -1,    -1,   988,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     574,    -1,    -1,   151,   416,    -1,    -1,    -1,    -1,    -1,
    5439,    -1,  1018,    -1,    -1,  1021,    -1,    -1,    -1,    -1,
      -1,   433,  1028,    -1,    -1,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   701,    -1,    -1,   704,    -1,    -1,   707,    -1,
    1066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5498,
      -1,    -1,   220,    -1,  5503,    -1,    -1,   225,   226,    -1,
      -1,   730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,  5522,    -1,    -1,    -1,    -1,  5527,    -1,
     749,    -1,    -1,    -1,    -1,  5534,    -1,    -1,    -1,  1115,
    1116,  1117,  1118,  5542,  5543,  1121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5569,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,  5583,    -1,    -1,    -1,  5587,    -1,
      -1,    -1,   574,    -1,    -1,    -1,    -1,    -1,    -1,  5598,
      -1,  5600,  5601,    -1,    -1,    -1,    -1,    -1,  5607,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   361,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5668,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5694,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1306,    -1,    -1,    -1,  1310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5748,
      -1,    -1,  5751,    -1,    -1,  5754,  5755,    -1,    -1,  5758,
    5759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5767,    -1,
    5769,  5770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5784,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5797,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5815,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5826,    -1,    -1,
      -1,  1407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   574,    -1,    -1,    -1,
      -1,  5860,  1438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5881,  5882,    -1,    -1,  5885,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1480,    -1,  1482,    -1,  5907,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5945,    -1,    -1,    -1,
      -1,    -1,    -1,  5952,    -1,    -1,    -1,    -1,    -1,  5958,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5966,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5996,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6013,  6014,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1640,    -1,  1642,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6096,    -1,    -1,
      -1,  6100,  1678,    -1,    -1,    -1,    -1,  6106,    -1,    -1,
      -1,  6110,    -1,    -1,    -1,  1691,  1692,  6116,    -1,    -1,
      -1,  1697,    -1,  6122,    -1,  1701,  1702,  1703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1712,  1713,  1714,    -1,
      -1,    -1,  1718,    -1,  1720,  1721,  1722,  1723,  1724,    -1,
    1726,    -1,    -1,  1729,  1730,    -1,    -1,    -1,    -1,    -1,
      -1,  1737,    -1,  1739,    -1,    -1,  1742,  1743,    -1,  1745,
    1746,  1747,    -1,  1749,  1750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1764,  1765,
    1766,  1767,  1768,    -1,  1770,  1771,  1772,    -1,    -1,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,    -1,  1783,  1784,  1785,
    1786,    -1,  1788,  1789,    -1,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,    -1,    -1,  1800,  1801,  1802,  1803,    -1,  1805,
    1806,  1807,    -1,  1809,    -1,  1811,    -1,  1813,    -1,    -1,
      -1,  1817,  1818,  1819,    -1,    -1,  1822,  1823,  1824,  1825,
    1826,    -1,  1828,    -1,    -1,    -1,    -1,    -1,    -1,  1835,
      -1,    -1,    -1,    -1,    -1,    -1,  1842,  1843,  1844,  1845,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1853,  1854,    -1,
    1856,  1857,    -1,    -1,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,    -1,    -1,  1875,
       5,    -1,     7,    -1,  1880,    -1,    -1,    -1,    -1,    -1,
      -1,  1887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    -1,   667,    -1,    -1,    -1,
    1916,    -1,    -1,    -1,    -1,  1921,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1931,    61,    -1,    -1,    -1,
      -1,    -1,    -1,   694,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2030,    -1,  2032,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2054,    -1,
     185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
    2066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   836,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,    -1,  2151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,
      -1,    -1,   933,    -1,    -1,    -1,  2182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,   988,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,
      -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1018,    -1,    -1,
      -1,   396,    -1,    -1,    -1,    -1,    -1,  1028,    -1,   404,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,
     415,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2314,  2315,
      -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   487,    -1,    -1,    -1,    -1,  1118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2391,    -1,    -1,    -1,   524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   537,  2409,   539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2431,    -1,  2433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2441,  2442,    -1,    -1,    -1,
      -1,    -1,    -1,   578,    -1,    -1,    -1,    -1,    -1,   584,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2505,
    2506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,    -1,
      -1,    -1,    -1,    -1,    -1,   650,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2533,  2534,  2535,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2545,
      -1,    -1,    -1,    -1,    -1,  1306,   681,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   709,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2607,    -1,    -1,  2610,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2628,    -1,    -1,    -1,  2632,  2633,    -1,  2635,
    2636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2644,    -1,
    2646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2674,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1438,    -1,    -1,
      -1,    -1,  2688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2701,    -1,    -1,  2704,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1480,
      -1,  1482,  2728,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2791,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2839,    -1,  2841,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1640,
      -1,  1642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2921,    -1,  1678,    -1,    -1,
      -1,    -1,  2928,    -1,    -1,  2931,  2932,  2933,    -1,  2935,
      -1,  2937,    -1,    -1,    -1,    -1,  1697,    -1,    -1,    -1,
    1701,    -1,  1703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1712,  1713,    -1,    -1,    -1,    -1,  1718,    -1,  1720,
    1721,  1722,  1723,  1724,    -1,  1726,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,  1739,    -1,
      -1,  1742,  1743,    -1,  1745,  1746,    -1,  2993,  1749,  1750,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1764,  1765,  1766,  1767,  1768,    -1,  1770,
      -1,  1772,    -1,    -1,  1775,  1776,  1777,  1778,  1779,  1780,
    1781,    -1,  1783,  1784,  1785,    -1,    -1,  1788,  1789,    -1,
      -1,  1792,  1793,  1794,    -1,    -1,    -1,    -1,    -1,  1800,
    1801,  1802,    -1,    -1,  1805,  1806,  1807,    -1,  1809,    -1,
    1811,    -1,  1813,    -1,    -1,    -1,  1817,  1818,  1819,    -1,
      -1,  1822,  1823,  1824,  1825,  1826,    -1,  1828,    -1,    -1,
      -1,    -1,    -1,    -1,  1835,    -1,    -1,    -1,    -1,    -1,
      -1,  1842,  1843,  1844,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1916,    -1,    -1,    -1,    -1,
    1921,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3208,    -1,    -1,  3211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3229,    -1,  3231,    -1,  3233,    -1,  3235,
    3236,  3237,  3238,  3239,  3240,    -1,  3242,  1998,    -1,    -1,
      -1,    -1,    -1,    -1,  3250,    -1,  3252,    -1,    -1,  3255,
    3256,  3257,    -1,    -1,    -1,    -1,    -1,    -1,  3264,  3265,
    3266,    -1,  3268,    -1,  3270,    -1,  3272,    -1,  3274,  2030,
    3276,  2032,    -1,    -1,    -1,    -1,    -1,    -1,  3284,    -1,
    3286,    -1,  3288,  3289,  3290,  3291,  3292,    -1,    -1,  3295,
      -1,  3297,    -1,    -1,  3300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2066,    -1,  3313,    -1,    -1,
      -1,    -1,  3318,    -1,    -1,  3321,    -1,  3323,  3324,  3325,
      -1,    -1,  3328,    -1,    -1,    -1,    -1,    -1,  3334,    -1,
      -1,    -1,    -1,  3339,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3348,    -1,    -1,    -1,    -1,    -1,  3354,    -1,
    3356,    -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3369,  3370,  3371,    -1,    -1,    -1,    -1,
    3376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3412,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3440,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3500,    -1,  3502,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2314,  2315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3570,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3591,    -1,    -1,    -1,    -1,
      -1,    -1,  3598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2431,    -1,  2433,    -1,    -1,  3681,    -1,    -1,    -1,    -1,
    2441,  2442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3774,    -1,
      -1,    -1,  2533,  2534,  2535,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3810,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3823,    -1,    -1,
    3826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3850,  3851,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3862,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2628,    -1,  3875,
      -1,  3877,    -1,  3879,    -1,  3881,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2644,    -1,  2646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3900,    -1,    -1,    -1,    -1,    -1,
    3906,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2674,    -1,  3921,  3922,    -1,    -1,    -1,
      -1,    -1,  3928,    -1,  3930,    -1,  3932,  2688,    -1,    -1,
      -1,  3937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2701,    -1,    -1,  2704,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2728,  3974,  3975,
    3976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,    -1,  2750,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4011,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2791,    -1,    -1,    -1,    -1,  4041,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4129,    -1,  4131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2921,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2935,    -1,  2937,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4361,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4416,  4417,    -1,  4419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4430,  4431,  4432,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4445,
      -1,  4447,    -1,    -1,    -1,    -1,    -1,  3208,    -1,    -1,
    3211,    -1,    -1,    -1,  4460,  4461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3229,    -1,
      -1,    -1,  3233,    -1,  3235,  3236,  3237,  3238,  3239,  3240,
      -1,  4487,    -1,    -1,    -1,    -1,    -1,    -1,  4494,  3250,
      -1,  3252,    -1,    -1,  3255,  3256,  3257,  4503,    -1,    -1,
      -1,    -1,    -1,  3264,  3265,  3266,    -1,  3268,    -1,  3270,
      -1,  3272,    -1,  3274,    -1,  3276,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3284,    -1,  3286,    -1,  3288,    -1,  3290,
    3291,  3292,    -1,    -1,  3295,    -1,  3297,    -1,    -1,  3300,
    4546,    -1,    -1,    -1,  4550,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3321,    -1,  3323,  3324,  3325,    -1,    -1,  3328,    -1,    -1,
      -1,    -1,    -1,  3334,    -1,    -1,    -1,    -1,  3339,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3359,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3500,
      -1,  3502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4777,  4778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4912,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3681,    -1,    -1,  4929,  4930,  4931,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4963,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5002,    -1,  5004,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3810,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3823,    -1,    -1,  3826,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3850,
    3851,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3875,    -1,  3877,    -1,  3879,    -1,
    3881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3921,  3922,    -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3937,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5200,    -1,    -1,  5203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3975,  3976,    -1,    -1,    -1,    -1,
      -1,    -1,  5228,    -1,    -1,    -1,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4129,    -1,
    4131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5399,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5547,    -1,    -1,    -1,    -1,    -1,    -1,  5554,  5555,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5641,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4416,  4417,    -1,    -1,    -1,
      -1,    -1,    -1,  5669,    -1,    -1,    -1,    -1,    -1,  4430,
    4431,  4432,    -1,    -1,    -1,  5681,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4445,    -1,  4447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4460,
    4461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5773,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4546,    -1,    -1,    -1,  4550,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5908,    -1,    -1,    -1,    -1,    -1,    -1,  5915,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4777,  4778,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6051,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4856,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4912,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4930,
    4931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4948,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5002,    -1,  5004,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5328,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5399,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5681,    -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,
      -1,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,  5773,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,  5808,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,   180,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,  5908,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,  6126,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   758,   759,    -1,    -1,
      -1,    -1,   764,    -1,    -1,    -1,     6,   769,    -1,    -1,
      -1,   773,   774,    -1,    -1,   777,   778,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,
      30,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    -1,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   758,   759,
       7,     8,    -1,    -1,   764,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,   773,   774,    -1,    -1,   777,   778,    -1,
      27,    -1,    29,    -1,    31,    -1,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    63,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,   220,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   298,   299,    -1,    -1,    -1,    -1,    -1,    -1,   306,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,   316,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,    -1,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,    -1,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,    -1,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,     7,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   769,    27,    -1,    29,    -1,    31,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,    63,
      -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   206,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,   220,    -1,   222,    -1,
      -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,   233,
      -1,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,   281,    -1,   283,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,   299,    -1,    -1,    -1,    -1,
      -1,    -1,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
      -1,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,    -1,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,     7,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   769,    27,    -1,    -1,    -1,
      31,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   195,   196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,   207,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
      -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,   237,    -1,    -1,    -1,
     241,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,
     281,    -1,   283,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,    -1,    -1,    -1,    -1,   306,   307,   308,   309,    -1,
     311,   312,   313,   314,   315,   316,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,    -1,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,    -1,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,    -1,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    -1,    32,    -1,    -1,    -1,   769,    -1,
      -1,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
     288,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    25,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,   271,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,   114,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,   114,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,    -1,
      -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    18,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   758,   759,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,
      -1,    -1,   774,    -1,    -1,   777,   778,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    24,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    24,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   760,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    32,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    32,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    -1,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,     6,     7,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,
      -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   281,   282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,     6,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   281,   282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,     6,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    35,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,     6,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    36,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    11,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    17,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    16,    17,    -1,   753,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   147,   148,    -1,   150,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,   159,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   267,   268,   269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     291,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
      -1,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,    -1,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,    -1,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,    -1,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,    -1,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,    -1,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    16,
      17,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,    -1,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,    -1,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,    -1,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,    -1,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,    -1,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    16,    17,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,   292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,    -1,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,    -1,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,    -1,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,    -1,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,    -1,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    16,    17,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,   148,
      -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   291,   292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,    -1,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
      -1,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,    -1,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,    -1,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,    -1,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
      17,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    17,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    17,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    18,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    24,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    45,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,    -1,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    37,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    45,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    74,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    46,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,
      -1,   774,    -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    47,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    57,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    57,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      57,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    61,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    61,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    61,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    61,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    61,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    61,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,    -1,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   770,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,   774,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   105,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    95,   746,   747,   748,
     749,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     759,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    95,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,   753,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,    -1,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,    -1,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,    -1,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,    -1,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,    -1,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,    -1,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,    -1,   638,
     639,   640,   641,   642,   643,   644,    -1,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,    -1,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,    -1,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
      -1,    -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,
     349,   350,   351,   352,    -1,    -1,    -1,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,    -1,   366,    -1,    -1,
      -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,    -1,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,    -1,
      -1,    -1,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,    -1,   458,
     459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
     479,   480,   481,   482,   483,   484,   485,   486,   487,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,    -1,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   110,   111,    -1,    -1,   578,
     579,    -1,   581,   582,   583,   584,    -1,   586,   587,   588,
     589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,    -1,   623,    -1,   625,   626,    -1,   628,
     629,    -1,   631,   632,   633,   634,   635,   636,    -1,   638,
     639,   640,   641,   642,   643,   644,    -1,   646,   647,   648,
      -1,   650,   651,   652,   653,    -1,   655,   656,    -1,    -1,
     659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,    -1,   678,
     679,    -1,   681,    -1,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,    -1,   704,   705,   706,   707,   708,
     709,   710,   711,    -1,   713,   714,   715,    -1,   717,   718,
     719,   720,    -1,    -1,   723,   724,    -1,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,    -1,    -1,    -1,   342,   343,   344,
     345,   346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,
      -1,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
      -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,    -1,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,   479,   480,   481,   482,   483,   484,
     485,   486,   487,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,    -1,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   110,
     111,    -1,    -1,   578,   579,    -1,   581,   582,   583,   584,
      -1,   586,   587,   588,   589,   590,   591,    -1,    -1,    -1,
      -1,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,    -1,   623,    -1,
     625,   626,    -1,   628,   629,    -1,   631,   632,   633,   634,
     635,   636,    -1,   638,   639,   640,   641,   642,   643,   644,
      -1,   646,   647,   648,    -1,   650,   651,   652,   653,    -1,
     655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,
      -1,   666,    -1,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,    -1,   678,   679,    -1,   681,    -1,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,    -1,   704,
     705,   706,   707,   708,   709,   710,   711,    -1,   713,   714,
     715,    -1,   717,   718,   719,   720,    -1,    -1,   723,   724,
      -1,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,    -1,    -1,   742,   743,    -1,
      -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,
     311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,    -1,    -1,
      -1,   342,   343,   344,   345,   346,    -1,    -1,   349,   350,
     351,   352,    -1,    -1,    -1,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,    -1,    -1,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,    -1,   458,   459,    -1,
     461,   462,    -1,    -1,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,   479,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,    -1,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,    -1,    -1,    -1,    -1,   578,   579,    -1,
     581,   582,   583,   584,    -1,   586,   587,   588,   589,   590,
     591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,    -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,
     631,   632,   633,   634,   635,   636,    -1,   638,   639,   640,
     641,   642,   643,   644,    -1,   646,   647,   648,    -1,   650,
     651,   652,   653,    -1,   655,   656,   110,   111,   659,    -1,
      -1,   662,   663,   664,    -1,   666,    -1,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,    -1,   678,   679,    -1,
     681,    -1,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,    -1,   704,   705,   706,   707,   708,   709,   710,
     711,    -1,   713,   714,   715,    -1,   717,   718,   719,   720,
      -1,    -1,   723,   724,    -1,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,    -1,
      -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,
      -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,    -1,   341,    -1,   343,
      -1,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   417,   418,   419,    -1,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,    -1,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
     544,   545,   546,   547,   548,    -1,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,    -1,    -1,    -1,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,    -1,    -1,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,    -1,    -1,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,    -1,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,    -1,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,    -1,   702,   703,
      -1,   705,   706,    -1,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,    -1,    -1,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    60,    63,
      65,    66,    73,    80,    93,    99,   110,   111,   112,   120,
     131,   144,   146,   151,   181,   195,   196,   206,   207,   218,
     219,   220,   222,   227,   233,   237,   241,   242,   279,   281,
     283,   288,   298,   299,   306,   307,   308,   309,   311,   312,
     313,   314,   315,   316,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   354,   355,
     356,   357,   358,   359,   360,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   446,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   746,   747,   748,   749,   769,   780,
     783,   784,   785,   786,   787,   789,   795,   797,   810,   887,
     940,   941,   948,   949,   965,   966,  1002,  1023,  1055,  1115,
    1172,  1224,  1327,  1377,  1380,  1390,  1395,  1401,  1414,  1417,
    1423,  1426,  1431,  1438,  1450,  1453,  1456,  1457,  1459,  1462,
    1463,  1465,  1466,  1469,  1470,  1473,  1691,  1693,  1706,  1709,
    1744,  1752,  1767,  1776,  1790,  1794,  1795,  1799,  1809,  1816,
    1824,  1826,  1832,  1835,  1836,  1868,  1887,  1889,  1897,  1911,
    1912,  1915,  1917,  1918,  1919,  1920,  1924,  1954,  1961,  1963,
    1972,  1975,  2015,  2017,  2022,  2023,  2024,  2025,  2057,  2066,
    2067,  2068,    49,   205,   326,   402,   451,   499,   650,   654,
     696,   726,  1328,  2029,  2030,  2031,  2032,   174,   448,   497,
    1425,  1797,   310,   338,   340,   341,   348,   353,   355,   361,
     376,   386,   401,   411,   416,   430,   444,   445,   451,   457,
     460,   463,   478,   488,   560,   574,   593,   595,   624,   627,
     637,   645,   657,   677,   680,   712,   722,   740,   747,  1889,
    1896,  1906,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1003,   518,  1418,   186,   499,   696,  1025,  1753,    49,   115,
     192,   205,   272,   425,   451,   499,   636,   654,   696,   699,
     726,   734,  1705,  1058,   873,   967,  1707,  1827,   115,   396,
     748,  1841,   263,   695,  1957,  1056,  1425,  1225,  1116,    17,
     518,  1782,   237,   247,   937,   942,   944,  1896,   645,   726,
    1957,  1060,   942,   943,   873,  1460,   678,  1921,  1777,   942,
    1962,  1745,  1896,  1458,  1057,   214,  1870,  1710,   146,   279,
     675,  1810,  2016,   171,   172,  1022,  1507,   265,   778,  1890,
     115,  1957,  1896,   743,  2019,  1692,   472,  1896,  1425,   391,
     950,  1964,   796,   589,   667,  1896,  1425,  1817,  2019,  1896,
    1833,     6,   660,   708,     6,   660,  1768,   589,   667,   339,
     340,   376,   416,   595,   612,   637,   677,  2060,  1459,  1466,
    1469,     0,    80,   781,   595,    49,    96,   244,   278,   636,
     726,   830,  1306,  1307,  1308,  1705,  2029,  2030,  2031,  2032,
      95,   123,  1476,  1477,  1687,  1454,  1451,    83,   121,   277,
    1468,  2026,  1467,  2026,   437,   448,   582,   777,  1796,  1797,
    1884,  1896,  1463,  1465,   238,   777,  1345,  1896,   875,  1896,
     753,   753,   875,   100,   112,  1704,   139,  1890,  1896,  1901,
    1063,  1064,  1067,  1090,  1896,  1704,  1369,  1370,   251,  1494,
    2033,  2034,  2029,   753,  1957,  1450,  1453,  1706,  1709,  1744,
    1752,  1793,   777,   888,   296,  1004,  1005,  1008,  1012,   808,
     809,  1890,   734,  1415,  1957,   316,   100,  1065,  1090,    37,
      38,    47,   432,   433,   740,   912,   913,   915,   916,   923,
     924,   925,   927,   933,   960,   961,  1889,  1897,  1909,  1912,
    1913,  1914,  1915,  1917,  1919,   114,   152,   465,   607,  1755,
    1765,  1766,  1704,  1695,    24,  1704,  1704,  1704,  1704,  1704,
     100,  1704,  1704,  1090,  1704,  1704,   650,  1957,  1039,  1897,
       6,     7,    41,    46,    63,    73,    99,   115,   120,   146,
     216,   233,   241,   272,   281,   282,   425,   430,   441,   600,
     604,   621,   626,   657,   689,  1901,  1976,  1980,  1981,  1983,
    1985,  1986,   997,   998,   152,   403,   464,  1712,   461,   666,
    1828,   123,  1837,  1955,    38,    87,    98,   127,   134,   176,
     225,   226,   239,   361,   433,   574,   909,   963,   964,   966,
     972,   973,   974,   975,   979,   980,   981,   982,   983,   992,
     993,   994,   995,  1002,  1017,  1018,  1023,  1042,  1048,  1055,
    1899,  1900,  1957,    17,    18,    19,    20,    21,    29,    30,
      32,    39,    40,    43,    44,    45,    46,    48,    49,    51,
      52,    57,    61,    64,    84,    85,    86,    88,    89,   101,
     102,   103,   105,   106,   110,   111,   112,   120,   122,   135,
     149,   154,   155,   157,   163,   165,   168,   171,   172,   173,
     175,   176,   177,   179,   194,   198,   199,   200,   202,   209,
     220,   228,   231,   251,   257,   258,   260,   261,   265,   273,
     274,   275,   285,   286,   287,   293,   295,   316,   317,   318,
     322,   329,   337,   353,   362,   364,   365,   367,   368,   369,
     370,   371,   386,   398,   399,   400,   448,   454,   456,   468,
     490,   491,   495,   533,   535,   540,   541,   542,   543,   553,
     554,   570,   584,   590,   591,   598,   605,   635,   641,   642,
     648,   655,   685,   704,   705,   706,   707,   711,   712,   726,
     728,   738,   739,   741,   749,   758,   759,   764,   769,   773,
     774,   777,   778,  1469,  1475,  1501,  1502,  1503,  1504,  1508,
    1520,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1530,  1531,
    1532,  1533,  1541,  1545,  1546,  1547,  1548,  1549,  1551,  1554,
    1860,  1863,  1865,  1866,  1867,  1881,  1888,  1889,  1896,  1906,
      26,  1117,   500,   350,   357,   373,   383,   384,   385,   393,
     532,   546,   647,   684,   698,   945,   947,   728,   938,   944,
    1896,   873,  1427,   909,  1045,   944,     6,   321,   604,  1973,
    1974,  1981,  1983,     6,    68,   249,   250,   259,   278,   464,
     670,   671,   672,   673,  1479,  1486,  1487,  2028,  1922,    32,
      61,   353,   451,   458,   497,   547,   584,   636,   653,   708,
     740,   778,  1269,  1889,  1894,  1896,  1910,  1912,  1913,  1914,
    1916,  1917,  1918,  1919,  1929,  1941,  1945,     6,    40,    41,
      50,   115,   129,   192,   205,   263,   332,   341,   353,   364,
     388,   419,   422,   424,   450,   451,   458,   459,   475,   497,
     518,   574,   588,   599,   602,   603,   617,   653,   660,   681,
     737,  1269,  1305,  1778,  1782,  1783,  1785,  1794,  1889,  1942,
     944,  1957,   152,  1751,   769,  1723,  1732,  1043,  1501,  1869,
     403,  1713,  1751,  1811,  1896,  2019,  1024,   331,  1901,  1432,
    1391,   777,    10,  2020,  1501,  1574,   790,   284,   792,  1800,
     406,  1884,  1886,  1896,  1965,  1901,   112,  1171,  1890,    95,
    1396,   518,   606,   660,  1818,  1819,   270,  2020,   736,  1834,
     661,   808,   211,   299,  1381,  1382,  1383,   661,   808,   263,
    1771,  1704,  1704,    18,   105,   106,   265,  1861,  1862,  1891,
    2059,  2059,  2059,   448,  2058,  2059,  2059,   770,   770,   776,
    1896,  1171,  1171,  1171,   654,   857,   115,   115,   115,   263,
     650,   192,   205,   272,   425,  2033,   325,   874,   874,  2029,
      74,   769,   774,  1475,  1478,  1579,  1580,  1581,  1582,  1583,
    1594,  1595,  1596,  1597,  1599,  1600,  1601,  1884,   189,   412,
    1682,  1683,  1688,   297,  1624,  1476,    93,   141,   146,   185,
    1488,  1649,  1654,  1660,  1661,  1665,   205,  1664,  1677,  1687,
       6,    68,  2027,  1660,  1662,  1469,  1472,  1473,  1661,  1663,
    1471,     6,  1896,  1792,  1791,   777,  1455,  1452,  1925,  1896,
    1330,   725,  1331,   777,   531,   700,   718,    45,  1901,  1902,
    1903,  1980,  1332,  1069,  1091,  1896,    84,  1337,  1336,     5,
      31,    73,   172,   212,   610,  1092,   873,   263,   114,   573,
    1371,  1372,  1373,   649,   425,   734,  2033,  1901,  1402,  1896,
     769,   891,  1013,    76,  1015,  1501,  1012,   270,  1416,  1698,
    1699,  1884,  1068,  1091,     5,  1897,  1026,   914,   925,   927,
      16,    17,    22,    23,    32,    58,    70,    90,   124,   147,
     148,   150,   158,   159,   160,   178,   213,   237,   243,   267,
     268,   269,   291,   292,   342,   344,   345,   360,   397,   399,
     420,   443,   454,   455,   486,   495,   541,   542,   543,   549,
     550,   566,   567,   590,   591,   609,   641,   701,   704,   707,
     730,   740,   749,   918,   960,  1230,  1232,  1234,  1236,  1238,
    1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1889,
    1912,  1915,  1917,  1919,   776,   776,   460,   772,    35,   310,
      95,  1756,    95,  1756,  1757,  1758,  1762,  1763,  1896,  1765,
    1896,   112,  1703,  1704,   875,   875,   875,   875,  1896,  1091,
     873,  1901,  1101,  1783,   873,  1696,  1704,  1704,  1059,  1040,
     599,  1984,   639,   639,   696,   699,   726,   734,   769,  1500,
     465,   576,  1988,   695,  1990,  1987,    50,   734,  1989,   180,
     358,   660,   270,   180,   772,   416,  1501,   114,  1368,   381,
     606,  1829,  1830,   348,   152,   380,  1843,  1884,  1958,  1959,
     296,   379,   451,  1889,  1898,  1907,  1915,  1917,  1918,  1919,
      95,   100,   553,  1896,  1898,  1898,  1898,  1898,  1896,   296,
    1898,  1896,   416,   963,   776,   784,   968,  1897,   976,   996,
    1896,    60,   340,    93,   151,   220,   298,   964,  1900,  1424,
     122,   758,   759,  1525,   769,   769,   769,   296,  1501,  1577,
    1578,   769,   769,   769,   769,   769,  1500,  1500,  1500,   769,
    1499,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,  1501,   769,   110,   111,   365,
     769,  1575,  1576,  1881,  1888,  1906,   769,   769,   769,   769,
    1501,  1499,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   197,   769,   769,   769,  1499,   265,  1862,  1500,
    1499,  1499,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   177,  1888,   769,   769,   769,   769,   769,
     769,   769,   265,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   728,   769,
     769,   769,   769,   769,   728,   769,   769,   769,   769,   769,
     769,   769,   265,   769,   769,   769,   265,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   122,  1525,   122,  1525,
    1525,  1226,  1469,  1501,  1868,  1896,  1888,  1555,     9,    10,
     184,   186,   303,  1505,  1506,    81,    97,   126,   132,   169,
     753,   754,   755,  1509,    15,   125,   140,   217,   668,  1507,
      69,   165,   183,   239,   240,   756,   757,   758,   759,   760,
     761,   762,   763,  1525,    34,   166,   191,   191,   741,  1891,
     777,   769,   197,  1118,    14,   270,   772,   753,  1891,  1428,
    1902,  1904,  1429,  1430,  1884,   724,  1984,   576,   180,    95,
     180,  1461,  1487,    61,  1896,  1928,  1944,   237,   636,   777,
      17,    61,   238,   753,  1270,  1271,  1726,  1901,    93,  1726,
    1951,  1726,  1901,  1931,   778,  1901,    17,    61,  1273,  1274,
    1901,  1726,   777,  1932,  1930,   661,   769,    49,   192,   205,
     263,   272,   425,   451,   650,   726,   734,   140,   297,  1789,
      24,   679,   363,   679,   679,   424,  1789,     6,  1183,  1901,
    1653,  1654,  1655,    95,   125,  1784,  1786,   363,   679,    93,
     679,   695,   667,     6,   343,   387,   389,   481,   530,   579,
     669,   691,  1772,  1773,  1774,   808,   467,   679,   809,  1655,
    1789,  1786,   500,   418,   366,   601,   695,   710,    93,  1493,
     679,   731,  1368,  1733,   772,   151,  1871,  1872,  1876,  1896,
     123,  1714,  1715,  1716,  1884,  1027,  1032,   772,  1433,  1434,
    1435,  1436,  1884,  1698,  1896,   351,   560,   218,   560,  2021,
     772,  1501,   793,    17,   252,   405,   419,   421,   452,   467,
     500,   518,   599,   606,   616,   629,   660,   663,   679,  1801,
    1806,  1807,  1889,  1957,    35,   778,   951,   952,   953,   954,
    1888,   574,   211,   361,  1507,  1896,   788,   734,  1393,  1957,
    1821,   348,  1820,   772,   645,  1896,  2021,    93,  1384,  1385,
    1384,   572,   745,   382,   772,  1384,  1384,  1699,  1896,  1890,
     772,   571,  2062,   690,  2063,   753,   128,   631,  2061,    80,
     782,  1896,   873,   873,  1171,  1171,   816,   818,  1171,  1171,
      24,  1171,  1171,   823,   825,   734,   451,   451,  2033,  1579,
    1583,  1595,  1596,  1597,  1598,  1599,  1896,    94,  1484,    42,
     117,   128,   135,   167,   228,   259,  1590,  1591,   772,   196,
    1592,  1593,   265,  1892,  1892,   778,  1684,  1685,  1686,  1896,
    1901,  1625,   100,  1628,  1624,   281,   149,   177,   229,   274,
     365,  1656,  1657,  1863,  1888,   125,    26,  1653,  1488,  1896,
    1488,  1489,  1489,  1472,  1793,  1798,  1861,  1896,  1896,  1661,
    1664,     6,    17,    61,   180,  1501,  1953,   238,    61,  1168,
    1169,  1180,  1181,  1278,   396,   877,  1896,  1500,   778,   877,
       5,  1070,  1884,   575,   395,  1087,  1087,  1087,     4,  1902,
    1903,  1904,  1996,  2000,  1884,  1373,   402,   479,   875,  1884,
     734,  1403,  1404,  1699,   777,   889,   892,   893,  1501,  1501,
     910,   911,   416,  1006,   798,  1698,    93,   352,   437,   439,
     529,   607,   772,  1419,  1420,  1421,  1070,  1087,   926,   340,
     916,   917,   776,   776,   769,  1252,  1254,  1252,  1253,   379,
    1252,  1261,  1262,   769,  1249,  1250,  1252,   203,  1249,  1261,
      17,    34,   329,   347,   721,  1235,  1262,  1269,  1279,  1280,
    1282,    32,   291,  1235,  1242,  1244,  1261,  1235,  1249,   769,
    1261,  1235,  1252,  1254,  1235,  1253,   769,  1249,  1261,    32,
     292,   292,   294,  1249,  1252,   769,   922,  1253,  1253,  1253,
    1252,  1253,   197,   777,    61,   238,   962,  1249,   294,  1254,
    1254,  1252,  1252,  1253,   769,  1250,  1257,    93,  1896,    93,
    1884,    14,  1754,  1701,  1702,  1885,  1896,    93,  1482,  1483,
    1624,   772,  1759,   777,  1764,    84,  1896,   875,   777,  1101,
    1979,  1981,   563,   736,  1102,  1103,   419,  1904,  1995,  1698,
    1697,  1694,   151,   125,  1041,   695,   770,   769,  2004,  2004,
    2004,  2004,  1904,  1996,   192,   205,   263,   451,  1982,   425,
     430,   441,   600,   621,   626,   657,   689,  1986,   112,   266,
    1714,   469,   726,  1501,  1831,  1831,  1439,   497,  1842,    11,
     753,  1620,  1621,  1622,   564,   736,   772,  1956,   977,   978,
     296,  1896,   553,    95,   123,   240,   977,   296,   769,   991,
     151,   776,   777,   969,  1501,   772,  1020,  1019,  1051,  1049,
    1054,  1050,  1698,   769,     6,  1565,  1623,  1565,  1565,  1501,
    1578,    76,   296,   416,  1501,  1574,  1501,    68,  1565,  1623,
     770,    57,    89,   105,   149,   177,   274,   770,  1669,  1673,
    1674,   770,  1501,  1501,  1881,   770,  1464,  1465,  1474,  1868,
      53,    54,    55,    56,   107,   108,   109,   161,   162,   232,
     304,   400,   468,   533,   535,   540,   605,   648,   738,   749,
    1617,  1618,  1501,    68,  1557,  1501,  1501,  1501,  1501,  1501,
    1617,  1501,  1888,  1576,   324,   772,   777,    68,  1565,  1501,
      68,  1565,  1501,  1501,  1501,   770,  1501,  1501,  1504,   770,
    1501,  1501,   770,   640,  1565,  1565,    68,  1565,  1565,  1565,
    1501,  1501,  1529,    25,   133,   271,  1501,  1521,  1501,  1501,
      68,  1565,  1501,  1574,  1501,   777,  1501,  1501,  1501,  1517,
    1518,  1501,  1501,  1501,  1501,  1501,  1501,  1501,  1574,   397,
     399,   704,   707,  1619,  1501,  1501,  1574,  1884,  1574,  1501,
    1501,  1501,  1574,  1574,  1574,    93,  1884,  1501,  1501,  1501,
    1574,    93,  1501,  1501,  1501,   770,  1501,  1884,  1501,  1501,
    1618,  1618,  1501,  1521,  1501,   770,   365,   777,  1882,  1896,
    1501,  1501,  1501,  1501,  1501,  1501,   770,   772,  1465,  1501,
     777,   778,  1556,  1901,  1501,  1501,  1501,  1503,    86,   176,
     273,   723,  1507,     6,   328,  1503,  1510,  1503,   769,  1475,
    1503,  1503,   140,    15,   125,   140,   217,  1504,  1504,  1504,
    1504,  1504,  1504,  1504,   122,  1504,   122,  1504,  1504,  1504,
    1504,  1504,  1275,  1901,  1525,   769,  1553,  1634,  1896,   769,
     100,  1888,  1534,   449,   483,   559,   640,  1519,   142,   208,
     496,   694,  1119,  1123,  1825,  1890,   947,   399,   704,   707,
     946,  1554,  1865,  1881,   772,   270,   772,  1956,  1046,   772,
      93,  1904,  1903,  1997,   192,   205,   451,  1982,   760,  1491,
    1492,  1494,   777,   777,  1726,   772,  1923,  1981,  1896,    34,
    1276,  1501,  1904,   265,   570,   584,  1952,  1953,   211,   482,
    1946,  1947,  1948,  1949,   458,   497,   653,  1943,  1726,  1953,
    1896,   708,  1933,  1944,   772,  1935,   679,   760,  1171,    24,
     875,   875,  1884,   875,   875,   875,  1884,  1904,  1884,  1493,
    1493,   363,   679,  1789,   875,  1789,  1784,   125,  1787,   500,
     544,   679,  1781,  1781,  1789,  1896,   875,  1789,  1903,  1784,
    1789,  1890,   480,   692,   440,    93,  1775,   772,   424,   679,
    1884,  1786,  1784,  1784,  1501,  1789,  1789,  1789,  1580,  1743,
    1884,  1494,  1735,  1737,   769,  1730,  1044,   772,   769,  1874,
    1715,  1711,  1700,  1884,   908,   416,   778,   125,   772,   196,
    1444,  1446,  1447,   437,   607,  1392,   238,   351,   218,  1501,
     791,    61,   114,   794,  1501,  1738,  1739,   500,   500,   500,
     500,   348,   500,   808,   500,   772,  1493,  1802,   946,   956,
    1901,   772,   753,  1621,  1966,    84,   667,  1501,  1394,  1698,
     270,  1823,   808,  1819,  1896,     6,  1379,   620,   674,  1386,
    1387,  1378,   664,  1383,  1956,  1861,   587,  2064,  1901,   820,
    1979,  1996,  1901,   814,  1171,  1171,   811,  1884,  1171,   875,
     824,  1494,  2042,   861,  1494,  1171,  1171,  1171,   734,   772,
     770,   770,   770,   770,   770,   772,   770,  1579,     6,    11,
      15,    95,  1485,  1622,   128,   128,   188,  1602,   135,   228,
    1590,  1602,  1579,  1581,   769,  1484,  1689,  1901,   772,   777,
    1501,    26,   104,  1626,  1628,   564,   736,  1490,   428,  1888,
     229,   569,   772,   777,   656,  1650,  1678,  1926,  1169,    34,
    1269,   407,   164,   210,   251,   374,   386,   488,   560,   879,
     886,  1901,   613,   719,  1088,  1089,   476,  1084,  1085,  1086,
    1093,  1101,  1103,  1338,   769,  1890,   333,   525,  1078,  1079,
    1080,  1093,  1094,  1095,  1101,  1103,  1071,  1072,  1078,   470,
     221,   772,  2007,  1956,  1335,  1334,  1884,   772,   586,  1405,
    1896,   891,   770,   772,  1014,   909,    29,   296,  1007,  1009,
      71,   113,   153,   471,   501,   502,   504,   505,   506,   507,
     508,   510,   511,   512,   513,   514,   515,   516,   517,   519,
     520,   521,   618,   619,   799,   800,   807,    93,  1422,   725,
    1699,  1420,   374,   557,   614,   720,  1081,  1082,  1083,  1093,
    1097,  1098,  1099,  1100,  1101,  1103,   283,  1066,   769,   929,
    1032,    57,   149,   177,   274,  1261,  1260,  1726,  1261,   177,
     280,   305,   658,  1251,  1251,  1279,    61,  1275,  1277,  1281,
    1282,  1270,    17,  1280,  1283,   379,  1263,  1261,  1235,  1251,
    1326,  1861,  1261,  1326,  1251,   294,  1251,  1261,   919,   920,
     921,  1897,   962,  1235,  1235,  1251,   230,   714,  1896,  1501,
    1501,   215,  1248,  1281,  1283,  1235,  1261,  1251,   177,  1251,
     928,   105,   759,   936,   937,  1666,  1668,  1592,   694,   772,
    1760,   777,  1764,   201,  1648,  1649,  1763,    95,   760,  1896,
     180,  1896,  1102,   772,  1726,  1727,   772,    28,   223,  1374,
    1698,  1698,   909,   635,  1038,  1896,  2005,  2006,   270,   299,
    1978,    24,   760,  1884,  1896,  1994,  1994,  1994,  1994,   999,
    1708,  1501,  1904,  1440,  1441,  1442,  1443,  1884,   116,   451,
    1889,  1893,  1905,  1912,  1913,  1914,  1915,  1916,  1917,  1918,
    1919,   152,   211,   745,  1960,  1668,  1959,  1501,   977,   123,
     641,  1896,   977,   985,   986,   990,  1896,   891,  1896,   912,
    1032,  1039,  1042,  1045,  1043,  1956,  1501,   770,  1566,   770,
     770,   266,   416,  1501,  1501,    11,   284,   770,   284,   772,
    1542,   770,   760,   770,   772,   772,   770,   770,  1465,    95,
     770,  1544,   770,   772,   770,   772,   772,   772,   772,   759,
     772,   770,   769,  1881,  1888,  1565,   770,   770,  1565,   770,
     772,   770,   772,   770,   770,   125,   772,   772,   770,   770,
    1565,   770,   770,   770,   772,    95,   772,   770,    95,  1501,
      95,  1501,    95,  1501,    95,   770,   772,   770,  1565,   770,
     770,   770,   770,  1888,   772,   770,   772,   770,   772,   772,
     772,   772,   772,   770,   770,   772,   770,   772,   770,   770,
     772,   770,   770,   770,   770,   770,   770,   770,   770,  1884,
     770,   770,   770,   772,   770,  1884,   770,   770,   772,   770,
     772,   772,   770,   772,   772,   772,   770,   770,   772,  1888,
    1896,   770,   777,   770,   772,    11,   494,   772,  1294,   772,
     770,  1617,  1617,  1574,   770,   775,  1888,  1943,   238,    86,
     176,   273,   723,   769,    10,  1501,   423,  1503,  1503,   769,
    1475,  1503,  1503,  1501,  1501,  1635,   196,  1637,   769,   769,
     777,  1494,  1538,  1539,  1540,   366,   769,  1128,  1129,  1121,
    1128,  1122,   582,  1131,   130,   462,  1501,   753,  1904,  1904,
    1430,   270,  1501,    99,  1981,    95,   772,    24,  1994,  1994,
    1994,  1994,   772,  1501,  1879,  1888,  1896,  1896,  1953,  1944,
      93,    93,  1726,  1277,  1726,   769,   769,   572,   745,   494,
     772,   772,   777,   777,   777,    61,   451,   740,  1889,  1890,
    1895,  1908,  1912,  1913,  1914,  1915,  1916,  1918,  1919,  1501,
    1726,  1946,  1934,  1936,  1937,   770,  1896,   875,  1890,  1501,
     875,  1789,  1789,  1890,    95,  1788,   873,  1789,   606,  1655,
    1774,  1787,  1784,  1884,  1789,  1789,   237,  1592,  1739,   770,
     772,  1731,   909,  1872,  1875,  1896,  1873,   136,   137,   237,
    1109,  1464,  1717,  1719,  1722,  1592,   963,  1033,  1901,    61,
    1437,  1896,  1435,  1884,  1114,  1446,   115,   130,  1303,  1448,
    1927,   792,   772,    62,  1812,   808,  1807,  1698,  1808,   954,
     957,   958,   953,   565,   566,   642,   955,   442,   553,  1896,
    1967,  1968,  1890,  1698,   437,   607,   727,  1397,  1398,  1399,
    1668,     6,  1822,   661,   772,   724,  1388,  1769,   772,    93,
    2065,  1167,  1168,   299,  1977,  2007,   858,  1896,  1896,  1896,
    1884,   813,   875,   883,   884,   875,  2052,  1171,  1171,  1884,
     875,  1896,   875,  1171,  1579,  1579,   775,   568,   704,   708,
    1480,  1481,  1527,  1481,   128,  1602,  1602,  1594,   128,   180,
     284,  1616,  1896,  1621,  1269,  1272,  1685,  1896,  1501,  1629,
    1880,  1627,   740,  1631,  1626,  1668,  1657,  1658,   428,  1657,
    1657,  1888,   538,  1651,  1880,   769,  1953,  1727,  1727,   548,
     251,   251,   649,  1890,   251,   251,   251,  1890,  1890,  1727,
     772,  1086,   156,   348,   394,   474,   536,   555,   556,   560,
     561,   562,   628,   677,   854,   855,    49,   466,   577,   584,
     592,   665,   726,   859,   860,  1727,  1727,   772,  1080,  1073,
    1074,  1093,  1094,  1095,    26,   299,   733,  1998,   252,   356,
     484,   558,   686,   746,  1992,  1993,  2000,   299,  2010,  1329,
     180,   869,  1342,   769,  2035,  1333,  1404,    93,   890,  1501,
     266,  1010,  1009,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   772,   725,  1727,
    1727,  1727,  1727,   772,  1083,   499,   438,  1075,  1076,  1077,
    1093,  1094,  1095,  1096,  1099,  1100,  1101,  1103,   896,   897,
     898,  1896,   126,   416,   770,   770,   770,   770,  1896,   772,
     305,   280,  1260,   770,   772,   770,  1230,   770,   772,   962,
     962,   777,   753,  1283,   187,   246,   248,   934,   935,   936,
     939,  1507,  1896,    57,    89,   149,   177,   274,  1481,  1702,
    1896,   284,  1896,   568,   141,  1659,  1580,   777,  1764,  1884,
    1981,  1182,  1901,  1904,  1956,   416,   769,   985,   988,   770,
     772,  1996,   321,  1994,   777,   777,   270,   270,   270,   270,
     910,  1717,   772,  1444,  1446,  1892,   745,   497,   380,   123,
     987,   770,   772,   777,   970,  1021,   416,  1052,  1016,  1047,
    1898,  1047,  1047,   772,  1501,  1501,   266,    17,    32,    58,
      70,    90,   122,   124,   280,   292,   397,   399,   550,   658,
     707,   730,  1567,  1571,  1572,  1270,  1270,  1567,  1574,   770,
     122,   122,  1501,  1574,  1501,  1501,  1501,  1501,  1501,  1501,
    1501,  1504,   777,   770,   770,  1501,  1501,  1501,  1501,  1501,
     770,  1501,  1501,  1501,  1501,    95,  1501,    95,  1501,    95,
    1501,   122,  1501,   770,  1518,  1501,  1517,  1574,  1501,  1501,
    1501,  1501,  1501,  1501,  1501,  1574,   149,   758,  1666,  1670,
     122,  1501,  1501,  1501,  1501,  1501,   777,   777,  1896,  1501,
      17,    32,  1289,  1290,  1291,  1292,  1293,  1669,  1668,   770,
    1501,   759,   759,  1895,  1501,  1474,  1503,   770,   772,  1503,
      10,  1501,   423,  1617,  1617,  1636,  1896,    26,   770,  1550,
    1573,  1574,  1888,  1501,   770,   772,   769,  1137,  1504,  1129,
     141,  1163,  1164,  1669,   688,  1132,   326,  1124,  1120,   946,
     270,  1884,   416,   576,  1995,  1903,  1994,    95,    95,    95,
      95,  1492,  1495,  1495,   777,  1726,  1726,   783,  1904,  1953,
     265,   265,   211,   625,   651,  1950,  1948,  1947,   777,   777,
    1726,  1953,  1935,   772,  1939,  1941,  1945,   422,   737,  1666,
    1671,  1779,   177,  1788,  1624,  1784,  1747,  1748,  1882,  1482,
    1495,  1494,  1734,  1736,  1739,   416,   770,   772,    11,  1720,
    1721,  1877,  1878,  1882,  1896,  1868,  1718,  1722,   776,   310,
    1034,  1445,   769,  1953,  1739,   753,    93,   299,  1803,  1804,
     753,   772,    97,   132,   442,   489,   553,   597,   753,   754,
     755,  1969,  1971,  1624,    95,  1400,  1398,  1387,   503,   807,
    1389,    73,   634,  1770,  1668,   534,   321,  2010,    92,   284,
     714,  1316,   180,   180,   812,   853,   854,   883,    11,   126,
    2056,   374,   880,   881,   882,   886,  2053,  2043,   875,   821,
     226,   769,   633,   226,   769,  1884,  1481,   265,  1504,    10,
     270,  1579,  1594,   128,   128,  1579,  1594,  1584,  1585,   770,
     772,  1611,  1612,  1271,  1690,   300,   301,   772,  1630,    12,
      65,  1652,  1501,  1553,  1632,  1633,  1631,  1658,  1490,   772,
    1652,  1494,  1679,  1680,  1681,  1277,  1271,   396,   396,   402,
     479,   105,   149,   177,   274,  1104,  1672,  1673,  1889,  1086,
    1727,  1727,    26,  1727,  1729,  1727,   156,   536,   299,  1727,
    1728,  1728,   855,  1890,  1890,  1890,  1890,  1668,  1890,  1890,
     770,   772,  1104,  1104,  1080,   772,  1074,   265,   584,  1901,
    2001,  2002,   265,   265,   265,    10,  1991,   522,   523,   526,
     527,   528,  2008,  2009,   319,   584,  1341,     5,     7,     8,
      31,    33,    39,    73,   115,   146,   181,   185,   193,   196,
     219,   254,   255,   256,   277,   302,   326,   334,   336,   355,
     362,   374,   381,   396,   404,   408,   409,   415,   419,   427,
     447,   473,   477,   487,   524,   537,   539,   578,   584,   611,
     622,   623,   624,   643,   650,   681,   696,   697,   709,   712,
    1112,  1174,  1176,  1179,  1180,  1181,  1346,  1350,  1352,  1355,
    1361,  1362,  1363,  1365,  1366,  1645,  1889,   378,   646,   219,
    1343,  1896,  2036,    11,  2035,     6,   366,  1406,   891,   910,
    1501,   769,   769,  1668,   769,  1668,  1668,  1890,  1890,  1671,
    1890,  1668,  1890,  1890,  1890,  1890,  1890,  1890,  1890,  1668,
    1890,   392,   560,   662,  1866,  1890,  1668,   800,  1890,  1669,
    1104,  1104,  1083,   100,  1727,   772,  1077,   770,   772,    17,
     291,   609,   641,   730,   960,  1233,  1234,  1237,  1238,  1239,
    1240,  1242,  1243,  1244,  1245,  1268,   930,   931,   177,  1281,
    1861,  1281,   920,  1896,   177,   772,   963,   449,   777,  1580,
    1764,  1493,   229,  1657,   224,  1761,  1624,  1956,  1374,   151,
     931,   989,    72,  2006,   299,  2012,   576,   270,   760,   760,
    1996,  1996,  1996,  1996,  1000,   180,  1740,  1442,  1884,  1446,
     114,  1449,  1838,  1501,   986,  1896,   891,   340,  1016,   151,
    1501,  1501,  1253,  1253,  1249,  1257,    56,   124,  1252,  1253,
    1253,   124,  1253,  1252,   770,   770,   770,   770,  1543,  1501,
    1501,   770,   185,  1559,   770,   770,   772,   772,   770,   772,
     770,   125,  1535,  1536,  1888,   770,   770,   770,   770,   770,
     772,    93,   772,  1501,  1501,  1501,  1501,   770,   770,    11,
    1511,   770,    11,   770,   770,   772,   770,   772,   770,   770,
     770,   770,   149,   177,   177,   770,   772,  1501,   770,   770,
     772,   772,   770,  1888,  1896,   777,   770,   769,  1284,  1284,
      12,    65,   635,   758,  1286,  1287,  1288,   772,   772,   770,
    1501,  1501,   777,   770,  1574,  1503,   770,   772,  1503,  1637,
    1629,   185,  1552,   770,   769,  1495,  1540,  1125,  1126,  1127,
    1896,   770,  1671,   122,    26,   769,  1139,   753,   769,  1129,
    1904,   220,    95,    95,  1997,  1997,  1997,  1997,    11,  1497,
    1890,  1896,   760,  1888,  1953,  1953,   770,   770,   375,   717,
     211,  1896,  1896,  1953,  1938,  1940,    57,    89,   149,   177,
     274,  1655,  1780,  1789,   772,  1746,  1726,  1621,  1739,   770,
     772,   151,  1896,   769,   770,   772,   777,  1465,  1724,  1725,
    1882,   296,  1035,  1036,   769,   204,  1613,  1614,  1615,  1896,
     769,  1805,   211,   350,   357,   373,   383,   384,   385,   393,
     532,   546,   632,   647,   684,   698,   959,   958,  1970,  1655,
     545,   753,   772,   681,   681,  1903,  1341,   396,   346,   462,
     644,  1322,  1322,   180,  1884,  1884,   136,   138,   140,  1105,
    1107,  1173,  1175,  1176,  1188,  1173,  2056,  1494,  1890,   880,
     769,   903,   905,   907,   875,   862,  2035,   828,   829,    58,
     124,   213,   683,  1186,   826,   827,   822,  1481,  1481,   180,
    1587,  1594,  1594,   180,  1589,  1501,   769,  1114,  1896,  1609,
    1610,   366,  1845,  1880,    11,   772,  1880,  1501,   770,   772,
    1670,  1670,  1670,  1670,  1670,  1670,   860,  1074,   265,    11,
     284,  1999,  2003,   186,  1992,  1668,  1668,  1668,  1866,   758,
    1666,  1667,  2008,   146,   279,  1339,   435,    36,   196,   372,
     585,   693,  1192,  1200,  1201,  1206,  1207,  1303,  1307,  1308,
    1367,  1367,   196,  1367,   196,   270,    36,    92,   196,   585,
     693,  1205,  1303,  1367,   407,  1727,   196,    26,  1727,  1114,
      11,   270,   753,  1376,  1727,  1727,  1727,  1727,   732,  1727,
    1727,  1727,  1727,   196,  1727,  1727,   407,  1727,   129,   696,
     129,  1727,   196,   696,  1727,  1727,  1727,  1727,  1367,  1727,
    1727,   196,   583,   196,   196,  1727,  1727,   410,   530,  1896,
    1727,  1727,   196,  1174,   772,  1111,  1112,  1350,   769,   777,
    1191,  1208,  1883,  1896,  1726,  1507,  2018,   330,   426,   863,
     270,   408,   415,   865,   770,   772,  2037,  2038,    11,     6,
     769,  1407,  1011,   803,   804,  1668,   805,   806,  1668,   801,
     802,  1668,  1896,  1104,  1077,   898,  1252,  1256,  1252,  1255,
    1255,   922,  1255,   197,   777,  1256,  1256,  1255,  1255,   932,
     770,   935,  1896,  1624,  1896,   428,   229,  1491,   770,  1501,
     988,    99,  1996,  2007,  2007,  2007,  2007,    76,    78,  1001,
     413,  1449,   492,   114,   316,  1844,   971,  1032,   909,  1568,
    1252,  1569,  1570,   770,  1617,  1617,    26,   235,  1558,  1501,
    1501,  1574,   167,   345,   770,   299,  1537,  1501,  1501,  1501,
    1617,    58,    70,    90,   124,   213,   280,   397,   399,   549,
     550,   707,  1242,  1243,  1512,  1513,  1514,  1515,  1567,  1501,
    1501,    86,   273,  1668,  1676,  1617,  1501,  1501,  1896,  1669,
     770,  1294,  1289,  1287,  1289,  1290,  1668,  1896,   770,  1574,
     185,  1638,    26,   770,  1573,  1497,   770,   772,  1501,  1123,
     196,  1140,  1141,  1669,  1125,  1997,  1997,  1890,  1896,   777,
    1726,  1726,  1939,  1944,  1655,  1748,  1624,    61,  1738,  1611,
    1495,  1739,  1464,  1877,   760,  1896,   770,   772,  1726,  1037,
    1036,     6,  1351,  1359,  1360,  1896,   770,   772,  1671,  1813,
    1814,   436,   146,   769,  1890,   807,   744,  1884,   817,   819,
      36,   585,  1189,  1190,  1191,  1192,  1200,  1201,   140,  1884,
    1110,  1111,   772,  1175,  1106,  1494,   831,   904,   878,    14,
     323,  1061,   180,    11,  2048,  2049,   894,   895,   667,  2048,
     894,  2035,  1586,   284,  1588,   284,  1616,   114,   283,   447,
    1604,  1605,  1608,    79,    82,   182,   264,  1846,  1847,   143,
    1848,  1652,  1634,  1633,  1652,  1495,  1681,   584,  1890,  2001,
     177,   177,   584,    61,   122,   551,  1340,   112,  1325,  1883,
    1171,    94,   112,  1170,   732,    33,    92,   204,   278,  1204,
    1302,  1171,  1303,  1304,  1304,  1170,  1703,  1425,  1703,  1351,
    1269,  1703,   130,  1704,    94,  1703,   732,   204,  1703,  1703,
    1727,    61,  1896,  1425,  1646,  1647,  1882,    61,  1668,  1675,
    1113,  1884,    61,  1668,    61,  1668,    61,  1668,  1177,    61,
    1896,  1671,  1668,  1668,  1425,  1890,  1890,  1727,  1668,  1901,
    1360,   442,   489,   560,  1185,  1668,  1671,  1671,  1703,    61,
    1668,  1890,  1425,  1425,  1425,    61,   377,   379,   414,   443,
     579,   615,  1184,  1675,  1668,  1675,  1351,     5,    73,  1363,
    1187,  1189,  1896,   323,   442,  1375,   216,  1296,  1209,   777,
      61,  1672,  1890,  1896,   596,  1501,  1501,   180,   869,   875,
     180,   374,   870,  1896,  1464,  2037,  1408,   475,   266,   770,
     772,   770,   772,   770,   772,  1281,   230,  1896,  1281,  1283,
    1281,  1283,  1450,  1868,    95,   428,   576,  2007,   299,  2011,
    2011,  2011,  2011,   910,   997,  1741,   123,   891,   416,   416,
    1281,  1281,  1281,   770,   770,  1560,  1880,  1861,   141,  1561,
    1562,  1563,   770,   772,   770,   488,   538,   606,   770,   770,
    1249,   124,  1253,    32,  1253,  1516,   770,   770,   770,   770,
     772,   770,   770,   770,  1285,   770,   772,   770,    26,   208,
     229,  1639,  1640,  1880,   770,  1127,  1617,   130,   462,  1142,
     770,   772,   770,   760,  1953,  1953,  1648,   770,   777,  1725,
    1739,   934,   770,   772,  1614,   770,   772,    10,  1815,  1736,
    1901,   815,   769,   769,    93,  1202,   770,   772,  1884,  1108,
    1844,  1175,  1173,   832,   205,   451,   850,   851,   852,   897,
     899,   900,   901,   879,   885,  2018,  2054,    63,   120,   281,
    1062,   646,  2037,   878,  2050,  1268,   770,   896,  1890,  2050,
     770,    11,  1501,   769,  1501,   769,   770,  1303,  1303,  1605,
      26,    26,    79,    26,  1847,   253,   264,  1849,  1850,   769,
     435,   177,   319,  1507,  1425,   769,  1507,  1202,   769,   130,
     130,  1304,  1171,  1325,  1896,  1171,  1171,  1883,  1351,  1883,
    1348,  1271,  1883,  1703,  1359,    93,   130,  1883,  1883,  1890,
    1351,   772,  1652,  1117,   769,  1669,  1890,   299,  1208,  1351,
    1356,  1351,   770,  1896,  1884,   652,   960,  1210,  1231,  1232,
    1896,  1617,   660,  1890,   411,  1344,   299,  2039,  1411,  1896,
       6,   769,  1409,   910,   804,   806,   802,   197,   777,  1504,
    2011,    99,  2008,  2013,  2014,   130,   263,  1016,   151,   772,
    1652,   770,  1564,  1657,  1501,   538,   434,  1281,  1671,   770,
    1668,  1651,   770,    15,   391,   399,   704,   707,   716,  1641,
    1642,  1865,  1652,   676,  1165,  1124,   769,  1130,  1143,  1896,
    1141,  1659,   760,   266,  1360,  1814,   408,   770,   575,   769,
    1323,  1324,  1896,  1323,  1896,  1190,   770,    11,  1166,  1110,
     205,   451,   836,   837,   838,   844,   849,   852,   924,   842,
     984,   840,   984,   416,   852,   118,   125,   190,   902,   770,
     772,    67,  2056,   180,   863,  2051,   875,   876,   226,   876,
     226,  2037,  1616,  1616,    93,  1603,  1603,  1861,  1861,    26,
    1861,    26,    26,  1850,   265,  1340,   400,  1339,    84,  1353,
    1896,    84,  1501,  1171,  1325,  1896,   284,  1315,   714,  1325,
    1325,    73,   237,  1208,  1419,  1276,  1883,  1896,  1374,  1347,
    1647,  1808,   263,  1375,  1357,  1359,  1349,   769,  1297,  1212,
     777,  1203,  1204,  1211,   777,   864,   871,   872,    33,   349,
     497,   770,   772,  1410,   230,   714,  1896,   270,   576,  2014,
     281,  1884,  1053,  1880,   569,   772,   770,   770,   770,   716,
    1642,  1643,  1865,   641,   594,   429,  1644,   594,  1668,   769,
    1137,  1133,    61,   289,   290,   391,   465,  1144,   910,   354,
     769,  1323,   770,   772,  1652,   769,   770,   769,  1109,  1108,
     842,   840,   833,   838,   849,   844,   776,   776,   839,   776,
     839,  1496,   190,   641,   960,  1268,   901,  1028,  1029,  1494,
     868,   869,  2056,  2048,  2048,   770,   770,   100,   128,   185,
    1607,  1606,  1861,  1861,  1861,   770,  1883,   582,   769,  1354,
     772,   770,  1325,  1315,   714,  1322,  1193,  1322,  1195,  1196,
      61,    61,  1375,  1425,   770,  1884,  1358,  1397,  1298,  1896,
     154,  1299,   204,   278,   302,   374,   485,   742,  1213,  1214,
    1223,  1265,  1266,  1267,  1295,  1507,  1889,  1232,    34,    61,
     176,   180,   334,   453,   652,  1217,  1219,  1258,  1259,  1266,
    1896,   676,   866,   963,   576,    33,    33,  1896,   204,  1412,
    1413,  1896,   197,  1504,  1742,  1592,  1047,  1652,  1657,  1657,
     446,    10,   446,   100,   391,   560,   703,  1135,  1136,  1896,
     770,   687,  1138,  1146,   702,   115,   374,   381,   396,   524,
     537,   557,   696,  1160,  1161,  1162,  1783,   859,   770,  1956,
    1324,   177,  1956,  1896,  1178,  1179,   847,  2056,   845,  2056,
     340,   416,   835,  1896,  1896,   876,   922,   197,   777,   876,
     912,  2044,   865,  1028,  2050,  2050,    26,    26,   769,   769,
    1204,  1669,  1140,  1896,  1199,  1197,  1322,   769,  1194,   769,
     769,   758,   759,   769,  1227,  1228,  1229,  1475,  1522,  1864,
    1889,  1114,   123,   770,   772,   450,   581,   659,   180,  1300,
     130,  1890,   693,  1266,   732,   130,   176,  1726,  1275,  1229,
     281,   327,    61,    11,   379,  1259,  1264,  1501,   417,   867,
      91,   856,   576,   576,   770,   772,   714,  1749,  1750,  1882,
    1839,  1643,   641,   187,   312,   770,   772,  1669,   769,  1148,
    1150,  1145,   407,  1727,  1727,   407,  1727,  1727,  1727,  1727,
     769,  1155,  1162,   419,   770,  1956,   299,   374,   487,  1310,
    1314,  1318,  1321,  1889,  1652,   770,  1311,  1313,  1318,  1320,
     772,   776,   984,   776,   984,  1032,   834,   843,   841,   230,
    1896,  1030,  1884,   870,   856,   876,   876,  1613,  1615,   770,
     770,   769,   769,  1198,  1323,   769,  1323,  1323,  1866,  1866,
    1226,   769,  1896,    63,   281,    61,  1672,  1890,  1896,   173,
     728,   641,  1227,  1260,  1258,  1501,  1413,   772,  1726,  1272,
    1134,  1136,   769,  1149,  1150,  1151,   156,  1147,  1150,  1727,
    1890,  1890,  1727,  1672,  1672,  1669,  1901,   688,  1156,  1157,
    1727,   284,   714,  1309,  1312,  1317,  1318,  1319,   580,  1890,
    1727,  1364,  1365,  1366,  1321,  1726,  1364,  1320,  1896,   848,
     846,   416,  1496,   907,   769,   905,   906,   197,   777,   340,
      93,   411,   770,   770,  1323,  1323,   769,   770,  1323,   770,
     770,   770,  1140,    28,   223,   237,   560,  1301,  1301,   769,
    1498,   416,   677,  1218,  1750,  1739,  1840,  1138,   770,   772,
     156,  1153,  1154,  1504,  1890,  1890,  1158,   770,   772,  1182,
    1322,  1322,  1364,  1319,  1889,  1668,  1366,  1365,    61,  1672,
    1890,  1896,   770,  1028,  1028,   876,   878,   894,   226,   230,
     714,  1896,  1032,  1494,   871,   770,   770,  1323,  1309,   770,
    1310,  1311,   770,    61,   176,   320,   180,   180,   770,  1669,
    1215,  1216,  1265,  1215,   586,   682,   735,  1220,   229,  1851,
    1150,   772,  1152,  1159,  1901,  1157,  1896,  2055,  2055,   770,
    2048,   197,  1031,  2045,  1296,  1309,   770,  1309,   281,    63,
     770,  1265,  1221,  1222,  1223,   470,  1845,  1154,   770,  1160,
     878,   714,   416,    75,  1309,  1301,  1301,  1223,    26,  1848,
     641,  1861,   114,  1852,  2046,   177,   769,  1854,   445,   593,
    2040,  2041,   143,   229,  1853,   770,   778,  1855,  1856,  1882,
     237,  1857,  1901,  2047,  1901,   770,   772,  1858,  1859,  1882,
     963,  1856,   772,  1726,   856,  1859,  1494,  1739,  1495
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   779,   780,   781,   780,   780,   782,   782,   783,   783,
     783,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   785,   786,   786,   788,   787,   789,   790,   791,   789,
     792,   793,   792,   794,   794,   796,   795,   798,   797,   799,
     799,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   801,   801,   801,   802,   803,   803,   803,   804,   805,
     805,   805,   806,   807,   807,   807,   807,   807,   807,   807,
     808,   808,   809,   811,   812,   810,   813,   810,   814,   815,
     810,   816,   817,   810,   818,   819,   810,   820,   810,   821,
     810,   822,   810,   823,   810,   824,   810,   825,   810,   826,
     810,   827,   810,   828,   810,   829,   810,   810,   810,   810,
     810,   810,   830,   810,   831,   810,   832,   833,   834,   810,
     835,   835,   836,   836,   836,   837,   837,   838,   838,   839,
     841,   840,   843,   842,   844,   844,   844,   846,   845,   848,
     847,   849,   850,   850,   851,   851,   852,   852,   853,   853,
     854,   854,   855,   855,   855,   855,   855,   855,   855,   855,
     855,   855,   855,   855,   855,   855,   856,   856,   858,   857,
     859,   859,   860,   860,   860,   860,   860,   860,   860,   862,
     861,   864,   863,   863,   865,   865,   865,   865,   866,   866,
     867,   867,   868,   868,   869,   870,   870,   872,   871,   873,
     874,   874,   875,   875,   876,   876,   877,   877,   878,   878,
     879,   879,   879,   879,   879,   879,   879,   880,   880,   881,
     881,   882,   882,   884,   883,   885,   885,   886,   886,   888,
     887,   889,   887,   890,   887,   891,   891,   892,   892,   893,
     893,   894,   895,   894,   896,   896,   897,   898,   898,   898,
     898,   898,   898,   899,   899,   900,   900,   901,   901,   901,
     901,   901,   901,   902,   902,   902,   902,   902,   904,   903,
     905,   906,   906,   907,   907,   908,   908,   909,   909,   911,
     910,   912,   912,   914,   913,   913,   915,   915,   916,   916,
     917,   917,   918,   918,   918,   919,   920,   921,   921,   922,
     923,   924,   924,   924,   924,   925,   925,   925,   926,   925,
     928,   927,   929,   929,   930,   932,   931,   933,   933,   933,
     933,   934,   934,   935,   936,   936,   937,   938,   938,   939,
     939,   939,   939,   939,   939,   940,   940,   941,   942,   942,
     943,   943,   944,   944,   945,   945,   946,   946,   946,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   948,   949,   950,   950,   951,   951,   952,   952,   953,
     954,   954,   955,   955,   955,   956,   957,   957,   958,   959,
     959,   959,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   959,   960,   960,   961,   961,   962,   962,   962,   963,
     963,   963,   963,   963,   963,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   965,   965,
     965,   965,   967,   966,   968,   969,   968,   970,   968,   971,
     968,   973,   972,   974,   974,   976,   975,   975,   978,   977,
     979,   979,   979,   979,   980,   980,   980,   980,   981,   982,
     983,   984,   985,   987,   986,   989,   988,   990,   990,   991,
     991,   992,   993,   993,   993,   994,   994,   995,   996,   996,
     998,   999,  1000,   997,  1001,  1001,  1001,  1003,  1002,  1005,
    1006,  1004,  1004,  1007,  1007,  1008,  1008,  1010,  1011,  1009,
    1013,  1014,  1012,  1015,  1015,  1016,  1016,  1017,  1019,  1018,
    1020,  1021,  1018,  1022,  1022,  1024,  1023,  1025,  1026,  1023,
    1027,  1029,  1030,  1031,  1028,  1033,  1032,  1034,  1034,  1035,
    1035,  1037,  1036,  1038,  1038,  1040,  1039,  1041,  1041,  1041,
    1042,  1044,  1043,  1046,  1045,  1047,  1049,  1048,  1050,  1048,
    1051,  1052,  1053,  1048,  1054,  1048,  1056,  1055,  1057,  1055,
    1058,  1059,  1055,  1060,  1055,  1061,  1061,  1062,  1062,  1062,
    1063,  1064,  1065,  1066,  1066,  1067,  1067,  1068,  1069,  1070,
    1070,  1072,  1071,  1073,  1073,  1073,  1074,  1074,  1074,  1075,
    1076,  1076,  1076,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1078,  1079,  1079,  1079,  1080,  1080,  1080,  1080,  1080,
    1081,  1082,  1082,  1082,  1083,  1083,  1083,  1083,  1083,  1083,
    1083,  1084,  1085,  1085,  1085,  1086,  1086,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1092,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1102,  1103,  1103,  1104,
    1104,  1106,  1105,  1105,  1105,  1107,  1107,  1108,  1108,  1109,
    1109,  1110,  1111,  1111,  1113,  1112,  1114,  1116,  1115,  1118,
    1117,  1119,  1120,  1119,  1119,  1119,  1121,  1119,  1119,  1122,
    1119,  1123,  1123,  1124,  1124,  1125,  1125,  1126,  1126,  1127,
    1128,  1129,  1130,  1131,  1131,  1132,  1133,  1132,  1134,  1132,
    1135,  1135,  1136,  1137,  1138,  1138,  1139,  1139,  1140,  1140,
    1142,  1141,  1143,  1144,  1145,  1144,  1146,  1144,  1144,  1144,
    1144,  1147,  1147,  1148,  1148,  1149,  1149,  1151,  1152,  1150,
    1153,  1153,  1154,  1154,  1155,  1155,  1156,  1156,  1158,  1157,
    1159,  1160,  1160,  1161,  1161,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1163,  1164,  1163,  1163,  1165,  1165,
    1166,  1166,  1167,  1167,  1168,  1168,  1169,  1169,  1170,  1170,
    1171,  1171,  1172,  1172,  1173,  1173,  1174,  1174,  1175,  1175,
    1175,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1177,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1178,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1184,  1184,
    1184,  1184,  1184,  1184,  1185,  1185,  1185,  1186,  1186,  1186,
    1186,  1187,  1188,  1189,  1189,  1190,  1190,  1190,  1190,  1190,
    1191,  1191,  1193,  1192,  1194,  1192,  1195,  1192,  1196,  1192,
    1197,  1192,  1198,  1192,  1199,  1192,  1200,  1201,  1202,  1203,
    1203,  1204,  1205,  1205,  1206,  1206,  1207,  1209,  1208,  1211,
    1210,  1212,  1210,  1213,  1213,  1214,  1214,  1215,  1215,  1216,
    1216,  1217,  1217,  1217,  1217,  1218,  1217,  1217,  1217,  1219,
    1219,  1220,  1220,  1220,  1220,  1221,  1221,  1222,  1222,  1223,
    1223,  1223,  1223,  1225,  1224,  1226,  1226,  1227,  1227,  1228,
    1228,  1229,  1229,  1230,  1231,  1231,  1232,  1232,  1232,  1232,
    1232,  1233,  1233,  1233,  1233,  1233,  1234,  1234,  1234,  1234,
    1234,  1234,  1234,  1234,  1234,  1234,  1235,  1235,  1235,  1235,
    1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,  1237,  1237,
    1237,  1237,  1237,  1237,  1237,  1237,  1238,  1238,  1238,  1238,
    1238,  1239,  1239,  1239,  1239,  1239,  1239,  1239,  1239,  1239,
    1239,  1239,  1239,  1239,  1239,  1239,  1239,  1240,  1240,  1241,
    1241,  1241,  1241,  1241,  1241,  1241,  1241,  1242,  1243,  1243,
    1244,  1244,  1245,  1245,  1245,  1245,  1245,  1246,  1246,  1246,
    1246,  1246,  1247,  1247,  1247,  1248,  1248,  1249,  1249,  1249,
    1250,  1251,  1251,  1251,  1251,  1251,  1251,  1252,  1252,  1252,
    1252,  1253,  1253,  1254,  1254,  1255,  1255,  1256,  1256,  1257,
    1257,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1260,  1260,  1261,  1261,  1262,  1263,  1264,  1265,  1265,  1265,
    1266,  1266,  1266,  1266,  1266,  1266,  1267,  1267,  1268,  1269,
    1269,  1270,  1270,  1271,  1271,  1272,  1272,  1273,  1273,  1274,
    1274,  1275,  1276,  1276,  1277,  1277,  1278,  1278,  1279,  1279,
    1279,  1280,  1281,  1281,  1282,  1282,  1282,  1282,  1282,  1282,
    1283,  1283,  1285,  1284,  1286,  1286,  1287,  1288,  1288,  1288,
    1288,  1289,  1290,  1291,  1291,  1292,  1293,  1293,  1294,  1294,
    1295,  1295,  1296,  1297,  1297,  1298,  1298,  1299,  1299,  1299,
    1299,  1300,  1300,  1300,  1300,  1300,  1301,  1301,  1301,  1301,
    1301,  1302,  1302,  1303,  1303,  1304,  1304,  1305,  1305,  1305,
    1306,  1306,  1307,  1308,  1309,  1309,  1310,  1310,  1311,  1311,
    1312,  1312,  1313,  1313,  1314,  1314,  1315,  1315,  1316,  1316,
    1316,  1317,  1317,  1318,  1318,  1318,  1318,  1318,  1318,  1319,
    1319,  1320,  1321,  1321,  1322,  1322,  1322,  1323,  1323,  1324,
    1324,  1325,  1325,  1326,  1326,  1328,  1329,  1327,  1330,  1327,
    1327,  1331,  1327,  1332,  1327,  1333,  1327,  1334,  1327,  1335,
    1327,  1327,  1327,  1327,  1327,  1336,  1327,  1327,  1337,  1338,
    1327,  1339,  1339,  1340,  1340,  1340,  1340,  1341,  1341,  1341,
    1341,  1341,  1342,  1342,  1342,  1342,  1343,  1343,  1344,  1344,
    1345,  1345,  1346,  1346,  1346,  1346,  1346,  1346,  1346,  1346,
    1346,  1346,  1347,  1346,  1346,  1348,  1346,  1349,  1346,  1346,
    1346,  1346,  1346,  1350,  1351,  1351,  1353,  1352,  1354,  1354,
    1354,  1356,  1355,  1357,  1358,  1357,  1359,  1359,  1360,  1361,
    1361,  1362,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1364,  1364,  1364,  1364,  1364,  1365,  1365,  1366,  1366,
    1367,  1367,  1368,  1368,  1370,  1369,  1371,  1371,  1372,  1372,
    1373,  1373,  1374,  1374,  1374,  1375,  1375,  1375,  1376,  1376,
    1376,  1376,  1378,  1377,  1379,  1377,  1377,  1377,  1380,  1381,
    1381,  1382,  1382,  1383,  1383,  1383,  1385,  1384,  1386,  1386,
    1387,  1387,  1387,  1388,  1388,  1388,  1389,  1389,  1391,  1390,
    1392,  1392,  1392,  1393,  1394,  1393,  1396,  1395,  1397,  1397,
    1398,  1398,  1399,  1399,  1399,  1400,  1400,  1402,  1401,  1403,
    1403,  1404,  1405,  1405,  1406,  1406,  1407,  1408,  1407,  1409,
    1410,  1409,  1411,  1411,  1411,  1412,  1412,  1412,  1413,  1413,
    1414,  1414,  1415,  1416,  1415,  1418,  1417,  1419,  1419,  1420,
    1420,  1421,  1421,  1421,  1421,  1421,  1421,  1422,  1422,  1424,
    1423,  1425,  1425,  1425,  1427,  1426,  1426,  1428,  1428,  1429,
    1429,  1430,  1432,  1431,  1433,  1433,  1434,  1434,  1435,  1436,
    1437,  1437,  1439,  1438,  1440,  1440,  1441,  1441,  1442,  1443,
    1445,  1444,  1447,  1446,  1448,  1448,  1449,  1449,  1451,  1450,
    1452,  1450,  1454,  1453,  1455,  1453,  1456,  1456,  1458,  1457,
    1460,  1461,  1459,  1462,  1463,  1464,  1464,  1465,  1465,  1467,
    1466,  1468,  1466,  1469,  1469,  1470,  1471,  1470,  1470,  1472,
    1472,  1473,  1474,  1475,  1475,  1476,  1476,  1477,  1478,  1478,
    1479,  1479,  1480,  1480,  1480,  1481,  1481,  1481,  1482,  1483,
    1483,  1484,  1484,  1485,  1485,  1485,  1485,  1486,  1486,  1487,
    1487,  1487,  1488,  1488,  1489,  1489,  1490,  1490,  1490,  1491,
    1491,  1491,  1492,  1492,  1493,  1494,  1495,  1496,  1497,  1497,
    1497,  1497,  1497,  1498,  1498,  1498,  1499,  1499,  1499,  1500,
    1500,  1501,  1501,  1501,  1501,  1501,  1502,  1502,  1502,  1502,
    1502,  1502,  1502,  1502,  1502,  1502,  1502,  1502,  1503,  1503,
    1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,
    1503,  1503,  1503,  1503,  1504,  1504,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1505,  1505,  1506,  1506,  1507,  1507,  1508,
    1508,  1509,  1509,  1509,  1509,  1509,  1509,  1510,  1510,  1511,
    1511,  1512,  1512,  1512,  1513,  1513,  1513,  1513,  1513,  1513,
    1514,  1514,  1514,  1516,  1515,  1515,  1517,  1518,  1518,  1519,
    1519,  1519,  1519,  1520,  1521,  1521,  1521,  1521,  1521,  1521,
    1521,  1521,  1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,
    1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,
    1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,  1522,
    1522,  1523,  1523,  1523,  1523,  1524,  1524,  1525,  1525,  1525,
    1525,  1525,  1525,  1526,  1526,  1527,  1527,  1528,  1528,  1528,
    1528,  1528,  1528,  1528,  1528,  1528,  1528,  1528,  1528,  1528,
    1528,  1528,  1528,  1528,  1528,  1528,  1528,  1528,  1529,  1529,
    1529,  1529,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1531,
    1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,
    1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,  1531,
    1531,  1531,  1531,  1531,  1531,  1531,  1532,  1532,  1532,  1532,
    1532,  1532,  1532,  1532,  1532,  1534,  1533,  1533,  1533,  1535,
    1535,  1536,  1536,  1537,  1537,  1538,  1538,  1539,  1539,  1540,
    1541,  1541,  1541,  1541,  1541,  1541,  1541,  1542,  1543,  1541,
    1541,  1541,  1541,  1541,  1541,  1541,  1541,  1541,  1541,  1541,
    1544,  1541,  1545,  1545,  1546,  1546,  1546,  1547,  1547,  1547,
    1547,  1547,  1547,  1547,  1547,  1547,  1547,  1547,  1547,  1547,
    1548,  1550,  1549,  1549,  1551,  1551,  1552,  1553,  1555,  1554,
    1556,  1556,  1556,  1556,  1557,  1557,  1558,  1558,  1559,  1559,
    1560,  1560,  1561,  1561,  1562,  1563,  1564,  1564,  1564,  1566,
    1565,  1567,  1568,  1567,  1569,  1567,  1570,  1567,  1567,  1567,
    1567,  1571,  1571,  1571,  1571,  1571,  1571,  1571,  1571,  1572,
    1572,  1572,  1572,  1573,  1573,  1574,  1574,  1575,  1575,  1576,
    1576,  1577,  1577,  1578,  1578,  1579,  1579,  1580,  1581,  1581,
    1582,  1582,  1583,  1584,  1583,  1585,  1583,  1583,  1586,  1583,
    1587,  1583,  1583,  1588,  1583,  1589,  1583,  1583,  1590,  1590,
    1590,  1591,  1591,  1592,  1592,  1593,  1594,  1594,  1594,  1594,
    1595,  1595,  1596,  1596,  1597,  1597,  1598,  1598,  1599,  1599,
    1600,  1601,  1602,  1602,  1603,  1603,  1603,  1603,  1604,  1604,
    1606,  1605,  1607,  1605,  1608,  1608,  1609,  1610,  1609,  1612,
    1611,  1613,  1613,  1614,  1614,  1615,  1615,  1616,  1616,  1617,
    1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,
    1617,  1618,  1618,  1618,  1618,  1618,  1618,  1618,  1618,  1618,
    1619,  1619,  1619,  1619,  1620,  1620,  1620,  1621,  1621,  1622,
    1623,  1623,  1624,  1625,  1624,  1626,  1627,  1626,  1628,  1628,
    1629,  1629,  1630,  1630,  1630,  1631,  1631,  1632,  1632,  1633,
    1635,  1634,  1636,  1636,  1637,  1637,  1638,  1638,  1639,  1639,
    1640,  1640,  1641,  1641,  1642,  1642,  1642,  1643,  1643,  1643,
    1644,  1644,  1644,  1644,  1644,  1644,  1645,  1646,  1646,  1647,
    1648,  1648,  1650,  1649,  1651,  1651,  1652,  1652,  1652,  1653,
    1653,  1654,  1654,  1654,  1655,  1656,  1656,  1656,  1657,  1657,
    1657,  1657,  1657,  1657,  1658,  1659,  1659,  1659,  1659,  1660,
    1660,  1660,  1661,  1661,  1662,  1663,  1664,  1664,  1664,  1665,
    1665,  1666,  1666,  1667,  1667,  1668,  1668,  1668,  1668,  1668,
    1668,  1669,  1669,  1669,  1669,  1669,  1670,  1670,  1670,  1670,
    1671,  1671,  1671,  1671,  1671,  1672,  1672,  1672,  1672,  1672,
    1673,  1674,  1674,  1675,  1675,  1676,  1676,  1676,  1678,  1677,
    1679,  1679,  1680,  1680,  1681,  1683,  1682,  1684,  1684,  1685,
    1686,  1686,  1686,  1687,  1689,  1690,  1688,  1688,  1688,  1692,
    1691,  1694,  1693,  1695,  1693,  1693,  1693,  1693,  1693,  1693,
    1693,  1693,  1693,  1696,  1693,  1693,  1693,  1693,  1693,  1693,
    1697,  1693,  1698,  1698,  1699,  1700,  1701,  1701,  1702,  1703,
    1703,  1704,  1704,  1705,  1705,  1707,  1708,  1706,  1710,  1711,
    1709,  1712,  1712,  1712,  1712,  1713,  1713,  1714,  1714,  1716,
    1715,  1717,  1717,  1718,  1717,  1719,  1720,  1720,  1721,  1721,
    1722,  1723,  1723,  1724,  1724,  1725,  1726,  1726,  1727,  1727,
    1728,  1728,  1729,  1729,  1731,  1730,  1733,  1732,  1734,  1734,
    1735,  1735,  1736,  1736,  1737,  1737,  1738,  1738,  1739,  1739,
    1740,  1741,  1742,  1740,  1743,  1743,  1745,  1746,  1744,  1747,
    1747,  1748,  1748,  1749,  1749,  1750,  1751,  1751,  1753,  1752,
    1754,  1754,  1755,  1755,  1756,  1757,  1758,  1759,  1758,  1760,
    1758,  1761,  1761,  1762,  1762,  1763,  1763,  1764,  1764,  1765,
    1765,  1766,  1766,  1766,  1768,  1769,  1767,  1770,  1770,  1770,
    1771,  1771,  1772,  1772,  1773,  1773,  1774,  1774,  1774,  1774,
    1774,  1774,  1774,  1774,  1774,  1775,  1775,  1777,  1776,  1778,
    1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1779,  1778,  1780,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,  1778,
    1781,  1781,  1781,  1782,  1782,  1783,  1783,  1784,  1784,  1785,
    1785,  1786,  1786,  1787,  1787,  1788,  1788,  1789,  1789,  1789,
    1791,  1790,  1792,  1790,  1793,  1793,  1793,  1793,  1793,  1793,
    1794,  1794,  1795,  1796,  1796,  1796,  1796,  1797,  1797,  1798,
    1798,  1798,  1800,  1799,  1802,  1801,  1801,  1803,  1803,  1804,
    1805,  1804,  1806,  1806,  1807,  1807,  1807,  1807,  1807,  1807,
    1807,  1807,  1807,  1807,  1807,  1807,  1807,  1807,  1807,  1807,
    1807,  1808,  1808,  1809,  1810,  1811,  1810,  1810,  1812,  1812,
    1813,  1813,  1813,  1814,  1815,  1815,  1817,  1816,  1818,  1818,
    1820,  1819,  1821,  1819,  1819,  1822,  1822,  1823,  1823,  1824,
    1825,  1824,  1827,  1826,  1828,  1828,  1828,  1829,  1829,  1829,
    1830,  1830,  1831,  1831,  1833,  1832,  1834,  1834,  1835,  1837,
    1838,  1839,  1840,  1836,  1841,  1841,  1842,  1842,  1843,  1843,
    1843,  1844,  1844,  1844,  1845,  1845,  1846,  1846,  1847,  1847,
    1847,  1847,  1848,  1848,  1849,  1849,  1850,  1850,  1851,  1851,
    1852,  1852,  1853,  1853,  1854,  1854,  1854,  1855,  1855,  1856,
    1856,  1857,  1857,  1858,  1858,  1859,  1860,  1860,  1860,  1860,
    1861,  1861,  1862,  1862,  1862,  1863,  1863,  1863,  1864,  1864,
    1865,  1865,  1865,  1865,  1865,  1865,  1865,  1865,  1865,  1865,
    1866,  1866,  1866,  1866,  1866,  1867,  1867,  1867,  1869,  1868,
    1870,  1870,  1871,  1871,  1873,  1872,  1874,  1874,  1875,  1875,
    1876,  1877,  1877,  1878,  1878,  1879,  1879,  1880,  1881,  1881,
    1881,  1881,  1881,  1882,  1882,  1882,  1882,  1882,  1883,  1883,
    1883,  1883,  1884,  1884,  1884,  1885,  1885,  1886,  1887,  1887,
    1888,  1888,  1888,  1889,  1890,  1891,  1892,  1893,  1893,  1894,
    1894,  1895,  1895,  1895,  1896,  1896,  1897,  1897,  1898,  1898,
    1899,  1899,  1900,  1901,  1901,  1901,  1902,  1902,  1902,  1903,
    1903,  1904,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,
    1905,  1906,  1906,  1906,  1906,  1906,  1906,  1906,  1906,  1906,
    1906,  1907,  1907,  1907,  1907,  1907,  1907,  1908,  1908,  1908,
    1908,  1908,  1908,  1908,  1908,  1908,  1909,  1909,  1909,  1909,
    1909,  1909,  1909,  1910,  1910,  1910,  1910,  1910,  1910,  1910,
    1910,  1910,  1911,  1911,  1911,  1911,  1911,  1911,  1911,  1912,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1913,  1913,  1913,  1913,  1913,  1913,
    1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1915,  1915,  1915,  1916,  1916,  1916,  1917,  1917,  1917,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1918,  1918,  1918,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,  1919,
    1919,  1919,  1919,  1919,  1919,  1919,  1919,  1921,  1920,  1922,
    1923,  1920,  1925,  1924,  1926,  1924,  1927,  1924,  1928,  1928,
    1930,  1929,  1931,  1929,  1932,  1929,  1934,  1933,  1933,  1935,
    1935,  1937,  1936,  1938,  1936,  1940,  1939,  1939,  1941,  1941,
    1941,  1942,  1942,  1942,  1942,  1943,  1943,  1943,  1943,  1944,
    1944,  1944,  1945,  1945,  1945,  1945,  1945,  1945,  1945,  1945,
    1945,  1945,  1945,  1945,  1945,  1945,  1945,  1946,  1946,  1946,
    1946,  1947,  1948,  1949,  1949,  1950,  1950,  1950,  1950,  1951,
    1951,  1952,  1952,  1952,  1953,  1953,  1953,  1953,  1953,  1955,
    1954,  1956,  1956,  1956,  1957,  1957,  1958,  1958,  1959,  1960,
    1960,  1960,  1960,  1960,  1962,  1961,  1964,  1963,  1965,  1965,
    1966,  1965,  1967,  1967,  1968,  1968,  1969,  1969,  1969,  1969,
    1970,  1969,  1971,  1971,  1971,  1971,  1971,  1972,  1973,  1973,
    1973,  1973,  1973,  1973,  1973,  1973,  1974,  1974,  1975,  1976,
    1976,  1976,  1976,  1976,  1976,  1976,  1977,  1977,  1978,  1978,
    1979,  1979,  1980,  1981,  1981,  1982,  1982,  1983,  1983,  1984,
    1984,  1985,  1985,  1987,  1986,  1988,  1986,  1989,  1986,  1990,
    1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,
    1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,
    1986,  1986,  1986,  1986,  1986,  1986,  1986,  1986,  1991,  1991,
    1992,  1992,  1993,  1993,  1993,  1994,  1994,  1994,  1994,  1995,
    1995,  1996,  1996,  1997,  1997,  1998,  1998,  1999,  1999,  2000,
    2000,  2000,  2000,  2001,  2001,  2002,  2003,  2003,  2003,  2004,
    2004,  2005,  2005,  2006,  2007,  2007,  2007,  2007,  2007,  2008,
    2008,  2008,  2008,  2008,  2009,  2009,  2010,  2010,  2011,  2011,
    2012,  2012,  2013,  2013,  2014,  2014,  2016,  2015,  2017,  2018,
    2018,  2019,  2019,  2020,  2020,  2020,  2021,  2021,  2021,  2022,
    2023,  2023,  2023,  2024,  2025,  2026,  2026,  2026,  2027,  2027,
    2027,  2028,  2028,  2028,  2028,  2028,  2028,  2028,  2028,  2028,
    2029,  2029,  2030,  2031,  2032,  2032,  2032,  2033,  2033,  2034,
    2034,  2035,  2035,  2036,  2036,  2038,  2037,  2039,  2039,  2039,
    2039,  2040,  2040,  2041,  2041,  2043,  2044,  2045,  2046,  2047,
    2042,  2049,  2048,  2051,  2050,  2053,  2054,  2052,  2055,  2055,
    2056,  2056,  2057,  2057,  2057,  2057,  2057,  2057,  2058,  2058,
    2059,  2059,  2059,  2060,  2060,  2060,  2061,  2061,  2061,  2062,
    2062,  2063,  2064,  2063,  2065,  2065,  2066,  2066,  2067,  2067,
    2068
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     0,     5,     3,     0,     0,     6,
       0,     0,     3,     1,     3,     0,     3,     0,     6,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     5,     5,
       1,     0,     1,     3,     1,     0,     1,     3,     1,     0,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     1,     0,     0,     8,     0,     8,     0,     0,
      16,     0,     0,    15,     0,     0,    15,     0,     6,     0,
      10,     0,    11,     0,     5,     0,     6,     0,     5,     0,
      11,     0,    14,     0,    11,     0,    14,    10,     8,     6,
       4,     3,     0,     3,     0,    13,     0,     0,     0,    16,
       1,     3,     1,     1,     2,     1,     2,     1,     2,     0,
       0,     8,     0,     6,     4,     4,     1,     0,     5,     0,
       5,     2,     0,     1,     1,     2,     3,     3,     0,     1,
       1,     2,     3,     2,     1,     3,     2,     1,     3,     3,
       3,     1,     1,     1,     1,     3,     0,     1,     0,    12,
       1,     3,     2,     2,     2,     2,     2,     2,     2,     0,
      12,     0,     6,     2,     0,     1,     3,     1,     0,     2,
       0,     2,     0,     1,     4,     0,     2,     0,     3,     0,
       0,     1,     3,     1,     0,     1,     0,     2,     0,     2,
       2,     2,     2,     2,     3,     3,     1,     2,     1,     1,
       2,     0,     1,     0,     2,     1,     2,     3,     3,     0,
       4,     0,     6,     0,     8,     0,     3,     0,     1,     3,
       1,     0,     0,     2,     3,     1,     1,     2,     6,     8,
       4,     6,     3,     0,     1,     3,     1,     3,     7,     9,
       5,     7,     4,     0,     1,     1,     1,     2,     0,     4,
       0,     1,     3,     1,     1,     0,     3,     2,     3,     0,
       2,     0,     1,     0,     3,     1,     2,     3,     2,     3,
       0,     1,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     5,     4,     1,     4,     2,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     1,     0,     3,     0,     5,     0,
       7,     0,     2,     1,     1,     0,     3,     1,     0,     2,
       1,     2,     3,     4,     1,     2,     3,     4,     2,     2,
       2,     0,     0,     0,     3,     0,     3,     1,     3,     0,
       3,     3,     3,     4,     5,     2,     4,     2,     1,     3,
       0,     0,     0,     7,     0,     2,     2,     0,     6,     0,
       0,     4,     1,     1,     2,     1,     2,     0,     0,     6,
       0,     0,     6,     0,     2,     0,     1,     1,     0,     6,
       0,     0,     9,     0,     2,     0,     5,     0,     0,     7,
       0,     0,     0,     0,     7,     0,     4,     0,     2,     1,
       2,     0,     5,     0,     1,     0,     3,     5,     3,     5,
       3,     0,     6,     0,     6,     1,     0,     5,     0,     5,
       0,     0,     0,    11,     0,     5,     0,     3,     0,     3,
       0,     0,     8,     0,     3,     1,     1,     1,     1,     1,
       2,     4,     5,     0,     4,     4,     4,     3,     3,     2,
       2,     0,     2,     1,     2,     3,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     0,     5,     3,     1,     2,     4,     0,     4,     1,
       4,     1,     0,     1,     0,     4,     0,     0,     3,     0,
       6,     6,     0,     4,     2,     2,     0,     3,     2,     0,
       3,     0,     1,     0,     3,     0,     1,     1,     3,     1,
       4,     3,     3,     0,     2,     0,     0,     7,     0,    10,
       1,     3,     1,     1,     0,     2,     0,     3,     1,     3,
       0,     6,     1,     0,     0,     4,     0,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     0,     0,     5,
       1,     3,     1,     1,     0,     3,     1,     3,     0,     4,
       1,     0,     1,     2,     1,     3,     4,     3,     3,     3,
       3,     4,     4,     3,     0,     0,     5,     2,     0,     2,
       0,     1,     0,     1,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     3,     0,     1,     1,     2,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     0,     6,     1,     1,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       0,     1,     2,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     2,
       1,     2,     0,     9,     0,    10,     0,     9,     0,     9,
       0,    10,     0,    11,     0,    10,     2,     7,     7,     0,
       1,     4,     0,     1,     0,     1,     2,     0,     4,     0,
       3,     0,     3,     0,     1,     2,     1,     0,     1,     2,
       1,     0,     1,     2,     3,     0,     6,     5,     5,     0,
       2,     0,     1,     1,     1,     0,     1,     2,     1,     1,
       2,     2,     1,     0,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     2,
       1,     1,     3,     3,     3,     3,     0,     1,     2,     2,
       3,     3,     2,     3,     3,     4,     3,     3,     3,     3,
       2,     3,     3,     3,     2,     2,     3,     1,     2,     2,
       2,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       2,     3,     2,     2,     2,     2,     2,     5,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     1,     2,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     3,     0,     1,     1,
       5,     0,     1,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     2,     1,     1,     2,     4,     1,     3,     2,     1,
       0,     2,     0,     1,     2,     2,     2,     2,     2,     1,
       1,     3,     3,     3,     3,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     0,     2,     1,     1,     0,     1,     2,     1,
       1,     2,     0,     1,     1,     2,     1,     2,     2,     1,
       0,     1,     0,     4,     1,     1,     1,     0,     1,     2,
       1,     1,     2,     1,     3,     3,     1,     1,     0,     2,
       0,     1,     5,     0,     3,     3,     1,     0,     2,     2,
       2,     0,     3,     3,     6,     6,     1,     1,     2,     2,
       2,     2,     2,     1,     1,     0,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     1,     2,     1,     2,     0,     2,     0,     2,
       2,     2,     2,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     4,     2,     1,
       4,     0,     1,     1,     3,     0,     0,     8,     0,     5,
       7,     0,     5,     0,     5,     0,    10,     0,     9,     0,
      11,     3,     4,     3,     3,     0,     8,     8,     0,     0,
       7,     1,     1,     0,     1,     1,     3,     0,     2,     3,
       5,     5,     0,     3,     1,     4,     0,     3,     0,     2,
       0,     1,     0,     2,     2,     2,     2,     1,     1,     1,
       4,     4,     0,     6,     4,     0,     5,     0,     6,     4,
       3,     1,     7,     2,     1,     1,     0,     6,     0,     3,
       2,     0,     5,     0,     0,     6,     1,     3,     1,     1,
       3,     3,     3,     2,     2,     4,     4,     2,     7,     6,
       5,     5,     4,     5,     4,     4,     2,     2,     7,     6,
       3,     5,     1,     1,     1,     1,     1,     3,     3,     3,
       5,     0,     1,     1,     2,     2,     3,     3,     3,     3,
       0,     1,     0,     1,     0,     2,     0,     1,     2,     1,
       1,     1,     0,     1,     1,     0,     2,     1,     0,     1,
       1,     1,     0,     6,     0,     5,     4,     4,     3,     0,
       1,     1,     3,     3,     2,     2,     0,     2,     1,     3,
       0,     1,     1,     0,     2,     4,     1,     3,     0,     5,
       0,     1,     1,     3,     0,     4,     0,     4,     0,     1,
       1,     2,     1,     1,     1,     0,     2,     0,     5,     1,
       3,     2,     0,     3,     1,     4,     1,     0,     4,     1,
       0,     4,     0,     1,     3,     0,     1,     3,     1,     1,
       2,     6,     3,     0,     4,     0,     3,     0,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     0,     2,     0,
       6,     0,     1,     1,     0,     4,     4,     3,     5,     1,
       3,     4,     0,     6,     1,     1,     1,     3,     2,     3,
       1,     1,     0,     6,     1,     1,     1,     3,     3,     4,
       0,     6,     0,     2,     0,     4,     0,     2,     0,     3,
       0,     4,     0,     3,     0,     4,     1,     1,     0,     3,
       0,     0,     5,     6,     7,     1,     2,     1,     1,     0,
       3,     0,     3,     3,     3,     1,     0,     4,     3,     1,
       1,     1,     1,     1,     4,     0,     1,     2,     1,     1,
       0,     1,     0,     1,     1,     2,     1,     2,     9,     0,
       1,     0,     2,     3,     1,     4,     4,     2,     1,     1,
       1,     1,     3,     5,     0,     1,     0,     2,     1,     3,
       1,     1,     3,     4,     0,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     4,     4,     4,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     7,     6,     3,     4,
       6,     6,     4,     4,     4,     4,     4,     4,     6,     8,
      10,     1,     1,     3,     1,     1,     3,     1,     2,     2,
       2,     2,     2,     1,     3,     4,     6,     4,     6,     2,
       2,     4,     4,     4,    10,     6,     8,     6,     4,     4,
       6,     4,     3,     4,     1,     4,     3,     4,     5,     3,
       5,     3,     6,     8,     2,     2,     8,     8,     6,     8,
       6,     6,     2,     6,     6,     8,     4,     2,     8,     8,
       4,     2,     2,     2,     6,     6,     4,     4,     8,     4,
       4,     4,     4,     3,     8,     6,     8,     4,     6,     4,
       6,     4,     4,     4,     6,     8,     4,     3,     6,     4,
       6,     5,     8,     7,    10,     1,     6,     4,     4,     4,
       4,     4,     6,     4,     6,     0,     5,     6,     8,     2,
       3,     0,     4,     0,     3,     0,     1,     1,     3,     4,
       4,     5,     4,     4,     4,     5,     4,     0,     0,     7,
       4,     5,     4,     5,     4,     4,     4,     4,     4,     5,
       0,     9,     3,     3,     1,     1,     1,     3,     3,     3,
       3,     3,     4,     4,     4,     6,     4,     6,     4,     6,
       5,     0,     7,     4,     4,     4,     4,     1,     0,     3,
       3,     1,     3,     5,     0,     1,     0,     2,     0,     3,
       4,     2,     0,     1,     1,     2,     1,     3,     3,     0,
       3,     2,     0,     4,     0,     4,     0,     4,     2,     1,
       1,     1,     1,     2,     1,     2,     2,     1,     2,     1,
       2,     2,     3,     0,     1,     1,     3,     1,     3,     1,
       3,     4,     5,     1,     3,     1,     1,     1,     1,     4,
       1,     3,     3,     0,     6,     0,     8,     4,     0,     8,
       0,    10,     6,     0,     8,     0,    10,     6,     1,     2,
       1,     1,     2,     0,     1,     5,     1,     1,     1,     1,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       5,     3,     0,     1,     0,     2,     3,     3,     1,     1,
       0,     7,     0,     7,     1,     2,     0,     0,     2,     0,
       2,     0,     1,     1,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     0,     1,     2,
       0,     1,     0,     0,     3,     0,     0,     3,     0,     4,
       4,     2,     0,     1,     1,     0,     2,     3,     1,     3,
       0,     7,     0,     1,     0,     3,     0,     3,     0,     3,
       1,     1,     1,     4,     2,     2,     2,     1,     2,     2,
       0,     3,     2,     2,     3,     3,     3,     3,     1,     2,
       0,     1,     0,     4,     4,     2,     0,     1,     1,     0,
       1,     2,     5,     4,     1,     1,     3,     3,     1,     3,
       1,     1,     1,     1,     1,     0,     2,     3,     4,     1,
       2,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       1,     0,     1,     2,     2,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     6,
       0,     1,     3,     1,     3,     0,     2,     3,     1,     1,
       2,     1,     3,     2,     0,     0,     7,     2,     1,     0,
       3,     0,     8,     0,     8,     4,     4,     5,     6,     4,
       4,     5,     5,     0,     6,     4,     4,     5,     6,     4,
       0,     6,     1,     3,     1,     2,     1,     3,     1,     0,
       2,     0,     2,     0,     1,     0,     0,     8,     0,     0,
       6,     0,     1,     1,     1,     1,     1,     2,     1,     0,
       2,     1,     2,     0,     3,     3,     0,     1,     3,     1,
       1,     3,     1,     3,     1,     3,     1,     1,     0,     1,
       1,     1,     1,     1,     0,     4,     0,     4,     0,     1,
       0,     1,     3,     1,     5,     3,     1,     1,     1,     1,
       0,     0,     0,     7,     5,     1,     0,     0,    11,     3,
       1,     3,     3,     3,     1,     3,     0,     1,     0,     3,
       0,     3,     2,     3,     3,     2,     5,     0,     5,     0,
       6,     0,     2,     1,     3,     2,     4,     0,     2,     0,
       2,     1,     1,     1,     0,     0,     7,     0,     2,     2,
       0,     1,     0,     1,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     0,     3,     0,     3,     2,
       4,     4,     3,     4,     4,     1,     3,     3,     3,     3,
       6,     2,     2,     0,     6,     0,     7,     5,     2,     1,
       1,     1,     5,     5,     2,     2,     1,     4,     3,     2,
       3,     2,     2,     1,     4,     4,     3,     3,     3,     2,
       3,     2,     3,     3,     3,     3,     4,     3,     2,     3,
       3,     3,     3,     4,     3,     3,     4,     3,     3,     3,
       1,     1,     1,     1,     1,     0,     1,     0,     2,     0,
       1,     1,     1,     0,     2,     0,     2,     0,     3,     3,
       0,     4,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     1,     1,     0,     3,     0,
       1,     1,     0,     4,     0,     4,     1,     0,     1,     4,
       0,     3,     3,     1,     2,     2,     2,     2,     3,     3,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       2,     0,     1,     2,     2,     0,     3,     1,     0,     5,
       0,     1,     3,     1,     0,     3,     0,     3,     3,     1,
       0,     4,     0,     3,     2,     0,     1,     0,     2,     5,
       0,     6,     0,     4,     0,     1,     1,     2,     2,     3,
       0,     1,     1,     2,     0,     3,     0,     4,     2,     0,
       0,     0,     0,    22,     1,     1,     0,     1,     0,     1,
       1,     0,     1,     1,     0,     2,     2,     1,     3,     4,
       3,     3,     0,     2,     2,     1,     3,     3,     0,     4,
       0,     3,     1,     1,     0,     3,     2,     3,     1,     1,
       2,     0,     2,     3,     1,     5,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     2,     2,     0,     4,
       0,     1,     1,     3,     0,     7,     0,     3,     1,     3,
       1,     1,     1,     3,     5,     3,     5,     1,     1,     3,
       4,     5,     4,     1,     3,     4,     4,     5,     1,     5,
       3,     2,     1,     3,     2,     2,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     3,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     3,     0,
       0,     7,     0,     4,     0,     6,     0,     7,     1,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     2,     0,
       2,     0,     2,     0,     4,     0,     3,     1,     1,     1,
       1,     0,     1,     1,     1,     0,     2,     2,     2,     3,
       5,     5,     3,     5,     5,     4,     6,     8,     8,     2,
       3,     3,     3,     5,     2,     3,     3,     1,     1,     3,
       3,     1,     3,     2,     2,     2,     2,     2,     1,     1,
       3,     1,     4,     4,     1,     1,     1,     1,     1,     0,
       5,     0,     2,     1,     1,     1,     1,     3,     3,     1,
       1,     2,     2,     2,     0,     3,     0,     3,     3,     2,
       0,     6,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     1,     1,     1,     1,     3,     6,     6,
       6,     6,     7,     7,     5,     3,     4,     1,     3,     8,
       8,     8,     8,     9,     6,     4,     0,     3,     0,     3,
       1,     3,     2,     1,     1,     0,     1,     1,     2,     0,
       1,     1,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     2,     0,     1,
       3,     1,     2,     2,     2,     1,     3,     3,     1,     1,
       3,     1,     3,     1,     3,     1,     1,     1,     1,     4,
       5,     4,     1,     3,     1,     2,     0,     2,     5,     0,
       3,     3,     1,     1,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     0,     2,     0,     2,
       0,     3,     2,     1,     2,     1,     0,     3,     1,     0,
       1,     0,     1,     0,     3,     2,     0,     1,     2,     4,
       4,     5,     4,     2,     3,     2,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     3,     3,     3,     3,     0,     1,     3,
       3,     0,     3,     1,     3,     0,     3,     0,     3,     4,
       4,     1,     1,     0,     2,     0,     0,     0,     0,     0,
      20,     0,     2,     0,     5,     0,     0,     8,     0,     1,
       1,     1,     4,     4,     3,     4,     3,     3,     0,     3,
       1,     3,     5,     1,     1,     1,     0,     1,     1,     0,
       2,     0,     0,     3,     0,     2,     6,     3,     4,     4,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 1756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 25868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3: /* $@1: %empty  */
#line 1765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 25895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 1790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 25904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 71: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 1873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 25912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 74: /* $@2: %empty  */
#line 1885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 25918 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 75: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 1887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 25928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 76: /* execute: EXECUTE_SYM ident execute_using  */
#line 1896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 25937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 77: /* $@3: %empty  */
#line 1901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 25943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 78: /* $@4: %empty  */
#line 1903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 25949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 79: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 1905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 25958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 80: /* execute_using: %empty  */
#line 1912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item_list)= NULL; }
#line 25964 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 81: /* $@5: %empty  */
#line 1914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 25970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 82: /* execute_using: USING $@5 execute_params  */
#line 1916 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 25979 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 83: /* execute_params: expr_or_ignore_or_default  */
#line 1924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 25988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 84: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 1929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 25997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 85: /* $@6: %empty  */
#line 1940 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 26006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 86: /* help: HELP_SYM $@6 ident_or_text  */
#line 1945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 26016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 87: /* $@7: %empty  */
#line 1956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 26024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 88: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 1960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 26030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 91: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 1970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 26038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 92: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 1974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 26046 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 93: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 1978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 26054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 94: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 1982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 26062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 95: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 1986 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 26070 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 96: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 1990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 26084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 97: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 26101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 26109 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 26117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 101: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 26125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 102: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 26133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 103: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 26150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 105: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 26158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 106: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 107: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 26198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 108: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 109: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 114: /* ignore_server_id: ulong_num  */
#line 2090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 118: /* do_domain_id: ulong_num  */
#line 2103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 122: /* ignore_domain_id: ulong_num  */
#line 2116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 26246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 124: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 26265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 26273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 126: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 26283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 26293 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 26303 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 129: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 26313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 130: /* optional_connection_name: %empty  */
#line 2173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 26322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 132: /* connection_name: TEXT_STRING_sys  */
#line 2182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 26334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 133: /* $@8: %empty  */
#line 2195 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 26350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 134: /* $@9: %empty  */
#line 2207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                  TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
          }
#line 26371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 135: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 136: /* $@10: %empty  */
#line 2230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
               add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                 TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 26415 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 137: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 138: /* $@11: %empty  */
#line 2285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 139: /* $@12: %empty  */
#line 2292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 140: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26472 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 141: /* $@13: %empty  */
#line 2304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 142: /* $@14: %empty  */
#line 2310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 143: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 144: /* $@15: %empty  */
#line 2322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 145: /* $@16: %empty  */
#line 2328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 146: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 147: /* $@17: %empty  */
#line 2340 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 26537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 148: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 26549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 149: /* $@18: %empty  */
#line 2354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 26562 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 150: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 151: /* $@19: %empty  */
#line 2368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 26582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 152: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 153: /* $@20: %empty  */
#line 2380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 154: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 155: /* $@21: %empty  */
#line 2390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 156: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail_standalone  */
#line 2395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 26625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 157: /* $@22: %empty  */
#line 2399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 158: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2405 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 159: /* $@23: %empty  */
#line 2410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 160: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@23 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 161: /* $@24: %empty  */
#line 2423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 162: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 163: /* $@25: %empty  */
#line 2437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 164: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@25 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 165: /* $@26: %empty  */
#line 2450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 166: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@26 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 167: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 26725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 168: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 26735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 169: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2478 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 26745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 170: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 26753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 171: /* create: CREATE TABLESPACE tablespace_info  */
#line 2488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 26761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 172: /* $@27: %empty  */
#line 2491 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 26767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 173: /* create: create_or_replace $@27 server_def  */
#line 2493 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 26773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 174: /* $@28: %empty  */
#line 2498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE,
                                                &sp_handler_package_spec,
                                                (yyvsp[-3].spname), (yyvsp[-7].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
          }
#line 26788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 175: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@28 opt_package_specification_element_list END remember_end_opt opt_sp_name  */
#line 2510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-8].spname), (yyvsp[0].spname), (yyvsp[-5].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 26797 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 176: /* $@29: %empty  */
#line 2518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE_BODY,
                                                &sp_handler_package_body,
                                                (yyvsp[-3].spname), (yyvsp[-8].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
            Lex->sp_block_init(thd);
          }
#line 26813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 177: /* $@30: %empty  */
#line 2530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 26822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 178: /* $@31: %empty  */
#line 2535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 26832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 179: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@29 package_implementation_declare_section $@30 package_implementation_executable_section $@31 remember_end_opt opt_sp_name  */
#line 2541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-10].spname), (yyvsp[0].spname), (yyvsp[-7].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 26841 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 180: /* package_implementation_executable_section: END  */
#line 2549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_add_empty(thd)))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init(0);
          }
#line 26851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 181: /* package_implementation_executable_section: BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 2554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                  { (yyval.spblock_handlers)= (yyvsp[-1].spblock_handlers); }
#line 26857 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 184: /* package_implementation_declare_section: package_implementation_declare_section_list1 package_implementation_declare_section_list2  */
#line 2566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 26863 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 186: /* package_implementation_declare_section_list1: package_implementation_declare_section_list1 package_implementation_item_declaration  */
#line 2573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 26869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 188: /* package_implementation_declare_section_list2: package_implementation_declare_section_list2 package_implementation_routine_definition  */
#line 2580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 26875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 189: /* package_routine_lex: %empty  */
#line 2584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex)= new (thd->mem_root)
                           sp_lex_local(thd, thd->lex))))
              MYSQL_YYABORT;
            thd->m_parser_state->m_yacc.reset_before_substatement();
          }
#line 26886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 190: /* $@32: %empty  */
#line 2595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_FUNCTION;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_function,
                                                        NOT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
            (void) is_native_function_with_warn(thd, &(yyvsp[0].ident_sys));
          }
#line 26905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 191: /* package_specification_function: remember_lex package_routine_lex ident $@32 opt_sp_parenthesized_fdparam_list RETURN_ORACLE_SYM sf_return_type sp_c_chistics  */
#line 2612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-7].lex);
            (yyval.lex)= (yyvsp[-6].lex);
          }
#line 26916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 192: /* $@33: %empty  */
#line 2622 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_PROCEDURE;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_procedure,
                                                        DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
          }
#line 26934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 193: /* package_specification_procedure: remember_lex package_routine_lex ident $@33 opt_sp_parenthesized_pdparam_list sp_c_chistics  */
#line 2637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-5].lex);
            (yyval.lex)= (yyvsp[-4].lex);

          }
#line 26946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 194: /* package_implementation_routine_definition: FUNCTION_SYM package_specification_function package_implementation_function_body ';'  */
#line 2650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 26958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 195: /* package_implementation_routine_definition: PROCEDURE_SYM package_specification_procedure package_implementation_procedure_body ';'  */
#line 2659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 26970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 196: /* package_implementation_routine_definition: package_specification_element  */
#line 2666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        { (yyval.spblock).init(); }
#line 26976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 197: /* $@34: %empty  */
#line 2672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 26988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 198: /* package_implementation_function_body: sp_tail_is remember_lex $@34 sp_body opt_package_routine_end_name  */
#line 2680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_function(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 26999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 199: /* $@35: %empty  */
#line 2690 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 27011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 200: /* package_implementation_procedure_body: sp_tail_is remember_lex $@35 sp_body opt_package_routine_end_name  */
#line 2698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_procedure(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 27022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 206: /* package_specification_element: FUNCTION_SYM package_specification_function ';'  */
#line 2723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 207: /* package_specification_element: PROCEDURE_SYM package_specification_procedure ';'  */
#line 2730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 208: /* opt_sequence: %empty  */
#line 2740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 27050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 212: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 213: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 214: /* sequence_def: NOMINVALUE_SYM  */
#line 2762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 215: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 2768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 216: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 2776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 217: /* sequence_def: NOMAXVALUE_SYM  */
#line 2782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 218: /* sequence_def: START_SYM opt_with longlong_num  */
#line 2788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 27123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 219: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 2796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 27135 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 220: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 2804 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27147 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 221: /* sequence_def: NOCACHE_SYM  */
#line 2812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 222: /* sequence_def: CYCLE_SYM  */
#line 2820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 223: /* sequence_def: NOCYCLE_SYM  */
#line 2828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 224: /* sequence_def: RESTART_SYM  */
#line 2836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 27199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 225: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 2848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 27216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 226: /* force_lookahead: %empty  */
#line 2863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 27222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 227: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 2863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      {}
#line 27228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 228: /* $@36: %empty  */
#line 2867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 27238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 229: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@36 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 2874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 27244 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 232: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 2884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 27253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 233: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 2889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 27262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 234: /* server_option: DATABASE TEXT_STRING_sys  */
#line 2894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 27271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 235: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 2899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 27280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 236: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 2904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 27289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 237: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 2909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 27298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 238: /* server_option: PORT_SYM ulong_num  */
#line 2914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 27306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 239: /* $@37: %empty  */
#line 2921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 27327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 240: /* event_tail: remember_name opt_if_not_exists sp_name $@37 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 2942 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 27339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 241: /* $@38: %empty  */
#line 2953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 27348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 243: /* ev_schedule_time: AT_SYM expr  */
#line 2960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 27356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 244: /* opt_ev_status: %empty  */
#line 2966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 245: /* opt_ev_status: ENABLE_SYM  */
#line 2968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27372 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 246: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 2974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 27382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 247: /* opt_ev_status: DISABLE_SYM  */
#line 2980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 248: /* ev_starts: %empty  */
#line 2989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 27403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 249: /* ev_starts: STARTS_SYM expr  */
#line 2996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 27411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 251: /* ev_ends: ENDS_SYM expr  */
#line 3004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 27419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 252: /* opt_ev_on_completion: %empty  */
#line 3010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 254: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 27436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 255: /* opt_ev_comment: %empty  */
#line 3025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 256: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 27451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 257: /* $@39: %empty  */
#line 3034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 27488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 258: /* ev_sql_stmt: $@39 sp_proc_stmt force_lookahead  */
#line 3067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 27498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 259: /* clear_privileges: %empty  */
#line 3076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 27512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 260: /* opt_aggregate: %empty  */
#line 3088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 27518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 261: /* opt_aggregate: AGGREGATE_SYM  */
#line 3089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 27524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 262: /* sp_name: ident '.' ident  */
#line 3094 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 263: /* sp_name: ident  */
#line 3099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27542 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 264: /* opt_sp_name: %empty  */
#line 3106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= NULL; }
#line 27548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 265: /* opt_sp_name: sp_name  */
#line 3107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= (yyvsp[0].spname); }
#line 27554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 266: /* sp_a_chistics: %empty  */
#line 3111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 267: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 27566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 268: /* sp_c_chistics: %empty  */
#line 3116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 269: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 27578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 270: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 271: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 27590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 272: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 27596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 273: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 27602 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 274: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 27608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 275: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 27614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 276: /* sp_chistic: sp_suid  */
#line 3135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 277: /* create_package_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27626 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 278: /* create_package_chistic: sp_suid  */
#line 3142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27632 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 279: /* create_package_chistics: create_package_chistic  */
#line 3146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 27638 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 280: /* create_package_chistics: create_package_chistics create_package_chistic  */
#line 3147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         { }
#line 27644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 282: /* opt_create_package_chistics: create_package_chistics  */
#line 3152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { }
#line 27650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 283: /* $@40: %empty  */
#line 3156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.init(); }
#line 27656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 285: /* sp_c_chistic: sp_chistic  */
#line 3162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { }
#line 27662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 286: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3163 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 27668 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 287: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 27674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 288: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 27680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 289: /* $@41: %empty  */
#line 3173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 290: /* call: CALL_SYM ident $@41 opt_sp_cparam_list  */
#line 3178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 291: /* $@42: %empty  */
#line 3183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 292: /* call: CALL_SYM ident '.' ident $@42 opt_sp_cparam_list  */
#line 3188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 293: /* $@43: %empty  */
#line 3193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 294: /* call: CALL_SYM ident '.' ident '.' ident $@43 opt_sp_cparam_list  */
#line 3198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 299: /* sp_cparams: sp_cparams ',' expr  */
#line 3217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 27742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 300: /* sp_cparams: expr  */
#line 3221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 27750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 301: /* sp_fdparam_list: %empty  */
#line 3229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 27759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 302: /* $@44: %empty  */
#line 3234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 27767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 303: /* sp_fdparam_list: $@44 sp_fdparams  */
#line 3238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 27775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 306: /* sp_param_name: ident  */
#line 3250 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 307: /* sp_param_name_and_type: sp_param_name sp_param_type  */
#line 3258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 27793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 308: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 309: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 310: /* sp_param_name_and_type: sp_param_name sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-3].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 311: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 312: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 27838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 317: /* sp_pdparam: sp_param_name sp_opt_inout sp_param_type  */
#line 3302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spvar)->mode= (yyvsp[-1].spvar_mode);
            if (unlikely(Lex->sp_param_fill_definition((yyvsp[-2].spvar))))
              MYSQL_YYABORT;
          }
#line 27848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 318: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 319: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-8].spvar)->mode= (yyvsp[-7].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-8].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 320: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spvar)->mode= (yyvsp[-3].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-4].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 321: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 322: /* sp_pdparam: sp_param_name sp_opt_inout ROW_SYM row_type_body  */
#line 3332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spvar)->mode= (yyvsp[-2].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyvsp[-3].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 27898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 323: /* sp_opt_inout: %empty  */
#line 3340 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 27904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 324: /* sp_opt_inout: IN_SYM  */
#line 3341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 27910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 325: /* sp_opt_inout: OUT_SYM  */
#line 3342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 27916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 326: /* sp_opt_inout: INOUT_SYM  */
#line 3343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 27922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 327: /* sp_opt_inout: IN_SYM OUT_SYM  */
#line 3344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 27928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 328: /* $@45: %empty  */
#line 3349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 27936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 329: /* sp_parenthesized_pdparam_list: '(' $@45 sp_pdparam_list ')'  */
#line 3354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 27944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 330: /* sp_no_param: %empty  */
#line 3361 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= Lex->sphead->m_param_end=
              YYLIP->get_cpp_tok_start() + 1;
          }
#line 27953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 335: /* sp_proc_stmts: %empty  */
#line 3378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 337: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 27965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 339: /* $@46: %empty  */
#line 3388 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 27973 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 340: /* sp_proc_stmts1_implicit_block: $@46 sp_proc_stmts1  */
#line 3392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 27982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 341: /* opt_sp_decl_body_list: %empty  */
#line 3400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).init();
          }
#line 27990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 342: /* opt_sp_decl_body_list: sp_decl_body_list  */
#line 3403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.spblock)= (yyvsp[0].spblock); }
#line 27996 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 343: /* $@47: %empty  */
#line 3408 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->sp_add_instr_cpush_for_cursors(thd, Lex->spcont)))
              MYSQL_YYABORT;
          }
#line 28005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 344: /* sp_decl_body_list: sp_decl_non_handler_list $@47 opt_sp_decl_handler_list  */
#line 3413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[0].spblock));
          }
#line 28013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 346: /* sp_decl_non_handler_list: sp_decl_non_handler ';'  */
#line 3420 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 347: /* sp_decl_non_handler_list: sp_decl_non_handler_list sp_decl_non_handler ';'  */
#line 3422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28027 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 348: /* sp_decl_handler_list: sp_decl_handler ';'  */
#line 3428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 349: /* sp_decl_handler_list: sp_decl_handler_list sp_decl_handler ';'  */
#line 3430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 350: /* opt_sp_decl_handler_list: %empty  */
#line 3436 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.spblock).init(); }
#line 28047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 352: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 353: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28067 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 354: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 355: /* row_field_name: ident_directly_assignable  */
#line 3463 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 357: /* row_field_definition_list: row_field_definition  */
#line 3475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 28095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 358: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 28104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 359: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 28110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 360: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 28118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 361: /* sp_decl_vars: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 28130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 362: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM TYPE_SYM sp_opt_default  */
#line 3511 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 363: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM sp_opt_default  */
#line 3519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 364: /* sp_decl_vars: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3527 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 28160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 366: /* sp_decl_non_handler: ident_directly_assignable CONDITION_SYM FOR_SYM sp_cond  */
#line 3537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 367: /* sp_decl_non_handler: ident_directly_assignable EXCEPTION_ORACLE_SYM  */
#line 3544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_condition_value *spcond= new (thd->mem_root)
                                        sp_condition_value_user_defined();
            if (unlikely(!spcond) ||
                unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-1].ident_sys), spcond)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28185 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 368: /* $@48: %empty  */
#line 3554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 28193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 369: /* sp_decl_non_handler: CURSOR_SYM ident_directly_assignable $@48 opt_parenthesized_cursor_formal_parameters IS sp_cursor_stmt  */
#line 3559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-4].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, false)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 28207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 370: /* $@49: %empty  */
#line 3572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 28216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 371: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@49 sp_hcond_list sp_proc_stmt  */
#line 3577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 28227 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 374: /* sp_cursor_stmt_lex: %empty  */
#line 3592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 28238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 375: /* $@50: %empty  */
#line 3602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 28249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 376: /* sp_cursor_stmt: sp_cursor_stmt_lex $@50 select  */
#line 3609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 28262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 377: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 28268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 378: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 28274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 379: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3622 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 28280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 380: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 28286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 381: /* sp_hcond_list: sp_hcond_element  */
#line 3629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 28292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 382: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)+= 1; }
#line 28298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 383: /* sp_hcond_element: sp_hcond  */
#line 3636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 28314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 384: /* sp_cond: ulong_num  */
#line 3651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 386: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 387: /* opt_value: %empty  */
#line 3682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 388: /* opt_value: VALUE_SYM  */
#line 3683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 389: /* sp_hcond: sp_cond  */
#line 3688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 28367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 390: /* sp_hcond: ident  */
#line 3692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 28377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 391: /* sp_hcond: SQLWARNING_SYM  */
#line 3698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 392: /* sp_hcond: not FOUND_SYM  */
#line 3704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 393: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 394: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 395: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 28426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 396: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 397: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 28444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 398: /* signal_value: ident  */
#line 3747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(!cond->has_sql_state()))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 28463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 399: /* signal_value: sqlstate  */
#line 3762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28469 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 400: /* opt_signal_value: %empty  */
#line 3767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= NULL; }
#line 28475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 401: /* opt_signal_value: signal_value  */
#line 3769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 402: /* opt_set_signal_information: %empty  */
#line 3774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 28489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 404: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 405: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 406: /* signal_allowed_expr: literal  */
#line 3807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 407: /* signal_allowed_expr: variable  */
#line 3809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 28543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 408: /* signal_allowed_expr: simple_ident  */
#line 3827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 409: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 28555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 410: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 28561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 411: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 28567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 412: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 28573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 413: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3841 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 28579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 414: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 28585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 415: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 28591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 416: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 28597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 417: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 28603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 418: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 28609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 419: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 28615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 420: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 28621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 421: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 422: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 28646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 423: /* which_area: %empty  */
#line 3883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 28652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 424: /* which_area: CURRENT_SYM  */
#line 3885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 28658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 425: /* diagnostics_information: statement_information  */
#line 3890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 28668 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 426: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 3896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 28678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 427: /* statement_information: statement_information_item  */
#line 3905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 28689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 428: /* statement_information: statement_information ',' statement_information_item  */
#line 3912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 28699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 429: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 3921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 28709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 430: /* simple_target_specification: ident_cli  */
#line 3930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 28718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 431: /* simple_target_specification: '@' ident_or_text  */
#line 3935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 28728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 432: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 3944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 28734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 433: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 3946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 28740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 434: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 3948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 28746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 435: /* condition_number: signal_allowed_expr  */
#line 3957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 436: /* condition_information: condition_information_item  */
#line 3962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 28763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 437: /* condition_information: condition_information ',' condition_information_item  */
#line 3969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 28773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 438: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 3978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 28783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 439: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 28789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 440: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 28795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 441: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 28801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 442: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 28807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 443: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 28813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 444: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 3997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 28819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 445: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 28825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 446: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4001 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 28831 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 447: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 28837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 448: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 28843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 449: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 28849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 450: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 28855 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 451: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 28861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 453: /* sp_decl_ident: keyword_sp_decl  */
#line 4017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 28870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 454: /* sp_decl_idents: sp_decl_ident  */
#line 4025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 28886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 455: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 28902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 456: /* sp_opt_default: %empty  */
#line 4051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = NULL; }
#line 28908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 457: /* sp_opt_default: DEFAULT expr  */
#line 4052 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 28914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 458: /* sp_opt_default: SET_VAR expr  */
#line 4053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 28920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 464: /* sp_proc_stmt: labels_declaration_oracle sp_labelable_stmt  */
#line 4062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 28926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 477: /* sp_labelable_stmt: NULL_SYM  */
#line 4078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 28932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 482: /* $@51: %empty  */
#line 4090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 28942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 483: /* sp_proc_stmt_if: IF_SYM $@51 sp_if END IF_SYM  */
#line 4096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 28948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 485: /* $@52: %empty  */
#line 4102 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // Direct procedure call (without the CALL keyword)
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 486: /* sp_statement: ident_directly_assignable $@52 opt_sp_cparam_list  */
#line 4108 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28967 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 487: /* $@53: %empty  */
#line 4113 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 488: /* sp_statement: ident_directly_assignable '.' ident $@53 opt_sp_cparam_list  */
#line 4118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28985 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 489: /* $@54: %empty  */
#line 4123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 490: /* sp_statement: ident_directly_assignable '.' ident '.' ident $@54 opt_sp_cparam_list  */
#line 4128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 491: /* $@55: %empty  */
#line 4135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only new LEX for the
              statement here as if it is start of parsing new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 29020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 492: /* sp_proc_stmt_statement: $@55 sp_statement  */
#line 4148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 495: /* $@56: %empty  */
#line 4163 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 496: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@56 expr  */
#line 4169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 497: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 29068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 498: /* $@57: %empty  */
#line 4191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 499: /* reset_lex_expr: $@57 expr  */
#line 4197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
            Lex->pop_select(); //main select
          }
#line 29087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 500: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 501: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 502: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29115 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 503: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 504: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 505: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 506: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 507: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 508: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 509: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29181 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 510: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 511: /* remember_lex: %empty  */
#line 4280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex)= thd->lex;
          }
#line 29198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 512: /* assignment_source_lex: %empty  */
#line 4286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29209 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 513: /* $@58: %empty  */
#line 4296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 514: /* assignment_source_expr: assignment_source_lex $@58 expr  */
#line 4303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //main select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29235 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 515: /* $@59: %empty  */
#line 4317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 29246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 516: /* for_loop_bound_expr: assignment_source_lex $@59 expr  */
#line 4324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 29261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 517: /* cursor_actual_parameters: assignment_source_expr  */
#line 4338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 518: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 519: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 29286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 520: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 29292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 521: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 29301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 522: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 523: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 524: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4375 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 525: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 29334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 526: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 29343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 527: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 528: /* sp_fetch_list: ident  */
#line 4410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 529: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 530: /* $@60: %empty  */
#line 4442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 531: /* $@61: %empty  */
#line 4448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 532: /* $@62: %empty  */
#line 4465 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 29447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 533: /* sp_if: $@60 expr THEN_SYM $@61 sp_proc_stmts1_implicit_block $@62 sp_elseifs  */
#line 4477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 29457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 537: /* $@63: %empty  */
#line 4492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 29511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 538: /* case_stmt_specification: CASE_SYM $@63 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 29529 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 539: /* $@64: %empty  */
#line 4561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 540: /* $@65: %empty  */
#line 4567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 541: /* case_stmt_body: $@64 expr $@65 simple_when_clause_list  */
#line 4576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 29558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 542: /* case_stmt_body: searched_when_clause_list  */
#line 4578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 29564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 547: /* $@66: %empty  */
#line 4593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 548: /* $@67: %empty  */
#line 4599 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 549: /* simple_when_clause: WHEN_SYM $@66 expr $@67 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 550: /* $@68: %empty  */
#line 4620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 551: /* $@69: %empty  */
#line 4626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 552: /* searched_when_clause: WHEN_SYM $@68 expr $@69 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29632 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 553: /* else_clause_opt: %empty  */
#line 4645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 555: /* sp_opt_label: %empty  */
#line 4659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 29653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 556: /* sp_opt_label: label_ident  */
#line 4660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 29659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 557: /* sp_block_label: labels_declaration_oracle  */
#line 4665 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 29669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 558: /* $@70: %empty  */
#line 4675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 559: /* sp_labeled_block: sp_block_label BEGIN_ORACLE_SYM $@70 sp_block_statements_and_exceptions END sp_opt_label  */
#line 4683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-2].spblock_handlers)), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 29688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 560: /* $@71: %empty  */
#line 4689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 29696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 561: /* $@72: %empty  */
#line 4693 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29705 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 562: /* sp_labeled_block: sp_block_label DECLARE_ORACLE_SYM $@71 opt_sp_decl_body_list $@72 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END sp_opt_label  */
#line 4701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].spblock).hndlrs+= (yyvsp[-2].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-5].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 29715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 565: /* $@73: %empty  */
#line 4715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 566: /* sp_unlabeled_block: BEGIN_ORACLE_SYM opt_not_atomic $@73 sp_block_statements_and_exceptions END  */
#line 4724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-1].spblock_handlers)))))
              MYSQL_YYABORT;
          }
#line 29736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 567: /* $@74: %empty  */
#line 4729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 29746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 568: /* $@75: %empty  */
#line 4735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 569: /* sp_unlabeled_block: DECLARE_ORACLE_SYM $@74 opt_sp_decl_body_list $@75 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 4742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spblock).hndlrs+= (yyvsp[-1].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-4].spblock))))
              MYSQL_YYABORT;
          }
#line 29765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 570: /* sp_instr_addr: %empty  */
#line 4750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.sp_instr_addr)= Lex->sphead->instructions(); }
#line 29771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 571: /* $@76: %empty  */
#line 4754 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 29779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 572: /* $@77: %empty  */
#line 4758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 573: /* $@78: %empty  */
#line 4764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock))))
              MYSQL_YYABORT;
          }
#line 29798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 575: /* $@79: %empty  */
#line 4775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_executable_section(thd, (yyvsp[-1].sp_instr_addr))))
              MYSQL_YYABORT;
          }
#line 29807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 576: /* sp_block_statements_and_exceptions: sp_instr_addr sp_proc_stmts $@79 opt_exception_clause  */
#line 4780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_exceptions(thd, (yyvsp[-3].sp_instr_addr), (yyvsp[0].num))))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init((yyvsp[0].num));
          }
#line 29817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 577: /* opt_exception_clause: %empty  */
#line 4788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= 0; }
#line 29823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 578: /* opt_exception_clause: EXCEPTION_ORACLE_SYM exception_handlers  */
#line 4789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= (yyvsp[0].num); }
#line 29829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 579: /* exception_handlers: exception_handler  */
#line 4793 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 1; }
#line 29835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 580: /* exception_handlers: exception_handlers exception_handler  */
#line 4794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= (yyvsp[-1].num) + 1; }
#line 29841 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 581: /* $@80: %empty  */
#line 4799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 29850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 582: /* exception_handler: WHEN_SYM $@80 sp_hcond_list THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4806 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 29859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 583: /* opt_sp_for_loop_direction: %empty  */
#line 4814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 29865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 584: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= -1; }
#line 29871 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 585: /* $@81: %empty  */
#line 4820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 586: /* sp_for_loop_index_and_bounds: ident_directly_assignable $@81 sp_for_loop_bounds  */
#line 4825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 29890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 587: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 29898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 588: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 29909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 589: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 29919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 590: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 591: /* $@82: %empty  */
#line 4869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 29949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 592: /* while_body: expr LOOP_SYM $@82 sp_proc_stmts1 END LOOP_SYM  */
#line 4880 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 29958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 593: /* $@83: %empty  */
#line 4888 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 594: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@83 expr END REPEAT_SYM  */
#line 4894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 29988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 595: /* pop_sp_loop_label: sp_opt_label  */
#line 4913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 29997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 596: /* $@84: %empty  */
#line 4921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 597: /* sp_labeled_control: labels_declaration_oracle LOOP_SYM $@84 loop_body pop_sp_loop_label  */
#line 4926 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 598: /* $@85: %empty  */
#line 4928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 599: /* sp_labeled_control: labels_declaration_oracle WHILE_SYM $@85 while_body pop_sp_loop_label  */
#line 4936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 600: /* $@86: %empty  */
#line 4938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 601: /* $@87: %empty  */
#line 4943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 602: /* $@88: %empty  */
#line 4952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 603: /* sp_labeled_control: labels_declaration_oracle FOR_SYM $@86 sp_for_loop_index_and_bounds $@87 LOOP_SYM sp_proc_stmts1 END LOOP_SYM $@88 pop_sp_loop_label  */
#line 4957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 30068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 604: /* $@89: %empty  */
#line 4962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 605: /* sp_labeled_control: labels_declaration_oracle REPEAT_SYM $@89 repeat_body pop_sp_loop_label  */
#line 4967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 606: /* $@90: %empty  */
#line 4972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 607: /* sp_unlabeled_control: LOOP_SYM $@90 loop_body  */
#line 4977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 608: /* $@91: %empty  */
#line 4981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 609: /* sp_unlabeled_control: WHILE_SYM $@91 while_body  */
#line 4989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 610: /* $@92: %empty  */
#line 4993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 611: /* $@93: %empty  */
#line 5000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 612: /* sp_unlabeled_control: FOR_SYM $@92 sp_for_loop_index_and_bounds $@93 LOOP_SYM sp_proc_stmts1 END LOOP_SYM  */
#line 5009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30154 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 613: /* $@94: %empty  */
#line 5017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 614: /* sp_unlabeled_control: REPEAT_SYM $@94 repeat_body  */
#line 5022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 615: /* trg_action_time: BEFORE_SYM  */
#line 5029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 30177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 616: /* trg_action_time: AFTER_SYM  */
#line 5031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 30183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 617: /* trg_event: INSERT  */
#line 5036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 30189 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 618: /* trg_event: UPDATE_SYM  */
#line 5038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 30195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 619: /* trg_event: DELETE_SYM  */
#line 5040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 30201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 623: /* opt_logfile_group_name: %empty  */
#line 5074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 624: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 30216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 625: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 30224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 626: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 30232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 631: /* $@95: %empty  */
#line 5115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 678: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 30247 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 679: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 680: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 681: /* tablespace_name: ident  */
#line 5233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 682: /* logfile_group_name: ident  */
#line 5246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30293 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 683: /* ts_access_mode: READ_ONLY_SYM  */
#line 5259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 30302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 684: /* ts_access_mode: READ_WRITE_SYM  */
#line 5264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 30311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 685: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 30320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 686: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 30329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 687: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 30338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 688: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 30347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 689: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 30356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 690: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 691: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 692: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 30385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 693: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 30396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 694: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 30408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 697: /* ts_wait: WAIT_SYM  */
#line 5361 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 30417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 698: /* ts_wait: NO_WAIT_SYM  */
#line 5366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 30428 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 699: /* size_number: real_ulonglong_num  */
#line 5375 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 30434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 700: /* size_number: IDENT_sys  */
#line 5377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 30443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 701: /* $@96: %empty  */
#line 5389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.option_list= NULL; }
#line 30449 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 702: /* create_body: create_field_list_parens $@96 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 703: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30461 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 704: /* create_body: create_like  */
#line 5393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 30476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 705: /* create_like: LIKE table_ident  */
#line 5406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 30482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 706: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 30488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 707: /* opt_create_select: %empty  */
#line 5411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 708: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 30503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 709: /* create_select_query_expression: query_expression  */
#line 5422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 30512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 710: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 30524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 711: /* opt_create_partitioning: opt_partitioning  */
#line 5438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 30538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 712: /* opt_partitioning: %empty  */
#line 5474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 714: /* $@97: %empty  */
#line 5480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 30559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 716: /* have_partitioning: %empty  */
#line 5495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 30575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 717: /* $@98: %empty  */
#line 5510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            DBUG_ASSERT(Lex->part_info->table);
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 30594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 718: /* partition_entry: PARTITION_SYM $@98 partition  */
#line 5525 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 30602 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 719: /* $@99: %empty  */
#line 5532 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->safe_to_cache_query= 1; }
#line 30608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 721: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5538 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 30619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 722: /* $@100: %empty  */
#line 5545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 30625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 723: /* part_type_def: opt_linear HASH_SYM $@100 part_func  */
#line 5546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 30631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 724: /* part_type_def: RANGE_SYM part_func  */
#line 5548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 725: /* part_type_def: RANGE_SYM part_column_list  */
#line 5550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 726: /* $@101: %empty  */
#line 5552 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 30651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 727: /* part_type_def: LIST_SYM $@101 part_func  */
#line 5556 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 30660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 728: /* part_type_def: LIST_SYM part_column_list  */
#line 5561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 30666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 729: /* $@102: %empty  */
#line 5563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 30675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 731: /* opt_linear: %empty  */
#line 5571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 732: /* opt_linear: LINEAR_SYM  */
#line 5573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 30687 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 733: /* opt_key_algo: %empty  */
#line 5578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 30693 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 734: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 30711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 735: /* part_field_list: %empty  */
#line 5596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 736: /* part_field_list: part_field_item_list  */
#line 5597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 30723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 737: /* part_field_item_list: part_field_item  */
#line 5601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 30729 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 738: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 30735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 739: /* part_field_item: ident  */
#line 5607 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 30750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 740: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 30760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 741: /* part_func: '(' part_func_expr ')'  */
#line 5631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 30772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 742: /* sub_part_func: '(' part_func_expr ')'  */
#line 5642 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 30781 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 743: /* opt_num_parts: %empty  */
#line 5650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 744: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 30801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 745: /* opt_sub_part: %empty  */
#line 5664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 746: /* $@103: %empty  */
#line 5666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 30813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 747: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@103 opt_num_subparts  */
#line 5667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 30819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 748: /* $@104: %empty  */
#line 5670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 30829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 749: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@104 opt_num_subparts  */
#line 5675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 30835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 750: /* sub_part_field_list: sub_part_field_item  */
#line 5679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 30841 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 751: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 30847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 752: /* sub_part_field_item: ident  */
#line 5685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 30862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 753: /* part_func_expr: bit_expr  */
#line 5699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 30875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 754: /* opt_num_subparts: %empty  */
#line 5710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 755: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5712 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 30894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 756: /* part_defs: %empty  */
#line 5724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 30908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 757: /* part_defs: '(' part_def_list ')'  */
#line 5734 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 30931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 758: /* part_def_list: part_definition  */
#line 5755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 30937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 759: /* part_def_list: part_def_list ',' part_definition  */
#line 5756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            {}
#line 30943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 760: /* $@105: %empty  */
#line 5761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 30963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 761: /* part_definition: PARTITION_SYM $@105 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 30969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 762: /* part_name: ident  */
#line 5785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 30981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 763: /* opt_part_values: %empty  */
#line 5796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 764: /* $@106: %empty  */
#line 5812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 765: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@106 part_func_max  */
#line 5824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 31024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 766: /* $@107: %empty  */
#line 5826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 767: /* opt_part_values: VALUES_IN_SYM $@107 part_values_in  */
#line 5838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 768: /* opt_part_values: CURRENT_SYM  */
#line 5840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 31056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 769: /* opt_part_values: HISTORY_SYM  */
#line 5845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 31065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 770: /* opt_part_values: DEFAULT  */
#line 5850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 31086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 771: /* part_func_max: MAXVALUE_SYM  */
#line 5870 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 772: /* part_func_max: part_value_item  */
#line 5887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 773: /* part_values_in: part_value_item  */
#line 5892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 31145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 774: /* part_values_in: '(' part_value_list ')'  */
#line 5919 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 775: /* part_value_list: part_value_item  */
#line 5930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 776: /* part_value_list: part_value_list ',' part_value_item  */
#line 5931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 777: /* $@108: %empty  */
#line 5936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 31184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 778: /* $@109: %empty  */
#line 5945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 779: /* part_value_item: '(' $@108 part_value_item_list $@109 ')'  */
#line 5947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 31215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 780: /* part_value_item_list: part_value_expr_item  */
#line 5970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 781: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                        {}
#line 31227 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 782: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5976 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 783: /* part_value_expr_item: bit_expr  */
#line 5987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 31260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 784: /* opt_sub_partition: %empty  */
#line 6005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 785: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 6019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31305 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 786: /* sub_part_list: sub_part_definition  */
#line 6044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 787: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6045 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                {}
#line 31317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 788: /* $@110: %empty  */
#line 6050 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 31354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 789: /* sub_part_definition: SUBPARTITION_SYM $@110 sub_name opt_part_options  */
#line 6082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 31360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 790: /* sub_name: ident_or_text  */
#line 6087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 31370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 791: /* opt_part_options: %empty  */
#line 6095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 792: /* opt_part_options: opt_part_option_list  */
#line 6096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 793: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6100 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 794: /* opt_part_option_list: opt_part_option  */
#line 6101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 795: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 31400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 796: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6108 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 31410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 797: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6114 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 31420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 798: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 31426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 799: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 800: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 801: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 31444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 802: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 31450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 803: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 31456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 804: /* opt_versioning_rotation: %empty  */
#line 6134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 805: /* $@111: %empty  */
#line 6135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 31468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 806: /* opt_versioning_rotation: $@111 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 31478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 807: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 31493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 808: /* opt_versioning_interval_start: %empty  */
#line 6158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 31501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 809: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 31515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 810: /* opt_as: %empty  */
#line 6178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 811: /* opt_as: AS  */
#line 6179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 31527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 812: /* opt_create_database_options: %empty  */
#line 6183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 813: /* opt_create_database_options: create_database_options  */
#line 6184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 31539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 814: /* create_database_options: create_database_option  */
#line 6188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 31545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 815: /* create_database_options: create_database_options create_database_option  */
#line 6189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         {}
#line 31551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 816: /* create_database_option: default_collation  */
#line 6193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 31557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 817: /* create_database_option: default_charset  */
#line 6194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 818: /* opt_if_not_exists_table_element: %empty  */
#line 6199 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 31571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 819: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6203 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 31579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 820: /* opt_if_not_exists: %empty  */
#line 6210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31587 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 821: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 31595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 822: /* create_or_replace: CREATE  */
#line 6221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 823: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 31611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 831: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 31630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 832: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 31639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 833: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 31648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 834: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 31657 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 835: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 31666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 836: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 31675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 837: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 31684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 838: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 31703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 839: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 31713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 840: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 31732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 841: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 31741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 842: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 31760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 843: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 31770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 844: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 31792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 845: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 31801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 846: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 31810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 847: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 31819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 848: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6388 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 31828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 849: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 31837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 850: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 31846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 851: /* $@112: %empty  */
#line 6403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 31854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 852: /* create_table_option: UNION_SYM opt_equal $@112 '(' opt_table_list ')'  */
#line 6407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 31880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 855: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 31889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 856: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6436 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 31898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 857: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 31907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 858: /* create_table_option: TABLESPACE ident  */
#line 6446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 31913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 859: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 31919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 860: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 31925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 861: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6452 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 31935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 862: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 31944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 863: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6463 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 31953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 864: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 31966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 865: /* create_table_option: IDENT_sys equal ident  */
#line 6477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 31979 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 866: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 31989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 867: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 31999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 868: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 872: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 873: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 874: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 875: /* storage_engines: ident_or_text  */
#line 6554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 32064 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 876: /* known_storage_engines: ident_or_text  */
#line 6564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 32076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 877: /* row_types: DEFAULT  */
#line 6574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 32082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 878: /* row_types: FIXED_SYM  */
#line 6575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 32088 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 879: /* row_types: DYNAMIC_SYM  */
#line 6576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 32094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 880: /* row_types: COMPRESSED_SYM  */
#line 6577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 32100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 881: /* row_types: REDUNDANT_SYM  */
#line 6578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 32106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 882: /* row_types: COMPACT_SYM  */
#line 6579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 32112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 883: /* row_types: PAGE_SYM  */
#line 6580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 32118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 884: /* merge_insert_types: NO_SYM  */
#line 6584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 32124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 885: /* merge_insert_types: FIRST_SYM  */
#line 6585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 32130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 886: /* merge_insert_types: LAST_SYM  */
#line 6586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 32136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 887: /* udf_type: STRING_SYM  */
#line 6590 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 32142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 888: /* udf_type: REAL  */
#line 6591 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 32148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 889: /* udf_type: DECIMAL_SYM  */
#line 6592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 32154 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 890: /* udf_type: INT_SYM  */
#line 6593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 32160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 891: /* create_field_list: field_list  */
#line 6599 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 892: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6606 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 895: /* field_list_item: column_def  */
#line 6617 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 32182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 899: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { }
#line 32188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 900: /* column_def: field_spec  */
#line 6626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 32194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 901: /* column_def: field_spec references  */
#line 6628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 32200 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 902: /* $@113: %empty  */
#line 6633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 903: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@113 '(' key_list ')' normal_key_options  */
#line 6638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 904: /* $@114: %empty  */
#line 6640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 905: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@114 '(' key_list ')' normal_key_options  */
#line 6645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 906: /* $@115: %empty  */
#line 6647 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 907: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@115 '(' key_list ')' fulltext_key_options  */
#line 6652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { }
#line 32248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 908: /* $@116: %empty  */
#line 6654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 909: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@116 '(' key_list ')' spatial_key_options  */
#line 6659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 32264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 910: /* $@117: %empty  */
#line 6663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 911: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@117 '(' key_list ')' normal_key_options  */
#line 6668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 912: /* $@118: %empty  */
#line 6671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 913: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@118 '(' key_list ')' normal_key_options  */
#line 6676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 914: /* $@119: %empty  */
#line 6678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 32310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 915: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@119 '(' key_list ')' references  */
#line 6688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 32340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 916: /* constraint_def: opt_constraint check_constraint  */
#line 6717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 32348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 917: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 32357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 918: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 32366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 919: /* opt_check_constraint: %empty  */
#line 6740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 32372 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 920: /* opt_check_constraint: check_constraint  */
#line 6741 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 32378 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 921: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6746 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 922: /* opt_constraint_no_id: %empty  */
#line 6755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32395 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 923: /* opt_constraint_no_id: CONSTRAINT  */
#line 6756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 924: /* opt_constraint: %empty  */
#line 6760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 32407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 925: /* opt_constraint: constraint  */
#line 6761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 32413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 926: /* constraint: CONSTRAINT opt_ident  */
#line 6765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 32419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 927: /* @120: %empty  */
#line 6770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 32439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 928: /* field_spec: field_ident @120 field_type_or_serial opt_check_constraint  */
#line 6786 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 32462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 929: /* $@121: %empty  */
#line 6807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 32468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 931: /* $@122: %empty  */
#line 6810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 933: /* opt_serial_attribute: %empty  */
#line 6820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 934: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 32491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 935: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                     {}
#line 32497 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 937: /* opt_asrow_attribute: %empty  */
#line 6830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 938: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 939: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 32515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 941: /* field_def: %empty  */
#line 6840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 32521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 945: /* $@123: %empty  */
#line 6845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 32530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 947: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 32539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 948: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 32548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 949: /* opt_generated_always: %empty  */
#line 6863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 950: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 951: /* vcol_opt_specifier: %empty  */
#line 6869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 952: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32576 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 953: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 954: /* vcol_opt_specifier: STORED_SYM  */
#line 6881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 955: /* vcol_opt_attribute: %empty  */
#line 6887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 956: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6888 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 32604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 957: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 {}
#line 32610 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 959: /* vcol_attribute: UNIQUE_SYM  */
#line 6898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 960: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 961: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 32636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 962: /* vcol_attribute: INVISIBLE_SYM  */
#line 6911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 32644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 963: /* $@124: %empty  */
#line 6918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 32659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 964: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@124 expr  */
#line 6929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 32671 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 966: /* parenthesized_expr: expr ',' expr_list  */
#line 6941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 32682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 967: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 968: /* virtual_column_func: subquery  */
#line 6959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 972: /* column_default_expr: expr_or_literal  */
#line 6975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 32717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 973: /* field_type: field_type_all  */
#line 6982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 32726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 974: /* qualified_field_type: field_type_all  */
#line 6990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 32734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 975: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 6994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 32743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 986: /* field_type_numeric: int_type opt_field_length field_options  */
#line 7019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 32749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 987: /* field_type_numeric: real_type opt_precision field_options  */
#line 7020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 32755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 988: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 7022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 32775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 989: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 32783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 990: /* field_type_numeric: BOOL_SYM  */
#line 7042 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 32791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 991: /* field_type_numeric: BOOLEAN_SYM  */
#line 7046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 32799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 992: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7050 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 993: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7052 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 32816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 994: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 995: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1000: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 32836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1001: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 32845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1002: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 32854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1003: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 32862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1004: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 32870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1005: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 32879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1006: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 32888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1007: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 32897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1008: /* sp_param_field_type_string: char opt_field_length_default_sp_param_char opt_binary  */
#line 7115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 32905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1009: /* sp_param_field_type_string: nchar opt_field_length_default_sp_param_char opt_bin_mod  */
#line 7119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 32914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1010: /* sp_param_field_type_string: BINARY opt_field_length_default_sp_param_char  */
#line 7124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 32923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1011: /* sp_param_field_type_string: varchar opt_field_length_default_sp_param_varchar opt_binary  */
#line 7129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 32931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1012: /* sp_param_field_type_string: VARCHAR2_ORACLE_SYM opt_field_length_default_sp_param_varchar opt_binary  */
#line 7133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 32939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1013: /* sp_param_field_type_string: nvarchar opt_field_length_default_sp_param_varchar opt_bin_mod  */
#line 7137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 32948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1014: /* sp_param_field_type_string: VARBINARY opt_field_length_default_sp_param_varchar  */
#line 7142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 32957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1015: /* sp_param_field_type_string: RAW_ORACLE_SYM opt_field_length_default_sp_param_varchar  */
#line 7147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 32966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1016: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 32988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1017: /* field_type_temporal: DATE_SYM  */
#line 7173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 32994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1018: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1019: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1020: /* field_type_temporal: DATETIME opt_field_length  */
#line 7189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1021: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1022: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33042 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1023: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33051 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1024: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33060 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1025: /* field_type_lob: spatial_type float_options srid_option  */
#line 7217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1026: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1027: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1028: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33102 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1029: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1030: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1031: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1032: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1033: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1034: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1035: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1036: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 33153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1037: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 33159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1038: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 33165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1039: /* spatial_type: GEOMETRY_SYM  */
#line 7271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 33171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1040: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 33177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1041: /* spatial_type: POINT_SYM  */
#line 7273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 33183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1042: /* spatial_type: MULTIPOINT  */
#line 7274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 33189 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1043: /* spatial_type: LINESTRING  */
#line 7275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 33195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1044: /* spatial_type: MULTILINESTRING  */
#line 7276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 33201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1045: /* spatial_type: POLYGON  */
#line 7277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 33207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1046: /* spatial_type: MULTIPOLYGON  */
#line 7278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 33213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1047: /* char: CHAR_SYM  */
#line 7282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 33219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1048: /* nchar: NCHAR_SYM  */
#line 7286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 33225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1049: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 33231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1050: /* varchar: char VARYING  */
#line 7291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1051: /* varchar: VARCHAR  */
#line 7292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1052: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 33249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1053: /* nvarchar: NVARCHAR_SYM  */
#line 7297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1054: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7298 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1055: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 33267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1056: /* nvarchar: NCHAR_SYM VARYING  */
#line 7300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1057: /* int_type: INT_SYM  */
#line 7304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 33279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1058: /* int_type: TINYINT  */
#line 7305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 33285 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1059: /* int_type: SMALLINT  */
#line 7306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 33291 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1060: /* int_type: MEDIUMINT  */
#line 7307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 33297 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1061: /* int_type: BIGINT  */
#line 7308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 33303 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1062: /* real_type: REAL  */
#line 7313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 33313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1063: /* real_type: DOUBLE_SYM  */
#line 7318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1064: /* real_type: DOUBLE_SYM PRECISION  */
#line 7319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33325 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1065: /* srid_option: %empty  */
#line 7324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->srid= 0; }
#line 33331 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1066: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7327 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 33339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1067: /* float_options: %empty  */
#line 7333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 33345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1068: /* float_options: field_length  */
#line 7334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 33351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1069: /* float_options: precision  */
#line 7335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1070: /* precision: '(' NUM ',' NUM ')'  */
#line 7339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 33363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1071: /* field_options: %empty  */
#line 7343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33369 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1072: /* field_options: SIGNED_SYM  */
#line 7344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 33375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1073: /* field_options: UNSIGNED  */
#line 7345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 33381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1074: /* field_options: ZEROFILL  */
#line 7346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1075: /* field_options: UNSIGNED ZEROFILL  */
#line 7347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33393 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1076: /* field_options: ZEROFILL UNSIGNED  */
#line 7348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33399 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1077: /* field_length: '(' LONG_NUM ')'  */
#line 7352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1078: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1079: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1080: /* field_length: '(' NUM ')'  */
#line 7355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33423 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1081: /* opt_field_length: %empty  */
#line 7359 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 33429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1082: /* opt_field_length: field_length  */
#line 7360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1083: /* opt_field_length_default_1: %empty  */
#line 7364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 33441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1084: /* opt_field_length_default_1: field_length  */
#line 7365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1085: /* opt_field_length_default_sp_param_varchar: %empty  */
#line 7386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("4000", "4000"); }
#line 33453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1086: /* opt_field_length_default_sp_param_varchar: field_length  */
#line 7387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1087: /* opt_field_length_default_sp_param_char: %empty  */
#line 7391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("2000", "2000"); }
#line 33465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1088: /* opt_field_length_default_sp_param_char: field_length  */
#line 7392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1089: /* opt_precision: %empty  */
#line 7396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 33477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1090: /* opt_precision: precision  */
#line 7397 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1091: /* attribute_list: attribute_list attribute  */
#line 7402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 33489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1093: /* attribute: NULL_SYM  */
#line 7407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 33495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1094: /* attribute: DEFAULT column_default_expr  */
#line 7408 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 33501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1095: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 33512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1096: /* attribute: AUTO_INC  */
#line 7416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 33518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1097: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1098: /* attribute: COLLATE_SYM collation_name  */
#line 7424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 33539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1100: /* opt_compression_method: %empty  */
#line 7434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 33545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1101: /* opt_compression_method: equal ident  */
#line 7435 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 33551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1102: /* opt_compressed: %empty  */
#line 7439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1103: /* opt_compressed: compressed  */
#line 7440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 33563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1104: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1105: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1106: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1107: /* asrow_attribute: not NULL_SYM  */
#line 7470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 33599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1108: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1111: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7485 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1112: /* serial_attribute: IDENT_sys equal ident  */
#line 7494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1113: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 33645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1114: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1115: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 33669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1116: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 33679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1117: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7534 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 33689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1118: /* sp_param_type: sp_param_field_type  */
#line 7544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1119: /* charset: CHAR_SYM SET  */
#line 7551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1120: /* charset: CHARSET  */
#line 7552 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1121: /* charset_name: ident_or_text  */
#line 7557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 33719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1122: /* charset_name: BINARY  */
#line 7561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 33725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1123: /* charset_name_or_default: charset_name  */
#line 7565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 33731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1124: /* charset_name_or_default: DEFAULT  */
#line 7566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1125: /* opt_load_data_charset: %empty  */
#line 7570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)= NULL; }
#line 33743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1126: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 33749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1127: /* old_or_new_charset_name: ident_or_text  */
#line 7576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 33760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1128: /* old_or_new_charset_name: BINARY  */
#line 7582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 33766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1129: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 33772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1130: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33778 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1131: /* collation_name: ident_or_text  */
#line 7592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 33787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1132: /* opt_collate: %empty  */
#line 7599 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)=NULL; }
#line 33793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1133: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7600 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 33799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1134: /* collation_name_or_default: collation_name  */
#line 7604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 33805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1135: /* collation_name_or_default: DEFAULT  */
#line 7605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1136: /* opt_default: %empty  */
#line 7609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1137: /* opt_default: DEFAULT  */
#line 7610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1138: /* charset_or_alias: charset charset_name  */
#line 7614 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 33829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1139: /* charset_or_alias: ASCII_SYM  */
#line 7615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 33835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1140: /* charset_or_alias: UNICODE_SYM  */
#line 7617 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 33844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1141: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 33850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1142: /* opt_binary: %empty  */
#line 7627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, false); }
#line 33856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1143: /* opt_binary: binary  */
#line 7628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 33862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1144: /* binary: BYTE_SYM  */
#line 7632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 33868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1145: /* binary: charset_or_alias opt_bin_mod  */
#line 7633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 33874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1146: /* binary: BINARY  */
#line 7634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, true); }
#line 33880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1147: /* binary: BINARY charset_or_alias  */
#line 7635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 33886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1148: /* binary: charset_or_alias collate  */
#line 7637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 33902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1149: /* binary: collate  */
#line 7648 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 33908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1150: /* opt_bin_mod: %empty  */
#line 7652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= false; }
#line 33914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1151: /* opt_bin_mod: BINARY  */
#line 7653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= true; }
#line 33920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1152: /* $@125: %empty  */
#line 7658 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 33932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1153: /* ws_nweights: '(' real_ulong_num $@125 ')'  */
#line 7666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 33938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1154: /* ws_level_flag_desc: ASC  */
#line 7670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.ulong_num)= 0; }
#line 33944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1155: /* ws_level_flag_desc: DESC  */
#line 7671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 33950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1156: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 33956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1157: /* ws_level_flags: %empty  */
#line 7678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 33962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1158: /* ws_level_flags: ws_level_flag_desc  */
#line 7679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 33968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1159: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 33974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1160: /* ws_level_flags: ws_level_flag_reverse  */
#line 7681 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 33980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1161: /* ws_level_number: real_ulong_num  */
#line 7686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 33989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1162: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 33997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1163: /* ws_level_list: ws_level_list_item  */
#line 7700 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1164: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1165: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1166: /* ws_level_list_or_range: ws_level_list  */
#line 7715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1167: /* ws_level_list_or_range: ws_level_range  */
#line 7716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1168: /* opt_ws_levels: %empty  */
#line 7720 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.ulong_num)= 0; }
#line 34038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1169: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1172: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34052 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1173: /* opt_ref_list: %empty  */
#line 7742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->ref_list.empty(); }
#line 34058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1175: /* ref_list: ref_list ',' ident  */
#line 7748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1176: /* ref_list: ident  */
#line 7755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1177: /* opt_match_clause: %empty  */
#line 7767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34088 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1178: /* opt_match_clause: MATCH FULL  */
#line 7769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1179: /* opt_match_clause: MATCH PARTIAL  */
#line 7771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1180: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1181: /* opt_on_update_delete: %empty  */
#line 7778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1182: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7784 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1183: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1184: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1185: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7804 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 34156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1186: /* delete_option: RESTRICT  */
#line 7812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 34162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1187: /* delete_option: CASCADE  */
#line 7813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 34168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1188: /* delete_option: SET NULL_SYM  */
#line 7814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 34174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1189: /* delete_option: NO_SYM ACTION  */
#line 7815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 34180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1190: /* delete_option: SET DEFAULT  */
#line 7816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 34186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1191: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 34192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1192: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 34198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1193: /* key_or_index: KEY_SYM  */
#line 7825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34204 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1194: /* key_or_index: INDEX_SYM  */
#line 7826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1195: /* opt_key_or_index: %empty  */
#line 7830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1197: /* keys_or_index: KEYS  */
#line 7835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 34222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1198: /* keys_or_index: INDEX_SYM  */
#line 7836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1199: /* keys_or_index: INDEXES  */
#line 7837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1200: /* opt_unique: %empty  */
#line 7841 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 34240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1201: /* opt_unique: UNIQUE_SYM  */
#line 7842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 34246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1202: /* fulltext: FULLTEXT_SYM  */
#line 7846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 34252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1203: /* spatial: SPATIAL_SYM  */
#line 7851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 34265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1204: /* normal_key_options: %empty  */
#line 7862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1205: /* normal_key_options: normal_key_opts  */
#line 7863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 34277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1206: /* fulltext_key_options: %empty  */
#line 7867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1207: /* fulltext_key_options: fulltext_key_opts  */
#line 7868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 34289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1208: /* spatial_key_options: %empty  */
#line 7872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1209: /* spatial_key_options: spatial_key_opts  */
#line 7873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 34301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1216: /* opt_USING_key_algorithm: %empty  */
#line 7892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1217: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1218: /* opt_key_algorithm_clause: %empty  */
#line 7898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1219: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34325 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1220: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7900 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34331 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1221: /* key_using_alg: USING btree_or_rtree  */
#line 7905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34337 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1222: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1223: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 34352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1224: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 34358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1225: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7919 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1226: /* all_key_opt: IDENT_sys equal ident  */
#line 7927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1227: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 34392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1228: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1233: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 34413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1234: /* btree_or_rtree: BTREE_SYM  */
#line 7969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 34419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1235: /* btree_or_rtree: RTREE_SYM  */
#line 7970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 34425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1236: /* btree_or_rtree: HASH_SYM  */
#line 7971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 34431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1237: /* key_list: key_list ',' key_part order_dir  */
#line 7976 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1238: /* key_list: key_part order_dir  */
#line 7980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1239: /* key_part: ident  */
#line 7987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1240: /* key_part: ident '(' NUM ')'  */
#line 7993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34470 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1241: /* opt_ident: %empty  */
#line 8004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 34476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1242: /* opt_ident: field_ident  */
#line 8005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 34482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1243: /* string_list: text_string  */
#line 8010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1244: /* string_list: string_list ',' text_string  */
#line 8012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1245: /* $@126: %empty  */
#line 8021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 34514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1246: /* $@127: %empty  */
#line 8037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                    TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 34529 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1247: /* alter: ALTER $@126 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@127 alter_commands  */
#line 8048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 34544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1248: /* $@128: %empty  */
#line 8059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 34555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1249: /* alter: ALTER DATABASE ident_or_empty $@128 create_database_options  */
#line 8066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 34569 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1250: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 8076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 34581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1251: /* $@129: %empty  */
#line 8084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1252: /* alter: ALTER PROCEDURE_SYM sp_name $@129 sp_a_chistics  */
#line 8094 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1253: /* $@130: %empty  */
#line 8104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1254: /* alter: ALTER FUNCTION_SYM sp_name $@130 sp_a_chistics  */
#line 8114 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1255: /* $@131: %empty  */
#line 8124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 34648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1256: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@131 view_list_opt AS view_select  */
#line 8131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1257: /* $@132: %empty  */
#line 8142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 34669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1258: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@132 view_list_opt AS view_select  */
#line 8149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1259: /* $@133: %empty  */
#line 8155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 34702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1260: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@133 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 34722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1261: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 34731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1262: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8199 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 34740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1263: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8204 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 34749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1264: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 34758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1265: /* $@134: %empty  */
#line 8214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 34768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1266: /* alter: ALTER SERVER_SYM ident_or_text $@134 OPTIONS_SYM '(' server_options_list ')'  */
#line 8218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    { }
#line 34774 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1267: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8222 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 34783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1268: /* $@135: %empty  */
#line 8227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->name= null_clex_str;
            lex->table_type= TABLE_TYPE_UNKNOWN;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            lex->create_info.init();
            lex->no_write_to_binlog= 0;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 34799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1269: /* $@136: %empty  */
#line 8239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 34813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1270: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@135 table_ident $@136 sequence_defs  */
#line 8249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1271: /* account_locking_option: LOCK_SYM  */
#line 8262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 34835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1272: /* account_locking_option: UNLOCK_SYM  */
#line 8266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 34843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1273: /* opt_password_expire_option: %empty  */
#line 8273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 34851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1274: /* opt_password_expire_option: NEVER_SYM  */
#line 8277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 34859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1275: /* opt_password_expire_option: DEFAULT  */
#line 8281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 34867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1276: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 34877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1282: /* ev_alter_on_schedule_completion: %empty  */
#line 8301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 34883 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1283: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.num)= 1; }
#line 34889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1284: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.num)= 1; }
#line 34895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1285: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                            { (yyval.num)= 1; }
#line 34901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1286: /* opt_ev_rename_to: %empty  */
#line 8308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 34907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1287: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 34920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1288: /* opt_ev_sql_stmt: %empty  */
#line 8321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= 0;}
#line 34926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1289: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 34932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1290: /* ident_or_empty: %empty  */
#line 8326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 34938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1293: /* alter_commands: DISCARD TABLESPACE  */
#line 8333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 34950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1294: /* alter_commands: IMPORT TABLESPACE  */
#line 8341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 34962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1300: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 34972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1301: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 34982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1302: /* $@137: %empty  */
#line 8377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 34997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1304: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1305: /* $@138: %empty  */
#line 8401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1307: /* $@139: %empty  */
#line 8413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1309: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35052 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1310: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8432 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1312: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1313: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8452 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1314: /* all_or_alt_part_name_list: ALL  */
#line 8459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1316: /* $@140: %empty  */
#line 8468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1317: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@140 add_part_extra  */
#line 8480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1319: /* add_part_extra: '(' part_def_list ')'  */
#line 8486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1320: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8491 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1321: /* $@141: %empty  */
#line 8498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1323: /* reorg_parts_rule: %empty  */
#line 8511 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35151 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1324: /* $@142: %empty  */
#line 8515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 35159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1325: /* reorg_parts_rule: alt_part_name_list $@142 INTO '(' part_def_list ')'  */
#line 8519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 35168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1326: /* alt_part_name_list: alt_part_name_item  */
#line 8526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {}
#line 35174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1327: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8527 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    {}
#line 35180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1328: /* alt_part_name_item: ident  */
#line 8532 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 35190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1332: /* alter_list_item: add_column column_def opt_place  */
#line 8554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1333: /* alter_list_item: ADD key_def  */
#line 8561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1334: /* alter_list_item: ADD period_for_system_time  */
#line 8566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 35218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1335: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 35228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1336: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1337: /* alter_list_item: ADD constraint_def  */
#line 8584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 35247 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1338: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8588 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 35256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1339: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8594 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1340: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1341: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 35292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1342: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1343: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 35321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1344: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1345: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1346: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1347: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1348: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 35381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1349: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 35391 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1350: /* alter_list_item: RENAME opt_to table_ident  */
#line 8686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 35409 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1351: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8700 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 35427 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1352: /* alter_list_item: create_table_options_space_separated  */
#line 8714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 35436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1353: /* alter_list_item: FORCE_SYM  */
#line 8719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 35444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1354: /* alter_list_item: alter_order_clause  */
#line 8723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 35453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1357: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 35462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1358: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 35471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1359: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 35479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1360: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1366: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 35500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1367: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1368: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 35518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1369: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8781 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1370: /* opt_column: %empty  */
#line 8788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1371: /* opt_column: COLUMN_SYM  */
#line 8789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 35539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1372: /* opt_ignore: %empty  */
#line 8793 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->ignore= 0;}
#line 35545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1373: /* opt_ignore: IGNORE_SYM  */
#line 8794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1374: /* $@143: %empty  */
#line 8798 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->ignore= 0;}
#line 35557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1380: /* alter_option: IGNORE_SYM  */
#line 8812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1381: /* alter_option: ONLINE_SYM  */
#line 8814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 35572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1382: /* opt_restrict: %empty  */
#line 8821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 35578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1383: /* opt_restrict: RESTRICT  */
#line 8822 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 35584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1384: /* opt_restrict: CASCADE  */
#line 8823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 35590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1385: /* opt_place: %empty  */
#line 8827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 35596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1386: /* opt_place: AFTER_SYM ident  */
#line 8829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35605 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1387: /* opt_place: FIRST_SYM  */
#line 8834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1388: /* opt_to: %empty  */
#line 8842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1389: /* opt_to: TO_SYM  */
#line 8843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 35627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1390: /* opt_to: '='  */
#line 8844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 35633 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1391: /* opt_to: AS  */
#line 8845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 35639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1392: /* $@144: %empty  */
#line 8850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 35650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1393: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@144 slave_until  */
#line 8857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1394: /* $@145: %empty  */
#line 8859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 35667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1395: /* slave: START_SYM ALL SLAVES slave_thread_opts $@145  */
#line 8865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1396: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 35684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1397: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 35695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1398: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 35712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1399: /* opt_start_transaction_option_list: %empty  */
#line 8900 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= 0;
          }
#line 35720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1400: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 35728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1401: /* start_transaction_option_list: start_transaction_option  */
#line 8911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 35736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1402: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 35744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1403: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 35752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1404: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8926 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 35760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1405: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 35768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1406: /* $@146: %empty  */
#line 8936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->slave_thd_opt= 0; }
#line 35774 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1407: /* slave_thread_opts: $@146 slave_thread_opt_list  */
#line 8938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35780 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1410: /* slave_thread_opt: %empty  */
#line 8947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 35786 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1411: /* slave_thread_opt: SQL_THREAD  */
#line 8948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 35792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1412: /* slave_thread_opt: RELAY_THREAD  */
#line 8949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 35798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1413: /* slave_until: %empty  */
#line 8953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 35804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1414: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 35817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1415: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 35825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1418: /* $@147: %empty  */
#line 8976 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 35836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1419: /* checksum: CHECKSUM_SYM table_or_tables $@147 table_list opt_checksum_type  */
#line 8983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1420: /* opt_checksum_type: %empty  */
#line 8987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= 0; }
#line 35848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1421: /* opt_checksum_type: QUICK  */
#line 8988 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 35854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1422: /* opt_checksum_type: EXTENDED_SYM  */
#line 8989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 35860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1424: /* $@148: %empty  */
#line 8995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 35866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1426: /* $@149: %empty  */
#line 9001 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 35880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1427: /* repair: REPAIR opt_no_write_to_binlog $@149 repair_table_or_view  */
#line 9011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35892 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1428: /* opt_mi_repair_type: %empty  */
#line 9021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 35898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1429: /* opt_mi_repair_type: mi_repair_types  */
#line 9022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 35904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1430: /* mi_repair_types: mi_repair_type  */
#line 9026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 35910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1431: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 9027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 35916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1432: /* mi_repair_type: QUICK  */
#line 9031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 35922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1433: /* mi_repair_type: EXTENDED_SYM  */
#line 9032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 35928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1434: /* mi_repair_type: USE_FRM  */
#line 9033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 35934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1435: /* opt_view_repair_type: %empty  */
#line 9037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 35940 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1436: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 9038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 35946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1437: /* $@150: %empty  */
#line 9043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 35960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1438: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@150 analyze_table_list  */
#line 9053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1442: /* opt_persistent_stat_clause: %empty  */
#line 9073 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35978 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1443: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 9075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 35986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1444: /* persistent_stat_spec: ALL  */
#line 9082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1445: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 9084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1446: /* persistent_column_stat_spec: ALL  */
#line 9088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1447: /* $@151: %empty  */
#line 9090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1448: /* persistent_column_stat_spec: '(' $@151 table_column_list ')'  */
#line 9098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1449: /* persistent_index_stat_spec: ALL  */
#line 9102 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36027 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1450: /* $@152: %empty  */
#line 9104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1451: /* persistent_index_stat_spec: '(' $@152 table_index_list ')'  */
#line 9112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1452: /* table_column_list: %empty  */
#line 9117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1453: /* table_column_list: ident  */
#line 9119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1454: /* table_column_list: table_column_list ',' ident  */
#line 9124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1455: /* table_index_list: %empty  */
#line 9132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1458: /* table_index_name: ident  */
#line 9139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1459: /* table_index_name: PRIMARY_SYM  */
#line 9146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1460: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1461: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1463: /* $@153: %empty  */
#line 9174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1465: /* $@154: %empty  */
#line 9179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1466: /* check: CHECK_SYM $@154 check_view_or_table  */
#line 9189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1467: /* opt_mi_check_type: %empty  */
#line 9201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1468: /* opt_mi_check_type: mi_check_types  */
#line 9202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 36162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1469: /* mi_check_types: mi_check_type  */
#line 9206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 36168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1470: /* mi_check_types: mi_check_type mi_check_types  */
#line 9207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       {}
#line 36174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1471: /* mi_check_type: QUICK  */
#line 9211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 36180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1472: /* mi_check_type: FAST_SYM  */
#line 9212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 36186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1473: /* mi_check_type: MEDIUM_SYM  */
#line 9213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 36192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1474: /* mi_check_type: EXTENDED_SYM  */
#line 9214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 36198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1475: /* mi_check_type: CHANGED  */
#line 9215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 36204 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1476: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1477: /* opt_view_check_type: %empty  */
#line 9220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 36216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1478: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1479: /* $@155: %empty  */
#line 9226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1480: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@155 table_list opt_lock_wait_timeout  */
#line 9236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1481: /* opt_no_write_to_binlog: %empty  */
#line 9246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 36254 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1482: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 36260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1483: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 1; }
#line 36266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1484: /* $@156: %empty  */
#line 9253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1485: /* rename: RENAME table_or_tables $@156 table_to_table_list  */
#line 9259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1486: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 36292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1487: /* rename_list: user TO_SYM user  */
#line 9270 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1488: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1491: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 36328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1492: /* $@157: %empty  */
#line 9305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.reset();
          }
#line 36336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1493: /* keycache: CACHE_SYM INDEX_SYM $@157 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 36346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1498: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1499: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1500: /* key_cache_name: ident  */
#line 9349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 36376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1501: /* key_cache_name: DEFAULT  */
#line 9350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 36382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1502: /* $@158: %empty  */
#line 9355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1503: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@158 preload_list_or_parts  */
#line 9363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1508: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36414 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1509: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1510: /* $@159: %empty  */
#line 9402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 36434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1512: /* $@160: %empty  */
#line 9409 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Lex->first_select_lex()->set_index_hint_type(INDEX_HINT_USE,
                                                         INDEX_HINT_MASK_ALL);
          }
#line 36444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1514: /* cache_key_list_or_empty: %empty  */
#line 9418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 36450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1516: /* opt_ignore_leaves: %empty  */
#line 9424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 36456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1517: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 36462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1518: /* $@161: %empty  */
#line 9434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1519: /* select: query_expression_no_with_clause $@161 opt_procedure_or_into  */
#line 9441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1520: /* $@162: %empty  */
#line 9448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1521: /* select: with_clause query_expression_no_with_clause $@162 opt_procedure_or_into  */
#line 9455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1522: /* $@163: %empty  */
#line 9467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1523: /* select_into: select_into_query_specification $@163 opt_order_limit_lock  */
#line 9472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
           }
#line 36530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1524: /* $@164: %empty  */
#line 9483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1525: /* select_into: with_clause select_into_query_specification $@164 opt_order_limit_lock  */
#line 9488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 36555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1526: /* simple_table: query_specification  */
#line 9503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1527: /* simple_table: table_value_constructor  */
#line 9504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1528: /* $@165: %empty  */
#line 9509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 36576 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1529: /* table_value_constructor: VALUES $@165 values_list  */
#line 9514 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 36585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1530: /* $@166: %empty  */
#line 9522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 36599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1531: /* $@167: %empty  */
#line 9532 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 36607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1532: /* query_specification_start: SELECT_SYM $@166 select_options $@167 select_item_list  */
#line 9536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 36615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1533: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1534: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1535: /* query_expression: query_expression_no_with_clause  */
#line 9619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 36640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1536: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9625 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 36650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1537: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 36656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1538: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9639 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 36662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1539: /* $@168: %empty  */
#line 9654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 36674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1540: /* query_expression_body_ext: query_expression_body $@168 opt_query_expression_tail  */
#line 9662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 36685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1541: /* $@169: %empty  */
#line 9669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 36694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1542: /* query_expression_body_ext: query_expression_body_ext_parens $@169 query_expression_tail  */
#line 9674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 36703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1543: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 36709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1544: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 36720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1545: /* query_expression_body: query_simple  */
#line 9699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 36730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1546: /* $@170: %empty  */
#line 9706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 36741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1547: /* query_expression_body: query_expression_body unit_type_decl $@170 query_primary  */
#line 9713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                TRUE)))
              MYSQL_YYABORT;
          }
#line 36753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1548: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 36765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1549: /* query_primary: query_simple  */
#line 9739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1550: /* query_primary: query_expression_body_ext_parens  */
#line 9741 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 36777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1551: /* query_simple: simple_table  */
#line 9750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 36783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1552: /* subselect: query_expression  */
#line 9755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 36792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1553: /* subquery: query_expression_body_ext_parens  */
#line 9796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 36805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1554: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              YYABORT;
          }
#line 36816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1558: /* table_reference_list: join_table_list  */
#line 9824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 36826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1561: /* select_options: select_option_list  */
#line 9839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 36836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1562: /* opt_history_unit: %empty  */
#line 9848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 36844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1563: /* opt_history_unit: TRANSACTION_SYM  */
#line 9852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 36852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1564: /* opt_history_unit: TIMESTAMP  */
#line 9856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 36860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1565: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime2.create_literal_item(thd,
                                                      (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                      YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 36873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1566: /* history_point: function_call_keyword_timestamp  */
#line 9872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 36881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1567: /* history_point: opt_history_unit bit_expr  */
#line 9876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 36889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1568: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 36905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1569: /* opt_for_portion_of_time_clause: %empty  */
#line 9899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 36913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1570: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
            (yyval.num)= true;
          }
#line 36921 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1571: /* opt_for_system_time_clause: %empty  */
#line 9910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 36929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1572: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= true;
          }
#line 36937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1573: /* system_time_expr: AS OF_SYM history_point  */
#line 9921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 36945 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1574: /* system_time_expr: ALL  */
#line 9925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 36953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1575: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 36961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1576: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 36969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1580: /* select_option: SQL_NO_CACHE_SYM  */
#line 9946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 36982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1581: /* select_option: SQL_CACHE_SYM  */
#line 9955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 36995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1582: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1583: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1584: /* opt_select_lock_type: %empty  */
#line 9983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1585: /* opt_select_lock_type: select_lock_type  */
#line 9987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1586: /* opt_lock_wait_timeout_new: %empty  */
#line 9994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1587: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 9998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37048 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1588: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 10003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1591: /* select_item_list: '*'  */
#line 10013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1592: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 10027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37081 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1593: /* select_item: remember_name expr remember_end select_alias  */
#line 10032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1594: /* remember_tok_start: %empty  */
#line 10053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1595: /* remember_name: %empty  */
#line 10059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1596: /* remember_end: %empty  */
#line 10065 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1597: /* remember_end_opt: %empty  */
#line 10071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (yychar == YYEMPTY)
              (yyval.simple_string)= (char*) YYLIP->get_cpp_ptr_rtrim();
            else
              (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1598: /* select_alias: %empty  */
#line 10080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1599: /* select_alias: AS ident  */
#line 10081 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37151 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1600: /* select_alias: AS TEXT_STRING_sys  */
#line 10082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37157 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1601: /* select_alias: ident  */
#line 10083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1602: /* select_alias: TEXT_STRING_sys  */
#line 10084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1603: /* opt_default_time_precision: %empty  */
#line 10088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1604: /* opt_default_time_precision: '(' ')'  */
#line 10089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37181 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1605: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 10090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1606: /* opt_time_precision: %empty  */
#line 10094 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1607: /* opt_time_precision: '(' ')'  */
#line 10095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1608: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 10096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1609: /* optional_braces: %empty  */
#line 10100 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 37211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1610: /* optional_braces: '(' ')'  */
#line 10101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 37217 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1611: /* expr: expr or expr  */
#line 10107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1612: /* expr: expr XOR expr  */
#line 10158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1613: /* expr: expr and expr  */
#line 10165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1614: /* expr: NOT_SYM expr  */
#line 10208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1616: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1617: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1618: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1619: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1620: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37390 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1621: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1622: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10254 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1623: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1624: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1625: /* boolean_test: boolean_test comp_op predicate  */
#line 10272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1626: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1628: /* predicate: predicate IN_SYM subquery  */
#line 10288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1629: /* predicate: predicate not IN_SYM subquery  */
#line 10294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1630: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1631: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1632: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1633: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1634: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1635: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1636: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1637: /* predicate: predicate LIKE predicate  */
#line 10356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1638: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1639: /* predicate: predicate not LIKE predicate  */
#line 10369 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1640: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1641: /* predicate: predicate REGEXP predicate  */
#line 10384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1642: /* predicate: predicate not REGEXP predicate  */
#line 10390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1644: /* bit_expr: bit_expr '|' bit_expr  */
#line 10403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1645: /* bit_expr: bit_expr '&' bit_expr  */
#line 10409 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37641 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1646: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1647: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1648: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1649: /* bit_expr: bit_expr '+' bit_expr  */
#line 10434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1650: /* bit_expr: bit_expr '-' bit_expr  */
#line 10440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1651: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1652: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10452 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1653: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1654: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10465 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1655: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1656: /* bit_expr: bit_expr '*' bit_expr  */
#line 10477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1657: /* bit_expr: bit_expr '/' bit_expr  */
#line 10483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1658: /* bit_expr: bit_expr '%' bit_expr  */
#line 10489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1659: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1660: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1661: /* bit_expr: bit_expr '^' bit_expr  */
#line 10507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1671: /* comp_op: '='  */
#line 10536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 37808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1672: /* comp_op: GE  */
#line 10537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 37814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1673: /* comp_op: '>'  */
#line 10538 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 37820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1674: /* comp_op: LE  */
#line 10539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 37826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1675: /* comp_op: '<'  */
#line 10540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 37832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1676: /* comp_op: NE  */
#line 10541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 37838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1677: /* all_or_any: ALL  */
#line 10545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 1; }
#line 37844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1678: /* all_or_any: ANY_SYM  */
#line 10546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 0; }
#line 37850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1679: /* opt_dyncol_type: %empty  */
#line 10551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 37859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1680: /* opt_dyncol_type: AS dyncol_type  */
#line 10555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 37865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1681: /* dyncol_type: numeric_dyncol_type  */
#line 10559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 37871 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1682: /* dyncol_type: temporal_dyncol_type  */
#line 10560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 37877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1683: /* dyncol_type: string_dyncol_type  */
#line 10561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 37883 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1684: /* numeric_dyncol_type: INT_SYM  */
#line 10565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 37889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1685: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 37895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1686: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 37901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1687: /* numeric_dyncol_type: REAL  */
#line 10568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 37907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1688: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 37913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1689: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 37919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1690: /* temporal_dyncol_type: DATE_SYM  */
#line 10574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 37925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1691: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 37931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1692: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 37937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1693: /* $@171: %empty  */
#line 10581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 37943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1694: /* string_dyncol_type: char $@171 opt_binary  */
#line 10583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 37951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1695: /* string_dyncol_type: nchar  */
#line 10587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 37960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1696: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 37984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1697: /* dyncall_create_list: dyncall_create_element  */
#line 10618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 37995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1698: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10625 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1699: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1700: /* plsql_cursor_attr: FOUND_SYM  */
#line 10634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1701: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1702: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1703: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1704: /* trim_operands: expr  */
#line 10649 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1705: /* trim_operands: LEADING expr FROM expr  */
#line 10650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1706: /* trim_operands: TRAILING expr FROM expr  */
#line 10651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38055 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1707: /* trim_operands: BOTH expr FROM expr  */
#line 10652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1708: /* trim_operands: LEADING FROM expr  */
#line 10653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38067 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1709: /* trim_operands: TRAILING FROM expr  */
#line 10654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1710: /* trim_operands: BOTH FROM expr  */
#line 10655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1711: /* trim_operands: expr FROM expr  */
#line 10656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1718: /* column_default_non_parenthesized_expr: param_marker  */
#line 10694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1720: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1721: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10705 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38115 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1723: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1724: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1725: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1726: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1727: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1728: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1729: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10752 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1730: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1731: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1732: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 38221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1733: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1734: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1735: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38250 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1736: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1737: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10802 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1738: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 38277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1739: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1740: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10817 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1743: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 38301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1744: /* primary_expr: subquery  */
#line 10828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 38310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1746: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 38319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1748: /* simple_expr: BINARY simple_expr  */
#line 10846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 38329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1749: /* simple_expr: '+' simple_expr  */
#line 10852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38337 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1750: /* simple_expr: '-' simple_expr  */
#line 10856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1751: /* simple_expr: '~' simple_expr  */
#line 10862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1752: /* simple_expr: not2 simple_expr  */
#line 10868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1754: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10878 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1755: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1756: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1757: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1758: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1759: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1760: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1761: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1762: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1763: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1764: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1765: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1766: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1767: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 10988 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1768: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 10994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1769: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 11000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1770: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 11006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1771: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 11012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1772: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 11018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1773: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 11026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1774: /* function_call_keyword: function_call_keyword_timestamp  */
#line 11033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1775: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 11037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 38609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1776: /* function_call_keyword: USER_SYM '(' ')'  */
#line 11043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 38621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1777: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 11051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1778: /* substring_operands: expr ',' expr ',' expr  */
#line 11060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1779: /* substring_operands: expr ',' expr  */
#line 11064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1780: /* substring_operands: expr FROM expr FOR_SYM expr  */
#line 11068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1781: /* substring_operands: expr FROM expr  */
#line 11072 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1782: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 11092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1783: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1784: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 11105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1785: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 11112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1786: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1787: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1788: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1789: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1790: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38756 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1791: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1792: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1793: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1794: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1795: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1796: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 38818 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1797: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1798: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1799: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1800: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 38869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1801: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11222 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1802: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1803: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1804: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11244 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1805: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1806: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1807: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1808: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1809: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1810: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1811: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38985 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1812: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1813: /* function_call_conflict: DATABASE '(' ')'  */
#line 11313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1814: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1815: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1816: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1817: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39051 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1818: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1819: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11359 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1820: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1821: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1822: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1823: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39115 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1824: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1825: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39135 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1826: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11404 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1827: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39157 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1828: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1829: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1830: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1831: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11436 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1832: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39209 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1833: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1834: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1835: /* function_call_conflict: geometry_function  */
#line 11469 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 39252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1836: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 39262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1837: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 39273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1838: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 39284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1839: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 39295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1840: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11511 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 39306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1841: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 39317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1842: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11525 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 39325 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1843: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11529 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 39336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1844: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 39345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1845: /* @172: %empty  */
#line 11553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 39368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1846: /* function_call_generic: IDENT_sys '(' @172 opt_udf_expr_list ')'  */
#line 11572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= native_functions_hash.find(thd, (yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 39421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1847: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1848: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1849: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 39445 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1850: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= FT_BOOL; }
#line 39451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1851: /* opt_natural_language_mode: %empty  */
#line 11640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1852: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1853: /* opt_query_expansion: %empty  */
#line 11645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 0;         }
#line 39469 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1854: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 39475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1855: /* opt_udf_expr_list: %empty  */
#line 11650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= NULL; }
#line 39481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1856: /* opt_udf_expr_list: udf_expr_list  */
#line 11651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 39487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1857: /* udf_expr_list: udf_expr  */
#line 11656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 39498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1858: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 39507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1859: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 39535 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1860: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1861: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1862: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1863: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1864: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1865: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1866: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1867: /* $@173: %empty  */
#line 11743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 39614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1868: /* $@174: %empty  */
#line 11745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr--; }
#line 39620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1869: /* sum_expr: COUNT_SYM '(' DISTINCT $@173 expr_list $@174 ')'  */
#line 11747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1870: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1871: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1872: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1873: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1874: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1875: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1876: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39700 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1877: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1878: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11806 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1879: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1880: /* $@175: %empty  */
#line 11818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 39736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1881: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@175 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11822 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 39758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1882: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 39770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1883: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 39789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1886: /* window_func: function_call_generic  */
#line 11874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 39805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1887: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1888: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1889: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1890: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1891: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39855 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1892: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1893: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1894: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1895: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1896: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 11952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1897: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 11963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1898: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 11970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39933 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1899: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 11981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1900: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 11993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 39962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1901: /* $@176: %empty  */
#line 12011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           { Select->prepare_add_window_spec(thd); }
#line 39968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1902: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@176 order_by_single_element_list ')'  */
#line 12013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 39976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1903: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 12017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1904: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 12034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1905: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 12040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1906: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 12049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1907: /* window_name: ident  */
#line 12058 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1908: /* $@177: %empty  */
#line 12067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40042 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1909: /* variable: '@' $@177 variable_aux  */
#line 12072 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1910: /* variable_aux: ident_or_text SET_VAR expr  */
#line 12079 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40064 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1911: /* variable_aux: ident_or_text  */
#line 12089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1912: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 12097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1913: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 12102 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1914: /* opt_distinct: %empty  */
#line 12109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1915: /* opt_distinct: DISTINCT  */
#line 12110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 1; }
#line 40106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1916: /* opt_gconcat_separator: %empty  */
#line 12115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1917: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1920: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1921: /* gorder_list: order_ident order_dir  */
#line 12135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1922: /* opt_glimit_clause: %empty  */
#line 12142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1923: /* opt_glimit_clause: glimit_clause  */
#line 12143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num) = 1; }
#line 40152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1924: /* glimit_clause_init: LIMIT  */
#line 12147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 40158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1925: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40166 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1926: /* glimit_options: limit_option  */
#line 12159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 40177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1927: /* glimit_options: limit_option ',' limit_option  */
#line 12166 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 40188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1928: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 40199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1929: /* $@178: %empty  */
#line 12185 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40212 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1930: /* in_sum_expr: opt_all $@178 expr  */
#line 12194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 40221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1931: /* cast_type: BINARY opt_field_length  */
#line 12202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 40227 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1932: /* $@179: %empty  */
#line 12204 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1933: /* cast_type: CHAR_SYM opt_field_length $@179 opt_binary  */
#line 12206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1934: /* $@180: %empty  */
#line 12208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40245 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1935: /* cast_type: VARCHAR field_length $@180 opt_binary  */
#line 12210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1936: /* $@181: %empty  */
#line 12212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1937: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@181 opt_binary  */
#line 12214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40263 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1938: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 40272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1939: /* cast_type: cast_type_numeric  */
#line 12220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1940: /* cast_type: cast_type_temporal  */
#line 12221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1941: /* cast_type_numeric: INT_SYM  */
#line 12225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1942: /* cast_type_numeric: SIGNED_SYM  */
#line 12226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1943: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1944: /* cast_type_numeric: UNSIGNED  */
#line 12228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1945: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1946: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 40320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1947: /* cast_type_numeric: FLOAT_SYM  */
#line 12231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 40326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1948: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 40332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1949: /* cast_type_temporal: DATE_SYM  */
#line 12236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 40338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1950: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 40344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1951: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 40350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1952: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 40358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1953: /* opt_expr_list: %empty  */
#line 12246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item_list)= NULL; }
#line 40364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1954: /* opt_expr_list: expr_list  */
#line 12247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 40370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1955: /* expr_list: expr  */
#line 12252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 40379 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1956: /* expr_list: expr_list ',' expr  */
#line 12257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1957: /* ident_list_arg: ident_list  */
#line 12264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1958: /* ident_list_arg: '(' ident_list ')'  */
#line 12265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 40400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1959: /* ident_list: simple_ident  */
#line 12270 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1960: /* ident_list: ident_list ',' simple_ident  */
#line 12277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1961: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1962: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 40444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1964: /* when_list_opt_else: when_list ELSE expr  */
#line 12305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1965: /* table_ref: table_factor  */
#line 12315 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1966: /* table_ref: join_table  */
#line 12317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1967: /* join_table_list: derived_table_list  */
#line 12328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 40479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1968: /* esc_table_ref: table_ref  */
#line 12339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 40485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1969: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12340 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 40491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1970: /* derived_table_list: esc_table_ref  */
#line 12347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1971: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1972: /* join_table: table_ref normal_join table_ref  */
#line 12366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 40519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1973: /* $@182: %empty  */
#line 12373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1974: /* join_table: table_ref normal_join table_ref ON $@182 expr  */
#line 12383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 40544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1975: /* $@183: %empty  */
#line 12391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 40554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1976: /* join_table: table_ref normal_join table_ref USING $@183 '(' using_list ')'  */
#line 12397 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 40564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1977: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 40576 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1978: /* $@184: %empty  */
#line 12414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1979: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@184 expr  */
#line 12424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 40602 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1980: /* $@185: %empty  */
#line 12432 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40612 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1981: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@185 USING '(' using_list ')'  */
#line 12438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 40622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1982: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 40635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1983: /* $@186: %empty  */
#line 12456 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1984: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@186 expr  */
#line 12466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 40662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1985: /* $@187: %empty  */
#line 12475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1986: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@187 USING '(' using_list ')'  */
#line 12481 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 40683 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1987: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 40697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1988: /* inner_join: JOIN_SYM  */
#line 12501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1989: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12502 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1990: /* inner_join: STRAIGHT_JOIN  */
#line 12503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 1; }
#line 40715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1991: /* normal_join: inner_join  */
#line 12507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 40721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1992: /* normal_join: CROSS JOIN_SYM  */
#line 12508 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1993: /* opt_use_partition: %empty  */
#line 12516 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.string_list)= 0;}
#line 40733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1995: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 40743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1996: /* table_factor: table_primary_ident_opt_parens  */
#line 12530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1997: /* table_factor: table_primary_derived_opt_parens  */
#line 12531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1998: /* table_factor: join_table_parens  */
#line 12533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 40764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1999: /* table_factor: table_reference_list_parens  */
#line 12537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2000: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2001: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12542 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 40782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2002: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2003: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 40794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2004: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 40800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2005: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 40809 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2006: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 40821 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2007: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 40830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2008: /* join_table_parens: '(' join_table_parens ')'  */
#line 12576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 40836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2009: /* join_table_parens: '(' join_table ')'  */
#line 12578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2010: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 40867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2011: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 40876 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2012: /* opt_outer: %empty  */
#line 12618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 40882 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2013: /* opt_outer: OUTER  */
#line 12619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 40888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2014: /* index_hint_clause: %empty  */
#line 12624 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 40896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2015: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 40902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2016: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 40908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2017: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 40914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2018: /* index_hint_type: FORCE_SYM  */
#line 12633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 40920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2019: /* index_hint_type: IGNORE_SYM  */
#line 12634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 40926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2020: /* $@188: %empty  */
#line 12639 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 40934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2022: /* $@189: %empty  */
#line 12644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 40942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2027: /* $@190: %empty  */
#line 12657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->alloc_index_hints(thd); }
#line 40948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2029: /* $@191: %empty  */
#line 12661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {  Select->clear_index_hints(); }
#line 40954 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2031: /* opt_key_usage_list: %empty  */
#line 12666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 40960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2032: /* opt_key_usage_list: key_usage_list  */
#line 12667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 40966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2033: /* key_usage_element: ident  */
#line 12672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 40972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2034: /* key_usage_element: PRIMARY_SYM  */
#line 12674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 40978 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2037: /* using_list: ident  */
#line 12684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 40993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2038: /* using_list: using_list ',' ident  */
#line 12695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2039: /* interval: interval_time_stamp  */
#line 12708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 41014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2040: /* interval: DAY_HOUR_SYM  */
#line 12709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2041: /* interval: DAY_MICROSECOND_SYM  */
#line 12710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2042: /* interval: DAY_MINUTE_SYM  */
#line 12711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2043: /* interval: DAY_SECOND_SYM  */
#line 12712 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2044: /* interval: HOUR_MICROSECOND_SYM  */
#line 12713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2045: /* interval: HOUR_MINUTE_SYM  */
#line 12714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2046: /* interval: HOUR_SECOND_SYM  */
#line 12715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2047: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2048: /* interval: MINUTE_SECOND_SYM  */
#line 12717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2049: /* interval: SECOND_MICROSECOND_SYM  */
#line 12718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2050: /* interval: YEAR_MONTH_SYM  */
#line 12719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2051: /* interval_time_stamp: DAY_SYM  */
#line 12723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2052: /* interval_time_stamp: WEEK_SYM  */
#line 12724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2053: /* interval_time_stamp: HOUR_SYM  */
#line 12725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2054: /* interval_time_stamp: MINUTE_SYM  */
#line 12726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2055: /* interval_time_stamp: MONTH_SYM  */
#line 12727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2056: /* interval_time_stamp: QUARTER_SYM  */
#line 12728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2057: /* interval_time_stamp: SECOND_SYM  */
#line 12729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2058: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2059: /* interval_time_stamp: YEAR_SYM  */
#line 12731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2060: /* date_time_type: DATE_SYM  */
#line 12735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2061: /* date_time_type: TIME_SYM  */
#line 12736 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2062: /* date_time_type: DATETIME  */
#line 12737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2063: /* date_time_type: TIMESTAMP  */
#line 12738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2067: /* opt_table_alias_clause: %empty  */
#line 12748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2068: /* opt_table_alias_clause: table_alias_clause  */
#line 12749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 41170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2069: /* table_alias_clause: table_alias ident_table_alias  */
#line 12754 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 41180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2072: /* opt_where_clause: %empty  */
#line 12767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->where= 0; }
#line 41186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2073: /* $@192: %empty  */
#line 12769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 41194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2074: /* opt_where_clause: WHERE $@192 expr  */
#line 12773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2076: /* $@193: %empty  */
#line 12785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 41214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2077: /* opt_having_clause: HAVING $@193 expr  */
#line 12789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2080: /* group_list: group_list ',' order_ident order_dir  */
#line 12809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 41235 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2081: /* group_list: order_ident order_dir  */
#line 12814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 41244 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2082: /* olap_opt: %empty  */
#line 12821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41250 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2083: /* olap_opt: WITH_CUBE_SYM  */
#line 12823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 41271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2084: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 41290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2085: /* opt_window_clause: %empty  */
#line 12862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2086: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2089: /* window_def: window_name AS window_spec  */
#line 12875 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 41315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2090: /* $@194: %empty  */
#line 12887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->prepare_add_window_spec(thd); }
#line 41321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2091: /* window_spec: '(' $@194 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12891 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 41327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2092: /* opt_window_ref: %empty  */
#line 12895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2093: /* opt_window_ref: ident  */
#line 12897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 41343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2094: /* opt_window_partition_clause: %empty  */
#line 12905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2096: /* opt_window_order_clause: %empty  */
#line 12910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41355 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2097: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 41361 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2098: /* opt_window_frame_clause: %empty  */
#line 12915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2099: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 41382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2100: /* window_frame_units: ROWS_SYM  */
#line 12930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 41388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2101: /* window_frame_units: RANGE_SYM  */
#line 12931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 41394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2102: /* window_frame_extent: window_frame_start  */
#line 12936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 41408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2103: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 41418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2104: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 12955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2105: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 12962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2106: /* window_frame_start: literal PRECEDING_SYM  */
#line 12969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2107: /* window_frame_bound: window_frame_start  */
#line 12978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 41457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2108: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 12980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2109: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 12987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2110: /* opt_window_frame_exclusion: %empty  */
#line 12996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2111: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 12998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 41491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2112: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 13000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 41497 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2113: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 13002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 41503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2114: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 13004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2115: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 13006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2119: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 13024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 41525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2120: /* opt_order_clause: %empty  */
#line 13037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= NULL; }
#line 41531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2121: /* opt_order_clause: order_clause  */
#line 13039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 41537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2122: /* $@195: %empty  */
#line 13044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->where= "ORDER clause";
          }
#line 41545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2123: /* order_clause: ORDER_SYM BY $@195 order_list  */
#line 13048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 41553 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2124: /* order_list: order_list ',' order_ident order_dir  */
#line 13055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2125: /* order_list: order_ident order_dir  */
#line 13061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2126: /* order_dir: %empty  */
#line 13069 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) =  1; }
#line 41579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2127: /* order_dir: ASC  */
#line 13070 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =1; }
#line 41585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2128: /* order_dir: DESC  */
#line 13071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =0; }
#line 41591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2129: /* opt_limit_clause: %empty  */
#line 13076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit).empty(); }
#line 41597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2130: /* opt_limit_clause: limit_clause  */
#line 13078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 41603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2131: /* limit_clause: LIMIT limit_options  */
#line 13083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2132: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2133: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2134: /* opt_global_limit_clause: opt_limit_clause  */
#line 13106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 41644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2135: /* limit_options: limit_option  */
#line 13115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2136: /* limit_options: limit_option ',' limit_option  */
#line 13121 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2137: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2138: /* limit_option: ident_cli  */
#line 13136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 41683 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2139: /* limit_option: ident_cli '.' ident_cli  */
#line 13141 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 41692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2140: /* limit_option: param_marker  */
#line 13146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 41700 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2141: /* limit_option: ULONGLONG_NUM  */
#line 13150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2142: /* limit_option: LONG_NUM  */
#line 13156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2143: /* limit_option: NUM  */
#line 13162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2144: /* limit_rows_option: limit_option  */
#line 13171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 41739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2145: /* delete_limit_clause: %empty  */
#line 13179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 41748 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2146: /* delete_limit_clause: LIMIT limit_option  */
#line 13184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 41759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2147: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13190 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 41765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2148: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 41771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2149: /* order_limit_lock: order_or_limit  */
#line 13196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 41780 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2150: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 41789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2151: /* order_limit_lock: select_lock_type  */
#line 13206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 41802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2152: /* opt_order_limit_lock: %empty  */
#line 13217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 41811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2153: /* opt_order_limit_lock: order_limit_lock  */
#line 13221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 41817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2156: /* opt_procedure_or_into: %empty  */
#line 13234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock).empty();
          }
#line 41825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2157: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 41833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2158: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 41847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2159: /* order_or_limit: order_clause opt_limit_clause  */
#line 13256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 41859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2160: /* order_or_limit: limit_clause  */
#line 13264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 41873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2163: /* int_num: opt_plus NUM  */
#line 13282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2164: /* int_num: '-' NUM  */
#line 13283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2165: /* ulong_num: opt_plus NUM  */
#line 13287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2166: /* ulong_num: HEX_NUM  */
#line 13288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 41897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2167: /* ulong_num: opt_plus LONG_NUM  */
#line 13289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2168: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2169: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41915 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2170: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41921 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2171: /* real_ulong_num: NUM  */
#line 13296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41927 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2172: /* real_ulong_num: HEX_NUM  */
#line 13297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 41933 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2173: /* real_ulong_num: LONG_NUM  */
#line 13298 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2174: /* real_ulong_num: ULONGLONG_NUM  */
#line 13299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41945 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2175: /* real_ulong_num: dec_num_error  */
#line 13300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 41951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2176: /* longlong_num: opt_plus NUM  */
#line 13304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2177: /* longlong_num: LONG_NUM  */
#line 13305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2178: /* longlong_num: '-' NUM  */
#line 13306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2179: /* longlong_num: '-' LONG_NUM  */
#line 13307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2180: /* ulonglong_num: opt_plus NUM  */
#line 13311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2181: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41987 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2182: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2183: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 41999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2184: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13315 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2185: /* real_ulonglong_num: NUM  */
#line 13319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2186: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42017 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2187: /* real_ulonglong_num: HEX_NUM  */
#line 13321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2188: /* real_ulonglong_num: LONG_NUM  */
#line 13322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2189: /* real_ulonglong_num: dec_num_error  */
#line 13323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 42035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2190: /* dec_num_error: dec_num  */
#line 13328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2193: /* choice: ulong_num  */
#line 13337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2194: /* choice: DEFAULT  */
#line 13338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2195: /* bool: ulong_num  */
#line 13342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2196: /* bool: TRUE_SYM  */
#line 13343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1; }
#line 42065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2197: /* bool: FALSE_SYM  */
#line 13344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 42071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2198: /* $@196: %empty  */
#line 13349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42099 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2199: /* procedure_clause: PROCEDURE_SYM ident $@196 '(' procedure_list ')'  */
#line 13373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2200: /* procedure_list: %empty  */
#line 13380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2201: /* procedure_list: procedure_list2  */
#line 13381 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 42120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2204: /* procedure_item: remember_name expr remember_end  */
#line 13391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2205: /* $@197: %empty  */
#line 13400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2206: /* select_var_list_init: $@197 select_var_list  */
#line 13408 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2208: /* select_var_list: select_var_ident  */
#line 13413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 42155 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2209: /* select_var_ident: select_outvar  */
#line 13417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 42176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2210: /* select_outvar: '@' ident_or_text  */
#line 13437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 42184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2211: /* select_outvar: ident_or_text  */
#line 13441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2212: /* select_outvar: ident '.' ident  */
#line 13446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2213: /* into: INTO into_destination  */
#line 13454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2214: /* $@198: %empty  */
#line 13459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 42223 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2215: /* $@199: %empty  */
#line 13470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 42229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2217: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 42248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2218: /* into_destination: select_var_list_init  */
#line 13488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 42256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2219: /* $@200: %empty  */
#line 13499 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 42268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2220: /* do: DO_SYM $@200 expr_list  */
#line 13507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 42279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2221: /* $@201: %empty  */
#line 13521 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2222: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@201 table_list opt_lock_wait_timeout opt_restrict  */
#line 13528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2223: /* $@202: %empty  */
#line 13530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 42305 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2224: /* drop: DROP INDEX_SYM $@202 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 42327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2225: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 42337 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2226: /* drop: DROP PACKAGE_ORACLE_SYM opt_if_exists sp_name  */
#line 13559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2227: /* drop: DROP PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_exists sp_name  */
#line 13567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE_BODY, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE BODY"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42361 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2228: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42379 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2229: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2230: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2231: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 42418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2232: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13616 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 42426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2233: /* $@203: %empty  */
#line 13620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2234: /* drop: DROP VIEW_SYM opt_if_exists $@203 table_list opt_restrict  */
#line 13627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2235: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 42452 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2236: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2237: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 42471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2238: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 42480 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2239: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 42489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2240: /* $@204: %empty  */
#line 13656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2241: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@204 table_list  */
#line 13664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2244: /* table_name: table_ident  */
#line 13674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 42520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2245: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 42534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2248: /* table_alias_ref: table_ident_opt_wild  */
#line 13704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 42548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2249: /* opt_if_exists_table_element: %empty  */
#line 13717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 42557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2250: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 42566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2251: /* opt_if_exists: %empty  */
#line 13730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 42574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2252: /* opt_if_exists: IF_SYM EXISTS  */
#line 13734 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 42582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2253: /* opt_temporary: %empty  */
#line 13740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 42588 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2254: /* opt_temporary: TEMPORARY  */
#line 13741 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 42594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2255: /* $@205: %empty  */
#line 13749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 42608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2256: /* $@206: %empty  */
#line 13760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 42617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2257: /* insert: INSERT $@205 insert_lock_option opt_ignore insert2 $@206 insert_field_spec opt_insert_update  */
#line 13765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 42628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2258: /* $@207: %empty  */
#line 13775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 42642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2259: /* $@208: %empty  */
#line 13785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 42651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2260: /* replace: REPLACE $@207 replace_lock_option insert2 $@208 insert_field_spec  */
#line 13790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 42662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2261: /* insert_lock_option: %empty  */
#line 13800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 42675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2262: /* insert_lock_option: LOW_PRIORITY  */
#line 13808 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 42681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2263: /* insert_lock_option: DELAYED_SYM  */
#line 13810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 42692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2264: /* insert_lock_option: HIGH_PRIORITY  */
#line 13816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 42698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2265: /* replace_lock_option: opt_low_priority  */
#line 13820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 42704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2266: /* replace_lock_option: DELAYED_SYM  */
#line 13822 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 42714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2267: /* insert2: INTO insert_table  */
#line 13830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 42720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2268: /* insert2: insert_table  */
#line 13831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 42726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2269: /* $@209: %empty  */
#line 13835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 42734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2270: /* insert_table: $@209 table_name_with_opt_use_partition  */
#line 13839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 42745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2271: /* insert_field_spec: insert_values  */
#line 13848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 42751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2272: /* insert_field_spec: insert_field_list insert_values  */
#line 13849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 42757 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2273: /* $@210: %empty  */
#line 13851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 42770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2275: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 42778 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2278: /* fields: fields ',' insert_ident  */
#line 13876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 42784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2279: /* fields: insert_ident  */
#line 13877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 42790 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2280: /* insert_values: create_select_query_expression  */
#line 13883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 42796 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2285: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 42807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2286: /* equal: '='  */
#line 13907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 42813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2287: /* equal: SET_VAR  */
#line 13908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 42819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2288: /* opt_equal: %empty  */
#line 13912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2289: /* opt_equal: equal  */
#line 13913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 42831 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2290: /* opt_with: opt_equal  */
#line 13917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 42837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2291: /* opt_with: WITH  */
#line 13918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 42843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2292: /* opt_by: opt_equal  */
#line 13922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 42849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2293: /* opt_by: BY  */
#line 13923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 42855 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2294: /* $@211: %empty  */
#line 13928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 42864 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2295: /* no_braces: '(' $@211 opt_values ')'  */
#line 13933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 42875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2296: /* $@212: %empty  */
#line 13943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 42884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2297: /* no_braces_with_names: '(' $@212 opt_values_with_names ')'  */
#line 13948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 42895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2298: /* opt_values: %empty  */
#line 13957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2300: /* opt_values_with_names: %empty  */
#line 13962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2302: /* values: values ',' expr_or_ignore_or_default  */
#line 13968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 42916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2303: /* values: expr_or_ignore_or_default  */
#line 13973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 42925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2304: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 13981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 42937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2305: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 13989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2306: /* expr_or_ignore: expr  */
#line 13999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 42955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2307: /* expr_or_ignore: IGNORE_SYM  */
#line 14001 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2308: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 14009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 42971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2309: /* expr_or_ignore_or_default: DEFAULT  */
#line 14011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2311: /* $@213: %empty  */
#line 14020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 42987 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2312: /* $@214: %empty  */
#line 14022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 42995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2313: /* opt_insert_update: ON DUPLICATE_SYM $@213 KEY_SYM UPDATE_SYM $@214 insert_update_list  */
#line 14026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2314: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 14034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2315: /* update_table_list: join_table_list  */
#line 14046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2316: /* $@215: %empty  */
#line 14053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2317: /* $@216: %empty  */
#line 14063 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2318: /* update: UPDATE_SYM $@215 opt_low_priority opt_ignore update_table_list SET update_list $@216 opt_where_clause opt_order_clause delete_limit_clause  */
#line 14082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2321: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 14098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2322: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 14105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2325: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 14118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2326: /* opt_low_priority: %empty  */
#line 14127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2327: /* opt_low_priority: LOW_PRIORITY  */
#line 14128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2328: /* $@217: %empty  */
#line 14135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2329: /* delete: DELETE_SYM $@217 delete_part2  */
#line 14147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2330: /* opt_delete_system_time: %empty  */
#line 14155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 43150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2331: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2332: /* delete_part2: opt_delete_options single_multi  */
#line 14165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 43164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2333: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2334: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2335: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
          }
#line 43200 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2336: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14204 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43212 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2337: /* $@218: %empty  */
#line 14212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2338: /* single_multi: table_wild_list $@218 FROM join_table_list opt_where_clause  */
#line 14218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2339: /* $@219: %empty  */
#line 14226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43244 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2340: /* single_multi: FROM table_alias_ref_list $@219 USING join_table_list opt_where_clause  */
#line 14232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2345: /* table_wild_one: ident opt_wild  */
#line 14253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43275 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2346: /* table_wild_one: ident '.' ident opt_wild  */
#line 14268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2347: /* opt_wild: %empty  */
#line 14285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2348: /* opt_wild: '.' '*'  */
#line 14286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 43306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2349: /* opt_delete_options: %empty  */
#line 14290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2350: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 43318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2351: /* opt_delete_option: QUICK  */
#line 14295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->options|= OPTION_QUICK; }
#line 43324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2352: /* opt_delete_option: LOW_PRIORITY  */
#line 14296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 43330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2353: /* opt_delete_option: IGNORE_SYM  */
#line 14297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->ignore= 1; }
#line 43336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2354: /* $@220: %empty  */
#line 14302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2355: /* $@221: %empty  */
#line 14313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 43363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2356: /* truncate: TRUNCATE_SYM $@220 opt_table_sym table_name opt_lock_wait_timeout $@221 opt_truncate_table_storage_clause  */
#line 14320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { }
#line 43369 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2366: /* profile_def: CPU_SYM  */
#line 14344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 43377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2367: /* profile_def: MEMORY_SYM  */
#line 14348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 43385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2368: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 43393 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2369: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 43401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2370: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 43409 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2371: /* profile_def: IPC_SYM  */
#line 14364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 43417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2372: /* profile_def: SWAPS_SYM  */
#line 14368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 43425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2373: /* profile_def: SOURCE_SYM  */
#line 14372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 43433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2374: /* profile_def: ALL  */
#line 14376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 43441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2375: /* opt_profile_args: %empty  */
#line 14383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 43449 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2376: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 43457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2377: /* $@222: %empty  */
#line 14396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 43472 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2378: /* show: SHOW $@222 show_param  */
#line 14407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 43481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2379: /* show_param: DATABASES wild_and_where  */
#line 14415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 43492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2380: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 43504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2381: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 43516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2382: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 43528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2383: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 43540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2384: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 43552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2385: /* show_param: PLUGINS_SYM  */
#line 14462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2386: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14469 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2387: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14476 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2388: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14482 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 43590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2389: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= NULL; }
#line 43596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2390: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 43609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2391: /* show_param: master_or_binary LOGS_SYM  */
#line 14495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 43617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2392: /* show_param: SLAVE HOSTS_SYM  */
#line 14499 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 43625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2393: /* $@223: %empty  */
#line 14503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 43634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2395: /* $@224: %empty  */
#line 14509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 43643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2397: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 43656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2398: /* show_param: opt_storage ENGINES_SYM  */
#line 14524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 43667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2399: /* show_param: AUTHORS_SYM  */
#line 14531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 43676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2400: /* show_param: CONTRIBUTORS_SYM  */
#line 14536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 43685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2401: /* show_param: PRIVILEGES  */
#line 14541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 43694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2402: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 43703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2403: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 43712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2404: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14556 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 43718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2405: /* show_param: ERRORS opt_global_limit_clause  */
#line 14558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 43724 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2406: /* show_param: PROFILES_SYM  */
#line 14560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 43730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2407: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14562 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 43741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2408: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 43753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2409: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 43759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2410: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 43771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2411: /* show_param: charset wild_and_where  */
#line 14587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 43782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2412: /* show_param: COLLATION_SYM wild_and_where  */
#line 14594 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 43793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2413: /* show_param: GRANTS  */
#line 14601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 43805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2414: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 43815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2415: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 43824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2416: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 43836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2417: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 43848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2418: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 43860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2419: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 43868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2420: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14648 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 43877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2421: /* show_param: SLAVE STATUS_SYM  */
#line 14653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 43888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2422: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 43897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2423: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14665 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 43908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2424: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 43919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2425: /* show_param: CREATE PACKAGE_ORACLE_SYM sp_name  */
#line 14679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 43929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2426: /* show_param: CREATE PACKAGE_ORACLE_SYM BODY_ORACLE_SYM sp_name  */
#line 14685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 43939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2427: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 43949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2428: /* show_param: CREATE USER_SYM  */
#line 14697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 43961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2429: /* show_param: CREATE USER_SYM user  */
#line 14705 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 43970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2430: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 43981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2431: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 43992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2432: /* show_param: PACKAGE_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2433: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2434: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2435: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2436: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM CODE_SYM sp_name  */
#line 14748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2437: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2438: /* show_param: describe_command FOR_SYM expr  */
#line 14758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2439: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2440: /* show_engine_param: STATUS_SYM  */
#line 14787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44090 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2441: /* show_engine_param: MUTEX_SYM  */
#line 14789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2442: /* show_engine_param: LOGS_SYM  */
#line 14791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44102 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2447: /* opt_db: %empty  */
#line 14805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2448: /* opt_db: from_or_in ident  */
#line 14806 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2449: /* opt_full: %empty  */
#line 14810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=0; }
#line 44120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2450: /* opt_full: FULL  */
#line 14811 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=1; }
#line 44126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2453: /* binlog_in: %empty  */
#line 14820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2454: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2455: /* binlog_from: %empty  */
#line 14825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2456: /* binlog_from: FROM ulonglong_num  */
#line 14826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2457: /* wild_and_where: %empty  */
#line 14830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.simple_string)= 0; }
#line 44156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2458: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14832 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2459: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2460: /* $@225: %empty  */
#line 14851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2461: /* describe: describe_command table_ident $@225 opt_describe_column  */
#line 14864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2462: /* $@226: %empty  */
#line 14869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 44211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2463: /* describe: describe_command opt_extended_describe $@226 explainable_command  */
#line 14871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 44220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2472: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 44228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2473: /* opt_extended_describe: EXTENDED_SYM  */
#line 14899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 44234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2474: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 44240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2475: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 44246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2476: /* opt_extended_describe: opt_format_json  */
#line 14903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 44252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2477: /* opt_format_json: %empty  */
#line 14907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2478: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 44272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2479: /* opt_describe_column: %empty  */
#line 14921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2480: /* opt_describe_column: text_string  */
#line 14922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 44284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2481: /* opt_describe_column: ident  */
#line 14924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 44296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2482: /* $@227: %empty  */
#line 14938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 44307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2483: /* flush: FLUSH_SYM opt_no_write_to_binlog $@227 flush_options  */
#line 14944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 44313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2484: /* $@228: %empty  */
#line 14949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 44327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2485: /* flush_options: table_or_tables $@228 opt_table_list opt_flush_lock  */
#line 14959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2486: /* flush_options: flush_options_list  */
#line 14961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2487: /* opt_flush_lock: %empty  */
#line 14965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2488: /* opt_flush_lock: flush_lock  */
#line 14967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 44361 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2489: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 14982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 44367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2490: /* $@229: %empty  */
#line 14984 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 44381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2491: /* flush_lock: FOR_SYM $@229 EXPORT_SYM  */
#line 14992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2493: /* flush_options_list: flush_option  */
#line 14998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44393 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2494: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 15003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 44399 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2495: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 15005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 44405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2496: /* flush_option: GENERAL LOGS_SYM  */
#line 15007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 44411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2497: /* flush_option: SLOW LOGS_SYM  */
#line 15009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 44417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2498: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 15011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 44423 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2499: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 15013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 44435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2500: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 15021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 44441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2501: /* flush_option: HOSTS_SYM  */
#line 15023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 44447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2502: /* flush_option: PRIVILEGES  */
#line 15025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 44453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2503: /* flush_option: LOGS_SYM  */
#line 15027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 44462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2504: /* flush_option: STATUS_SYM  */
#line 15032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 44468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2505: /* flush_option: SLAVE optional_connection_name  */
#line 15034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 44480 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2506: /* flush_option: MASTER_SYM  */
#line 15042 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 44486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2507: /* flush_option: DES_KEY_FILE  */
#line 15044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 44492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2508: /* flush_option: RESOURCES  */
#line 15046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 44498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2509: /* flush_option: SSL_SYM  */
#line 15048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SSL;}
#line 44504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2510: /* flush_option: IDENT_sys remember_tok_start  */
#line 15050 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 44522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2511: /* opt_table_list: %empty  */
#line 15066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2512: /* opt_table_list: table_list  */
#line 15067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 44534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2513: /* backup: BACKUP_SYM backup_statements  */
#line 15071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 44540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2514: /* backup_statements: STAGE_SYM ident  */
#line 15076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 44556 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2515: /* $@230: %empty  */
#line 15088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 44565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2516: /* backup_statements: LOCK_SYM $@230 table_ident  */
#line 15093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 44577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2517: /* backup_statements: UNLOCK_SYM  */
#line 15101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 44586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2518: /* opt_delete_gtid_domain: %empty  */
#line 15108 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2519: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 15110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2523: /* delete_domain_id: ulonglong_num  */
#line 15120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 44615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2524: /* optional_flush_tables_arguments: %empty  */
#line 15135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {(yyval.num)= 0;}
#line 44621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2525: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 44627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2526: /* $@231: %empty  */
#line 15141 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 44636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2527: /* reset: RESET_SYM $@231 reset_options  */
#line 15146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2530: /* $@232: %empty  */
#line 15155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 44648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2531: /* reset_option: SLAVE $@232 optional_connection_name slave_reset_options  */
#line 15157 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 44654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2532: /* $@233: %empty  */
#line 15159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 44663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2534: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 44669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2535: /* slave_reset_options: %empty  */
#line 15168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= false; }
#line 44675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2536: /* slave_reset_options: ALL  */
#line 15169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= true; }
#line 44681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2537: /* master_reset_options: %empty  */
#line 15173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44687 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2538: /* master_reset_options: TO_SYM ulong_num  */
#line 15175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 44695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2539: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 44703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2540: /* $@234: %empty  */
#line 15186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 44709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2541: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@234 expr  */
#line 15188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 44719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2542: /* $@235: %empty  */
#line 15200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 44731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2543: /* kill: KILL_SYM $@235 kill_type kill_option  */
#line 15208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 44739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2544: /* kill_type: %empty  */
#line 15214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 44745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2545: /* kill_type: HARD_SYM  */
#line 15215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 44751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2546: /* kill_type: SOFT_SYM  */
#line 15216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 44757 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2547: /* kill_option: opt_connection kill_expr  */
#line 15220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 44763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2548: /* kill_option: QUERY_SYM kill_expr  */
#line 15221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 44769 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2549: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 44779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2550: /* opt_connection: %empty  */
#line 15231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 44785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2551: /* opt_connection: CONNECTION_SYM  */
#line 15232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 44791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2552: /* kill_expr: expr  */
#line 15237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 44799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2553: /* kill_expr: USER_SYM user  */
#line 15241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 44808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2554: /* $@236: %empty  */
#line 15248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 44814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2555: /* shutdown: SHUTDOWN $@236 shutdown_option  */
#line 15249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 44820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2556: /* shutdown_option: %empty  */
#line 15253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 44826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2557: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 44834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2558: /* use: USE_SYM ident  */
#line 15263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 44844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2559: /* $@237: %empty  */
#line 15274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 44862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2560: /* $@238: %empty  */
#line 15288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 44877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2561: /* $@239: %empty  */
#line 15299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 44894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2562: /* $@240: %empty  */
#line 15312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 44900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2563: /* load: LOAD data_or_xml $@237 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@238 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@239 opt_load_data_charset $@240 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 44911 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2564: /* data_or_xml: DATA_SYM  */
#line 15325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 44917 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2565: /* data_or_xml: XML_SYM  */
#line 15326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 44923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2566: /* opt_local: %empty  */
#line 15330 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=0;}
#line 44929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2567: /* opt_local: LOCAL_SYM  */
#line 15331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1;}
#line 44935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2568: /* load_data_lock: %empty  */
#line 15335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 44941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2569: /* load_data_lock: CONCURRENT  */
#line 15337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 44953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2570: /* load_data_lock: LOW_PRIORITY  */
#line 15344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 44959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2571: /* opt_duplicate: %empty  */
#line 15348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 44965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2572: /* opt_duplicate: REPLACE  */
#line 15349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 44971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2573: /* opt_duplicate: IGNORE_SYM  */
#line 15350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1; }
#line 44977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2578: /* field_term: TERMINATED BY text_string  */
#line 15365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 44986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2579: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 44997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2580: /* field_term: ENCLOSED BY text_string  */
#line 15377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2581: /* field_term: ESCAPED BY text_string  */
#line 15382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2586: /* line_term: TERMINATED BY text_string  */
#line 15400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2587: /* line_term: STARTING BY text_string  */
#line 15405 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2588: /* opt_xml_rows_identified_by: %empty  */
#line 15412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { }
#line 45039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2589: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2591: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15420 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2592: /* lines_or_rows: LINES  */
#line 15427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { }
#line 45060 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2593: /* lines_or_rows: ROWS_SYM  */
#line 15428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 45066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2594: /* opt_field_or_var_spec: %empty  */
#line 15432 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2595: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2596: /* opt_field_or_var_spec: '(' ')'  */
#line 15434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 45084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2597: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45090 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2598: /* fields_or_vars: field_or_var  */
#line 15441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2599: /* field_or_var: simple_ident_nospvar  */
#line 15445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45102 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2600: /* field_or_var: '@' ident_or_text  */
#line 15447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2601: /* opt_load_data_set_spec: %empty  */
#line 15455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2602: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15456 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2605: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2606: /* text_literal: TEXT_STRING  */
#line 15479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2607: /* text_literal: NCHAR_STRING  */
#line 15484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45154 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2608: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2609: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2610: /* text_string: TEXT_STRING_literal  */
#line 15502 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2611: /* text_string: hex_or_bin_String  */
#line 15509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2612: /* hex_or_bin_String: HEX_NUM  */
#line 15515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2613: /* hex_or_bin_String: HEX_STRING  */
#line 15523 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2614: /* hex_or_bin_String: BIN_NUM  */
#line 15531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2615: /* param_marker: PARAM_MARKER  */
#line 15546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 45241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2616: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 45251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2617: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 45262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2618: /* signed_literal: '+' NUM_literal  */
#line 15568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 45268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2619: /* signed_literal: '-' NUM_literal  */
#line 15570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 45277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2620: /* literal: text_literal  */
#line 15577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 45283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2621: /* literal: NUM_literal  */
#line 15578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 45289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2622: /* literal: temporal_literal  */
#line 15579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 45295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2623: /* literal: NULL_SYM  */
#line 15581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 45313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2624: /* literal: FALSE_SYM  */
#line 15595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2625: /* literal: TRUE_SYM  */
#line 15601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2626: /* literal: HEX_NUM  */
#line 15607 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2627: /* literal: HEX_STRING  */
#line 15613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2628: /* literal: BIN_NUM  */
#line 15619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2629: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15625 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 45383 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2630: /* NUM_literal: NUM  */
#line 15644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2631: /* NUM_literal: LONG_NUM  */
#line 15654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2632: /* NUM_literal: ULONGLONG_NUM  */
#line 15664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2633: /* NUM_literal: DECIMAL_NUM  */
#line 15670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2634: /* NUM_literal: FLOAT_NUM  */
#line 15677 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2635: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2636: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2637: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime2.create_literal_item(thd,
                                                             (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                             YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2638: /* $@241: %empty  */
#line 15711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 45495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2639: /* with_clause: WITH opt_recursive $@241 with_list  */
#line 15727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 45504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2640: /* opt_recursive: %empty  */
#line 15735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 0; }
#line 45510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2641: /* opt_recursive: RECURSIVE_SYM  */
#line 15736 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 45516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2644: /* $@242: %empty  */
#line 15749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 45527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2645: /* with_list_element: with_element_head opt_with_column_list $@242 AS '(' query_expression ')'  */
#line 15756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 45545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2646: /* opt_with_column_list: %empty  */
#line 15774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2647: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2648: /* with_column_list: ident  */
#line 15782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 45566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2649: /* with_column_list: with_column_list ',' ident  */
#line 15787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 45575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2650: /* with_element_head: ident  */
#line 15796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 45588 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2651: /* insert_ident: simple_ident_nospvar  */
#line 15813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 45594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2652: /* insert_ident: table_wild  */
#line 15814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 45600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2653: /* table_wild: ident '.' '*'  */
#line 15819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2654: /* table_wild: ident '.' ident '.' '*'  */
#line 15824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2655: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15832 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2656: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2657: /* order_ident: expr  */
#line 15844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 45642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2658: /* simple_ident: ident_cli  */
#line 15850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2659: /* simple_ident: ident_cli '.' ident_cli  */
#line 15855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2660: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2661: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2662: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2663: /* simple_ident_nospvar: ident  */
#line 15879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2664: /* simple_ident_nospvar: ident '.' ident  */
#line 15884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2665: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2666: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2667: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15900 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2668: /* field_ident: ident  */
#line 15907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 45740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2669: /* field_ident: ident '.' ident '.' ident  */
#line 15909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 45755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2670: /* field_ident: ident '.' ident  */
#line 15920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 45767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2671: /* field_ident: '.' ident  */
#line 15927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 45773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2672: /* table_ident: ident  */
#line 15932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2673: /* table_ident: ident '.' ident  */
#line 15938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2674: /* table_ident: '.' ident  */
#line 15944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2675: /* table_ident_opt_wild: ident opt_wild  */
#line 15954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2676: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 15960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2677: /* table_ident_nodb: ident  */
#line 15969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2682: /* ident_cli: keyword_ident  */
#line 15985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 45841 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2683: /* IDENT_sys: IDENT_cli  */
#line 15990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 45850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2684: /* TEXT_STRING_sys: TEXT_STRING  */
#line 15998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 45859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2685: /* TEXT_STRING_literal: TEXT_STRING  */
#line 16006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 45868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2686: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 16014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 45877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2688: /* ident_table_alias: keyword_table_alias  */
#line 16023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2690: /* ident_set_usual_case: keyword_set_usual_case  */
#line 16032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2692: /* ident_sysvar_name: keyword_sysvar_name  */
#line 16041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2693: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 16046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 45913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2695: /* ident: keyword_ident  */
#line 16056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2697: /* ident_directly_assignable: keyword_directly_assignable  */
#line 16065 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2699: /* label_ident: keyword_label  */
#line 16075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 45940 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2700: /* labels_declaration_oracle: label_declaration_oracle  */
#line 16082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 45946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2701: /* labels_declaration_oracle: labels_declaration_oracle label_declaration_oracle  */
#line 16083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                             { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 45952 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2702: /* label_declaration_oracle: SHIFT_LEFT label_ident SHIFT_RIGHT  */
#line 16088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_goto_label(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[-1].ident_sys);
          }
#line 45962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2703: /* ident_or_text: ident  */
#line 16096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 45968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2704: /* ident_or_text: TEXT_STRING_sys  */
#line 16097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 45974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2705: /* ident_or_text: LEX_HOSTNAME  */
#line 16098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 45980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2706: /* user_maybe_role: ident_or_text  */
#line 16103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 45995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2707: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 16114 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2708: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 16143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2711: /* user: user_maybe_role  */
#line 16154 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3197: /* $@243: %empty  */
#line 16775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3198: /* set: SET $@243 start_option_value_list  */
#line 16785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3199: /* $@244: %empty  */
#line 16791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3200: /* $@245: %empty  */
#line 16797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3201: /* set: SET STATEMENT_SYM $@244 set_stmt_option_value_following_option_type_list $@245 FOR_SYM verb_clause  */
#line 16808 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3202: /* $@246: %empty  */
#line 16813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if(sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3203: /* set_assign: ident_directly_assignable SET_VAR $@246 set_expr_or_default  */
#line 16821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3204: /* $@247: %empty  */
#line 16827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3205: /* set_assign: ident_directly_assignable '.' ident SET_VAR $@247 set_expr_or_default  */
#line 16835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->var_list.is_empty());
            if (unlikely(lex->set_variable(&(yyvsp[-5].ident_sys), &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 46150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3206: /* $@248: %empty  */
#line 16843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!lex->is_trigger_new_or_old_reference(&(yyvsp[-3].ident_sys))))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-4].kwd).pos());
              MYSQL_YYABORT;
            }
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3207: /* set_assign: COLON_ORACLE_SYM ident '.' ident SET_VAR $@248 set_expr_or_default  */
#line 16856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING tmp= { (yyvsp[-5].ident_sys).str, (yyvsp[-5].ident_sys).length };
            if (unlikely(Lex->set_trigger_field(&tmp, &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46178 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3210: /* $@249: %empty  */
#line 16877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3212: /* $@250: %empty  */
#line 16883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3213: /* start_option_value_list: TRANSACTION_SYM $@250 transaction_characteristics  */
#line 16887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46204 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3214: /* $@251: %empty  */
#line 16892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46212 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3216: /* $@252: %empty  */
#line 16902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3218: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3221: /* $@253: %empty  */
#line 16922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3222: /* option_value_list: $@253 option_value  */
#line 16927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3223: /* $@254: %empty  */
#line 16932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3224: /* option_value_list: option_value_list ',' $@254 option_value  */
#line 16937 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3225: /* $@255: %empty  */
#line 16946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3228: /* option_type: GLOBAL_SYM  */
#line 16954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3229: /* option_type: LOCAL_SYM  */
#line 16955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3230: /* option_type: SESSION_SYM  */
#line 16956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3231: /* opt_var_type: %empty  */
#line 16960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3232: /* opt_var_type: GLOBAL_SYM  */
#line 16961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3233: /* opt_var_type: LOCAL_SYM  */
#line 16962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3234: /* opt_var_type: SESSION_SYM  */
#line 16963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3235: /* opt_var_ident_type: %empty  */
#line 16967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 46322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3236: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 16968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 46328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3237: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 16969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3238: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 16970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3239: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 16976 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3240: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 16981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3241: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16986 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3242: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 16995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3243: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 17000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3244: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 17005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3245: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 17010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3246: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 17015 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3247: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 17020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3248: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 17025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3249: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 17030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 46448 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3250: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 17044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 46463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3251: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 17055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3252: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 17074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3253: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 17092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3254: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 17104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3255: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 17112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3256: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 17117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3261: /* transaction_access_mode: transaction_access_mode_types  */
#line 17140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3262: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 17159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3263: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 17176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= true; }
#line 46606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3264: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 17177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= false; }
#line 46612 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3265: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 17181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 46618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3266: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 17182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 46624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3267: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 17183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 46630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3268: /* isolation_types: SERIALIZABLE_SYM  */
#line 17184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 46636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3269: /* opt_for_user: equal  */
#line 17189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3270: /* opt_for_user: FOR_SYM user equal  */
#line 17202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 46660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3271: /* text_or_password: TEXT_STRING  */
#line 17207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 46669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3272: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 46678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3273: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 46690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3274: /* set_expr_or_default: expr  */
#line 17227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3275: /* set_expr_or_default: DEFAULT  */
#line 17228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.item)=0; }
#line 46702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3276: /* set_expr_or_default: ON  */
#line 17230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3277: /* set_expr_or_default: ALL  */
#line 17236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3278: /* set_expr_or_default: BINARY  */
#line 17242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3279: /* $@256: %empty  */
#line 17253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 46744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3280: /* lock: LOCK_SYM table_or_tables $@256 table_lock_list opt_lock_wait_timeout  */
#line 17261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3281: /* opt_lock_wait_timeout: %empty  */
#line 17266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {}
#line 46756 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3282: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 46766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3283: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 46776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3284: /* table_or_tables: TABLE_SYM  */
#line 17282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 46782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3285: /* table_or_tables: TABLES  */
#line 17283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 46788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3288: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 46808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3289: /* lock_option: READ_SYM  */
#line 17311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 46814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3290: /* lock_option: WRITE_SYM  */
#line 17312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 46820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3291: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 46828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3292: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 46834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3293: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ; }
#line 46840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3294: /* $@257: %empty  */
#line 17324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 46852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3295: /* unlock: UNLOCK_SYM $@257 table_or_tables  */
#line 17332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3296: /* $@258: %empty  */
#line 17341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 46867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3297: /* handler: HANDLER_SYM $@258 handler_tail  */
#line 17346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 46875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3298: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 46888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3299: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 46901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3300: /* $@259: %empty  */
#line 17371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 46922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3301: /* handler_tail: table_ident_nodb READ_SYM $@259 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17388 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 46947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3302: /* handler_read_or_scan: handler_scan_function  */
#line 17411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= null_clex_str; }
#line 46953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3303: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 46959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3304: /* handler_scan_function: FIRST_SYM  */
#line 17416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 46965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3305: /* handler_scan_function: NEXT_SYM  */
#line 17417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 46971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3306: /* handler_rkey_function: FIRST_SYM  */
#line 17421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 46977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3307: /* handler_rkey_function: NEXT_SYM  */
#line 17422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 46983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3308: /* handler_rkey_function: PREV_SYM  */
#line 17423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 46989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3309: /* handler_rkey_function: LAST_SYM  */
#line 17424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 46995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3310: /* $@260: %empty  */
#line 17426 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3311: /* handler_rkey_function: handler_rkey_mode $@260 '(' values ')'  */
#line 17434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3312: /* handler_rkey_mode: '='  */
#line 17438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3313: /* handler_rkey_mode: GE  */
#line 17439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3314: /* handler_rkey_mode: LE  */
#line 17440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3315: /* handler_rkey_mode: '>'  */
#line 17441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3316: /* handler_rkey_mode: '<'  */
#line 17442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3317: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3318: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3319: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17460 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3320: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3321: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3322: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47099 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3323: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3324: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3325: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3326: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17506 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3327: /* admin_option_for_role: grant_role  */
#line 17508 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3328: /* grant: GRANT clear_privileges grant_command  */
#line 17513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3329: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3330: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47166 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3331: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3332: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3333: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3334: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3335: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3336: /* opt_with_admin: %empty  */
#line 17571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = 0; }
#line 47225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3337: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3338: /* opt_with_admin_option: %empty  */
#line 17576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= false; }
#line 47237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3339: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= true; }
#line 47243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3340: /* role_list: grant_role  */
#line 17582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3341: /* role_list: role_list ',' grant_role  */
#line 17587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3342: /* current_role: CURRENT_ROLE optional_braces  */
#line 17595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3343: /* grant_role: ident_or_text  */
#line 17605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3347: /* grant_privileges: object_privilege_list  */
#line 17632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 47301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3348: /* grant_privileges: ALL opt_privileges  */
#line 17634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 47310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3353: /* $@261: %empty  */
#line 17652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 47316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3354: /* object_privilege: SELECT_SYM $@261 opt_column_list  */
#line 17653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3355: /* $@262: %empty  */
#line 17655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 47328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3356: /* object_privilege: INSERT $@262 opt_column_list  */
#line 17656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3357: /* $@263: %empty  */
#line 17658 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 47340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3358: /* object_privilege: UPDATE_SYM $@263 opt_column_list  */
#line 17659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3359: /* $@264: %empty  */
#line 17661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 47352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3360: /* object_privilege: REFERENCES $@264 opt_column_list  */
#line 17662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3361: /* object_privilege: DELETE_SYM  */
#line 17663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 47364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3362: /* object_privilege: USAGE  */
#line 17664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 47370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3363: /* object_privilege: INDEX_SYM  */
#line 17665 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 47376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3364: /* object_privilege: ALTER  */
#line 17666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 47382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3365: /* object_privilege: CREATE  */
#line 17667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 47388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3366: /* object_privilege: DROP  */
#line 17668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 47394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3367: /* object_privilege: EXECUTE_SYM  */
#line 17669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 47400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3368: /* object_privilege: RELOAD  */
#line 17670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 47406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3369: /* object_privilege: SHUTDOWN  */
#line 17671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 47412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3370: /* object_privilege: PROCESS  */
#line 17672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 47418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3371: /* object_privilege: FILE_SYM  */
#line 17673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 47424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3372: /* object_privilege: GRANT OPTION  */
#line 17674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 47430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3373: /* object_privilege: SHOW DATABASES  */
#line 17675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 47436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3374: /* object_privilege: SUPER_SYM  */
#line 17676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 47442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3375: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17677 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 47448 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3376: /* object_privilege: LOCK_SYM TABLES  */
#line 17678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 47454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3377: /* object_privilege: REPLICATION SLAVE  */
#line 17679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 47460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3378: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 47466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3379: /* object_privilege: CREATE VIEW_SYM  */
#line 17681 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 47472 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3380: /* object_privilege: SHOW VIEW_SYM  */
#line 17682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 47478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3381: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 47484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3382: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 47490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3383: /* object_privilege: CREATE USER_SYM  */
#line 17685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 47496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3384: /* object_privilege: EVENT_SYM  */
#line 17686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 47502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3385: /* object_privilege: TRIGGER_SYM  */
#line 17687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 47508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3386: /* object_privilege: CREATE TABLESPACE  */
#line 17688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 47514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3387: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 47520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3388: /* opt_and: %empty  */
#line 17693 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3389: /* opt_and: AND_SYM  */
#line 17694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 47532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3392: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 47543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3393: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 47554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3394: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 47565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3395: /* grant_ident: '*'  */
#line 17728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3396: /* grant_ident: ident '.' '*'  */
#line 17738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3397: /* grant_ident: '*' '.' '*'  */
#line 17747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47605 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3398: /* grant_ident: table_ident  */
#line 17756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 47619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3399: /* user_list: user  */
#line 17769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3400: /* user_list: user_list ',' user  */
#line 17774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3401: /* grant_list: grant_user  */
#line 17782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3402: /* grant_list: grant_list ',' grant_user  */
#line 17787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3403: /* user_and_role_list: user_or_role  */
#line 17795 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3404: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3409: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17811 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 47683 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3410: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17817 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47693 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3411: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 47702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3412: /* grant_user: user_or_role  */
#line 17828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 47710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3413: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 47720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3414: /* auth_expression: auth_token  */
#line 17841 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 47728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3415: /* auth_token: ident_or_text opt_auth_str  */
#line 17848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 47737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3416: /* opt_auth_str: %empty  */
#line 17856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 47746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3417: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17861 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 47756 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3418: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 47766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3419: /* opt_column_list: %empty  */
#line 17876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 47775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3420: /* opt_column_list: '(' column_list ')'  */
#line 17880 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 47781 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3423: /* column_list_id: ident  */
#line 17890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 47811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3425: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 47819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3426: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 47827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3427: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 47835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3428: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 47843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3429: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 47852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3430: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 47861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3431: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 17949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 47870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3432: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 17954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 47879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3433: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 17959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 47888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3434: /* resource_option_list: resource_option_list resource_option  */
#line 17966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 47894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3435: /* resource_option_list: resource_option  */
#line 17967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3436: /* opt_resource_options: %empty  */
#line 17971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3438: /* opt_grant_options: %empty  */
#line 17977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3439: /* opt_grant_options: WITH grant_option_list  */
#line 17978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 47918 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3440: /* opt_grant_option: %empty  */
#line 17982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3441: /* opt_grant_option: WITH GRANT OPTION  */
#line 17983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 47930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3442: /* grant_option_list: grant_option_list grant_option  */
#line 17987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 47936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3443: /* grant_option_list: grant_option  */
#line 17988 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 47942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3444: /* grant_option: GRANT OPTION  */
#line 17992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 47948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3445: /* grant_option: resource_option  */
#line 17993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47954 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3446: /* $@265: %empty  */
#line 17998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 47964 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3447: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@265 opt_work  */
#line 18003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 47970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3448: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 18008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 47980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3449: /* opt_not: %empty  */
#line 18016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 47986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3450: /* opt_not: not  */
#line 18017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 1; }
#line 47992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3451: /* opt_work: %empty  */
#line 18021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3452: /* opt_work: WORK_SYM  */
#line 18022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 48004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3453: /* opt_chain: %empty  */
#line 18027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3454: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 18028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3455: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 18029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3456: /* opt_release: %empty  */
#line 18034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3457: /* opt_release: RELEASE_SYM  */
#line 18035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48034 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3458: /* opt_release: NO_SYM RELEASE_SYM  */
#line 18036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3459: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 18041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3460: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 18053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3461: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 18062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3462: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 18068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3463: /* savepoint: SAVEPOINT_SYM ident  */
#line 18077 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3464: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 18086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3465: /* unit_type_decl: UNION_SYM union_option  */
#line 18099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3466: /* unit_type_decl: INTERSECT_SYM  */
#line 18101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3467: /* unit_type_decl: EXCEPT_SYM  */
#line 18103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3468: /* union_option: %empty  */
#line 18110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=1; }
#line 48130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3469: /* union_option: DISTINCT  */
#line 18111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1; }
#line 48136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3470: /* union_option: ALL  */
#line 18112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=0; }
#line 48142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3471: /* query_expression_option: STRAIGHT_JOIN  */
#line 18116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3472: /* query_expression_option: HIGH_PRIORITY  */
#line 18118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3473: /* query_expression_option: DISTINCT  */
#line 18123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3474: /* query_expression_option: UNIQUE_SYM  */
#line 18124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3475: /* query_expression_option: SQL_SMALL_RESULT  */
#line 18125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3476: /* query_expression_option: SQL_BIG_RESULT  */
#line 18126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3477: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 18127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3478: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 18128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3479: /* query_expression_option: ALL  */
#line 18129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { Select->options|= SELECT_ALL; }
#line 48200 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3482: /* no_definer: %empty  */
#line 18145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3483: /* definer: DEFINER_SYM '=' user_or_role  */
#line 18159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3484: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 18172 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3485: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 18173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3486: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 18174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3487: /* opt_view_suid: %empty  */
#line 18178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3488: /* opt_view_suid: view_suid  */
#line 18179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48254 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3489: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 18183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3490: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 18184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3491: /* view_list_opt: %empty  */
#line 18189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 48272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3492: /* view_list_opt: '(' view_list ')'  */
#line 18190 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { }
#line 48278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3493: /* view_list: ident  */
#line 18195 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3494: /* view_list: view_list ',' ident  */
#line 18201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3495: /* $@266: %empty  */
#line 18209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 48308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3496: /* view_select: $@266 query_expression view_check_option  */
#line 18216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 48317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3497: /* view_check_option: %empty  */
#line 18223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 48323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3498: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3499: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3500: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 48341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3501: /* trigger_action_order: FOLLOWS_SYM  */
#line 18237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 48347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3502: /* trigger_action_order: PRECEDES_SYM  */
#line 18239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 48353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3503: /* trigger_follows_precedes_clause: %empty  */
#line 18244 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 48363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3504: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 48372 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3505: /* $@267: %empty  */
#line 18260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 48381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3506: /* $@268: %empty  */
#line 18269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 48389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3507: /* $@269: %empty  */
#line 18275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 48397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3508: /* $@270: %empty  */
#line 18280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 48405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3509: /* $@271: %empty  */
#line 18284 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 48430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3510: /* trigger_tail: remember_name opt_if_not_exists $@267 sp_name trg_action_time trg_event ON remember_name $@268 table_ident FOR_SYM remember_name $@269 EACH_SYM ROW_SYM $@270 trigger_follows_precedes_clause $@271 sp_proc_stmt force_lookahead  */
#line 18305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                    TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                    MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 48453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3511: /* $@272: %empty  */
#line 18332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 48464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3512: /* sf_return_type: $@272 sp_param_type  */
#line 18339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 48474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3513: /* $@273: %empty  */
#line 18348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3514: /* sf_c_chistics_and_body_standalone: sp_c_chistics $@273 sp_tail_is sp_body force_lookahead  */
#line 18355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 48493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3515: /* $@274: %empty  */
#line 18363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 48504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3516: /* $@275: %empty  */
#line 18371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48513 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3517: /* sp_tail_standalone: sp_name $@274 opt_sp_parenthesized_pdparam_list sp_c_chistics $@275 sp_tail_is sp_body opt_sp_name  */
#line 18378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure_standalone(thd, (yyvsp[0].spname))))
              MYSQL_YYABORT;
          }
#line 48522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3518: /* opt_package_routine_end_name: %empty  */
#line 18386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 48528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3519: /* opt_package_routine_end_name: ident  */
#line 18387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 48534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3522: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 48542 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3523: /* xa: XA_SYM END xid opt_suspend  */
#line 18403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 48550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3524: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 48558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3525: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 48566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3526: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 48574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3527: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 48583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3528: /* opt_format_xid: %empty  */
#line 18426 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= false; }
#line 48589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3529: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 48606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3530: /* xid: text_string  */
#line 18444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 48617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3531: /* xid: text_string ',' text_string  */
#line 18451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 48628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3532: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 48639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3533: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 48645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3534: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 48651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3535: /* begin_or_start: START_SYM  */
#line 18469 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 48657 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3536: /* opt_join_or_resume: %empty  */
#line 18473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 48663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3537: /* opt_join_or_resume: JOIN_SYM  */
#line 18474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 48669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3538: /* opt_join_or_resume: RESUME_SYM  */
#line 18475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 48675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3539: /* opt_one_phase: %empty  */
#line 18479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 48681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3540: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 48687 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3541: /* opt_suspend: %empty  */
#line 18485 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 48693 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3542: /* $@276: %empty  */
#line 18487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 48699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3544: /* opt_migrate: %empty  */
#line 18492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 48705 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3545: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18493 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 48711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3546: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 48720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3547: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 48728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3548: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 48737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3549: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 48746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3550: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYERROR;
          }
#line 48754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;


#line 48758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

